webpackJsonp([65],{

/***/ 111:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AccountsMapProfileProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

var AccountsMapProfileProvider = /** @class */ (function () {
    function AccountsMapProfileProvider() {
        this.postableAccountTypes = ['Facebook', 'Linkedin', 'Twitter', 'GoogleMyBusiness', 'YouTube', 'Blogger', 'Pinterest', 'Instagram', 'InstaBusiness'];
    }
    AccountsMapProfileProvider.prototype.mapProfiles = function (apiProfilesFromConfig, account) {
        return new Promise(function (resolve, reject) {
            var mappedProfilesArray = [];
            for (var _i = 0, apiProfilesFromConfig_1 = apiProfilesFromConfig; _i < apiProfilesFromConfig_1.length; _i++) {
                var profile = apiProfilesFromConfig_1[_i];
                var tempMappedProfile = {
                    display: {
                        profile_name: "",
                        profile_picture_url: "",
                        network: account.display.network,
                    },
                    profile_id: profile.sampleId,
                    account_id: account.account_id,
                    settings: {
                        enabled: false,
                        mappingEnabled: false,
                        isDeviceMapped: false
                    },
                    data: {
                        lists: {},
                        groups: [],
                        power_users: {},
                        streams: []
                    },
                    original_config: profile,
                    monitored: ''
                }; //end tempMappedProfile
                //monitored
                if (profile.monitored == 'on' || profile.socialMonitored == 'on')
                    tempMappedProfile.monitored = 'on';
                else if (profile.monitored == 'expired' || profile.socialMonitored == 'expired')
                    tempMappedProfile.monitored = 'expired';
                else
                    tempMappedProfile.monitored = 'off';
                // for historical reasons need to check both monitored & socialMonitored
                if ((profile.monitored == 'on' || tempMappedProfile.monitored == 'expired') || profile.socialMonitored == 'on') {
                    tempMappedProfile.settings.enabled = true;
                }
                //Character Limit - Twitter and Instagram
                // if (account.settings.character_limit) {
                //   tempMappedProfile.settings.character_limit = account.settings.character_limit;
                // }
                // map streams into array - check if exists in profile or in account
                if (profile.accountStreams && Array.isArray(profile.accountStreams.stream)) {
                    tempMappedProfile.data.streams = profile.accountStreams.stream;
                }
                else if (profile.accountStreams != undefined) {
                    tempMappedProfile.data.streams = [profile.accountStreams.stream];
                }
                else if (account.data.streams && account.data.streams != undefined && Array.isArray(account.data.streams.stream)) {
                    tempMappedProfile.data.streams = account.data.streams.stream;
                }
                else if (account.data.streams && account.data.streams != undefined) {
                    tempMappedProfile.data.streams = Array.isArray(account.data.streams) ? account.data.streams : [account.data.streams];
                }
                ;
                // picture
                if (!(profile.profilePicture) || profile.profilePicture === 'undefined' || profile.profilePicture.includes('\/null\/')) {
                    tempMappedProfile.display.profile_picture_url = 'https://app.eclincher.com/img/no_user_image.jpg';
                }
                else if (tempMappedProfile.display.network.backend_network_name === 'pinterest') {
                    tempMappedProfile.display.profile_picture_url = profile.profilePicture.replace('http://media', 'https://s-media');
                }
                else if (profile.profilePicture.includes('http:')) {
                    tempMappedProfile.display.profile_picture_url = profile.profilePicture.replace('http://', '//');
                }
                else {
                    tempMappedProfile.display.profile_picture_url = profile.profilePicture;
                }
                tempMappedProfile.display.profile_picture_url = decodeURIComponent(tempMappedProfile.display.profile_picture_url);
                //Object Type
                if (profile.objectType) {
                    tempMappedProfile.data.objectType = profile.objectType;
                }
                // Map by network
                switch (tempMappedProfile.display.network.backend_network_name) {
                    case 'Facebook':
                        if (profile.pageName) {
                            tempMappedProfile.display.profile_name = profile.pageName;
                        }
                        ;
                        if (profile.pageCategory) {
                            tempMappedProfile.display.profile_type = profile.pageCategory;
                        }
                        ;
                        if (profile.pageAddress && tempMappedProfile.display.profile_type != 'User') {
                            tempMappedProfile.display.profile_address = profile.pageAddress;
                        }
                        //We only map non-display attributes if profile is monitored
                        if (tempMappedProfile.settings.enabled === true) {
                            if (profile["pageCategory"] == "User") {
                                //tempMappedProfile.monitored = 'off';
                                if (profile["facebookGroups"] && profile["facebookGroups"]["group"]) {
                                    //Put object in array
                                    if (!(Array.isArray(profile.facebookGroups.group))) {
                                        profile.facebookGroups.group = [profile.facebookGroups.group];
                                    }
                                    tempMappedProfile.data.groups = profile.facebookGroups.group;
                                }
                                //tempMappedProfile.monitored = 'off';
                            }
                        }
                        if (tempMappedProfile.display.profile_type && tempMappedProfile.display.profile_type === 'User') {
                            tempMappedProfile.settings.isFBUser = true;
                        }
                        break;
                    case 'Linkedin':
                        var lnProfileName = profile.profileName.split('(');
                        if (lnProfileName.length > 1 && profile.profileName.indexOf('Profile') !== -1) {
                            tempMappedProfile.display.profile_name = lnProfileName[0] + '(User)';
                        }
                        else {
                            console.log("Linkedinprofile", profile.profileName);
                            tempMappedProfile.display.profile_name = profile.profileName;
                        }
                        break;
                    case 'Twitter':
                        tempMappedProfile.display.profile_name = profile.specifiedHandleOrHashTag;
                        tempMappedProfile.data.lists = {
                            default_element: undefined,
                            data: []
                        };
                        if (profile.twitterLists && profile.twitterLists.list) {
                            if (!(Array.isArray(profile.twitterLists.list))) {
                                profile.twitterLists.list = [profile.twitterLists.list];
                            }
                            tempMappedProfile.data.lists.data = profile.twitterLists.list;
                        }
                        if (profile.powerUsers) {
                            tempMappedProfile.data.power_users = profile.powerUsers;
                        }
                        else {
                            tempMappedProfile.data.power_users = {
                                state: 'on',
                                mediumLow: '2000',
                                mediumHigh: '7500',
                                high: '7500'
                            };
                        }
                        break;
                    case 'Blogger':
                        // if (profile.userName && profile.userName != '') {
                        tempMappedProfile.display.profile_name = account.data.config.fullName;
                        // } else {
                        //   tempMappedProfile.display.profile_name = account.display.network.backend_network_name;
                        // }
                        break;
                    case 'Pinterest':
                        tempMappedProfile.display.profile_name = profile.fullName;
                        if (profile.objectType && profile.objectType == 'user') {
                            tempMappedProfile.display.profile_type = "User";
                        }
                        else {
                            tempMappedProfile.display.profile_type = "Board";
                        }
                        break;
                    case 'Instagram':
                    case 'InstaBusiness':
                        if (profile.userName && profile.userName != '') {
                            tempMappedProfile.display.profile_name = profile.userName;
                            if (tempMappedProfile.display.network.backend_network_name === 'Instagram') {
                                tempMappedProfile.display.profile_name += ' (User)';
                            }
                            else {
                                if (profile.pageCategory === 'Creator')
                                    tempMappedProfile.display.profile_name += ' (Creator)';
                                // else tempMappedProfile.display.profile_name += ' (Biz)';
                                else if (profile.pageCategory === 'Biz' || profile.socialMonitored === 'on')
                                    tempMappedProfile.display.profile_name += ' (Biz)';
                            }
                        }
                        else {
                            tempMappedProfile.display.profile_name = account.display.network.backend_network_name;
                        }
                        break;
                    case 'TikTok':
                        // console.log("TikTok", profile);
                        if (profile.userName && profile.userName != '') {
                            if (profile.pageCategory === 'Creator')
                                tempMappedProfile.display.profile_name = "" + profile.userName;
                            else
                                tempMappedProfile.display.profile_name = "" + profile.userName;
                        }
                        else {
                            tempMappedProfile.display.profile_name = account.display.network.backend_network_name;
                        }
                        break;
                    // case 'Instagram':
                    //   if (profile.userName && profile.userName != '') {
                    //     tempMappedProfile.display.profile_name = profile.userName + ' (User)';
                    //   } else {
                    //     tempMappedProfile.display.profile_name = account.display.network.backend_network_name;
                    //   }
                    //   break
                    // case 'InstaBusiness':
                    //   console.log("InstaBusiness",profile);
                    //   if (profile.userName && profile.userName != '') {
                    //     if (profile.pageCategory === 'Creator') tempMappedProfile.display.profile_name = `${profile.userName} (Creator)`;
                    //     else tempMappedProfile.display.profile_name = `${profile.userName} (Biz)`;
                    //   } else {
                    //     tempMappedProfile.display.profile_name = account.display.network.backend_network_name;
                    //   }
                    //   break
                    case 'GooglePlus':
                        if (typeof profile.fullName !== 'string') {
                            profile.fullName = '';
                        }
                        if (profile.objectType && profile.objectType == 'page') {
                            tempMappedProfile.display.profile_name = profile.fullName;
                            tempMappedProfile.display.profile_type = "Page";
                        }
                        else {
                            tempMappedProfile.display.profile_name = (profile.fullName != undefined && profile.fullName != '') ? "" + profile.fullName.split("(")[0] : '(User)';
                            tempMappedProfile.display.profile_type = "User";
                            tempMappedProfile.monitored = 'off';
                        }
                        break;
                    case 'GoogleAnalytics':
                        if (profile.title && profile.title != undefined) {
                            var temp = profile.title.split('(')[0] || profile.title + " ";
                            tempMappedProfile.display.profile_name = temp.substring(0, temp.length - 1);
                        }
                        else {
                            tempMappedProfile.display.profile_name = account.display.network.display_name;
                        }
                        break;
                    case 'GoogleMyBusiness':
                        // tempMappedProfile.display.profile_name = profile.userName.split(',').shift();
                        var ckobka = profile.userName.indexOf(')');
                        if (ckobka !== -1) {
                            tempMappedProfile.display.profile_name = profile.userName.slice(0, ckobka + 1);
                            tempMappedProfile.display.profile_address = profile.userName.slice(ckobka + 1).trim();
                        }
                        else {
                            tempMappedProfile.display.profile_name = profile.userName.slice(0, profile.userName.indexOf(','));
                            tempMappedProfile.display.profile_address = profile.userName.slice(profile.userName.indexOf(',') + 1).trim();
                        }
                        break;
                    case 'YouTube':
                        if (profile.userFirstName && profile.userFirstName != '') {
                            tempMappedProfile.display.profile_name = profile.userFirstName + " ";
                            // tempMappedProfile.display.profile_name_key = 'userFirstName';
                        }
                        else {
                            tempMappedProfile.display.profile_name = account.display.network.display_name;
                            // tempMappedProfile.display.profile_name_key = 'nickName';
                        }
                        break;
                    case 'Bitly':
                        tempMappedProfile.display.profile_name = account.display.network.backend_network_name;
                        break;
                    case 'Sniply':
                        tempMappedProfile.display.profile_name = account.display.network.backend_network_name;
                        break;
                    case 'Pocket':
                        tempMappedProfile.display.profile_name = profile.fullName;
                        break;
                    case 'Zendesk':
                        tempMappedProfile.display.profile_name = account.display.network.display_name;
                        break;
                    case 'Yelp':
                        tempMappedProfile.display.profile_name = account.display.account_name;
                        break;
                } // end switch
                mappedProfilesArray.push(tempMappedProfile);
            } // end for
            resolve(mappedProfilesArray);
        }); // end Promise
    };
    ; // end mapProfiles
    AccountsMapProfileProvider.prototype.canPost = function (accountType) {
        return this.postableAccountTypes.indexOf(accountType) !== -1;
    };
    AccountsMapProfileProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [])
    ], AccountsMapProfileProvider);
    return AccountsMapProfileProvider;
}());

; // end export AccountsMapProfileProvider
//# sourceMappingURL=accounts-map-profile.js.map

/***/ }),

/***/ 112:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FacebookProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_facebook__ = __webpack_require__(337);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var FacebookProvider = /** @class */ (function () {
    function FacebookProvider(_facebook, _alertController
    // private nativeStorage: NativeStorage
    ) {
        this._facebook = _facebook;
        this._alertController = _alertController;
    }
    FacebookProvider.prototype.login = function () {
        // return new Promise((resolve, reject) => {
        //   resolve({status: 'connected', authResponse: {userID:"114898135571183"}}); 
        // });
        return this._facebook.login(['email'])
            .then(function (facebookLoginResponse) {
            console.log("facebookLoginResponse success", facebookLoginResponse);
            return facebookLoginResponse;
        }).catch(function (er) {
            console.log("facebookLoginResponse erreor", er);
        }); //end then
    };
    ; //end login
    FacebookProvider.prototype.facebookLogout = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this._facebook.logout()
                .then(function (res) {
                console.log('facebook logout res', res);
                resolve(true);
            }).catch(function (err) {
                console.log('FB login error!', err);
                resolve(false);
            });
        });
    };
    FacebookProvider.prototype.facebookStatus = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this._facebook.getLoginStatus()
                .then(function (res) {
                console.log('facebook status res', res);
                resolve(res);
            }).catch(function (err) {
                console.log('FB login error!', err);
                resolve(err);
            });
        });
    };
    FacebookProvider.prototype.facebookGetToken = function () {
        this._facebook.getAccessToken()
            .then(function (res) {
            console.log('facebook status res', res);
        }).catch(function (err) {
            console.log('FB login error!', err);
        });
    };
    FacebookProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ionic_native_facebook__["a" /* Facebook */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */]
            // private nativeStorage: NativeStorage
        ])
    ], FacebookProvider);
    return FacebookProvider;
}());

; //end FacebookProvider
//# sourceMappingURL=facebook.js.map

/***/ }),

/***/ 113:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LinkedinFeedItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__ = __webpack_require__(61);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__ = __webpack_require__(30);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
//CLASSES


var LinkedinFeedItem = /** @class */ (function (_super) {
    __extends(LinkedinFeedItem, _super);
    function LinkedinFeedItem(http, data, feed) {
        var _this = _super.call(this, http, data, feed) || this;
        _this.header = null;
        _this.summary = {};
        _this.actionButtons = {};
        _this.actionHeader = {};
        //prepare data
        _this.prepareData();
        return _this;
    }
    /**
    * prepareData
    */
    LinkedinFeedItem.prototype.prepareData = function () {
        this.header = {
            profile: this.profile,
            eventType: this.feed.stream.name,
            eventDate: this.data.eventTime
        };
        //tags for inbox
        if (this.feed.id === 'cinbox' || this.feed.id === 'inBox') {
            this.header.eventType = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["j" /* formatEventType */](this.data.eventType, this.data);
            this.header.eventTags = {
                selectedTagsArray: this.data.tags,
                hasTags: Boolean(this.data.tags.length)
            };
            if (Array.isArray(this.data.roles) && this.data.roles.length > 0) {
                this.header.assignedRoles = {
                    selectedRoles: this.getAssignedRoles(),
                    hasRoles: false
                };
            }
            console.log('this.header', this.header);
        }
        this.summary.messageView = {
            sender: {
                senderName: this.getSenderName(),
                createdDate: this.getCreatedDate(),
                twittterHandle: this.getScreenName(),
                senderProfileImage: this.getProfilePic(),
                senderProfileURL: ''
            },
            messageText: this.getMessageText(),
            tags: this.getAssignedTagsAndRoles()
        };
        //SCREEN NAME
        if (this.getScreenName() !== '') {
            this.summary.messageView.sender.twittterHandle = this.getScreenName();
        }
        //PREPARE MEDIA
        var media = this.getMedia();
        // if( media.mediaUrl != '' )
        {
            this.summary.messageView.media = media;
        }
        //Prepare actionHeaders
        this.getActionHeaders();
        //ACTION BUTTONS
        this.getActionButtons();
    };
    LinkedinFeedItem.prototype.getSenderName = function () {
        var senderName = '';
        if (this.feed.id === 'lnc_homeWall') {
            senderName = this.profile.display.profile_name.replace('(Company Page)', '');
        }
        else {
            senderName = this.profile.display.profile_name.replace('(User)', '');
        }
        return senderName;
    };
    LinkedinFeedItem.prototype.getCreatedDate = function () {
        if (this.feed.id === 'cinbox') {
            if (this.data.commentCreationTimestamp) {
                return parseInt(this.data.commentCreationTimestamp);
            }
        }
        return parseInt(this.data.creationTimestamp);
    };
    LinkedinFeedItem.prototype.getScreenName = function () {
        var screenName = '';
        return screenName;
    };
    LinkedinFeedItem.prototype.getProfilePic = function () {
        return this.profile.display.profile_picture_url;
    };
    LinkedinFeedItem.prototype.getMessageText = function () {
        var messageText = '';
        if (this.data.updateContent != undefined) {
            if (this.data.updateContent.currentUpdate != undefined) {
                if (this.data.updateContent.currentUpdate.content != undefined) {
                    if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.updateContent.currentUpdate.content.description))
                        this.data.updateContent.currentUpdate.content.description = '';
                    if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.updateContent.currentUpdate.content.title))
                        this.data.updateContent.currentUpdate.content.title = '';
                }
            }
        }
        var centerData;
        if (this.feed.stream.streamId === 'ln_posted' || this.feed.stream.streamId === 'lnc_homeWall' || this.feed.id === 'cinbox') {
            if (this.data.updateContent && this.data.updateContent.currentUpdate && this.data.updateContent.currentUpdate.content) {
                if (this.data.updateContent.currentUpdate.comment)
                    centerData = this.data.updateContent.currentUpdate.comment;
            }
        }
        var l_message = (this.data.updateContent != undefined ? this.data.updateContent.currentUpdate : undefined);
        if (this.feed.id == 'cinbox') {
            if (typeof centerData !== 'string') {
                if (l_message && l_message.content && l_message.content.description)
                    centerData = l_message.content.description;
                else if (Math.pow(l_message, l_message.content) && l_message.content.title)
                    centerData = l_message.content.title;
                else
                    centerData = '';
            }
            centerData = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["f" /* decodeHTMLEntities */](centerData);
            var last_comment = { text: '' };
            if (this.data.comments && this.data.comments.values) {
                if (this.data.comments.values.length)
                    last_comment = this.data.comments.values[0];
                else
                    last_comment = this.data.comments.values;
            }
            messageText = '<span class="comment-subtitle">' + __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["v" /* replace_type_in_username */](this.profile.display.profile_name) + '\'s Post:</span> ';
            messageText += __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["r" /* new_url_to_link */](centerData);
            messageText += '<br><br><span class="comment-subtitle">' + this.getSenderName() + '\'s Comment:</span> ' + last_comment.text;
            this.data.last_comment = last_comment;
            // this.isCommentView = true;
        }
        else {
            if (centerData) {
                centerData = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["f" /* decodeHTMLEntities */](centerData);
                messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["r" /* new_url_to_link */](centerData);
            }
        }
        if (this.data.updateContent && this.data.updateContent.currentUpdate && this.data.updateContent.currentUpdate.annotations && this.data.updateContent.currentUpdate.annotations.annotation) {
            var mentions = Array.isArray(this.data.updateContent.currentUpdate.annotations.annotation) ? this.data.updateContent.currentUpdate.annotations.annotation : [this.data.updateContent.currentUpdate.annotations.annotation];
            for (var _i = 0, mentions_1 = mentions; _i < mentions_1.length; _i++) {
                var mention = mentions_1[_i];
                if (mention) {
                    if (!mention.name)
                        mention.name = '';
                    mention.name = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["k" /* getMentionFromText */](messageText.trim(), mention.start, mention['length']);
                }
            }
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["p" /* ln_mentions_to_links */](messageText, mentions);
        }
        return messageText;
    };
    LinkedinFeedItem.prototype.getMedia = function () {
        var media = {
            isImage: true,
            alt: '',
            mediaUrl: '',
            gallery: []
        };
        if (this.data.updateContent != undefined) {
            if (this.data.updateContent.currentUpdate != undefined) {
                if (this.data.updateContent.currentUpdate.content != undefined) {
                    if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.updateContent.currentUpdate.content.description))
                        this.data.updateContent.currentUpdate.content.description = '';
                    if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.updateContent.currentUpdate.content.title))
                        this.data.updateContent.currentUpdate.content.title = '';
                }
            }
        }
        if (this.feed.stream.streamId === 'ln_posted' || this.feed.stream.streamId === 'lnc_homeWall' || this.feed.id === 'cinbox') {
            if (this.data.updateContent && this.data.updateContent.currentUpdate && this.data.updateContent.currentUpdate.content) {
                if (typeof this.data.updateContent.currentUpdate.content.submittedImageUrl === 'string' && this.data.updateContent.currentUpdate.content.submittedImageUrl.indexOf('https:') !== -1) {
                    media.mediaUrl = this.data.updateContent.currentUpdate.content.submittedImageUrl;
                }
                else if (typeof this.data.updateContent.currentUpdate.content.thumbnailUrl === 'string' && this.data.updateContent.currentUpdate.content.thumbnailUrl.indexOf('https:') !== -1) {
                    media.mediaUrl = this.data.updateContent.currentUpdate.content.thumbnailUrl;
                }
                if (!(/\.(jpg|jpeg|png|bmp|tiff|avi|mpeg|mkv|ogg|mov|mpeg|mpg|mpe|flv|3gp|gif)$/i).test(this.data.updateContent.currentUpdate.content.title)
                    && this.data.updateContent.currentUpdate.content.title !== 'View Image'
                    && this.data.updateContent.currentUpdate.content.title !== 'Click Here to View Image'
                    && this.data.updateContent.currentUpdate.content.title !== 'Content title'
                    && this.data.updateContent.currentUpdate.content.title.indexOf('_ecsize_') === -1) {
                    media.mediaOriginalPageUrl = this.data.updateContent.currentUpdate.content.submittedUrl;
                    media.mediaOriginalPageContent = this.data.updateContent.currentUpdate.content.title;
                }
                media.mediaOriginalPagePreview = this.data.updateContent.currentUpdate.content.description;
                if (media.mediaOriginalPagePreview === 'Content description') {
                    media.mediaOriginalPagePreview = '';
                }
                if (typeof this.data.updateContent.currentUpdate.content.submittedUrl === 'string'
                    && this.data.updateContent.currentUpdate.content.submittedUrl.indexOf('youtube.com') !== -1) {
                    var youtube_link = this.data.updateContent.currentUpdate.content.submittedUrl;
                    var hashes = youtube_link.slice(youtube_link.indexOf('?') + 1).split('&');
                    var video_id = '';
                    for (var i = hashes.length; i--;) {
                        var hash = hashes[i].split('=');
                        if (hash[0] === 'v') {
                            video_id = hash[1];
                        }
                    }
                    if (video_id) {
                        media.isImage = false;
                        media.videoUrl = "https://www.youtube.com/embed/" + video_id;
                    }
                }
                if (typeof this.data.updateContent.currentUpdate.content.submittedUrl === 'string' && this.data.updateType === 'VIDEO'
                    && this.data.updateContent.currentUpdate.content.thumbnailUrl.indexOf('video_empty_thumb.png') === -1) {
                    media.isImage = false;
                    media.videoUrl = this.data.updateContent.currentUpdate.content.submittedUrl;
                }
            }
        }
        // Extract Media from last comment 
        if (this.feed.id == 'cinbox' && this.data.last_comment) {
            if (this.data.last_comment.contentList && this.data.last_comment.contentList.content) {
                if (!Array.isArray(this.data.last_comment.contentList.content))
                    this.data.last_comment.contentList.content = [this.data.last_comment.contentList.content];
                // first item for now
                var content = this.data.last_comment.contentList.content[0];
                if (typeof content.submittedUrl === 'string') {
                    var type = content.title.toLowerCase();
                    if (type === 'video') { }
                    else {
                        media.mediaUrl = content.submittedUrl;
                        media.isImage = true;
                    }
                }
            }
        }
        if (media.mediaUrl === '') {
            media.isImage = false;
        }
        if (media.mediaUrl !== '') {
            media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
        }
        return media;
    };
    LinkedinFeedItem.prototype.getActionHeaders = function () {
        console.log('this.data', this.data);
        //Likes
        if (this.data.likes == undefined) {
            this.actionHeader.likes = { count: 0 };
        }
        else {
            // console.log('this.data 111', this.data.likes._total);
            this.actionHeader.likes = {
                count: this.data.likes._total
            };
            if (this.actionHeader.likes.count > 0)
                this.actionHeader.likes.highlighted = true;
        }
        //Comments
        if (this.data.comments == undefined) {
            this.actionHeader.comments = { count: 0 };
        }
        else {
            this.actionHeader.comments = { count: this.data.comments._total };
            if (this.actionHeader.comments.count > 0)
                this.actionHeader.comments.highlighted = true;
        }
    };
    LinkedinFeedItem.prototype.getActionButtons = function () {
        var objectID = this.data.updateKey;
        if (this.feed.id === 'cinbox') {
            objectID = this.data.id;
        }
        var actor = '';
        if (this.profile.display.profile_name.indexOf('(Company Page)') === -1) {
            actor = 'urn:li:person:';
        }
        else {
            actor = 'urn:li:organization:';
        }
        actor += this.profile.original_config.profile_Id;
        if (this.feed.id === 'lnc_homeWall' || this.feed.id === 'ln_posted') {
            this.data.isCommentable = 'true';
            this.data.isLikable = 'true';
            // Like
            this.actionButtons.lnLike = {
                highlighted: (this.data.isLiked == 'true'),
                post_id: objectID,
                actor: actor
            };
            // Comment
            this.actionButtons.comment = {
                highlighted: false,
                id: objectID,
                text: '',
                actor: actor
            };
            // delete
            this.actionButtons.delete = {
                action: 'deleteLnShare',
                postID: this.data.id
            };
        }
        else if (this.feed.id === 'cinbox') {
            this.actionButtons.completeItem = { highlighted: false };
            if (this.data.ecCompleted === 'true') {
                this.actionButtons.completeItem.highlighted = true;
            }
            if (this.data.id && this.data.id.indexOf('UPDATE-') === -1 && this.data.id.indexOf(':comment:') !== -1) {
                this.data.isCommentable = 'true';
                this.data.isLikable = 'true';
                // Like
                this.actionButtons.lnLike = {
                    highlighted: (this.data.ecLike === 'true'),
                    post_id: objectID,
                    actor: actor
                };
                // reply
                this.actionButtons.reply = {
                    highlighted: (this.data.ecReply === 'true'),
                    id: this.data.updateKey,
                    actor: actor,
                    parentComment: objectID
                };
            }
            if (!__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.comments)) {
                this.actionButtons.showViewLatest = {
                    label: 'View Post & Comments',
                    pageTitle: 'Comments'
                };
            }
        }
    };
    return LinkedinFeedItem;
}(__WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__["a" /* FeedItem */]));

//# sourceMappingURL=linkedin-feed-item.js.map

/***/ }),

/***/ 13:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserSettingsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_device__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_map__ = __webpack_require__(144);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_map___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_map__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_moment_timezone__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_moment_timezone__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_feeds_inbox_filter__ = __webpack_require__(139);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__app_settings_app_settings__ = __webpack_require__(25);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







//PROVIDERS


//import { HttpParams } from '@angular/common/http/src/params';
//AuthProvider also calls get "user/settings" but with headers and {observe: "response"}
var UserSettingsProvider = /** @class */ (function () {
    function UserSettingsProvider(_http, device, _ionicStorage, _appSettingsProvider, _inboxFilterProvider) {
        this._http = _http;
        this.device = device;
        this._ionicStorage = _ionicStorage;
        this._appSettingsProvider = _appSettingsProvider;
        this._inboxFilterProvider = _inboxFilterProvider;
        // source for observable
        this.userSettingsSource = new __WEBPACK_IMPORTED_MODULE_4_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.userSettings$ = this
            .userSettingsSource
            .asObservable();
        // source for observable
        this.inboxNotificationSource = new __WEBPACK_IMPORTED_MODULE_4_rxjs_BehaviorSubject__["BehaviorSubject"](false);
        // observable stream
        this.inboxNotification$ = this
            .inboxNotificationSource
            .asObservable();
    }
    ; //end constructor
    UserSettingsProvider.prototype.getSettings = function () {
        var _this = this;
        return this._http.get("/user/settings").map(function (response) {
            _this.userSettingsSource.next(response);
            return response;
        });
    };
    ;
    /**
     * getDisplayName
     */
    UserSettingsProvider.prototype.getDisplayName = function () {
        var displayName = "";
        var userSettings = this.getUserSettings();
        var roles = this.getRoles();
        for (var r = 0; r < roles.length; r++) {
            if (userSettings.email === roles[r].userName) {
                displayName = roles[r].displayName;
                return displayName;
            }
        }
        // // displayName = userSettings && userSettings.displayName ? userSettings.displayName : "";
        if (this.isMainAdmin()) {
            displayName = "Main Admin";
        }
        return displayName;
    };
    /**
     * isMainAdmin
     */
    UserSettingsProvider.prototype.isMainAdmin = function () {
        var userSettings = this.userSettingsSource.value;
        var flag = true;
        // console.log('isMainAdmin', userSettings);
        if (!userSettings) {
            return false;
        }
        if (userSettings.isManagedUser === "true")
            flag = false;
        return flag;
    };
    UserSettingsProvider.prototype.saveSettings = function (data) {
        var params = {
            action: 'saveSettings',
            data: data
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/user/settings", params, httpOptions);
    };
    UserSettingsProvider.prototype.getUserSettings = function () {
        return this.userSettingsSource.value;
    };
    UserSettingsProvider.prototype.saveSettingsEvents = function (selectedProfile) {
        // try {
        // let socialAccounts = userSettings["socialAccounts"];
        var eventTypes = this._inboxFilterProvider.getEventFilterTypes();
        // if (null != socialAccounts) {
        var userSettingsData = [];
        // for (let socialAccount of socialAccounts) {
        var setting = {};
        // setting["accountId"] = socialAccount.account_id;
        setting["accountId"] = selectedProfile.account_id;
        var configs = [];
        // if (Object.prototype.toString.call(socialAccount.data.config) === "[object Array]") {
        //   for (let _config of socialAccount.data.config) {
        //     let config = {}
        //     config["sampleId"] = _config["sampleId"];
        //     config["eventsMonitored"] = _config["eventsMonitored"];
        //     for (let eventType of eventTypes) {
        //       if (_config.hasOwnProperty(eventType.flag)) {
        //         config[eventType.flag] = _config[eventType.flag];
        //       }
        //     }
        //     configs.push(config);
        //   }
        // }
        // else {
        var config = {};
        var _config = selectedProfile.original_config;
        config["sampleId"] = _config["sampleId"];
        config["eventsMonitored"] = _config["eventsMonitored"];
        for (var _i = 0, eventTypes_1 = eventTypes; _i < eventTypes_1.length; _i++) {
            var eventType = eventTypes_1[_i];
            if (_config.hasOwnProperty(eventType.keyForInboxSettings)) {
                config[eventType.keyForInboxSettings] = _config[eventType.keyForInboxSettings];
            }
        }
        configs.push(config);
        // }
        setting["config"] = configs;
        userSettingsData.push(setting);
        // }
        var requestBody = { data: userSettingsData };
        return this
            ._http
            .post("/account/events", requestBody);
        // }
        // else {
        //   // reject("'socialAccount' property was not found in Settings");
        // }
        // }
        // catch (ex) {
        //   return (ex);
        // }
    };
    ; //end saveSettingsEvents
    UserSettingsProvider.prototype.saveSettingsFlags = function (updatedUserSettings) {
        var requestBody = {
            "action": "saveSettings",
            "data": updatedUserSettings
        };
        return this
            ._http
            .post("/user/settings", requestBody);
    };
    ; //end saveSettingsFlags
    UserSettingsProvider.prototype.setInboxNotification = function (flag) {
        this.inboxNotificationSource.next(flag);
    };
    ;
    UserSettingsProvider.prototype.getUserTimeZone = function () {
        var timeZone = __WEBPACK_IMPORTED_MODULE_6_moment_timezone___default.a.tz.guess();
        if (this.userSettingsSource.value && this.userSettingsSource.value.timezone) {
            timeZone = this.userSettingsSource.value.timezone;
        }
        return timeZone;
    };
    /**
     * saveDeviceInfo
     */
    UserSettingsProvider.prototype.saveDeviceInfo = function (deviceInfo, actionType) {
        if (actionType === void 0) { actionType = '1'; }
        var apiPath = "/user/settings";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        httpParams = httpParams.set('action', 'saveSettings');
        httpParams = httpParams.set('data[map_flag]', actionType);
        httpParams = httpParams.set('data[devices][0][deviceId]', deviceInfo.deviceId);
        httpParams = httpParams.set('data[devices][0][deviceType]', deviceInfo.deviceType);
        httpParams = httpParams.set('data[devices][0][nickName]', deviceInfo.nickName);
        httpParams = httpParams.set('data[devices][0][gcmId]', deviceInfo.gcmId);
        httpParams = httpParams.set('data[devices][0][sampleId]', deviceInfo.sampleId);
        httpParams = httpParams.set('data[devices][0][notificationType]', deviceInfo.notificationType);
        return this
            ._http
            .post(apiPath, httpParams);
    };
    UserSettingsProvider.prototype.getInternalNotifications = function () {
        var deviceId = this.device.uuid ? this.device.uuid : '121';
        var currentPlatform = this.device.platform ? this.device.platform.toLowerCase() : 'android';
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]().set("uuid", deviceId);
        return this._http.get("/feed/notifications", { params: requestBody }).map(function (response) {
            var notifications = [];
            var notification = null;
            if (response.notifications && Array.isArray(response.notifications)) {
                for (var i = 0; i < response.notifications.length; i++) {
                    if (response.notifications[i].device === currentPlatform) {
                        notifications.push(response.notifications[i]);
                    }
                }
            }
            if (notifications.length)
                notification = notifications[0];
            return notification;
        });
    };
    ;
    UserSettingsProvider.prototype.updateFCMToken = function () {
        var _this = this;
        this._ionicStorage.get(this._appSettingsProvider.getFCMTokenKey()).then(function (token) {
            if (!token || token === '') {
                return;
            }
            var deviceInfo = {
                deviceId: _this.device.uuid,
                notificationType: 'FCM',
                gcmId: token
            };
            _this
                ._http
                .post('/user/updateGCM', deviceInfo)
                .subscribe(function (resp) {
                console.log('FCM Token updated after login', deviceInfo);
            });
        });
    };
    ;
    /**
     * getInboxFilterKey
     */
    UserSettingsProvider.prototype.getInboxFilterKey = function () {
        var settings = this.userSettingsSource.value;
        if (!settings) {
            return '';
        }
        var key = settings.email;
        var clientId = '';
        if (settings.agencyConfiguration && settings.agencyConfiguration.client) {
            for (var _i = 0, _a = settings.agencyConfiguration.client; _i < _a.length; _i++) {
                var client = _a[_i];
                if (client.selected) {
                    clientId = client.clientId;
                }
            }
            key += '::' + clientId;
        }
        return key;
    };
    UserSettingsProvider.prototype.getUserDisplayName = function (userSettings) {
        var name = '';
        if (userSettings.signupFirstName !== null) {
            name = userSettings.signupFirstName;
        }
        if (userSettings.signupLastName !== null) {
            name += ' ' + userSettings.signupLastName;
        }
        if (!name.length) {
            if (userSettings.displayName !== null) {
                name = userSettings.displayName;
            }
            else {
                name = userSettings.email;
            }
        }
        if (name.indexOf('@') !== -1) {
            name = name.split('@')[0];
        }
        return name;
    };
    /*
      public saveSettingsEvents(userSettings, selectedProfile): Observable<HttpResponse<any>> { //, accountsFiltersAndTags
        try {
    
          let socialAccounts = userSettings["socialAccounts"];
          let eventTypes = this._inboxFilterProvider.getTypes();
    
          if (null != socialAccounts) {
            let userSettingsData = [];
            for (let socialAccount of socialAccounts) {
              let setting = {};
              setting["accountId"] = socialAccount.account_id;
              setting["accountId"] = selectedProfile.original_config.account_id;
              let configs = [];
    
              if (Object.prototype.toString.call(socialAccount.data.config) === "[object Array]") {
                for (let _config of socialAccount.data.config) {
                  let config = {}
                  config["sampleId"] = _config["sampleId"];
                  config["eventsMonitored"] = _config["eventsMonitored"];
                  for (let eventType of eventTypes) {
                    if (_config.hasOwnProperty(eventType.flag)) {
                      config[eventType.flag] = _config[eventType.flag];
                    }
                  }
                  configs.push(config);
                }
              }
              else {
                let config = {}
                let _config = socialAccount.data.config;
                config["sampleId"] = _config["sampleId"];
                config["eventsMonitored"] = _config["eventsMonitored"];
                for (let eventType of eventTypes) {
                  if (_config.hasOwnProperty(eventType.flag)) {
                    config[eventType.flag] = _config[eventType.flag];
                  }
                }
                configs.push(config);
              }
              setting["config"] = configs;
              userSettingsData.push(setting);
            }
    
            let requestBody = { data: userSettings };
            return this
              ._http
              .post<HttpResponse<any>>("/account/events", requestBody)
          }
          else {
          }
        }
        catch (ex) {
          return (ex);
        }
      }; //end saveSettingsEvents */
    // public saveSettingautoMarkAsCompletedTWFollowsFlags(userSettings): Observable<HttpResponse<any>> {
    //   try {
    //     if (null != userSettings["flags"]) {
    //       let requestBody = {
    //         "action": "saveSettings",
    //         "data": {
    //           // "hideInboxEventCounter": userSettings.flags.hideInboxEventCounter,
    //           // "alwaysHideCompletedEvents": userSettings.flags.alwaysHideCompletedEvents,
    //           "autoMarkAsCompletedTWFollow": userSettings.flags.autoMarkAsCompletedTWFollow
    //         }
    //       }
    //       return this
    //         ._http
    //         .post<HttpResponse<any>>("/user/settings", requestBody)
    //     }
    //     else {
    //       // return("'flags' property was not found in Settings");
    //     }
    //   }
    //   catch (ex) {
    //     return (ex);
    //   }
    // }; //end saveSettingsFlags
    UserSettingsProvider.prototype.setMarkAllCompleted = function (data /* userSettings */) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("markAll", data.markAll);
        if (data.sampleIds.length > 0) {
            for (var s = 0; s < data.feeds.length; s++) {
                requestBody = requestBody.append("sampleIds[" + s + "]", data.sampleIds[s]);
            }
        }
        if (data.feeds.length > 0) {
            for (var f = 0; f < data.feeds.length; f++) {
                requestBody = requestBody.append("feeds[" + f + "]", data.feeds[f]);
            }
        }
        if (data.tags.length > 0) {
            for (var t = 0; t < data.tags.length; t++) {
                requestBody = requestBody.append("tags[" + t + "]", data.tags[t]);
            }
        }
        if (data.searchText != undefined || data.searchText != null) {
            requestBody = requestBody.set("searchText", data.searchText);
        }
        console.info("UserSettingsProvider::setMarkAllCompleted  - requestBody - ", requestBody);
        return this
            ._http
            .post("/user/events", requestBody); //user/events
    };
    ; //end setMarkAllCompleted
    UserSettingsProvider.prototype.getUserProfile = function (params) {
        var apiPath = "/user/profiles";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", params.accountID)
            .set("profileID", params.profileID)
            .set("action", params.action);
        if (params.userId) {
            httpParams = httpParams.append('user_id', params.userId);
        }
        if (params.stream) {
            httpParams = httpParams.append('stream', params.stream);
            httpParams = httpParams.append('next', params.next);
        }
        if (params.cmp_id) {
            httpParams = httpParams.append('cmp_id', params.cmp_id);
        }
        return this
            ._http
            .get(apiPath, { params: httpParams }).map(function (response) {
            return response;
        });
    };
    UserSettingsProvider.prototype.getShrinkOption = function () {
        var option = 'google', userSettings = this.userSettingsSource.value;
        if (userSettings) {
            if (userSettings['shortenUrl'] == 'none' || userSettings['shortenUrl'] == '') {
                option = 'none';
            }
            else {
                option = userSettings['shortenUrl'];
            }
        }
        return option;
    };
    /**
     * get user roles
     */
    UserSettingsProvider.prototype.getUserRoles = function () {
        var _this = this;
        return this
            ._http
            .get("/user/roles?action=getUserRoles")
            .map(function (httpResponse) {
            //default role
            var defaultRole = {
                displayName: 'All Team Members',
                status: 'active',
                userName: 'all_roles',
                enabled: true
            };
            //admin role
            var adminRole = {
                displayName: 'Main Admin',
                status: 'active',
                userName: '',
                enabled: false
            };
            if (_this.userSettingsSource.value) {
                adminRole.userName = (_this.userSettingsSource.value.isAdminUser == true || _this.userSettingsSource.value.isAdminUser == "true") ? _this.userSettingsSource.value.email : _this.userSettingsSource.value.adminUserName;
            }
            var teamMembers = [];
            if (httpResponse.data) {
                for (var _i = 0, _a = httpResponse.data; _i < _a.length; _i++) {
                    var role = _a[_i];
                    if (role.approvalUrl) {
                        continue;
                    }
                    var teamMember = {
                        displayName: role.displayName,
                        userName: role.userName,
                        enabled: false,
                        status: role.userStatus,
                        accountPermissions: (role.accountPermissions && role.accountPermissions.client) ? role.accountPermissions.client : {},
                        masterAccountsPermission: (role.masterAccountsPermission) ? role.masterAccountsPermission : false
                    };
                    teamMembers.push(teamMember);
                }
            }
            console.log("this.userSettingsSource.value", teamMembers);
            teamMembers.unshift(defaultRole);
            teamMembers.splice(1, 0, adminRole);
            _this.setRoles(teamMembers);
            _this._inboxFilterProvider.saveRoles(teamMembers);
            return teamMembers;
        });
    };
    ; //end saveSettingsFlags
    UserSettingsProvider.prototype.setRoles = function (roles) {
        this.roles = roles;
    };
    UserSettingsProvider.prototype.getRoles = function () {
        return this.roles;
    };
    /**
     * isAdmin
     */
    UserSettingsProvider.prototype.isAdmin = function () {
        var userSettings = this.userSettingsSource.value;
        var flag = true;
        if (!userSettings) {
            return flag;
        }
        // Premier
        if (userSettings
            && (userSettings.licenseType && userSettings.licenseType == 'Premier')
            && (userSettings.masterAccountsPermission && userSettings.masterAccountsPermission == 'false')) {
            flag = false;
        }
        // Agency
        var client = this.getSelectedClient();
        if (!client || !client.permission) {
            return flag;
        }
        if (client.permission === 'edit' || client.permission === 'view') {
            flag = false;
        }
        return flag;
    };
    /**
     * getAdminUsername
     */
    UserSettingsProvider.prototype.getAdminUsername = function () {
        var userSettings = this.getUserSettings();
        var userName = '';
        if (userSettings) {
            userName = userSettings && userSettings.userName ? userSettings.userName : '';
            userName = userSettings && userSettings.email ? userSettings.email : userName;
            if (!this.isMainAdmin()) {
                if ((userSettings.adminUserName && !Array.isArray(userSettings.adminUserName))) {
                    userName = userSettings.adminUserName;
                }
                else if (userSettings.agencyConfiguration) {
                    userName = userSettings.agencyConfiguration.agencyName;
                }
                else {
                    userName = userSettings.accountCode;
                }
            }
        }
        return userName;
    };
    /**
     * getuserName
     */
    UserSettingsProvider.prototype.getUserName = function () {
        var userSettings = this.getUserSettings();
        var userName = "";
        if (userSettings && userSettings.email) {
            userName = userSettings.email;
        }
        else if (userSettings && userSettings.userName) {
            userName = userSettings.userName;
        }
        return userName;
    };
    /**
     * name
     */
    UserSettingsProvider.prototype.getSelectedClient = function () {
        var userSettings = this.userSettingsSource.value;
        var selectedClient = null;
        if (!userSettings) {
            return selectedClient;
        }
        if (!userSettings.agencyConfiguration || !userSettings.agencyConfiguration.client) {
            return selectedClient;
        }
        if (!Array.isArray(userSettings.agencyConfiguration.client)) {
            userSettings.agencyConfiguration.client = [userSettings.agencyConfiguration.client];
        }
        userSettings.agencyConfiguration.client.find(function (client) {
            if (client.selected) {
                selectedClient = client;
            }
        });
        return selectedClient;
    };
    /**
     * getCurrentBrandPermission
     */
    UserSettingsProvider.prototype.getCurrentBrandPermission = function () {
        var selectedClient = this.getSelectedClient();
        var permission = '';
        if (selectedClient && selectedClient.permission) {
            permission = selectedClient.permission;
        }
        return permission;
    };
    //  /**
    //  * getuserName
    //  */
    // public getUserName() {
    //   let userSettings = this.userSettingsSource.value;
    //   return userSettings && userSettings.email ? userSettings.email : "";
    // }
    /**
     * getLicenseType
     */
    UserSettingsProvider.prototype.getLicenseType = function () {
        var userSettings = this.userSettingsSource.value;
        if (userSettings && typeof userSettings.licenseType === 'string') {
            return userSettings.licenseType.toLowerCase();
        }
        return '';
    };
    /**
     * isPostApprovalAllowed
     */
    UserSettingsProvider.prototype.isPostApprovalAllowed = function () {
        if (['free', 'individual', 'basic'].indexOf(this.getLicenseType()) === -1) {
            return true;
        }
        return false;
    };
    /**
     * getManagedUserPrivateView
     * @param profile
     */
    UserSettingsProvider.prototype.getManagedUserPrivateView = function (profile) {
        var privateView = true;
        var userSettings = this.userSettingsSource.value;
        if (userSettings && userSettings.isAdminUser === 'true')
            return privateView;
        if (userSettings && userSettings.licenseType != 'Basic') {
            var selectedClient = this.getSelectedClient();
            if (selectedClient && selectedClient.privateView != null)
                privateView = (selectedClient.privateView === 'true') ? true : false;
            else if (profile && typeof profile === 'object') {
                if ((profile.monitored !== 'off' && profile.display.network.backend_network_name.toLowerCase() !== 'pinterest') ||
                    (profile.display.network.backend_network_name.toLowerCase() === 'pinterest' /*&& account.has_monitored_profiles()*/ && profile.data.objectType === 'user')) // skip PI boards
                 {
                    privateView = (profile.original_config && profile.original_config.privateView === 'true') ? true : false;
                }
            }
            else if (selectedClient.isManagedUser)
                privateView = false;
        }
        return privateView;
    };
    /**
    * getBrands
    */
    UserSettingsProvider.prototype.getBrands = function (excludeCurrentBrand) {
        if (excludeCurrentBrand === void 0) { excludeCurrentBrand = false; }
        var userSettings = this.userSettingsSource.value;
        if (!userSettings) {
            return [];
        }
        if (!this.isAgency()) {
            return [];
        }
        var brands = (userSettings.agencyConfiguration && userSettings.agencyConfiguration.client) ? userSettings.agencyConfiguration.client : [];
        var inboxCountByBrand = userSettings.inboxCountByBrand || {};
        for (var _i = 0, brands_1 = brands; _i < brands_1.length; _i++) {
            var brand = brands_1[_i];
            if (brand === undefined || typeof brand != "object" || Object.keys(brand).length <= 0)
                continue;
            brand.inboxCount = inboxCountByBrand[brand.clientId] || '';
            if (brand.profilePicture && brand.profilePicture.indexOf('/img/no_user_image.jpg') !== -1)
                brand.profilePicture = 'https://app.eclincher.com/img/no_brand_image.png';
            brand.isFavorite = this.brandFavoriteCheck(brand.clientId);
        }
        if (excludeCurrentBrand) {
            brands = brands.filter(function (b) { return !b.selected; });
        }
        brands.sort(function (a, b) {
            var aName = a.clientName.toLowerCase();
            var bName = b.clientName.toLowerCase();
            if (aName > bName) {
                return 1;
            }
            else if (aName < bName) {
                return -1;
            }
            else
                return 0;
        });
        return brands;
    };
    UserSettingsProvider.prototype.brandFavoriteCheck = function (brand_id) {
        var userSettings = this.userSettingsSource.value;
        var feSettings = userSettings.feSettings;
        if (!feSettings || !feSettings.brandSettings)
            return false;
        if (feSettings && feSettings.brandSettings.favoriteBrands && feSettings.brandSettings.favoriteBrands.findIndex(function (b) { return b == brand_id; }) >= 0)
            return true;
        return false;
    };
    /**
     * getSelectedBrand
     */
    UserSettingsProvider.prototype.getSelectedBrand = function () {
        var brands = this.getBrands();
        var brand = brands.find(function (b) {
            return b.selected;
        });
        if (!brand && brands.length) {
            brand = brands[0];
        }
        return brand;
    };
    /**
     * isAgency
     */
    UserSettingsProvider.prototype.isAgency = function () {
        var userSettings = this.userSettingsSource.value;
        if (userSettings && (userSettings.licenseType === 'Agency' || userSettings.licenseType === 'Profiles')) {
            return true;
        }
        return false;
    };
    /**
    * getNestApiUrl
    */
    UserSettingsProvider.prototype.getNestApiUrl = function (isReputation) {
        if (isReputation === void 0) { isReputation = false; }
        var baseURL = "";
        // baseURL = (isReputation) ? baseURL.replace('service', '') : baseURL.replace('service', 'custom-report/');
        // if (location.href.indexOf('localhost') !== -1) {
        baseURL = (isReputation) ? 'https://nest.eclincher.com/' : 'https://nest.eclincher.com/custom-report/';
        // baseURL = (isReputation) ? 'http://localhost:3000/' : 'http://localhost:3000/custom-report/';
        // }    
        return baseURL;
    };
    /**
    * getBrandById
    */
    UserSettingsProvider.prototype.getBrandById = function (clientId) {
        var brands = this.getBrands();
        var brand = brands.find(function (b) {
            return b.clientId == clientId;
        });
        return brand;
    };
    UserSettingsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_device__["a" /* Device */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_8__app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_feeds_inbox_filter__["a" /* InboxFilterProvider */]])
    ], UserSettingsProvider);
    return UserSettingsProvider;
}());

; // end AppSettingsProvider
;
//# sourceMappingURL=user-settings.js.map

/***/ }),

/***/ 138:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FeedsServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_feeds_classes_facebook_feed__ = __webpack_require__(338);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_feeds_classes_twitter_feed__ = __webpack_require__(342);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_feeds_classes_linkedin_feed__ = __webpack_require__(346);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_feeds_classes_instagram_feed__ = __webpack_require__(340);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_feeds_classes_instagram_business_feed__ = __webpack_require__(341);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_feeds_classes_youtube_feed__ = __webpack_require__(344);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_feeds_classes_googleplus_feed__ = __webpack_require__(345);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_pinterest_feed__ = __webpack_require__(487);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_feeds_classes_google_business_feed__ = __webpack_require__(347);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_feeds_classes_blogger_feed__ = __webpack_require__(488);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_feeds_classes_inbox_feed__ = __webpack_require__(489);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__classes_yelp_feed__ = __webpack_require__(490);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__feed_notes_service__ = __webpack_require__(149);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



//rxjs

//PROVIDERS
















var FeedsServiceProvider = /** @class */ (function () {
    function FeedsServiceProvider(http, _ionicStorage, accountsServiceProvider, appSettingsProvider, userSettingsProvider, feeNotesProvider) {
        this.http = http;
        this._ionicStorage = _ionicStorage;
        this.accountsServiceProvider = accountsServiceProvider;
        this.appSettingsProvider = appSettingsProvider;
        this.userSettingsProvider = userSettingsProvider;
        this.feeNotesProvider = feeNotesProvider;
        this.feedContainer = [];
        // source for observable
        this.inboxReloadSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.inboxReload$ = this.inboxReloadSource.asObservable();
    }
    /**
     * initialize
     */
    FeedsServiceProvider.prototype.initialize = function (profile, stream, group, options) {
        if (group === void 0) { group = {}; }
        if (options === void 0) { options = {}; }
        var found = false;
        var uniqueID = this.getUniqueID(profile, stream);
        var currentTime = (new Date()).getTime();
        for (var i in this.feedContainer) {
            if (this.feedContainer[i].uniqueID == uniqueID) {
                //check reloadInterval
                if ((currentTime - this.feedContainer[i].lastLoadedTime) > this.appSettingsProvider.feedRefreshInterval) {
                    this.feedContainer.splice(parseInt(i), 1);
                    continue;
                }
                else {
                    this.feed = this.feedContainer[i];
                    found = true;
                    break;
                }
            }
        }
        if (found)
            return true;
        switch (profile.display.network.backend_network_name.toLowerCase()) {
            case 'facebook':
                this.feed = new __WEBPACK_IMPORTED_MODULE_6__providers_feeds_classes_facebook_feed__["a" /* FacebookFeed */](this.http, stream, profile, group, options);
                break;
            case 'twitter':
                this.feed = new __WEBPACK_IMPORTED_MODULE_7__providers_feeds_classes_twitter_feed__["a" /* TwitterFeed */](this.http, stream, profile, group, options);
                break;
            case 'linkedin':
                this.feed = new __WEBPACK_IMPORTED_MODULE_8__providers_feeds_classes_linkedin_feed__["a" /* LinkedinFeed */](this.http, stream, profile, group, options);
                break;
            case 'instagram':
                this.feed = new __WEBPACK_IMPORTED_MODULE_9__providers_feeds_classes_instagram_feed__["a" /* InstagramFeed */](this.http, stream, profile, group, options);
                break;
            case 'instabusiness':
                this.feed = new __WEBPACK_IMPORTED_MODULE_10__providers_feeds_classes_instagram_business_feed__["a" /* InstagramBusinessFeed */](this.http, stream, profile, group, options);
                break;
            case 'youtube':
                this.feed = new __WEBPACK_IMPORTED_MODULE_11__providers_feeds_classes_youtube_feed__["a" /* YoutubeFeed */](this.http, stream, profile, group, options);
                break;
            case 'googleplus':
                this.feed = new __WEBPACK_IMPORTED_MODULE_12__providers_feeds_classes_googleplus_feed__["a" /* GoogleplusFeed */](this.http, stream, profile, group, options);
                //this.feed.setAccountsServiceProvider(this.accountsServiceProvider);
                break;
            case 'googlemybusiness':
                this.feed = new __WEBPACK_IMPORTED_MODULE_14__providers_feeds_classes_google_business_feed__["a" /* GoogleMyBusinessFeed */](this.http, stream, profile, group, options);
                break;
            case 'blogger':
                this.feed = new __WEBPACK_IMPORTED_MODULE_15__providers_feeds_classes_blogger_feed__["a" /* BloggerFeed */](this.http, stream, profile, group, options);
                //this.feed.setAccountsServiceProvider(this.accountsServiceProvider);
                break;
            case 'pinterest':
                this.feed = new __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_pinterest_feed__["a" /* PinterestFeed */](this.http, stream, profile, group, options);
                //this.feed.setAccountsServiceProvider(this.accountsServiceProvider);
                break;
            case 'cinbox':
                this.feed = new __WEBPACK_IMPORTED_MODULE_16__providers_feeds_classes_inbox_feed__["a" /* InboxFeed */](this.http, stream, profile, group, options, this._ionicStorage);
                break;
            case 'yelp':
                this.feed = new __WEBPACK_IMPORTED_MODULE_17__classes_yelp_feed__["a" /* YelpFeed */](this.http, stream, profile, group, options);
                break;
            default:
                break;
        }
        this.feed.setAccountsServiceProvider(this.accountsServiceProvider);
        this.feed.setUserSettingsProvider(this.userSettingsProvider);
        this.feed.setFeedNotesProvider(this.feeNotesProvider);
        this.feed.setAccount();
        //set UniqueID
        this.feed.setUniqueID(uniqueID);
        this.feedContainer.push(this.feed);
    };
    /**
     * getUniqueID
     */
    FeedsServiceProvider.prototype.getUniqueID = function (profile, stream) {
        return stream.streamId + '_' + profile.profile_id;
    };
    /**
     * getStreams
     */
    FeedsServiceProvider.prototype.getStreams = function () {
        return this.feed.profile.data.streams;
    };
    /**
     * saveStreams
     */
    FeedsServiceProvider.prototype.saveStreams = function (streams) {
        console.log('inside', streams);
        var apiPath = "/feed/streams";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.feed.profile.account_id)
            .set("profileID", this.feed.profile.profile_id)
            .set("action", 'setStreams');
        // set streams
        if (streams.length > 0) {
            for (var i in streams) {
                httpParams = httpParams.append("stream[" + i + "][streamId]", streams[i].streamId);
                httpParams = httpParams.append("stream[" + i + "][name]", streams[i].name);
                httpParams = httpParams.append("stream[" + i + "][value]", streams[i].value);
                httpParams = httpParams.append("stream[" + i + "][size]", streams[i].size);
            }
        }
        ;
        return this.http.post(apiPath, httpParams);
    };
    /**
     * updateFavorite
     */
    FeedsServiceProvider.prototype.addToFavorite = function () {
        var apiPath = "/feed/favoriteStreams";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.feed.profile.account_id)
            .set("profileID", this.feed.profile.profile_id)
            .set("streamID", this.feed.id)
            .set("streamName", this.feed.name)
            .set("action", 'addFavoriteStream');
        return this.http.post(apiPath, httpParams);
    };
    /**
     * getInboxAccount
     */
    FeedsServiceProvider.prototype.getInboxProfile = function () {
        var profile = {
            display: {
                profile_name: 'InboxPage',
                profile_type: 'Cinbox',
                profile_picture_url: '',
                network: {
                    backend_network_name: 'Cinbox',
                    display_name: 'cinbox',
                    color: '',
                    logo: '',
                    circle_logo: '',
                    account_manage_order: 1,
                    character_limit: 10,
                },
            },
            profile_id: 'cinbox',
            account_id: 'cinbox',
            settings: {
                enabled: true
            },
            data: {
                lists: null,
                groups: [],
                power_users: null,
                streams: [{
                        id: 'cinbox',
                        streamId: 'cinbox',
                        network: 'cinbox',
                        value: 'true'
                    }]
            },
            monitored: 'on',
            original_config: {
                sampleId: 'cinbox',
                monitored: 'on',
                editorMonitored: "off",
                pageAccessToken: "000000",
                pageCategory: "User",
                pageId: "000000",
                pageName: 'InboxPage',
                socialMonitored: 'off',
                workingCalendar: 'off',
            }
        };
        return profile;
    };
    /**
     * getAccountsandSettings
     */
    // public getAccountsandSettings(): Observable<MappedAccountsInterface> {
    //     this
    //         .accountsServiceProvider
    //         .getAccountsAndSettings()
    // }
    /**
     * getYTComments
     */
    FeedsServiceProvider.prototype.getYoutubeComments = function (params) {
        var apiPath = "/feed/youTubeFeed";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", params.account_id)
            .set("profileID", params.profile_id)
            .set("video_id", params.video_id)
            .set('stream', 'yt_comments')
            .set("action", 'getYouTubeFeed');
        return this.http.get(apiPath, { params: httpParams });
    };
    /**
     * getIGComments
     */
    FeedsServiceProvider.prototype.getIGComments = function (params) {
        var apiPath = "/feed/igPostComments";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", params.account_id)
            .set("profileID", params.profile_id)
            .set("post_id", params.post_id)
            .set("action", 'getInComments');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            var comments = [];
            if (httpResponse && httpResponse.comment) {
                comments = httpResponse.comment;
                if (!Array.isArray(comments)) {
                    comments = [comments];
                }
            }
            return comments;
        });
    };
    /**
     * getIGComments
     */
    FeedsServiceProvider.prototype.getIGBComments = function (params) {
        var apiPath = "/feed/instagramBusiness";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", params.account_id)
            .set("profileID", params.profile_id)
            .set("post_id", params.post_id)
            .set("stream", 'igbComments')
            .set("action", 'getInstagramBusinessFeed');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            var comments = [];
            if (httpResponse && httpResponse.data) {
                comments = httpResponse.data;
                if (!Array.isArray(comments)) {
                    comments = [comments];
                }
            }
            return comments;
        });
    };
    /**
     * get Retweets
     *
     */
    FeedsServiceProvider.prototype.getRetweets = function (feedItem) {
        var _this = this;
        console.log('feedItem', feedItem);
        var apiPath = "/feed/retweets";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", feedItem.profile.account_id)
            .set("profileID", feedItem.profile.profile_id)
            .set("postId", feedItem.data.retweets.id)
            .set("action", 'getOtherRetweets');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            var retweets = [];
            if (httpResponse && httpResponse.length > 0) {
                for (var i = 0, l = httpResponse.length; i < l; i++) {
                    var retweet = _this.getMappedRetweetList(httpResponse[i]);
                    retweets.push(retweet);
                }
            }
            return retweets;
        });
    };
    FeedsServiceProvider.prototype.getMappedRetweetList = function (data) {
        var list = {};
        if (data && data.user) {
            list = {
                profilePic: data.user.profile_image_url,
                name: data.user.name,
                screenName: data.user.screen_name,
                tweets: data.user.statuses_count,
                followers: data.user.followers_count,
                following: data.user.friends_count,
                isFollowing: (data.user.following === 'true') ? true : false
            };
        }
        return list;
    };
    FeedsServiceProvider.prototype.getMappedLikesList = function (feedItem) {
        var likes = {};
        var list = [];
        console.log('feedItem', feedItem);
        if (feedItem.data.likes && parseInt(feedItem.data.likes.count) > 0) {
            for (var i = 0, l = parseInt(feedItem.data.likes.count); i < l; i++) {
                var like = (feedItem.data.likes.like[i]) ? feedItem.data.likes.like[i] : feedItem.data.likes.like;
                likes = {
                    profilePic: "https://graph.facebook.com/" + like.id + "/picture?width=1000&height=1000",
                    name: like.name,
                    profileLink: like.profileLink,
                    screenName: like.id
                };
                list.push(likes);
            }
        }
        return list;
    };
    FeedsServiceProvider.prototype.getLNLikes = function (feedItem) {
        var _this = this;
        console.log('feedItem', feedItem);
        var apiPath = "/feed/linkedInPostLikes";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", feedItem.profile.account_id)
            .set("profileID", feedItem.profile.profile_id)
            .set("post_id", feedItem.data.updateKey)
            .set("action", 'lnShareLikes');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            console.log('httpResponse', httpResponse);
            var retweets = [];
            if (httpResponse.streamEntry) {
                feedItem.data.likes = httpResponse.streamEntry.likes;
                if (parseInt(feedItem.data.likes._total) === 1)
                    feedItem.data.likes.values.creator = [feedItem.data.likes.values.creator];
            }
            else if (feedItem.data.likes._total === '0') {
                delete feedItem.data.likes.like;
                delete feedItem.data.likes.values;
            }
            console.log('feedItem.data.likes.values.creator', feedItem.data.likes.values.creator);
            retweets = _this.getMappedLNLikes(feedItem);
            return retweets;
        });
    };
    FeedsServiceProvider.prototype.getMappedLNLikes = function (feedItem) {
        var likes = feedItem.data.likes.values.creator;
        var likeData = {};
        var list = [];
        for (var i = 0, l = likes.length; i < l; i++) {
            console.log('likes[i]', likes[i]);
            if (likes[i].pictureUrl == null)
                likes[i].pictureUrl = feedItem.feed.defaultProfileImage;
            var lastName = (typeof (likes[i].lastName) == 'undefined') ? '' : likes[i].lastName;
            console.log("likes[i].lastName", likes[i].lastName);
            likeData = {
                profilePic: likes[i].pictureUrl,
                name: likes[i].firstName + ' ' + lastName,
                screenName: ''
            };
            list.push(likeData);
        }
        return list;
    };
    FeedsServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_18__user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_19__feed_notes_service__["a" /* FeedNotesProvider */]])
    ], FeedsServiceProvider);
    return FeedsServiceProvider;
}());

//# sourceMappingURL=feeds-service.js.map

/***/ }),

/***/ 139:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InboxFilterProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_storage__ = __webpack_require__(24);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var InboxFilterProvider = /** @class */ (function () {
    function InboxFilterProvider(_ionicStorage, _http) {
        this._ionicStorage = _ionicStorage;
        this._http = _http;
        this._keyForfiltersInStorage = "inbox_filters";
        this._keyForRolesInStorage = "inbox_roles";
        this._latestMessage = {};
        this._eventFilterTypes = [
            {
                keyForFilters: 'FBComments',
                displayText: 'Comments',
                network_name: 'facebook',
                keyForInboxSettings: 'FBEventsComments'
            },
            {
                keyForFilters: 'FBAdsComments',
                displayText: 'Ad Comments',
                network_name: 'facebook',
                keyForInboxSettings: 'FBEventsAdsComments'
            },
            // {
            //     keyForFilters: 'FBLikes|FBShares|FBOthers',
            //     displayText: 'Likes/Shares',
            //     network_name: 'facebook',
            //     keyForInboxSettings: 'FBEventsLikes'
            // },
            {
                keyForFilters: 'FBWallPosts',
                displayText: 'Write on Wall',
                network_name: 'facebook',
                keyForInboxSettings: 'FBEventsWallPosts'
            }, {
                keyForFilters: 'FBDirectMessage',
                displayText: 'Messenger',
                displayTextForHeader: 'Inbox (Messages)',
                network_name: 'facebook',
                keyForInboxSettings: 'FBEventsDirectMessages'
            }, {
                keyForFilters: 'FBReviews',
                displayText: 'Reviews',
                network_name: 'facebook',
                keyForInboxSettings: 'FBEventsReviews'
            }, {
                keyForFilters: 'FBMentions',
                displayText: 'Mentions',
                network_name: 'facebook',
                keyForInboxSettings: 'FBEventsMentions'
            }, {
                keyForFilters: 'TWFollowers',
                displayText: 'New Followers',
                network_name: 'twitter',
                keyForInboxSettings: 'TWEventsFollowers'
            }, {
                keyForFilters: 'TWDirectMessage',
                displayText: 'Direct Messages',
                network_name: 'twitter',
                keyForInboxSettings: 'TWEventsDirectMessages'
            }, {
                keyForFilters: 'TWMentions',
                displayText: 'Mentions',
                network_name: 'twitter',
                keyForInboxSettings: 'TWEventsMentions'
            }, {
                keyForFilters: 'TWRetweets',
                displayText: 'Retweets',
                network_name: 'twitter',
                keyForInboxSettings: 'TWEventsRetweets'
            },
            {
                keyForFilters: 'LNCompanyUpdates',
                displayText: 'Company Comments',
                displayTextForHeader: 'Comment',
                network_name: 'linkedin',
                keyForInboxSettings: 'LNEventsCompoanyUpdates'
            },
            {
                keyForFilters: 'LNLikesComments',
                displayText: 'Profile Comments',
                displayTextForHeader: 'Comment',
                network_name: 'linkedin',
                keyForInboxSettings: 'LNEventsLikesComments'
            },
            // {
            //     keyForFilters: 'GPComments',
            //     displayText: 'Page Comments',
            //     network_name: 'googleplus',
            //     keyForInboxSettings: 'GPEventsPageComments'
            // }, 
            {
                keyForFilters: 'INMessages',
                displayText: 'Direct Messages',
                displayTextForHeader: 'Inbox (Messages)',
                network_name: 'instagram',
                keyForInboxSettings: 'INEventsDirectMessages'
            },
            {
                keyForFilters: 'INComments',
                displayText: 'Comments',
                network_name: 'instagram',
                keyForInboxSettings: 'INEventsComments'
            }, {
                keyForFilters: 'INMentions',
                displayText: 'Mentions',
                network_name: 'instagram',
                keyForInboxSettings: 'INEventsMentions'
            }, {
                keyForFilters: 'YTComments',
                displayText: 'Comment',
                network_name: 'youtube',
                keyForInboxSettings: 'YTEventsComments'
            }, {
                keyForFilters: 'GMBReviews',
                displayText: 'Review',
                displayTextForHeader: '',
                network_name: 'googlemybusiness',
                keyForInboxSettings: 'GMBEventsReviews'
            }, {
                keyForFilters: 'GMBQuestions',
                displayText: 'Q & A',
                displayTextForHeader: '',
                network_name: 'googlemybusiness',
                keyForInboxSettings: 'GMBEventsQuestions'
            }, {
                keyForFilters: 'YelpReviews',
                displayText: 'Review',
                displayTextForHeader: '',
                network_name: 'yelp',
                keyForInboxSettings: 'YelpReviews'
            }
        ];
    }
    /**
     * get saved filters for inbox feeds
     */
    InboxFilterProvider.prototype.loadSavedFilters = function (key) {
        if (key === void 0) { key = ''; }
        return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(this._ionicStorage.get(this._keyForfiltersInStorage).then(function (savedFilter) {
            console.log('savedFilter', savedFilter);
            if (savedFilter && savedFilter[key]) {
                return savedFilter[key];
            }
            else {
                return {
                    profileIds: [],
                    types: [],
                    tags: []
                };
            }
        }, function () {
            return null;
        }));
    };
    ;
    InboxFilterProvider.prototype.saveFilters = function (filteredData, key) {
        var _this = this;
        if (key === void 0) { key = ''; }
        return new Promise(function (resolve, reject) {
            var userInboxFilters = {
                profileIds: filteredData.profileIds,
                types: filteredData.types,
                tags: filteredData.tags
            };
            _this
                ._ionicStorage
                .get(_this._keyForfiltersInStorage)
                .then(function (savedFilter) {
                if (!savedFilter) {
                    savedFilter = {};
                }
                savedFilter[key] = userInboxFilters;
                _this
                    ._ionicStorage
                    .set(_this._keyForfiltersInStorage, savedFilter)
                    .then(function (result) {
                    resolve();
                }, function (error) {
                    reject(error);
                });
            });
        });
    };
    ;
    InboxFilterProvider.prototype.mapProfilesForFilter = function (getUserEventParams) {
        var mappedProfiles = [];
        return new Promise(function (resolve, reject) {
            try {
                for (var _i = 0, _a = getUserEventParams.accounts.accounts; _i < _a.length; _i++) {
                    var account = _a[_i];
                    // if (account.data.config.monitored === 'on' && account.data.config.eventsMonitored === 'on') {
                    if (undefined != account.profiles && account.profiles.length > 0 && account.display.network.backend_network_name.toLocaleLowerCase() !== "pinterest") {
                        for (var _b = 0, _c = account.profiles; _b < _c.length; _b++) {
                            var profile = _c[_b];
                            if (profile.original_config.eventsMonitored === 'off') {
                                continue;
                            }
                            if (profile.display.network.backend_network_name.toLocaleLowerCase() === 'facebook' && profile.original_config.pageCategory === 'User') {
                                continue;
                            }
                            if (profile.original_config.monitored === 'on' || profile.original_config.socialMonitored == 'on') {
                                if (account.display.network.backend_network_name === 'GooglePlus' && profile.original_config.objectType === 'person') {
                                    continue;
                                }
                            }
                            if ((profile.original_config.monitored === 'on' || (['GoogleMyBusiness', 'GooglePlus', 'Yelp'].indexOf(account.display.network.backend_network_name) !== -1 && profile.original_config.socialMonitored === 'on')) && profile.original_config.eventsMonitored === 'on') { //  
                                if (profile.display.network.backend_network_name.toLocaleLowerCase() === 'facebook' && profile.original_config.pageCategory === 'User') {
                                }
                                else {
                                    var _selected = (getUserEventParams.savedFilters.profileIds && getUserEventParams.savedFilters.profileIds.length > 0) ? getUserEventParams.savedFilters.profileIds.indexOf(profile.profile_id) > -1 : false;
                                    mappedProfiles.push({
                                        selected: _selected,
                                        profile: profile,
                                    });
                                }
                                // }
                            }
                        }
                    }
                } //end for
                resolve(mappedProfiles);
            }
            catch (err) {
                reject(err);
            }
        }); //end promise
    };
    InboxFilterProvider.prototype.mapTypesForFilter = function (getUserEventParams) {
        var _this = this;
        var mappedTypes = [];
        return new Promise(function (resolve, reject) {
            for (var _i = 0, _a = _this._eventFilterTypes; _i < _a.length; _i++) {
                var type = _a[_i];
                for (var _b = 0, _c = getUserEventParams.accounts.networks; _b < _c.length; _b++) {
                    var network = _c[_b];
                    if (type.network_name !== network.backend_network_name.toLowerCase()) {
                        continue;
                    }
                    var _selected = false;
                    if (getUserEventParams.savedFilters.types && getUserEventParams.savedFilters.types.length) {
                        if (type.keyForFilters.indexOf('|') !== -1) {
                            var subTypes = type.keyForFilters.split('|');
                            for (var index = 0; index < subTypes.length; index++) {
                                if (getUserEventParams.savedFilters.types.indexOf(subTypes[index]) !== -1) {
                                    _selected = true;
                                    break;
                                }
                            }
                        }
                        else {
                            _selected = getUserEventParams.savedFilters.types.indexOf(type.keyForFilters) !== -1 ? true : false;
                        }
                    }
                    mappedTypes.push({
                        selected: _selected,
                        data: {
                            id: type.keyForFilters,
                            displayText: type.displayText,
                            logo: {
                                name: network.circle_logo,
                                color: network.color
                            }
                        }
                    });
                }
            }
            resolve(mappedTypes);
        }); //end promise
    };
    ;
    InboxFilterProvider.prototype.mapTagsForFilter = function (getUserEventParams, tags) {
        var mappedTags = [];
        return new Promise(function (resolve, reject) {
            for (var _i = 0, tags_1 = tags; _i < tags_1.length; _i++) {
                var tag = tags_1[_i];
                var _selected = (getUserEventParams.savedFilters.tags && getUserEventParams.savedFilters.tags.length) > 0 ? getUserEventParams.savedFilters.tags.indexOf(tag) > -1 : false;
                mappedTags.push({
                    selected: _selected,
                    data: { displayText: tag }
                });
            }
            resolve(mappedTags);
        }); //end promise
    };
    ;
    InboxFilterProvider.prototype.getEventFilterTypes = function () {
        return this._eventFilterTypes;
    };
    /**
    * isEventExists
    */
    InboxFilterProvider.prototype.isAllowedEventType = function (eventType) {
        var flag = false;
        for (var i = 0; i < this._eventFilterTypes.length; i++) {
            var element = this._eventFilterTypes[i];
            if (element.keyForFilters === eventType) {
                flag = true;
                break;
            }
        }
        return flag;
    };
    /**
    * Used for add and delete
    * @param tags
    */
    InboxFilterProvider.prototype.updateTags = function (tags) {
        console.log('tags', tags);
        var requestBody = {
            tags: tags
        };
        return this
            ._http
            .post("/user/events", requestBody);
    };
    ; //end addNewTags()
    /**
    * Used to assign roles
    * @param roles
    */
    InboxFilterProvider.prototype.assignRole = function (eventData, roles) {
        var requestBody = {
            events: [
                {
                    date: eventData.eventTime,
                    roles: roles.length === 0
                        ? 'clear_tags'
                        : roles
                }
            ]
        };
        if (eventData.eventUserName) {
            requestBody.events[0].eventUserName = eventData.eventUserName;
        }
        return this
            ._http
            .post("/user/events", requestBody);
    };
    ; //end addNewTags()
    InboxFilterProvider.prototype.updateItemTags = function (eventDate, tags, eventUserName) {
        if (eventUserName === void 0) { eventUserName = ''; }
        var requestBody = {
            events: [
                {
                    date: eventDate,
                    eventUserName: eventUserName,
                    tags: tags.length === 0
                        ? 'clear_tags'
                        : tags
                }
            ]
        };
        return this
            ._http
            .post("/user/events", requestBody);
    }; //end saveUserItemTags
    InboxFilterProvider.prototype.getTags = function () {
        var maxEvents = 1, startTime = 0, endTime = 0;
        var getUserInboxTagsParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", "getUserEvents")
            .set("maxEvents", maxEvents.toString())
            .set("startTime", startTime.toString())
            .set("endTime", endTime.toString())
            .set("request_action", "getUserTags");
        var options = { params: getUserInboxTagsParams };
        return this
            ._http
            .get("/feed/userEvents", options)
            .map(function (tagsResponse) {
            return tagsResponse["tags"];
        });
    };
    ; // end getTags
    InboxFilterProvider.prototype.saveRoles = function (roleData) {
        var _this = this;
        console.log("saveRoles", roleData);
        return new Promise(function (resolve, reject) {
            _this._ionicStorage.set(_this._keyForRolesInStorage, roleData)
                .then(function (result) {
                resolve();
            }, function (error) {
                reject(error);
            });
        });
    };
    /**
       * get saved roles for inbox feeds
       */
    InboxFilterProvider.prototype.loadSavedRoles = function () {
        return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(this._ionicStorage.get(this._keyForRolesInStorage).then(function (savedRoles) {
            return savedRoles;
        }, function () {
            return null;
        }));
    };
    ;
    InboxFilterProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], InboxFilterProvider);
    return InboxFilterProvider;
}());

;
//# sourceMappingURL=inbox-filter.js.map

/***/ }),

/***/ 140:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ReputationsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__user_data_user_data__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_moment__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/*
  Generated class for the ReputationsProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var ReputationsProvider = /** @class */ (function () {
    function ReputationsProvider(http, userSettingsService, ionicStorage, userDataProvider) {
        this.http = http;
        this.userSettingsService = userSettingsService;
        this.ionicStorage = ionicStorage;
        this.userDataProvider = userDataProvider;
        this.mappedRoles = [];
        this.mappedTags = [];
        this.isRecentSort = false;
        this.mappedKeyWords = [];
        this.countries = [];
        this.siteCategories = [];
        this.languages = [];
        this.nextToken = null;
        this.typesFilter = [{ id: 'all', value: "All", count: 0 }, { id: "news", value: "News", count: 0 }, { id: "blogs", value: "Blogs", count: 0 }, { id: "discussion", value: "Discussion", count: 0 }, { id: "reviews", value: "Reviews", count: 0 }, { id: "videos", value: "Videos", count: 0 }];
        this.dataLimit = 50;
        // source for analytic show/Hide legend number
        this.typesCountSource = new __WEBPACK_IMPORTED_MODULE_5_rxjs_BehaviorSubject__["BehaviorSubject"](false);
        // source for observable
        this.repReloadSource = new __WEBPACK_IMPORTED_MODULE_5_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.repReload$ = this.repReloadSource.asObservable();
        this.nestApiUrl = this.userSettingsService.getNestApiUrl(true);
    }
    ReputationsProvider.prototype.getReputationUser = function () {
        var _this = this;
        var userSettings = this.userSettingsService.getUserSettings();
        if (userSettings) {
            var userParam = {};
            userParam.userName = this.userSettingsService.getUserName();
            if (this.userSettingsService.isAgency()) {
                var currentBrand = this.userSettingsService.getSelectedBrand();
                userParam.clientId = currentBrand.clientId;
                // console.log("addKeyword", this.userSettingsService.getSelectedBrand())
            }
            if (userSettings.reputationSampleFrequency) {
                userParam.sampleFrequency = userSettings.reputationSampleFrequency;
                userParam.postCount = userSettings.reputationLicenseNumberOfKeywords;
            }
            var params = {
                userDetails: userParam
            };
            return this.http
                .post(this.nestApiUrl + 'user-keywords/reputation-user', params, this.httpOptions)
                .map(function (resp) {
                if (resp.data) {
                    _this.saveReputationUserId(resp.data.userId);
                    if (resp.data.totalKeywordAdded)
                        _this.setKeywordCount(resp.data.totalKeywordAdded);
                    _this.reputationUserId = resp.data.userId;
                }
                return resp.data.userId;
            });
        }
    };
    ReputationsProvider.prototype.saveReputationUserId = function (userId) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var saveKey = _this.getUserKeyForLocalStorage();
            var param = {};
            param[saveKey] = userId;
            _this.ionicStorage.set('reputation_user_id', param)
                .then(function (result) {
                resolve();
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.getReputationUserId = function () {
        return this.reputationUserId;
    };
    ReputationsProvider.prototype.setKeywordCount = function (keywordCount) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var userSettings = _this.userSettingsService.getUserSettings();
            var param = {};
            param[userSettings.userName] = keywordCount;
            _this.ionicStorage.set("keyword_count", param)
                .then(function (result) {
                resolve();
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.getKeywordCount = function (keywordCount) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var userSettings = _this.userSettingsService.getUserSettings();
            _this.ionicStorage.get("keyword_count")
                .then(function (result) {
                resolve(result[userSettings.userName]);
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.getUserKeyForLocalStorage = function () {
        var userSettings = this.userSettingsService.getUserSettings();
        var saveKey = userSettings.userName;
        if (this.userSettingsService.isAgency()) {
            var currentBrand = this.userSettingsService.getSelectedBrand();
            saveKey = currentBrand.clientId;
        }
        return saveKey;
    };
    ReputationsProvider.prototype.setHeaderData = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this
                .ionicStorage
                .get(_this.userDataProvider.responseHeadersKey2)
                .then(function (savedUserDataFromStorage) {
                if (null === savedUserDataFromStorage) {
                    return null;
                }
                else {
                    // let temp = JSON.parse(savedUserDataFromStorage);
                    // Make a request to get user/settings with user_data in headers\
                    _this.httpOptions = { headers: new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["d" /* HttpHeaders */]({ "Authorization": 'Bearer ' + savedUserDataFromStorage, target: 'api', bearer: 'true' }) };
                    resolve(_this.httpOptions);
                }
            }).catch(function (settingsError) {
                return settingsError;
            }); //end get /user/settings
        });
    };
    /**
         * get saved roles for inbox feeds
         */
    ReputationsProvider.prototype.loadSavedRoles = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ionicStorage.get('inbox_roles')
                .then(function (savedRoles) {
                if (_this.userSettingsService.isAgency())
                    savedRoles = _this.mapBrandRoles(savedRoles);
                _this.mappedRoles = savedRoles;
                resolve(savedRoles);
            }, function (error) {
                reject(error);
            });
        });
    };
    ;
    ReputationsProvider.prototype.mapBrandRoles = function (roles) {
        var selectedBrand = this.userSettingsService.getSelectedBrand();
        var mappedRoles = [];
        mappedRoles.push(roles[0]); //All Team Members
        mappedRoles.push(roles[1]); //Main Admin
        for (var _i = 0, roles_1 = roles; _i < roles_1.length; _i++) {
            var role = roles_1[_i];
            if (role.accountPermissions && Array.isArray(role.accountPermissions)) {
                var accountPermisions = role.accountPermissions;
                // console.log("mapBrandRoles",accountPermisions);
                // console.log('mappedRoles', roles);
                for (var _a = 0, accountPermisions_1 = accountPermisions; _a < accountPermisions_1.length; _a++) {
                    var permission = accountPermisions_1[_a];
                    if (permission.clientId === selectedBrand.clientId && permission.permission != "disabled") {
                        mappedRoles.push(role);
                    }
                    else {
                        continue;
                    }
                }
            }
        }
        return mappedRoles;
    };
    ReputationsProvider.prototype.getMappedRoles = function () {
        return this.mappedRoles.slice();
    };
    ReputationsProvider.prototype.loadKeywordEntities = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ionicStorage.get('keyword_entities')
                .then(function (res) {
                if (res) {
                    var entities = JSON.parse(res);
                    // if (entities.countries) {
                    //   this.countries = entities.countries;
                    // }
                    // if (entities.languages) {
                    //   this.languages = entities.languages;
                    // }
                    // if (entities.categories) {
                    //   this.siteCategories = entities.categories;
                    // }
                    resolve(entities);
                }
                else {
                    resolve(null);
                }
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.loadSavedUserId = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ionicStorage.get('reputation_user_id')
                .then(function (resp) {
                var saveKey = _this.getUserKeyForLocalStorage();
                if (resp && resp[saveKey]) {
                    _this.reputationUserId = resp[saveKey];
                    resolve(resp[saveKey]);
                }
                else {
                    resolve(null);
                }
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.loadSavedKeyword = function () {
        var _this = this;
        var userKey = this.getUserKeyForLocalStorage();
        return new Promise(function (resolve, reject) {
            _this.ionicStorage.get("last_selected_keyword")
                .then(function (keyword) {
                if (keyword && keyword[userKey]) {
                    resolve(keyword[userKey]);
                }
                else {
                    resolve(null);
                }
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.loadSavedSearch = function () {
        var _this = this;
        var userKey = this.getUserKeyForLocalStorage();
        return new Promise(function (resolve, reject) {
            _this.ionicStorage.get('rep_search')
                .then(function (searchData) {
                if (searchData && searchData[userKey]) {
                    resolve(searchData[userKey]);
                }
                else {
                    resolve([]);
                }
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.getKeywordEntities = function () {
        var _this = this;
        return this.http
            .get(this.nestApiUrl + 'user-keywords/get-keyword-entities', this.httpOptions).
            map(function (resp) {
            if (resp.data) {
                // if (resp.data.countries) {
                //   this.countries = resp.data.countries;
                // }
                // if (resp.data.languages) {
                //   this.languages = resp.data.languages;
                // }
                // if (resp.data.categories) {
                //   this.siteCategories = resp.data.categories;
                // }
                _this.saveKeywordEntities(resp.data);
            }
            return resp.data;
        });
    };
    ReputationsProvider.prototype.saveKeywordEntities = function (entities) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ionicStorage.set('keyword_entities', JSON.stringify(entities))
                .then(function (result) {
                resolve();
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.getTags = function () {
        var _this = this;
        return this
            .http
            .get(this.nestApiUrl + 'user-tags/get-usertags/' + this.reputationUserId, this.httpOptions)
            .map(function (response) {
            if (response && response.data) {
                _this.setMappedTags(response.data);
                return response.data;
            }
            return [];
        });
    };
    ; // end getTags
    ReputationsProvider.prototype.setMappedTags = function (tags) {
        this.mappedTags = [];
        var userSettings = this.userSettingsService.getUserSettings();
        var tagKey = 'recentTag';
        var tempTags = [];
        var savedSettings = [];
        this.isRecentSort = false;
        if (this.userSettingsService.isAgency()) {
            tagKey = this.userSettingsService.getSelectedBrand().clientName;
        }
        if (userSettings && userSettings.feSettings && userSettings.feSettings.tagSettings) {
            if (userSettings.feSettings.tagSettings.recent)
                this.isRecentSort = userSettings.feSettings.tagSettings.recent;
            if (userSettings.feSettings.tagSettings[tagKey]) {
                savedSettings = userSettings.feSettings.tagSettings[tagKey];
                for (var t = 0; t < savedSettings.length; t++) {
                    tempTags.push(savedSettings[t].tagName);
                }
            }
        }
        for (var i = 0; i < tags.length; i++) {
            var createdAt = 0;
            if (tempTags && tempTags.length > 0) {
                createdAt = (tempTags.indexOf(tags[i].tag) > -1) ? savedSettings[tempTags.indexOf(tags[i].tag)].createdAt : 0;
            }
            this.mappedTags.push({
                selected: false,
                editForm: false,
                confirmDelete: false,
                createdAt: createdAt,
                data: {
                    id: tags[i].id,
                    displayText: tags[i].tag,
                    oldText: tags[i].tag
                }
            });
        }
    };
    ReputationsProvider.prototype.getKeyWords = function () {
        var _this = this;
        var userId = this.getReputationUserId();
        if (userId) {
            return this.http
                .get(this.nestApiUrl + 'user-keywords/get-keywords/' + userId, this.httpOptions)
                .map(function (resp) {
                // let keywords = (resp.data) ? resp.data : [];
                var keywords = [];
                if (resp.data && resp.data.keywords) {
                    keywords = _this.setMappedKeyword(resp.data.keywords);
                }
                return keywords;
            });
        }
        else {
            return __WEBPACK_IMPORTED_MODULE_6_rxjs_Observable__["Observable"].of([]);
        }
    };
    ; // end getKeywords
    ReputationsProvider.prototype.setMappedKeyword = function (keyWords) {
        this.mappedKeyWords = [];
        var _loop_1 = function (val) {
            var createdAt = 0;
            var mappedKeyword = {};
            var tempCat = [];
            var tempCountry = [];
            var tempLang = [];
            var exclude = '';
            //mapping cateory country and languages
            if (val.UserKeywordParam) {
                if (val.UserKeywordParam.category && this_1.siteCategories) {
                    var selectedCat_1 = val.UserKeywordParam.category.split(',').map(Number);
                    this_1.siteCategories.map(function (category) {
                        if (selectedCat_1.indexOf(category.id) != -1) {
                            tempCat.push(category);
                        }
                    });
                }
                if (val.UserKeywordParam.country && this_1.countries) {
                    var selectedCountry_1 = val.UserKeywordParam.country.split(',').map(Number);
                    this_1.countries.map(function (country) {
                        if (selectedCountry_1.indexOf(country.id) != -1) {
                            tempCountry.push(country);
                        }
                    });
                }
                if (val.UserKeywordParam.language && this_1.languages) {
                    var selectedLang_1 = val.UserKeywordParam.language.split(',').map(Number);
                    this_1.languages.map(function (language) {
                        if (selectedLang_1.indexOf(language.id) != -1) {
                            tempLang.push(language);
                        }
                    });
                }
                exclude = (val.UserKeywordParam.exclude) ? val.UserKeywordParam.exclude : exclude;
            }
            // console.log('t-------------------',tempCat);
            mappedKeyword = {
                selected: (val.selected == 'Y') ? true : false,
                editForm: false,
                createdAt: val.createdDate,
                data: {
                    id: val.id,
                    displayText: val.keyword,
                    oldText: val.keyword,
                    exclude: exclude,
                    category: tempCat,
                    language: tempLang,
                    country: tempCountry,
                    postCount: (val.postCount) ? val.postCount.toLocaleString() : val.postCount //(val.postCount && val.postCount > 99) ? '99+' : val.postCount
                }
            };
            this_1.mappedKeyWords.push(mappedKeyword);
        };
        var this_1 = this;
        for (var _i = 0, keyWords_1 = keyWords; _i < keyWords_1.length; _i++) {
            var val = keyWords_1[_i];
            _loop_1(val);
        }
        return this.mappedKeyWords;
    };
    ReputationsProvider.prototype.updateMappedkeyword = function (mappedKeywords) {
        this.mappedKeyWords = mappedKeywords;
    };
    /**
     * getReputationData
     */
    ReputationsProvider.prototype.getReputationData = function (keywordParam, userFilterOptions, exportReport) {
        var _this = this;
        if (exportReport === void 0) { exportReport = false; }
        if (keywordParam && keywordParam.data) {
            var params = {
                userId: this.reputationUserId,
                keywordId: keywordParam.data.id,
                limit: this.dataLimit
            };
            if (userFilterOptions) {
                params.filter = {};
                if (userFilterOptions.category && userFilterOptions.category.length > 0) {
                    var catParam = [];
                    for (var _i = 0, _a = userFilterOptions.category; _i < _a.length; _i++) {
                        var category = _a[_i];
                        catParam.push(category.id);
                    }
                    params.filter.category = catParam;
                }
                if (userFilterOptions.country && userFilterOptions.country.length > 0) {
                    var countryParam = [];
                    for (var _b = 0, _c = userFilterOptions.country; _b < _c.length; _b++) {
                        var country = _c[_b];
                        countryParam.push(country.id);
                    }
                    params.filter.country = countryParam;
                }
                if (userFilterOptions.languages && userFilterOptions.languages.length > 0) {
                    var languageParam = [];
                    for (var _d = 0, _e = userFilterOptions.languages; _d < _e.length; _d++) {
                        var category = _e[_d];
                        languageParam.push(category.id);
                    }
                    params.filter.language = languageParam;
                }
                if (userFilterOptions.types && userFilterOptions.types.length > 0) {
                    params.postType = userFilterOptions.types;
                }
                if (userFilterOptions.tags && userFilterOptions.tags.length > 0) {
                    params.userTag = userFilterOptions.tags;
                }
                if (userFilterOptions.roles && userFilterOptions.roles.length > 0) {
                    params.roles = userFilterOptions.roles;
                }
                if (userFilterOptions.rating && userFilterOptions.rating.rate && userFilterOptions.rating.rate > 0) {
                    params.filter.ratingPrefix = (userFilterOptions.rating.option === "Greater than") ? 'gt' : 'lt';
                    params.filter.rating = userFilterOptions.rating.rate;
                }
                if (userFilterOptions.domainRank && userFilterOptions.domainRank > 0) {
                    params.filter.rank = userFilterOptions.domainRank;
                }
                if (userFilterOptions.complete && (userFilterOptions.complete == 'Y' || userFilterOptions.complete == 'N')) {
                    params.complete = userFilterOptions.complete;
                }
                if (userFilterOptions.publishedDate) {
                    if (new Date(userFilterOptions.publishedDate.startDate).valueOf() != new Date(userFilterOptions.publishedDate.endDate).valueOf()) {
                        params.filter.publishDate = {};
                        params.filter.publishDate.from = __WEBPACK_IMPORTED_MODULE_7_moment__(userFilterOptions.publishedDate.startDate).format('YYYY-MM-DD');
                        params.filter.publishDate.to = __WEBPACK_IMPORTED_MODULE_7_moment__(userFilterOptions.publishedDate.endDate).format('YYYY-MM-DD');
                        // params.filter.rank = userFilterOptions.domainRank;
                    }
                }
                if (userFilterOptions.searchText && userFilterOptions.searchText != '') {
                    params.searchText = userFilterOptions.searchText;
                }
                if (userFilterOptions.sentiment && userFilterOptions.sentiment != 'all') {
                    params.filter.sentiment = userFilterOptions.sentiment;
                }
            }
            if (this.nextToken)
                params.offset = this.nextToken;
            //for export purpose
            if (exportReport) {
                params.limit = 100;
                params.offset = 0;
            }
            return this.http
                .post(this.nestApiUrl + 'posts/get-posts', params, this.httpOptions)
                .map(function (resp) {
                var reputations = [];
                if (resp.data) {
                    var reputations_1 = [];
                    if (exportReport === false) {
                        if (resp.data.nextToken) {
                            _this.nextToken = resp.data.nextToken;
                        }
                        else {
                            _this.nextToken = null;
                        }
                    }
                    console.log("************", _this.nextToken);
                    if (resp.data.posts) {
                        var newsCnt = 0, blogsCnt = 0, discussionCnt = 0, reviewCnt = 0, videoCnt = 0;
                        var _loop_2 = function (post) {
                            // let posts = [];
                            // console.log("mahe::11",post);
                            var reputation = {};
                            if (post) {
                                reputation.id = post.id || '';
                                reputation.header = {
                                    title: (post.title) ? post.title : "",
                                    postDate: (post.publishedDate) ? __WEBPACK_IMPORTED_MODULE_7_moment__(post.publishedDate).format('MMM DD,YYYY HH:MM') : '',
                                    domainName: (post.siteUrl) ? post.siteUrl : '',
                                    imageUrl: (post.imgUrl) ? post.imgUrl : '',
                                    siteType: (post.postType) ? post.postType : '',
                                };
                                reputation.summary = {
                                    text: (post.text) ? post.text : '',
                                    srcUrl: (post.siteUrl) ? post.siteUrl : '',
                                    siteLink: (post.siteUrl) ? new URL(post.siteUrl).hostname : '',
                                    sentiment: 'neutral'
                                };
                                if (post.PostUserTags) {
                                    // reputation.summary.tags = post.PostUserTags;
                                    _this.mappedTags.forEach(function (tag) {
                                        for (var _i = 0, _a = post.PostUserTags; _i < _a.length; _i++) {
                                            var t = _a[_i];
                                            if (t.userTagId === tag.data.id) {
                                                t.tagName = tag.data.displayText;
                                            }
                                        }
                                    });
                                    reputation.summary.tags = post.PostUserTags;
                                }
                                if (post.PostRole) {
                                    var mappedRoles = _this.getMappedRoles();
                                    for (var _i = 0, mappedRoles_1 = mappedRoles; _i < mappedRoles_1.length; _i++) {
                                        var role = mappedRoles_1[_i];
                                        if (role.userName === post.PostRole.role) {
                                            // console.log("role",role,)
                                            reputation.summary.role = role;
                                        }
                                    }
                                }
                                reputation.summary.sentiment = (post.PostSentiment && post.PostSentiment.sentiment) ? post.PostSentiment.sentiment : 'neutral';
                                // if (post.PostSentiment && post.PostSentiment.sentiment) {
                                //   if (post.PostSentiment.sentiment === 'negative') {
                                //     reputation.summary.sentiment = {
                                //       type: post.PostSentiment.sentiment,
                                //       class: 'text-danger fas fa-frown'
                                //     }
                                //   } else if (post.PostSentiment.sentiment === 'positive') {
                                //     reputation.summary.sentiment = {
                                //       type: post.PostSentiment.sentiment,
                                //       class: 'text-success fas fa-smile',
                                //     }
                                //   }
                                // }
                                reputation.actions = {
                                    engage: {
                                        highlighted: false,
                                    },
                                    tag: {
                                        highlighted: (post.PostUserTags && post.PostUserTags.length > 0) ? true : false,
                                    },
                                    assign: {
                                        highlighted: (post.PostRole && post.PostRole.role) ? true : false,
                                    },
                                    delete: {
                                        highlighted: false,
                                    },
                                    schedule: true,
                                    addToQueue: true,
                                    completeItem: {
                                        highlighted: (post.complete == 'Y') ? true : false
                                    }
                                };
                                reputation.originalData = post;
                                switch (post.postType) {
                                    case 'news':
                                        newsCnt++;
                                        break;
                                    case 'blogs':
                                        blogsCnt++;
                                        break;
                                    case 'discussions':
                                        discussionCnt++;
                                        break;
                                    case 'reviews':
                                        reviewCnt++;
                                        break;
                                    case 'videos':
                                        videoCnt++;
                                        break;
                                }
                                reputations_1.push(reputation);
                            }
                            _this.typesFilter[1].count = newsCnt;
                            _this.typesFilter[2].count = blogsCnt;
                            _this.typesFilter[3].count = discussionCnt;
                            _this.typesFilter[4].count = reviewCnt;
                            _this.typesFilter[5].count = videoCnt;
                            _this.typesFilter[0].count = newsCnt + blogsCnt + discussionCnt + reviewCnt + videoCnt;
                            _this.typesCountSource.next(true);
                        };
                        for (var _i = 0, _a = resp.data.posts; _i < _a.length; _i++) {
                            var post = _a[_i];
                            _loop_2(post);
                        }
                    }
                    // }
                    return reputations_1;
                }
                return reputations;
            });
        }
        else {
            return __WEBPACK_IMPORTED_MODULE_6_rxjs_Observable__["Observable"].of([]);
        }
    };
    ReputationsProvider.prototype.setLastSelectedKeyword = function (keyword) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var param = {};
            var userKey = _this.getUserKeyForLocalStorage();
            param[userKey] = keyword;
            _this.ionicStorage.set("last_selected_keyword", param)
                .then(function (result) {
                resolve();
            }, function (error) {
                reject(error);
            });
        });
    };
    ReputationsProvider.prototype.deletePost = function (postId) {
        var param = {
            postId: postId
        };
        return this.http
            .post(this.nestApiUrl + 'posts/delete-post', param, this.httpOptions)
            .map(function (resp) {
            console.log("deletePost", resp);
            return resp;
        });
    };
    ReputationsProvider.prototype.updatePost = function (params) {
        if (!params.postId) {
            return __WEBPACK_IMPORTED_MODULE_6_rxjs_Observable__["Observable"].of(null);
        }
        return this.http
            .post(this.nestApiUrl + 'posts/update-post', params, this.httpOptions)
            .map(function (resp) {
            console.log("completePost", resp);
            return resp;
        });
    };
    /**
     * get mapped reputation tags
     */
    ReputationsProvider.prototype.getMappedTags = function () {
        return this.mappedTags.slice();
    };
    ReputationsProvider.prototype.addUserTag = function (tagName, tagId) {
        if (tagId === void 0) { tagId = null; }
        var param = {
            tagName: tagName,
            userId: this.reputationUserId
        };
        if (tagId) {
            param.tagId = tagId;
        }
        return this.http
            .post(this.nestApiUrl + 'user-tags/add-tag', param, this.httpOptions)
            .map(function (resp) {
            console.log("addUserTag", resp);
            return resp;
        });
    };
    ReputationsProvider.prototype.updateMappedTags = function (tags) {
        this.mappedTags = tags;
    };
    ReputationsProvider.prototype.deleteUserTag = function (tagId) {
        var param = {
            tagId: tagId
        };
        return this.http
            .post(this.nestApiUrl + 'user-tags/delete-tag', param, this.httpOptions).
            map(function (resp) {
            console.log("addUserTag", resp);
            return resp;
        });
    };
    ReputationsProvider.prototype.assignTag = function (params) {
        if (!params.postId) {
            return __WEBPACK_IMPORTED_MODULE_6_rxjs_Observable__["Observable"].of(null);
        }
        return this.http
            .post(this.nestApiUrl + 'posts/assign-tag', params, this.httpOptions).
            map(function (resp) {
            console.log("assignTag", resp);
            return resp;
        });
    };
    ReputationsProvider.prototype.assignRole = function (param) {
        if (!param.postId) {
            return __WEBPACK_IMPORTED_MODULE_6_rxjs_Observable__["Observable"].of(null);
        }
        return this.http
            .post(this.nestApiUrl + 'posts/assign-roles', param, this.httpOptions).
            map(function (resp) {
            console.log("assignRole", resp);
            return resp;
        });
    };
    ReputationsProvider.prototype.mapItemFilter = function (selectedItem) {
        var items = [
            {
                selected: (selectedItem == 'all') ? true : false,
                data: {
                    displayText: 'All'
                }
            },
            {
                selected: (selectedItem == 'completed') ? true : false,
                data: {
                    displayText: 'Completed Items'
                }
            }
        ];
        return items;
    };
    ReputationsProvider.prototype.mapRolesForFilter = function (selectedRoles) {
        console.log("selectedRoles", selectedRoles);
        var userSettings = this.userSettingsService.getUserSettings();
        var mappedFilterRoles = [];
        var selected = false;
        for (var _i = 0, _a = this.mappedRoles; _i < _a.length; _i++) {
            var role = _a[_i];
            var roleName = (userSettings.isAdminUser && userSettings.email === role.userName) ? "Main Admin" : role.displayName;
            if (selectedRoles && selectedRoles.length <= 0 && role.userName === "all_roles")
                selected = true;
            else {
                selected = selectedRoles && selectedRoles.indexOf(role.userName) > -1 ? true : false;
            }
            mappedFilterRoles.push({
                selected: selected,
                data: {
                    displayText: roleName,
                    id: role.userName
                }
            });
        }
        return mappedFilterRoles;
    };
    ReputationsProvider.prototype.mapTypesFilter = function (selectedTypes) {
        var typesFilter = [];
        var types = this.typesFilter;
        var selected = false;
        for (var _i = 0, types_1 = types; _i < types_1.length; _i++) {
            var type = types_1[_i];
            if (selectedTypes && selectedTypes.length <= 0 && type.id === "all")
                selected = true;
            else {
                selected = (selectedTypes && selectedTypes.indexOf(type.id) > -1) ? true : false;
            }
            typesFilter.push({
                selected: selected,
                data: {
                    displayText: type.value,
                    id: type.id,
                    count: type.count
                }
            });
        }
        return typesFilter;
    };
    ReputationsProvider.prototype.mapTagsFilter = function (selectedTags) {
        var mappedFilterTags = [];
        for (var _i = 0, _a = this.mappedTags; _i < _a.length; _i++) {
            var tag = _a[_i];
            mappedFilterTags.push({
                selected: (selectedTags && selectedTags.indexOf(tag.data.id) > -1) ? true : false,
                data: {
                    displayText: tag.data.displayText,
                    id: tag.data.id
                }
            });
        }
        return mappedFilterTags;
    };
    ReputationsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_2__user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_3__user_data_user_data__["a" /* UserDataProvider */]])
    ], ReputationsProvider);
    return ReputationsProvider;
}());

//# sourceMappingURL=reputations.js.map

/***/ }),

/***/ 141:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AccountsBrandsServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


// import 'rxjs/add/observable/throw';
// import 'rxjs/add/operator/catch';
var AccountsBrandsServiceProvider = /** @class */ (function () {
    function AccountsBrandsServiceProvider(_http) {
        this._http = _http;
    }
    ; //end constructor
    //Used in AccountsManagePage and AccountsSocialProfilesPage
    /*   public findSelectedBrand(clients: ClientInterface[]): Promise<ClientInterface> {
        return new Promise((resolve, reject) => {
          for (let client of clients) {
            if (client.selected) {
              //found selecetd
              resolve(client)
            }
          };
          reject();
        });
      }; // end _findSelectedBrand
     */
    AccountsBrandsServiceProvider.prototype.selectBrand = function (clientRequestParams) {
        var _this = this;
        // let headers = new HttpHeaders().set("user_data", JSON.stringify(selectClientHeaders));
        return this
            ._http
            .post("/agency/selectClient", clientRequestParams).map(function (addResponse) {
            return _this._mapObjectIntoArray(addResponse);
        });
    };
    ; // end getClient
    AccountsBrandsServiceProvider.prototype.addBrand = function (addBrandBody) {
        var _this = this;
        return this
            ._http
            .put("/agency/client", addBrandBody).map(function (addResponse) {
            return _this._mapObjectIntoArray(addResponse);
        });
    };
    ; // end addBrand
    AccountsBrandsServiceProvider.prototype.deleteBrand = function (deleteBrandBody) {
        var _this = this;
        return this
            ._http
            .post("/agency/client", deleteBrandBody).map(function (deleteResponse) {
            return _this._mapObjectIntoArray(deleteResponse);
        });
    };
    ; // end deleteBrand
    AccountsBrandsServiceProvider.prototype.editBrand = function (editBrandBody) {
        return this
            ._http
            .post("/user/updateBrandName", editBrandBody).map(function (editResponse) {
            // return this._mapObjectIntoArray(editResponse)
            return editResponse;
        });
    };
    ; // end addBrand
    AccountsBrandsServiceProvider.prototype._mapObjectIntoArray = function (response) {
        if (response["agencyConfiguration"]["client"] && response["agencyConfiguration"]["client"].constructor !== Array) {
            var clientArray = [response["agencyConfiguration"]["client"]];
            response["agencyConfiguration"]["client"] = clientArray;
        }
        return response["agencyConfiguration"];
    };
    ; // end _mapObjectIntoArray
    AccountsBrandsServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], AccountsBrandsServiceProvider);
    return AccountsBrandsServiceProvider;
}());

; // end export AccountsBrandsProvider
;
;
;
;
//# sourceMappingURL=accounts-brands-service.js.map

/***/ }),

/***/ 142:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FcmProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_device__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_instagram__ = __webpack_require__(349);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ionic_native_file_transfer__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_file__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_native_android_permissions__ = __webpack_require__(350);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ionic_native_clipboard__ = __webpack_require__(147);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_window_service_window_service__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_auth_auth__ = __webpack_require__(80);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_publishing_service_publishing_service__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_15_rxjs_BehaviorSubject__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




//PLUGINS






//PROVIDERS





//rxjs

var FcmProvider = /** @class */ (function () {
    function FcmProvider(http, device, instagram, transfer, file, androidPermissions, windowServiceProvider, clipboard, loadingController, ionicStorage, authProvider, appSettingsProvider, userSettingsProvider, publishingProvider) {
        this.http = http;
        this.device = device;
        this.instagram = instagram;
        this.transfer = transfer;
        this.file = file;
        this.androidPermissions = androidPermissions;
        this.windowServiceProvider = windowServiceProvider;
        this.clipboard = clipboard;
        this.loadingController = loadingController;
        this.ionicStorage = ionicStorage;
        this.authProvider = authProvider;
        this.appSettingsProvider = appSettingsProvider;
        this.userSettingsProvider = userSettingsProvider;
        this.publishingProvider = publishingProvider;
        this.notificationType = 'FCM';
        this._fcmDataSource = new __WEBPACK_IMPORTED_MODULE_15_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.fcmData$ = this._fcmDataSource.asObservable();
        this.inboxDataSource = new __WEBPACK_IMPORTED_MODULE_15_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        this.inboxData$ = this.inboxDataSource.asObservable();
        this._sharedDataSource = new __WEBPACK_IMPORTED_MODULE_15_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.sharedData$ = this._sharedDataSource.asObservable();
    }
    /**
     * set FcmDataSource
     */
    FcmProvider.prototype.setFcmDataSource = function (data) {
        if (data === void 0) { data = null; }
        this._fcmDataSource.next(data);
    };
    /**
     * set setInboxDataSource
     */
    FcmProvider.prototype.setInboxDataSource = function (data) {
        if (data === void 0) { data = null; }
        this.inboxDataSource.next(data);
    };
    /**
     * set sharedDataSource
     */
    FcmProvider.prototype.setSharedDataSource = function (data) {
        if (data === void 0) { data = null; }
        this._sharedDataSource.next(data);
    };
    /**
     * updateFCMToken
     */
    FcmProvider.prototype.updateFCMToken = function (token) {
        if (!token || token === '') {
            return;
        }
        this.FCMToken = token;
        this
            .ionicStorage
            .set(this.appSettingsProvider.getFCMTokenKey(), token);
        this.updateFCMByDeviceID().then(function (status) {
            console.log('FCM token updated', token);
        });
        if (this.userSettingsProvider.userSettingsSource.value === null) {
        }
        else {
            this.updateFCMTokenForInbox().then(function (status) {
                console.log('FCM token updated', token);
            });
        }
    };
    FcmProvider.prototype.updateFCMByDeviceID = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            //prepare apiPath and httpParams
            var apiPath = "/user/updateGCMByDeviceID";
            var requestBody = {
                deviceID: _this.device.uuid,
                gcmID: _this.FCMToken,
                notificationType: _this.notificationType,
                deviceName: _this.device.model
            };
            if (!_this.FCMToken || _this.FCMToken === '') {
                resolve(false);
            }
            _this
                .http
                .post(apiPath, requestBody)
                .subscribe(function (resp) {
                resolve(true);
            }, function (error) {
                resolve(false);
            });
        });
    };
    FcmProvider.prototype.updateFCMTokenForInbox = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            //prepare apiPath and httpParams
            var apiPath = "/user/addNotification";
            if (!_this.FCMToken || _this.FCMToken === '') {
                resolve(false);
            }
            var requestBody = {
                id: _this.FCMToken,
                deviceName: _this.device.model
            };
            _this
                .http
                .post(apiPath, requestBody)
                .subscribe(function (resp) {
                resolve(true);
            }, function (error) {
                resolve(false);
            });
        });
    };
    FcmProvider.prototype.setFcmData = function (data) {
        this.fcmData = data;
    };
    FcmProvider.prototype.shareToTikTok = function (fcmData) {
        var _this = this;
        if (fcmData === void 0) { fcmData = null; }
        console.log('shareToTikTok entered::', this.fcmData, fcmData);
        return new Promise(function (resolve, reject) {
            //set data if it is passed
            if (fcmData !== null) {
                _this.setFcmData(fcmData);
            }
            //Giphy. If the attachment is from Giphy, then take its mp4 url to share
            if (typeof _this.fcmData.attachments !== 'undefined' && _this.fcmData.attachments.length == 1) {
                if (_this.isGiphyImage(_this.fcmData.attachments[0])) {
                    _this.fcmData.type = "video";
                    _this.fcmData.attachments[0] = _this.getMP4URL(_this.fcmData.attachments[0]);
                }
            }
            //set Caption
            _this.clipboard.copy(_this.getCaption());
            if (_this.device.platform.toLowerCase() == 'android') {
                // this.updatePostStatus().then(status => {
                _this.checkPermissions().then(function (hasPermission) {
                    console.log("shareToTikTok checkPerm");
                    console.log('Permission', hasPermission);
                    if (hasPermission) {
                        _this.shareTiktokVideo(_this.fcmData.attachments[0]).then(function (res) {
                            _this.updatePostStatus().then(function (status) { });
                            console.log("shareToTikTok after shareTiktokVideo");
                            resolve(true);
                            // return true;
                        }).catch(function (error) {
                            reject(error);
                        });
                    }
                    // resolve(true);
                });
                // })
            }
            //Multiple images/videos sharing
            // if ((typeof this.fcmData.attachments !== 'undefined' && this.fcmData.attachments.length > 1)
            //   || (this.fcmData.type == 'video' && this.device.platform.toLowerCase() == 'android')
            // ) {
            //   this.updatePostStatus().then(status => {
            //     this.shareMultipleImages(true).then(result => {
            //       //Todos after sharing
            //       console.log('MULTI IMAGES SHARED');
            //       resolve(true);
            //     }, error => {
            //       reject(error);
            //     });
            //   });
            // }
            // else if (this.fcmData.type == 'video') {
            //   //Video sharing
            //   this.updatePostStatus().then(status => {
            //     this.shareVideo(true).then(result => {
            //       //Todos after sharing
            //       console.log('VIDEO SHARED', result);
            //       resolve(true);
            //     }, error => {
            //       reject(error);
            //     });
            //   });
            // }
            else {
                // let loading = this.loadingController.create();
                // loading.present();
                // this.updatePostStatus().then(status => {
                _this.publishingProvider
                    .getInstagramPendingNotifications()
                    .subscribe(function (instagramPostsByDate) {
                    _this.shareMultipleImages(true).then(function (result) {
                        _this.updatePostStatus().then(function (status) { });
                        //Todos after sharing
                        console.log('MULTI IMAGES SHARED');
                        resolve(true);
                    }, function (error) {
                        reject(error);
                    });
                    resolve(true);
                });
                // });
            }
        });
    };
    FcmProvider.prototype.shareToInstagram = function (fcmData) {
        var _this = this;
        if (fcmData === void 0) { fcmData = null; }
        return new Promise(function (resolve, reject) {
            //set data if it is passed
            if (fcmData !== null) {
                _this.setFcmData(fcmData);
            }
            //Giphy. If the attachment is from Giphy, then take its mp4 url to share
            if (typeof _this.fcmData.attachments !== 'undefined' && _this.fcmData.attachments.length == 1) {
                if (_this.isGiphyImage(_this.fcmData.attachments[0])) {
                    _this.fcmData.type = "video";
                    _this.fcmData.attachments[0] = _this.getMP4URL(_this.fcmData.attachments[0]);
                }
            }
            console.log('shareToInstagram entered::', _this.fcmData);
            //set Caption
            _this.clipboard.copy(_this.getCaption());
            //Multiple images/videos sharing
            if ((typeof _this.fcmData.attachments !== 'undefined' && _this.fcmData.attachments.length > 1)
                || (_this.fcmData.type == 'video' && _this.device.platform.toLowerCase() == 'android')) {
                _this.updatePostStatus().then(function (status) {
                    _this.shareMultipleImages().then(function (result) {
                        //Todos after sharing
                        console.log('MULTI IMAGES SHARED');
                        resolve(true);
                    }, function (error) {
                        reject(error);
                    });
                });
            }
            else if (_this.fcmData.type == 'video') {
                //Video sharing
                _this.updatePostStatus().then(function (status) {
                    _this.shareVideo().then(function (result) {
                        //Todos after sharing
                        console.log('VIDEO SHARED', result);
                        resolve(true);
                    }, function (error) {
                        reject(error);
                    });
                });
            }
            else {
                //Image Sharing
                // this.updatePostStatus().then(status => {
                //   this.shareImage().then(result => {
                //     //Todos after sharing
                //     console.log('IMAGE SHARED');
                //     resolve(true);
                //   }, error => {
                //     reject(error);
                //   });
                // });
                _this.updatePostStatus().then(function (status) {
                    _this.shareMultipleImages().then(function (result) {
                        //Todos after sharing
                        console.log('MULTI IMAGES SHARED');
                        resolve(true);
                    }, function (error) {
                        reject(error);
                    });
                });
            }
        });
    };
    FcmProvider.prototype.shareMultipleImages = function (isTikTok) {
        var _this = this;
        if (isTikTok === void 0) { isTikTok = false; }
        return new Promise(function (resolve, reject) {
            if (_this.device.platform.toLowerCase() == 'ios') {
                var images = [];
                for (var i in _this.fcmData.attachments) {
                    images.push(_this.fcmData.attachments[i]);
                }
                if (isTikTok) {
                    // this.windowServiceProvider.window.Instagram.shareMultipleImagesTikTok((result) => {
                    //   resolve(true);
                    // })
                    _this.windowServiceProvider.window.Instagram.shareTiktokVideo(function (result) {
                        resolve(true);
                    }, function (e) {
                        resolve(false);
                    }, images);
                    //tiktok sharing
                }
                else {
                    _this.windowServiceProvider.window.Instagram.shareMultipleImages(function (result) {
                        resolve(true);
                    }, function (e) {
                        resolve(false);
                    }, images);
                }
            }
            else if (_this.device.platform.toLowerCase() == 'android') {
                //Check and get WRITE Permisson for External storage
                _this.checkPermissions().then(function (hasPermission) {
                    console.log('Permission', hasPermission);
                    if (hasPermission) {
                        //download all images
                        var promisedDownloadsArray = [];
                        for (var i in _this.fcmData.attachments) {
                            promisedDownloadsArray.push(_this.downloadFile(_this.fcmData.attachments[i]));
                        }
                        var loading_1 = _this.loadingController.create();
                        loading_1.present();
                        Promise.all(promisedDownloadsArray).then(function (resolvedDownloadsArray) {
                            loading_1.dismiss();
                            // let packageName: string = (isTikTok) ? "com.zhiliaoapp.musically" : "com.instagram.android";
                            var packageName = (isTikTok) ? "com.ss.android.ugc.trill" : "com.instagram.android";
                            _this.windowServiceProvider.window.startApp.set({
                                "package": packageName
                            }).start();
                            setTimeout(function () {
                                resolve(true);
                            }, 1000);
                        }, function (err) {
                            console.log('download error', err);
                            resolve(false);
                        });
                    }
                    else {
                        resolve(false);
                    }
                }, function (err) {
                    console.log('err', err);
                });
            }
        });
    };
    /**
     * Share Image (single)
     */
    FcmProvider.prototype.shareImage = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            //prepare apiPath and httpParams
            var apiPath = "/upload/getBase64ImageData";
            var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]().set("url", _this.fcmData.attachments[0]);
            _this
                .http
                .get(apiPath, { params: httpParams })
                .subscribe(function (resp) {
                var httpResponse = resp;
                _this.instagram.share(httpResponse.img_data, _this.getCaption())
                    .then(function () { resolve(true); })
                    .catch(function (error) { resolve(false); });
            }, function (error) {
                resolve(false);
            });
        });
    };
    /**
     * Video Sharing (single)
     */
    FcmProvider.prototype.shareVideo = function (isTikTok) {
        var _this = this;
        if (isTikTok === void 0) { isTikTok = false; }
        return new Promise(function (resolve, reject) {
            var url = _this.fcmData.attachments[0];
            var targetPath = _this.file.externalDataDirectory + 'ec-' + (new Date().getTime()) + '.mp4';
            console.log('url', url, 'targetPath', targetPath, _this.fcmData);
            if (_this.device.platform.toLowerCase() == 'ios') {
                if (isTikTok) {
                    //tiktok sharing
                    _this.windowServiceProvider.window.Instagram.shareVideoTikTok(function (result) {
                        console.log('Instagram.shareVideoTikTok success: ' + result);
                        resolve(true);
                    }, function (e) {
                        console.log('Instagram.shareVideoTikTok error: ' + e);
                        resolve(false);
                    }, [url]);
                }
                else {
                    _this.windowServiceProvider.window.Instagram.shareMultipleImages(function (result) {
                        console.log('Instagram.shareAsset success: ' + result);
                        resolve(true);
                    }, function (e) {
                        console.log('Instagram.shareAsset error: ' + e);
                        resolve(false);
                    }, [url]);
                }
                ;
                // this.windowServiceProvider.window.Instagram.shareAsset(function(result) {
                //     console.log('Instagram.shareAsset success: ' + result);
                //     resolve(true);
                // }, function(e) {
                //     console.log('Instagram.shareAsset error: ' + e);
                //     resolve(false);
                // }, encodeURI(url));
            }
            else {
                //Check and get WRITE Permisson for External storage
                _this.checkPermissions().then(function (hasPermission) {
                    console.log('Permission', hasPermission);
                    if (hasPermission) {
                        var loading_2 = _this.loadingController.create();
                        loading_2.present();
                        _this.downloadFile(url).then(function (fileURL) {
                            console.log('fileURL', fileURL);
                            loading_2.dismiss();
                            if (isTikTok) {
                                //tiktok sharing
                            }
                            else {
                                _this.windowServiceProvider.window.Instagram.shareAsset(function (result) {
                                    resolve(true);
                                }, function (error) {
                                    resolve(false);
                                }, fileURL);
                            }
                        }, function (error) {
                            loading_2.dismiss();
                            resolve(false);
                        });
                    }
                });
            }
        });
    };
    FcmProvider.prototype.updatePostStatus = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            //prepare apiPath and httpParams
            var apiPath = "/account/updatePost";
            /* let httpParams: HttpParams = new HttpParams()
                  .set("accountID", this.fcmData.accountId)
                  .set("profileID", this.fcmData.sampleId)
                  .set("postId", this.fcmData.postId)
                  .set("postSource", "scheduled")
                  .set("postTime", this.fcmData.postTime)
                  .set("actualPostTime", this.fcmData.actualPostTime)
                  .set("result", "SUCCESS")
                  .set("description", "SUCCESS"); */
            var requestBody = {
                accountID: _this.fcmData.accountId,
                profileID: _this.fcmData.sampleId,
                postId: _this.fcmData.postId,
                postSource: "scheduled",
                postTime: _this.fcmData.postTime,
                actualPostTime: _this.fcmData.actualPostTime,
                result: "SUCCESS",
                description: "SUCCESS"
            };
            console.log("updatePostStatus this.fcmData", _this.fcmData);
            _this
                .http
                .post(apiPath, requestBody)
                .subscribe(function (resp) {
                resolve(true);
            }, function (error) {
                resolve(false);
            });
        });
    };
    /**
     * Check and Get Write Permission for External Storage
     */
    FcmProvider.prototype.checkPermissions = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.androidPermissions.checkPermission(_this.androidPermissions.PERMISSION.WRITE_EXTERNAL_STORAGE).then(function (result) {
                console.log('Has permission?', result.hasPermission);
                if (result.hasPermission) {
                    resolve(true);
                }
                else {
                    _this.androidPermissions.requestPermission(_this.androidPermissions.PERMISSION.WRITE_EXTERNAL_STORAGE).then(function (result) {
                        resolve(result.hasPermission);
                    }, function (err) {
                        resolve(false);
                    });
                }
            }, function (err) {
                _this.androidPermissions.requestPermission(_this.androidPermissions.PERMISSION.WRITE_EXTERNAL_STORAGE).then(function (result) {
                    resolve(result.hasPermission);
                }, function (err) {
                    resolve(false);
                });
            });
        });
    };
    FcmProvider.prototype.downloadFile = function (fileName) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var fileTransfer = _this.transfer.create();
            fileName = encodeURI(fileName);
            var uuid = (new Date()).getTime();
            var targetPath = _this.file.externalRootDirectory + 'ec-' + uuid + '.' + (fileName.split('.').pop());
            fileTransfer.download(fileName, targetPath).then(function (entry) {
                _this.windowServiceProvider.window.refreshMedia.refresh(targetPath);
                resolve(entry.toURL());
            }, function (error) {
                reject(error);
            });
        });
    };
    /**
     * getPostByID
     */
    FcmProvider.prototype.getPostByID = function (id, source) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.publishingProvider.getPostByID(id, source).then(function (resp) {
                resolve(resp);
            });
        });
    };
    FcmProvider.prototype.isGiphyImage = function (url) {
        var assetName = url.split('/').pop();
        return (assetName.split('.').pop() == 'gif' && assetName.indexOf('_GID-') !== -1);
    };
    FcmProvider.prototype.getMP4URL = function (url) {
        if (this.isGiphyImage(url)) {
            var assetName = url.split('/').pop();
            assetName = assetName.replace('.gif', '');
            assetName = assetName.split('_GID-').pop();
            var segments = assetName.split('-');
            if (segments.length == 2) {
                this.fcmData.type = 'video';
                url = 'https://' + segments[1] + '.giphy.com/media/' + segments[0] + '/giphy-loop.mp4';
            }
        }
        return url;
    };
    FcmProvider.prototype.getCaption = function () {
        var caption = this.fcmData.postContent;
        //convertToHTML
        var div = document.createElement('div');
        div.innerHTML = caption;
        caption = div.textContent;
        return caption;
    };
    FcmProvider.prototype.shareTiktokVideo = function (fileName) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var fileTransfer = _this.transfer.create();
            fileName = encodeURI(fileName);
            var uuid = (new Date()).getTime();
            var targetPath = _this.file.externalRootDirectory + 'ec-' + uuid + '.' + (fileName.split('.').pop());
            var loading = _this.loadingController.create();
            loading.present();
            fileTransfer.download(fileName, targetPath).then(function (entry) {
                loading.dismiss();
                _this.windowServiceProvider.window.refreshMedia.refresh(targetPath);
                var success = function (result) {
                    alert(result);
                    resolve(true);
                };
                var failure = function (result) {
                    reject(true);
                };
                if (targetPath.indexOf('file:///') > -1) {
                    targetPath = targetPath.replace('file://', '');
                }
                if (_this.device.platform.toLowerCase() == 'ios') {
                    _this.windowServiceProvider.window.Instagram.shareTiktokVideo(function (result) {
                        resolve(true);
                    }, function (e) {
                        resolve(false);
                    }, targetPath);
                }
                else {
                    console.log("shareToTikTok inside shareTiktokVideo");
                    // cordova.plugins.TiktokShare.shareVideo(targetPath, success, failure);//sdk method
                    cordova.plugins.TiktokShare.shareVideo(targetPath, success, failure); //sdk method
                    // cordova.plugins.TiktokShare.shareSheetVideo(targetPath, success, failure);//shareSheet(intent) method
                }
                resolve(true);
            }, function (error) {
                reject(error);
            });
        });
    };
    FcmProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_device__["a" /* Device */],
            __WEBPACK_IMPORTED_MODULE_5__ionic_native_instagram__["a" /* Instagram */],
            __WEBPACK_IMPORTED_MODULE_6__ionic_native_file_transfer__["a" /* FileTransfer */],
            __WEBPACK_IMPORTED_MODULE_7__ionic_native_file__["a" /* File */],
            __WEBPACK_IMPORTED_MODULE_8__ionic_native_android_permissions__["a" /* AndroidPermissions */],
            __WEBPACK_IMPORTED_MODULE_10__providers_window_service_window_service__["a" /* WindowServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_9__ionic_native_clipboard__["a" /* Clipboard */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* LoadingController */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_11__providers_auth_auth__["a" /* AuthProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_14__providers_publishing_service_publishing_service__["a" /* PublishingProvider */]])
    ], FcmProvider);
    return FcmProvider;
}());

//# sourceMappingURL=fcm.js.map

/***/ }),

/***/ 145:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InAppProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_in_app_purchase_2__ = __webpack_require__(351);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_moment__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






var InAppProvider = /** @class */ (function () {
    function InAppProvider(http, inApp, platform, userSettingsProvider, _alertController) {
        this.http = http;
        this.inApp = inApp;
        this.platform = platform;
        this.userSettingsProvider = userSettingsProvider;
        this._alertController = _alertController;
        this.duplicateNotificationFlag = true;
        this.isExpired = false;
    }
    /**
     * prepareProducts
     */
    InAppProvider.prototype.prepareProducts = function () {
        this.androidInAppProducts = [
            { id: 'basic1', alias: 'Basic', type: this.inApp.PAID_SUBSCRIPTION, price: 49, ecName: 'Basic' },
            //{id:'basic_y', alias:'Basic Yearly', type: this.inApp.PAID_SUBSCRIPTION, price:0, ecName: 'Basic-Y'},
            { id: 'individual', alias: 'Individual', type: this.inApp.PAID_SUBSCRIPTION, price: 15, ecName: 'Individual' },
            //{id:'individual_y', alias:'Individual Yearly', type: this.inApp.PAID_SUBSCRIPTION, price:0, ecName: 'Individual-Y'},
            { id: 'premier1', alias: 'Premier', type: this.inApp.PAID_SUBSCRIPTION, price: 99, ecName: 'Premier' },
            //{id:'premier_y', alias:'Premier Yearly', type: this.inApp.PAID_SUBSCRIPTION, price:0, ecName: 'Premier-Y'},
            { id: 'agency1', alias: 'Agency', type: this.inApp.PAID_SUBSCRIPTION, price: 219, ecName: 'Agency' },
        ];
        this.iosInAppProducts = [
            { id: 'basic_monthly', alias: 'Basic', type: this.inApp.PAID_SUBSCRIPTION, price: 58.99, ecName: 'Basic' },
            // {id:'basic_m', alias:'Basic',  type: this.inApp.PAID_SUBSCRIPTION, price:48.99, ecName: 'Basic'},
            //{id:'basic_y', alias:'Basic Yearly',  type: this.inApp.PAID_SUBSCRIPTION, price:0, ecName: 'Basic-Y'},
            { id: 'individual_m', alias: 'Individual', type: this.inApp.PAID_SUBSCRIPTION, price: 14.99, ecName: 'Individual' },
            //{id:'individual_y', alias:'Individual Yearly',  type: this.inApp.PAID_SUBSCRIPTION, price:0, ecName: 'Individual-Y'},
            { id: 'premier_monthly', alias: 'Premier', type: this.inApp.PAID_SUBSCRIPTION, price: 118.99, ecName: 'Premier' },
            // {id:'premier_m', alias:'Premier',  type: this.inApp.PAID_SUBSCRIPTION, price:99.99, ecName: 'Premier'},
            //{id:'premier_y', alias:'Premier Yearly',  type: this.inApp.PAID_SUBSCRIPTION, price:0, ecName: 'Premier-Y'},
            { id: 'agency_m', alias: 'Agency', type: this.inApp.PAID_SUBSCRIPTION, price: 219.99, ecName: 'Agency' }
        ];
    };
    /**
     * registerProducts
     */
    InAppProvider.prototype.registerProducts = function () {
        var _this = this;
        if (!this.platform.is('cordova'))
            return;
        this.prepareProducts();
        // Enable maximum logging level
        this.inApp.verbosity = this.inApp.DEBUG;
        this.inApp.validator = function (product, callback) { callback(true, product.transaction); };
        var products = [];
        if (this.platform.is('cordova') && this.platform.is('ios')) {
            products = this.iosInAppProducts;
            // backward support
            // products.push({ id: 'basic_m', alias: 'Basic', type: this.inApp.PAID_SUBSCRIPTION, price: 48.99, ecName: 'BasicOld' });
            // products.push({ id: 'premier_m', alias: 'Premier', type: this.inApp.PAID_SUBSCRIPTION, price: 99.99, ecName: 'PremierOld' });
        }
        else if (this.platform.is('cordova') && this.platform.is('android')) {
            products = this.androidInAppProducts;
        }
        // Inform the store of your products
        for (var i in products) {
            var product = {
                id: products[i].id,
                alias: products[i].alias,
                type: products[i].type
            };
            this.inApp.register(product);
            // console.log('registerProducts Onregistering', JSON.stringify(product));
        }
        // this.inApp.when('product').approved(product => {
        //   // console.log('registerProducts approved',product, product.verify());
        //   product.verify();
        // });
        // this.inApp.when('product').verified(product => {
        //   // console.log('registerProducts verified',product,product.finish());
        //   product.finish();
        // });
        this.inApp.when('product').updated(function (product) {
            var userSettings = _this.userSettingsProvider.userSettingsSource.value;
            // console.log('registerProducts productBeforeCheck', JSON.stringify(product));
            if (product.owned && product.state == 'owned' && product.transaction != null) {
                _this.ownedProduct = product;
                _this.updateSubscription();
                // product.finish();
            }
        });
        this.inApp.refresh();
    };
    /**
     * getCurrentPlatformProducts
     */
    InAppProvider.prototype.getCurrentPlatformProducts = function () {
        var products = [];
        if (this.platform.is('cordova') && this.platform.is('ios')) {
            products = this.iosInAppProducts;
        }
        else if (this.platform.is('cordova') && this.platform.is('android')) {
            products = this.androidInAppProducts;
        }
        return products;
    };
    /**
     * getProductByID
      id: string
    */
    InAppProvider.prototype.getProductByID = function (id) {
        var products = this.getCurrentPlatformProducts();
        // Inform the store of your products
        var product = null;
        for (var i in products) {
            if (products[i].id == id) {
                product = products[i];
            }
        }
        return product;
    };
    InAppProvider.prototype.getProductByEcName = function (ecName) {
        var products = this.getCurrentPlatformProducts();
        console.log(products, ecName);
        // Inform the store of your products
        var product = null;
        for (var i in products) {
            if (products[i].ecName == ecName) {
                product = products[i];
            }
        }
        return product;
    };
    /**
     * purchase
     */
    InAppProvider.prototype.purchase = function (plan) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            console.log('plan', plan);
            _this.inApp.order(plan).then(function (success) {
                resolve(true);
            }, function (error) {
                resolve(false);
            });
        });
    };
    InAppProvider.prototype.updateSubscription = function () {
        var _this = this;
        var productDetails = this.getProductByID(this.ownedProduct.id);
        var userSettings = this.userSettingsProvider.userSettingsSource.value;
        // console.log('registerProducts ownedProduct', JSON.stringify(this.ownedProduct));
        // console.log('registerProducts productDetails',JSON.stringify(productDetails));
        // console.log('registerProducts userSettings', JSON.stringify(userSettings));
        // console.log('registerProducts duplicateNotify',this.duplicateNotificationFlag);
        if (!this.ownedProduct)
            return;
        if (typeof this.ownedProduct.transaction === 'undefined')
            return;
        if (userSettings == null)
            return;
        if (userSettings.paymentConfig == undefined || typeof userSettings.paymentConfig != 'object')
            return;
        var paymentDetails = {};
        if (!this.isEmptyObject(userSettings) && !this.isEmptyObject(userSettings.paymentConfig)) {
            paymentDetails = userSettings.paymentConfig.paymentId;
            var paymentMode = this.getExistingMode(paymentDetails);
            if (paymentMode === 1 && this.duplicateNotificationFlag) {
                this.duplicateNotificationFlag = false;
                setTimeout(function () {
                    _this.showDuplicateWarning();
                    console.log('registerProducts duplicateNotify afterNotify', _this.duplicateNotificationFlag);
                }, 3000);
                console.log('Duplicate TXN found.');
                return;
            }
        }
        var goFlag = false;
        //Check if details ( paymentId ) is empty array. Empty Array means customer is in trial period
        if (Array.isArray(paymentDetails) && !paymentDetails.length) {
            console.log('RRRRRRRRRR', userSettings.paymentConfig.accountCode, userSettings.email);
            if (userSettings.paymentConfig.accountCode
                && userSettings.paymentConfig.paymentLicense
                && (userSettings.email == userSettings.paymentConfig.accountCode)
                && userSettings.licenseType == userSettings.paymentConfig.paymentLicense) {
                goFlag = true;
            }
            else {
                goFlag = false;
            }
        }
        else if (typeof paymentDetails == 'string'
            && (paymentDetails.indexOf('ios-appstore') != -1
                || paymentDetails.indexOf('android-playstore') != -1)) {
            //goFlag = true;
            //if( details.type == txn.type ) 
            {
                //go_flag = false;
            }
            if (userSettings.paymentConfig.accountCode
                && userSettings.paymentConfig.paymentLicense
                && userSettings.email == userSettings.paymentConfig.accountCode) {
                goFlag = true;
            }
            else {
                goFlag = false;
            }
        }
        else {
            goFlag = false;
        }
        if (!goFlag)
            return;
        var updatedPaymentId = JSON.stringify({ type: this.ownedProduct.transaction.type, 'token': this.ownedProduct.transaction.id });
        if (userSettings && userSettings.paymentConfig && userSettings.paymentConfig.paymentId) {
            if (userSettings.paymentConfig.paymentId === updatedPaymentId) {
                console.log('update not needed', updatedPaymentId, userSettings.paymentConfig.paymentId);
                return;
            }
        }
        var apiPath = "/subscribe/create";
        var requestBody = {
            paymentProvider: JSON.stringify(this.ownedProduct),
            paymentId: updatedPaymentId,
            plan: productDetails.ecName
        };
        console.log('requestBody::subscribe/create', requestBody);
        this
            .http
            .post(apiPath, requestBody)
            .subscribe(function (resp) {
            if (resp.settings) {
                _this.userSettingsProvider.userSettingsSource.next(resp.settings);
            }
            //resolve(true);
        }, function (error) {
            //resolve(false);
        });
    };
    /**
     * updatePaymentStatus
     */
    InAppProvider.prototype.updatePaymentStatus = function (status) {
        if (status === void 0) { status = 'expired'; }
        var userSettings = this.userSettingsProvider.userSettingsSource.value;
        var apiPath = "/subscribe/upadteStatus";
        var requestBody = {
            status: status,
            plan: userSettings.licenseType
        };
        console.log('requestBody::subscribe/upadteStatus', requestBody);
        this
            .http
            .post(apiPath, requestBody)
            .subscribe(function (resp) {
            // if (resp.settings) {
            //   this.userSettingsProvider.userSettingsSource.next(resp.settings);
            // }          
            //resolve(true);
        }, function (error) {
            //resolve(false);
        });
    };
    InAppProvider.prototype.isSubscriptionExpired = function () {
        return this.isExpired;
    };
    /**
     * updateExpiredStatus
     */
    InAppProvider.prototype.updateExpiredStatus = function () {
        var userSettings = this.userSettingsProvider.userSettingsSource.value;
        if (!userSettings) {
            return this.isExpired;
        }
        var paymentDetails = null;
        if (!this.isEmptyObject(userSettings) && !this.isEmptyObject(userSettings.paymentConfig)) {
            paymentDetails = userSettings.paymentConfig.paymentId;
        }
        if (!paymentDetails) {
            return this.isExpired;
        }
        var paymentMode = this.getExistingMode(paymentDetails);
        if (paymentMode !== 2) {
            return this.isExpired;
        }
        var createdTime;
        if (userSettings.paymentConfig && userSettings.paymentConfig.createdAt) {
            createdTime = parseInt(userSettings.paymentConfig.createdAt);
        }
        if (!createdTime) {
            return this.isExpired;
        }
        var currentTime = __WEBPACK_IMPORTED_MODULE_5_moment__().valueOf();
        var maxAllowedTime = __WEBPACK_IMPORTED_MODULE_5_moment__(createdTime).add(40, 'day').valueOf();
        // let maxAllowedTime = moment(createdTime).valueOf();
        if (currentTime > maxAllowedTime) {
            this.isExpired = true;
        }
        return this.isExpired;
    };
    InAppProvider.prototype.isEmptyObject = function (obj) {
        for (var name in obj) {
            return false;
        }
        return true;
    };
    /*
    * 0 => No payment (trial) 1 => Destop 2 => Mobile
    */
    InAppProvider.prototype.getExistingMode = function (paymentDetails) {
        var status = 0;
        if (Array.isArray(paymentDetails) && !paymentDetails.length) {
            status = 0;
        }
        if (typeof paymentDetails == 'string') {
            if (paymentDetails.indexOf('ios-appstore') !== -1 || paymentDetails.indexOf('android-playstore') !== -1) {
                status = 2;
            }
            else {
                status = 1;
            }
        }
        return status;
    };
    InAppProvider.prototype.showDuplicateWarning = function () {
        var message = 'You already have a subscription, please cancel your mobile subscription in Settings - App Store or Play Store';
        var alertConfirm = this._alertController.create({ message: message });
        alertConfirm.addButton({
            text: 'Ok',
            handler: function (data) {
            }
        });
        alertConfirm.present();
    };
    InAppProvider.prototype.getSubscribedIosProduct = function (ecName) {
        var products = [
            { id: 'basic_monthly', alias: 'Basic', type: this.inApp.PAID_SUBSCRIPTION, price: 58.99, ecName: 'Basic' },
            { id: 'individual_m', alias: 'Individual', type: this.inApp.PAID_SUBSCRIPTION, price: 14.99, ecName: 'Individual' },
            { id: 'premier_monthly', alias: 'Premier', type: this.inApp.PAID_SUBSCRIPTION, price: 118.99, ecName: 'Premier' },
            { id: 'agency_m', alias: 'Agency', type: this.inApp.PAID_SUBSCRIPTION, price: 219.99, ecName: 'Agency' }
        ];
        var product = null;
        for (var i in products) {
            if (products[i].ecName == ecName) {
                product = products[i];
            }
        }
        return product;
    };
    InAppProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_in_app_purchase_2__["a" /* InAppPurchase2 */],
            __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["r" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_4__providers_user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["b" /* AlertController */]])
    ], InAppProvider);
    return InAppProvider;
}());

;
//# sourceMappingURL=in-app.js.map

/***/ }),

/***/ 146:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PublishingValidatorProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__publishing_service_publishing_helper__ = __webpack_require__(64);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

//PROVIDERS


var PublishingValidatorProvider = /** @class */ (function () {
    function PublishingValidatorProvider(_appSettingsProvider) {
        this._appSettingsProvider = _appSettingsProvider;
    }
    PublishingValidatorProvider.prototype.validateTextLimit = function (postData) {
        var validationResult = {
            status: false,
            text: ''
        };
        var limit = postData.limitCharacters(postData.content);
        console.log('validateTextLimit limit', limit);
        if (limit.remaining >= 0) {
            validationResult.status = true;
            return validationResult;
        }
        if (postData.has_fb_profile) {
            validationResult.text = 'Facebook limits your post to 5000 characters. Please edit your post.';
        }
        else if (postData.has_twitter_profile) {
            validationResult.text = 'Twitter limits your post to 280 characters. Please edit your post.';
        }
        else if (postData.has_linkedin_profile) {
            validationResult.text = 'Linkedin limits your post to 600 characters. Please edit your post.';
        }
        else if (postData.has_pinterest_profile) {
            validationResult.text = 'Pinterest limits your post to 500 characters. Please edit your post.';
        }
        else if (postData.has_instagram_profile) {
            if (postData.has_instagram_business_profile) {
                validationResult.text = 'Instagram limits your post to 2200 characters. Please edit your post.';
            }
            else {
                validationResult.text = 'Instagram limits your post to 1400 characters. Please edit your post.';
            }
        }
        else if (postData.has_googlemybusiness_profile) {
            validationResult.text = 'Google My Business limits your post to 1500 characters. Please edit your post.';
        }
        else if (postData.has_googleplus_profile) {
            validationResult.text = 'Google+ limits your post to 5000 characters. Please edit your post.';
        }
        else if (postData.has_youtube_profile) {
            validationResult.text = 'YouTube limits your post to 5000 characters. Please edit your post.';
        }
        else if (postData.has_tiktok_profile) {
            validationResult.text = 'TikTok limits your post to 1400 characters.';
        }
        return validationResult;
    };
    ;
    PublishingValidatorProvider.prototype.validateAttachments = function (postData, deepCheck) {
        if (deepCheck === void 0) { deepCheck = true; }
        var validationResult = {
            status: false,
            text: ''
        };
        //Validate Attachments
        var mediaTypes = ['twitter', 'instagram', 'linkedin', 'googleplus', 'googlemybusiness', 'pinterest', 'youtube'];
        for (var _i = 0, mediaTypes_1 = mediaTypes; _i < mediaTypes_1.length; _i++) {
            var mediaType = mediaTypes_1[_i];
            switch (mediaType) {
                case 'twitter':
                    validationResult = this.validateTwitterAttachments(postData);
                    break;
                case 'instagram':
                    validationResult = this.validateInstagramAttachments(postData, deepCheck);
                    break;
                case 'linkedin':
                    validationResult = this.validateLinkedinAttachments(postData);
                    break;
                case 'googleplus':
                    validationResult = this.validateGoogleplusAttachments(postData);
                    break;
                case 'googlemybusiness':
                    validationResult = this.validateGoogleMyBusinessAttachments(postData);
                    break;
                case 'pinterest':
                    validationResult = this.validatePinterestAttachments(postData, deepCheck);
                    break;
                case 'youtube':
                    validationResult = this.validateYoutubeAttachments(postData, deepCheck);
                case 'tiktok':
                    validationResult = this.validateTikTokAttahments(postData, deepCheck);
                    break;
            }
            if (validationResult && !validationResult.status) {
                return validationResult;
            }
        }
        if (postData.attachments.length) {
            var att = postData.attachments[postData.attachments.length - 1];
            if (att.originalData && att.originalData.type && (att.originalData.type == 'video' || att.originalData.type.match(/video.*/))) {
                validationResult = this.validateVideoSize(postData, att);
            }
            else {
                console.log('image validation');
                validationResult = this.validateImageize(postData, att, {}, deepCheck);
            }
            if (validationResult && !validationResult.status) {
                return validationResult;
            }
        }
        validationResult = {
            status: true,
            text: ''
        };
        //   validationResult.status = true;
        //   validationResult.text = '';
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateYoutubeAttachments = function (postData, deepCheck) {
        if (deepCheck === void 0) { deepCheck = true; }
        console.log('validateYoutubeAttachments deepCheck', deepCheck);
        var validationResult = {
            status: true,
            text: ''
        };
        console.log('validateYoutubeAttachments postData', postData);
        if (!postData.has_youtube_profile) {
            return validationResult;
        }
        if (postData.attachments.length > 1) {
            validationResult.status = false;
            validationResult.text = 'YouTube allows only one video attachment.';
        }
        if (deepCheck) {
            if (!postData.has_video) {
                validationResult.status = false;
                validationResult.text = 'YouTube requires a video for posting. Please edit your post.';
                return validationResult;
            }
            if (postData.callsToAction && postData.callsToAction.yt && typeof postData.callsToAction.yt.title === 'string' && postData.callsToAction.yt.title.length) { }
            else {
                validationResult.status = false;
                validationResult.text = 'YouTube publishing requires video title.';
                return validationResult;
            }
            ;
        }
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateTwitterAttachments = function (postData) {
        var validationResult = {
            status: true,
            text: ''
        };
        console.log('postData validateTwitterAttachments', postData);
        if (!postData.has_twitter_profile) {
            return validationResult;
        }
        if (postData.attachments.length > 4) {
            validationResult.status = false;
            validationResult.text = 'Twitter limits your post to 4 attachments. Please edit your post.';
        }
        if (postData.has_10mb_image) {
            validationResult.status = false;
            validationResult.text = 'The maximum image size for Twitter is 10MB. Please edit your post.';
        }
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateGoogleMyBusinessAttachments = function (postData) {
        var validationResult = {
            status: true,
            text: ''
        };
        if (!postData.has_googlemybusiness_profile) {
            return validationResult;
        }
        if (postData.attachments.length > 1) {
            validationResult.status = false;
            validationResult.text = 'Google My Business limits your post to one attachment. Please edit your post.';
        }
        if (postData.attachments.length == 1) {
            var s3Url = postData.attachments[0].url.full;
            if (typeof s3Url === 'string' && (s3Url.indexOf('.jpg') !== -1 || s3Url.indexOf('.jpeg') !== -1 || s3Url.indexOf('.png') !== -1)) { }
            else {
                validationResult.status = false;
                validationResult.text = 'Google My Business supports only PNG, JPEG and JPG file format. Please edit your post.';
            }
        }
        if (postData.callsToAction && postData.callsToAction.gmbMediaPost) {
            var urls = __WEBPACK_IMPORTED_MODULE_2__publishing_service_publishing_helper__["c" /* extractUrls */](postData.content);
            var url = (urls.length) ? urls[0].url : '';
            if (url) { // || postData.link ?
                validationResult.status = false;
                validationResult.text = 'Google My Business Photo post should not include a URL. Please edit your post.';
            }
            if (postData.getAttachmentCount(true) === 0) {
                validationResult.status = false;
                validationResult.text = 'GMB Photo Post requires an image for posting.';
            }
        }
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateInstagramAttachments = function (postData, deepCheck) {
        if (deepCheck === void 0) { deepCheck = true; }
        var validationResult = {
            status: true,
            text: ''
        };
        if (!postData.has_instagram_profile) {
            return validationResult;
        }
        if (postData.attachments.length > 10) {
            validationResult.status = false;
            validationResult.text = 'Instagram limits your post to 10 attachments. Please edit your post.';
        }
        if (postData.hashTagsCount > 30) {
            validationResult.status = false;
            validationResult.text = 'You reached Instagram limit of 30 hashtags. Please edit your post.';
        }
        if (postData.attachments.length == 0 && deepCheck) {
            validationResult.status = false;
            validationResult.text = 'Instagram requires an image/video for posting. Please edit your post.';
        }
        //instagram device map validation
        if (postData.has_instagram_profile && postData.scheduledTimes.length) {
            for (var _i = 0, _a = postData.accounts; _i < _a.length; _i++) {
                var account = _a[_i];
                var network = account.profile.display.network.backend_network_name.toLowerCase();
                if (network == 'instabusiness') {
                    var gcmMapped = account.profile.settings.isDeviceMapped;
                    var scrappedImages = (postData.scrappedAttachments) ? postData.scrappedAttachments : {};
                    if (Object.keys(scrappedImages).length <= 0 && postData.attachments.length) {
                        scrappedImages = postData.attachments[0];
                    }
                    if (!gcmMapped && (postData.getAttachmentCount(true) > 1
                        || (postData.getAttachmentCount(true) === 1
                            && (scrappedImages.s3_url && /.gif/i.test(scrappedImages.s3_url)
                                || scrappedImages.location && /.gif/i.test(scrappedImages.location)
                                || scrappedImages.image && /.gif/i.test(scrappedImages.image))))) {
                        validationResult.status = false;
                        validationResult.text = 'Please connect your mobile device - Posting carousel/GIF will generate push notification and requires connected device. You may publish one image/video to Instagram business without connected device.';
                    }
                }
            }
        }
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateLinkedinAttachments = function (postData) {
        var validationResult = {
            status: true,
            text: ''
        };
        if (!postData.has_linkedin_profile) {
            return validationResult;
        }
        if (postData.attachments.length > 1) {
            validationResult.status = false;
            validationResult.text = 'Linkedin limits your post to one attachment. Please edit your post.';
        }
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateGoogleplusAttachments = function (postData) {
        var validationResult = {
            status: true,
            text: ''
        };
        if (!postData.has_googleplus_profile) {
            return validationResult;
        }
        if (postData.attachments.length > 1) {
            validationResult.status = false;
            validationResult.text = 'Google+ limits your post to one attachment. Please edit your post.';
        }
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validatePinterestAttachments = function (postData, deepCheck) {
        if (deepCheck === void 0) { deepCheck = true; }
        var validationResult = {
            status: true,
            text: ''
        };
        if (!postData.has_pinterest_profile) {
            return validationResult;
        }
        if (postData.attachments.length > 1) {
            validationResult.status = false;
            validationResult.text = 'Pinterest limits your post to one attachment. Please edit your post.';
        }
        else if (postData.attachments.length == 0 && deepCheck) {
            validationResult.status = false;
            validationResult.text = 'Pinterest requires an image for posting. Please edit your post.';
        }
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateTikTokAttahments = function (postData, deepCheck) {
        if (deepCheck === void 0) { deepCheck = true; }
        console;
        var validationResult = {
            status: true,
            text: ''
        };
        if (!postData.has_tiktok_profile) {
            return validationResult;
        }
        //
        if (postData.attachments.length == 0) {
            validationResult.status = false;
            validationResult.text = 'Tiktok requires a video for posting. Please edit your post.';
        }
        if (postData.attachments.length > 1) {
            validationResult.status = false;
            validationResult.text = 'Tiktok allows only one video attachment.';
        }
        if (deepCheck) {
            if (!postData.has_video || postData.attachments.length == 0) {
                validationResult.status = false;
                validationResult.text = 'Tiktok requires a video for posting. Please edit your post.';
                return validationResult;
            }
        }
        //
    };
    PublishingValidatorProvider.prototype.validateImageize = function (postData, attachment, options, deepCheck) {
        if (options === void 0) { options = {}; }
        if (deepCheck === void 0) { deepCheck = true; }
        var validationResult = {
            status: true,
            text: ''
        };
        var has_fb_profile = (typeof options.has_fb_profile == 'boolean') ? options.has_fb_profile : postData.has_fb_profile;
        var has_twitter_profile = (typeof options.has_twitter_profile == 'boolean') ? options.has_twitter_profile : postData.has_twitter_profile;
        var has_linkedin_profile = (typeof options.has_linkedin_profile == 'boolean') ? options.has_linkedin_profile : postData.has_linkedin_profile;
        var has_pinterest_profile = (typeof options.has_pinterest_profile == 'boolean') ? options.has_pinterest_profile : postData.has_pinterest_profile;
        var has_googleplus_profile = (typeof options.has_googleplus_profile == 'boolean') ? options.has_googleplus_profile : postData.has_googleplus_profile;
        var has_instagram_profile = (typeof options.has_instagram_profile == 'boolean') ? options.has_instagram_profile : postData.has_instagram_profile;
        var has_instagram_business_profile = (typeof options.has_instagram_business_profile == 'boolean') ? options.has_instagram_business_profile : postData.has_instagram_business_profile;
        var has_googlemybusiness_profile = (typeof options.has_googlemybusiness_profile == 'boolean') ? options.has_googlemybusiness_profile : postData.has_googlemybusiness_profile;
        var has_tiktok_profile = (typeof options.has_tiktok_profile == 'boolean') ? options.has_tiktok_profile : postData.has_tiktok_profile;
        var dimension = attachment.originalData.dimension;
        if (typeof dimension == 'undefined' || typeof dimension.size == 'undefined' || typeof dimension.width == 'undefined' || typeof dimension.height == 'undefined')
            return validationResult;
        if (has_twitter_profile && dimension.size / 1000 > 10000) { //10mb
            validationResult.text = "Twitter image attachment file size should be less than 10MB.";
        }
        else if (has_twitter_profile && postData.has_gif && dimension.size / 1000 > 5000) { //5mb
            validationResult.text = "Twitter Gif attachment file size should be less than 5MB.";
        }
        else if (has_linkedin_profile && dimension.size / 1000 > 10000) { //10mb
            validationResult.text = "Linkedin image attachment file size should be less than 10MB.";
        }
        else if (has_googleplus_profile && dimension.size / 1000 > 10000) { //10mb
            validationResult.text = "Google+ image attachment file size should be less than 10MB.";
        }
        else if (has_pinterest_profile && dimension.size / 1000 > 10000) { //10mb
            validationResult.text = "Pinterest image attachment file size should be less than 10MB.";
        }
        else if (has_instagram_profile && dimension.size / 1000 > 8000) { //10mb
            validationResult.text = "Instagram image attachment file size should be less than 8MB.";
        }
        else if (has_tiktok_profile && dimension.size / 1024 > 0.5) // 8mb
         {
            validationResult.text = 'TikTok image attachment file size should be less than 8MB.';
        }
        else if (has_fb_profile && dimension.size / 1000 > 10000) { //10mb
            validationResult.text = "Facebook image attachment file size should be less than 10MB.";
        }
        else if (has_pinterest_profile && dimension.width && dimension.height && (dimension.width < 80 || dimension.height < 80)) {
            validationResult.text = "Image is too small. Pinterest requires image attachment larger than 80 pixels by 80 pixels.";
        }
        else if (dimension.width && dimension.height && (dimension.width < 17 || dimension.height < 17)) {
            validationResult.text = "Image is too small. image attachment should be larger than 17 pixels by 17 pixels.";
        }
        else if (dimension.width && dimension.height && (dimension.width / dimension.height >= 1 && (dimension.width > 8192 || dimension.height > 8192))) {
            validationResult.text = "Image is too large. image attachment should be less than 8192 pixels by 8192 pixels.";
        }
        else if (dimension.width && dimension.height && (dimension.width / dimension.height < 1 && (dimension.width > 4910 || dimension.height > 6590))) {
            validationResult.text = "Image is too large. Portrait image attachment should be less than 4910 pixels by 6590 pixels.";
        }
        else if (has_googlemybusiness_profile && dimension.width && dimension.height && (dimension.width < 480 || dimension.height < 270)) {
            validationResult.text = 'Google My Business image attachment should be at a minimum resolution of 480 pixels wide by 270 pixels tall';
        }
        else if (has_googlemybusiness_profile && dimension.width && dimension.height && (dimension.width > 2120 || dimension.height > 1192)) {
            validationResult.text = 'Google My Business image attachment should be at a maximum resolution of 2120 pixels wide by 1192 pixels tall';
        }
        else if (has_instagram_profile && dimension.width && dimension.height && (dimension.width < 150 || dimension.height < 150)) {
            validationResult.text = "Image is too small. Instagram requires image attachment larger than 150 pixels by 150 pixels.";
        }
        // else if( has_instagram_profile && dimension.width && dimension.height && (dimension.width > 3840 || dimension.height > 2160) ) {
        //   validationResult.text = "Image is too large. Instagram requires image attachment should be less than 3840 pixels by 2160 pixels.";
        // }
        // else if( has_instagram_profile && dimension.width && dimension.height && ( dimension.width/dimension.height < 0.8 || dimension.width/dimension.height > 1.91 ) ) {
        //   validationResult.text = "Instagram photos aspect ratio must be between 4:5 to 1.91:1";
        // }
        else if (deepCheck && has_instagram_business_profile && postData.attachments.length === 1 && postData.has_image && dimension.width && dimension.height && (dimension.width / dimension.height < 0.8 || dimension.width / dimension.height > 1.91)) {
            if (!postData.isIGStory)
                validationResult.text = "Instagram photos aspect ratio must be between 4:5 to 1.91:1";
        }
        else if (postData.attachments.length > 12 && has_tiktok_profile) {
            validationResult.text = 'TikTok limits your post to 12 images.';
        }
        if (validationResult.text.length)
            validationResult.status = false;
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateVideoSize = function (postData, attachment) {
        var validationResult = {
            status: true,
            text: ''
        };
        if (attachment.originalData && attachment.originalData.videoData != undefined && attachment.originalData.videoData.videoMetaData != undefined) {
            var videoInfo = attachment.originalData.videoData.videoMetaData;
            var width = Number(videoInfo.width), height = Number(videoInfo.height), fps = void 0;
            if (videoInfo.r_frame_rate) {
                var ch = Number(videoInfo.r_frame_rate.split('/')[0]);
                var zn = Number(videoInfo.r_frame_rate.split('/')[1]);
                if (!isNaN(ch) && !isNaN(zn) && zn !== 0)
                    fps = ch / zn;
            }
            var videoFormat = attachment.originalData.s3_url.substr(attachment.originalData.s3_url.lastIndexOf('.') + 1);
            if (videoFormat.indexOf('?') !== -1) {
                var temp = videoFormat.split('?');
                videoFormat = temp[0];
            }
            if (videoInfo.video_format != undefined) {
                videoFormat = videoInfo.video_format.toLowerCase();
            }
            videoFormat = videoFormat.toLowerCase();
            console.log('videoFormat', videoFormat, attachment);
            if (postData.has_twitter_profile && videoFormat == 'avi') {
                validationResult.text = 'Twitter Support only mov/mp4 file.';
            }
            else if (postData.has_instagram_profile && ['mp4', 'mov'].indexOf(videoFormat) === -1) {
                validationResult.text = 'Instagram Support only mov/mp4 file.';
            }
            else if (postData.has_instagram_profile && ['mp4', 'mov', 'avi'].indexOf(videoFormat) === -1) {
                validationResult.text = 'YouTube Support only avi/mov/mp4 file.';
            }
            else if (postData.has_instagram_profile && videoFormat === 'mov' && videoInfo.size > 100000 * 1000) {
                validationResult.text = 'Instagram "MOV" video format size is limited to 100MB.';
            }
            else if (postData.has_tiktok_profile) {
                if (['mp4', 'mov'].indexOf(videoFormat) === -1) {
                    validationResult.text = "TikTok supports only MOV and MP4 file format.";
                }
                else if (videoInfo.size / 1024 > (1024 * 50)) { //72MB
                    validationResult.text = "TikTok video file size should be less than 50MB.";
                }
                var durationLimits = { lower: 1, upper: 15 };
                if (videoInfo.jobData && videoInfo.jobData.input && videoInfo.jobData.input.DetectedProperties
                    && videoInfo.jobData.input.DetectedProperties.DurationMillis) {
                    videoInfo = videoInfo.jobData.input.DetectedProperties.DurationMillis;
                    durationLimits = { lower: 1000, upper: 15000 };
                }
                // if (!isNaN(width) && !isNaN(height) && (width / height < 1 || width / height > 16 / 9)) {
                //   validationResult.text = 'TikTok video aspect ratio must be 9:16 or 1:1';
                // } else 
                if (videoInfo.duration && (Number(videoInfo.duration) < durationLimits.lower || Number(videoInfo.duration) > durationLimits.upper)) {
                    validationResult.text = 'TikTok video duration should be between 1 second and 15 seconds.';
                }
            }
            else if (postData.has_twitter_profile && videoInfo.size > 15000 * 1000) {
                validationResult.text = 'Twitter is limiting video size to 15MB.';
            }
            else if (postData.has_twitter_profile && postData.attachments.length > 1) {
                validationResult.text = 'Twitter allows only one video attachment.';
            }
            else if (postData.has_twitter_profile
                && videoInfo.duration
                && (Number(videoInfo.duration) < 0.5 || Number(videoInfo.duration) > 140)) {
                validationResult.text = 'Twitter video duration should be between 0.5 seconds and 140 seconds.';
            }
            else if (postData.has_twitter_profile && !isNaN(width) && (width < 32 || width > 1280)) {
                validationResult.text = 'Twitter video dimensions should be between 32x32 and 1280x1024. Reduce width dimension.';
            }
            else if (postData.has_twitter_profile && !isNaN(height) && (height < 32 || height > 1024)) {
                validationResult.text = 'Twitter video dimensions should be between 32x32 and 1280x1024. Reduce height dimension.';
            }
            else if (postData.has_twitter_profile && !isNaN(width) && !isNaN(height) && height !== 0 && (width / height < 1 / 3 || width / height > 3)) {
                validationResult.text = 'Twitter video aspect ratio should be between 1:3 and 3:1.';
            }
            else if (postData.has_twitter_profile && fps && (Number(fps) > 40)) {
                validationResult.text = 'Twitter video frame per second should be 40fps or less.';
            }
            else if (postData.has_twitter_profile && videoInfo.channel_layout && ['mono', 'stereo'].indexOf(videoInfo.channel_layout) === -1) {
                validationResult.text = 'Twitter video audio should be mono or stereo.';
            }
            else if (postData.has_fb_profile && postData.attachments.length > 1) {
                validationResult.text = 'Facebook allows only one video attachment.';
            }
            else if (postData.has_fb_profile && postData.has_fb_profile && videoInfo.duration && (Number(videoInfo.duration) > 1200)) {
                validationResult.text = 'Facebook maximum video duration should be less than 20 minutes.';
            }
            else if (postData.has_instagram_profile && videoInfo.duration && (Number(videoInfo.duration) < 3 || Number(videoInfo.duration) > 60)) {
                validationResult.text = 'Instagram video duration should be between 3 seconds and 60 seconds.';
            }
            else if (postData.has_instagram_business_profile) {
                if (!isNaN(width) && !isNaN(height) && (width / height < 0.8 || width / height > 16 / 9)) {
                    if (!postData.isIGStory)
                        validationResult.text = 'Instagram Business video aspect ratio must be between 4:5 to 16:5';
                }
                else if (fps && (Number(fps) < 23 || Number(fps) > 40)) {
                    validationResult.text = 'Instagram Business video frame per second should be 23 to 60fps';
                }
            }
            else if (postData.has_youtube_profile && videoInfo.size > 1048576 * 1024)
                validationResult.text = 'YouTube video size should be less than 1GB.';
            else if (postData.has_linkedin_profile && videoInfo.duration && (Number(videoInfo.duration) < 3 || Number(videoInfo.duration) > 600)) {
                validationResult.text = 'LinkedIn video duration should be between 3 seconds and 10 minutes.';
            }
            else if (postData.has_linkedin_profile && !isNaN(width) && !isNaN(height) && (width / height < 0.41 || width / height > 2.4)) {
                validationResult.text = 'LinkedIn video dimensions should be between 1:2.4 to 2.4:1.';
            }
            else if (postData.has_linkedin_profile && videoInfo.size > 204800 * 1024) {
                validationResult.text = 'LinkedIn video size should be less than 200MB.';
            }
            else if (postData.has_linkedin_profile && postData.attachments.length > 1) {
                validationResult.text = 'LinkedIn allows only one video attachment.';
            }
        }
        if (validationResult.text.length)
            validationResult.status = false;
        return validationResult;
    };
    PublishingValidatorProvider.prototype.validateBeforeUpload = function (postData, attachment) {
        var validationResult = {
            status: true,
            text: ''
        };
        var 
        // add = true,
        //   is_video = false,
        //   is_gif = false,
        //   has_video = false,
        //   has_gif = false,
        //   video_count = 0,
        // attCount = postData.getAttachmentCount(true),
        uploadedAttCount = postData.getAttachmentCount(), msg = "";
        // filename = attachment.name;
        var attachmentSize = 0;
        if (attachment && attachment.size) {
            attachmentSize = attachment.size;
        }
        console.log("isValid", attachment, postData);
        // if (attachment.isVideo || (attachment.type && attachment.type == 'video')) {
        //   is_video = true;
        // }
        // if ((attachment.ext && attachment.ext == 'gif') ||
        //   (attachment.imageUrlSource != undefined && attachment.imageUrlSource != ""
        //     && attachment.imageUrlSource.substr(attachment.imageUrlSource.lastIndexOf("/") + 1).indexOf('.gif') != -1)) {
        //   is_gif = true;
        // }
        if (uploadedAttCount)
            uploadedAttCount = uploadedAttCount - 1;
        //   if (attCount > 0) {
        //     for (let i = 0; i < attCount; i++) {
        //         if (this.attachments[i].name == filename) add = false;
        //         if (this.attachments[i].name.indexOf('_ecsize_') !== -1) {
        //             if (this.attachments[i].name.substr(0, this.attachments[i].name.indexOf('_ecsize_')) == filename) add = false;
        //         }
        //         if (this.attachments[i].type == 'video') {
        //             has_video = true;
        //             video_count++;
        //         }
        //         if (this.attachments[i].imageUrlSource != undefined && this.attachments[i].imageUrlSource != "" && this.attachments[i].imageUrlSource.substr(this.attachments[i].imageUrlSource.lastIndexOf("/") + 1).indexOf('.gif') != -1) has_gif = true;
        //     }
        // }
        // if (custom['uploadedAttCount']) uploadedAttCount = custom['uploadedAttCount'];
        // if (isBeforeUpload && has_video && is_video && (!this.hasInstagramProfilesOnly() || this.hasIgbBoost(this))) {
        //     msg = 'Video attachment is limited to 1 video.';
        // }
        // else if (isBeforeUpload && has_gif && is_gif && (!this.hasInstagramProfilesOnly() || this.hasIgbBoost(this))) {
        //     msg = 'Gif attachment is limited to 1 image.'
        // }
        // else if (this.hasIgbBoost(this) && uploadedAttCount >= 1) {
        //     msg = 'Instagram ads support only a single image or video';
        // }
        //   else if (this.hasInstagramProfilesOnly() && uploadedAttCount >= 10) {
        //     msg = 'Instagram limits your ' + msgType + ' to 10 images.';
        // }
        // else if (uploadedAttCount >= 1 && this.editorFor.toLowerCase() == "comment" && this.has_fb_profile) {
        //     msg = 'Image attachment is limited to 1 image.';
        // }
        // if (uploadedAttCount >= 1 && postData.has_pinterest_profile) {
        //   msg = 'Pinterest limits your  post to one attachment.';
        // } else if (uploadedAttCount >= 1 && postData.has_googleplus_profile) {
        //   msg = 'Google+ limits your post to one attachment.';
        // }
        // else if (uploadedAttCount >= 10 && postData.has_linkedin_profile) {
        //   msg = 'Linkedin limits your post to 10 images.';
        // }
        // else if ((!this.hasInstagramProfilesOnly() || this.hasIgbBoost(this)) && uploadedAttCount >= 4) {
        //   if (this.hasFacebookProfilesOnly() || this.hasFacebookInstagramProfilesOnly()) {
        //     if (uploadedAttCount >= 10) msg = 'Image attachment is limited to 10 images.'
        //   }
        //   else {
        //     msg = 'Image attachment is liddmited to 4 images.';
        //   }
        // }
        // else 
        if (uploadedAttCount > 12 && postData.has_tiktok_profile) {
            msg = 'TikTok limits your post to 12 images.';
        }
        else if (attachment.isVideo || (attachment.mimeType && attachment.mimeType.indexOf('video') > -1)) {
            // let hasLinkedInUserVideo: boolean = false;
            // if (postData.has_linkedin_user) {
            //   hasLinkedInUserVideo = true;
            // }
            // if (postData.has_blogger_profile || postData.has_googleplus_profile
            //   || postData.has_pinterest_profile || postData.has_googlemybusiness_profile || hasLinkedInUserVideo) {
            //   msg = 'Video attachment is only supported by Facebook, Twitter, YouTube, Instagram, TikTok and LinkedIn Company.';
            // }
            // if (postData.has_twitter_profile) {
            //   if (attachmentSize / 1024 > 524288) { //512mb
            //     msg = "Twitter video file size should be less than 512MB.";
            //   }
            // }
            // if (postData.has_googlemybusiness_profile) {
            //   if (attachmentSize / 1024 > 102400) { //100mb
            //     msg = "Google My Business video file size should be less than 100MB.";
            //   }
            // }
            if (postData.has_tiktok_profile) {
                if (attachmentSize / 1024 > (1024 * 50)) { //50MB (was 72MB)
                    msg = "TikTok video file size should be less than 50MB.";
                }
            }
            //   if (postData.has_twitter_profile &&
            //     ((attachment.location && attachment.location.toLowerCase().indexOf(".avi") != -1)
            //       || (attachment.ext && typeof attachment.ext == "string" && attachment.ext.toLowerCase() == 'avi'))) {
            //     msg = "Twitter support only mov/mp4 file.";
            //   }
            // }
            // else if (postData.has_youtube_profile) {
            //   if (attachment.type != 'video' && !attachment.type.match(/video.*/)) {
            //     msg = 'YouTube requires a video for posting';
            //   }
            // }
        }
        validationResult.text = msg;
        validationResult.status = (msg && msg != '') ? false : true;
        return validationResult;
    };
    PublishingValidatorProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__app_settings_app_settings__["a" /* AppSettingsProvider */]])
    ], PublishingValidatorProvider);
    return PublishingValidatorProvider;
}());

//# sourceMappingURL=publishing-validator.js.map

/***/ }),

/***/ 149:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FeedNotesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__feed_helper__ = __webpack_require__(30);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_moment__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



//HELPERS


var FeedNotesProvider = /** @class */ (function () {
    function FeedNotesProvider(http, userSettingsProvider) {
        var _this = this;
        this.http = http;
        this.userSettingsProvider = userSettingsProvider;
        this
            .userSettingsProvider
            .userSettings$
            .subscribe(function (userSettings) {
            _this.userSettings = userSettings;
        });
    }
    FeedNotesProvider.prototype.formatNotes = function (rawNotes) {
        var notes = {};
        var eventNotes = [];
        if (rawNotes && rawNotes.length > 0) {
            for (var n = 0; n < rawNotes.length; n++) {
                console.log('rawNotes[n]', rawNotes[n]);
                var temp = {};
                temp.note_by = rawNotes[n].slice(15, rawNotes[n].indexOf(':')).trim();
                temp.note_time = this.formatDateInUserHour(new Date(parseInt(rawNotes[n].slice(0, 13))));
                temp.note_content = __WEBPACK_IMPORTED_MODULE_3__feed_helper__["r" /* new_url_to_link */](rawNotes[n].slice(rawNotes[n].indexOf(':') + 1).trim());
                eventNotes.push(temp);
            }
        }
        notes.eventNotes = eventNotes;
        notes.lastNote = this.getLastNote(eventNotes);
        return notes;
    };
    FeedNotesProvider.prototype.formatDateInUserHour = function (date) {
        if (date != null && typeof date === 'object' && ['Date', 'Moment'].indexOf(date.constructor.name) !== -1) {
            if (date.constructor.name === 'Date')
                date = __WEBPACK_IMPORTED_MODULE_4_moment__(date);
            if (this.userSettings.postHourFormat === '12h')
                date = date.format('MMM DD, YYYY, h:mma');
            else
                date = date.format('MMM DD, YYYY, H:mm');
        }
        return date;
    };
    FeedNotesProvider.prototype.getLastNote = function (notes) {
        if (notes === void 0) { notes = []; }
        notes = notes;
        var lastNote = '';
        if (notes.length) {
            var last_note = notes[notes.length - 1];
            lastNote = 'Note: ' + last_note.note_time + ' - ' + last_note.note_content;
        }
        return lastNote;
    };
    FeedNotesProvider.prototype.setUserEvents = function (params) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        requestBody = requestBody.append('events[0][date]', params.date);
        if (params.eventUserName) {
            requestBody = requestBody.append('events[0][eventUserName]', params.eventUserName);
        }
        if (typeof params.comments != 'string') {
            for (var i in params.comments) {
                requestBody = requestBody.append("events[0][comments][]", params.comments[i]);
            }
        }
        else {
            requestBody = requestBody.append('events[0][comments]', params.comments);
        }
        return this
            .http
            .post("/user/events", requestBody); //user/events
    };
    FeedNotesProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_2__user_settings_user_settings__["a" /* UserSettingsProvider */]])
    ], FeedNotesProvider);
    return FeedNotesProvider;
}());

//# sourceMappingURL=feed-notes-service.js.map

/***/ }),

/***/ 161:
/***/ (function(module, exports) {

function webpackEmptyAsyncContext(req) {
	// Here Promise.resolve().then() is used instead of new Promise() to prevent
	// uncatched exception popping up in devtools
	return Promise.resolve().then(function() {
		throw new Error("Cannot find module '" + req + "'.");
	});
}
webpackEmptyAsyncContext.keys = function() { return []; };
webpackEmptyAsyncContext.resolve = webpackEmptyAsyncContext;
module.exports = webpackEmptyAsyncContext;
webpackEmptyAsyncContext.id = 161;

/***/ }),

/***/ 203:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"../pages/accounts-brands-manage/accounts-brands-manage.module": [
		518,
		61
	],
	"../pages/accounts-manage/accounts-manage.module": [
		519,
		14
	],
	"../pages/accounts-social-profiles/accounts-social-profiles.module": [
		520,
		13
	],
	"../pages/add-gmb-event/add-gmb-event.module": [
		521,
		44
	],
	"../pages/add-location/add-location.module": [
		522,
		43
	],
	"../pages/add-tiktok-account/add-tiktok-account.module": [
		523,
		60
	],
	"../pages/add-zendesk-account/add-zendesk-account.module": [
		524,
		59
	],
	"../pages/approval-assign/approval-assign.module": [
		525,
		42
	],
	"../pages/approval-comment/approval-comment.module": [
		526,
		58
	],
	"../pages/approval-list/approval-list.module": [
		527,
		16
	],
	"../pages/approval-post-detail/approval-post-detail.module": [
		528,
		22
	],
	"../pages/auth-forgot-password/auth-forgot-password.module": [
		529,
		46
	],
	"../pages/auth-login/auth-login.module": [
		530,
		45
	],
	"../pages/auth-pricing/auth-pricing.module": [
		532,
		64
	],
	"../pages/auth-signup/auth-signup.module": [
		531,
		31
	],
	"../pages/boards/boards.module": [
		533,
		28
	],
	"../pages/change-password/change-password.module": [
		534,
		30
	],
	"../pages/comments-list/comments-list.module": [
		535,
		9
	],
	"../pages/event-reply-retweet-dm/event-reply-retweet-dm.module": [
		536,
		2
	],
	"../pages/event-view-comments/event-view-comments.module": [
		537,
		8
	],
	"../pages/event-view-conversation/event-view-conversation.module": [
		538,
		7
	],
	"../pages/fcm-testing/fcm-testing.module": [
		539,
		57
	],
	"../pages/feed-groups/feed-groups.module": [
		540,
		56
	],
	"../pages/feed-popover/feed-popover.module": [
		541,
		55
	],
	"../pages/feed-settings/feed-settings.module": [
		542,
		41
	],
	"../pages/feed-streams/feed-streams.module": [
		543,
		54
	],
	"../pages/feeds/feeds.module": [
		544,
		4
	],
	"../pages/inbox-filters/inbox-filters.module": [
		545,
		26
	],
	"../pages/inbox-notes/inbox-notes.module": [
		546,
		32
	],
	"../pages/inbox-roles/inbox-roles.module": [
		547,
		40
	],
	"../pages/inbox-settings-individual-profiles/inbox-settings-individual-profiles.module": [
		517,
		21
	],
	"../pages/inbox-settings/inbox-settings.module": [
		548,
		5
	],
	"../pages/inbox-tags/inbox-tags.module": [
		549,
		11
	],
	"../pages/inbox/inbox.module": [
		550,
		6
	],
	"../pages/instagram-notifications/instagram-notifications.module": [
		551,
		10
	],
	"../pages/instagram-profiles-list/instagram-profiles-list.module": [
		552,
		20
	],
	"../pages/keywords/keywords.module": [
		553,
		53
	],
	"../pages/main-tabs/main-tabs.module": [
		554,
		63
	],
	"../pages/mentions-list/mentions-list.module": [
		555,
		3
	],
	"../pages/pages-new-rre/pages-new-rre.module": [
		556,
		0
	],
	"../pages/post-filter/post-filter.module": [
		557,
		25
	],
	"../pages/post-settings/post-settings.module": [
		558,
		39
	],
	"../pages/profiles/profiles.module": [
		559,
		52
	],
	"../pages/publishin-actions-popup/publishin-actions-popup.module": [
		560,
		38
	],
	"../pages/publishing-post-preview/publishing-post-preview.module": [
		561,
		51
	],
	"../pages/publishing-schedule/publishing-schedule.module": [
		562,
		37
	],
	"../pages/publishing-select-profiles/publishing-select-profiles.module": [
		563,
		24
	],
	"../pages/publishing/publishing.module": [
		564,
		1
	],
	"../pages/rep-filters/rep-filters.module": [
		565,
		12
	],
	"../pages/rep-popover/rep-popover.module": [
		566,
		62
	],
	"../pages/rep-roles/rep-roles.module": [
		567,
		36
	],
	"../pages/rep-tags/rep-tags.module": [
		568,
		23
	],
	"../pages/reputations/reputations.module": [
		569,
		15
	],
	"../pages/retweet-list/retweet-list.module": [
		570,
		50
	],
	"../pages/settings/settings.module": [
		571,
		29
	],
	"../pages/subscription/subscription.module": [
		572,
		49
	],
	"../pages/suggested-hashtags/suggested-hashtags.module": [
		573,
		35
	],
	"../pages/te-image-list/te-image-list.module": [
		574,
		34
	],
	"../pages/te-saved-replies/te-saved-replies.module": [
		575,
		19
	],
	"../pages/te-thumbnail-modal/te-thumbnail-modal.module": [
		576,
		48
	],
	"../pages/tiktok-notifications/tiktok-notifications.module": [
		577,
		18
	],
	"../pages/tiktok-profile-list/tiktok-profile-list.module": [
		578,
		17
	],
	"../pages/video-properties/video-properties.module": [
		579,
		27
	],
	"../pages/video-thumnails/video-thumnails.module": [
		580,
		33
	],
	"../pages/view-profile/view-profile.module": [
		581,
		47
	]
};
function webpackAsyncContext(req) {
	var ids = map[req];
	if(!ids)
		return Promise.reject(new Error("Cannot find module '" + req + "'."));
	return __webpack_require__.e(ids[1]).then(function() {
		return __webpack_require__(ids[0]);
	});
};
webpackAsyncContext.keys = function webpackAsyncContextKeys() {
	return Object.keys(map);
};
webpackAsyncContext.id = 203;
module.exports = webpackAsyncContext;

/***/ }),

/***/ 21:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Feed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__ = __webpack_require__(30);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_moment__);
//HELPERS


// import momentTimezone from 'moment-timezone';
/*
*   Feed is a base class for all social feeds ( Fasebook, twitter, etc...).
*   it will carry the info of profile, stream and its options.
*/
var Feed = /** @class */ (function () {
    function Feed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        this.defaultProfileImage = 'https://app.eclincher.com/img/no_user_image.jpg';
        this.stream = stream;
        this.groups = [];
        this.group = group;
        this.profile = profile;
        this.options = options || {};
        this.network = profile.display.network.backend_network_name.toLowerCase();
        this.name = stream.name || stream.id;
        this.id = stream.streamId;
        this.favorited = stream.favorited || false;
        this.nextToken = false;
        this.lastLoadedTime = (new Date()).getTime();
        this.items = [];
        this.http = http;
        //set defaultGroupdId
        if (profile.original_config && (profile.original_config.defaultGroupId || profile.original_config.defaultGroupId)) {
            if (profile.display.network.backend_network_name.toLowerCase() == 'youtube') {
                this.defaultGroupID = profile.original_config.defaultChannelId;
            }
            if (profile.display.network.backend_network_name.toLowerCase() == 'youtube') {
                this.defaultGroupID = 'followed-by';
            }
            else {
                this.defaultGroupID = profile.original_config.defaultGroupId;
            }
        }
    }
    /**
     * setOptions
     */
    Feed.prototype.setOptions = function (options) {
        this.options = options;
    };
    /*
    *   It return true if group is not epty
    */
    Feed.prototype.isGroupFeed = function () {
        return !__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](this.group);
    };
    /**
     * setGroups
     */
    Feed.prototype.setGroups = function (groups) {
        this.groups = groups;
    };
    /**
     * setSelectedGroup
     */
    Feed.prototype.setSelectedGroup = function (group) {
        this.nextToken = false;
        this.group = group;
    };
    /**
     * setSelectedGroup
     */
    Feed.prototype.setAccountsServiceProvider = function (accountsServiceProvider) {
        this.accountsServiceProvider = accountsServiceProvider;
    };
    Feed.prototype.setUserSettingsProvider = function (userSettingsProvider) {
        this.userSettingsProvider = userSettingsProvider;
    };
    Feed.prototype.setFeedNotesProvider = function (feedNotesProvider) {
        this.feedNotesProvider = feedNotesProvider;
    };
    /**
     * setUniqueID
     */
    Feed.prototype.setUniqueID = function (id) {
        this.uniqueID = id;
    };
    Feed.prototype.setAccount = function () {
        var _this = this;
        //set account
        this.accountsServiceProvider.getAccountByID(this.profile.account_id).subscribe(function (account) {
            _this.account = account;
        });
    };
    Feed.prototype.formatGMBItem = function (data) {
        var this_datum = {
            id: data.id,
            fromId: this.profile.data.userId,
            fromName: this.profile.display.profile_name,
            profilePic: this.profile.display.profile_picture_url,
            updateTime: new Date(data.createTime).getTime() / 1000 >> 0,
            state: data.state,
            message: data.summary,
            callToAction: data.callToAction,
            event: data.event
        };
        if (data.updateTime)
            this_datum.updateTime = new Date(data.updateTime).getTime() / 1000 >> 0;
        if (this.id === 'cinbox') {
            this_datum.tags = data.tags;
            this_datum.eventNetwork = data.eventNetwork;
            this_datum.eventType = data.eventType;
            this_datum.roles = data.roles;
            this_datum.eventUserName = data.eventUserName;
            this_datum.eventTime = data.eventTime;
            this_datum.ecCompleted = data.ecCompleted;
            this_datum.ecDeleted = data.ecDeleted;
            this_datum.ecRead = data.ecRead;
            this_datum.ecReply = data.ecReply;
            this_datum.ecLike = data.ecLike;
        }
        if (this.id === 'gmbReviews' || data.eventNetwork === 'GMBReviews') {
            this_datum.fromId = 'reviewer';
            this_datum.fromName = data.reviewerName || 'Anonymous';
            this_datum.profilePic = this.defaultProfileImage;
            this_datum.reviewReply = data.reviewReply;
        }
        else if (this.id === 'gmbQuestions' || data.eventType === 'GMBQuestions') {
            this_datum.fromId = 'author';
            if (data.author) {
                this_datum.fromName = data.author.fromName;
                this_datum.profilePic = data.author.profilePic;
                this_datum.fromType = data.author.fromType;
            }
            else {
                this_datum.fromName = 'Anonymous';
                this_datum.profilePic = this.defaultProfileImage;
                this_datum.fromType = 'UNSPECIFIED';
            }
            this_datum.rootEvent = data.rootEvent;
            this_datum.upvoteCount = data.upvoteCount;
            if (typeof data.totalAnswerCount === 'string' && data.totalAnswerCount !== 'null')
                this_datum.totalAnswerCount = data.totalAnswerCount;
            else
                this_datum.totalAnswerCount = '0';
            if (data.topAnswers && data.topAnswers.answer) {
                this_datum.topAnswers = data.topAnswers;
                if (!Array.isArray(this_datum.topAnswers.answer))
                    this_datum.topAnswers.answer = [this_datum.topAnswers.answer];
                var l = this_datum.topAnswers.answer.length;
                for (var i = 0; i < l; i++) {
                    var answer = this_datum.topAnswers.answer[i];
                    if (answer.author && answer.author.fromType === 'MERCHANT' && answer.author.fromName === this.account.display.account_name) {
                        this_datum.ownerAnswer = answer;
                        break;
                    }
                }
            }
        }
        // take 1 attachment for now
        if (data.mediaArray && data.mediaArray.media && !__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](data.mediaArray.media)) {
            var media = data.mediaArray.media;
            if (Array.isArray(media))
                media = media[0];
            if (media.mediaFormat === 'PHOTO') {
                this_datum.media = {};
                if (typeof media.googleUrl === 'string' && media.googleUrl.indexOf('https:') !== -1)
                    this_datum.media.src = media.googleUrl;
            }
        }
        return this_datum;
    };
    Feed.prototype.formatTwitterItem = function (data) {
        var this_datum = {
            user: data.user,
            updateTime: (new Date(data.created_at).getTime() / 1000),
            favorites: {
                count: data.favorite_count,
                by_me: data.favorited
            },
            retweets: {
                count: data.retweet_count,
                by_me: data.retweeted,
                id: ((data.retweeted_status != undefined) ? data.retweeted_status.id_str : data.id_str),
                retweetId: ((data.retweetId != undefined) ? data.retweetId : false)
            },
            message: data.text,
            fromName: (data.name || data.user.name),
            username: (data.screen_name || data.user.screen_name),
            profilePic: (data.profile_image_url || data.user.profile_image_url),
            postID: data.id_str,
            id: data.id_str,
            raw_data: data
        };
        if (data.entities != undefined && data.entities.media != undefined && Array.isArray(data.entities.media.media_url)) {
            this_datum.media = [];
            data.entities.media.media_url.forEach(function (media_url) {
                this_datum.media.push({
                    type: 'photo',
                    src: media_url
                });
            });
        }
        return this_datum;
    };
    Feed.prototype.formatGPItem = function (data) {
        var this_datum = data;
        this_datum.fromId = data.user.fromId;
        this_datum.fromName = data.user.fromName;
        this_datum.profileLink = data.user.profileLink;
        this_datum.profilePic = data.user.profilePic;
        this_datum.updateTime = new Date(this_datum.updateTime).getTime() / 1000;
        delete this_datum.user;
        // take 1 attachment for now
        if (data.attachments != undefined && !__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](data.attachments)) {
            if (Array.isArray(data.attachments.attachment))
                this_datum.media = data.attachments.attachment[0];
            else
                this_datum.media = data.attachments.attachment;
            if (this_datum.media.content) {
                if ((/\w{8}(-\w{4}){3}-\w{12}/i).test(this_datum.media.content))
                    this_datum.media.content = '';
            }
            if (this_datum.media.type === 'photo' || this_datum.media.type === 'article') {
                if (this_datum.media.fullImage && typeof this_datum.media.fullImage.url === 'string' && this_datum.media.fullImage.url.indexOf('https:') !== -1) {
                    this_datum.media.src = this_datum.media.fullImage.url;
                    if (this_datum.media.image)
                        delete this_datum.media.image;
                }
                else if (this_datum.media.image && typeof this_datum.media.image.url === 'string' && this_datum.media.image.url.indexOf('https:') !== -1) {
                    this_datum.media.src = this_datum.media.image.url;
                    if (this_datum.media.fullImage)
                        delete this_datum.media.fullImage;
                }
                else
                    delete this_datum.media;
            }
            else if (this_datum.media.type === 'video') {
                if (this_datum.media.image && typeof this_datum.media.image.url === 'string' && this_datum.media.image.url.indexOf('https:') !== -1) {
                    this_datum.media.src = this_datum.media.image.url;
                    if (this_datum.media.embed != undefined)
                        this_datum.media.video = {
                            source_url: this_datum.media.embed.url,
                            display_url: this_datum.media.embed.url
                        };
                    else
                        this_datum.media.video = {
                            source_url: this_datum.media.url,
                            display_url: this_datum.media.url
                        };
                }
                else
                    delete this_datum.media;
            }
        }
        return this_datum;
    };
    Feed.prototype.formatGPActivitiesItem = function (data) {
        var this_datum = {
            fromId: data.user.id,
            fromName: data.user.full_name,
            profilePic: data.user.profile_picture,
            profileLink: data.user.profile_link,
            selfLink: data.selfLink,
            updateTime: (new Date(data.created_time).getTime() / 1000),
            message: data.title,
            resharers: data.resharers,
            likes: data.likes,
            comments: data.comments,
            postID: data.id,
            raw_data: data
        };
        if (this_datum.comments.comment != undefined && !Array.isArray(this_datum.comments.comment))
            this_datum.comments.comment = [this_datum.comments.comment];
        if (this_datum.likes.like != undefined && !Array.isArray(this_datum.likes.like))
            this_datum.likes.like = [this_datum.likes.like];
        // take 1 attachment for now
        if (data.attachments != undefined) {
            if (Array.isArray(data.attachments.attachment))
                this_datum.media = data.attachments.attachment[0];
            else
                this_datum.media = data.attachments.attachment;
            if (this_datum.media.content) {
                if ((/\w{8}(-\w{4}){3}-\w{12}/i).test(this_datum.media.content))
                    this_datum.media.content = '';
            }
            if (this_datum.media.type === 'photo' || this_datum.media.type === 'article') {
                if (this_datum.media.fullImage && typeof this_datum.media.fullImage.url === 'string' && this_datum.media.fullImage.url.indexOf('https:') !== -1) {
                    this_datum.media.src = this_datum.media.fullImage.url;
                    if (this_datum.media.image)
                        delete this_datum.media.image;
                }
                else if (this_datum.media.image && typeof this_datum.media.image.url === 'string' && this_datum.media.image.url.indexOf('https:') !== -1) {
                    this_datum.media.src = this_datum.media.image.url;
                    if (this_datum.media.fullImage)
                        delete this_datum.media.fullImage;
                }
                else
                    delete this_datum.media;
            }
            else if (this_datum.media.type === 'video') {
                if (this_datum.media.image && typeof this_datum.media.image.url === 'string' && this_datum.media.image.url.indexOf('https:') !== -1) {
                    this_datum.media.src = this_datum.media.image.url;
                    if (this_datum.media.embed != undefined)
                        this_datum.media.video = {
                            source_url: this_datum.media.embed.url,
                            display_url: this_datum.media.embed.url
                        };
                    else
                        this_datum.media.video = {
                            source_url: this_datum.media.url,
                            display_url: this_datum.media.url
                        };
                }
                else
                    delete this_datum.media;
            }
        }
        return this_datum;
    };
    Feed.prototype.formatInstagramBusinessItem = function (data) {
        var this_datum = {
            id: data.id,
            caption: {
                text: data.mediaDescription
            },
            created_time: (data.updateTime ? new Date(data.updateTime.replace(/([+\-]\d\d)(\d\d)$/, "$1:$2")).getTime() / 1000 : null),
            user: {
                id: data.fromId,
                username: this.profile.display.profile_name,
                full_name: data.fromName,
                profile_picture: data.profilePic
            },
            recipient_id: data.object_id,
            images: {
                standard_resolution: { url: '' },
                low_resolution: { url: '' },
                thumbnail: { url: '' }
            },
            type: data.type,
            link: data.permalink,
            comments: data.comments,
            likes: data.likes,
            user_has_liked: 'false',
            business: true
        };
        if (this.id === 'igbInbox')
            this_datum.created_time = data.updateTime;
        if (data.type === 'carousel_album' && Array.isArray(data.media)) {
            this_datum.type = 'carousel';
            this_datum.carousel_media = { media: [] };
            data.media.forEach(function (media) {
                var carou_media = {
                    standard_resolution: { url: media.src },
                    thumbnail: { url: media.src },
                    type: media.type.toLowerCase()
                };
                if (media.type === 'VIDEO' && media.video && media.video.display_url) {
                    carou_media.videos = {
                        standard_resolution: {
                            url: media.video.display_url
                        },
                        low_resolution: {
                            url: media.video.display_url
                        }
                    };
                }
                this_datum.carousel_media.media.push(carou_media);
            });
        }
        else if (data.media && data.media.src) {
            this_datum.images = {
                standard_resolution: {
                    url: data.media.src
                },
                thumbnail: {
                    url: data.media.src
                }
            };
            if (data.type === 'video' && data.media.video && data.media.video.display_url) {
                this_datum.videos = {
                    standard_resolution: {
                        url: data.media.video.display_url
                    },
                    low_resolution: {
                        url: data.media.video.display_url
                    }
                };
            }
        }
        return this_datum;
    };
    Feed.prototype.formatPinterestItem = function (data) {
        var this_datum = {
            message: data.note,
            raw_data: data
        };
        if (data.counts && data.counts.repins)
            this_datum.repins = '' + data.counts.repins;
        else
            this_datum.repins = '';
        this_datum.link = data.link;
        this_datum.title = data.title;
        if (data.description)
            this_datum.message = data.description;
        if (data.counts && data.counts.likes)
            this_datum.likes = { count: data.counts.likes };
        if (data.counts && data.counts.comments)
            this_datum.comments = { count: data.counts.comments };
        if (data.shareable_url)
            this_datum.permalink = data.shareable_url;
        // if (data.image && data.image.original) {
        if (data.image_large_url) {
            this_datum.media = {
                type: 'photo',
                src: data.image_large_url
            };
        }
        // if (data.metadata && data.metadata.link && data.metadata.link.favicon && data.metadata.link.site_name) {
        //     this_datum.mediaDescription = '<div class="pi-from"><img src="' + data.metadata.link.favicon
        //         + '" /></div>from ' + data.metadata.link.site_name;
        // }
        if (data.domain) {
            this_datum.mediaDescription = '<div class="pi-from"><img src="" /></div>from ' + data.domain;
        }
        return this_datum;
    };
    Feed.prototype.formatYoutubeItem = function (data) {
        var media = data.media;
        if (media.type == "video") {
            media.video = {
                display_url: 'http://www.youtube.com/embed/' + media.id + '?autoplay=1',
                source_url: 'http://www.youtube.com/embed/' + media.id + '?autoplay=1'
            };
        }
        var this_datum = {
            fromId: data.fromId,
            fromName: data.fromName,
            profilePic: data.profilePic,
            profileLink: data.profileLink,
            updateTime: (new Date(data.updateTime).getTime() / 1000),
            message: data.message,
            channelId: data.channelId,
            channelLink: 'https://www.youtube.com/channel/' + data.channelId,
            channelTitle: data.channelTitle,
            activityType: data.activityType || '',
            likes: data.likes,
            views: data.views,
            comments: data.comments,
            media: media,
            postID: data.fromId,
            raw_data: data
        };
        if (data.message.indexOf('uploaded a video') != -1)
            this_datum.message = '';
        return this_datum;
    };
    Feed.prototype.formatBloggerItem = function (data) {
        var this_datum = data;
        if (__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](data.name))
            data.name = undefined;
        if (typeof data.message == 'string') {
            this_datum.message = data.message
                .replace(/<h\d/gi, '<div')
                .replace(/<\/h\d>/gi, '</div>')
                .replace(/class="\w*"/gi, '')
                .replace(/style=/gi, 'data-s=')
                .replace(/width=/gi, 'data-w=')
                .replace(/height=/gi, 'data-h=')
                .replace(/a href/gi, 'a target="_blank" href')
                .replace(/<br\s*[\/]?>/gi, '<span></span>');
        }
        else {
            this_datum.message = ''; //data.message;
        }
        return this_datum;
    };
    Feed.prototype.format_tw_entry = function (data_i) {
        var this_datum = {
            eventNetwork: data_i.eventNetwork,
            eventType: data_i.eventType,
            eventTime: data_i.eventTime,
            eventUserName: data_i.eventUserName,
            ecCompleted: data_i.ecCompleted,
            ecDeleted: data_i.ecDeleted,
            ecRead: data_i.ecRead,
            ecFollow: data_i.ecFollow,
            ecRetweet: data_i.ecRetweet,
            ecFavorite: data_i.ecFavorite,
            ecDM: data_i.ecDM,
            ecReply: data_i.ecReply,
            roles: data_i.roles,
            tags: data_i.tags,
            user: data_i.user,
            updateTime: (data_i.eventType == 'TWFollowers' ? data_i.eventTime.substr(0, 10) : new Date(data_i.created_at).getTime() / 1000),
            favorites: {
                count: data_i.favorite_count,
                by_me: data_i.favorited
            },
            retweets: {
                count: data_i.retweet_count,
                by_me: data_i.retweeted,
                id: ((data_i.retweeted_status != undefined) ? data_i.retweeted_status.id_str : data_i.id_str)
            },
            message: data_i.text,
            // message: $('<div>').html( data_i.text ).text(),
            fromName: (data_i.name || data_i.user.name),
            twVerified: (data_i.verified || data_i.user.verified),
            username: (data_i.screen_name || data_i.user.screen_name),
            profilePic: (data_i.profile_image_url || data_i.user.profile_image_url),
            postID: data_i.id_str,
            raw_data: data_i
        };
        if (data_i.entities != undefined && data_i.entities.media != undefined && Array.isArray(data_i.entities.media.media_url)) {
            this_datum.media = [];
            data_i.entities.media.media_url.forEach(function (media_url) {
                this_datum.media.push({
                    type: 'photo',
                    src: media_url
                });
            });
        }
        if (data_i.eventType == 'TWFollowers') {
            // var from_name = $('<div>').html( this_datum.fromName ).text();
            //this_datum.message = this_datum.fromName + ' @' + this_datum.username + ' now following you.';
            var from_name = this_datum.fromName;
            this_datum.message = '<span class="day-following">' + __WEBPACK_IMPORTED_MODULE_1_moment__(parseInt(data_i.eventTime)).format('LL') + '</span>' +
                ' ' + from_name + ' is now following you. <span class="view-follower">View ' +
                from_name + ' profile</span>';
            this_datum.raw_data.entities = { user_mentions: { screen_name: this_datum.username } };
        }
        return this_datum;
    };
    return Feed;
}());

//# sourceMappingURL=feed.js.map

/***/ }),

/***/ 25:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AppSettingsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_device__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


//rxjs

/* import { Observable } from 'rxjs/Observable';
import { Subscription } from "rxjs/Subscription"
 */
var AppSettingsProvider = /** @class */ (function () {
    function AppSettingsProvider(device) {
        this.device = device;
        // source for observable
        this._qaAppSettings = {
            //baseUrl: "https://ionicdev.app.eclincher.com",
            baseUrl: "https://qa.app.eclincher.com/service"
        };
        this._prodAppSettings = {
            baseUrl: "https://app.eclincher.com/service",
        };
        this.s3Url = 'https://s3.amazonaws.com';
        this.feedRefreshInterval = 3 * 60 * 1000;
        this.storeUrl = {
            android: 'https://play.google.com/store/apps/details?id=com.eclincher.eclincher',
            ios: 'https://itunes.apple.com/us/app/eclincher-social-media-management/id1047260905?mt=8'
        };
        this._appSettingsSource = new __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__["BehaviorSubject"](this._prodAppSettings);
        // observable stream
        this.appSettings$ = this
            ._appSettingsSource
            .asObservable();
        this._fcmTokenKey = 'FCMTOKEN';
        this.sharedDataKey = 'SHARED_DATA';
        this.sharedIosDataKey = 'IOS_SHARED_DATA';
    }
    ;
    AppSettingsProvider.prototype.changeEnvToProd = function () {
        this._appSettingsSource.next(this._prodAppSettings);
    };
    ;
    AppSettingsProvider.prototype.changeEnvToQA = function () {
        this._appSettingsSource.next(this._qaAppSettings);
    };
    ;
    AppSettingsProvider.prototype.getFCMTokenKey = function () {
        return this._fcmTokenKey;
    };
    AppSettingsProvider.prototype.getApiUrl = function () {
        if (this._appSettingsSource.value) {
            return this._appSettingsSource.value.baseUrl;
        }
        return '';
    };
    /**
     * getS3Url
     */
    AppSettingsProvider.prototype.getS3Url = function () {
        return this.s3Url;
    };
    /**
     * getStoreUrl
     */
    AppSettingsProvider.prototype.getStoreUrl = function () {
        var url = '';
        var platform = this.device.platform ? this.device.platform.toLowerCase() : 'android';
        if (platform === 'ios') {
            url = this.storeUrl.ios;
        }
        else {
            url = this.storeUrl.android;
        }
        return url;
    };
    AppSettingsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_device__["a" /* Device */]])
    ], AppSettingsProvider);
    return AppSettingsProvider;
}());

; //end AppSettingsProvider
;
//# sourceMappingURL=app-settings.js.map

/***/ }),

/***/ 30:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["y"] = url_to_link;
/* harmony export (immutable) */ __webpack_exports__["r"] = new_url_to_link;
/* harmony export (immutable) */ __webpack_exports__["h"] = fixCommasInString;
/* harmony export (immutable) */ __webpack_exports__["d"] = commas;
/* harmony export (immutable) */ __webpack_exports__["o"] = isEmptyObject;
/* harmony export (immutable) */ __webpack_exports__["c"] = cloneObject;
/* harmony export (immutable) */ __webpack_exports__["w"] = tw_deep_link_to_html;
/* harmony export (immutable) */ __webpack_exports__["u"] = replaceWithDisplayURL;
/* harmony export (immutable) */ __webpack_exports__["i"] = for_each;
/* harmony export (immutable) */ __webpack_exports__["t"] = replaceURLWithHTMLLinks;
/* harmony export (immutable) */ __webpack_exports__["a"] = FB_thumbnail_to_full_size;
/* harmony export (immutable) */ __webpack_exports__["n"] = hashtag_to_link;
/* harmony export (immutable) */ __webpack_exports__["v"] = replace_type_in_username;
/* harmony export (immutable) */ __webpack_exports__["q"] = mention_to_link;
/* harmony export (immutable) */ __webpack_exports__["f"] = decodeHTMLEntities;
/* harmony export (immutable) */ __webpack_exports__["x"] = tw_user_mentions_to_links;
/* unused harmony export onlyUniqueVal */
/* harmony export (immutable) */ __webpack_exports__["g"] = fb_tags_to_links;
/* harmony export (immutable) */ __webpack_exports__["p"] = ln_mentions_to_links;
/* harmony export (immutable) */ __webpack_exports__["k"] = getMentionFromText;
/* harmony export (immutable) */ __webpack_exports__["b"] = amp_encode;
/* harmony export (immutable) */ __webpack_exports__["m"] = getUrlParam;
/* harmony export (immutable) */ __webpack_exports__["j"] = formatEventType;
/* harmony export (immutable) */ __webpack_exports__["l"] = getTimeStamp;
/* harmony export (immutable) */ __webpack_exports__["s"] = removeRolesAndTagsFromHtml;
/* harmony export (immutable) */ __webpack_exports__["e"] = convertToHTML;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_twitter_text__ = __webpack_require__(334);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_twitter_text___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_twitter_text__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_jquery__);


function url_to_link(text) {
    var target = "_blank";
    var exp = /(\b((https?|ftp|file):\/\/|bit.ly\/|goo.gl\/|t.co\/)[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
    function replacer(match) {
        return "<a target='" + target + "' href='" + (match.indexOf('//') == -1 ? '//' + match : match) + "'>" + (match.indexOf('//') == -1 ? '//' + match : match) + "</a>";
    }
    if (typeof text == 'string')
        return text.replace(exp, replacer);
    else
        return '';
}
;
function new_url_to_link(text) {
    var $urls = [], replacer, result = text || '';
    var target = "_blank";
    if (typeof text === 'string') {
        $urls = __WEBPACK_IMPORTED_MODULE_0_twitter_text__["extractUrls"](text);
        $urls.forEach(function (url) {
            replacer = '<a href="' + (url.indexOf('//') === -1 ? '//' + url : url) + ' "'
                + (typeof target === 'undefined' ? 'target="_blank"' : 'target="' + target + '"') + '>' + url + '</a>';
            result = result.replace(url, replacer);
        });
    }
    return result;
}
function fixCommasInString(j) {
    self = this;
    if (j == undefined || j == null) {
        return j;
    }
    j = j.toString();
    var temphack = j.replace(/,/g, '');
    temphack = temphack.replace(/\(/g, ' ( ');
    temphack = temphack.replace(/\)/g, ' ) ');
    var temphacktwo = temphack.split(' ');
    for (var i = 0; i < temphacktwo.length; i++) {
        if (isNumber(temphacktwo[i])) {
            temphacktwo[i] = numberWithCommas(temphacktwo[i]);
        }
    }
    j = temphacktwo.join(' ');
    j = j.replace(/ \( /g, ' (');
    j = j.replace(/ \) /g, ') ');
    function isNumber(n) {
        var result = !isNaN(parseFloat(n)) && isFinite(n);
        return result;
    }
    ;
    function numberWithCommas(x) {
        if (x == undefined)
            return '';
        var parts = x.toString().split(".");
        parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        return parts.join(".");
    }
    ;
    console.log('j', typeof j);
    return j;
}
;
function commas(x) {
    var parts = x.toString().split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    return parts.join(".");
}
function isEmptyObject(obj) {
    for (var name in obj) {
        return false;
    }
    return true;
}
function cloneObject(obj) {
    return __WEBPACK_IMPORTED_MODULE_1_jquery__["extend"](true, {}, obj);
}
// return text
function tw_deep_link_to_html(text, raw_data) {
    text = text || '';
    var deep_link = 'https://twitter.com/messages/compose?recipient_id=';
    if (raw_data.entities && raw_data.entities.urls) {
        for_each(raw_data.entities.urls, function (url) {
            if (url.url && url.expanded_url && url.expanded_url.indexOf(deep_link) !== -1) {
                var expanded_url = url.expanded_url, recipient_id = expanded_url.replace(deep_link, '');
                var message_me = '<div class="message-me" data-recipient="' + recipient_id + '">\
                        <svg class="message-me-icon" viewBox="0 0 56 54" version="1.1" style="fill:currentcolor; color:rgb(3, 133, 67); ">\
                            <path d=" M 10.07 0.00 L 12.02 0.00 C 12.68 0.59 13.34 1.19 13.98 1.80 C 13.98 3.86 14.00 5.93 14.01 7.99 C 16.73 8.16 21.66 6.90 21.96 10.93 C 21.78 15.09 16.78 13.88 14.01 14.01 C 14.00 15.99 14.10 17.98 13.89 19.96 C 13.15 22.68 8.90 22.61 8.10 19.97 C 7.90 17.99 8.00 15.99 8.00 14.01 C 5.24 13.80 1.63 14.98 0.00 12.02 L 0.00 9.96 C 0.59 9.31 1.18 8.67 1.78 8.04 C 3.85 8.03 5.92 7.99 8.00 7.99 C 8.23 5.25 6.94 1.48 10.07 0.00 Z"></path>\
                            <path d=" M 30.14 13.83 C 27.67 12.68 28.11 8.21 30.98 8.08 C 36.36 7.91 41.76 7.98 47.15 8.05 C 51.55 7.99 55.34 11.72 56.00 15.96 L 56.00 33.17 C 55.26 37.39 51.51 41.03 47.12 40.97 C 40.52 41.06 33.92 40.96 27.32 41.01 C 22.14 45.09 17.15 49.43 11.86 53.37 C 10.32 54.54 7.84 52.91 8.05 51.07 C 7.98 44.39 7.92 37.69 8.08 31.02 C 8.22 28.14 12.77 27.67 13.80 30.28 C 14.29 34.70 13.85 39.16 14.01 43.59 C 17.80 40.85 21.38 37.79 25.29 35.21 C 33.03 34.39 41.05 35.76 48.69 34.55 C 51.34 31.54 49.32 26.73 49.94 23.01 C 49.45 20.16 51.36 15.69 48.05 14.14 C 42.09 13.68 36.09 14.34 30.14 13.83 Z"></path>\
                        </svg>\
                        <span class="message-me-text">Send a private message</span>\
                    </div>';
                text = text.replace(url.url, message_me);
                text = text.replace(url.expanded_url, message_me);
            }
        });
    }
    return text;
}
;
function replaceWithDisplayURL(message_html, entities) {
    var result = message_html;
    if (entities && !isEmptyObject(entities.urls)) {
        var urls = entities.urls;
        for_each(urls, function (url) {
            if (url.url && url.expanded_url && url.display_url) {
                if (url.display_url.indexOf('pic.twitter.com/') === 0)
                    result = result.replace(url.url, '');
                else
                    result = result.replace(url.url, '<a href="' + url.expanded_url + '" target="_blank">' + url.display_url + '</a>');
            }
        });
    }
    else
        result = new_url_to_link(message_html);
    return result;
}
function for_each(array, fn) {
    array = Array.isArray(array) ? array : [array];
    for (var index = 0, length = array.length; index < length; ++index)
        fn(array[index], index, length);
}
;
function replaceURLWithHTMLLinks(text) {
    if (typeof text != "string")
        return;
    var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
    return text.replace(exp, "<a href='$1' target='_blank'>$1</a>");
}
;
function FB_thumbnail_to_full_size(url) {
    var url_n = url;
    if (url.indexOf("?") == -1) {
        if (url.indexOf("_s.jpg") != -1)
            url_n = url.replace("_s.jpg", "_n.jpg");
        else {
            if (url.indexOf("_s.jpeg") != -1)
                url_n = url.replace("_s.jpeg", "_n.jpeg");
            else
                url_n = url.replace("_s.png", "_n.png");
        }
    }
    return url_n;
}
;
function hashtag_to_link(text, network) {
    var exp = /\B#(\w*[a-zA-Z]+\w*)/ig, linked = '';
    if (Array.isArray(text))
        text = text[0];
    if (typeof text != 'undefined') {
        if (network === 'twitter')
            linked = text.replace(exp, "<a class='tw-hashtag' href='https://twitter.com/search?q=%23$1' target='_blank' data-query='%23$1'>#$1</a>");
        else if (network === 'facebook')
            linked = text.replace(exp, "<a href='https://www.facebook.com/hashtag/$1' target='_blank'>#$1</a>"); // https://www.facebook.com/hashtag/nba?hc_location=ufi
        else
            linked = text.replace(exp, "<a href='https://twitter.com/search?q=%23$1' target='_blank'>#$1</a>");
    }
    return linked;
}
function replace_type_in_username(userName) {
    return userName.replace(/( \(User\)$| \(Profile\)$| \(Page\)$| \(Company Page\)$)/, '');
}
function mention_to_link(text, network) {
    var exp = /\B@(\w*[a-zA-Z]+\w*)/ig, linked = '';
    if (Array.isArray(text))
        text = text[0];
    if (typeof text != 'undefined') // maybe if text != undefined
        if (network != undefined && network == 'twitter')
            linked = text.replace(exp, "<a class='tw-user' href='https://twitter.com/$1' target='_blank' data-user='@$1'>@$1</a>");
        else
            linked = text.replace(exp, "<a href='https://twitter.com/$1' target='_blank'>@$1</a>");
    return linked;
}
function decodeHTMLEntities(encodedString) {
    if (typeof encodedString !== 'string')
        return encodedString;
    var textArea = document.createElement('textarea');
    textArea.innerHTML = encodedString;
    return textArea.value;
}
function tw_user_mentions_to_links(text, raw_data) {
    text = text || '';
    var user_mentions;
    if (raw_data.entities != undefined && raw_data.entities.user_mentions != undefined
        && raw_data.entities.user_mentions.screen_name != undefined) {
        user_mentions = raw_data.entities.user_mentions.screen_name;
        if (!Array.isArray(user_mentions))
            user_mentions = [user_mentions];
    }
    user_mentions = user_mentions || [];
    user_mentions = user_mentions.filter(onlyUniqueVal);
    for (var i = 0, l = user_mentions.length; i < l; i++) {
        var screen_name = user_mentions[i];
        var exp = new RegExp('@' + screen_name, 'ig');
        text = text.replace(exp, '<a class="tw-user" href="https://twitter.com/' + screen_name +
            '" target="_blank"  data-user="@' + screen_name + '">@' + screen_name + '</a>');
    }
    return text;
}
function onlyUniqueVal(value, index, self) {
    return self.indexOf(value) === index;
}
function fb_tags_to_links(text, tags, type) {
    if (!Array.isArray(tags))
        tags = [tags];
    tags.sort(function (a, b) {
        return parseInt(a.offset) - parseInt(b.offset);
    });
    var result = [], cur_offset = 0, result_str = '', tag, length, offset, multitags = {};
    for (var i = 0, l = tags.length; i < l; i++) {
        tag = tags[i];
        offset = parseInt(tag.offset);
        length = parseInt(tag.length);
        if (cur_offset <= offset) {
            result.push(text.substring(cur_offset, offset));
            cur_offset = offset + length;
            //result.push( tag.link );
            result.push({
                id: tag.id,
                name: (tag.name == undefined || isEmptyObject(tag.name) ? text.substr(offset, length) : tag.name),
                type: tag.type,
                link: tag.link
            });
        }
        else //multitags
         {
            if (multitags[tag.offset] == undefined) {
                var prev_link = result.pop();
                multitags[tag.offset] = {
                    offset: offset,
                    length: length,
                    name: text.substr(offset, length),
                    tags: [{ name: tags[i - 1].name, link: prev_link },
                        { name: tag.name, link: tag.link }]
                };
                result.push('_$mt$_' + offset + text.substr(offset, length));
            }
            else //add multitag
                multitags[tag.offset].tags.push({ name: tag.name, link: tag.link });
        }
    }
    result.push(text.substring(cur_offset));
    //result_str = url_to_link( result.join('') );
    for (var i = 0, l = result.length; i < l; i++) {
        var item = result[i];
        if (typeof item == 'object') //tag
         {
            result_str += '<a class="fb-' + item.type + '" href="' + item.link + '" target="_blank" data-user="' +
                item.id + '">' + item.name + '</a>';
        }
        else
            result_str += url_to_link(item);
    }
    for (var offset_1 in multitags) {
        var multitag = multitags[offset_1];
        var tt = '';
        for (var k = 0, l = multitag.tags.length; k < l; k++) {
            if (k < 3)
                tt = tt + (tt.length == 0 ? '' : ', ') + multitag.tags[k].name;
        }
        if (multitag.tags.length > 3)
            tt = tt + ', ...';
        result_str = result_str.replace('_$mt$_' + multitag.offset + multitag.name, '<span class="multitag" data-tooltip="' +
            tt + '" data-offset="' + type + '_' + multitag.offset + '">' + multitag.name + '</span>');
    }
    return result_str;
}
;
function ln_mentions_to_links(text, annotations) {
    var mentions = (Array.isArray(annotations)) ? annotations : [annotations];
    if (mentions.length) {
        mentions.sort(function (a, b) {
            return a.name.length - b.name.length;
        });
        for (var i = 0; i < mentions.length; i++) {
            var mention_key = mentions[i].name;
            if (typeof mentions[i].entity != 'string' && typeof mention_key != 'string') {
                continue;
            }
            var reg_pattern_str = mention_key.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
            var reg_pattern = new RegExp(reg_pattern_str, 'g');
            var reg_pattern_enc = new RegExp(htmlFromText(reg_pattern_str), 'g');
            if (!reg_pattern.test(text))
                reg_pattern = reg_pattern_enc;
            text = text.replace(reg_pattern, '<a class="link" target="_blank" rel="noopener noreferrer"  href ="https://www.linkedin.com/company/' + mentions[i].entity.split(":").pop() + '" class="lnmention">' + mention_key.replace('@', '') + '</a>');
        }
    }
    function htmlFromText(str) {
        str = str.toString();
        return str
            .replace(/&/g, '&amp;')
            .replace(/</g, '&lt;')
            .replace(/>/g, '&gt;')
            .replace(/"/g, '&quot;')
            .replace(/'/g, '&#x27;')
            .replace(/`/g, '&#x60;')
            .replace(/(?:\r\n|\r|\n)/g, '\n')
            .replace(/(\n+)/g, '<div>$1</div>')
            .replace(/\n/g, '<br/>')
            .replace(/<br\/><\/div>/g, '</div>');
    }
    ;
    return text;
}
function getMentionFromText(text, start, strLength) {
    var name = text.substring(start, start + strLength);
    console.log("getMentionFromText", name);
    return name;
}
function amp_encode(str) {
    str = str.toString();
    return str.replace(/\&/g, '&amp;');
}
;
function getUrlParam(name, url) {
    if (!url)
        url = location.href;
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(url);
    return results == null ? null : results[1];
}
;
function formatEventType(type, data) {
    if (data === void 0) { data = {}; }
    var formatedType = type;
    console.log('formatedType', formatedType);
    switch (type) {
        case 'TWMentions':
            formatedType = 'Mention';
            break;
        case 'TWFollowers':
            formatedType = 'New Followers';
            break;
        case 'TWRetweets':
            formatedType = 'Retweet';
            break;
        case 'TWRetweets':
            formatedType = 'Retweet';
            break;
        case 'TWRetweetsWithComments':
            formatedType = 'Quote Retweet';
            break;
        case 'TWDirectMessage':
            formatedType = 'Direct Message';
            break;
        case 'GPComments':
            formatedType = 'Comment';
            break;
        case 'GMBReviews':
            formatedType = 'Review';
            break;
        case 'YTComments':
            formatedType = 'Comment: ';
            var status_1 = 'Public';
            switch (data.moderationStatus) {
                case 'heldForReview':
                    status_1 = 'Held for Review';
                    break;
                case 'likelySpam':
                    status_1 = 'Likely Spam';
                    break;
                case 'rejected':
                    status_1 = 'Rejected';
                    break;
            }
            formatedType += status_1;
            break;
        case 'FBComments':
            formatedType = 'Comment';
            break;
        case 'FBAdsComments':
            formatedType = 'Ad Comment';
            break;
        case 'FBShares':
            formatedType = 'Share';
            break;
        case 'FBOthers':
            formatedType = 'Other';
            break;
        case 'FBLikes':
            formatedType = 'Like';
            break;
        case 'FBWallPosts':
            formatedType = 'Write on Wall';
            break;
        case 'FBReviews':
            formatedType = 'Review Comment';
            if (data && data.eventTitle) {
                formatedType = data.eventTitle;
            }
            break;
        case 'FBMentions':
            formatedType = 'Mentions';
            break;
        case 'FBDirectMessage':
            formatedType = 'Messenger';
            break;
        case 'INMessages':
            formatedType = 'Direct Messages';
            break;
        case 'INComments':
            formatedType = 'Comment';
            break;
        case 'INMentions':
            formatedType = 'Mentions';
            break;
        case 'LNCompanyUpdates':
            formatedType = 'Comment';
            break;
        case 'LNLikesComments':
            formatedType = 'Comment';
            break;
        case 'YelpReviews':
            formatedType = 'Review';
            break;
        case 'GMBQuestions':
            formatedType = 'Q & A';
            break;
        case 'GMBReviews':
            formatedType = 'Review';
            break;
    }
    return formatedType;
}
function getTimeStamp(str) {
    //maps months to integer from 0 to 11
    var monthArray = { "Jan": 0, "Feb": 1, "Mar": 2, "Apr": 3, "May": 4, "Jun": 5, "Jul": 6, "Aug": 7, "Sep": 8, "Oct": 9, "Nov": 10, "Dec": 11 };
    //get the values from the string
    var regex = /^[^ ]+ ([^ ]+) (\d{1,2}) (\d{2}):(\d{2}):(\d{2}) \+(\d{4}) (\d{4})$/;
    var match = regex.exec(str);
    var month, date, hours, minutes, seconds, ms, year;
    if (match) {
        month = monthArray[match[1]],
            date = match[2],
            hours = match[3],
            minutes = match[4],
            seconds = match[5],
            ms = match[6],
            year = match[7];
    }
    else {
        regex = /(\d{4})\-(\d{1,2})\-(\d{1,2})T(\d{2}):(\d{2}):(\d{2})\+(\d{4})$/;
        match = regex.exec(str);
        if (!match)
            return str;
        month = Number(match[2]) - 1,
            date = match[3],
            hours = match[4],
            minutes = match[5],
            seconds = match[6],
            ms = match[7],
            year = match[1];
    }
    //create date object with values
    var dateObject = new Date(year, month, date, hours, minutes, seconds, ms);
    var d = new Date();
    return (dateObject.getTime() / 1000) - (d.getTimezoneOffset() * 60);
}
function removeRolesAndTagsFromHtml(htmlString) {
    if (htmlString === void 0) { htmlString = ''; }
    var $div = __WEBPACK_IMPORTED_MODULE_1_jquery__('<div>', { html: htmlString });
    $div.find('span.badge').remove();
    console.log('33333', $div.html());
    return $div.html();
}
/**
 * convertToHTML
 * It return HTML decoded text
 */
function convertToHTML(str) {
    var div = document.createElement('div');
    div.innerHTML = str;
    return div.innerText;
}
//# sourceMappingURL=feed-helper.js.map

/***/ }),

/***/ 31:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TimelineFeedItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__ = __webpack_require__(61);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__ = __webpack_require__(30);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
//CLASSES


var TimelineFeedItem = /** @class */ (function (_super) {
    __extends(TimelineFeedItem, _super);
    function TimelineFeedItem(http, data, feed) {
        var _this = _super.call(this, http, data, feed) || this;
        _this.header = null;
        _this.summary = {};
        _this.actionButtons = {};
        //prepare data
        _this.prepareData();
        return _this;
    }
    /**
     * prepareData
     */
    TimelineFeedItem.prototype.prepareData = function () {
        this.header = {
            profile: this.profile,
            eventType: this.feed.stream.name,
            eventDate: this.data.eventTime,
        };
        if (this.feed.id === 'cinbox' || this.feed.id === 'inBox') {
            this.header.eventType = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["j" /* formatEventType */](this.data.eventType, this.data);
            if (this.data.tags) {
                this.header.eventTags = {
                    selectedTagsArray: this.data.tags,
                    hasTags: Boolean(this.data.tags.length)
                };
            }
            if (Array.isArray(this.data.roles) && this.data.roles.length > 0) {
                this.header.assignedRoles = {
                    selectedRoles: this.getAssignedRoles(),
                    hasRoles: false
                };
            }
        }
        this.summary.messageView = {
            sender: {
                senderName: this.getSenderName(),
                twittterHandle: this.getTwitterHandle(),
                createdDate: this.getCreatedDate(),
                senderProfileImage: this.getProfilePic(),
                senderProfileURL: ''
            },
            messageText: this.getMessageText(),
            tags: this.getAssignedTagsAndRoles(),
            reviewReply: this.getReviewReply()
        };
        //Prepare Media
        var media = this.getMedia();
        if (media.mediaUrl != '') {
            this.summary.messageView.media = media;
        }
        //Prepare actionHeaders
        this.actionHeader = {};
        this.getActionHeaders();
        //prepare Action Buttons
        this.actionButtons = {};
        switch (this.feed.profile.display.network.backend_network_name.toLowerCase()) {
            case 'facebook':
                this.getFBActionButtons();
                break;
            case 'twitter':
                this.getTWActionButtons();
                break;
            case 'linkedin':
                this.getLNActionButtons();
                break;
            case 'youtube':
                this.getYTActionButtons();
                break;
            case 'googleplus':
                this.getGPActionButtons();
                break;
            case 'googlemybusiness':
                this.getGMBActionButtons();
                break;
            case 'pinterest':
                this.getPNActionButtons();
                break;
            case 'blogger':
                this.getBloggerActionButtons();
                break;
            case 'yelp':
                this.getYelpActionButtons();
                break;
            default:
                break;
        }
        // update action buttons
        if (this.feed.network === 'cinbox') {
            this.actionButtons.completeItem = { highlighted: false };
            if (this.data.ecCompleted === 'true') {
                this.actionButtons.completeItem.highlighted = true;
            }
            if (this.data.ecReply == 'true' && this.actionButtons.reply) {
                this.actionButtons.reply.highlighted = true;
            }
            if (this.data.ecDM == 'true') {
                this.actionButtons.directMessage = { highlighted: true };
            }
            if (this.data.eventType == 'TWRetweets' || this.data.eventType == 'TWRetweetsWithComments') {
                if ((this.data.favorites && this.data.favorites.by_me === 'true') || this.data.ecFavorite === 'true') {
                    if (this.actionButtons.twLike) {
                        this.actionButtons.twLike.highlighted = true;
                    }
                }
                if ((this.data.retweets && this.data.retweets.by_me === 'true') || this.data.ecRetweet === 'true') {
                    if (this.actionButtons.retweet) {
                        this.actionButtons.retweet.highlighted = true;
                    }
                }
            }
        }
    };
    /* get profile picture*/
    TimelineFeedItem.prototype.getProfilePic = function () {
        return this.data.profilePic || this.data.icon;
    };
    TimelineFeedItem.prototype.getSenderName = function () {
        return (typeof this.data.fromName != 'undefined') ? this.data.fromName : '';
    };
    TimelineFeedItem.prototype.getCreatedDate = function () {
        var createdDate = 0;
        if (!isNaN(this.data.updateTime)) {
            var tempTime = parseInt(this.data.updateTime);
            createdDate = tempTime * 1000;
        }
        return createdDate;
    };
    TimelineFeedItem.prototype.getTwitterHandle = function () {
        var handle = '';
        if (isNaN(this.data.updateTime)) {
            if (this.feed.network != 'facebook'
                || (this.feed.id != 'search' && this.feed.id != 'outreach')
                || (this.feed.options.parameters != undefined && this.feed.options.parameters.type == undefined)) {
                handle = (this.data.username) ? '@' + this.data.username : '';
            }
            else if (this.feed.options.parameters.type == 'page' || this.feed.options.parameters.type == 'place') {
                handle = this.data.category;
            }
        }
        else {
            if (this.data.eventType == 'TWFollowers') {
                handle = (this.data.username) ? '@' + this.data.username : '';
            }
        }
        console.log("handle", handle);
        return handle;
    };
    TimelineFeedItem.prototype.getMessageText = function () {
        var messageText = '';
        if (typeof this.data.message !== 'string') {
            this.data.message = '';
        }
        if (this.network == 'rss') {
            //Todo
        }
        else if (this.network === 'googleplus') {
            /* GooglePlus */
            messageText = this.data.message;
            messageText = (typeof messageText === 'string') ? this.convertToHTML(messageText) : '';
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
            if (this.feed.id === 'cinbox') {
                messageText = 'You have a comment here';
                if (this.data.comments != undefined && this.data.comments.comment != undefined) {
                    if (!Array.isArray(this.data.comments.comment)) {
                        this.data.comments.comment = [this.data.comments.comment];
                    }
                    if (this.data.comments.comment.length > 0) {
                        messageText = '<span class="comment-subtitle">' + __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["v" /* replace_type_in_username */](this.profile.display.profile_name) + '\'s Post:</span> ';
                        messageText += this.data.message;
                        messageText += '<br><br><span class="comment-subtitle">' + this.data.fromName + '\'s Comment:</span> ';
                        messageText += this.data.comments.comment[0].message;
                    }
                }
            }
        }
        else if (this.feed.id == 'fb_notifications'
            || ['FBComments', 'FBShares', 'FBOthers', 'FBLikes', 'FBReviews', 'FBAdsComments'].indexOf(this.data.eventType) !== -1) {
            /* Facebook INBOX and notifications feed */
            messageText = this.data.message;
            messageText = this.convertToHTML(messageText);
            //For comments type, prepare messageText from postMessage and it's last comment
            if (this.data.eventType === 'FBComments'
                || this.data.eventType === 'FBAdsComments'
                || this.data.eventTitle === 'Review Comment') {
                //postMessage
                var post_message = (typeof this.data.name === 'string' ? this.data.name : '');
                if (this.data.eventType === 'FBAdsComments' || this.data.eventTitle === 'Review Comment') {
                    post_message = (typeof this.data.objectMessage === 'string' ? this.data.objectMessage : '');
                }
                if (post_message.length > 150)
                    post_message = post_message.slice(0, 150) + '...';
                //last comment
                var last_comment = { message: '' };
                if ((this.data.eventType === 'FBComments' && this.data.comments && this.data.comments.comment)
                    || this.data.eventType === 'FBAdsComments' || this.data.eventTitle === 'Review Comment' || this.data.eventType === 'FBReviews') {
                    if (this.data.eventType === 'FBAdsComments' || this.data.eventTitle === 'Review Comment' || this.data.eventType === 'FBReviews') {
                        last_comment = this.data;
                    }
                    else {
                        if (this.data.comments.comment.length) {
                            var this_id = this.data.fromId;
                            var this_id_comments = [];
                            for (var i = this.data.comments.comment.length; i--;) {
                                if (this.data.comments.comment[i].fromId === this_id) {
                                    this_id_comments.push(this.data.comments.comment[i]);
                                }
                            }
                            this_id_comments.sort(function (a, b) {
                                return a.createdTime - b.createdTime;
                            });
                            if (this_id_comments.length)
                                last_comment = this_id_comments[this_id_comments.length - 1];
                            else
                                last_comment = { message: this.data.message };
                        }
                        else
                            last_comment = this.data.comments.comment;
                    }
                    post_message = this.convertToHTML(post_message);
                    post_message = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](post_message);
                    post_message = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["n" /* hashtag_to_link */](post_message, 'facebook');
                    last_comment.message = this.convertToHTML(last_comment.message);
                    last_comment.message = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](last_comment.message);
                    last_comment.message = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["n" /* hashtag_to_link */](last_comment.message, 'facebook');
                    var post_user = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["v" /* replace_type_in_username */](this.profile.display.profile_name) + '\'s Post:';
                    if (this.data.eventTitle === 'Review Comment' && typeof this.data.objectFromName === 'string')
                        post_user = this.data.objectFromName + '\'s Review:';
                    // messageText = '<span class="comment-subtitle">' + post_user + '</span> ' + post_message
                    //     + '<br><br><span class="comment-subtitle">' + this.data.fromName + '\'s Comment:</span> ' + last_comment.message;
                    if (last_comment.message.length > 200)
                        messageText = last_comment.message.slice(0, 200) + '...';
                    else
                        messageText = last_comment.message;
                    // prepare media
                    var media = {
                        isImage: true,
                        isAnimated: false,
                        alt: '',
                        mediaUrl: '',
                        gallery: []
                    };
                    // this.summary.messageView.media = this.prepareFBMedia(this.data, media);
                    this.data.last_comment = last_comment;
                }
                else {
                    messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
                    messageText = this.replaceFBMentions(messageText);
                }
            }
            else if (this.feed.id == 'fb_notifications') {
                messageText = this.replaceFBMentions(messageText);
            }
        }
        else if (this.feed.network == 'blogger') {
            /** Blogger */
            var title = '';
            if (this.data.name != undefined) {
                title = '<a href="javascript;" onclick="EC.UI.open(\'' + this.data.permalink + '\');" class="title" >' + (this.data.name || '') + '</a>';
            }
            messageText = title + (this.data.message || '');
        }
        else if (this.feed.network == 'twitter' || this.data.eventNetwork == 'twitter') {
            /** Twitter */
            //Replace Urls from messageText
            if (this.data.raw_data.retweeted_status == undefined
                && this.data.raw_data.quoted_tweet != undefined
                && this.data.raw_data.quoted_tweet.streamEntry != undefined
                && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.raw_data.quoted_tweet.streamEntry)) {
                //Find first url and replce it from messageText 
                if (this.data.raw_data.entities.urls != undefined
                    && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.raw_data.entities.urls)) {
                    var urls = this.data.raw_data.entities.urls, first_url = void 0;
                    if (Array.isArray(urls))
                        first_url = urls[0].url;
                    else
                        first_url = urls.url;
                    messageText = this.data.message.replace(first_url, '');
                }
                messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
            }
            else {
                messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["w" /* tw_deep_link_to_html */](this.data.message, this.data.raw_data);
                //Replce all urls from messageText
                if (this.data.raw_data.entities
                    && this.data.raw_data.entities.urls != undefined
                    && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.raw_data.entities.urls)) {
                    var urls = this.data.raw_data.entities.urls;
                    __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["i" /* for_each */](urls, function (url) {
                        if (url.url && url.expanded_url && url.display_url) {
                            messageText = messageText.replace(url.url, '<a href="' + url.expanded_url + '" target="_blank">' + url.display_url + '</a>');
                        }
                    });
                }
                else
                    messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
            }
            if (this.data.raw_data.description
                && (this.feed.id == 'twFriends' || this.feed.id == 'twFollowers' || this.data.eventType === 'TWFollowers'
                    || ((this.feed.id === 'search' || this.feed.id === 'outreach') && this.feed.options.parameters.type === 'users'))) {
                messageText = this.convertToHTML(this.data.raw_data.description);
                messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
                messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["q" /* mention_to_link */](messageText, 'twitter');
                var from_name = this.convertToHTML(this.data.fromName);
                if (this.data.eventType === 'TWFollowers')
                    messageText += '<br/><span class="view-follower">View ' + from_name + ' profile</span>';
            }
        }
        else {
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["f" /* decodeHTMLEntities */](this.data.message);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
        }
        if (this.feed.network == 'rss' && typeof messageText == 'string') {
            messageText = messageText
                .replace(/width=/gi, 'data-w=')
                .replace(/height=/gi, 'data-h=')
                .replace(/margin/gi, 'data-m')
                .replace(/<br\s*[\/]?>/gi, '<span></span>');
        }
        else if (this.feed.network == 'twitter' || this.data.eventNetwork == 'twitter') {
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["x" /* tw_user_mentions_to_links */](messageText, this.data.raw_data);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["n" /* hashtag_to_link */](messageText, 'twitter');
        }
        else if (this.feed.network == 'linkedin') {
            messageText = this.data.title + this.data.pre_summary + messageText;
        }
        else if ((this.feed.network == 'facebook' || ['FBWallPosts', 'FBMentions'].indexOf(this.data.eventType) !== -1) && this.feed.id != 'fb_notifications') {
            messageText = this.convertToHTML(this.data.message);
            var story_html = void 0;
            if (this.data.story != undefined && this.data.story.length > 0) {
                // if ( this.data.story.indexOf('You added ') == -1 )
                if (this.data.story.indexOf('new photos') == -1) {
                    story_html = this.convertToHTML(this.data.story);
                    if (this.data.storyTags != undefined && this.data.storyTags.storyTag != undefined) {
                        story_html = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["g" /* fb_tags_to_links */](story_html, this.data.storyTags.storyTag, 'story');
                    }
                    else {
                        story_html = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](story_html);
                    }
                }
            }
            if (this.data.messageTags != undefined && this.data.messageTags.messageTag != undefined) {
                messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["g" /* fb_tags_to_links */](messageText, this.data.messageTags.messageTag, 'message');
            }
            else {
                messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
            }
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["n" /* hashtag_to_link */](messageText, 'facebook');
            if (story_html != undefined) {
                if (messageText.length > 0)
                    story_html = '<p>' + story_html + '</p>';
                messageText = story_html + messageText;
            }
        }
        if (this.feed.network !== 'rss')
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["b" /* amp_encode */](messageText);
        messageText = messageText.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
        // Todo
        if (this.feed.network == 'twitter' || this.data.eventNetwork == 'twitter') {
            // tw_deep_link_action( $this.find('.item-text'), $this.find('.item-functions .btn.direct-message'));
        }
        // console.log('messageText', messageText);
        return messageText;
    };
    TimelineFeedItem.prototype.getMedia = function () {
        var media = {
            isImage: true,
            isAnimated: false,
            alt: '',
            mediaUrl: '',
            gallery: [],
            byChannel: {},
            metaInfo: {}
        };
        // if media prepared in getMessageText, take it
        if (this.summary.messageView.media) {
            media = this.summary.messageView.media;
        }
        var preview = '';
        if (Array.isArray(this.data.media)) {
            //Multiple images
            if (this.data.media.length) {
                media.isImage = true;
                var images = [];
                for (var i in this.data.media) {
                    var currentImage = this.data.media[i];
                    media.gallery.push(this.prepareGalleyImage(currentImage.src));
                }
                if (this.profile.display.network.backend_network_name.toLowerCase() == 'facebook') {
                    media.gallery.reverse();
                }
                //Media URL
                if (media.gallery.length) {
                    media.mediaUrl = media.gallery[0].url.full;
                }
            }
        }
        else if (typeof this.data.media == 'object' && this.data.media.type != 'unavailable') {
            if (this.feed.network === 'facebook' && typeof this.data.picture === 'string' && this.data.media.type !== 'video') {
                //Media URL
                media.mediaUrl = this.data.picture;
            }
            if (this.data.media.type == "photo") {
                var mediaUrl = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["a" /* FB_thumbnail_to_full_size */](this.data.media.src);
                //Media Preview
                if (this.data.mediaDescription != undefined && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.mediaDescription))
                    preview = this.data.mediaDescription;
                else if (this.data.caption != undefined)
                    preview = this.data.caption;
                else if (typeof this.data.media.alt === 'string') {
                    //this.data.media.alt = $('<div>').html(this.data.media.alt).text();
                    if (this.data.media.alt !== this.data.message)
                        preview = this.data.media.alt;
                }
                if (this.feed.network != 'pinterest')
                    preview = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["t" /* replaceURLWithHTMLLinks */](preview);
                //GooglePlus
                if (this.feed.network == 'googleplus' || this.data.eventNetwork == 'googleplus') {
                    if (this.data.media != undefined) {
                        var gp_img = void 0;
                        if (this.data.media.fullImage != undefined && this.data.media.fullImage.url != undefined) {
                            gp_img = this.data.media.fullImage.url;
                        }
                        else if (this.data.media.image != undefined && this.data.media.image.url != undefined) {
                            gp_img = this.data.media.image.url;
                        }
                        if (this.data.media.content != undefined && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.media.content)) {
                            preview = this.data.media.content;
                        }
                        if (typeof gp_img === 'string' && gp_img.indexOf('https:') !== -1) {
                            //Media URL
                            media.mediaUrl = gp_img;
                        }
                    }
                }
                else {
                    //Media URL
                    media.mediaUrl = mediaUrl;
                }
                //Media Link
                if (this.feed.network == 'youtube') {
                    media.mediaOriginalPageContent = this.data.channelTitle || '';
                    media.mediaOriginalPageUrl = this.data.channelLink;
                }
                else if (this.feed.network == 'pinterest'
                    && this.data.link
                // && this.data.raw_data.metadata.link
                // && this.data.raw_data.metadata.link.title
                ) {
                    // media.mediaOriginalPageContent = this.data.raw_data.metadata.link.title || '';
                    media.mediaOriginalPageContent = this.data.title || '';
                    media.mediaOriginalPageUrl = this.data.link;
                }
                //Media Preview
                if (preview != '') {
                    media.mediaOriginalPagePreview = preview;
                }
            }
            else if (this.data.media.type == "video" || (this.feed.network === 'facebook' && this.data.media.video != null && this.data.media.type === 'share')) {
                if (this.data.mediaDescription == undefined) {
                    if (this.data.caption == undefined) {
                        preview = (this.data.media.alt == this.data.message) ? '' : this.data.media.alt;
                    }
                    else {
                        preview = this.data.caption;
                    }
                }
                else {
                    preview = this.data.mediaDescription;
                }
                preview = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["t" /* replaceURLWithHTMLLinks */](preview);
                //Media Preview
                if (preview != '') {
                    media.mediaOriginalPagePreview = preview;
                }
                if (this.feed.network == 'youtube') {
                    media.mediaOriginalPageUrl = '';
                    media.mediaOriginalPageContent = this.data.media.title;
                    if (this.data.channelId != this.data.fromId) {
                        media.metaInfo.channelLink = this.data.channelLink;
                        media.metaInfo.channelTitle = this.data.channelTitle;
                    }
                    media.metaInfo.uploadDate = (this.data.media.uploadDate) ? new Date(this.data.media.uploadDate) : '';
                    media.metaInfo.viewCount = (this.data.views.count) ? this.data.views.count : '';
                }
                else if (this.feed.network == 'googleplus' || this.data.eventNetwork == 'googleplus') {
                    if (this.data.media.content != undefined && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.media.content)) {
                        preview = this.data.media.content;
                    }
                    media.mediaOriginalPageUrl = '';
                    media.mediaOriginalPageContent = this.data.media.displayName || 'Watch video';
                }
                if (this.data.media != undefined && this.data.media.video != undefined) {
                    //Media URL
                    media.mediaUrl = this.data.media.src.replace('Fdefault', 'Fhqdefault').replace('/default', '/hqdefault');
                    media.videoUrl = this.data.media.video.source_url;
                    media.isImage = false;
                    if (media.mediaOriginalPageUrl === '') {
                        media.mediaOriginalPageUrl = media.videoUrl;
                    }
                }
                if (this.data.eventNetwork === 'facebook') {
                    //ToDo On image click, open show more
                }
            }
            else if (this.data.media.type == "article" && (this.feed.network == 'googleplus' || this.data.eventNetwork == 'googleplus')) {
                var mediaURL = void 0;
                if (this.data.media.fullImage != undefined && this.data.media.fullImage.url != undefined) {
                    mediaURL = this.data.media.fullImage.url;
                }
                else if (this.data.media.image != undefined && this.data.media.image.url != undefined) {
                    mediaURL = this.data.media.image.url;
                }
                if (typeof mediaURL === 'string' && mediaURL.indexOf('https:') !== -1) {
                    //Media URL
                    media.mediaUrl = mediaURL;
                    //Media Link
                    media.mediaOriginalPageContent = this.data.media.displayName || '';
                    media.mediaOriginalPageUrl = this.data.media.url;
                    //Media Preview
                    if (this.data.media.content != undefined && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.media.content)) {
                        media.mediaOriginalPagePreview = this.data.media.content;
                    }
                }
            }
            else if (this.data.media.type === 'animated_image_share' && this.feed.network === 'facebook') {
                //Media URL
                media.mediaUrl = this.data.link;
            }
            else {
                if (this.data.mediaDescription == undefined) {
                    if (this.data.caption == undefined) {
                        preview = (this.data.media.alt != this.data.message) ? '' : this.data.media.alt;
                    }
                    else {
                        preview = this.data.caption;
                    }
                }
                else {
                    preview = this.data.mediaDescription;
                }
                if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.media.src)) {
                    if (this.feed.network == 'googleplus' || this.data.eventNetwork == 'googleplus') {
                        if (this.data.media != undefined) {
                            var gp_img = void 0;
                            if (this.data.media.fullImage != undefined && this.data.media.fullImage.url != undefined) {
                                gp_img = this.data.media.fullImage.url;
                            }
                            else if (this.data.media.image != undefined && this.data.media.image.url != undefined) {
                                gp_img = this.data.media.image.url;
                            }
                            if (this.data.media.content != undefined && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.media.content)) {
                                preview = this.data.media.content;
                            }
                            if (typeof gp_img === 'string' && gp_img.indexOf('https:') !== -1) {
                                media.mediaUrl = gp_img;
                            }
                        }
                    }
                    else {
                        media.mediaOriginalPageUrl = this.data.media.href;
                    }
                }
                else {
                    //Media Link
                    media.mediaOriginalPageContent = this.data.name || '';
                    media.mediaOriginalPageUrl = this.data.media.href;
                    media.mediaUrl = this.data.media.src;
                }
                //Media Preview
                if (preview != '') {
                    media.mediaOriginalPagePreview = preview;
                }
            }
            if (media.mediaUrl !== '') {
                media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
            }
        }
        else if (this.data.raw_data != undefined && this.data.raw_data.entities != undefined) {
            if (this.data.raw_data.retweeted_status == undefined
                && this.data.raw_data.quoted_tweet != undefined
                && this.data.raw_data.quoted_tweet.streamEntry != undefined
                && !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.raw_data.quoted_tweet.streamEntry)) {
                //Todo
                var quoted_tweet = this.data.raw_data.quoted_tweet.streamEntry;
                var first_url = '';
                if (this.data.raw_data.entities.urls != undefined) {
                    var urls = this.data.raw_data.entities.urls;
                    if (Array.isArray(urls))
                        first_url = urls[0].url;
                    else
                        first_url = urls.url;
                }
                this.summary.messageView.retweetData = {
                    name: quoted_tweet.user.name,
                    screenName: '@' + quoted_tweet.user.screen_name,
                    content: ''
                };
                // retweet content
                var message_htm = quoted_tweet.text.replace(/“/g, '').replace(/”/g, '');
                message_htm = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](message_htm);
                message_htm = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["n" /* hashtag_to_link */](message_htm, 'twitter');
                var regex = /(^|[^@\w])@(\w{1,15})\b/g, replace = '$1<a class="tw-user" href="https://twitter.com/$2" target="_blank" data-user="@$2">@$2</a>';
                message_htm = message_htm.replace(regex, replace);
                this.summary.messageView.retweetData.content = message_htm.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
                if (quoted_tweet.entities != undefined
                    && quoted_tweet.entities.media != undefined
                    && typeof quoted_tweet.entities.media.media_url === 'string'
                    && quoted_tweet.entities.media.media_url.indexOf('https:') !== -1) {
                    this.summary.messageView.retweetData.media = {
                        isImage: true,
                        alt: '',
                        mediaUrl: quoted_tweet.entities.media.media_url
                    };
                }
            }
            else if (this.data.raw_data.entities.media != undefined) {
                media = this.prepareTwitterMedia(this.data.raw_data, media);
            }
            else {
                if (this.data.raw_data.preview_content) {
                    var preview_content = JSON.parse(this.data.raw_data.preview_content);
                    //Media URL
                    //media.mediaUrl = this.data.link;
                    //Media Link
                    if (preview_content.title != '') {
                        media.mediaOriginalPageContent = preview_content.title;
                        media.mediaOriginalPageUrl = preview_content.url;
                    }
                    //Media Preview
                    if (typeof this.data.raw_data.picture_text === 'string') {
                        media.mediaOriginalPagePreview = this.data.raw_data.picture_text;
                    }
                }
            }
            if (media.mediaUrl !== '') {
                media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
            }
        }
        // else if (this.data.eventType === "FBMentions" && this.data.link) {
        //     media.mediaUrl = this.data.link;
        //     media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
        // }
        return media;
    };
    TimelineFeedItem.prototype.getActionHeaders = function () {
        if (this.feed.network == 'facebook') {
            //Likes
            if (this.feed && this.feed.id === 'search') {
            }
            else if (this.data.likes == undefined) {
                this.actionHeader.likes = { count: 0 };
            }
            else {
                this.actionHeader.likes = { count: this.data.likes.count };
                if (this.actionHeader.likes.count)
                    this.actionHeader.likes.highlighted = true;
            }
            //Comments
            if (this.data.comments == undefined) {
                this.actionHeader.comments = { count: 0 };
            }
            else {
                this.actionHeader.comments = { count: this.data.comments.count };
                if (this.actionHeader.comments.count)
                    this.actionHeader.comments.highlighted = true;
            }
            // Todo
            // if( ! $.isEmptyObject(self.data.comments) && self.feed.id == 'cinbox' ) 
            // {
            //     $vc = $('<div>', { class: 'item-comments' });
            //     $vc.html('View Latest Conversation');
            //     $this.find('.item-footer').html($vc);
            // }
            if (this.data.sharedCound != undefined || (this.data.reactions && this.data.reactions.count)) {
                this.fbShare();
            }
            if ((this.data.isActivity != undefined && this.data.isActivity == 'true')
                || ((this.feed.id == 'search' || this.feed.id == 'outreach') && this.feed.options.parameters.type == 'user') || this.feed.id == 'fb_notifications') {
                //remove likes
                this.actionHeader = this.removeKeys(this.actionHeader, ['likes']);
            }
            else if ((this.feed.id == 'search' || this.feed.id == 'outreach')
                && (this.feed.options.parameters.type == 'page' || this.feed.options.parameters.type == 'place')) {
                //remove likes & comments
                this.actionHeader = this.removeKeys(this.actionHeader, ['likes', 'comments']);
                //Likes
                if (typeof this.data.likes !== 'string')
                    this.data.likes = { count: 0 };
                this.actionHeader.likes = { count: this.data.likes };
                if (this.actionHeader.likes)
                    this.actionHeader.likes.highlighted = true;
            }
        }
        else if (this.feed.network == 'twitter') {
            // retweets
            if (this.data.retweets.count != undefined) {
                this.actionHeader.retweets = { count: this.data.retweets.count };
                if (this.data.retweets.count > 0)
                    this.actionHeader.retweets.highlighted = true;
            }
            // favorites (likes)
            if (this.data.favorites.count != undefined) {
                this.actionHeader.likes = { count: this.data.favorites.count };
                if (this.data.favorites.count > 0)
                    this.actionHeader.likes.highlighted = true;
            }
        }
        else if (this.feed.network == 'linkedin') {
            // Todo
        }
        else if (this.feed.network == 'youtube' || this.data.eventNetwork === 'youtube' || this.feed.network === 'blogger') {
            //likes/dislikes
            if (this.feed.network == 'youtube' && this.data.likes) {
                this.actionHeader.likes = { count: this.data.likes.count };
                this.actionHeader.disLikes = { count: this.data.likes.dislikes };
                if (this.actionHeader.likes.count > 0)
                    this.actionHeader.likes.highlighted = true;
                if (this.actionHeader.disLikes.count > 0)
                    this.actionHeader.disLikes.highlighted = true;
            }
            if (this.feed.network === 'youtube' || this.feed.network === 'blogger') {
                if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.comments)) {
                    this.actionHeader.comments = { count: 0 };
                }
                else {
                    this.actionHeader.comments = { count: this.data.comments.count };
                    if (this.actionHeader.comments.count > 0)
                        this.actionHeader.comments.highlighted = true;
                }
            }
            if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.likes) && __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.comments)) {
                this.actionHeader = {};
            }
        }
        else if (this.feed.network == 'googleplus' || this.data.eventNetwork == 'googleplus') {
            //Likes
            if (this.data.likes == undefined)
                this.actionHeader.likes = { count: 0, highlighted: false };
            else {
                this.actionHeader.likes = { count: this.data.likes.count };
                if (this.actionHeader.likes.count > 0) {
                    this.actionHeader.likes.highlighted = true;
                }
                ;
            }
            //Comments
            if (__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.comments))
                this.actionHeader.comments = { count: 0, highlighted: false };
            else {
                this.actionHeader.comments = { count: this.data.comments.count };
                if (this.actionHeader.comments.count > 0)
                    this.actionHeader.comments.highlighted = true;
            }
            // Todo
            // if( ! $.isEmptyObject(self.data.comments) && this.feed.id == 'cinbox' ) 
            // {
            //     $vc = $('<div>', { class: 'item-comments' });
            //     $vc.html('View Post & Comments');
            //     $this.find('.item-footer').html($vc);
            //     $this.find('.item-likes-comments').css('display', 'none');
            // }
            //resharers
            if (this.data.resharers != undefined && this.data.resharers.count != '0') {
                this.actionHeader.shares = { count: this.data.resharers.count };
                if (this.actionHeader.shares.count)
                    this.actionHeader.shares.highlighted = true;
            }
        }
        else if (this.feed.network == 'pinterest') {
            //repins
            if (this.data.repins != '') {
                this.actionHeader.repins = { count: this.data.repins };
                if (this.actionHeader.repins.count)
                    this.actionHeader.repins.highlighted = true;
            }
            else {
                this.actionHeader.repins = { count: 0 };
            }
            //comments
            // if (this.data.comments && this.data.comments.count != 0) {
            //     this.actionHeader.comments = { count: this.data.comments.count };
            //     if (this.actionHeader.comments.count) this.actionHeader.comments.highlighted = true;
            // }
            // else {
            //     this.actionHeader.comments = { count: 0 };
            // }
        }
        else if (this.feed.id == 'cinbox') {
            if (['FBComments', 'FBShares', 'FBOthers', 'FBLikes', 'FBWallPosts', 'FBAdsComments', 'FBMentions', 'TWRetweets', 'TWRetweetsWithComments', 'YelpReviews'].indexOf(this.data.eventType) !== -1
                || this.data.eventTitle === 'Review Comment') {
                this.data.likes = null;
            }
            else if (this.data.eventType === 'FBReviews' && this.data.sharedCound !== undefined) {
                this.fbShare();
            }
        }
        if (this.feed.id === 'gmbReviews' || this.data.eventType === 'GMBReviews') {
            this.fbShare();
        }
        if (this.feed.id === 'gmbQuestions' || this.data.eventType === 'GMBQuestions') {
            if (this.feed.id === 'gmbQuestions' && this.data.rootEvent == null) {
                if (this.data.totalAnswerCount && this.data.totalAnswerCount != 0) {
                    this.actionHeader.answers = { count: this.data.totalAnswerCount };
                    if (this.actionHeader.answers.count)
                        this.actionHeader.answers.highlighted = true;
                }
                else {
                    this.actionHeader.answers = { count: 0 };
                }
            }
        }
    };
    TimelineFeedItem.prototype.getFBActionButtons = function () {
        if (this.data.eventType === 'FBComments' && this.data.comments && this.data.comments.comment) {
            if (this.data.last_comment && this.data.last_comment.can_hide !== 'true') {
                var hidden = 'false';
                if (typeof this.data.ecHidden === 'string') {
                    hidden = this.data.ecHidden;
                }
                else {
                    if (this.data.last_comment.is_hidden === 'true')
                        hidden = 'true';
                    this.data.ecHidden = hidden;
                }
                if (this.data.can_hide && this.data.can_hide !== 'false') {
                    this.actionButtons.fbHide = {
                        highlighted: false,
                        id: this.data.last_comment.messageId,
                        value: this.data.ecHidden === 'true' ? 'false' : 'true'
                    };
                }
            }
        }
        // if ((this.data.eventType === 'FBComments' && this.data.comments && this.data.comments.comment)
        //     || this.data.eventType === 'FBAdsComments' || this.data.eventTitle === 'Review Comment' || this.data.eventType === 'FBReviews') {
        if ((this.data.eventType === 'FBComments' && this.data.comments && this.data.comments.comment)
            || this.data.eventType === 'FBAdsComments'
            || this.data.eventTitle === 'Review Comment'
            || this.data.eventType === 'FBReviews') {
            this.actionButtons.fbPostLike = {
                highlighted: (this.data.ecLike === 'true') ? true : false,
                id: this.data.id,
                action: 'likeFBComment'
            };
            if (this.data.last_comment) {
                if (this.data.last_comment.messageId) {
                    this.actionButtons.fbPostLike.id = this.data.last_comment.messageId;
                    // if (this.data.last_comment.can_reply_privately === 'true') {
                    //     this.actionButtons.fbPrivateReply = {
                    //         highlighted: (this.data.ecPrivateReply === 'true'),
                    //         action: 'addFbPrivateReply',
                    //         id: this.data.last_comment.messageId
                    //     }
                    // }
                }
            }
        }
        if (this.data.eventTitle === 'Review') {
            //Comment
            this.actionButtons.comment = {
                highlighted: false,
                id: this.data.id
            };
        }
        if (this.data.type !== 'video' && ['wallPosts', 'timeline', 'fb_likes', 'hidden_groups'].indexOf(this.feed.id) !== -1
            || (this.feed.id === 'search' && this.feed.options.parameters.type === 'pageFeed')) {
            // Todo
            //Repost
        }
        //More Info
        if (this.data.link && (this.feed.id == 'fb_notifications' || this.data.eventType == 'FBComments' || this.data.eventType === 'FBAdsComments'
            || this.data.eventType == 'FBShares' || this.data.eventType == 'FBOthers' || this.data.eventType == 'FBLikes' || this.data.eventTitle === 'Review Comment')) {
            var mresult = this.getPostIdAndObjectType();
            var display_more = mresult.display_more, post_id = mresult.post_id, object_type = mresult.object_type;
            var link = this.data.link, comment_id = void 0;
            var exp = /(comment_id=\d*)/ig, m = exp.exec(link);
            //Reply
            if (m != null && this.data.type != 'Likes') {
                comment_id = m[0].replace('comment_id=', '');
                comment_id = this.data.object_id + '_' + comment_id;
            }
            if (this.data.eventType === 'FBAdsComments' || this.data.eventTitle === 'Review Comment') {
                comment_id = this.data.messageId;
            }
            if (this.data.source === 'fbwebhook') {
                comment_id = this.data.commentId;
                if (this.actionButtons.fbPostLike) {
                    this.actionButtons.fbPostLike.id = comment_id;
                }
                if (this.actionButtons.fbLike) {
                    this.actionButtons.fbLike.id = comment_id;
                }
            }
            if (comment_id && !this.data.parentId) {
                this.actionButtons.reply = {
                    highlighted: false,
                    id: comment_id,
                    text: ''
                };
            }
            console.log('this.data.source', this.data);
            if (display_more) {
                //this.actionButtons.buttons.showMore = {label: 'show more'};
                if ((this.data.eventType === 'FBComments' || this.data.eventType === 'FBAdsComments' || this.data.eventTitle === 'Review Comment') && this.feed.id === 'cinbox') {
                    if (this.data.eventTitle === 'Review Comment') {
                        //this.actionButtons.buttons.showMore.label = 'View Review & Comments';
                        this.actionButtons.showViewLatest = { label: 'View Review & Comments', pageTitle: 'Comments' };
                    }
                    else {
                        //this.actionButtons.buttons.showMore.label = 'View Post & Comments';
                        this.actionButtons.showViewLatest = { label: 'View Post & Comments', pageTitle: 'Comments' };
                    }
                    //permalink (showinfacebook)
                    if (this.data.eventTitle !== 'Review Comment' || typeof this.data.permalink === 'string') {
                        this.actionButtons.showInFacebook = true;
                    }
                }
                else {
                    if (this.data.eventType === 'FBLikes') {
                    }
                    else {
                        this.actionButtons.showViewLatest = { label: 'More info' };
                        if (this.feed.id === "fb_notifications") {
                            this.actionButtons.showViewLatest = { label: 'More info', pageTitle: 'Notification Details' };
                        }
                    }
                    this.actionButtons.showInFacebook = true;
                }
                if (this.actionButtons.showViewLatest) {
                    this.actionButtons.showViewLatest.id = post_id;
                    this.actionButtons.showViewLatest.type = object_type;
                }
            }
            else {
                //permalink (showinfacebook)
                this.actionButtons.showInFacebook = true;
            }
        }
        if ((['FBWallPosts', 'FBMentions'].indexOf(this.data.eventType) !== -1 && this.data.permalink)) {
            this.actionButtons.showInFacebook = true;
        }
        if ((this.feed.id != 'search'
            && this.feed.id != 'fb_notifications'
            && this.data.eventType != 'FBComments'
            && this.data.eventType !== 'FBAdsComments'
            && this.data.eventType != 'FBShares'
            && this.data.eventType != 'FBOthers'
            && this.data.eventType != 'FBLikes'
            && this.data.eventType != 'FBReviews'
            && this.feed.id != 'outreach') ||
            (this.feed.options.parameters
                && (this.feed.options.parameters.type == null || this.feed.options.parameters.type === 'pageFeed'))) {
            //remove all buttons
            // this.actionButtons = this.removeButtons();
            this.actionButtons.fbPostLike = { highlighted: false };
            this.actionButtons.comment = {
                highlighted: false,
                id: this.data.id,
                text: ''
            };
        }
        if (this.data.eventType === 'FBMentions' && (this.data.id && this.data.id.indexOf('notif_') === 0)) {
            if (this.actionButtons.fbLike)
                delete this.actionButtons.fbLike;
            if (this.actionButtons.fbPostLike)
                delete this.actionButtons.fbPostLike;
            if (this.actionButtons.comment)
                delete this.actionButtons.comment;
            if (this.data.link && this.data.permalink == null) {
                this.data.permalink = this.data.link;
                this.actionButtons.showInFacebook = true;
            }
        }
        if (this.data.can_delete == 'true' &&
            (this.feed.id == 'wallPosts' || this.feed.id == 'timeline')) {
            //delete
            this.actionButtons.delete = {
                action: 'deletePostItem',
                postID: this.data.id
            };
        }
        if ((this.data.eventTitle === 'Review' || this.feed.id === 'fb_reviews') && this.data.id) {
            if (this.actionButtons.fbLike)
                delete this.actionButtons.fbLike;
            if (this.actionButtons.fbPostLike)
                delete this.actionButtons.fbPostLike;
            this.actionButtons.showInFacebook = true;
        }
        //HIGHLIGHT Like
        if (this.data.user_likes && this.data.user_likes == 'true') {
            if (this.actionButtons.fbLike) {
                this.actionButtons.fbLike.highlighted = true;
            }
            if (this.actionButtons.fbPostLike) {
                this.actionButtons.fbPostLike.highlighted = true;
            }
        }
        if (this.data.ecLike === 'true') {
            if (this.actionButtons.fbPostLike) {
                this.actionButtons.fbPostLike.highlighted = true;
            }
            if (this.actionButtons.fbLike) {
                this.actionButtons.fbLike.highlighted = true;
            }
        }
        //showInFacebookURL
        if (this.actionButtons.showInFacebook) {
            this.data.showInFacebookURL = this.data.link;
            if (this.data.eventType && ['FBWallPosts', 'FBMentions'].indexOf(this.data.eventType) !== -1) {
                this.data.showInFacebookURL = this.data.permalink;
            }
            else if (this.data.eventType === 'FBReviews' || this.feed.id === 'fb_reviews') {
                this.data.showInFacebookURL = (this.data.permalink && typeof this.data.permalink === 'string') ? this.data.permalink : 'https://www.facebook.com/' + this.data.id;
            }
        }
        if (this.feed.id === 'cinbox') {
            if (this.actionButtons.comment && this.data.ecComment) {
                this.actionButtons.comment.highlighted = (this.data.ecComment === 'true');
            }
            if (this.actionButtons.reply && this.data.ecReply) {
                this.actionButtons.reply.highlighted = (this.data.ecReply === 'true');
            }
            if (this.actionButtons.fbPrivateReply && this.data.ecPrivateReply) {
                this.actionButtons.fbPrivateReply.highlighted = (this.data.ecPrivateReply === 'true');
            }
            if (this.actionButtons.fbLike && this.data.ecLike) {
                this.actionButtons.fbLike.highlighted = (this.data.ecLike === 'true');
            }
        }
        console.log('actions', this.actionButtons);
        // this.actionButtons.streamEntryData.viewLatestParams = {
        //     commentId: this.data.id
        // }
    };
    TimelineFeedItem.prototype.getTWActionButtons = function () {
        if (this.feed.id == 'twFollowers' || this.feed.id == 'twFriends' || this.data.eventType == 'TWFollowers'
            || ((this.feed.id == 'search' || this.feed.id == 'outreach') && this.feed.options.parameters.type == 'users')) {
            //REPLY
            this.actionButtons.reply = {
                highlighted: false,
                id: this.data.id ? this.data.id : this.data.postID,
                text: this.getInitialReplyText()
            };
            //Direct Message
            if (this.feed.options.user_id_for_request) { }
            else {
                this.actionButtons.directMessage = {
                    highlighted: false,
                    id: this.data.postID ? this.data.postID : '',
                    userID: (this.data.user != undefined ? this.data.user.id_str : this.data.postID)
                };
            }
            // Follow
            if (this.feed.account.user_id !== this.data.postID) {
                this.actionButtons.twFollow = { highlighted: false };
                if (this.data.eventType == 'TWFollowers') {
                    if (this.data.ecFollow == 'true') {
                        this.actionButtons.twFollow = { highlighted: true };
                    }
                }
                else {
                    if (this.data.raw_data.following == 'true') {
                        this.actionButtons.twFollow = { highlighted: true };
                    }
                }
            }
        }
        else if (this.feed.id == 'sendTweets') {
            this.actionButtons.reply = {
                highlighted: false,
                id: this.data.id,
                text: this.getInitialReplyText()
            };
            this.actionButtons.retweet = {
                highlighted: false,
                id: this.data.id,
                permalink: (this.data.raw_data && this.data.raw_data.permalink) ? this.data.raw_data.permalink : ''
            };
            this.actionButtons.twLike = { highlighted: false };
            this.actionButtons.delete = {
                action: 'TWSTDestroy',
                postID: this.data.postID,
            };
        }
        else if (this.feed.id == 'myTweetsRetweeted') {
            //REPLY
            this.actionButtons.reply = {
                highlighted: false,
                id: this.data.id,
                text: ''
            };
        }
        else {
            this.actionButtons.reply = {
                highlighted: false,
                id: this.data.id ? this.data.id : this.data.postID,
                text: this.getInitialReplyText()
            };
            this.actionButtons.retweet = {
                highlighted: false,
                id: this.data.id ? this.data.id : this.data.postID,
                permalink: (this.data.raw_data && this.data.raw_data.permalink) ? this.data.raw_data.permalink : ''
            };
            this.actionButtons.twLike = { highlighted: false };
            //Direct Message
            if (this.data.user.connections != undefined && this.data.user.connections.indexOf('followed_by') != -1) {
                this.actionButtons.directMessage = {
                    highlighted: false,
                    id: this.data.postID ? this.data.postID : '',
                    userID: (this.data.user != undefined ? this.data.user.id_str : this.data.postID)
                };
            }
            if (this.data.username == this.feed.profile.display.profile_name) {
                //REMOVE retweet and like
                this.actionButtons = this.removeButtons(['retweet', 'twLike']);
                //DELETE 
                this.actionButtons.delete = {
                    action: 'TWSTDestroy',
                    postID: this.data.postID,
                };
            }
            if (this.feed.id === 'search' || this.feed.id === 'twFavorites' || this.feed.id === 'homeFeed' || this.feed.id === 'lists') // add follow button
             {
                if (this.feed.account.user_id !== this.data.user.id_str) {
                    this.actionButtons.twFollow = { highlighted: false };
                    //Highlight follow
                    if (this.data.user.following === 'true') {
                        this.actionButtons.twFollow = { highlighted: true };
                    }
                }
            }
        }
        //HIGHLIGHT Like and ReTweet
        if ((this.data.favorites != undefined && this.data.favorites.by_me == 'true') || (this.data.ecFavorite && this.data.ecFavorite === 'true')) {
            this.actionButtons.twLike = { highlighted: true };
        }
        if ((this.data.retweets != undefined && this.data.retweets.by_me == 'true') || (this.data.ecRetweet && this.data.ecRetweet === 'true')) {
            this.actionButtons.retweet = { highlighted: true };
        }
        if (this.actionButtons.directMessage && this.data.ecDM) {
            this.actionButtons.directMessage.highlighted = (this.data.ecDM == 'true');
        }
        // if (this.data.raw_data && this.data.raw_data.permalink) {
        //     this.actionButtons.streamEntryData.URLLinkForRetweet = this.data.raw_data.permalink;
        // }
        // if (this.data && this.data.id) {
        //     this.actionButtons.streamEntryData.userId = this.data.id;
        // }
        // if (this.data && this.data.username) {
        //     this.actionButtons.streamEntryData.screenName = this.data.username;
        // }
    };
    TimelineFeedItem.prototype.getYTActionButtons = function () {
        if (this.feed.network === 'youtube') {
            //GENERIC Feeds
            if (this.data.media != undefined && this.data.media.type == 'video') {
                this.actionButtons.ytLike = { highlighted: false };
                this.actionButtons.ytDisLike = { highlighted: false };
                this.actionButtons.comment = {
                    highlighted: false,
                    id: this.data.media.id,
                    text: ''
                };
                //Highlight
                if (this.data.media.rating == 'like') {
                    this.actionButtons.ytLike.highlighted = true;
                }
                else if (this.data.media.rating == 'dislike') {
                    this.actionButtons.ytDisLike.highlighted = true;
                }
            }
        }
        else {
            //INBOX            
            this.actionButtons.reply = {
                highlighted: (this.data.ecReply === 'true'),
                id: this.data.parentId,
            }; //REPLY
            this.actionButtons.showViewLatest = { label: 'View All Comments', pageTitle: 'Comments' };
        }
    };
    TimelineFeedItem.prototype.getLNActionButtons = function () {
        this.actionButtons.lnLike = { highlighted: false };
        this.actionButtons.comments = true;
    };
    TimelineFeedItem.prototype.getGPActionButtons = function () {
        if (this.feed.network == 'googleplus' || this.data.eventNetwork == 'googleplus') {
            if (this.feed.id == 'gp_pages' || this.feed.id == 'gp_pages_only') {
                this.actionButtons.comment = {
                    highlighted: false,
                    id: this.data.postID
                };
                this.actionButtons.delete = {
                    action: 'deleteGPPost',
                    postID: this.data.postID
                };
                this.actionButtons.edit = {
                    action: 'updateGPPost',
                    id: this.data.postID
                };
            }
            else if (this.data.eventType == 'GPComments') {
                this.actionButtons.comment = {
                    highlighted: false,
                    id: this.data.postID
                };
            }
            if (!__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.comments) && this.feed.id == 'cinbox') {
                this.actionButtons.showViewLatest = {
                    label: 'View Post & Comments',
                    pageTitle: 'Comments'
                };
            }
        }
    };
    TimelineFeedItem.prototype.getGMBActionButtons = function () {
        if (this.feed.id === 'gmbReviews' || this.data.eventType === 'GMBReviews') {
            // Todo
            if (this.data.reviewReply) {
                this.actionButtons.edit = {
                    action: 'updateGMBReviewReply',
                    id: this.profile.original_config.userId + '/reviews/' + this.data.id,
                    label: 'Edit Reply'
                };
                this.actionButtons.delete = {
                    action: 'deleteGMBReviewReply',
                    postID: this.profile.original_config.userId + '/reviews/' + this.data.id,
                    label: 'Delete Reply'
                };
            }
            else {
                this.actionButtons.reply = {
                    highlighted: false,
                    action: 'updateGMBReviewReply',
                    id: this.profile.original_config.userId + '/reviews/' + this.data.id,
                    text: ''
                };
            }
        }
        else if (this.feed.id === 'gmbQuestions' || this.data.eventType === 'GMBQuestions') {
            console.log('getGMBActionButtons', this.data);
            console.log('getGMBActionButtons this.feed', this.feed);
            if (this.data.eventQuestion == null) // not inbox answer
             {
                if (this.data.ownerAnswer) {
                    console.log('this.profile actionButtons', this.data.id);
                    this.actionButtons.edit = {
                        action: 'upsertGMBAnswer',
                        id: this.data.id,
                        label: 'Edit Answer'
                    };
                    this.actionButtons.delete = {
                        action: 'deleteGMBAnswer',
                        postID: this.data.id,
                        label: 'Delete Answer'
                    };
                }
                else {
                    this.actionButtons.reply = {
                        highlighted: (this.data.ownerAnswer) ? true : false,
                        action: 'upsertGMBAnswer',
                        id: this.data.id,
                        text: ''
                    };
                    if (this.feed.id === 'cinbox') {
                        this.actionButtons.showViewLatest = { label: 'View Answers', pageTitle: 'Question' };
                    }
                }
            }
        }
    };
    TimelineFeedItem.prototype.getYelpActionButtons = function () {
        if (this.feed.network == 'yelp' || this.data.eventType === 'YelpReviews') {
            this.actionButtons.showInYelp = true;
            if (this.data.rating) {
                this.actionHeader.stars = {
                    highlighted: false,
                    count: parseInt(this.data.rating)
                };
            }
        }
    };
    TimelineFeedItem.prototype.getPNActionButtons = function () {
        // if (this.feed.network == 'pinterest') {
        //     this.actionButtons.pinIt = { highlighted: false };
        //     if (this.data.link) {
        //         this.actionButtons.showInPinterest = true;
        //     }
        // }
        if (this.feed.network == 'pinterest') {
            // if (['pi_myActivity', 'pi_board', 'pi_pins'].indexOf(this.feed.id) !== -1) {
            //     this.actionButtons.delete = {
            //         action: 'changePin',
            //         ObjectId: this.data.raw_data.id,
            //         label: 'Delete'
            //     };
            // }
            this.actionButtons.pinIt = { highlighted: false };
            if (this.data.link || this.data.permalink) {
                // this.actionButtons.showInPinterest = true;
                this.actionButtons.showInPinterest = true;
            }
        }
    };
    TimelineFeedItem.prototype.getBloggerActionButtons = function () {
    };
    TimelineFeedItem.prototype.replaceFBMentions = function (message_html) {
        var result = message_html;
        var uname = this.profile.display.profile_name;
        var pageId = ''; //this.profile.data.pageId; Todo
        var mentions_pattern = this.data.fromName + ' mentioned ' + __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["v" /* replace_type_in_username */](uname);
        var re_mentions_pattern = new RegExp(mentions_pattern);
        if (re_mentions_pattern.test(message_html))
            result = message_html.replace(mentions_pattern, '<a class="fb-page" href="' + this.data.profileLink + '" target="_blank"'
                + ' data-user="' + this.data.fromId + '">' + this.data.fromName + '</a> mentioned <a class="fb-page" href="https://www.facebook.com/' + pageId + '" target="_blank"'
                + ' data-user="' + pageId + '">' + __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["v" /* replace_type_in_username */](uname) + '</a>');
        return result;
    };
    TimelineFeedItem.prototype.fbShare = function () {
        if (this.feed.id === 'fb_reviews' || this.data.eventType === 'FBReviews') {
            //display stars
            this.actionHeader.stars = { count: parseInt(this.data.sharedCound) };
        }
        else if ((this.feed.id === 'gmbReviews' || this.data.eventType === 'GMBReviews') && typeof this.data.state === 'string') {
            //display stars
            var star_count = ['STAR_RATING_UNSPECIFIED', 'ONE', 'TWO', 'THREE', 'FOUR', 'FIVE'].indexOf(this.data.state);
            this.actionHeader.stars = { count: star_count };
        }
        else {
            if (this.data.reactions && this.data.reactions.count) {
                this.actionHeader.reactions = { count: this.data.reactions.count };
            }
        }
    };
    TimelineFeedItem.prototype.getInitialReplyText = function () {
        var users_arr = [this.data.username], initial_text = '';
        if (this.data.raw_data.retweeted_status != undefined) {
            if (this.data.message.indexOf(': ') != -1 && this.data.message.substr(0, 2) == 'RT') {
                var retw_user = this.data.message.substring(0, this.data.message.indexOf(': '));
                retw_user = retw_user.replace('RT ', '');
                users_arr.push(retw_user.replace('@', ''));
            }
        }
        if (this.data.conversation != undefined && this.data.conversation.tweets != 'false') {
            this.data.conversation.tweets.forEach(function (tweet) {
                if (users_arr.indexOf(tweet.username) == -1)
                    users_arr.push(tweet.username);
            });
        }
        if (this.data.raw_data.entities != undefined && this.data.raw_data.entities.user_mentions != undefined) {
            var screen_name = this.data.raw_data.entities.user_mentions.screen_name;
            if (!Array.isArray(screen_name))
                screen_name = [screen_name];
            screen_name.forEach(function (name) {
                if (users_arr.indexOf(name) == -1)
                    users_arr.push(name);
            });
        }
        var profile_user = this.profile.display.profile_name.trim().toLowerCase();
        users_arr.forEach(function (user) {
            if (user.toLowerCase() != profile_user)
                initial_text = initial_text + ' @' + user;
        });
        return initial_text.trim();
    };
    return TimelineFeedItem;
}(__WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__["a" /* FeedItem */]));

//# sourceMappingURL=timeline-feed-item.js.map

/***/ }),

/***/ 333:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AccountsMapAccountProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_device__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_operator_map__ = __webpack_require__(144);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_operator_map___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_operator_map__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__accounts_service_accounts_map_profile__ = __webpack_require__(111);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var AccountsMapAccountProvider = /** @class */ (function () {
    function AccountsMapAccountProvider(_accountsMapProfileProvider, _device) {
        this._accountsMapProfileProvider = _accountsMapProfileProvider;
        this._device = _device;
        this._mappedAccounts = {
            networks: [],
            accounts_order: [],
            accounts: [],
            analytics_groups: [],
            _retrievedAt: new Date()
        };
        //public - for direct access
        this._networks = [
            {
                backend_network_name: "Facebook",
                display_name: "Facebook",
                account_manage_order: 0,
                color: "facebook",
                // logo: "logo-facebook",
                logo: "logo-facebook",
                circle_logo: "logo-facebook-circle",
                character_limit: 5000,
                logo_img: "fb.png"
            }, {
                backend_network_name: "InstaBusiness",
                display_name: "Instagram Business & Creator ",
                account_manage_order: 1,
                color: "instagram",
                logo: "logo-instagram",
                circle_logo: "logo-instagram-circle",
                character_limit: 2200,
                logo_img: "ig.png"
            }, {
                backend_network_name: "Instagram",
                display_name: "Instagram User Profile",
                account_manage_order: 2,
                color: "instagram",
                logo: "logo-instagram",
                circle_logo: "logo-instagram-circle",
                character_limit: 1400,
                logo_img: "ig.png"
            }, {
                backend_network_name: "Twitter",
                display_name: "Twitter",
                account_manage_order: 3,
                color: "twitter",
                // logo: "logo-twitter",
                logo: "logo-twitter-circle",
                circle_logo: "logo-twitter-circle",
                character_limit: 280,
                logo_img: "twitter.png"
            }, {
                backend_network_name: "Linkedin",
                display_name: "LinkedIn",
                account_manage_order: 4,
                color: "linkedin",
                // logo: "logo-linkedin",
                logo: "logo-linkedin-circle",
                circle_logo: "logo-linkedin-circle",
                character_limit: 1300,
                logo_img: "li.png"
            },
            {
                backend_network_name: "YouTube",
                display_name: "YouTube",
                account_manage_order: 5,
                color: "youtube",
                // logo: "logo-youtube",
                logo: "logo-youtube-circle",
                circle_logo: "logo-youtube-circle",
                character_limit: 5000,
                logo_img: "yt.png"
            },
            {
                backend_network_name: "TikTok",
                display_name: "TikTok",
                account_manage_order: 6,
                color: "tiktok",
                logo: "logo-tiktok",
                circle_logo: "logo-tiktok-circle",
                character_limit: 1400,
                logo_img: "tiktok.png"
            }, {
                // Google My Business in BETA, not final! 
                backend_network_name: "GoogleMyBusiness",
                display_name: "Google My Business",
                account_manage_order: 7,
                color: "googlemybusiness",
                logo: "logo-googlemybusiness",
                circle_logo: "logo-googlemybusiness-circle",
                character_limit: 1500,
                logo_img: "gb.png"
            }, {
                backend_network_name: "GooglePlus",
                display_name: "Google Plus",
                account_manage_order: 8,
                color: "googleplus",
                logo: "logo-googleplus",
                circle_logo: "logo-googleplus-circle",
                character_limit: 5000,
            },
            {
                backend_network_name: "Pinterest",
                display_name: "Pinterest",
                account_manage_order: 9,
                color: "pinterest",
                // logo: "logo-pinterest",
                logo: "logo-pinterest-circle",
                circle_logo: "logo-pinterest-circle",
                character_limit: 500,
                logo_img: "pinterest.png"
            }, {
                backend_network_name: "GoogleAnalytics",
                display_name: "G. Analytics",
                account_manage_order: 10,
                color: "googleanalytics",
                // logo: "logo-googleanalytics",
                logo: "logo-googleanalytics-circle",
                circle_logo: "logo-googleanalytics-circle",
                character_limit: 5000,
                logo_img: "ga.png"
            }, {
                backend_network_name: "Blogger",
                display_name: "Blogger",
                account_manage_order: 11,
                color: "blogger",
                // logo: "logo-blogger",
                logo: "logo-blogger-circle",
                circle_logo: "logo-blogger-circle",
                character_limit: 5000,
                logo_img: "blogger.png"
            }, {
                backend_network_name: "Feedly",
                display_name: "Feedly",
                account_manage_order: 12,
                color: "feedly",
                // logo: "logo-feedly",
                logo: "logo-feedly-circle",
                circle_logo: "logo-feedly-circle",
                character_limit: 5000,
                logo_img: "feedly.png"
            }, {
                backend_network_name: "Pocket",
                display_name: "Pocket",
                account_manage_order: 13,
                color: "pocket",
                // logo: "logo-pocket",
                logo: "logo-pocket-circle",
                circle_logo: "logo-pocket-circle",
                character_limit: 5000,
                logo_img: "pocket.png"
            }, {
                backend_network_name: "Bitly",
                display_name: "Bitly",
                account_manage_order: 14,
                color: "bitly",
                // logo: "logo-bitly",
                logo: "logo-bitly-circle",
                circle_logo: "logo-bitly-circle",
                character_limit: 5000,
                logo_img: "bitly.png"
            }, {
                backend_network_name: "Sniply",
                display_name: "Sniply",
                account_manage_order: 15,
                color: "sniply",
                // logo: "logo-sniply",
                logo: "logo-sniply-circle",
                circle_logo: "logo-sniply-circle",
                character_limit: 5000,
                logo_img: "sniply.png"
            }, {
                backend_network_name: "Zendesk",
                display_name: "Zendesk",
                account_manage_order: 16,
                color: "zendesk",
                // logo: "logo-zendesk",
                logo: "logo-zendesk-circle",
                circle_logo: "logo-zendesk-circle",
                character_limit: 5000,
                logo_img: "zendesk.png"
            }, {
                backend_network_name: "Yelp",
                display_name: "Yelp",
                account_manage_order: 17,
                color: "yelp",
                // logo: "logo-yelp",
                logo: "logo-yelp-circle",
                circle_logo: "logo-yelp-circle",
                character_limit: 5000,
                logo_img: "yelp.png"
            }
        ];
    }
    AccountsMapAccountProvider.prototype.mapAccounts = function (apiAccountsAndSettings) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            // if account is object - put in array
            if (apiAccountsAndSettings.account) {
                if (apiAccountsAndSettings.account && !Array.isArray(apiAccountsAndSettings.account)) {
                    apiAccountsAndSettings.account = [apiAccountsAndSettings.account];
                }
                ;
            }
            ;
            // reset working arrays
            var tempMappedAccountsArray = [];
            //start mapping
            if (apiAccountsAndSettings.account) {
                var _loop_1 = function (account) {
                    var accountType = _this._networks.find(function (network) {
                        return account["type"] === network.backend_network_name;
                    });
                    if (!accountType) {
                        return "continue";
                    }
                    var tempAccount = {
                        display: {
                            account_name: account.nickName ? account.nickName : null,
                            network: null,
                        },
                        account_id: account.accountId,
                        creation_date: account.creationDate,
                        user_access_token: account.userAccessToken,
                        user_id: account.userId,
                        profiles: [],
                        settings: {
                            expired: (account.monitored == 'expired' ? true : false),
                        },
                        data: {
                            config: null,
                            adAccounts: account.adAccounts,
                        }
                    }; //end let tempAccount
                    // console.info(this._networks)
                    //assign network
                    // tempAccount.display.network = this._networks.find(network => {
                    //   return account["type"] === network.backend_network_name
                    // })
                    tempAccount.display.network = accountType;
                    //streams
                    if (account.accountStreams && account.accountStreams.stream) {
                        if (Array.isArray(account.accountStreams.stream)) {
                            tempAccount.data.streams = account.accountStreams.stream;
                        }
                        else {
                            tempAccount.data.streams = [account.accountStreams.stream];
                        }
                    }
                    // if (tempAccount.network.account_manage_order == -1) { tempAccount.network.account_manage_order = 99 };
                    // keep Pinterest as an array?
                    if (Array.isArray(account.config) && account.type != 'Pinterest') {
                        tempAccount.data.config = account.config[0];
                    }
                    else {
                        tempAccount.data.config = account.config;
                    }
                    ;
                    //Start Switching
                    switch (account.type) {
                        case 'Facebook':
                            break;
                        case 'Linkedin':
                            break;
                        case 'Twitter':
                            tempAccount.settings.character_limit = 280;
                            break;
                        case 'Blogger':
                            break;
                        case 'Pinterest':
                            break;
                        case 'Instagram':
                            tempAccount.settings.character_limit = 1600;
                            break;
                        case 'TikTok':
                            tempAccount.settings.character_limit = 1600; // now cloning insta need to be changed
                            break;
                        case 'GooglePlus':
                            if (typeof tempAccount.data.config.fullName === 'string') {
                                // console.info(this._networks);
                                tempAccount.display.account_name = tempAccount.data.config.fullName.split("(")[0];
                                // console.info(this._networks);
                            }
                            else {
                                tempAccount.display.account_name = account.nickName.split("(")[0];
                                if (account.nickName.indexOf("Google+") != -1) {
                                    tempAccount.display.account_name = "Google+";
                                }
                            }
                            break;
                        case 'GoogleAnalytics':
                            break;
                        case 'YouTube':
                            if (account.config.userFirstName && tempAccount.data.config.userFirstName != '') {
                                tempAccount.display.account_name = tempAccount.data.config.userFirstName;
                            }
                            else if (account.nickName && account.nickName != '') {
                                tempAccount.display.account_name = account.nickName;
                            }
                            else {
                                tempAccount.display.account_name = 'YouTube';
                            }
                            break;
                        case 'Pocket':
                            break;
                        case 'Bitly':
                            break;
                        case 'Sniply':
                            break;
                    }
                    ; // end switch
                    // Temporary fix for Sniply
                    if (account.type === null || account.type === undefined) {
                        if (account.data.type === 'Sniply') {
                            tempAccount.display.network.backend_network_name = "sniply";
                            tempAccount.display.network.logo = "logo-sniply";
                            tempAccount.display.network.circle_logo = "logo-sniply-circle";
                        }
                    }
                    ;
                    /* ------------------------------ MAP PROFILES -----------------*/
                    //if (false === tempAccount.settings.expired) {
                    // Create an array of tempProfiles to iterate thorugh for maping
                    var tempProfiles = [];
                    if (Array.isArray(account.config) === false) {
                        tempProfiles.push(account.config);
                    }
                    else {
                        tempProfiles = account.config;
                    }
                    ;
                    _this._accountsMapProfileProvider
                        .mapProfiles(tempProfiles, tempAccount)
                        .then(function (mappedProfiles) {
                        //Mapped Device Info
                        if (apiAccountsAndSettings.settings.devices && typeof apiAccountsAndSettings.settings.devices.device !== 'undefined') {
                            if (!Array.isArray(apiAccountsAndSettings.settings.devices.device)) {
                                apiAccountsAndSettings.settings.devices.device = [apiAccountsAndSettings.settings.devices.device];
                            }
                            for (var i in mappedProfiles) {
                                var deviceInfo = _this.getDeviceInfoBySampleID(apiAccountsAndSettings.settings.devices.device, mappedProfiles[i].profile_id);
                                if (deviceInfo) {
                                    mappedProfiles[i].deviceInfo = deviceInfo;
                                    mappedProfiles[i].settings.isDeviceMapped = true;
                                    if (_this._device.uuid == deviceInfo.deviceId && mappedProfiles[i].profile_id == deviceInfo.sampleId) {
                                        mappedProfiles[i].settings.mappingEnabled = true;
                                    }
                                }
                            }
                        }
                        tempAccount.profiles = mappedProfiles;
                        // this._sortArray(tempAccount.profiles, 'username');
                    })
                        .catch(function (error) {
                        console.error('accounts-mapping - getAccountsAndSettings() - this.mapProfiles() - error', error);
                    });
                    //}// end if(false ===tempAccount.settings.expired)
                    tempMappedAccountsArray
                        .push(tempAccount);
                };
                for (var _i = 0, _a = apiAccountsAndSettings.account; _i < _a.length; _i++) {
                    var account = _a[_i];
                    _loop_1(account);
                }
                ; //end for let account of apiAccountsAndSettings.account
            }
            ; //end if apiAccountsAndSettings.account
            /* ------------------------------ FINISH AND RESOLVE -----------------*/
            _this._mappedAccounts.networks = _this._networks;
            _this._mappedAccounts.accounts_order = apiAccountsAndSettings.account_order;
            if (_this._mappedAccounts.accounts_order && _this._mappedAccounts.accounts_order.indexOf('InstaBusiness') === -1) {
                _this._mappedAccounts.accounts_order.push('InstaBusiness');
            }
            if (_this._mappedAccounts.accounts_order && _this._mappedAccounts.accounts_order.indexOf('TikTok') === -1) {
                _this._mappedAccounts.accounts_order.push('TikTok');
            }
            if (_this._mappedAccounts.accounts_order && _this._mappedAccounts.accounts_order.indexOf('GoogleMyBusiness') === -1) {
                _this._mappedAccounts.accounts_order.push('GoogleMyBusiness');
            }
            // this._mappedAccounts.settings = apiAccountsAndSettings.settings
            _this._mappedAccounts.accounts = tempMappedAccountsArray;
            if (apiAccountsAndSettings.analyticsGroups) {
                _this._mappedAccounts.analytics_groups = apiAccountsAndSettings.analyticsGroups.analyticsGroup;
            }
            resolve(_this._mappedAccounts);
        }); //end Promise
    };
    ; // end mapAccount
    AccountsMapAccountProvider.prototype.getDeviceInfoBySampleID = function (devices, sampleId) {
        return devices.find(function (device) {
            return device.sampleId === sampleId;
        });
    };
    AccountsMapAccountProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__accounts_service_accounts_map_profile__["a" /* AccountsMapProfileProvider */], __WEBPACK_IMPORTED_MODULE_1__ionic_native_device__["a" /* Device */]])
    ], AccountsMapAccountProvider);
    return AccountsMapAccountProvider;
}());

; // end export AccountsMapAccountProvider
//# sourceMappingURL=accounts-map-account.js.map

/***/ }),

/***/ 338:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FacebookFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_collapsible_feed_Item__ = __webpack_require__(339);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_9_moment__);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES




var FacebookFeed = /** @class */ (function (_super) {
    __extends(FacebookFeed, _super);
    function FacebookFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    FacebookFeed.prototype.getGroups = function () {
        var _this = this;
        //Groupd data is available in Profile data if it is hidden_groups
        if (this.id == 'hidden_groups'
            && this.profile.data
            && this.profile.data.groups) {
            if (!Array.isArray(this.profile.data.groups)) {
                this.profile.data.groups = [this.profile.data.groups];
            }
            for (var i in this.profile.data.groups) {
                var group = { id: this.profile.data.groups[i].id, name: this.profile.data.groups[i].name };
                this.groups.push(group);
                if (group.id == this.defaultGroupID) {
                    this.group = group;
                }
            }
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of(this.groups);
        }
        //prepare httpParams and apiPath
        var apiPath = "/feed/news";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("stream", this.id);
        httpParams = httpParams.set("wall", "false");
        httpParams = httpParams.set("limit", "10");
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            var httpResponse = response;
            if (typeof httpResponse.data == 'undefined') {
                return [];
            }
            if (!Array.isArray(httpResponse.data)) {
                httpResponse.data = [httpResponse.data];
            }
            for (var i in httpResponse.data) {
                var group = { id: httpResponse.data[i].id, name: httpResponse.data[i].name };
                _this.groups.push(group);
            }
            return _this.groups;
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    /**
     * It returns feed data
     */
    FacebookFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/news";
        if (this.nextToken !== false)
            apiPath = "/feed/fbMore";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id);
        if (this.isGroupFeed()) {
            apiPath = "/feed/fbGroup";
            httpParams = httpParams.set("stream", "groupFeed");
            httpParams = httpParams.set("groupId", this.group.id);
        }
        else if (this.id == 'inBox' && this.nextToken === false) {
            apiPath = '/feed/fbConversions';
            httpParams = httpParams.set("action", 'getFbConversions');
            httpParams = httpParams.set("stream", this.id);
            this.nextToken = "/conversations";
            if (this.profile.original_config.pageCategory == "User") {
                this.nextToken = "/inbox";
            }
        }
        else {
            var stream = this.id == 'fb_notifications' ? 'notifications' : this.id;
            httpParams = httpParams.set("stream", stream);
            httpParams = httpParams.set("limit", "10");
            if (['wallPosts', 'fb_influences', 'timeline'].indexOf(this.id) !== -1) {
                httpParams = httpParams.set("wall", "true");
            }
            else {
                httpParams = httpParams.set("wall", "false");
            }
        }
        if (this.nextToken !== false) {
            httpParams = httpParams.set('next', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    FacebookFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            if (feedResponse.paging)
                nextToken = feedResponse.paging.next;
            if (this.nextToken == nextToken)
                nextToken = false;
            //prepare feed item
            for (var i in feedResponse.data) {
                if (this.id == 'inBox') {
                    if (feedResponse.data[i].updateTime && isNaN(feedResponse.data[i].updateTime)) {
                        feedResponse.data[i].updateTime = __WEBPACK_IMPORTED_MODULE_9_moment___default()(feedResponse.data[i].updateTime).unix();
                    }
                    items.push(new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_collapsible_feed_Item__["a" /* CollapsibleFeedItem */](this.http, feedResponse.data[i], this));
                }
                else {
                    items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, feedResponse.data[i], this));
                }
            }
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    /**
     * ggg
     */
    FacebookFeed.prototype.ggg = function () {
    };
    return FacebookFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=facebook-feed.js.map

/***/ }),

/***/ 339:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollapsibleFeedItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__ = __webpack_require__(61);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__ = __webpack_require__(30);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_moment__);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
//CLASSES



// import * as momentTimezone from 'moment-timezone';
var CollapsibleFeedItem = /** @class */ (function (_super) {
    __extends(CollapsibleFeedItem, _super);
    function CollapsibleFeedItem(http, data, feed) {
        var _this = _super.call(this, http, data, feed) || this;
        _this.header = null;
        _this.summary = {};
        _this.actionButtons = {};
        //prepare data
        _this.prepareData();
        return _this;
    }
    /**
     * prepareData
     */
    CollapsibleFeedItem.prototype.prepareData = function () {
        this.header = {
            profile: this.profile,
            eventType: this.feed.stream.name,
            eventDate: this.data.eventTime
        };
        if (this.feed.id === 'cinbox' || this.feed.id === 'inBox') {
            this.header.eventType = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["j" /* formatEventType */](this.data.eventType, this.data);
            this.header.eventTags = {
                selectedTagsArray: this.data.tags,
                hasTags: Boolean(this.data.tags.length)
            };
            if (Array.isArray(this.data.roles) && this.data.roles.length > 0) {
                this.header.assignedRoles = {
                    selectedRoles: this.getAssignedRoles(),
                    hasRoles: false
                };
            }
        }
        this.summary.messageView = {
            sender: {
                senderName: this.getSenderName(),
                twittterHandle: '',
                createdDate: this.getCreatedDate(),
                senderProfileImage: this.getProfilePic(),
                senderProfileURL: ''
            },
            messageText: this.getMessageText(),
            tags: this.getAssignedTagsAndRoles()
        };
        //Prepare Media
        var media = this.getMedia();
        //console.log('media', media);
        if (media.mediaUrl != '') {
            this.summary.messageView.media = media;
        }
        //Prepare actionHeaders
        this.actionHeader = {};
        //prepare Action Buttons
        this.getActionButtons();
        if (this.feed.network === 'cinbox') {
            this.actionButtons.completeItem = { highlighted: false };
            if (this.data.ecCompleted === 'true') {
                this.actionButtons.completeItem.highlighted = true;
            }
        }
    };
    CollapsibleFeedItem.prototype.getSenderName = function () {
        var fromId = '', fromName = '';
        if (this.data.comments && this.data.comments.comment) {
            if (!Array.isArray(this.data.comments.comment))
                this.data.comments.comment = [this.data.comments.comment];
            var comms_length = this.data.comments.comment.length;
            var comm = void 0;
            if (comms_length) {
                var participant = void 0;
                if (this.feed.network === 'cinbox') {
                    for (var i = 0; i < comms_length; i++) {
                        var curr_comm = this.data.comments.comment[i];
                        if (this.profile.original_config.pageId !== curr_comm.fromId) {
                            comm = curr_comm;
                            break;
                        }
                    }
                }
                else {
                    comm = this.data.comments.comment[0];
                }
                if (comm) {
                    fromId = comm.fromId;
                    this.data.fromId = comm.fromId;
                    this.data.messageId = comm.messageId;
                    fromName = (participant) ? participant.name : comm.fromName;
                    if (comm.media)
                        this.data.media = comm.media;
                    var fromPicture = '';
                    if (typeof comm.fromPicture === 'string')
                        fromPicture = comm.fromPicture;
                    if (fromPicture)
                        this.data.fromPicture = fromPicture;
                }
            }
        }
        if (this.feed.id === 'inBox') {
            var me = this.profile.display.profile_name; // has some extra characters other than username
            // reply to the one who doesn't have same username as me
            for (var p = 0, l = this.data.participants.participant.length; p < l; p++) {
                if (me.indexOf(this.data.participants.participant[p].name) < 0) {
                    fromId = this.data.participants.participant[p].id;
                    this.data.fromId = fromId;
                    fromName = this.data.participants.participant[p].name;
                    this.data.fromName = fromName;
                    this.data.fromPicture = null;
                    break;
                }
            }
        }
        if (this.data.eventType === 'INMessages')
            fromName = this.data.fromName;
        if (fromId.length)
            return fromName;
        if (fromId.length === 0 && this.data.senders && this.data.senders.sender) {
            var senders = this.data.senders.sender;
            if (!Array.isArray(senders))
                senders = [senders];
            if (senders.length) {
                fromId = senders[0].id;
                this.data.fromId = fromId;
                return senders[0].name;
            }
        }
        return fromName;
    };
    /* get profile picture*/
    CollapsibleFeedItem.prototype.getProfilePic = function () {
        if (this.feed.id = "inBox") {
            if (this.data.comments && this.data.comments.comment) {
                if (!Array.isArray(this.data.comments.comment))
                    this.data.comments.comment = [this.data.comments.comment];
                var comms_length = this.data.comments.comment.length;
                if (comms_length) {
                    for (var i = 0; i < comms_length; i++) {
                        var curr_comm = this.data.comments.comment[i];
                        if ((this.profile.original_config.pageId !== curr_comm.fromId) && curr_comm.fromPicture) {
                            return curr_comm.fromPicture;
                        }
                    }
                }
            }
        }
        if (this.data.fromPicture) {
            return this.data.fromPicture;
        }
        else if (typeof this.data.fromId !== 'undefined') {
            return 'https://graph.facebook.com/v11.0/' + this.data.fromId + '/picture';
        }
        else {
            return this.feed.defaultProfileImage;
        }
    };
    CollapsibleFeedItem.prototype.getCreatedDate = function () {
        var createdDate = 0;
        if (!isNaN(this.data.updateTime)) {
            createdDate = this.data.updateTime * 1000;
        }
        else {
            createdDate = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["l" /* getTimeStamp */](this.data.updateTime) * 1000;
        }
        return createdDate;
    };
    CollapsibleFeedItem.prototype.getMessageText = function () {
        var messageText = (this.data.snippet ? this.data.snippet : '');
        if (!messageText && this.data.message) {
            messageText = this.data.message;
        }
        messageText = this.convertToHTML(messageText);
        messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](messageText);
        if (this.feed.id === 'inBox' && this.data.comments && this.data.comments.comment && this.data.comments.comment.length) {
            var comment = this.data.comments.comment[0];
            if (comment.fromId === this.profile.original_config.pageId)
                messageText = 'You: ' + messageText;
        }
        return messageText;
    };
    CollapsibleFeedItem.prototype.getMedia = function () {
        var media = {
            isImage: true,
            alt: '',
            mediaUrl: '',
            gallery: []
        };
        media = this.prepareFBMedia(this.data, media);
        return media;
    };
    CollapsibleFeedItem.prototype.getActionButtons = function () {
        if (this.data.participants.participant.length < 3) {
            // console.log("colaapsibleFeedItem",this.data);
            this.actionButtons.reply = {
                highlighted: false,
                id: this.data.participants.participant[1].id,
                text: '',
                action: 'addFbPost'
            };
            if (this.summary.messageView.sender.createdDate) {
                var now = __WEBPACK_IMPORTED_MODULE_2_moment__(new Date()); //todays date
                var end = __WEBPACK_IMPORTED_MODULE_2_moment__(new Date(this.summary.messageView.sender.createdDate)); // another date
                var duration = __WEBPACK_IMPORTED_MODULE_2_moment__["duration"](now.diff(end));
                var hours = duration.asHours();
                if (hours > 168) {
                    this.actionButtons.reply.disable = true;
                    this.actionButtons.reply.disableMsg = "Messenger reply must be within 7 days";
                }
            }
            var me = this.profile.display.profile_name; // has some extra characters other than username
            var to_id = "";
            // reply to the one who doesn't have same username as me
            for (var i = 0, l = this.data.participants.participant.length; i < l; i++) {
                if (me.indexOf(this.data.participants.participant[i].name) < 0) {
                    to_id = this.data.participants.participant[i].id;
                    break;
                }
            }
            this.actionButtons.reply.id = to_id;
            if (this.profile.original_config.pageCategory !== 'User' && this.data.eventType != "FBDirectMessage") {
                this.actionButtons.reply.id = this.data.id;
            }
            if (this.feed.id == 'cinbox' && this.data.ecReply === 'true') {
                this.actionButtons.reply.highlighted = true;
            }
            // if (this.feed.id === 'inBox') this.actionButtons.showMore = { label: 'Conversation' };
        }
        if (this.data.eventType === 'INMessages') {
            if (typeof this.data.link === 'string') {
                this.actionButtons.showInInstagram = true;
            }
            this.actionButtons.reply = {
                highlighted: (this.data.ecReply == 'true'),
                id: this.data.fromId,
                text: '@' + this.data.fromName + ' '
            };
        }
        this.actionButtons.showViewLatest = { label: 'View Latest Conversation', pageTitle: 'Conversations' };
    };
    return CollapsibleFeedItem;
}(__WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__["a" /* FeedItem */]));

//# sourceMappingURL=collapsible-feed-Item.js.map

/***/ }),

/***/ 340:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InstagramFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_instagram_feed_item__ = __webpack_require__(73);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var InstagramFeed = /** @class */ (function (_super) {
    __extends(InstagramFeed, _super);
    function InstagramFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    InstagramFeed.prototype.getGroups = function () {
        this.groups.push({ id: 'followed-by', name: 'My Followers' });
        this.groups.push({ id: 'follows', name: 'Following' });
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of(this.groups);
    };
    /**
     * It returns feed data
     */
    InstagramFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/instagram";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("wall", "false");
        if (this.id === 'search') {
        }
        else {
            if (this.id === 'igMyMedia') {
                httpParams = httpParams.set("stream", 'myMedia');
                httpParams = httpParams.set("action", 'getInMyMedia');
                apiPath += '/myMedia';
            }
            else if (this.id === 'ig_feed') {
                httpParams = httpParams.set("stream", 'userFeed');
                httpParams = httpParams.set("action", 'getInFeed');
                apiPath += '/feed';
            }
            else if (this.id === 'ig_relationships') {
                httpParams = httpParams.set("stream", this.group.id);
                httpParams = httpParams.set("action", 'getInRelationships');
                apiPath = '/feed/inRelationships';
            }
        }
        if (this.nextToken !== false) {
            httpParams = httpParams.set('next', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    InstagramFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        console.log('feedResponse', feedResponse);
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            //prepare feed item
            for (var i in feedResponse.data) {
                items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_instagram_feed_item__["a" /* InstagramFeedItem */](this.http, feedResponse.data[i], this));
            }
        }
        if (feedResponse.pagination != undefined) {
            nextToken = feedResponse.pagination.next_max_id;
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    return InstagramFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=instagram-feed.js.map

/***/ }),

/***/ 341:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InstagramBusinessFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_instagram_feed_item__ = __webpack_require__(73);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var InstagramBusinessFeed = /** @class */ (function (_super) {
    __extends(InstagramBusinessFeed, _super);
    function InstagramBusinessFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    InstagramBusinessFeed.prototype.getGroups = function () {
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of([]);
    };
    /**
     * It returns feed data
     */
    InstagramBusinessFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/instagramBusiness";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("action", "getInstagramBusinessFeed")
            .set("stream", this.id);
        if (this.nextToken !== false) {
            httpParams = httpParams.set('next', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    InstagramBusinessFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        console.log('feedResponse', this.id);
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            //prepare feed item
            for (var i in feedResponse.data) {
                items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_instagram_feed_item__["a" /* InstagramFeedItem */](this.http, this.formatInstagramBusinessItem(feedResponse.data[i]), this));
            }
        }
        if (feedResponse.paging != null && feedResponse.paging.next != undefined) {
            nextToken = feedResponse.paging.next;
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    return InstagramBusinessFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=instagram-business-feed.js.map

/***/ }),

/***/ 342:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TwitterFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_twitter_collapsible_feed_item__ = __webpack_require__(343);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES



var TwitterFeed = /** @class */ (function (_super) {
    __extends(TwitterFeed, _super);
    function TwitterFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    TwitterFeed.prototype.getGroups = function () {
        var _this = this;
        //prepare httpParams and apiPath
        var apiPath = "/feed/twitter";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("action", this.getActionString(this.id));
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            //return response;
            var httpResponse = response;
            if (typeof httpResponse.data == 'undefined') {
                return [];
            }
            if (!Array.isArray(httpResponse.data)) {
                httpResponse.data = [httpResponse.data];
            }
            for (var i in httpResponse.data) {
                var group = { id: httpResponse.data[i].id_str, name: httpResponse.data[i].name };
                _this.groups.push(group);
            }
            return _this.groups;
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    /**
     * It returns feed data
     */
    TwitterFeed.prototype.getData = function () {
        var _this = this;
        console.log('FFFFF', this.account);
        //set apiPath
        var apiPath = "/feed/twitter";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("action", this.getActionString(this.id));
        if (this.isGroupFeed()) {
            httpParams = httpParams.set("listId", this.group.id);
            httpParams = httpParams.set("action", "getTWListFeed");
        }
        else {
            httpParams = httpParams.set("stream", this.id);
        }
        if (this.nextToken !== false) {
            httpParams = httpParams.set('max_id', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    TwitterFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            var skip = false;
            if (feedResponse.cursor && feedResponse.cursor[0] != 0)
                nextToken = feedResponse.cursor[0];
            else {
                nextToken = feedResponse.data[feedResponse.data.length - 1].id_str;
                skip = true;
            }
            console.log("prepareFeedItems", response, nextToken);
            var data = feedResponse.data;
            //prepare feed item
            if (this.id == 'direct_message' && data != undefined) {
                var mincoming = [], cuserId = this.account.user_id;
                for (var i = 0, l = data.length; i < l; i++) {
                    if (data[i].conversation == undefined || data[i].conversation.streamEntry == undefined)
                        continue;
                    if (!Array.isArray(data[i].conversation.streamEntry))
                        data[i].conversation.streamEntry = [data[i].conversation.streamEntry];
                    items.push(new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_twitter_collapsible_feed_item__["a" /* TwitterCollapsibleFeedItem */](this.http, data[i].conversation.streamEntry, this));
                    for (var k = 0, ll = data[i].conversation.streamEntry.length; k < ll; k++) {
                        var cmessage = data[i].conversation.streamEntry[k];
                        if (cmessage.recipient.id_str === cuserId) // latest incoming in conversation
                         {
                            mincoming.push({
                                data: cmessage,
                                time: new Date(cmessage.created_at).getTime(),
                                id: cmessage.id_str
                            });
                            break;
                        }
                    }
                }
                mincoming.sort(function (a, b) {
                    if (a.time > b.time) {
                        return -1;
                    }
                    if (a.time < b.time) {
                        return 1;
                    }
                    return 0;
                });
                // find latest incoming
                if (mincoming.length > 0)
                    this.firstItemID = mincoming[0].time;
                else
                    this.firstItemID = '' + new Date().getTime();
            }
            else {
                for (var i in feedResponse.data) {
                    if (this.id == 'mentions') {
                        items.push(new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_twitter_collapsible_feed_item__["a" /* TwitterCollapsibleFeedItem */](this.http, [this.formatTwitterItem(feedResponse.data[i])], this));
                    }
                    else {
                        items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this.formatTwitterItem(feedResponse.data[i]), this));
                    }
                }
            }
            if (skip && this.id != 'direct_message') {
                items.splice(0, 1); //to avoid last item duplication
            }
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    TwitterFeed.prototype.getActionString = function (stremName) {
        var action = '';
        switch (stremName) {
            case 'homeFeed':
                action = 'getTWHomeFeed';
                break;
            case 'mentions':
                action = 'getTWMentions';
                break;
            case 'twFollowers':
                action = 'getTWFollowers';
                break;
            case 'twFriends':
                action = 'getTWFriendsList';
                break;
            case 'sendTweets':
                action = 'getTWSendTweets';
                break;
            case 'myTweetsRetweeted':
                action = 'getTWRetweets';
                break;
            case 'twFavorites':
                action = 'getTWFavorites';
                break;
            case 'direct_message':
                action = 'getTWInBox';
                break;
            case 'lists':
                action = 'getTWLists';
                break;
            case 'search':
                action = 'getTWSearch';
                break;
            case 'outreach':
                action = 'getTWSearch';
                break;
            default:
                break;
        }
        return action;
    };
    return TwitterFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=twitter-feed.js.map

/***/ }),

/***/ 343:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TwitterCollapsibleFeedItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__ = __webpack_require__(61);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__ = __webpack_require__(30);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
//CLASSES

// import { Feed } from '../../classes/feed';
// HELPERS

var TwitterCollapsibleFeedItem = /** @class */ (function (_super) {
    __extends(TwitterCollapsibleFeedItem, _super);
    function TwitterCollapsibleFeedItem(http, data, feed) {
        var _this = _super.call(this, http, data, feed) || this;
        _this.pal = null;
        _this.header = null;
        _this.summary = {};
        _this.actionButtons = {};
        //prepare data
        _this.prepareData();
        return _this;
    }
    /**
     * prepareData
     */
    TwitterCollapsibleFeedItem.prototype.prepareData = function () {
        this.header = {
            profile: this.profile,
            eventType: __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["j" /* formatEventType */](this.data.eventType, this.data),
            eventDate: null
        };
        if (this.feed.id === 'cinbox' || this.feed.id === 'inBox') {
            console.log("dfjhgdsfufgsuf");
            if (this.data && this.data[0]) {
                this.header.eventType = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["j" /* formatEventType */](this.data[0].eventType);
                this.header.eventTags = {
                    selectedTagsArray: this.data[0].tags,
                    hasTags: Boolean(this.data[0].tags.length)
                };
                if (Array.isArray(this.data[0].roles) && this.data[0].roles.length > 0) {
                    this.header.assignedRoles = {
                        selectedRoles: this.getAssignedRoles(),
                        hasRoles: false
                    };
                }
            }
            else {
                this.header.eventType = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["j" /* formatEventType */](this.data.eventType);
                this.header.eventTags = {
                    selectedTagsArray: this.data.tags,
                    hasTags: Boolean(this.data.tags.length)
                };
                if (Array.isArray(this.data.roles) && this.data.roles.length > 0) {
                    this.header.assignedRoles = {
                        selectedRoles: this.getAssignedRoles(),
                        hasRoles: false
                    };
                }
            }
        }
        if (this.feed.id === 'direct_message') {
            var this_comment = this.data[0];
            this.pal = this_comment.sender;
            if (this.feed.account && this.feed.account.user_id === this_comment.sender.id_str && this_comment.recipient) {
                this.pal = this_comment.recipient;
            }
        }
        this.summary.messageView = {
            sender: {
                senderName: __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["f" /* decodeHTMLEntities */](this.getSenderName()),
                twittterHandle: '',
                createdDate: this.getCreatedDate(),
                senderProfileImage: this.getProfilePic(),
                senderProfileURL: this.getSenderProfileUrl(),
            },
            messageText: this.getMessageText(),
            tags: this.getAssignedTagsAndRoles()
        };
        //Prepare Media
        var media = this.getMedia();
        if (media.mediaUrl != '') {
            this.summary.messageView.media = media;
        }
        //Prepare actionHeaders
        this.actionHeader = {};
        //prepare Action Buttons
        this.getActionButtons();
        if (this.feed.network === 'cinbox') {
            console.log('this.data', this.data);
            this.actionButtons.completeItem = { highlighted: false };
            if (this.data[0].ecCompleted === 'true') {
                this.actionButtons.completeItem.highlighted = true;
            }
        }
    };
    TwitterCollapsibleFeedItem.prototype.getSenderName = function () {
        if (this.feed.id == 'mentions' || (this.data[0] != undefined && this.data[0].eventType == 'TWMentions')) {
            var this_comment = this.data[0];
            return this_comment.fromName;
        }
        else {
            var this_comment = this.data[0];
            if (this.feed.id === 'direct_message')
                return this.pal.name;
            return this_comment.sender.name;
        }
    };
    /* get profile picture*/
    TwitterCollapsibleFeedItem.prototype.getProfilePic = function () {
        if (this.feed.id == 'mentions' || (this.data[0] != undefined && this.data[0].eventType == 'TWMentions')) {
            var this_comment = this.data[0];
            return this_comment.profilePic;
        }
        else {
            var this_comment = this.data[0];
            if (this.feed.id === 'direct_message')
                return this.pal.profile_image_url;
            return this_comment.sender.profile_image_url;
        }
    };
    TwitterCollapsibleFeedItem.prototype.getCreatedDate = function () {
        var createdDate = 0;
        if (this.feed.id == 'mentions' || (this.data[0] != undefined && this.data[0].eventType == 'TWMentions')) {
            var this_comment = this.data[0];
            createdDate = this_comment.updateTime * 1000;
        }
        else {
            var this_comment = this.data[0];
            createdDate = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["l" /* getTimeStamp */](this_comment.created_at) * 1000;
        }
        return createdDate;
    };
    TwitterCollapsibleFeedItem.prototype.getMessageText = function () {
        var messageText = '';
        if (this.feed.id == 'mentions' || (this.data[0] != undefined && this.data[0].eventType == 'TWMentions')) {
            var this_comment = this.data[0];
            messageText = this_comment.message;
            messageText = this.convertToHTML(messageText);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["w" /* tw_deep_link_to_html */](messageText, this_comment.raw_data);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["u" /* replaceWithDisplayURL */](messageText, this_comment.raw_data.entities);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["x" /* tw_user_mentions_to_links */](messageText, this_comment.raw_data);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["n" /* hashtag_to_link */](messageText, 'twitter');
            if (this.feed.id === 'cinbox' && this.data[0].user) {
                messageText = '<span class="comment-subtitle">@' + this.data[0].user.screen_name + '\'s Mention:</span> ' + messageText;
            }
        }
        else {
            var this_comment = this.data[0];
            messageText = this_comment.text;
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["u" /* replaceWithDisplayURL */](messageText, this_comment.entities);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["x" /* tw_user_mentions_to_links */](messageText, this_comment);
            messageText = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["n" /* hashtag_to_link */](messageText, 'twitter');
            if (this.feed.id === 'direct_message' && this.feed.account
                && this.feed.account.user_id === this_comment.sender.id_str) {
                messageText = 'You: ' + messageText;
            }
        }
        return messageText;
    };
    TwitterCollapsibleFeedItem.prototype.getMedia = function () {
        var media = {
            isImage: true,
            isAnimated: false,
            alt: '',
            mediaUrl: '',
            gallery: []
        };
        var preview = '';
        if (this.feed.id == 'mentions' || (this.data[0] != undefined && this.data[0].eventType == 'TWMentions')) {
            var this_comment = this.data[0];
            media = this.prepareTwitterMedia(this_comment.raw_data, media);
        }
        else {
            var this_comment = this.data[0];
            media = this.prepareTwitterMedia(this_comment, media);
        }
        return media;
    };
    TwitterCollapsibleFeedItem.prototype.getActionButtons = function () {
        if (this.feed.id === 'mentions' || (this.data[0] && this.data[0].eventType === 'TWMentions')) {
            if (!this.data[0].raw_data || !__WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data[0].raw_data.in_reply_to_status_id_str)) {
                this.actionButtons.showViewLatest = { label: 'View Latest Conversation', pageTitle: 'Conversations' };
            }
        }
        else {
            if (this.data.length > 1) {
                this.actionButtons.showViewLatest = { label: 'Messages', pageTitle: 'Conversations' };
                ;
            }
        }
        if (this.feed.id == 'mentions' || (this.data[0] != undefined && this.data[0].eventType == 'TWMentions')) {
            var removeRetweet = false;
            if (this.data[0].user != undefined && (this.data[0].user.id_str == this.feed.account.user_id)) {
                removeRetweet = true;
            }
            if (this.data[0].user.connections != undefined && this.data[0].user.connections.indexOf('followed_by') != -1) {
                this.actionButtons.reply = {
                    highlighted: false,
                    id: this.data[0].postID,
                    text: this.getInitialReplyText()
                };
                if (!removeRetweet) {
                    this.actionButtons.retweet = {
                        highlighted: false,
                        id: this.data[0].postID,
                        permalink: (this.data[0].raw_data && this.data[0].raw_data.permalink) ? this.data[0].raw_data.permalink : '',
                        text: ''
                    };
                }
                this.actionButtons.twLike = { highlighted: false };
                this.actionButtons.directMessage = {
                    highlighted: false,
                    id: this.data[0].postID,
                    userID: (this.data[0].user != undefined ? this.data[0].user.id_str : this.data[0].postID)
                };
            }
            else {
                this.actionButtons.reply = {
                    highlighted: false,
                    id: this.data[0].postID,
                    text: this.getInitialReplyText()
                };
                if (!removeRetweet) {
                    this.actionButtons.retweet = {
                        highlighted: false,
                        id: this.data[0].id,
                        permalink: (this.data[0].raw_data && this.data[0].raw_data.permalink) ? this.data[0].raw_data.permalink : '',
                        text: ''
                    };
                }
                this.actionButtons.twLike = { highlighted: false };
            }
            if ((this.data[0].favorites != undefined && this.data[0].favorites.by_me == 'true')
                || this.data[0].ecFavorite == 'true') {
                this.actionButtons.twLike.highlighted = true;
            }
            if ((this.data[0].retweets != undefined && this.data[0].retweets.by_me == 'true')
                || this.data[0].ecRetweet == 'true') {
                if (this.actionButtons.retweet) {
                    this.actionButtons.retweet.highlighted = true;
                }
            }
        }
        else {
            var pal = void 0;
            if (this.data[0].recipient.id_str != this.feed.account.user_id) {
                pal = this.data[0].recipient;
            }
            else {
                pal = this.data[0].sender;
            }
            this.data[0].postID = pal.id_str;
            this.actionButtons.directMessage = {
                highlighted: false,
                id: this.data[0].postID,
                userID: (this.data[0].user != undefined ? this.data[0].user.id_str : this.data[0].postID)
            };
        }
        //show in twitter
        // if (this.data[0].raw_data && this.data[0].raw_data.permalink && typeof this.data[0].raw_data.permalink === 'string') {
        //     this.actionButtons. = {
        //         label: 'Show In Twitter',
        //         link: this.data[0].raw_data.permalink
        //     }
        // }
        // else {
        //     let media = this.summary.messageView.media;
        //     if (this.data[0].eventType && this.data[0].eventType === 'TWDirectMessage' && media && media.isImage && !media.isAnimated) {
        //         this.actionButtons.showInMedia = {
        //             label: 'Show In Twitter',
        //             link: 'https://twitter.com/messages'
        //         }
        //     }
        // }
        if (this.feed.network == 'cinbox') {
            if (this.actionButtons.directMessage && this.data[0] && this.data[0].ecDM) {
                this.actionButtons.directMessage.highlighted = (this.data[0].ecDM == 'true');
            }
            if (this.actionButtons.reply && this.data[0] && this.data[0].ecReply) {
                this.actionButtons.reply.highlighted = (this.data[0].ecReply == 'true');
            }
        }
    };
    TwitterCollapsibleFeedItem.prototype.getInitialReplyText = function () {
        var initial_text = '';
        if (this.feed.id == 'mentions' || (this.data[0] != undefined && this.data[0].eventType == 'TWMentions')) {
            var users_arr_1 = [this.data[0].username];
            if (this.data[0].raw_data.retweeted_status != undefined) {
                if (this.data[0].message.indexOf(': ') != -1 && this.data[0].message.substr(0, 2) == 'RT') {
                    var retw_user = this.data[0].message.substring(0, this.data[0].message.indexOf(': '));
                    retw_user = retw_user.replace('RT ', '');
                    users_arr_1.push(retw_user.replace('@', ''));
                }
            }
            if (this.data[0].raw_data.entities != undefined && this.data[0].raw_data.entities.user_mentions != undefined) {
                var screen_name = this.data[0].raw_data.entities.user_mentions.screen_name;
                if (!Array.isArray(screen_name))
                    screen_name = [screen_name];
                screen_name.forEach(function (name) {
                    if (users_arr_1.indexOf(name) == -1)
                        users_arr_1.push(name);
                });
            }
            var profile_user_1 = this.profile.display.profile_name.trim();
            users_arr_1.forEach(function (user) {
                if (user.toLowerCase() != profile_user_1)
                    initial_text = initial_text + ' @' + user;
            });
        }
        return initial_text.trim();
    };
    TwitterCollapsibleFeedItem.prototype.getSenderProfileUrl = function () {
        console.log('getSenderProfileUrl', this.feed, this.data);
        var profileUrl = '';
        if (this.data[0].eventType === 'TWMentions') {
            profileUrl = "https://twitter.com/" + this.data[0].username;
        }
        else if (this.data[0].eventType == 'TWDirectMessage') {
            profileUrl = "https://twitter.com/" + this.data[0].sender.screen_name;
        }
        if (this.feed.id === 'direct_message')
            return profileUrl = this.pal.screen_name;
        // if()
        return profileUrl;
    };
    return TwitterCollapsibleFeedItem;
}(__WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__["a" /* FeedItem */]));

//# sourceMappingURL=twitter-collapsible-feed-item.js.map

/***/ }),

/***/ 344:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return YoutubeFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var YoutubeFeed = /** @class */ (function (_super) {
    __extends(YoutubeFeed, _super);
    function YoutubeFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    YoutubeFeed.prototype.getGroups = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/youTube";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("stream", this.id)
            .set("action", 'getYouTubeFeed');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            //set defaultGroupID
            _this.defaultGroupID = response.data.defaultChannelId;
            if (!Array.isArray(response.data.items)) {
                response.data.items = [response.data.items];
            }
            for (var index in response.data.items) {
                var group = { name: response.data.items[index].channelTitle, id: response.data.items[index].channelId };
                _this.groups.push(group);
                if (group.id == _this.defaultGroupID) {
                    _this.group = group;
                }
            }
            return _this.groups;
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    /**
     * It returns feed data
     */
    YoutubeFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/youTube";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("stream", this.id)
            .set("action", "getYouTubeFeed");
        if (this.id == 'yt_mySubscription') {
            httpParams = httpParams.set("stream", 'yt_channelVideos');
            httpParams = httpParams.set("channel_id", this.group.id);
        }
        if (this.nextToken !== false) {
            httpParams = httpParams.set('nextToken', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    YoutubeFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        console.log('feedResponse', feedResponse);
        if (feedResponse.data
            && feedResponse.data.items
            && Array.isArray(feedResponse.data.items)
            && feedResponse.data.items.length) {
            //prepare feed item
            for (var i in feedResponse.data.items) {
                items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this.formatYoutubeItem(feedResponse.data.items[i]), this));
            }
        }
        if (feedResponse.pagination != undefined) {
            nextToken = feedResponse.pagination.next_max_id;
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    return YoutubeFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=youtube-feed.js.map

/***/ }),

/***/ 345:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GoogleplusFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var GoogleplusFeed = /** @class */ (function (_super) {
    __extends(GoogleplusFeed, _super);
    function GoogleplusFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    GoogleplusFeed.prototype.getGroups = function () {
        var _this = this;
        return this.accountsServiceProvider.getAccountByID(this.profile.account_id).map(function (mappedAccount) {
            mappedAccount.profiles.forEach(function (profile) {
                if (profile.data.objectType && profile.data.objectType === 'page' && profile.monitored === 'on') {
                    _this.groups.push({
                        id: profile.original_config.page_id,
                        name: profile.display.profile_name,
                        profileID: profile.profile_id
                    });
                }
            });
            return _this.groups;
        });
    };
    /**
     * It returns feed data
     */
    GoogleplusFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/googlePlusStream";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("action", "getGPStream");
        if (this.isGroupFeed()) {
            httpParams = httpParams.set("profileID", this.group.profileID);
        }
        switch (this.id) {
            case 'gp_pages':
                httpParams = httpParams.set("stream", 'gp_page_stream');
                break;
            case 'gp_pages_only':
                httpParams = httpParams.set("stream", 'gp_page_only_stream');
                break;
            case 'gp_activities':
                httpParams = httpParams.set("stream", 'gp_activities');
                break;
            default:
                httpParams = httpParams.set("stream", 'gp_page_stream');
                break;
        }
        if (this.nextToken !== false) {
            httpParams = httpParams.set('next', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    GoogleplusFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        console.log('feedResponse', feedResponse);
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            //prepare feed item
            for (var i in feedResponse.data) {
                var this_datum = void 0;
                if (this.id == 'gp_activities') {
                    this_datum = this.formatGPActivitiesItem(feedResponse.data[i]);
                }
                else {
                    this_datum = this.formatGPItem(feedResponse.data[i]);
                }
                items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this_datum, this));
            }
        }
        if (feedResponse.next != undefined) {
            nextToken = feedResponse.next;
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    return GoogleplusFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=googleplus-feed.js.map

/***/ }),

/***/ 346:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LinkedinFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_linkedin_feed_item__ = __webpack_require__(113);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var LinkedinFeed = /** @class */ (function (_super) {
    __extends(LinkedinFeed, _super);
    function LinkedinFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    LinkedinFeed.prototype.getGroups = function () {
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of(this.groups);
    };
    /**
     * It returns feed data
     */
    LinkedinFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/linkedIn/";
        if (this.getActionString(this.id) === 'getLNCmpHome') {
            apiPath += 'companyHome';
        }
        else {
            apiPath += 'getMyUpdates';
        }
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("profile_Id", this.profile.original_config.profile_Id)
            .set("action", this.getActionString(this.id))
            .set("start", '0');
        if (this.nextToken !== false) {
            httpParams = httpParams.set('start', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    LinkedinFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        console.log('feedResponse', feedResponse);
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            nextToken = feedResponse.data.length;
            //prepare feed item
            for (var i in feedResponse.data) {
                items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_linkedin_feed_item__["a" /* LinkedinFeedItem */](this.http, feedResponse.data[i], this));
            }
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    LinkedinFeed.prototype.getActionString = function (stremName) {
        var action = '';
        switch (stremName) {
            case 'lnc_homeWall':
                action = 'getLNCmpHome';
                break;
            default:
                action = 'getMyUpdates';
                break;
        }
        return action;
    };
    return LinkedinFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=linkedin-feed.js.map

/***/ }),

/***/ 347:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GoogleMyBusinessFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var GoogleMyBusinessFeed = /** @class */ (function (_super) {
    __extends(GoogleMyBusinessFeed, _super);
    function GoogleMyBusinessFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, http, stream, profile, group, options) || this;
        console.log('stream', stream);
        return _this;
    }
    /*
    *   it returns groups or like-pages list
    */
    GoogleMyBusinessFeed.prototype.getGroups = function () {
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of([]);
    };
    /**
     * It returns feed data
     */
    GoogleMyBusinessFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/googleMyBusinessFeed";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("stream", this.id)
            .set("action", "getGoogleMyBusinessFeed");
        if (this.nextToken !== false) {
            httpParams = httpParams.set('next', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    GoogleMyBusinessFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        // console.log('feedResponse', feedResponse);
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            //prepare feed item
            for (var i in feedResponse.data) {
                items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this.formatGMBItem(feedResponse.data[i]), this));
            }
        }
        if (feedResponse.next)
            nextToken = feedResponse.next;
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    return GoogleMyBusinessFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=google-business-feed.js.map

/***/ }),

/***/ 352:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TETextEditorServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var TETextEditorServiceProvider = /** @class */ (function () {
    function TETextEditorServiceProvider(_http) {
        this._http = _http;
    }
    ;
    TETextEditorServiceProvider.prototype.shortenUrl = function (linkToShorten, urlType) {
        console.info('Entering InboxActionButtonProvider::_shortenUrl.');
        urlType != 'google' ? linkToShorten = linkToShorten : linkToShorten + '?utm_source=KZ_TM&utm_medium=&utm_content=&utm_campaign=';
        var requestBody = {
            "action": "shorten_url",
            "url": linkToShorten,
            "shrink_opt": urlType
        };
        console.info("InboxActionButtonProvider::shortenUrl  - requestBody - ", requestBody);
        return this
            ._http
            .post("/publishing/shortenurl", requestBody)
            .catch(function (shortenUrlError) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].throw(shortenUrlError);
        }); //end Observable
    };
    ; //end shortenUrl
    /*
  
    public getGiphyOrStickers(requestParams: GiphyParamsInterface): Observable<HttpResponse<any>> {
  
      let params = new HttpParams()
        .set('action', 'getGiphyFeed')
        .set('command', "trending")
        .set('mode', requestParams.mode);
  
      //build array for offset and limit
      const parameters = [
        { "key": "limit", "value": requestParams.limit.toString() },
        { "key": "offset", "value": requestParams.offset.toString() }
      ]
  
      //Push to array, if search value exists
      if (requestParams.searchValue && requestParams.searchValue.trim().length > 0) {
        params = params.set('command', 'search');
        parameters.push({ "key": "q", "value": requestParams.searchValue });
      }
  
      //Build params based on parameters array
      for (let index = 0; index < parameters.length; index++) {
        params = params.set(`parameters["${index}"][key]`, parameters[index]["key"])
          .set(`parameters["${index}"][value]`, parameters[index]["value"]);
      };
  
      return this
        ._http
        .get<HttpResponse<any>>("/giphy/gf", { params: params })
  
    }; // end getGiphyOrStickers
  
    public getPixabayImages(requestParams: PixabayParamsInterface): Observable<HttpResponse<any>> {
      let params = new HttpParams().set("action", "getPixabayFeed");
  
      // Array for default paramters
      const parameters: any = [
        { "key": "image_type", "value": "photo" },
        { "key": "category", "value": requestParams.category },
        { "key": "min_width", "value": requestParams.min_width },
        { "key": "min_height", "value": requestParams.min_height },
        // { "key": "q", "value": searchTerm },
      ];
  
      // Category
      if (requestParams.category) {
        parameters.push({ "key": "category", "value": requestParams.category },
        )
      };
  
      if (requestParams.pagination) {
        parameters.push({ "key": "page", "value": requestParams.pagination.page },
          { "key": "count", "value": requestParams.pagination.count },
          { "key": "per_page", "value": requestParams.pagination.per_page }
        )
      };
  
      //Search - Push to array, if search value exists
      if (requestParams.searchValue && requestParams.searchValue.trim().length > 0) {
        parameters.push(
          { "key": "q", "value": requestParams.searchValue },
        );
      }
  
      //Scroll - Push to array, if Scroll values exists
      if (requestParams.scroll_total_count) {
        parameters.push({ "key": "total_count", "value": requestParams.scroll_total_count }
        )
      };
  
      //Build params based on parameters array
      for (let index = 0; index < parameters.length; index++) {
        params = params.set(`parameters["${index}"][key]`, parameters[index]["key"])
          .set(`parameters["${index}"][value]`, parameters[index]["value"]);
      };
  
      return this
        ._http
        .get<HttpResponse<any>>("/feed/pixabay", { params: params });
    }; // end getPixabayImages
  
  
    / -- ********** Convert images from Pixabay/Giphy/Stickers to eClincher S3 *************** -- /
    public convertExternalUrlToS3(imageInfo: ExternalURLToS3RequestParams): Observable<HttpResponse<any>> {
      console.info('Entering InboxActionButtonProvider::s3Upload.', imageInfo);
  
      let requestBody: any = {}, i = 0;
      if (imageInfo[i].type = "image.pixabay") {
        let ext = imageInfo[i].value.webformatURL.split('.');
  
        requestBody = {
          action: "s3_upload",
          images: {
            src: imageInfo[i].value.webformatURL,
            title: "",
            filename: UUID() + '.' + ext[2],
            ext: ext[2]
          }
        }
      }
      else if (imageInfo[i].type = "image.giphy") {
        requestBody = {
          action: "s3_upload",
          images: {
            src: imageInfo[i].value.images.original.url,
            title: "",
            filename: UUID() + '.' + imageInfo[i].value.type,
            ext: imageInfo[i].value.type
          }
        }
      };
  
      return this
        ._http
        .post<HttpResponse<any>>("/upload/s3", requestBody)
  
    }; // end convertExternalUrlToS3
  */
    TETextEditorServiceProvider.prototype.mapS3ToEcAttachment = function (imageData) {
        var item;
        return item;
    };
    ; // end mapS3ToEcAttachment
    TETextEditorServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], TETextEditorServiceProvider);
    return TETextEditorServiceProvider;
}());

; //end TextEditorProvider
;
;
;
//# sourceMappingURL=te-text-editor-service.js.map

/***/ }),

/***/ 37:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AccountsServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch__ = __webpack_require__(477);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_accounts_service_accounts_map_account__ = __webpack_require__(333);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__accounts_map_profile__ = __webpack_require__(111);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





//PROVIDERS AND INTERFACES



var AccountsServiceProvider = /** @class */ (function () {
    /*
    // source for observable
    private _userQueues = new BehaviorSubject < any > (null);
    // observable stream
    public userQueues$ = this
      ._userQueues
      .asObservable();
  */
    function AccountsServiceProvider(_http, _userSettingsProvider, _accountsMapAccountProvider, accountsMapProfile) {
        this._http = _http;
        this._userSettingsProvider = _userSettingsProvider;
        this._accountsMapAccountProvider = _accountsMapAccountProvider;
        this.accountsMapProfile = accountsMapProfile;
        // source for observable
        this.accountsSource = new __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.accounts$ = this
            .accountsSource
            .asObservable();
    }
    ; //end constructor
    AccountsServiceProvider.prototype.getAccountsAndSettings = function (checkTimeStamp) {
        var _this = this;
        if (checkTimeStamp === void 0) { checkTimeStamp = true; }
        //Pass in false when selecting brand for Agency
        if (checkTimeStamp && this.accountsSource.value !== null && this._checkTimeStamp() === 'use_accounts_in_memory') {
            return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].of(this.accountsSource.value); // this.accounts$;
        }
        else {
            return this
                ._http
                .get('/account/accounts')
                .flatMap(function (getAccountsAndSettingsReponse) {
                // let ismapped:boolean = false;
                // let tikTok :any ={};
                // if(getAccountsAndSettingsReponse && getAccountsAndSettingsReponse.account){
                //   for(let account of getAccountsAndSettingsReponse.account){
                //     if(!ismapped && account.type === "InstaBusiness"){
                //       tikTok = $.extend({},account);
                //       tikTok.type = "TikTok";
                //       ismapped = true;
                //       if(tikTok) getAccountsAndSettingsReponse.account.push(tikTok); 
                //       break;
                //     }
                //   }
                // }
                //need flatMap
                return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].fromPromise(_this._accountsMapAccountProvider.mapAccounts(getAccountsAndSettingsReponse).then(function (mappedAccounts) {
                    _this
                        .accountsSource
                        .next(mappedAccounts);
                    //Update settings Observable - make sure client is always an Array
                    var settings = getAccountsAndSettingsReponse["settings"];
                    if (settings != undefined) {
                        if (settings["agencyConfiguration"]) {
                            if (settings["agencyConfiguration"]["client"] && settings["agencyConfiguration"]["client"].constructor !== Array) {
                                var clientArray = [settings.agencyConfiguration.client];
                                settings.agencyConfiguration.client = clientArray;
                            }
                        }
                    }
                    _this._userSettings = settings;
                    _this._userSettingsProvider.userSettingsSource.next(_this._userSettings);
                    console.log('getAccountsAndSettingsReponse', mappedAccounts);
                    return mappedAccounts;
                }) //end then
                ); //end fromPromise
            }) //end flatMap
                .catch(function (error) {
                console.error('AccountsServiceProvider - error - ', error);
                return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].throw(error);
            });
        }
    }; // end getAccountsAndSettings
    AccountsServiceProvider.prototype._checkTimeStamp = function () {
        var interval = 2 * (60 * 60 * 1000); // two hours
        var currentTime = new Date().getTime();
        var retrievedAt = this
            .accountsSource
            .value
            ._retrievedAt
            .getTime();
        if (retrievedAt && currentTime < retrievedAt + interval) {
            return 'use_accounts_in_memory';
        }
        else {
            return 'get_accounts';
        }
    }; // end _checkTimeStamp
    /*
    public getUserQueues() : Observable < any > {
      console.log('getUserQueues');
      return this._http.get('/publishing/userQueues?action=getUserQueues')
        .map(response => response.json()
        ).catch(responseError => {
          console.error('AccountsManagerProvider - getUserQueues - responseError - ', responseError);
          return Observable.throw(responseError);
        });
    };
  */
    /**************** BUTTON METHODS ************************/
    AccountsServiceProvider.prototype.refreshAccountToken = function (account) {
        if (account.display.network.backend_network_name.toLowerCase() === 'linkedin') {
            return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].throw("Can't refresh LinkedIn");
        }
        else {
            var action = void 0;
            (account.display.network.backend_network_name.toLowerCase() == 'pinterest')
                ? action = "updatePIBoards"
                : action = "refreshAccount";
            var refreshBody = {
                action: action,
                accountID: account.account_id,
                accountType: account.display.network.backend_network_name
            };
            return this
                ._http
                .post("/account/refresh", refreshBody);
        }
        ;
    };
    ;
    AccountsServiceProvider.prototype.deleteAccount = function (account) {
        var deleteBody = {
            action: 'deleteAccountByID',
            accid: account.account_id
        };
        return this
            ._http
            .post("/account/delete", deleteBody);
    };
    ; // end deleteAccount
    AccountsServiceProvider.prototype.updateMonitoring = function (profile) {
        var requestData = {
            action: 'setSingleProfileMonitored',
            data: {
                accountID: profile.account_id,
                profileID: profile.profile_id,
                checked: profile.settings.enabled
            }
        };
        return this
            ._http
            .post("/account/singleprofilemonitor", requestData);
    };
    ; // end updateMonitoring
    AccountsServiceProvider.prototype.isUnderMonitoringLimit = function (profile) {
        var uncheckedNetworks = ['googleanalytics', 'pocket', 'feedly', 'bitly', 'sniply', 'googlemybusiness'];
        if (!profile.settings.enabled) {
            return true;
        }
        if (uncheckedNetworks.indexOf(profile.display.network.backend_network_name) !== -1) {
            return true;
        }
        if (this._userSettingsProvider.getLicenseType() === 'profiles') {
            if (Number(this._userSettings.totalProfilesOn) + 1 <= Number(this._userSettings.numberOfProfiles)) {
                return true;
            }
        }
        else {
            if (Number(this._userSettings.activeSocialAccounts) + 1 <= Number(this._userSettings.numberOfSocialsOn)) {
                return true;
            }
        }
        return false;
    };
    ;
    AccountsServiceProvider.prototype.getAccountByID = function (accountID) {
        return this.accounts$.map(function (updatedMappedAccounts) {
            var account;
            if (updatedMappedAccounts) {
                for (var index in updatedMappedAccounts.accounts) {
                    if (accountID == updatedMappedAccounts.accounts[index].account_id) {
                        account = updatedMappedAccounts.accounts[index];
                        break;
                    }
                }
            }
            return account;
        });
        //console.log('HHHHH');
    };
    AccountsServiceProvider.prototype.getAccountDataByID = function (accountID) {
        var updatedMappedAccounts = this.accountsSource.value;
        var account;
        for (var index in updatedMappedAccounts.accounts) {
            if (accountID == updatedMappedAccounts.accounts[index].account_id) {
                account = updatedMappedAccounts.accounts[index];
                break;
            }
        }
        return account;
        //console.log('HHHHH');
    };
    AccountsServiceProvider.prototype.getProfileByID = function (profileID) {
        var updatedMappedAccounts = this.accountsSource.value;
        var account;
        var profile;
        if (!updatedMappedAccounts)
            return null;
        for (var index in updatedMappedAccounts.accounts) {
            account = updatedMappedAccounts.accounts[index];
            for (var i in account.profiles) {
                if (account.profiles[i].profile_id == profileID) {
                    profile = account.profiles[i];
                    break;
                }
            }
        }
        return profile;
    };
    AccountsServiceProvider.prototype.getAccountsByType = function (accountTypes) {
        var updatedMappedAccounts = this.accountsSource.value;
        var accounts = [];
        if (!updatedMappedAccounts)
            return accounts;
        for (var index in updatedMappedAccounts.accounts) {
            var account = updatedMappedAccounts.accounts[index];
            if (accountTypes.indexOf(account.display.network.backend_network_name) !== -1) {
                accounts.push(account);
            }
        }
        return accounts;
    };
    AccountsServiceProvider.prototype.getProfilesByType = function (profileTypes) {
        var updatedMappedAccounts = this.accountsSource.value;
        var account;
        var profiles = [];
        if (!updatedMappedAccounts)
            return profiles;
        for (var index in updatedMappedAccounts.accounts) {
            account = updatedMappedAccounts.accounts[index];
            for (var i in account.profiles) {
                if (profileTypes.indexOf(account.profiles[i].display.network.backend_network_name) !== -1) {
                    profiles.push(account.profiles[i]);
                }
            }
        }
        return profiles;
    };
    AccountsServiceProvider.prototype.getMontitoredProfilesByType = function (profileTypes) {
        var updatedMappedAccounts = this.accountsSource.value;
        var account;
        var profiles = [];
        if (!updatedMappedAccounts)
            return profiles;
        for (var index in updatedMappedAccounts.accounts) {
            account = updatedMappedAccounts.accounts[index];
            for (var i in account.profiles) {
                if (profileTypes.indexOf(account.profiles[i].display.network.backend_network_name) !== -1 && account.profiles[i].original_config.monitored == "on") {
                    profiles.push(account.profiles[i]);
                }
            }
        }
        return profiles;
    };
    AccountsServiceProvider.prototype.getAccounts = function () {
        return this.accountsSource.value;
    };
    /**
     * getUserSettings
     */
    AccountsServiceProvider.prototype.getUserSettings = function () {
        return this._userSettingsProvider.userSettingsSource.value;
    };
    /**
    * getCurrentUserRole
    */
    AccountsServiceProvider.prototype.getCurrentUserRole = function (userSettings) {
        if (userSettings === void 0) { userSettings = null; }
        userSettings = userSettings || this.getUserSettings();
        if (userSettings == null)
            return null;
        if (userSettings.isAdminUser && userSettings.isAdminUser == "true")
            return 'Main Admin';
        var userRoleStr = 'Publisher';
        var isAgency = this._userSettingsProvider.isAgency();
        if (isAgency) {
            var selectedBrand = this._userSettingsProvider.getSelectedBrand();
            if (selectedBrand) {
                if (selectedBrand.permission === 'admin')
                    userRoleStr = 'Admin';
                else if (selectedBrand.permission === 'view')
                    userRoleStr = 'Contributor';
            }
        }
        else {
            if (userSettings.masterAccountsPermission)
                userRoleStr = 'Admin';
            else {
                var permission = this.getCurrentUserAccountsPermission();
                if (permission == null)
                    userRoleStr = null;
                else if (permission === 'view')
                    userRoleStr = 'Contributor';
                else
                    userRoleStr = 'Publisher';
            }
        }
        return userRoleStr;
    };
    AccountsServiceProvider.prototype.getCurrentUserAccountsPermission = function (accountId) {
        var _this = this;
        var permission = 'view';
        var mappedAccounts = this.getAccountDataByID(accountId);
        if (mappedAccounts.profiles) {
            var profiles = mappedAccounts.profiles;
            if (accountId) {
                profiles.forEach(function (profileId) {
                    var profile = _this.getProfileByID(profileId);
                    if (_this.accountsMapProfile.canPost(profile.display.network.backend_network_name) && _this.getProfilePermission(profile) === 'edit')
                        permission = 'edit';
                });
            }
            else {
                for (var key in profiles) {
                    if (profiles.hasOwnProperty(key)) {
                        var profile = profiles[key];
                        if (this.accountsMapProfile.canPost(profile.display.network.backend_network_name) && this.getProfilePermission(profile) === 'edit')
                            permission = 'edit';
                    }
                }
            }
        }
        return permission;
    };
    AccountsServiceProvider.prototype.getProfilePermission = function (profile) {
        var permission = 'view';
        if (profile) {
            var accountType = profile.display.network.backend_network_name;
            if ((profile.monitored !== 'off' && accountType !== 'Pinterest')
                || (accountType === 'Pinterest' /* && account.has_monitored_profiles() */ && profile.data.objectType === 'user')) // skip PI boards
             {
                if (profile.original_config && profile.original_config.permission === 'edit')
                    permission = 'edit';
            }
        }
        return permission;
    };
    AccountsServiceProvider.prototype.addTikTokAccount = function (profileName) {
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        var params = {};
        params.profileName = profileName;
        return this
            ._http
            .post("/account/addTikTok", params, httpOptions)
            .map(function (httpResponse) {
            return httpResponse;
        });
    };
    AccountsServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_6__providers_user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_accounts_service_accounts_map_account__["a" /* AccountsMapAccountProvider */],
            __WEBPACK_IMPORTED_MODULE_7__accounts_map_profile__["a" /* AccountsMapProfileProvider */]])
    ], AccountsServiceProvider);
    return AccountsServiceProvider;
}());

; // end AccountsServiceProvider
//# sourceMappingURL=accounts-service.js.map

/***/ }),

/***/ 398:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CrispChatProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__user_settings_user_settings__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/*
  Generated class for the CrispChatProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var CrispChatProvider = /** @class */ (function () {
    function CrispChatProvider(http, userSettingsProvider) {
        this.http = http;
        this.userSettingsProvider = userSettingsProvider;
        console.log('Hello CrispChatProvider Provider');
    }
    CrispChatProvider.prototype.getIcHash = function () {
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        var params = {
            action: 'getIcHash',
            email: this.userSettingsProvider.getUserSettings().email
        };
        return this.http.post("/notification/icHash", params, httpOptions)
            .map(function (response) {
            return response;
        });
    };
    CrispChatProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_2__user_settings_user_settings__["a" /* UserSettingsProvider */]])
    ], CrispChatProvider);
    return CrispChatProvider;
}());

//# sourceMappingURL=crisp-chat.js.map

/***/ }),

/***/ 399:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PipesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ec_date_ec_date__ = __webpack_require__(484);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__truncate_truncate__ = __webpack_require__(485);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};



var PipesModule = /** @class */ (function () {
    function PipesModule() {
    }
    PipesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["L" /* NgModule */])({
            declarations: [__WEBPACK_IMPORTED_MODULE_1__ec_date_ec_date__["a" /* EcDatePipe */], __WEBPACK_IMPORTED_MODULE_2__truncate_truncate__["a" /* TruncatePipe */]],
            imports: [],
            exports: [__WEBPACK_IMPORTED_MODULE_1__ec_date_ec_date__["a" /* EcDatePipe */], __WEBPACK_IMPORTED_MODULE_2__truncate_truncate__["a" /* TruncatePipe */]]
        })
    ], PipesModule);
    return PipesModule;
}());

//# sourceMappingURL=pipes.module.js.map

/***/ }),

/***/ 400:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ActionButtonsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_badge_count_badge_count__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_fromPromise__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var ActionButtonsProvider = /** @class */ (function () {
    function ActionButtonsProvider(_http, _badgeCountProvider) {
        this._http = _http;
        this._badgeCountProvider = _badgeCountProvider;
    }
    /**
     *
     * @param data like action
     */
    ActionButtonsProvider.prototype.like = function (data) {
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/feed/like", data, httpOptions)
            .map(function (response) {
            return response;
        });
    };
    /**
     * Twitter favorite/Unfavorite action
     */
    ActionButtonsProvider.prototype.favorite = function (data) {
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/feed/favorite", data, httpOptions)
            .map(function (response) {
            return response;
        });
    };
    /**
     * follow/unfollow action
     */
    ActionButtonsProvider.prototype.follow = function (data) {
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/feed/follow", data, httpOptions)
            .map(function (response) {
            return response;
        });
    };
    /**
     * mark as complete for inbox feed items
     * @param eventButtonsInput
     */
    ActionButtonsProvider.prototype.markComplete = function (eventButtonsInput) {
        var _this = this;
        var feedData = (eventButtonsInput.data[0]) ? eventButtonsInput.data[0] : eventButtonsInput.data;
        console.log('feedData', feedData);
        var actionButtonRequestBody = {
            date: feedData.eventTime,
            eventUserName: feedData.eventUserName.toLowerCase(),
            ecCompleted: !eventButtonsInput.actionButtons.completeItem.highlighted
        };
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        //convert only booleans to string
        for (var key in actionButtonRequestBody) {
            requestBody = requestBody.append("events[0][" + key + "]", actionButtonRequestBody[key].toString());
        }
        ; //end for loop
        return this
            ._http
            .post("/user/events", requestBody)
            .map(function (response) {
            _this
                ._badgeCountProvider
                .getInboxUncompletedBadgeCount()
                .subscribe(function (badgeCount) { });
            return response;
        });
        ;
    };
    ;
    ActionButtonsProvider.prototype.deleteFeedItem = function (data, url) {
        if (url === void 0) { url = '/feed/deletePost'; }
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post(url, data, httpOptions);
    };
    ;
    ActionButtonsProvider.prototype.deleteIGFeedItem = function (data) {
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/feed/deletePost", data, httpOptions);
    };
    ;
    // let httpOptions = {
    //     headers: new HttpHeaders({ 'Content-Type': 'application/json' })
    // };
    // return this
    //     ._http
    //     .post<HttpResponse<any>>("/feed/like", data, httpOptions)
    //     .map((response: any) => {
    //         return response;
    //     });
    ActionButtonsProvider.prototype.reply = function (data) {
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/feed/reply", data, httpOptions);
    };
    ActionButtonsProvider.prototype.hide = function () {
    };
    /**
     * mark as complete for inbox feed items
     * @param eventButtonsInput
     */
    ActionButtonsProvider.prototype.updateUserEvents = function (item) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        //convert only booleans to string
        for (var key in item) {
            requestBody = requestBody.append("events[0][" + key + "]", item[key].toString());
        }
        ; //end for loop
        return this
            ._http
            .post("/user/events", requestBody)
            .map(function (response) {
            // this._badgeCountProvider.getInboxUncompletedBadgeCount().subscribe((badgeCount) => {});
            return response;
        });
        ;
    };
    ;
    ActionButtonsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_2__providers_badge_count_badge_count__["a" /* BadgeCountProvider */]])
    ], ActionButtonsProvider);
    return ActionButtonsProvider;
}());

//# sourceMappingURL=action-button.js.map

/***/ }),

/***/ 401:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MentionsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var MentionsProvider = /** @class */ (function () {
    function MentionsProvider(_http) {
        this._http = _http;
        this.isMentionsPageOpened = false;
        this.querySource = new __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        this.query$ = this.querySource.asObservable();
        this.ecKeyUpSource = new __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__["BehaviorSubject"](false);
        this.ecKeyUp$ = this.ecKeyUpSource.asObservable();
        this.mentions = [];
    }
    ;
    /**
     * setMentionsPageStatus
     */
    MentionsProvider.prototype.setMentionsPageStatus = function (flag) {
        if (flag === void 0) { flag = false; }
        this.isMentionsPageOpened = flag;
    };
    /**
     * getMentionsPageStatus
     */
    MentionsProvider.prototype.getMentionsPageStatus = function () {
        return this.isMentionsPageOpened;
    };
    /**
     * getMentionsCount
     */
    MentionsProvider.prototype.getMentionsCount = function () {
        return this.mentions.length;
    };
    /**
     * resetMentions
     */
    MentionsProvider.prototype.unsetMentions = function () {
        this.mentions = [];
    };
    MentionsProvider.prototype.getMentions = function (q, profile) {
        if (q === void 0) { q = ''; }
        var network = profile.display.network.backend_network_name.toLowerCase();
        console.log('mappedMentions', network);
        if (network === 'twitter') {
            return this.getTWMentions(q, profile);
        }
        if (network === 'facebook') {
            return this.getFBMentions(q, profile);
        }
        if (network === 'linkedin') {
            return this.getLNMentions(q, profile);
        }
        if (network === 'instagram' || network === 'instabusiness') {
            return this.getIGMentions(q, profile);
        }
    };
    MentionsProvider.prototype.getTWMentions = function (q, profile) {
        var _this = this;
        if (q === void 0) { q = ''; }
        var params = {
            action: 'getTWSearch',
            parameters: [{ key: 'q', value: q }],
            type: 'users',
            accountID: profile.account_id,
            profileID: profile.profile_id
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/listMentions', params, httpOptions)
            .map(function (httpResponse) {
            console.log(httpResponse);
            _this.mentions = [];
            if (httpResponse.returnCode && httpResponse.returnCode === 'SUCCESS' && httpResponse.data) {
                var data = Array.isArray(httpResponse.data) ? httpResponse.data : [httpResponse.data];
                for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
                    var item = data_1[_i];
                    var mention = {
                        profile_picture_url: item.profile_image_url,
                        name: item.name,
                        screenName: item.screen_name,
                        isVerified: (item.verified === 'true'),
                        rawData: item,
                        type: 'twitter'
                    };
                    _this.mentions.push(mention);
                }
            }
            console.log('mentions', _this.mentions);
            return _this.mentions;
        });
    };
    MentionsProvider.prototype.getFBMentions = function (q, profile) {
        var _this = this;
        if (q === void 0) { q = ''; }
        var params = {
            action: 'doFbRequest',
            stream: 'search',
            parameters: [{ key: 'q', value: q }, { key: 'type', value: 'page' }],
            wall: false,
            next: '?typeahead',
            limit: 10,
            type: 'publish_mention',
            accountID: profile.account_id,
            profileID: profile.profile_id
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/listMentions', params, httpOptions)
            .map(function (httpResponse) {
            console.log(httpResponse);
            if (httpResponse.data) {
                var data = Array.isArray(httpResponse.data) ? httpResponse.data : [httpResponse.data];
                _this.mentions = [];
                for (var _i = 0, data_2 = data; _i < data_2.length; _i++) {
                    var item = data_2[_i];
                    var mention = {
                        profile_picture_url: 'https://graph.facebook.com/' + item.fromId + '/picture?width=50&height=50',
                        name: item.fromName,
                        screenName: null,
                        isVerified: (item.verification_status === 'blue_verified'),
                        rawData: item,
                        type: 'facebook'
                    };
                    var loc = item.location;
                    if (loc) {
                        mention.address = (loc.street ? loc.street + ' ' : '') + (loc.city ? loc.city + ' ' : '') + (loc.state ? loc.state + ' ' : '')
                            + (loc.country ? loc.country + ' ' : '') + (loc.zip ? loc.zip + ' ' : '');
                    }
                    _this.mentions.push(mention);
                }
            }
            console.log('mentions', _this.mentions);
            return _this.mentions;
        });
    };
    MentionsProvider.prototype.getIGMentions = function (q, profile) {
        var _this = this;
        if (q === void 0) { q = ''; }
        var params = {
            action: 'getInFeed',
            stream: 'search',
            parameters: [{ key: 'q', value: q }, { key: 'type', value: 'tags' }],
            accountID: profile.account_id,
            profileID: profile.profile_id
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/listMentions', params, httpOptions)
            .map(function (httpResponse) {
            console.log(httpResponse);
            if (httpResponse.data) {
                var data = Array.isArray(httpResponse.data) ? httpResponse.data : [httpResponse.data];
                _this.mentions = [];
                for (var _i = 0, data_3 = data; _i < data_3.length; _i++) {
                    var item = data_3[_i];
                    var mention = {
                        profile_picture_url: '',
                        name: item.type,
                        screenName: null,
                        postsCount: 0,
                        rawData: item,
                        type: 'instagram'
                    };
                    if (item.comments && item.comments.count) {
                        mention.postsCount = _this.numberWithCommas(item.comments.count);
                    }
                    _this.mentions.push(mention);
                }
            }
            console.log('mentions', _this.mentions);
            return _this.mentions;
        });
    };
    MentionsProvider.prototype.getLNMentions = function (q, profile) {
        var _this = this;
        if (q === void 0) { q = ''; }
        if (q == "" || !profile)
            return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].of([]);
        var params = {
            action: 'getLnsSearch',
            stream: 'search',
            parameters: [{ key: 'q', value: q }],
            accountID: profile.account_id,
            profileID: profile.profile_id
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json', 'skipLoader': 'true' })
        };
        return this
            ._http
            .post('/publishing/listMentions', params, httpOptions)
            .map(function (httpResponse) {
            // console.log('mentions',httpResponse);
            _this.mentions = [];
            if (httpResponse.streamEntry) {
                var data = Array.isArray(httpResponse.streamEntry) ? httpResponse.streamEntry : [httpResponse.streamEntry];
                for (var _i = 0, data_4 = data; _i < data_4.length; _i++) {
                    var item = data_4[_i];
                    var mention = {
                        profile_picture_url: item.smallLogoUrl || "",
                        name: item.name,
                        screenName: null,
                        postsCount: 0,
                        rawData: item,
                        type: "linkedin"
                    };
                    if (item.comments && item.comments.count) {
                        mention.postsCount = _this.numberWithCommas(item.comments.count);
                    }
                    _this.mentions.push(mention);
                }
            }
            // console.log('getLNMentions', this.mentions);
            return _this.mentions;
        });
    };
    /**
     * getFBMentionReplaceText
     */
    MentionsProvider.prototype.getFBMentionReplaceText = function (mentionName) {
        var key = '@' + mentionName;
        var replaceText = '<span data-id="' + key + '" class="mentions-key hide">@</span>';
        replaceText += '<span data-id="' + key + '" data-screen-name ="' + mentionName + '" class="mentions-value">' + mentionName + '</span>&nbsp;';
        return replaceText;
    };
    /**
     * getFBMentionReplaceText
     */
    MentionsProvider.prototype.getLNMentionReplaceText = function (mentionName) {
        var key = mentionName;
        var replaceText = '<span data-id="' + key + '" data-screen-name ="' + mentionName + '" class="mentions-value">' + mentionName + '</span>&nbsp;';
        return replaceText;
    };
    /**
     * getTWMentionReplaceText
     */
    MentionsProvider.prototype.getTWMentionReplaceText = function (mentionName, key) {
        if (key === void 0) { key = '@'; }
        return '<span data-id="' + mentionName + '" data-screen-name ="' + mentionName + '" class="twitter mentions-value">' + (key + mentionName) + '</span>&nbsp;';
    };
    MentionsProvider.prototype.numberWithCommas = function (x) {
        if (x == undefined)
            return '';
        var parts = x.toString().split(".");
        parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        return parts.join(".");
    };
    MentionsProvider.prototype.test = function () {
        return 'i am from MentionsProvider...';
    };
    MentionsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], MentionsProvider);
    return MentionsProvider;
}());

; //end MentionsProvider
;
//# sourceMappingURL=mention.js.map

/***/ }),

/***/ 402:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EcUploaderProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_file_transfer__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_file__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_file_path__ = __webpack_require__(348);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var EcUploaderProvider = /** @class */ (function () {
    function EcUploaderProvider(http, fileTransfer, file, platform, filePath) {
        this.http = http;
        this.fileTransfer = fileTransfer;
        this.file = file;
        this.platform = platform;
        this.filePath = filePath;
        this.s3BaseURL = 'https://s3.amazonaws.com/dev-eclincher/';
        this.s3BaseThumbURL = 'https://s3.amazonaws.com/eclincher-prod-post-imgs/';
        this.s3Url = 'https://s3.amazonaws.com/';
        this.imageBucket = 'uploads.eclincher';
        this.videoBucket = 'videouploads.eclincher';
        this.thumbBucket = 'eclincher-prod-post-imgs';
        // source for observable
        this.loadingProgressSource = new __WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject__["BehaviorSubject"](0);
        // observable stream
        this.loadingProgressStatus$ = this
            .loadingProgressSource
            .asObservable();
        this.thumbnailCheckCount = 0;
        this.maxThumbnailCheckCount = 10;
        this.startTimeout = 2000;
        this.loopTimeout = 500;
    }
    /**
     * getFileInfo
     */
    EcUploaderProvider.prototype.getFileInfo = function (fileURI, isGetImageDimention) {
        var _this = this;
        if (isGetImageDimention === void 0) { isGetImageDimention = false; }
        return new Promise(function (resolve, reject) {
            var fileName = fileURI.split('/').pop();
            var directoryPath = fileURI.replace('/' + fileName, '');
            _this.file.resolveDirectoryUrl(directoryPath).then(function (directoryEntry) {
                _this.file.getFile(directoryEntry, fileName, {}).then(function (fileEntry) {
                    fileEntry.file(function (file) {
                        if (!isGetImageDimention) {
                            resolve(file);
                        }
                        else {
                            var reader = new FileReader();
                            reader.onloadend = function (evt) {
                                var image = new Image();
                                var fileData = {};
                                fileData.file = file;
                                image.onload = function (evt) {
                                    image.width = this["width"];
                                    image.height = this["height"];
                                    fileData.width = this["width"];
                                    fileData.height = this["height"];
                                    resolve(fileData);
                                };
                                image.src = (typeof evt.target["result"] === 'string') ? evt.target["result"] : '';
                            };
                            reader.readAsDataURL(file);
                        }
                    }, function (error) { console.log('getFileInfo error 1', JSON.stringify(error)); resolve(null); });
                }, function (error) { console.log('getFileInfo error 2', JSON.stringify(error)); resolve(null); });
            }, function (error) { console.log('getFileInfo error 3', JSON.stringify(error)); resolve(null); });
        });
    };
    EcUploaderProvider.prototype.getNativeFileInfo = function (fileURI, isGetImageDimention) {
        var _this = this;
        if (isGetImageDimention === void 0) { isGetImageDimention = false; }
        return new Promise(function (resolve, reject) {
            _this.filePath.resolveNativePath(fileURI).then(function (filePathUrl) {
                console.log('filePathUrl', filePathUrl);
                resolve(filePathUrl);
            }, function (error) { console.log('getFileInfo error 1', JSON.stringify(error)); resolve(null); });
        });
    };
    /**
     * s3Upload
     */
    EcUploaderProvider.prototype.s3Upload = function (params) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            //choose bucket
            var bucket = _this.getBucket(params.extension);
            var path = 'dktp' + _this.getRandomHexNo() + '/' + params.fileName;
            //set type of upload(image/video)
            params.isVideo = _this.isVideo(params.extension);
            if (params.isVideo) { //For Video ppload
                _this.startTimeout = 14000;
                _this.loopTimeout = 4000;
                _this.maxThumbnailCheckCount = 60;
            }
            else { //For Image ppload
                _this.startTimeout = 2000;
                _this.loopTimeout = 500;
                _this.maxThumbnailCheckCount = 10;
            }
            _this.getS3Credentilas(bucket).then(function (data) {
                if (data === null) { //If credentilad are not valid
                    resolve(null);
                }
                else {
                    //prepare options of FileTransfer
                    var options = {
                        fileKey: "file",
                        fileName: path,
                        mimeType: params.mimeType,
                        chunkedMode: false,
                        params: {
                            "key": path,
                            "AWSAccessKeyId": data.awsKey,
                            "acl": "public-read",
                            "policy": data.policy,
                            "signature": data.signature,
                            "Content-Type": params.mimeType
                        }
                    };
                    var fileTransfer = _this.fileTransfer.create();
                    fileTransfer.upload(params.fileURI, "http://" + bucket + ".s3.amazonaws.com/", options)
                        .then(function (data) {
                        console.log('file uploaded::', params);
                        var imageData = {
                            originalData: {},
                            url: {
                                full: _this.s3BaseURL + path,
                                thumbnail: _this.s3BaseThumbURL + path,
                                isVideo: false
                            }
                        };
                        imageData.originalData.name = params.fileName.split('.')[0], // +  '_ecsize_'+resp.img_width+'_'+resp.img_height+'_'+ params.size;
                            imageData.originalData.size = params.size;
                        imageData.originalData.type = 'picture';
                        imageData.originalData.location = path;
                        imageData.originalData.s3_url = bucket + '/' + path;
                        imageData.originalData.imageThumbnail = _this.thumbBucket + '/' + path;
                        setTimeout(function () {
                            _this.isThumbnailGenerated(params, _this.thumbBucket, path).then(function (dimension) {
                                console.log('After isThumbnailGenerated:::', dimension);
                                if (params.isVideo) {
                                    imageData.originalData.type = 'video';
                                    imageData.url.isVideo = true;
                                    // In LAMDA at D3, all videos will be converted as mp4 
                                    imageData.originalData.location = imageData.originalData.location.replace('.mov', '.mp4').replace('.MOV', '.mp4');
                                    var s3Url = "dev-eclincher/" + path;
                                    imageData.originalData.s3_url = s3Url.replace('.mov', '.mp4').replace('.MOV', '.mp4');
                                    var temp1 = path.split('.');
                                    temp1[temp1.length - 1] = 'json';
                                    var jsonFile = _this.s3BaseURL + temp1.join('.');
                                    _this.getGeneratedThumbnails(jsonFile, path).then(function (videoData) {
                                        console.log("mappedImageData", videoData);
                                        imageData.originalData.videoData = videoData;
                                        if (videoData.videoThumbnails.thumbnail && Array.isArray(videoData.videoThumbnails.thumbnail)) {
                                            imageData.url.full = _this.s3Url + videoData.videoThumbnails.thumbnail[0];
                                            imageData.url.thumbnail = _this.s3Url + videoData.videoThumbnails.thumbnail[0];
                                            imageData.originalData.imageThumbnail = videoData.videoThumbnails.thumbnail[0];
                                        }
                                        resolve(imageData);
                                    });
                                }
                                else {
                                    if (dimension) {
                                        imageData.originalData.dimension = dimension;
                                    }
                                    else {
                                        imageData.originalData.imageThumbnail = null;
                                        imageData.url.full = 'https://s3.amazonaws.com/' + imageData.originalData.s3_url;
                                        imageData.url.thumbnail = imageData.url.full;
                                    }
                                    resolve(imageData);
                                }
                            });
                        }, _this.startTimeout);
                    }, function (err) {
                        // error
                        console.log('S3-upload error::', err);
                        resolve(null);
                    });
                    //loader part
                    fileTransfer.onProgress(function (listener) {
                        if (listener.lengthComputable) {
                            var percent = Math.round((listener.loaded / listener.total) * 100);
                            _this.loadingProgressSource.next(percent);
                        }
                    });
                }
            });
        });
    };
    EcUploaderProvider.prototype.urlUploadToS3 = function (images) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var data = {
                action: 's3',
                images: images
            };
            _this
                .http
                .post('/upload/s3', data)
                .subscribe(function (response) {
                resolve(response);
            });
        });
    };
    /**
     * getS3Credentilas
     */
    EcUploaderProvider.prototype.getS3Credentilas = function (bucket) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var apiPath = "/publishing/signing_url";
            var requestBody = { bucket: bucket };
            _this
                .http
                .post(apiPath, requestBody)
                .subscribe(function (resp) {
                var httpResponse = resp;
                var data = {
                    awsKey: httpResponse.awsKey,
                    policy: httpResponse.policy,
                    signature: httpResponse.signature
                };
                resolve(data);
            }, function (error) {
                resolve(null);
            });
        });
    };
    /**
     * checkThumbNailGeneration
     */
    EcUploaderProvider.prototype.checkThumbNailGeneration = function (thumbBucket, thumbName, isVideo) {
        var _this = this;
        if (isVideo === void 0) { isVideo = false; }
        return new Promise(function (resolve, reject) {
            //prepare apiPath and httpParams
            var apiPath = "/publishing/check_s3_obj";
            if (isVideo) {
                thumbBucket = 'dev-eclincher';
                var temp = thumbName.split('.');
                temp[temp.length - 1] = 'json';
                thumbName = temp.join('.');
            }
            var requestBody = {
                bucket: thumbBucket,
                key: thumbName,
                is_video: isVideo ? "true" : "false"
            };
            _this
                .http
                .post(apiPath, requestBody)
                .subscribe(function (response) {
                var data = response;
                var dimension;
                if (data.success == undefined || data.success == false) {
                    dimension = null;
                }
                else {
                    if (isVideo) {
                        dimension = {
                            width: 0,
                            height: 0,
                            size: 0
                        };
                    }
                    else {
                        dimension = {
                            width: data.img_width,
                            height: data.img_height,
                            size: data.success.size
                        };
                    }
                }
                _this.thumbnailCheckCount++;
                setTimeout(function () {
                    resolve(dimension);
                }, (_this.thumbnailCheckCount > 1 ? _this.loopTimeout : 0));
            }, function (error) {
                _this.thumbnailCheckCount++;
                reject(error);
            });
        });
    };
    EcUploaderProvider.prototype.isThumbnailGenerated = function (params, thumbBucket, thumbName) {
        var _this = this;
        return this.checkThumbNailGeneration(thumbBucket, thumbName, params.isVideo).then(function (flag) {
            console.log('coming here', _this.thumbnailCheckCount, _this.maxThumbnailCheckCount);
            if (flag === null) {
                if (_this.thumbnailCheckCount == _this.maxThumbnailCheckCount) {
                    return null;
                }
                else {
                    return _this.isThumbnailGenerated(params, thumbBucket, thumbName);
                }
            }
            else {
                return flag;
            }
        }, function (error) {
            return null;
        });
    };
    EcUploaderProvider.prototype.getGeneratedThumbnails = function (jsonFile, path) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            //prepare apiPath and httpParams
            _this
                .http
                .get(jsonFile)
                .subscribe(function (resp) {
                console.log('getThumbnails::Success::', resp);
                var data = resp;
                var videoData = { videoMetaData: {}, videoThumbnails: {} };
                videoData.videoThumbnails.thumbnail = [];
                videoData.videoMetaData = (data.streams != undefined && data.streams[0] != undefined) ? data.streams[0] : {};
                var video_size = (data.format != undefined && data.format.size != undefined) ? data.format.size : '';
                var video_duration = (data.format != undefined && data.format.duration != undefined) ? data.format.duration : false;
                videoData.videoMetaData.size = video_size;
                videoData.videoMetaData.viddeo_format = 'mp4';
                var thumbsnapSeconds = (data.format != undefined && data.format.thumbsnapSeconds != undefined) ? data.format.thumbsnapSeconds : 10;
                var tcount = (video_duration && video_duration / 15 < 10) ? video_duration / 15 : 10;
                tcount = ((parseFloat(tcount).toString()).indexOf('.') !== -1 && tcount < 10) ? parseInt(tcount) + 1 : tcount;
                videoData.videoMetaData.thumbTimeframes = {};
                video_duration = parseInt(video_duration);
                var thumbsnapmilliSeconds = thumbsnapSeconds * 1000;
                for (var i = 1; i <= tcount; i++) {
                    var temp = path.split('.');
                    temp[temp.length - 2] = temp[temp.length - 2] + ((i == 10) ? "_000" : "_0000") + i;
                    temp[temp.length - 1] = 'png';
                    var thumb = _this.thumbBucket + "/" + temp.join('.');
                    videoData.videoThumbnails.thumbnail.push(thumb);
                    videoData.videoMetaData.thumbTimeframes[thumb] = (i == 1) ? 0 : (i - 1) * thumbsnapmilliSeconds;
                }
                console.log('getThumbnails::videoData', videoData);
                resolve(videoData);
            }, function (error) {
                console.log('getThumbnails::Error::', error);
                resolve(null);
            });
        });
    };
    /**
     * resetLoadProgress
     */
    EcUploaderProvider.prototype.resetLoadProgress = function () {
        this.loadingProgressSource.next(0);
    };
    /**
     * setLoadProgress
     */
    EcUploaderProvider.prototype.setLoadProgress = function (n) {
        this.loadingProgressSource.next(n);
    };
    EcUploaderProvider.prototype.getBucket = function (extension) {
        if (['mov', 'avi', 'mp4'].indexOf(extension.toLowerCase()) !== -1) {
            return this.videoBucket;
        }
        return this.imageBucket;
    };
    EcUploaderProvider.prototype.isVideo = function (extension) {
        if (['mov', 'avi', 'mp4'].indexOf(extension.toLowerCase()) !== -1) {
            return true;
        }
        return false;
    };
    EcUploaderProvider.prototype.getRandomHexNo = function () {
        return Math.floor(Math.random() * 16777215).toString(16);
    };
    /**
     * uuid
     */
    EcUploaderProvider.prototype.uuid = function () {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0, v = c === 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    };
    EcUploaderProvider.prototype.fff = function (lp) {
        this.loadingProgressSource.next(lp + 5);
    };
    EcUploaderProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_file_transfer__["a" /* FileTransfer */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_file__["a" /* File */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["r" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_5__ionic_native_file_path__["a" /* FilePath */]])
    ], EcUploaderProvider);
    return EcUploaderProvider;
}());

;
;
//# sourceMappingURL=ec-uploader.js.map

/***/ }),

/***/ 406:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ScrappingProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_observable_forkJoin__ = __webpack_require__(137);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_observable_forkJoin___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_observable_forkJoin__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_publishing_service_publishing_map_post__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_jquery__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_base_64__ = __webpack_require__(491);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_base_64___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_9_base_64__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




//PROVIDERS






var ScrappingProvider = /** @class */ (function () {
    function ScrappingProvider(_http, _accountsServiceProvider, _publishingMapPostProvider, _userSettingsProvider) {
        this._http = _http;
        this._accountsServiceProvider = _accountsServiceProvider;
        this._publishingMapPostProvider = _publishingMapPostProvider;
        this._userSettingsProvider = _userSettingsProvider;
        this.isScrappingInProgress = false;
    }
    /**
       * scrape
       */
    ScrappingProvider.prototype.scrape = function (post, shrinkType) {
        var _this = this;
        if (shrinkType === void 0) { shrinkType = ''; }
        var isInputShorten = (shrinkType == '') ? false : true;
        return new Promise(function (resolve, reject) {
            var onlyUrl = _this.extractUrls(post);
            console.log('shortening shrinkType', shrinkType);
            shrinkType = (shrinkType == "") ? _this._userSettingsProvider.getShrinkOption() : shrinkType;
            var userSettings = _this._userSettingsProvider.userSettingsSource.value;
            if (onlyUrl.length
                && (typeof post.scrappedAttachments === 'undefined'
                    || (Array.isArray(post.scrappedAttachments) && !post.scrappedAttachments.length))) { // Scrape and Shrink
                if (_this.isScrappingInProgress) {
                    resolve(false);
                    return;
                }
                _this.isScrappingInProgress = true;
                var reqs = [];
                if ((post.attachments && post.attachments.length === 0) && __WEBPACK_IMPORTED_MODULE_7_jquery__["isEmptyObject"](post.previewContent))
                    reqs.push(_this.getScrappedData(onlyUrl, post));
                if (!isInputShorten && (userSettings && userSettings.automaticShortenLinks === 'false') || _this._userSettingsProvider.getShrinkOption() === 'none' || _this._userSettingsProvider.getShrinkOption() === '') {
                }
                else {
                    reqs.push(_this.shrinkUrl(onlyUrl, shrinkType));
                }
                Object(__WEBPACK_IMPORTED_MODULE_3_rxjs_observable_forkJoin__["forkJoin"])(reqs).subscribe(function (results) {
                    var link = { long: onlyUrl, short: onlyUrl };
                    if (results && results.length > 1 && results[1] !== null) { //if 2 requests exist
                        link = results[1];
                    }
                    //  else if (results && results.length == 1 && "long" in results[0]) { //if only one request exist and check if its shrink url request
                    // 	link = results[0];
                    // }
                    // if (!$.isEmptyObject(link)) {
                    if (results && results.length > 0) {
                        post.links.push(link);
                        post.link = link.long;
                        post.lastScrappedUrls = link;
                        if (results[0])
                            post.previewContent = results[0];
                        var replaceStr = link.short;
                        var tempContent = post.htmlContent.slice(0).trim();
                        tempContent = tempContent.replace('<a href="' + link.long + '">' + link.long + '</a>', link.long); //to remove the a tag added
                        if (!__WEBPACK_IMPORTED_MODULE_7_jquery__["isEmptyObject"](post.previewContent)
                            && typeof post.previewContent.title === 'string'
                            && post.previewContent.title.length) {
                            if (userSettings && userSettings.includeTitleWithShortenLink !== 'false') {
                                replaceStr = post.previewContent.title + ' ' + replaceStr;
                            }
                        }
                        post.htmlContent = tempContent.replace(link.long, replaceStr).trim();
                        post.htmlContent += ' ';
                        post.htmlContent = post.htmlContent.replace(/  +/g, ' ');
                    }
                    _this.isScrappingInProgress = false;
                    post.updateCharactersLimit();
                    resolve(true);
                });
            }
            else { // Shrink
                if (userSettings && userSettings.automaticShortenLinks === 'false') {
                    resolve(false);
                    return;
                }
                if (!onlyUrl.length) {
                    resolve(false);
                    return;
                }
                if (__WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["q" /* validateShortLinkDomains */](onlyUrl.trim())) {
                    resolve(false);
                    return;
                }
                _this
                    .shrinkUrl(onlyUrl, shrinkType)
                    .subscribe(function (result) {
                    if (result !== null) {
                        var link = result;
                        if (!__WEBPACK_IMPORTED_MODULE_7_jquery__["isEmptyObject"](link)) {
                            post.links.push(link);
                            post.link = link.long;
                            post.htmlContent = post.htmlContent.replace(link.long, link.short).trim();
                            post.htmlContent += ' ';
                            post.htmlContent = post.htmlContent.replace(/  +/g, ' ');
                        }
                    }
                    post.updateCharactersLimit();
                    resolve(true);
                });
            }
        });
    };
    ScrappingProvider.prototype.getScrappedData = function (scrapeUrl, post) {
        var _this = this;
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        httpParams = httpParams.set("action", 'scrapeUrl');
        httpParams = httpParams.set("scrap_image_limit", '5');
        httpParams = httpParams.set("scrap_image_width", '80');
        httpParams = httpParams.set("scrap_image_height", '80');
        httpParams = httpParams.set("skip_cache", 'true');
        httpParams = httpParams.set("convert_image_to_rawstring", 'false');
        httpParams = httpParams.set("scrap_depth", 'true');
        if (scrapeUrl.indexOf('http://') == -1
            && scrapeUrl.indexOf('https://') == -1
            && scrapeUrl.indexOf('//') == -1) {
            scrapeUrl = "http://" + scrapeUrl;
        }
        httpParams = httpParams.set("url_to_scrape", __WEBPACK_IMPORTED_MODULE_9_base_64__["encode"](scrapeUrl));
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .get("/publishing/scrapeurl", { params: httpParams })
            .flatMap(function (resp) {
            console.log(resp);
            var httpResponse = resp;
            if (httpResponse.returnCode == 'SUCCESS') {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(_this.getPreviewContent(httpResponse, post, scrapeUrl).then(function (previewContent) {
                    post.previewContent = previewContent;
                    return previewContent;
                }));
            }
            else {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(null);
            }
        });
    };
    /**
     * shrinkUrl
     */
    ScrappingProvider.prototype.shrinkUrl = function (url, shrinkOption) {
        console.log("shrinkOption", shrinkOption);
        url = url.replace(/\&nbsp/g, ''); //remove &nbsp
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        var data = {
            action: 'shorten_url',
            url: url,
            shrink_opt: shrinkOption
        };
        return this
            ._http
            .post("/publishing/shortenurl", data, httpOptions)
            .map(function (resp) {
            var httpResponse = resp;
            var link = null;
            if (typeof httpResponse.short_url == 'string') {
                link = {
                    long: url,
                    short: httpResponse.short_url
                };
            }
            return link;
        });
    };
    /**
     * keyUpEvent
     */
    ScrappingProvider.prototype.keyUpEvent = function (post) {
        post.updateProfilesFlag();
        if (post.accounts.length) {
            var limit = post.limitCharacters(post.content);
            post.content = limit.text;
        }
        if (!__WEBPACK_IMPORTED_MODULE_7_jquery__["isEmptyObject"](post.previewContent) && post.link && post.links) {
            if (post.accounts.length === 0 || post.has_twitter_profile) {
                this.checkLinkDeletion(post);
            }
        }
    };
    ScrappingProvider.prototype.getPreviewContent = function (response, post, url) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var parsedData = {
                title: '',
                description: '',
                image: [],
                url: url,
                scrappedUrl: '',
                twitterData: {},
                twitterTag: false,
                isFbUrl: false
            };
            // Parse OpenGraph data
            if (response.opengraph && Array.isArray(response.opengraph)) {
                parsedData = _this.parseOpenGraph(response.opengraph);
            }
            // Parse Meta data
            if (response.metadata && Array.isArray(response.metadata)) {
                var tempData = _this.parseMetaData(response.metadata);
                if (!parsedData.title.length) {
                    parsedData.title = tempData.title;
                }
                if (!parsedData.description.length) {
                    parsedData.description = tempData.description;
                }
                if (!parsedData.image.length) {
                    parsedData.image = tempData.image;
                }
            }
            // Parse twitter data
            if (typeof response.twitter_data === 'object' && response.twitter_data) {
                parsedData.twitterData = _this.parseTwitterData(response.twitter_data, parsedData);
            }
            // set twitter tag
            if (typeof response.twitter_tag === 'boolean') {
                parsedData.twitterTag = response.twitter_tag;
            }
            // remove gif images
            for (var i = 0; i < parsedData.image.length; i++) {
                var element = parsedData.image[i];
                if (element && element.type && element.type === 'image/gif') {
                    parsedData.image.splice(i, 1);
                }
            }
            console.log('parsedData', parsedData);
            if (parsedData.image.length) {
                var tempImage = parsedData.image;
                parsedData.image = [];
                if (!parsedData.twitterTag) {
                    for (var _i = 0, tempImage_1 = tempImage; _i < tempImage_1.length; _i++) {
                        var img = tempImage_1[_i];
                        parsedData.image.push({
                            name: __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["g" /* getUUID */](),
                            image: img.file || img.src,
                            src: img.file || img.src,
                            imageUrlSource: img.src,
                            source: 'scrape',
                            type: 'picture',
                            width: img.width || 0,
                            height: img.height || 0,
                            dimension: { width: img.width, height: img.height, size: 0 }
                        });
                    }
                }
                else {
                    parsedData.image = [{
                            name: __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["g" /* getUUID */](),
                            image: tempImage[0].file || tempImage[0].src,
                            imageUrlSource: tempImage[0].src,
                            src: tempImage[0].src,
                            source: 'scrape',
                            type: 'picture',
                            width: tempImage[0].width || 0,
                            height: tempImage[0].height || 0,
                            dimension: { width: tempImage[0].width, height: tempImage[0].height, size: 0 }
                        }];
                }
                if (response.twitter_tag
                    && !post.has_pinterest_profile
                    && !post.has_instagram_profile
                    && !post.has_googlemybusiness_profile) {
                    //parsedData.image = [];
                }
            }
            if (response.twitter_tag
                && !__WEBPACK_IMPORTED_MODULE_7_jquery__["isEmptyObject"](response.twitter_data)
                && response.twitter_data.image != undefined
                && (!response.twitter_data.image
                    || response.twitter_data.image.imageUrlSource !== response.twitter_data.image)) {
                if (parsedData.twitterData) {
                    parsedData.twitterData.image = response.twitter_data.image;
                }
            }
            if (!post.has_pinterest_profile
                && !post.has_instagram_profile
                && !post.has_fb_profile
                && !post.has_googlemybusiness_profile) {
                post.attachments = [];
            }
            // pending_post.preview_content = all_content;
            console.log('allContent', parsedData);
            if (parsedData.image.length) {
                var originalData = parsedData.image[0];
                originalData.name = __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["g" /* getUUID */]();
                originalData.previewContent = parsedData;
                var attachment = {
                    originalData: originalData,
                    url: {
                        full: originalData.src,
                        thumbnail: originalData.src,
                        isVideo: false,
                        isScrapped: true
                    }
                };
                post.scrappedAttachments = [attachment];
                _this.includeScrappedAttachments(post);
            }
            if (response.fbUrl != undefined && response.fbUrl) {
                parsedData.isFbUrl = response.fbUrl;
                parsedData.image = [];
            }
            resolve(parsedData);
        });
    };
    /**
     * includeScrappedAttachments
     * include scrapped images only if the post has twitter , pinterest, instgarm or googlemybusiness
     */
    ScrappingProvider.prototype.includeScrappedAttachments = function (post) {
        post.updateProfilesFlag();
        if (post.has_twitter_profile || post.has_pinterest_profile
            || post.has_instagram_profile || post.has_googlemybusiness_profile) {
            if (post.scrappedAttachments && Array.isArray(post.scrappedAttachments) && post.scrappedAttachments.length) {
                post.attachments = [];
                for (var _i = 0, _a = post.scrappedAttachments; _i < _a.length; _i++) {
                    var sa = _a[_i];
                    post.attachments.push(sa);
                }
            }
        }
    };
    /**
    * HELPER FUNCTIONS
    */
    ScrappingProvider.prototype.extractUrls = function (post) {
        // Extract urls from post content
        var urls = __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["c" /* extractUrls */](post.htmlContent), i = urls.length;
        // check and remove urls which already exists in links array of post
        while (i--) {
            var found = false;
            if (post.links && post.links.length) {
                for (var _i = 0, _a = (post.links); _i < _a.length; _i++) {
                    var linkObj = _a[_i];
                    if (linkObj.long == urls[i].url || linkObj.short == urls[i].url) {
                        found = true;
                    }
                }
            }
            if (post.lastScrappedUrls) {
                if (post.lastScrappedUrls.long === urls[i].url || post.lastScrappedUrls.short === urls[i].url)
                    found = true;
            }
            if (found) {
                urls.splice(i, 1);
            }
        }
        var shrinkOption = this._userSettingsProvider.getShrinkOption(), onlyUrl = '';
        for (var _b = 0, urls_1 = urls; _b < urls_1.length; _b++) {
            var urlObj = urls_1[_b];
            // if(shrinkOption !== 'none' && urlObj.url.indexOf(shrinkOption) === -1) {
            onlyUrl = urlObj.url;
            // }
        }
        return onlyUrl;
    };
    ScrappingProvider.prototype.parseOpenGraph = function (opengraph) {
        var parsedData = {
            title: '',
            description: '',
            image: [],
            scrappedUrl: '',
            twitterData: {}
        };
        for (var _i = 0, opengraph_1 = opengraph; _i < opengraph_1.length; _i++) {
            var graph = opengraph_1[_i];
            switch (graph.key) {
                case 'title':
                    parsedData.title = graph.value;
                    break;
                case 'image':
                    parsedData.image = graph.value;
                    break;
                case 'description':
                    parsedData.description = graph.value;
                    break;
                case 'scraped_url':
                    parsedData.scrappedUrl = graph.value;
                    break;
            }
        }
        parsedData.title = __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["e" /* getDecodedHtmlContent */](parsedData.title);
        parsedData.description = __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["e" /* getDecodedHtmlContent */](parsedData.description);
        return parsedData;
    };
    ScrappingProvider.prototype.parseMetaData = function (metaData) {
        var parsedData = {
            title: '',
            description: '',
            image: [],
            scrappedUrl: '',
            twitterData: {}
        };
        for (var _i = 0, metaData_1 = metaData; _i < metaData_1.length; _i++) {
            var meta = metaData_1[_i];
            switch (meta.key) {
                case 'title':
                    parsedData.title = meta.value;
                    break;
                case 'sailthru.image.full':
                    parsedData.image = meta.value;
                    break;
                case 'description':
                    parsedData.description = meta.value;
                    break;
            }
        }
        parsedData.title = __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["e" /* getDecodedHtmlContent */](parsedData.title);
        parsedData.description = __WEBPACK_IMPORTED_MODULE_8__providers_publishing_service_publishing_helper__["e" /* getDecodedHtmlContent */](parsedData.description);
        return parsedData;
    };
    ScrappingProvider.prototype.parseTwitterData = function (twitterData, parsedData) {
        var updatedData = {};
        var keys = Object.keys(twitterData);
        for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
            var key = keys_1[_i];
            if (key === 'image') { }
            else if (key === 'title' && twitterData[key] === parsedData.title) { }
            else if (key === 'description' && twitterData[key] === parsedData.description) { }
            else
                updatedData[key] = twitterData[key];
        }
        return updatedData;
    };
    ScrappingProvider.prototype.checkLinkDeletion = function (post) {
        var urlsToFind = [], deletePreview = true;
        for (var _i = 0, _a = post.links; _i < _a.length; _i++) {
            var linkObject = _a[_i];
            if (linkObject.long === post.link || linkObject.short === post.link) {
                urlsToFind = [];
                urlsToFind.push(linkObject.long);
                urlsToFind.push(linkObject.short);
            }
        }
        if (urlsToFind.length && (post.htmlContent.indexOf(urlsToFind[0]) !== -1 || post.htmlContent.indexOf(urlsToFind[1]) !== -1 || post.has_pinterest_profile || post.has_googlemybusiness_profile)) {
            deletePreview = false;
        }
        if (deletePreview) {
            post.previewContent = null;
            post.links = [];
            post.link = '';
            post.attachments = [];
            post.lastScrappedUrls = {
                long: '',
                short: ''
            };
            post.scrappedAttachments = [];
        }
    };
    ScrappingProvider.prototype.validateShortLinkDomains = function (str) {
        var short_link_domains = ['bit.do',
            't.co',
            'lnkd.in',
            'db.tt',
            'qr.ae',
            'adf.ly',
            'goo.gl',
            'bitly.com',
            'cur.lv',
            'tinyurl.com',
            'ow.ly',
            'bit.ly',
            'ity.im',
            'q.gs',
            'is.gd',
            'po.st',
            'bc.vc',
            'twitthis.com',
            'u.to',
            'j.mp',
            'buzurl.com',
            'cutt.us',
            'u.bb',
            'yourls.org',
            'x.co',
            'prettylinkpro.com',
            'scrnch.me',
            'filoops.info',
            'vzturl.com',
            'qr.net',
            '1url.com',
            'tweez.me',
            'v.gd',
            'tr.im',
            'link.zip.net',
            'adcraft.co',
            'adcrun.ch',
            'adflav.com',
            'aka.gr',
            'bee4.biz',
            'cektkp.com',
            'dft.ba',
            'fun.ly',
            'fzy.co',
            'gog.li',
            'golinks.co',
            'hit.my',
            'id.tl',
            'linkto.im',
            'lnk.co',
            'nov.io',
            'p6l.org',
            'picz.us',
            'shortquik.com',
            'su.pr',
            'sk.gy',
            'tota2.com',
            'xlinkz.info',
            'xtu.me',
            'yu2.it',
            'zpag.es', 'tcrn.ch'];
        str = str.replace('http://', '');
        str = str.replace('https://', '');
        str = str.replace('://', '');
        str = str.split('?')[0];
        str = str.split('/')[0];
        if (str.indexOf('.goo.gl') != -1) {
            return true;
        }
        for (var i = 0; i < short_link_domains.length; i++) {
            if (str == short_link_domains[i]) {
                return true;
            }
        }
        return false;
    };
    ScrappingProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_publishing_service_publishing_map_post__["a" /* PublishingMapPostProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_user_settings_user_settings__["a" /* UserSettingsProvider */]])
    ], ScrappingProvider);
    return ScrappingProvider;
}());

//# sourceMappingURL=scrapping-service.js.map

/***/ }),

/***/ 408:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EventViewConversationsServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



//PROVIDERS
// import { InboxMappingProvider } from '../../providers/feeds/inbox-mapping';
var EventViewConversationsServiceProvider = /** @class */ (function () {
    function EventViewConversationsServiceProvider(_http
    // private _inboxMappingProvider: InboxMappingProvider
    ) {
        this._http = _http;
    } //end constructor
    /******************************************************\
     *  CONVERSATION HISTORY FOR YOU TUBE - YTCOMMENTS
    /******************************************************/
    EventViewConversationsServiceProvider.prototype.getYouTubeFeed = function (data) {
        var getYouTubeFeed = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", "getYouTubeFeed")
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("video_id", data.videoId)
            .set("stream", data.stream)
            .set("nextToken", data.nextToken);
        return this
            ._http
            .get("/feed/youTubeFeed", { params: getYouTubeFeed });
    };
    ; // end _getYouTubeFeed
    /******************************************************\
     *  CONVERSATION HISTORY FOR Twitter MENTIONS
    /******************************************************/
    EventViewConversationsServiceProvider.prototype.getTWConversationKeys = function (data) {
        var getTWConversation = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("id_str", data.userId);
        return this
            ._http
            .get("/feed/twitter", { params: getTWConversation });
    };
    ; // end getTWConversation
    EventViewConversationsServiceProvider.prototype.getTWConversationsForKeys = function (data) {
        console.info('Entering InboxActionButtonProvider::getTWConversationsForKeys.');
        // let conversationIds = "";
        // for (let index = 0; index < conversationKeys.length; index++) {
        //   conversationIds = conversationIds + conversationKeys[index].id;
        //   // if we are at the last value in data, no need to add ','; else add ','
        //   if ((index + 1) < conversationKeys.length) {
        //     conversationIds = conversationIds + ",";
        //   }
        // };
        var getTweetCollection = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("ids", data.userIds);
        return this
            ._http
            .get("/feed/twitter", { params: getTweetCollection });
    };
    ;
    /******************************************************\
     *  CONVERSATION HISTORY FOR Twitter DirectMessage
    /******************************************************/
    EventViewConversationsServiceProvider.prototype.getConversationHistory = function (data) {
        console.info('Entering InboxActionButtonProvider::getConversationHistory.');
        var getConversationHistory = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("eventType", data.eventType)
            .set("eventDate", data.date)
            .set("recipientId", data.recipientId)
            .set("senderId", data.senderId)
            .set("sampleId", data.sampleId);
        // let options = new RequestOptions({ params: getConversationHistory });
        return this
            ._http
            .get("/feed/conversationHistory", { params: getConversationHistory });
    };
    ; // end getConversationHistory
    /******************************************************\
     *  CONVERSATION HISTORY FOR Facebook DirectMessage
    /******************************************************/
    EventViewConversationsServiceProvider.prototype.getFBConversationHistory = function (data) {
        console.info('Entering InboxActionButtonProvider::getFBConversationHistory.');
        var getFBConversation = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("objectID", data.objectId)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId);
        return this
            ._http
            .get("/feed/fbConversations", { params: getFBConversation });
    };
    ; // end getFBConversationHistory
    /****************************************************************\
     *  CONVERSATION HISTORY FOR FACEBOOK - COMMENTS and MENTIONS
    /*****************************************************************/
    EventViewConversationsServiceProvider.prototype.getsingleFBPost = function (data) {
        var getFBConversation = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("postId", data.postId)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId);
        return this
            ._http
            .get("/feed/singleFBPost", { params: getFBConversation })
            // .flatMap(conversation => {
            //   console.log("userEventsResponse.json().data : ", conversation['data']);
            //   return Observable.fromPromise(this.processUserEvents(conversation['data'], inboxItem.itemData.eventType).then(inboxItems => {
            //     this._conversationHistory = inboxItems;
            //     return this._conversationHistory;
            //   })); //end fromPromise
            // })
            .catch(function (conversationHistoryError) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].throw(conversationHistoryError);
        }); //end flatMap
    };
    ; // end getsingleFBPost
    /****************************************************\
     *  CONVERSATION HISTORY FOR FACEBOOK - COMMENTS
    /*****************************************************/
    EventViewConversationsServiceProvider.prototype.getFBUserProfile = function (data) {
        console.info('Entering InboxActionButtonProvider::getFBUserProfile');
        var getFBConversation = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("user_id", data.id);
        return this
            ._http
            .get("/user/profiles", { params: getFBConversation });
    };
    ; // end getFBUserProfile
    /****************************************************\
     *  CONVERSATION HISTORY FOR INSTRAGRAM - COMMENTS
    /*****************************************************/
    EventViewConversationsServiceProvider.prototype.getInComments = function (data) {
        console.info('Entering InboxActionButtonProvider::getInComments');
        var getInComments = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.postId);
        return this
            ._http
            .get("/feed/igPostComments", { params: getInComments });
    };
    ; // end getInComments
    /****************************************************\
     *  GP COMMENTS
    /*****************************************************/
    EventViewConversationsServiceProvider.prototype.getGPComments = function (data) {
        console.info('Entering InboxActionButtonProvider::getGPComments');
        var getGPComments = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.postId);
        return this
            ._http
            .get("/feed/gpPostComments", { params: getGPComments })
            .map(function (httpResponse) {
            var comments = [];
            if (httpResponse.data && httpResponse.data.comments && httpResponse.data.comments.comment) {
                if (!Array.isArray(httpResponse.data.comments.comment)) {
                    comments = [httpResponse.data.comments.comment];
                }
                else {
                    comments = httpResponse.data.comments.comment;
                }
            }
            return comments;
        });
    };
    ; // end getInComments
    EventViewConversationsServiceProvider.prototype.getInstagramBusinessFeed = function (data) {
        console.info('Entering InboxActionButtonProvider::getInstagramBusinessFeed');
        var getINBusinessFeed = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.postId)
            .set("stream", data.stream)
            .set("next", data.next);
        return this
            ._http
            .get("/feed/instagramBusiness", { params: getINBusinessFeed });
    };
    ; // end getInstagramBusinessFeed
    /* ========== PRIVATE EVENTS METHODS ========== */
    EventViewConversationsServiceProvider.prototype.mapEventsToArray = function (events, originalData) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var promisedMappedInboxEventsArray = [];
            for (var _i = 0, events_1 = events; _i < events_1.length; _i++) {
                var event_1 = events_1[_i];
                promisedMappedInboxEventsArray.push(_this._mapSingleEvent(event_1, originalData));
            }
            ; // end for loop
            return Promise.all(promisedMappedInboxEventsArray).then(function (resolvedMappedEventsArray) {
                resolve(resolvedMappedEventsArray);
            });
        });
    };
    ; //end _mapEventsToArray
    EventViewConversationsServiceProvider.prototype._mapSingleEvent = function (event, originalData) {
        return new Promise(function (resolve) {
            // for (const account of getUserEventParams.accounts.accounts) {
            // for (const profile of account.profiles) {
            //   if (event["sampleId"] === profile.profile_id) {
            Promise.all([
            // this._inboxMappingProvider.mapEventSummary(event, originalData),
            // this._inboxMappingProvider.mapConversationActionButtons(event, originalData)
            ]).then(function (mappedEventInArray) {
                var mappedEvent = {
                    eventSummary: mappedEventInArray[0],
                    // summary: mappedEventInArray[1],
                    eventActionButtons: mappedEventInArray[1]
                };
                resolve(mappedEvent);
            }).catch(function (mappingError) {
                console.error(mappingError);
            });
            // }
            // }
            // }//end outer for loop
        });
    };
    ; //end _mapSingleEvent
    EventViewConversationsServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]
            // private _inboxMappingProvider: InboxMappingProvider
        ])
    ], EventViewConversationsServiceProvider);
    return EventViewConversationsServiceProvider;
}()); //end EventViewConversationsServiceProvider

; //end YouTubeCommentsInterface
; //end InstagramBusinessFeedInterface
; //end InstagramBusinessFeedInterface
; //end TwitterConversationKeysInterface
; //end TwitterConversationsForKeysInterface
; //end TwitterConversationHistoryDMInterface
; //end FacebookConversationHistoryDMInterface
; //end FacebookSinglePostInterface
; //end FacebookUserProfileInterface
//# sourceMappingURL=event-view-conversations-service.js.map

/***/ }),

/***/ 409:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AccountsAddProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_device__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_in_app_browser__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_google_plus__ = __webpack_require__(336);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var AccountsAddProvider = /** @class */ (function () {
    function AccountsAddProvider(_device, _inAppBrowser, _ionicGooglePlus) {
        this._device = _device;
        this._inAppBrowser = _inAppBrowser;
        this._ionicGooglePlus = _ionicGooglePlus;
        this.inAppBrowserAccounts = ['Facebook', 'Twitter', 'Pinterest', 'Instagram', 'Pocket'];
    }
    AccountsAddProvider.prototype.addAccount = function (accountType) {
        console.log(accountType);
        switch (accountType) {
            case 'GooglePlus':
                this._addGooglePlusAccount();
            default:
        } // end switch
    }; // end addAccount
    AccountsAddProvider.prototype._addGooglePlusAccount = function () {
        console.log('AccountsTypesProvider - _addGooglePlusAccount');
        this._ionicGooglePlus
            .login({})
            .then(function (googlePlusResponse) {
            console.log('googlePlusResponse', JSON.stringify(googlePlusResponse));
            console.log('googlePlusResponse.idToken', googlePlusResponse.idToken);
            return;
        })
            .catch(function (googlePlusError) {
            console.error('googlePlusError', googlePlusError);
            return;
        });
    }; // end _addGooglePlusAccount
    AccountsAddProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_device__["a" /* Device */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_in_app_browser__["a" /* InAppBrowser */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_google_plus__["a" /* GooglePlus */]])
    ], AccountsAddProvider);
    return AccountsAddProvider;
}()); // end export AccountsTypesProvider

//# sourceMappingURL=accounts-add.js.map

/***/ }),

/***/ 412:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FeedCommentsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_jquery__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_facebook_feed__ = __webpack_require__(338);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_feeds_classes_instagram_feed__ = __webpack_require__(340);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_feeds_classes_instagram_business_feed__ = __webpack_require__(341);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_feeds_classes_twitter_feed__ = __webpack_require__(342);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_feeds_classes_youtube_feed__ = __webpack_require__(344);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_feeds_classes_googleplus_feed__ = __webpack_require__(345);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_feeds_classes_linkedin_feed__ = __webpack_require__(346);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_feeds_classes_feed_items_linkedin_feed_item__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_feeds_classes_feed_items_instagram_feed_item__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__ = __webpack_require__(30);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_17_moment__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18_moment_timezone__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_18_moment_timezone__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19_ionic_angular_util_util__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__classes_google_business_feed__ = __webpack_require__(347);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__user_settings_user_settings__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



//rxjs

//PROVIDERS


// CLASSES
















var FeedCommentsProvider = /** @class */ (function () {
    function FeedCommentsProvider(http, accountsServiceProvider, appSettingsProvider, userSettingsProvider) {
        this.http = http;
        this.accountsServiceProvider = accountsServiceProvider;
        this.appSettingsProvider = appSettingsProvider;
        this.userSettingsProvider = userSettingsProvider;
        this.comments = [];
    }
    /**
     * getComments
     */
    FeedCommentsProvider.prototype.getComments = function (feedItem) {
        this.feedItem = feedItem;
        this.feedItem.data.getOriginal = (this.feedItem.feed.id === 'cinbox') ? true : false; //to get original post of each feed
        switch (this.feedItem.network) {
            case 'facebook':
                return this.getFBComments();
            case 'youtube':
                return this.getYoutubeComments();
            case 'instagram':
                return this.getIGComments();
            case 'instabusiness':
                if (this.feedItem.feed && (this.feedItem.feed.id === 'igbInbox' || (this.feedItem.feed.id === 'cinbox' && this.feedItem.data.eventType == 'INMessages')))
                    return this.getIGBMessages();
                return this.getIGBComments();
            case 'linkedin':
                return this.getLNComments();
            case 'googleplus':
                return this.getGPComments();
            case 'twitter':
                return this.getTWComments();
            case 'googlemybusiness':
                return this.getGMBQuestionAnswers();
            default:
                return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].of([]);
        }
    };
    /**
     *
     * get GMB question and anser
     */
    FeedCommentsProvider.prototype.getGMBQuestionAnswers = function () {
        var _this = this;
        var apiPath = "/feed/gmbQuestionAnswer";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("stream", 'gmbAnswers')
            .set("accountID", this.feedItem.profile.account_id)
            .set("profileID", this.feedItem.profile.profile_id)
            .set("objectID", this.feedItem.data.id)
            .set("next", '');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (obj) {
            _this.comments = [];
            console.log('httpResponse', obj);
            if (obj.data) {
                if (!Array.isArray(obj.data))
                    obj.data = [obj.data];
                var l = obj.data.length;
                for (var i = 0; i < l; i++) {
                    var comment = _this.getMappedGMBQuestionAnswers(obj.data[i]);
                    _this.comments.push(comment);
                }
            }
            if (l <= 0)
                _this.getOriginalPost('googlemybusiness');
            return _this.comments;
        });
    };
    FeedCommentsProvider.prototype.getMappedGMBQuestionAnswers = function (raw_answer) {
        console.log('raw_answer', raw_answer);
        if (this.feedItem.feed.id === 'cinbox') {
            this.getOriginalPost('googlemybusiness');
        }
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.network = this.feedItem.network;
        comment.profile = this.feedItem.profile;
        comment.data = raw_answer;
        comment.isCommentView = true;
        // comment.data.uniqueId = raw_comment.messageId;
        comment.summary = {
            messageView: {
                sender: {
                    senderName: raw_answer.author.fromName,
                    createdDate: raw_answer.updateTime,
                    senderProfileImage: raw_answer.author.profilePic || this.feedItem.feed.defaultProfileImage,
                    senderProfileURL: raw_answer.fromProfileLink || ''
                },
                messageText: raw_answer.summary
            }
        };
        comment.actionButtons = {};
        if (raw_answer.author && raw_answer.author.fromType === 'MERCHANT' && (this.feedItem.feed.account && (raw_answer.author.fromName === this.feedItem.feed.account.display.account_name))) {
            comment.actionButtons.edit = {
                action: 'upsertGMBAnswer',
                id: this.feedItem.data.id,
                label: 'Edit Answer'
            };
            comment.actionButtons.delete = {
                action: 'deleteGMBAnswer',
                postID: this.feedItem.data.id,
                label: 'Delete Answer'
            };
        }
        return comment;
    };
    /**
     * getComments
     */
    FeedCommentsProvider.prototype.getReplies = function (feedItem) {
        this.feedItem = feedItem;
        switch (this.feedItem.network) {
            case 'linkedin':
                return this.getLNComments(true);
            default:
                return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].of([]);
        }
    };
    /**
     * getYTComments
     */
    FeedCommentsProvider.prototype.getFBComments = function () {
        var _this = this;
        this.comments = [];
        if (this.feedItem.actionButtons.showViewLatest) {
            if (this.feedItem.feed.id === 'inBox' || (this.feedItem.data.eventType && this.feedItem.data.eventType === 'FBDirectMessage')) {
                var apiPath = "/feed/fbConversations";
                var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
                    .set("accountID", this.feedItem.profile.account_id)
                    .set("profileID", this.feedItem.profile.profile_id)
                    .set("objectID", this.feedItem.data.id)
                    .set("action", "fbConversations");
                return this
                    .http
                    .get(apiPath, { params: httpParams })
                    .map(function (httpResponse) {
                    var data = httpResponse;
                    var conversation = [];
                    if (data.returnCode !== 'SUCCESS') {
                        return _this.comments;
                    }
                    if (!data.data || !data.data.length) {
                        return _this.comments;
                    }
                    for (var j = 0, ll = data.data.length; j < ll; j++) {
                        conversation.push(data.data[j].comments.comment);
                    }
                    // sort
                    conversation.sort(function (a, b) {
                        if (!a.timestamp)
                            a.timestamp = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["l" /* getTimeStamp */](a.createdTime) * 1000;
                        if (!b.timestamp)
                            b.timestamp = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["l" /* getTimeStamp */](b.createdTime) * 1000;
                        if (a.timestamp > b.timestamp)
                            return 1;
                        else if (a.timestamp < b.timestamp)
                            return -1;
                        else
                            return 0;
                    });
                    for (var i = 0, l = conversation.length; i < l; i++) {
                        var post = conversation[i];
                        var tweet = {
                            id: post.messageId,
                            content: post.message,
                            userID: post.fromId,
                            images: {
                                large: post.fromPicture ? post.fromPicture : 'https://graph.facebook.com/v11.0/' + post.fromId + '/picture?width=1000&height=1000'
                            },
                            name: post.fromName,
                            media: post.media,
                            date: post.timestamp,
                            show_functions: 'facebook',
                            self: _this.feedItem
                        };
                        _this.comments.push(_this.getMappedFBConversation(tweet));
                    }
                    return _this.comments;
                });
            }
            else {
                var apiPath = "/feed/singleFBPost";
                var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
                    .set("accountID", this.feedItem.profile.account_id)
                    .set("profileID", this.feedItem.profile.profile_id)
                    .set("postId", this.feedItem.data.id)
                    .set("action", "getSingleFBPost");
                var vlData = this.feedItem.actionButtons.showViewLatest;
                if (vlData.id && vlData.type) {
                    switch (vlData.type) {
                        case 'photo':
                            httpParams = httpParams.set('action', 'getFBPhoto');
                            break;
                        case 'video':
                            httpParams = httpParams.set('action', 'getFBVideo');
                            break;
                        case 'link':
                            httpParams = httpParams.set('action', 'getFBLink');
                            break;
                        case 'review':
                            httpParams = httpParams.set('action', 'getFBReview');
                            break;
                        default:
                            break;
                    }
                    httpParams = httpParams.set('postId', vlData.id);
                }
                return this
                    .http
                    .get(apiPath, { params: httpParams })
                    .map(function (httpResponse) {
                    if (httpResponse
                        && httpResponse.data
                        && httpResponse.data.length
                        && httpResponse.data[0]) {
                        if (_this.feedItem.feed.id === 'cinbox') {
                            _this.getOriginalPost('facebook', httpResponse.data[0]);
                        }
                        if (httpResponse.data[0].comments
                            && httpResponse.data[0].comments.count) {
                            var raw_comments = httpResponse.data[0].comments.comment;
                            if (!Array.isArray(raw_comments)) {
                                raw_comments = [raw_comments];
                            }
                            _this.parseFBComments(raw_comments);
                            _this.updateCommentsCount(raw_comments.length);
                        }
                    }
                    return _this.comments;
                });
            }
        }
        else {
            if (['timeline', 'wallPosts', 'fb_mentions'].indexOf(this.feedItem.feed.id) !== -1) {
                var apiPath = "/feed/singleFBPost";
                var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
                    .set("accountID", this.feedItem.profile.account_id)
                    .set("profileID", this.feedItem.profile.profile_id)
                    .set("postId", this.feedItem.data.id)
                    .set("action", "getSingleFBPost");
                return this
                    .http
                    .get(apiPath, { params: httpParams })
                    .map(function (httpResponse) {
                    if (httpResponse
                        && httpResponse.data
                        && httpResponse.data.length
                        && httpResponse.data[0]
                        && httpResponse.data[0].comments
                        && httpResponse.data[0].comments.count) {
                        var raw_comments = httpResponse.data[0].comments.comment;
                        if (!Array.isArray(raw_comments)) {
                            raw_comments = [raw_comments];
                        }
                        _this.parseFBComments(raw_comments);
                    }
                    return _this.comments;
                });
            }
            else {
                var raw_comments = [];
                if (this.feedItem.data.comments && this.feedItem.data.comments.comment) {
                    if (Object(__WEBPACK_IMPORTED_MODULE_19_ionic_angular_util_util__["e" /* isArray */])(this.feedItem.data.comments.comment)) {
                        raw_comments = this.feedItem.data.comments.comment;
                    }
                    else {
                        raw_comments = [this.feedItem.data.comments.comment];
                    }
                }
                this.parseFBComments(raw_comments);
                return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].of(this.comments);
            }
        }
    };
    FeedCommentsProvider.prototype.parseFBComments = function (raw_comments) {
        raw_comments.sort(function (a, b) {
            if (a.createdTime < b.createdTime)
                return -1;
            else if (a.createdTime > b.createdTime)
                return 1;
            return 0;
        });
        var fbComments = [], fbReplies = {};
        for (var i = 0, l = raw_comments.length; i < l; i++) {
            var temp = raw_comments[i];
            if (temp.parentId == undefined) {
                fbComments.push(temp);
            }
            else {
                if (fbReplies[temp.parentId] == undefined) {
                    fbReplies[temp.parentId] = [];
                }
                fbReplies[temp.parentId].push(temp);
            }
        }
        var count = 0;
        for (var i_1 = 0; i_1 < fbComments.length; i_1++) {
            var raw_comment = fbComments[i_1];
            var comment = this.getMappedFBComment(raw_comment);
            comment.replies = [];
            count++;
            if (fbReplies[raw_comment.messageId]) {
                for (var j = 0; j < fbReplies[raw_comment.messageId].length; j++) {
                    var raw_reply = fbReplies[raw_comment.messageId][j];
                    var reply = this.getMappedFBComment(raw_reply);
                    comment.replies.push(reply);
                    count++;
                }
            }
            this.comments.push(comment);
        }
        this.updateCommentsCount(count);
        return this.comments;
    };
    /**
     * getYTComments
     */
    FeedCommentsProvider.prototype.getYoutubeComments = function () {
        var _this = this;
        if (this.feedItem.feed.id === 'cinbox') {
            this.getOriginalPost('youtube');
        } //to get the original post of the comments
        console.log('this.feedItem.data.originalPost', this.feedItem.data.originalPost);
        var apiPath = "/feed/youTubeFeed";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.feedItem.profile.account_id)
            .set("profileID", this.feedItem.profile.profile_id)
            .set("video_id", this.feedItem.data.media.id)
            .set('stream', 'yt_comments')
            .set("action", 'getYouTubeFeed');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            _this.comments = [];
            var count = 0;
            if (httpResponse && httpResponse.data && httpResponse.data.items) {
                var items = httpResponse.data.items;
                items.sort(function (a, b) {
                    var aTime = new Date(a.updateTime).getTime();
                    var bTime = new Date(b.updateTime).getTime();
                    if (aTime > bTime)
                        return -1;
                    else if (aTime < bTime)
                        return 1;
                    else
                        return 0;
                });
                for (var i = 0, l = items.length; i < l; i++) {
                    var raw_comment = {
                        fromId: items[i].fromId,
                        fromName: items[i].fromName,
                        profilePic: items[i].profilePic,
                        profileLink: items[i].profileLink,
                        updateTime: (new Date(items[i].updateTime).getTime() / 1000),
                        message: items[i].message,
                        canRate: items[i].canRate,
                        canReply: items[i].canReply,
                        parentId: items[i].parentId,
                        replies: items[i].comments,
                        likes: items[i].likes
                    };
                    var comment = _this.getMappedYTComment(raw_comment);
                    comment.replies = [];
                    if (raw_comment.replies && raw_comment.replies.count && raw_comment.replies.items) {
                        var replies = raw_comment.replies.items;
                        for (var k = 0, ln = replies.length; k < ln; k++) {
                            if (typeof replies[k].updateTime === 'string') {
                                replies[k].updateTime = new Date(replies[k].updateTime).getTime() / 1000;
                            }
                            replies[k].parent = raw_comment;
                            var reply_1 = _this.getMappedYTComment(replies[k]);
                            comment.replies.push(reply_1);
                        }
                    }
                    var reply = 0;
                    if (items[i].comments && items[i].comments.count) {
                        reply = parseInt(items[i].comments.count);
                    }
                    count += 1 + reply;
                    _this.comments.push(comment);
                }
            }
            if (_this.feedItem.actionHeader.comments && _this.feedItem.actionHeader.comments.count > count) {
            }
            else {
                _this.updateCommentsCount(count);
            }
            return _this.comments;
        });
    };
    /**
     * getIGComments
     */
    FeedCommentsProvider.prototype.getIGComments = function () {
        var _this = this;
        if (this.feedItem.feed.id === 'cinbox') {
            this.getOriginalPost('instagram');
        } //to get the original post of the comments
        var apiPath = "/feed/igPostComments";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.feedItem.profile.account_id)
            .set("profileID", this.feedItem.profile.profile_id)
            .set("post_id", this.feedItem.data.id)
            .set("action", 'getInComments');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            _this.comments = [];
            if (httpResponse && httpResponse.comment) {
                var items = httpResponse.comment;
                if (!Array.isArray(items)) {
                    items = [items];
                }
                for (var i = 0, l = items.length; i < l; i++) {
                    var raw_comment = items[i];
                    var comment = _this.getMappedIGComment(raw_comment);
                    _this.comments.push(comment);
                }
            }
            _this.updateCommentsCount(_this.comments.length);
            return _this.comments;
        });
    };
    /**
     * getIGComments
     */
    FeedCommentsProvider.prototype.getIGBComments = function () {
        var _this = this;
        console.log("getIGBComments", this.feedItem);
        if (this.feedItem.feed.id === 'cinbox') {
            this.getOriginalPost('instabusiness');
        } //to get the original post of the comments
        var apiPath = "/feed/instagramBusiness";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.feedItem.profile.account_id)
            .set("profileID", this.feedItem.profile.profile_id)
            .set("post_id", this.feedItem.data.id)
            .set("stream", 'igbComments')
            .set("action", 'getInstagramBusinessFeed');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            _this.comments = [];
            var count = 0;
            if (httpResponse && httpResponse.data) {
                var items = httpResponse.data;
                if (!Array.isArray(items)) {
                    items = [items];
                }
                for (var i = 0, l = items.length; i < l; i++) {
                    var raw_comment = items[i];
                    var comment = _this.getMappedIGBComment(raw_comment);
                    count++;
                    // replies
                    if (raw_comment.comments && raw_comment.comments.comment) {
                        if (!Array.isArray(raw_comment.comments.comment)) {
                            raw_comment.comments.comment = [raw_comment.comments.comment];
                        }
                        raw_comment.comments.comment.sort(function (a, b) {
                            var dateA = new Date(a.date.replace(/\+\d{2}/, '$&' + ':')).getTime();
                            var dateB = new Date(b.date.replace(/\+\d{2}/, '$&' + ':')).getTime();
                            if (dateA > dateB)
                                return 1;
                            else if (dateA < dateB)
                                return -1;
                            else
                                return 0;
                        });
                        comment.replies = [];
                        for (var i_2 = 0; i_2 < raw_comment.comments.comment.length; i_2++) {
                            var rawReply = raw_comment.comments.comment[i_2];
                            rawReply.id = rawReply.objectId;
                            var reply = _this.getMappedIGBComment(rawReply, true);
                            comment.replies.push(reply);
                        }
                        count += comment.replies.length;
                    }
                    _this.comments.push(comment);
                }
            }
            _this.updateCommentsCount(count);
            return _this.comments;
        });
    };
    /**
     * getIGComments
     */
    FeedCommentsProvider.prototype.getLNComments = function (isReply) {
        var _this = this;
        if (isReply === void 0) { isReply = false; }
        if (this.feedItem.feed.id === 'cinbox') {
            this.getOriginalPost('linkedin');
        } //to get the original post of the comments
        var apiPath = "/feed/linkedInPostComments";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.feedItem.profile.account_id)
            .set("profileID", this.feedItem.profile.profile_id)
            .set("post_id", this.feedItem.data.updateKey)
            .set("action", 'lnShareComments');
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            _this.comments = [];
            if (httpResponse
                && httpResponse.streamEntry
                && httpResponse.streamEntry.comments
                && httpResponse.streamEntry.comments.values) {
                var items = httpResponse.streamEntry.comments.values;
                if (!Array.isArray(items)) {
                    items = [items];
                }
                items.sort(function (a, b) {
                    var aTime = new Date(parseInt(a.creationTimestamp)).getTime();
                    var bTime = new Date(parseInt(b.creationTimestamp)).getTime();
                    if (aTime < bTime)
                        return -1;
                    else if (aTime > bTime)
                        return 1;
                    else
                        return 0;
                });
                console.log('AS', items);
                var repliesCount = 0;
                for (var i = 0, l = items.length; i < l; i++) {
                    var raw_comment = items[i];
                    var comment = _this.getMappedLNComment(raw_comment, isReply);
                    _this.comments.push(comment);
                    if (raw_comment.aggregatedTotal) {
                        repliesCount += parseInt(raw_comment.aggregatedTotal);
                    }
                }
                if (!isReply)
                    _this.updateCommentsCount(_this.comments.length + repliesCount);
            }
            return _this.comments;
        });
    };
    /**
     * get GooglePlus comments
     */
    FeedCommentsProvider.prototype.getGPComments = function () {
        var _this = this;
        if (this.feedItem.feed.id === 'cinbox' && this.feedItem.data.eventType === 'GPComments') {
            this.getOriginalPost('googleplus');
        }
        var apiPath = "/feed/gpPostComments";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", 'getGPComments')
            .set("accountID", this.feedItem.profile.account_id)
            .set("profileID", this.feedItem.profile.profile_id)
            .set("post_id", this.feedItem.data.postID);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            _this.comments = [];
            if (httpResponse.returnCode !== 'SUCCESS') {
                return _this.comments;
            }
            if (httpResponse.data
                && httpResponse.data.comments
                && httpResponse.data.comments.comment) {
                var items = httpResponse.data.comments.comment;
                if (!Array.isArray(items)) {
                    items = [items];
                }
                items.sort(function (a, b) {
                    if (a.createdTime > b.createdTime) {
                        return 1;
                    }
                    if (a.createdTime < b.createdTime) {
                        return -1;
                    }
                    return 0;
                });
                for (var i = 0, l = items.length; i < l; i++) {
                    var raw_comment = items[i];
                    var comment = _this.getMappedGPComments(raw_comment);
                    _this.comments.push(comment);
                }
            }
            _this.updateCommentsCount(_this.comments.length);
            return _this.comments;
        });
    };
    ;
    /**
     * getTWComments
     */
    FeedCommentsProvider.prototype.getTWComments = function () {
        var _this = this;
        this.comments = [];
        var original_tweet = this.feedItem.data[0];
        if (this.feedItem.feed.id == 'direct_message'
            || (this.feedItem.data[0] != undefined && this.feedItem.data[0].eventType == 'TWDirectMessage')) {
            var conversation_1 = [];
            if (this.feedItem.feed.network === 'cinbox') {
                var apiPath = "/feed/conversationHistory";
                var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
                    .set("action", 'getConversationHistory')
                    .set("eventType", 'TWDirectMessage')
                    .set("eventDate", original_tweet.eventTime)
                    .set("sampleId", this.feedItem.profile.profile_id)
                    .set("senderId", original_tweet.sender.id_str)
                    .set("recipientId", original_tweet.recipient.id_str);
                return this
                    .http
                    .get(apiPath, { params: httpParams })
                    .map(function (data) {
                    _this.comments = [];
                    if (data.returnCode === 'SUCCESS' && data.streamEntry && data.streamEntry.conversation) {
                        if (!Array.isArray(data.streamEntry.conversation.streamEntry)) {
                            data.streamEntry.conversation.streamEntry = [data.streamEntry.conversation.streamEntry];
                        }
                        data.streamEntry.conversation.streamEntry.reverse();
                        for (var j = 0, ll = data.streamEntry.conversation.streamEntry.length; j < ll; j++) {
                            conversation_1.push(data.streamEntry.conversation.streamEntry[j]);
                        }
                    }
                    _this.feedItem.conversation = conversation_1;
                    for (var i = 0; i < conversation_1.length; i++) {
                        var row = conversation_1[i];
                        var temp_date = new Date(row.created_at);
                        var tweet = {
                            id: row.id_str,
                            content: row.text,
                            entities: row.entities,
                            username: row.sender.screen_name,
                            images: {
                                large: row.sender.profile_image_url
                            },
                            name: row.sender.name,
                            date: temp_date
                        };
                        tweet.show_functions = 'twitter';
                        tweet.self = _this.feedItem;
                        _this.comments.push(_this.getMappedTWComment(tweet));
                    }
                    return _this.comments;
                });
            }
            else {
                for (var i = 1, l = this.feedItem.data.length; i < l; i++) {
                    this.feedItem.data[i].updateTime = new Date(this.feedItem.data[i].created_at).getTime();
                    conversation_1.push(this.feedItem.data[i]);
                }
                conversation_1.sort(function (a, b) {
                    if (a.updateTime < b.updateTime)
                        return -1;
                    else if (a.updateTime > b.updateTime)
                        return 1;
                    else
                        return 0;
                });
                for (var i = 0; i < conversation_1.length; i++) {
                    var row = conversation_1[i];
                    var temp_date = new Date(row.created_at);
                    var tweet = {
                        id: row.id_str,
                        content: row.text,
                        entities: row.entities,
                        username: row.sender.screen_name,
                        images: {
                            large: row.sender.profile_image_url
                        },
                        name: row.sender.name,
                        date: temp_date
                    };
                    tweet.show_functions = 'twitter';
                    tweet.self = this.feedItem;
                    this.comments.push(this.getMappedTWComment(tweet));
                }
            }
        }
        else if (this.feedItem.feed.id == 'mentions'
            || (this.feedItem.data[0] != undefined && this.feedItem.data[0].eventType == 'TWMentions')) {
            var apiPath = "/feed/twitter";
            var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
                .set("action", 'getTWConversation')
                .set("accountID", this.feedItem.profile.account_id)
                .set("profileID", this.feedItem.profile.profile_id)
                .set('id_str', original_tweet.postID);
            return this
                .http
                .get(apiPath, { params: httpParams })
                .flatMap(function (data) {
                var ids = [];
                var conversation = data.data;
                if (conversation && Array.isArray(conversation)) {
                    ids = conversation.map(function (e) { return e.id; });
                }
                else {
                    conversation = [];
                }
                if (ids.length > 100)
                    ids.slice(0, 99);
                var apiPath = "/feed/twitter";
                var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
                    .set("action", 'getTweetCollection')
                    .set("accountID", _this.feedItem.profile.account_id)
                    .set("profileID", _this.feedItem.profile.profile_id)
                    .set("ids", ids.join(','));
                return _this
                    .http
                    .get(apiPath, { params: httpParams })
                    .map(function (httpResponse) {
                    _this.comments = [];
                    var raw_data = {};
                    if (httpResponse.data && Array.isArray(httpResponse.data)) {
                        httpResponse.data.forEach(function (t) {
                            raw_data[t.id_str] = t;
                        });
                    }
                    // console.log('conversation', conversation, raw_data);
                    var stream = {
                        favorited: false,
                        name: "Home Feed",
                        size: "1",
                        streamId: "homeFeed",
                        id: "homeFeed",
                        value: "false"
                    };
                    var twFeed = new __WEBPACK_IMPORTED_MODULE_9__providers_feeds_classes_twitter_feed__["a" /* TwitterFeed */](_this.http, stream, _this.feedItem.profile, {});
                    twFeed.setAccountsServiceProvider(_this.accountsServiceProvider);
                    twFeed.setAccount();
                    var afters = [];
                    for (var i = 0; i < conversation.length; i++) {
                        var tweet = conversation[i];
                        tweet.show_functions = 'twitter';
                        if (raw_data[tweet.id]) {
                            var tmp = _this.feedItem.feed.formatTwitterItem(raw_data[tweet.id]);
                            tweet.self = new __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](_this.http, tmp, twFeed);
                        }
                        if (tweet.state === 'before') {
                            _this.comments.push(_this.getMappedTWComment(tweet));
                        }
                        else {
                            afters.push(_this.getMappedTWComment(tweet));
                        }
                    }
                    // remove show conversation and complete item options . It is notneeded in comments page
                    var clonedObject = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["c" /* cloneObject */](_this.feedItem);
                    delete clonedObject.actionButtons.completeItem;
                    delete clonedObject.actionButtons.showViewLatest;
                    if (clonedObject.data && clonedObject.data[0]) {
                        clonedObject.data.uniqueId = clonedObject.data[0].postID;
                        console.log('clonedObject', clonedObject);
                    }
                    _this.comments.push(clonedObject);
                    for (var _i = 0, afters_1 = afters; _i < afters_1.length; _i++) {
                        var c = afters_1[_i];
                        _this.comments.push(c);
                    }
                    // console.log('conversation comments::', this.comments);
                    return _this.comments;
                });
            });
        }
        return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].of(this.comments);
    };
    // PRIVATE FUNCTIONS
    FeedCommentsProvider.prototype.getMappedFBComment = function (raw_comment) {
        console.log('raw_comment getMappedFBComment', raw_comment);
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.profile = this.feedItem.profile;
        comment.network = this.feedItem.network;
        comment.data = raw_comment;
        comment.isCommentView = true;
        comment.data.uniqueId = raw_comment.messageId;
        comment.summary = {
            messageView: {
                sender: {
                    senderName: raw_comment.fromName,
                    twittterHandle: '',
                    createdDate: parseInt(raw_comment.createdTime) * 1000,
                    senderProfileImage: 'https://graph.facebook.com/' + raw_comment.fromId + '/picture?width=1000&height=1000',
                    senderProfileURL: ''
                },
                messageText: raw_comment.message
            }
        };
        // Media
        var media = {
            isImage: false,
            isAnimated: false,
            isSticker: false,
            alt: '',
            mediaUrl: '',
            gallery: []
        };
        if (raw_comment.media) {
            media.isImage = true;
            media.mediaUrl = raw_comment.media.src;
            if (raw_comment.media.type && raw_comment.media.type === 'sticker') {
                media.isSticker = true;
            }
            else if (raw_comment.media.type == "video") {
                media.isImage = false;
                media.isAnimated = true;
                media.videoUrl = raw_comment.media.href;
            }
            else {
                media.gallery = [{
                        originalData: '',
                        url: {
                            full: raw_comment.media.src,
                            thumbnail: raw_comment.media.src
                        }
                    }];
            }
        }
        if (media.mediaUrl !== '') {
            comment.summary.messageView.media = media;
        }
        comment.actionButtons = {};
        if (!raw_comment.parentId) {
            // comments
            if (this.feedItem.feed.id === 'inBox' || this.feedItem.data.eventType === 'FBDirectMessage') {
            }
            else {
                //REPLY
                comment.actionButtons.reply = {
                    highlighted: false,
                    id: raw_comment.messageId
                };
                if (this.feedItem.data.originalPost
                    && this.feedItem.data.originalPost.data.currentCommentID
                    && raw_comment.messageId === this.feedItem.data.originalPost.data.currentCommentID
                    && this.feedItem.data.ecReply === 'true') {
                    comment.actionButtons.reply.highlighted = true;
                }
                comment.actionButtons.fbPostLike = {
                    highlighted: (raw_comment.userLikes == 'true') ? true : false,
                    id: raw_comment.messageId,
                    action: 'likeFBComment'
                };
                if (raw_comment.canRemove == "true") {
                    comment.actionButtons.delete = {
                        action: 'deleteFBComment',
                        commentID: raw_comment.messageId
                    };
                }
                if (raw_comment.can_hide !== 'false') {
                    comment.actionButtons.fbHide = {
                        highlighted: (raw_comment.is_hidden === 'true'),
                        id: raw_comment.messageId,
                        value: (raw_comment.is_hidden === 'true' ? 'false' : 'true')
                    };
                }
            }
        }
        else {
            // replies
            if (this.feedItem.feed.id === 'cinbox') {
                //REPLY
                comment.actionButtons.reply = {
                    highlighted: false,
                    id: raw_comment.parentId
                };
                if (raw_comment.canRemove === 'true') {
                    comment.actionButtons.delete = {
                        action: 'deleteFBComment',
                        commentID: raw_comment.messageId
                    };
                }
                if (raw_comment.can_hide !== 'false') {
                    comment.actionButtons.fbHide = {
                        highlighted: (raw_comment.is_hidden === 'true'),
                        id: raw_comment.messageId,
                        value: (raw_comment.is_hidden === 'true' ? 'false' : 'true')
                    };
                }
            }
        }
        return comment;
    };
    FeedCommentsProvider.prototype.getMappedYTComment = function (raw_comment) {
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.isCommentView = true;
        comment.network = this.feedItem.network;
        comment.profile = this.feedItem.profile;
        comment.network = this.feedItem.network;
        comment.data = this.feedItem.data;
        if (raw_comment.message === this.feedItem.data.message && raw_comment.fromId === this.feedItem.data.fromId) {
            comment.data.uniqueId = this.feedItem.data.fromId;
        }
        comment.summary = {
            messageView: {
                sender: {
                    senderName: raw_comment.fromName,
                    twittterHandle: '',
                    createdDate: parseInt(raw_comment.updateTime) * 1000,
                    senderProfileImage: raw_comment.profilePic,
                    senderProfileURL: raw_comment.profileLink
                },
                messageText: raw_comment.message
            }
        };
        comment.actionHeader = {};
        comment.actionHeader.likes = {
            highlighted: false,
            count: (raw_comment.likes && raw_comment.likes.count ? raw_comment.likes.count : 0)
        };
        comment.actionButtons = {};
        if (raw_comment.fromId === this.feedItem.profile.original_config.userId.replace('channel==', '')) {
            comment.actionButtons.delete = {
                action: 'deleteYTComment',
                ObjectId: raw_comment.channelId || raw_comment.parentId,
            };
            comment.actionButtons.edit = {
                action: 'updateYTComment',
                id: raw_comment.channelId || raw_comment.parentId,
            };
        }
        if (raw_comment.canReply === 'true') {
            comment.actionButtons.reply = {
                highlighted: false,
                id: raw_comment.parentId
            };
        }
        return comment;
    };
    FeedCommentsProvider.prototype.getMappedIGComment = function (raw_comment) {
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.network = this.feedItem.network;
        comment.profile = this.feedItem.profile;
        comment.isCommentView = true;
        comment.data = {
            id: this.feedItem.data.id,
            text: this.feedItem.data.user.username
        };
        comment.data.uniqueId = raw_comment.id;
        comment.summary = {
            messageView: {
                sender: {
                    senderName: (__WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["o" /* isEmptyObject */](raw_comment.from.full_name) ? raw_comment.from.username : raw_comment.from.username + ' (' + raw_comment.from.full_name + ')'),
                    twittterHandle: '',
                    createdDate: parseInt(raw_comment.created_time) * 1000,
                    senderProfileImage: raw_comment.from.profile_picture || this.feedItem.feed.defaultProfileImage,
                    senderProfileURL: ''
                },
                messageText: raw_comment.text
            }
        };
        comment.actionButtons = {};
        // if (raw_comment.from.id !== this.feedItem.profile.original_config.userId) {
        // 	comment.actionButtons.reply = {
        // 		highlighted: false,
        // 		id: this.feedItem.data.id,
        // 		text: '@' + comment.summary.messageView.sender.senderName + ' '
        // 	};
        // }
        if (this.feedItem.feed.id === 'ig_feed') {
        }
        else {
            // comment.actionButtons.delete = {
            // 	action: 'deleteIGComment',
            // 	postID: this.feedItem.data.id,
            // 	commentID: raw_comment.id
            // };
        }
        return comment;
    };
    FeedCommentsProvider.prototype.getMappedIGBComment = function (raw_comment, isReply) {
        if (isReply === void 0) { isReply = false; }
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.profile = this.feedItem.profile;
        comment.data = this.feedItem.data;
        comment.isCommentView = true;
        comment.network = this.feedItem.network;
        comment.profile = this.feedItem.profile;
        comment.data = {
            id: this.feedItem.data.id,
            text: this.feedItem.data.user.username,
            eventUserName: this.feedItem.data.eventUserName,
            eventTime: this.feedItem.data.eventTime
        };
        comment.data.uniqueId = raw_comment.id;
        comment.summary = {
            messageView: {
                sender: {
                    senderName: '',
                    twittterHandle: '',
                    createdDate: (raw_comment.updateTime) ? raw_comment.updateTime : raw_comment.date,
                    senderProfileImage: raw_comment.profilePic || this.feedItem.feed.defaultProfileImage,
                    senderProfileURL: ''
                },
                messageText: raw_comment.message
            }
        };
        if (!isReply && raw_comment.fromId) {
            comment.summary.messageView.sender.senderName = raw_comment.fromId + (__WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["o" /* isEmptyObject */](raw_comment.fromName) ? '' : ' (' + raw_comment.fromName + ')');
        }
        else {
            comment.summary.messageView.sender.senderName = raw_comment.fromName;
        }
        comment.actionButtons = {};
        comment.actionButtons.reply = {
            highlighted: false,
            id: raw_comment.id,
            text: '@' + raw_comment.fromName + ' '
        };
        comment.actionButtons.delete = {
            action: 'deleteInstagramBusinessComment',
            commentID: raw_comment.id
        };
        return comment;
    };
    FeedCommentsProvider.prototype.getMappedLNComment = function (raw_comment, isReply) {
        if (isReply === void 0) { isReply = false; }
        console.log('raw_comment', raw_comment);
        var comment = {};
        comment.actionButtons = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.feedItem.data.eventTitle,
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.isCommentView = true;
        comment.profile = this.feedItem.profile;
        comment.network = this.feedItem.network;
        comment.data = {
            updateKey: raw_comment.id,
            creator: raw_comment.creator,
            eventTime: this.feedItem.data.eventTime,
            eventUserName: this.feedItem.data.eventUserName
        };
        comment.data.uniqueId = raw_comment.id;
        if (!isReply) {
            comment.data.defaultProfileImage = this.feedItem.feed.defaultProfileImage;
        }
        if (raw_comment.aggregatedTotal) {
            comment.data.replyCount = raw_comment.aggregatedTotal;
        }
        comment.summary = {
            messageView: {
                sender: {
                    senderName: '',
                    twittterHandle: '',
                    createdDate: parseInt(raw_comment.creationTimestamp),
                    senderProfileImage: raw_comment.creator.pictureUrl || (!isReply) ? this.feedItem.feed.defaultProfileImage : this.feedItem.data.defaultProfileImage,
                    senderProfileURL: raw_comment.creator.siteStandardProfileRequest
                },
                messageText: raw_comment.text
            }
        };
        // Media
        var media = {
            isImage: false,
            isAnimated: false,
            isSticker: false,
            alt: '',
            mediaUrl: '',
            gallery: []
        };
        if (raw_comment.contentList && raw_comment.contentList.content) {
            if (!Array.isArray(raw_comment.contentList.content))
                raw_comment.contentList.content = [raw_comment.contentList.content];
            // first item for now
            var content = raw_comment.contentList.content[0];
            if (typeof content.submittedUrl === 'string') {
                var type = content.title.toLowerCase();
                if (type === 'video') { }
                else {
                    media.mediaUrl = content.submittedUrl;
                    media.isImage = true;
                    media.gallery = [{
                            originalData: '',
                            url: {
                                full: content.submittedUrl,
                                thumbnail: content.submittedUrl
                            }
                        }];
                }
            }
        }
        if (media.mediaUrl !== '') {
            comment.summary.messageView.media = media;
        }
        if (raw_comment.creator.firstName) {
            comment.summary.messageView.sender.senderName = raw_comment.creator.firstName;
        }
        if (raw_comment.creator.lastName && typeof raw_comment.creator.lastName === 'string') {
            comment.summary.messageView.sender.senderName += ' (' + raw_comment.creator.lastName + ')';
        }
        if ((raw_comment.id == null || raw_comment.id.indexOf('UPDATE-') !== -1)) { }
        else {
            var actor = '';
            if (this.feedItem.profile.display.profile_name.indexOf('(Company Page)') === -1) {
                actor = 'urn:li:person:';
            }
            else {
                actor = 'urn:li:organization:';
            }
            actor += this.feedItem.profile.original_config.profile_Id;
            if (!isReply) {
                var actor_1 = '';
                if (this.feedItem.profile.display.profile_name.indexOf('(Company Page)') === -1) {
                    actor_1 = 'urn:li:person:';
                }
                else {
                    actor_1 = 'urn:li:organization:';
                }
                actor_1 += this.feedItem.profile.original_config.profile_Id;
                comment.actionButtons.reply = {
                    highlighted: false,
                    id: this.feedItem.data.updateKey,
                    actor: actor_1,
                    parentComment: raw_comment.id
                };
            }
            if (raw_comment.likesTotal) {
                console.log('raw_comment.likesTotal', raw_comment.likesTotal);
                comment.actionHeader = {};
                comment.actionHeader.likes = { count: parseInt(raw_comment.likesTotal) };
            }
            // if (isReply) {
            // } else {
            comment.actionButtons.lnLike = {
                highlighted: raw_comment.likedByUser ? true : false,
                action: 'likeLnShare',
                post_id: raw_comment.id,
                actor: actor
                // };
            };
        }
        return comment;
    };
    FeedCommentsProvider.prototype.getMappedGPComments = function (raw_comment) {
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.network = this.feedItem.network;
        comment.profile = this.feedItem.profile;
        comment.data = raw_comment;
        comment.isCommentView = true;
        comment.data.uniqueId = raw_comment.messageId;
        comment.summary = {
            messageView: {
                sender: {
                    senderName: raw_comment.fromName,
                    twittterHandle: '',
                    createdDate: raw_comment.createdTime,
                    senderProfileImage: raw_comment.fromPicture || this.feedItem.feed.defaultProfileImage,
                    senderProfileURL: raw_comment.fromProfileLink
                },
                messageText: raw_comment.message
            }
        };
        comment.actionButtons = {};
        if (this.feedItem.profile.original_config.page_id === raw_comment.fromId) {
            comment.actionButtons.edit = {
                action: 'updateGPComment',
                id: raw_comment.messageId
            };
        }
        //for comment delete button
        comment.actionButtons.delete = {
            action: 'deleteGPComment',
            commentID: raw_comment.messageId
        };
        return comment;
    };
    FeedCommentsProvider.prototype.getMappedTWComment = function (tweet) {
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.profile = this.feedItem.profile;
        comment.data = tweet;
        comment.network = this.feedItem.network;
        comment.profile = this.feedItem.profile;
        comment.isCommentView = true;
        comment.data.uniqueId = tweet.id;
        comment.summary = {
            messageView: {
                sender: {
                    senderName: tweet.name,
                    twittterHandle: '@' + tweet.username,
                    createdDate: new Date(tweet.date).getTime(),
                    senderProfileImage: tweet.images.large,
                    senderProfileURL: 'http://twitter.com/' + tweet.username
                },
                messageText: tweet.content
            }
        };
        var content = tweet.content;
        if (tweet.show_functions == 'twitter' && tweet.self && tweet.self.data) {
            var self_data = tweet.self.data;
            if (tweet.self.data.length)
                self_data = tweet.self.data[0];
            if (self_data.raw_data)
                content = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["w" /* tw_deep_link_to_html */](content, self_data.raw_data);
        }
        if (typeof content !== 'string')
            content = '';
        if (tweet.entities) {
            content = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["u" /* replaceWithDisplayURL */](content, tweet.entities);
        }
        // content = FeedHelper.unicode_to_image( content );
        content = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["q" /* mention_to_link */](content, 'twitter');
        content = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["n" /* hashtag_to_link */](content, 'twitter');
        comment.summary.messageView.messageText = content;
        comment.actionButtons = {};
        if (tweet.self) {
            var self_data = tweet.self.data;
            var tw_user_id = void 0;
            if (Array.isArray(tweet.self.data))
                self_data = tweet.self.data[0];
            tw_user_id = (self_data.user != undefined ? self_data.user.id_str : (self_data.sender != undefined ? self_data.sender.id_str : self_data.postID));
            if (tweet.self.profile.display.profile_name.toLowerCase().replace(/\s+/g, '') == tweet.username.toLowerCase().replace(/\s+/g, '')) {
                if (tweet.self.feed.id === 'direct_message' || self_data.eventType === 'TWDirectMessage'
                    || tweet.self.feed.id === 'mentions' || self_data.eventType === 'TWMentions' || tweet.self.feed.id === 'homeFeed') {
                    comment.actionButtons.delete = { postID: tweet.id };
                    comment.actionButtons.delete.action = (tweet.self.feed.id === 'mentions' || self_data.eventType === 'TWMentions') ? 'TWSTDestroy' : 'TWDestroy';
                    // console.log('RDRDRD YY', self_data.eventType, tweet.self);
                    if (comment.actionButtons.delete.action === 'TWDestroy' && tweet.self.feed.id === 'cinbox') {
                        var parameters = [];
                        if (this.feedItem.conversation) {
                            for (var _i = 0, _a = this.feedItem.conversation; _i < _a.length; _i++) {
                                var conversation = _a[_i];
                                if (conversation.id_str === tweet.id) {
                                    parameters = [{
                                            key: 'recipientId',
                                            value: conversation.recipient.id_str
                                        }, {
                                            key: 'senderId',
                                            value: conversation.sender.id_str
                                        }, {
                                            key: 'eventDate',
                                            value: this.feedItem.data[0].eventTime
                                        }];
                                }
                            }
                        }
                        comment.actionButtons.delete.parameters = parameters;
                        // console.log('RDRDRD', this.feedItem, tweet.id, parameters);
                    }
                    comment.isReChat = true;
                }
            }
            else if (tweet.self.feed.id == 'direct_message' || self_data.eventType == 'TWDirectMessage') {
                comment.actionButtons.directMessage = {
                    highlighted: false,
                    id: self_data.postID,
                    userID: self_data.postID
                };
            }
            else if (tweet.self.feed.id == 'mentions' || self_data.eventType == 'TWMentions'
                || tweet.self.feed.id == 'sendTweets' || tweet.self.feed.id == 'search' || tweet.self.feed.id == 'homeFeed'
                || tweet.self.feed.id == 'lists' || tweet.self.feed.id == 'outreach') {
                comment.actionButtons.reply = {
                    highlighted: false,
                    id: self_data.postID,
                    text: ''
                };
                if (tweet.self.actionButtons && tweet.self.actionButtons.directMessage) {
                    comment.actionButtons.directMessage = {
                        highlighted: false,
                        id: self_data.postID,
                        userID: self_data.postID
                    };
                }
                if (tw_user_id === tweet.self.feed.account.user_id) {
                }
                else {
                    comment.actionButtons.retweet = {
                        highlighted: (self_data.retweets != undefined && self_data.retweets.by_me == 'true'),
                        id: self_data.postID,
                        permalink: '',
                        text: ''
                    };
                    comment.actionButtons.twLike = {
                        highlighted: (self_data.favorites != undefined && self_data.favorites.by_me == 'true')
                    };
                    comment.data.postID = self_data.postID;
                }
            }
        }
        return comment;
    };
    FeedCommentsProvider.prototype.getMappedFBConversation = function (tweet) {
        var comment = {};
        comment.header = {
            profile: this.feedItem.profile,
            eventType: this.getEventTitle(),
            eventDate: null
        };
        comment.feed = { id: this.feedItem.feed.id, network: this.feedItem.feed.network };
        comment.profile = this.feedItem.profile;
        comment.data = tweet;
        comment.network = this.feedItem.network;
        comment.profile = this.feedItem.profile;
        comment.isCommentView = true;
        comment.data.uniqueId = tweet.id;
        comment.summary = {
            messageView: {
                sender: {
                    senderName: tweet.name,
                    twittterHandle: '',
                    createdDate: new Date(tweet.date).getTime(),
                    senderProfileImage: tweet.images.large,
                    senderProfileURL: 'http://facebook.com/' + tweet.userID
                },
                messageText: ''
            }
        };
        var content = tweet.content;
        if (typeof content !== 'string')
            content = '';
        content = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["r" /* new_url_to_link */](content);
        var autoMessExpr = /You are responding to \D* on your Page/gm;
        if (autoMessExpr.test(content)) {
            var m = void 0;
            var linkText = '';
            var regex = /View \w*./gm;
            if ((m = regex.exec(content)) !== null) {
                linkText = m[0];
                content = content.replace(linkText, '').replace('(', '').replace(')', '');
                linkText = linkText.replace('.', '');
            }
            var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
            content = content.replace(exp, "<a href='$1' target='_blank' rel='noopener noreferrer' >" + linkText + "</a>");
        }
        else {
            content = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["e" /* convertToHTML */](content);
            content = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["r" /* new_url_to_link */](content);
        }
        comment.summary.messageView.messageText = content;
        // Media
        if (tweet.media) {
            var media = {
                isImage: true,
                isAnimated: false,
                isSticker: false,
                alt: '',
                mediaUrl: '',
                gallery: []
            };
            media = this.feedItem.prepareFBMedia(tweet, media);
            if (media.mediaUrl !== '') {
                comment.summary.messageView.media = this.feedItem.prepareFBMedia(tweet, media);
            }
        }
        comment.actionButtons = {};
        comment.actionHeader = {};
        if (tweet.notification) {
            if (tweet.comments == undefined) {
                comment.actionHeader.comments = {
                    count: 0,
                    highlighted: false
                };
            }
            else {
                if (!Array.isArray(tweet.comments.comment)) {
                    tweet.comments.comment = [tweet.comments.comment];
                }
                comment.actionHeader.comments = {
                    count: tweet.comments.count,
                    highlighted: false
                };
                if (parseInt(tweet.comments.count) >= 1) {
                    comment.actionHeader.comments.highlighted = true;
                }
            }
            if (tweet.likes == undefined) {
                comment.actionHeader.likes = {
                    count: 0,
                    highlighted: false
                };
            }
            else {
                if (!Array.isArray(tweet.likes.like)) {
                    tweet.likes.like = [tweet.likes.like];
                }
                comment.actionHeader.likes = {
                    count: tweet.likes.count,
                    highlighted: false
                };
                if (parseInt(tweet.likes.count) >= 1) {
                    comment.actionHeader.likes.highlighted = true;
                }
            }
            if (tweet.object_type != 'link') {
                comment.actionButtons.comment = {
                    highlighted: false
                };
                comment.actionButtons.fbLike = {
                    highlighted: (tweet.user_likes == 'true')
                };
            }
        }
        else {
            if (tweet.self.profile.original_config.pageCategory != 'User') {
                if (tweet.self.feed.profile.original_config.pageId == tweet.userID) {
                }
                else {
                    comment.actionButtons.reply = {
                        highlighted: false,
                        action: 'addFbPost',
                        id: tweet.self.data.id,
                        text: ''
                    };
                }
            }
        }
        if (tweet.self) {
            if (tweet.self.feed.id === 'inBox' || tweet.self.data.eventType === 'FBDirectMessage') {
                if (tweet.userID === tweet.self.profile.original_config.pageId) {
                    comment.isReChat = true;
                }
            }
        }
        if (comment.summary.messageView.sender.createdDate && comment.actionButtons.reply) {
            var now = __WEBPACK_IMPORTED_MODULE_17_moment__(new Date()); //todays date
            var end = __WEBPACK_IMPORTED_MODULE_17_moment__(new Date(comment.summary.messageView.sender.createdDate)); // another date
            var duration = __WEBPACK_IMPORTED_MODULE_17_moment__["duration"](now.diff(end));
            var hours = duration.asHours();
            if (hours > 168) {
                comment.actionButtons.reply.disable = true;
                comment.actionButtons.reply.disableMsg = "Messenger reply must be within 7 days";
            }
        }
        return comment;
    };
    FeedCommentsProvider.prototype.updateCommentsCount = function (count) {
        if (!this.feedItem.actionHeader.comments) {
            return;
        }
        count = parseInt(count);
        this.feedItem.actionHeader.comments = {
            count: count,
            highlighted: false
        };
        if (count) {
            this.feedItem.actionHeader.comments.highlighted = true;
        }
    };
    FeedCommentsProvider.prototype.getIGBMessages = function () {
        var _this = this;
        // if (this.feedItem.feed.id === 'cinbox') {
        //   this.getOriginalPost('instabusiness');
        // }//to get the original post of the comments
        // let streamId = (this.feedItem.feed && this.feedItem.feed.id == "igbTags") ? "igbTagsComments" : "igbComments";
        console.log("igbInbox", this.feedItem);
        var streamId = "igbInbox";
        var postId = (this.feedItem.feed && this.feedItem.feed.id === 'igbInbox') ? this.feedItem.data.recipient_id : this.feedItem.data.fromId;
        var apiPath = "/feed/instagramBusiness";
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.feedItem.profile.account_id)
            .set("profileID", this.feedItem.profile.profile_id)
            .set("post_id", postId)
            .set("stream", streamId)
            .set("action", 'getInstagramBusinessFeed');
        if (this.feedItem.data.eventType && this.userSettingsProvider.isAgency()) {
            var brand = this.userSettingsProvider.getBrandById(this.feedItem.data.eventUserName);
            if (brand && !brand.selected) {
                httpParams = httpParams.set('fromClientId', brand.clientId);
            }
        }
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (httpResponse) {
            _this.comments = [];
            var count = 0;
            if (httpResponse && httpResponse.data && httpResponse.data.length
                && httpResponse.data[0].comments && httpResponse.data[0].comments.comment) {
                var items = httpResponse.data[0].comments.comment;
                if (!Array.isArray(items))
                    items = [items];
                // sort
                items.sort(function (a, b) {
                    if (a.createdTime > b.createdTime)
                        return 1;
                    else if (a.createdTime < b.createdTime)
                        return -1;
                    else
                        return 0;
                });
                for (var i = 0, l = items.length; i < l; i++) {
                    var raw_message = items[i];
                    count++;
                    var comment = {};
                    comment.header = {
                        profile: _this.feedItem.profile,
                        eventType: _this.getEventTitle(),
                        eventDate: null
                    };
                    // if (this.feedItem.header) {
                    //   if (this.feedItem.header.eventTags) comment.header.eventTags = this.feedItem.header.eventTags;
                    //   if (this.feedItem.header.assignedRoles) comment.header.assignedRoles = this.feedItem.header.assignedRoles;
                    // }
                    comment.feed = { id: _this.feedItem.feed.id, network: _this.feedItem.feed.network };
                    comment.profile = _this.feedItem.profile;
                    comment.isCommentView = true;
                    comment.network = _this.feedItem.network;
                    comment.profile = _this.feedItem.profile;
                    comment.data = {
                        id: raw_message.fromId,
                        text: raw_message.fromName,
                        recipient_id: raw_message.objectFromId,
                        eventUserName: _this.feedItem.data.eventUserName,
                        eventTime: _this.feedItem.data.eventTime
                    };
                    comment.data.ecCompleted = _this.feedItem.data.ecCompleted;
                    comment.data.uniqueId = raw_message.messageId;
                    comment.summary = {
                        messageView: {
                            sender: {
                                senderName: '',
                                twittterHandle: '',
                                createdDate: parseInt(raw_message.createdTime) * 1000,
                                senderProfileImage: raw_message.profilePic || _this.feedItem.feed.defaultProfileImage,
                                senderProfileURL: ''
                            },
                            messageText: raw_message.message
                        }
                    };
                    comment.summary.messageView.sender.senderName = raw_message.fromName;
                    // Media
                    var media = {
                        isImage: false,
                        isAnimated: false,
                        isSticker: false,
                        alt: '',
                        mediaUrl: '',
                        gallery: []
                    };
                    if (raw_message.media) {
                        media.isImage = true;
                        media.mediaUrl = raw_message.media.src;
                        if (raw_message.media.type && raw_message.media.type === 'sticker')
                            media.isSticker = true;
                        else if (raw_message.media.type === 'video') {
                            media.isImage = false;
                            media.isAnimated = true;
                            media.videoUrl = raw_message.media.href;
                        }
                        else {
                            media.gallery = [{
                                    originalData: '',
                                    url: {
                                        full: raw_message.media.src,
                                        thumbnail: raw_message.media.src
                                    }
                                }];
                        }
                    }
                    if (media.mediaUrl !== '')
                        comment.summary.messageView.media = media;
                    comment.actionButtons = {};
                    if (raw_message.fromId !== _this.feedItem.profile.original_config.page_id) {
                        comment.actionButtons.reply = {
                            highlighted: false,
                            id: raw_message.objectFromId,
                            // text: '@' + raw_message.fromName + ' '
                            text: ""
                        };
                    }
                    else {
                        comment.summary.messageView.sender.senderProfileImage = _this.feedItem.profile.display.profile_picture_url;
                    }
                    // Story
                    if (raw_message.objectFromName == 'Mention Story' || typeof raw_message.objectLink === 'string') {
                        // comment.actionButtons.showInMedia = {
                        //     label: 'Show Story',
                        //     link: raw_message.objectLink
                        // };
                        media.alt = 'Story';
                        media.isImage = true;
                        media.mediaUrl = raw_message.objectLink;
                        media.gallery = [{
                                originalData: '',
                                url: {
                                    full: raw_message.objectLink,
                                    thumbnail: raw_message.objectLink
                                }
                            }];
                        if (media.mediaUrl !== '')
                            comment.summary.messageView.media = media;
                        if (raw_message.objectFromName == 'Mention Story') {
                            comment.summary.messageView.messageText = 'Mentioned you in their story';
                            // comment.actionButtons.showInMedia.label = 'Show Story Mention';
                        }
                    }
                    if (raw_message.objectMessage === 'is_unsupported') {
                        comment.summary.messageView.messageText = 'Unsupported message';
                        comment.data.is_unsupported = true;
                    }
                    if (comment.summary.messageView.sender.createdDate && comment.actionButtons.reply) {
                        var today = new Date();
                        var createdate = new Date(comment.summary.messageView.sender.createdDate);
                        var hourDiff = Math.abs(today.getTime() - createdate.getTime()) / 3600000;
                        if (hourDiff > 168) {
                            comment.actionButtons.reply.disable = true;
                            comment.actionButtons.reply.disableMsg = "Messenger reply must be within 7 days";
                        }
                    }
                    if (comment.data.uniqueId === _this.feedItem.data.id) {
                        // comment.showEditor = true;
                        if (_this.feedItem.data.notes)
                            comment.data.notes = _this.feedItem.data.notes;
                        comment.actionButtons.completeItem = { highlighted: _this.feedItem.actionButtons.completeItem.highlighted };
                    }
                    if (raw_message.fromId === _this.feedItem.profile.original_config.page_id) {
                        comment.isReChat = true;
                    }
                    _this.comments.push(comment);
                }
            }
            return _this.comments;
        });
    };
    FeedCommentsProvider.prototype.getOriginalPost = function (feedType, data) {
        if (data === void 0) { data = {}; }
        var originalPost;
        this.feedItem.feed.profile = __WEBPACK_IMPORTED_MODULE_2_jquery__["extend"](true, {}, this.feedItem.profile);
        switch (feedType) {
            case 'instabusiness':
                data = {
                    fromId: this.feedItem.profile.original_config.page_id,
                    fromName: this.feedItem.profile.original_config.fullName,
                    id: this.feedItem.data.id,
                    media: this.feedItem.data.media,
                    mediaDescription: this.feedItem.data.my_post_text,
                    profilePic: this.feedItem.profile.display.profile_picture_url,
                    source: 'igb',
                    type: this.feedItem.data.type,
                    updateTime: __WEBPACK_IMPORTED_MODULE_18_moment_timezone___default()(this.feedItem.data.my_post_time * 1000, 'UTC').format('YYYY-MM-DDTHH:mm:ssZZ')
                };
                var igbStream = {
                    name: 'Comments',
                    network: 'instabusiness',
                    size: '1',
                    streamId: 'igbMedia',
                    id: 'igbMedia',
                    value: 'true'
                };
                if (this.feedItem.data.carousel_media) {
                    data.carousel_media = this.feedItem.data.carousel_media;
                }
                var igbFeed = new __WEBPACK_IMPORTED_MODULE_8__providers_feeds_classes_instagram_business_feed__["a" /* InstagramBusinessFeed */](this.http, igbStream, this.feedItem.profile, {}, {});
                originalPost = new __WEBPACK_IMPORTED_MODULE_15__providers_feeds_classes_feed_items_instagram_feed_item__["a" /* InstagramFeedItem */](this.http, igbFeed.formatInstagramBusinessItem(data), igbFeed);
                break;
            case 'instagram':
                data = {
                    created_time: this.feedItem.data.my_post_time,
                    id: this.feedItem.data.id,
                    images: this.feedItem.data.images,
                    link: this.feedItem.data.link,
                    type: this.feedItem.data.type,
                    user: {
                        id: this.feedItem.profile.data.userId,
                        full_name: this.feedItem.profile.original_config.fullName,
                        username: this.feedItem.profile.display.profile_name,
                        profile_picture: this.feedItem.profile.display.profile_picture_url
                    },
                    user_has_liked: this.feedItem.data.user_has_liked
                };
                if (this.feedItem.data.carousel_media) {
                    data.carousel_media = this.feedItem.data.carousel_media;
                }
                var igStream = {
                    name: 'Comments',
                    network: 'instagram',
                    size: '1',
                    streamId: 'igMyMedia',
                    id: 'igMyMedia',
                    value: 'true'
                };
                var igFeed = new __WEBPACK_IMPORTED_MODULE_7__providers_feeds_classes_instagram_feed__["a" /* InstagramFeed */](this.http, igStream, this.feedItem.profile, {}, {});
                originalPost = new __WEBPACK_IMPORTED_MODULE_15__providers_feeds_classes_feed_items_instagram_feed_item__["a" /* InstagramFeedItem */](this.http, data, igFeed);
                break;
            case 'youtube':
                data = {
                    activityType: 'upload',
                    updateTime: null,
                    fromId: this.feedItem.profile.original_config.userId,
                    fromName: this.feedItem.profile.display.profile_name,
                    channelId: this.feedItem.data.channelId,
                    channelTitle: this.feedItem.profile.display.profile_name,
                    channelLink: 'https://www.youtube.com/channel/' + this.feedItem.profile.original_config.userId.replace('channel==', ''),
                    profilePic: this.feedItem.profile.display.profile_picture_url,
                    media: this.feedItem.data.media,
                    views: this.feedItem.data.views,
                    message: this.feedItem.data.media.title // ???
                };
                var ytStream = {
                    name: 'Home - All Activities',
                    network: 'youtube',
                    size: '1',
                    streamId: 'yt_myChannelHome',
                    id: 'yt_myChannelHome',
                    value: 'true'
                };
                var ytFeed = new __WEBPACK_IMPORTED_MODULE_10__providers_feeds_classes_youtube_feed__["a" /* YoutubeFeed */](this.http, ytStream, this.feedItem.profile, {}, {});
                originalPost = new __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, data, ytFeed);
                break;
            case 'linkedin':
                data = {
                    creationTimestamp: this.feedItem.data.creationTimestamp,
                    isLiked: this.feedItem.data.isLiked,
                    updateContent: this.feedItem.data.updateContent,
                    updateKey: this.feedItem.data.updateKey
                };
                var lnStream = {
                    name: 'My Updates',
                    network: 'linkedin',
                    size: '1',
                    streamId: 'ln_posted',
                    id: 'ln_posted',
                    value: 'true'
                };
                var lnFeed = new __WEBPACK_IMPORTED_MODULE_12__providers_feeds_classes_linkedin_feed__["a" /* LinkedinFeed */](this.http, lnStream, this.feedItem.profile, {}, {});
                originalPost = new __WEBPACK_IMPORTED_MODULE_14__providers_feeds_classes_feed_items_linkedin_feed_item__["a" /* LinkedinFeedItem */](this.http, data, lnFeed);
                break;
            case 'facebook':
                var fbStream = {
                    name: 'Comment',
                    network: 'facebook',
                    size: '1',
                    streamId: 'timeline',
                    id: 'timeline',
                    value: 'true'
                };
                var fbFeed = new __WEBPACK_IMPORTED_MODULE_6__classes_facebook_feed__["a" /* FacebookFeed */](this.http, fbStream, this.feedItem.profile, {}, {});
                originalPost = new __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, data, fbFeed);
                //set current comment id
                var comment_id_1 = '';
                var exp = /(comment_id=\d*)/ig;
                var m = exp.exec(this.feedItem.data.link);
                if (m != null && this.feedItem.data.type !== 'Likes') {
                    comment_id_1 = m[0].replace('comment_id=', '');
                }
                exp = /(reply_comment_id=\d*)/ig;
                m = exp.exec(this.feedItem.data.link);
                if (m != null && this.feedItem.data.type !== 'Likes') {
                    comment_id_1 += '_' + m[0].replace('reply_comment_id=', '');
                }
                if (this.feedItem.data.eventTitle === 'Review Comment' || this.feedItem.data.eventType === 'FBAdsComments') {
                    comment_id_1 = this.feedItem.data.messageId;
                }
                if (this.feedItem.data.source === 'fbwebhook')
                    comment_id_1 = this.feedItem.data.commentId;
                if (comment_id_1 && originalPost.data.comments && originalPost.data.comments.comment != null) {
                    if (!Array.isArray(originalPost.data.comments.comment)) {
                        originalPost.data.comments.comment = [originalPost.data.comments.comment];
                    }
                    originalPost.data.comments.comment.forEach(function (comment) {
                        if (typeof comment.messageId === 'string' && comment.messageId.indexOf(comment_id_1) !== -1) {
                            originalPost.data.currentCommentID = comment.messageId;
                        }
                    });
                }
                //for comment view original post text
                if (this.feedItem.data.eventType === 'FBComments') {
                    if (originalPost.summary && originalPost.summary.messageView && originalPost.summary.messageView.messageText == '') {
                        originalPost.summary.messageView.messageText = this.feedItem.data.name;
                    }
                }
                break;
            case 'googleplus':
                data = {
                    attachments: this.feedItem.data.attachments,
                    message: this.feedItem.data.message,
                    postID: this.feedItem.data.postID,
                    selfLink: this.feedItem.data.selfLink,
                    updateTime: this.feedItem.data.createdTime,
                    user: {
                        fromId: this.feedItem.profile.original_config.page_id,
                        fromName: this.feedItem.profile.original_config.fullName,
                        profileLink: 'https://plus.google.com/' + this.feedItem.profile.original_config.page_id,
                        profilePic: this.feedItem.profile.original_config.profilePicture
                    }
                };
                var gpStream = {
                    name: 'My Posts (Pages)',
                    network: 'googleplus',
                    size: '1',
                    streamId: 'gp_pages_only',
                    id: 'gp_pages_only',
                    value: 'true'
                };
                var gpFeed = new __WEBPACK_IMPORTED_MODULE_11__providers_feeds_classes_googleplus_feed__["a" /* GoogleplusFeed */](this.http, gpStream, this.feedItem.profile, {}, {});
                originalPost = new __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, gpFeed.formatGPItem(data), gpFeed);
                break;
            case 'googlemybusiness':
                if (this.feedItem.data.eventType === 'GMBReviews') {
                    originalPost = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["c" /* cloneObject */](this.feedItem);
                }
                if (this.feedItem.data.eventType === 'GMBQuestions') {
                    if (this.feedItem.data.eventQuestion == null)
                        originalPost = this.feedItem;
                    else {
                        var gmbStream = {
                            streamId: "gmbQuestions",
                            id: 'gmbQuestions',
                            name: "Questions & answers",
                            network: 'googlemybusiness',
                            value: "true",
                            size: "1"
                        };
                        var gmbFeed = new __WEBPACK_IMPORTED_MODULE_20__classes_google_business_feed__["a" /* GoogleMyBusinessFeed */](this.http, gmbStream, this.feedItem.profile, {}, {});
                        gmbFeed.account = this.feedItem.feed.account;
                        originalPost = new __WEBPACK_IMPORTED_MODULE_13__providers_feeds_classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, gmbFeed.formatGMBItem(this.feedItem.data.eventQuestion), gmbFeed);
                        originalPost.actionHeader = this.feedItem.actionHeader;
                        if (originalPost.actionButtons) {
                            if (originalPost.actionButtons.showViewLatest)
                                delete originalPost.actionButtons.showViewLatest;
                            if (originalPost.actionButtons.edit)
                                delete originalPost.actionButtons.edit;
                            if (originalPost.actionButtons.delete)
                                delete originalPost.actionButtons.delete;
                        }
                    }
                }
                break;
        }
        // console.log('originalPost', originalPost);
        delete originalPost.data.originalPost;
        this.feedItem.data.originalPost = originalPost;
    };
    FeedCommentsProvider.prototype.getEventTitle = function () {
        var eventType = '';
        if (this.feedItem.feed.network === 'cinbox') {
            eventType = __WEBPACK_IMPORTED_MODULE_16__providers_feeds_feed_helper__["j" /* formatEventType */](this.feedItem.data.eventType);
        }
        else {
            eventType = this.feedItem.data.eventTitle;
        }
        return eventType;
    };
    FeedCommentsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_21__user_settings_user_settings__["a" /* UserSettingsProvider */]])
    ], FeedCommentsProvider);
    return FeedCommentsProvider;
}());

//# sourceMappingURL=feed-comments-service.js.map

/***/ }),

/***/ 413:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EventActionButtonsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


var EventActionButtonsProvider = /** @class */ (function () {
    function EventActionButtonsProvider(_http) {
        this._http = _http;
    }
    ; //end constructor
    /***********************************************************\
   * GENERIC METHOD TO SAVE BOOLEAN VALUES FOR ACTION BUTTONS
  /***********************************************************/
    EventActionButtonsProvider.prototype.saveButtonValueInUserEvents = function (actionButtonRequest) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        //convert only booleans to string
        for (var key in actionButtonRequest) {
            requestBody = requestBody.append("events[0][" + key + "]", actionButtonRequest[key].toString());
        }
        ; //end for loop
        return this
            ._http
            .post("/user/events", requestBody);
    };
    ; //end saveButtonValueInUserEvents
    /******************************************************\
     *                 LIKE METHOD TWITTER
    /******************************************************/
    EventActionButtonsProvider.prototype.saveLikeForTwitter = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("id", data.userId)
            .set("action", data.action);
        return this
            ._http
            .post("/feed/favorite", requestBody);
    };
    ; //end saveLikeForTwitter
    /******************************************************\
     *                 LIKE METHOD  - FACEBOOK
    /******************************************************/
    EventActionButtonsProvider.prototype.saveLikeForFacebook = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("comment_id", data.userId)
            .set("action", data.action)
            .set("liked", data.like);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end saveLikeForFacebook
    EventActionButtonsProvider.prototype.savePostLikeForFacebook = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.postId)
            .set("action", data.action)
            .set("like", data.like);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end saveLikeForFacebook
    /******************************************************\
    *            FOLLOW METHOD - TWITTER
    /******************************************************/
    EventActionButtonsProvider.prototype.saveTWFollower = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("user_id", data.userId)
            .set("action", data.action);
        console.info("InboxActionButtonProvider::_saveFollower  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/follow", requestBody);
    };
    ; //end saveTWFollower
    /****************************************************\
     *   TWITTER - CONVERSATION HISTORY FOR DIRECTMESSAGE
    /*****************************************************/
    EventActionButtonsProvider.prototype.deleteTWDirectMessage = function (data) {
        console.info('Entering InboxActionButtonProvider::deleteTWDirectMessage.');
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.postId)
            .set("action", data.action);
        return this
            ._http
            .post("/feed/deletePost", requestBody);
    };
    ; //end deleteTWDirectMessage
    /****************************************************\
   *   FACEBOOK - CONVERSATION HISTORY FOR COMMENTS
  /*****************************************************/
    EventActionButtonsProvider.prototype.deleteFBComment = function (data) {
        console.info('Entering InboxActionButtonProvider::deleteFBComment.');
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("comment_id", data.commentId)
            .set("action", data.action);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end deleteFBComment
    /******************************************************\
     *                 LIKE METHOD YOUTUBE
    /******************************************************/
    EventActionButtonsProvider.prototype.saveLikeForYoutube = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.userId)
            .set("action", data.action)
            .set("like", data.like);
        console.info("InboxActionButtonProvider::saveLikeForYoutube  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end saveLikeForYoutube
    /******************************************************\
     *                 LIKE METHOD INSTAGRAM
    /******************************************************/
    EventActionButtonsProvider.prototype.saveLikeForInstagram = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.userId)
            .set("action", data.action)
            .set("like", data.like);
        console.info("InboxActionButtonProvider::saveLikeForInstagram  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end saveLikeForInstagram
    /******************************************************\
     *                 Follow METHOD INSTAGRAM
    /******************************************************/
    EventActionButtonsProvider.prototype.saveFollowForInstagram = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("user_id", data.userId)
            .set("action", data.action)
            .set("follow", data.follow);
        console.info("InboxActionButtonProvider::saveFollowForInstagram  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end saveFollowForInstagram
    /******************************************************\
     *                 LIKE METHOD LINKEDIN
    /******************************************************/
    EventActionButtonsProvider.prototype.saveLikeForLinkedin = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.post_id)
            .set("action", data.action)
            .set("payload", data.payload);
        console.info("InboxActionButtonProvider::saveFollowForInstagram  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end saveFollowForInstagram
    /******************************************************\
     *                 UNLIKE METHOD LINKEDIN
    /******************************************************/
    EventActionButtonsProvider.prototype.saveUnLikeForLinkedin = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.post_id)
            .set("action", data.action)
            .set("actor", data.actor);
        console.info("InboxActionButtonProvider::saveFollowForInstagram  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end saveFollowForInstagram
    /******************************************************\
     *                 UNLIKE METHOD LINKEDIN
    /******************************************************/
    EventActionButtonsProvider.prototype.deleteLnShare = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("id", data.id)
            .set("action", data.action);
        console.info("InboxActionButtonProvider::saveFollowForInstagram  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/deleteLinkedinShare", requestBody);
    };
    ; //end saveFollowForInstagram
    /******************************************************\
     *                 DELETE IGB COMMENT
    /******************************************************/
    EventActionButtonsProvider.prototype.deleteInstagramBusinessComment = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("comment_id", data.comment_id)
            .set("action", data.action);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end deleteInstagramBusinessComment
    /******************************************************\
     *                 DELETE IG COMMENT
    /******************************************************/
    EventActionButtonsProvider.prototype.deleteInstagramComment = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("comment_id", data.comment_id)
            .set("post_id", data.post_id)
            .set("action", data.action);
        return this
            ._http
            .post("/feed/like", requestBody);
    };
    ; //end deleteInstagramComment
    /****************************************************\
     *   PUBLISHING
    /*****************************************************/
    EventActionButtonsProvider.prototype.deletedraftPostPublishing = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("id", data.id);
        return this
            ._http
            .post("/publishing/deleteUnscheduledPosts", requestBody);
    };
    ; //end deletedraftPostPublishing
    /******************************************************\
     *                 DELETE YT COMMENT
    /******************************************************/
    EventActionButtonsProvider.prototype.deleteYoutubeComment = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("object_id", data.object_id)
            .set("action", data.action);
        console.info("InboxActionButtonProvider::saveFollowForInstagram  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end deleteYoutubeComment
    EventActionButtonsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], EventActionButtonsProvider);
    return EventActionButtonsProvider;
}());

; //end EventActionButtonsProvider
; //end ActionButtonRequest
; //end TwitterLikeRequest
; //end FacebookLikeRequest
; //end FacebookLikeRequest
; //end TwitterFollowRequest
; //end FacebookDeleteCommentRequest
; //end TwitterDeleteInterface
; //end PublishingDeleteInterface
; //end YTLikeRequest
; //end InstagramLikeRequest
; //end InstagramLikeRequest
//# sourceMappingURL=event-action-buttons.js.map

/***/ }),

/***/ 414:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PostPreviewProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment_timezone__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_moment_timezone__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

//PROVIDERS




var PostPreviewProvider = /** @class */ (function () {
    function PostPreviewProvider(_accountsServiceProvider, _appSettingsProvider, _userSettingsProvider) {
        var _this = this;
        this._accountsServiceProvider = _accountsServiceProvider;
        this._appSettingsProvider = _appSettingsProvider;
        this._userSettingsProvider = _userSettingsProvider;
        this.userTimeZone = this._userSettingsProvider.getUserTimeZone();
        this.userSettings = this._userSettingsProvider.userSettingsSource.value;
        ;
        this._userSettingsProvider
            .userSettings$
            .subscribe(function (userSettings) {
            _this.userSettings = userSettings;
            _this.userTimeZone = _this._userSettingsProvider.getUserTimeZone();
        });
    }
    PostPreviewProvider.prototype.getPreviewData = function (post, profileType) {
        if (profileType === void 0) { profileType = 'Facebook'; }
        var preview = {
            content: post.content
        };
        // Account
        if (post.accounts) {
            var account = post.accounts.find(function (account) {
                return account.profile.display.network.backend_network_name === profileType;
            });
            if (account) {
                preview.account = account;
            }
        }
        // Media
        if (post.attachments && post.attachments.length) {
            preview.media = post.attachments[0];
        }
        // title and description
        if (['Facebook', 'GooglePlus', 'Linkedin', 'Blogger'].indexOf(profileType) !== -1) {
            if (post.previewContent) {
                if (!post.attachments.length && post.scrappedAttachments.length) {
                    preview.media = post.scrappedAttachments[0];
                }
                preview.title = {
                    content: post.previewContent.title,
                    link: (post.previewContent.scrappedUrl != '' ? post.previewContent.scrappedUrl : post.link)
                };
                preview.description = post.previewContent.description;
            }
        }
        if (profileType === 'Instagram' || profileType === 'InstaBusiness') {
            preview.content = '';
            preview.description = post.content;
        }
        if (profileType === 'GoogleMyBusiness' && post.callsToAction) {
            if (post.callsToAction && post.callsToAction.gmbEvent) {
                preview.content = this.getEventContent(post.callsToAction.gmbEvent);
            }
            if (post.callsToAction.gmb) {
                var actionType = post.callsToAction.gmb.actionType;
                var url = post.callsToAction.gmb.url || '';
                if (url.indexOf('//') === -1)
                    url = '//' + url;
                if (typeof actionType === 'string' && typeof url === 'string') {
                    preview.content += ('<div class="gmb-call-to-action"><a href="' + url + '" target="_blank">' + actionType.replace(/_/g, ' ') + '</a></div>');
                }
            }
        }
        return preview;
    };
    PostPreviewProvider.prototype.getEventContent = function (event) {
        var postHourFormat = '24h';
        if (this.userSettings && this.userSettings.postHourFormat) {
            postHourFormat = this.userSettings.postHourFormat;
        }
        var start = __WEBPACK_IMPORTED_MODULE_4_moment_timezone___default.a.tz(event.startMonth + '-' + event.startDay + '-' + event.startYear + ' '
            + event.startHours + ':' + event.startMinutes, 'MM-DD-YYYY h:mm', this.userTimeZone);
        var end = __WEBPACK_IMPORTED_MODULE_4_moment_timezone___default.a.tz(event.endMonth + '-' + event.endDay + '-' + event.endYear + ' '
            + event.endHours + ':' + event.endMinutes, 'MM-DD-YYYY h:mm', this.userTimeZone);
        if (postHourFormat === '12h') {
            start = start.format('MMM DD, YYYY, h:mmA');
            end = end.format('MMM DD, YYYY, h:mmA');
        }
        else {
            start = start.format('MMM DD, YYYY, H:mm');
            end = end.format('MMM DD, YYYY, H:mm');
        }
        return '<strong>' + start + ' -<br>' + end + '</strong><br>' + event.title;
    };
    ;
    PostPreviewProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_2__app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_user_settings_user_settings__["a" /* UserSettingsProvider */]])
    ], PostPreviewProvider);
    return PostPreviewProvider;
}());

//# sourceMappingURL=post-preview.js.map

/***/ }),

/***/ 415:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TEImageListServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_uuid_v1__ = __webpack_require__(335);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_uuid_v1___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_uuid_v1__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_te_text_editor_service_te_text_editor_service__ = __webpack_require__(352);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



// PROVIDERS

var TEImageListServiceProvider = /** @class */ (function () {
    function TEImageListServiceProvider(_http, _textEditorServiceProvider) {
        this._http = _http;
        this._textEditorServiceProvider = _textEditorServiceProvider;
        this._localMappedImagesArray = [];
        console.log('Hello ImageListProvider Provider');
    }
    ;
    TEImageListServiceProvider.prototype.getGiphyOrStickers = function (requestParams, resetLocalImagesArray) {
        var _this = this;
        if (resetLocalImagesArray) {
            console.log('Giphy reset local image array !!!');
            this._localMappedImagesArray = [];
        }
        var params = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set('action', 'getGiphyFeed')
            .set('command', "trending")
            .set('mode', requestParams.mode);
        //build array for offset and limit
        var parameters = [
            { "key": "limit", "value": requestParams.limit.toString() },
            { "key": "offset", "value": requestParams.offset.toString() }
        ];
        //Push to array, if search value exists
        if (requestParams.searchValue && requestParams.searchValue.trim().length > 0) {
            params = params.set('command', 'search');
            parameters.push({ "key": "q", "value": requestParams.searchValue });
        }
        ;
        //Build params based on parameters array
        for (var index = 0; index < parameters.length; index++) {
            params = params.set("parameters[\"" + index + "\"][key]", parameters[index]["key"])
                .set("parameters[\"" + index + "\"][value]", parameters[index]["value"]);
        }
        ;
        console.log('Giphy params', parameters);
        console.log('params before HTTP GET', params);
        return this._http.get("/giphy/gf", { params: params }).map(function (giphyResponse) {
            giphyResponse['data'].map(function (giphyAttachment) {
                var mappedThumbnail = {
                    originalData: giphyAttachment,
                    url: {
                        full: giphyAttachment["images"]["original"]["url"],
                        thumbnail: giphyAttachment["images"]["fixed_width"]["url"],
                        alt: giphyAttachment['title']
                    }
                };
                _this._localMappedImagesArray.push(mappedThumbnail);
            });
            return _this._localMappedImagesArray;
        });
    };
    ; // end getGiphyOrStickers
    TEImageListServiceProvider.prototype.getPixabayImages = function (requestParams, resetLocalImagesArray) {
        var _this = this;
        console.log('resetLocalImagesArray', resetLocalImagesArray);
        if (resetLocalImagesArray) {
            this._localMappedImagesArray = [];
        }
        var params = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]().set("action", "getPixabayFeed");
        // Array for default paramters
        var parameters = [
            { "key": "image_type", "value": "photo" },
            { "key": "category", "value": requestParams.category },
            { "key": "min_width", "value": requestParams.min_width },
            { "key": "min_height", "value": requestParams.min_height },
        ];
        // Category
        if (requestParams.category) {
            parameters.push({ "key": "category", "value": requestParams.category });
        }
        ;
        //Search - Push to array, if search value exists
        if (requestParams.searchValue && requestParams.searchValue.trim().length > 0) {
            parameters.push({ "key": "q", "value": requestParams.searchValue });
        }
        //Scroll - Push to array, if Scroll values exists
        if (requestParams.scroll_total_count) {
            parameters.push({ "key": "total_count", "value": requestParams.scroll_total_count });
        }
        ;
        //Build params based on parameters array
        for (var index = 0; index < parameters.length; index++) {
            params = params.set("parameters[\"" + index + "\"][key]", parameters[index]["key"])
                .set("parameters[\"" + index + "\"][value]", parameters[index]["value"]);
        }
        ;
        // Pagination
        if (requestParams.pagination) {
            var pagination = [
                { key: "page", value: requestParams.pagination.page },
                { key: "count", value: requestParams.pagination.count },
                { key: "per_page", value: requestParams.pagination.per_page }
            ];
            for (var index = 0; index < pagination.length; index++) {
                params = params.set("pagination[" + pagination[index].key + "]", pagination[index].value);
            }
            ;
        }
        ;
        return this._http.get("/feed/pixabay", { params: params }).map(function (pixabayResponse) {
            pixabayResponse['hits'].map(function (pixabayAttachment) {
                var mappedThumbnail = {
                    originalData: pixabayAttachment,
                    url: {
                        full: pixabayAttachment["largeImageURL"],
                        thumbnail: pixabayAttachment["previewURL"],
                        alt: pixabayAttachment["type"]
                    }
                };
                _this._localMappedImagesArray.push(mappedThumbnail);
            });
            return _this._localMappedImagesArray;
        });
    };
    ; // end getPixabayImages
    /********** Convert images from Pixabay/Giphy/Stickers to eClincher S3 ***************/
    TEImageListServiceProvider.prototype.convertExternalUrlToS3 = function (imageInfo, source) {
        console.info('Entering InboxActionButtonProvider::s3Upload.', imageInfo);
        var requestBody = {};
        if (source === "pixabay") {
            var ext = imageInfo.originalData.webformatURL.split('.'); // imageInfo.value.webformatURL.split('.');
            requestBody = {
                action: "s3_upload",
                images: {
                    src: imageInfo.originalData.webformatURL,
                    title: "",
                    filename: __WEBPACK_IMPORTED_MODULE_2_uuid_v1___default()() + '.' + ext[2],
                    ext: ext[2]
                }
            };
        }
        else if (source === "giphy") {
            var media = imageInfo.originalData.images.original.url.split(".");
            media = media[0].replace('https://', '');
            media = media.replace('http://', '');
            requestBody = {
                action: "s3_upload",
                images: {
                    src: imageInfo.originalData.images.original.url,
                    title: "",
                    filename: __WEBPACK_IMPORTED_MODULE_2_uuid_v1___default()() + "_GID-" + imageInfo.originalData.id + "-" + media + "." + imageInfo.originalData.type,
                    ext: imageInfo.originalData.type // imageInfo[i].value.type
                }
            };
        }
        ;
        return this
            ._http
            .post("/upload/s3", requestBody);
    };
    ; // end convertExternalUrlToS3
    TEImageListServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_3__providers_te_text_editor_service_te_text_editor_service__["a" /* TETextEditorServiceProvider */]])
    ], TEImageListServiceProvider);
    return TEImageListServiceProvider;
}());

; // end ImageListServiceProvider
;
;
;
//# sourceMappingURL=te-image-list-service.js.map

/***/ }),

/***/ 416:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TESavedRepliesServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


var TESavedRepliesServiceProvider = /** @class */ (function () {
    function TESavedRepliesServiceProvider(_http) {
        this._http = _http;
    }
    TESavedRepliesServiceProvider.prototype.getSavedReplies = function () {
        var getSavedReplies = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        getSavedReplies.set("action", "getSavedReplies");
        return this
            ._http
            .get("/publishing/savedReplies", { params: getSavedReplies });
    };
    ; // end getSavedReplies
    TESavedRepliesServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], TESavedRepliesServiceProvider);
    return TESavedRepliesServiceProvider;
}());

; //end InboxSavedRepliesServiceProvider
//# sourceMappingURL=te-saved-replies-service.js.map

/***/ }),

/***/ 417:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ViewProfileProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_jquery__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__feed_helper__ = __webpack_require__(30);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



//provider


var ViewProfileProvider = /** @class */ (function () {
    function ViewProfileProvider(http, _userSettingsProvider) {
        this.http = http;
        this._userSettingsProvider = _userSettingsProvider;
    }
    /**
     * getComments
     */
    ViewProfileProvider.prototype.getProfile = function (feedItem) {
        this.feedItem = feedItem;
        var params = {};
        var network = (this.feedItem.feed.network || this.feedItem.data.eventNetwork);
        console.log('this.feedItem', this.feedItem);
        switch (this.feedItem.network) {
            case 'facebook':
                return this.getFacebokProfile();
            case 'youtube':
                return this.getYTUserProfile();
            case 'instagram':
                return this.getInstaUserProfile();
            case 'instabusiness':
                return this.getInstaBusinessProfile();
            case 'linkedin':
                return this.getLinkedInProfile();
            case 'googleplus':
                return this.getGPUserProfile();
            case 'twitter':
                return this.getTwitterUserProfile();
            case 'googlemybusiness':
                return this.getGMBUserProfile();
            case 'blogger':
                return this.getBloggerProfile();
            default:
            // return Observable.of([]);
        }
    };
    ViewProfileProvider.prototype.getYTUserProfile = function () {
        var _this = this;
        console.log('this.feedItem', this.feedItem, this.feedItem.data, this.feedItem.data.fromId);
        var params = {};
        var profile = {};
        profile.youTubeInfo = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.userId = this.feedItem.data.fromId;
        params.action = 'getYTChannelInfo';
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                if (data.data.items && data.data.items[0]) {
                    if (data.data.items[0].media && typeof data.data.items[0].media.src === 'string') {
                        profile.profilePic = data.data.items[0].media.src;
                    }
                    else {
                        profile.profilePic = _this.feedItem.data.profilePic;
                    }
                    ;
                    profile.name = data.data.items[0].channelTitle;
                    if (data.data.items[0].message != undefined)
                        profile.description = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["y" /* url_to_link */](data.data.items[0].message);
                    if (data.data.items[0].subscribers && data.data.items[0].subscribers.count != undefined)
                        profile.youTubeInfo.subscribers = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["h" /* fixCommasInString */](data.data.items[0].subscribers.count);
                    if (data.data.items[0].views && data.data.items[0].views.count != undefined)
                        profile.youTubeInfo.views = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["h" /* fixCommasInString */](data.data.items[0].views.count);
                    profile.youTubeInfo.channelLink = 'https://www.youtube.com/channel/' + data.data.items[0].channelId;
                }
                console.log('profile', profile);
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getInstaUserProfile = function () {
        var _this = this;
        var profile = {};
        profile.instagram = {};
        console.log('getInstaUserProfile');
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.userId = (this.feedItem.feed.id === 'cinbox') ? this.feedItem.profile.original_config.userId : this.feedItem.data.user.id;
        params.action = 'getInUserProfile';
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                if (data.type === 'error') {
                    if (data.first_name === 'APINotAllowedError') {
                        profile.instagram.errorType = 'APINotAllowedError';
                    }
                    else {
                        profile.instagram.errorType = 'error';
                        profile.name = data.first_name;
                        profile.instagram.userName = data.full_name;
                    }
                    profile.instagram.isError = true;
                    profile.instagram.publicProfile = "http://instagram.com/" + _this.feedItem.data.user.username;
                }
                else {
                    profile = {
                        profilePic: _this.feedItem.data.user.profile_picture || _this.feedItem.feed.defaultProfileImage,
                        name: (typeof data.first_name == 'string' ? data.full_name : data.username),
                    };
                    profile.instagram = {};
                    profile.instagram.isError = false;
                    if (data.username != undefined)
                        profile.instagram.userName = data.username;
                    if (data.counts.followed_by != undefined)
                        profile.instagram.followers = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.counts.followed_by);
                    if (data.counts.follows != undefined)
                        profile.instagram.following = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.counts.follows);
                    if (data.counts.media != undefined)
                        profile.instagram.posts = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.counts.media);
                    if (data.bio != undefined && typeof data.bio != 'object')
                        profile.instagram.bio = data.bio;
                    if (data.website != undefined && typeof data.website != 'object')
                        profile.instagram.websiteUrl = data.website;
                    profile.instagram.publicProfile = "http://instagram.com/" + data.username;
                    if (data.outgoing_status === 'follows')
                        profile.instagram.followStatus = 'following';
                    else if (data.outgoing_status === 'paramsed')
                        profile.instagram.followStatus = 'paramsed';
                    else
                        profile.instagram.followStatus = 'follow';
                }
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getInstaBusinessProfile = function () {
        var _this = this;
        var profile = {};
        profile.instagram = {};
        console.log('getInstaUserProfile');
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        // params.userId = this.feedItem.data.user.id;
        params.stream = 'ig_business_account';
        params.action = 'getInstagramBusinessFeed';
        params.next = '';
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                if (data.code === 'SUCCESS' && data.data && Array.isArray(data.data)) {
                    data = data.data[0];
                    profile.profilePic = data.profilePic || _this.feedItem.feed.defaultProfileImage;
                    profile.name = (typeof data.name == 'string' ? data.name : data.fromName);
                    if (data.fromName != null)
                        profile.instagram.userName = data.fromName;
                    if (data.caption != null)
                        profile.instagram.followers = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.caption);
                    if (data.source != null)
                        profile.instagram.following = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.source);
                    if (data.type != null)
                        profile.instagram.posts = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.type);
                    if (data.mediaDescription && typeof data.mediaDescription === 'string')
                        profile.instagram.bio = data.mediaDescription;
                    if (data.permalink && typeof data.permalink === 'string')
                        profile.instagram.websiteUrl = data.permalink;
                    // $items.append('<div class="user-info-row profile-link"><strong>Public Profile: </strong><a target="_blank" href="http://instagram.com/'+data.username+'">http://instagram.com/'+data.username+'</a></div>');
                }
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getFacebokProfile = function () {
        var _this = this;
        var profile = {};
        profile.facebook = {};
        console.log('getInstaUserProfile');
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.userId = this.feedItem.data.fromId;
        params.action = 'getFBUserProfile';
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                profile.profilePic = 'https://graph.facebook.com/' + params.userId + '/picture?width=1000&height=1000';
                if (data.code === 'FAIL') {
                    profile.name = "not available - FB API limit reached";
                }
                else {
                    profile.facebook.profile = {};
                    profile.name = (data.name || data.firstName + ' ' + data.lastName);
                    if (data.location && !__WEBPACK_IMPORTED_MODULE_2_jquery__["isEmptyObject"](data.location.name))
                        profile.facebook.profile.location = data.location.name;
                    if (data.friends != undefined)
                        profile.facebook.profile.friends = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.friends);
                    if (data.mutual_friends != undefined)
                        profile.facebook.profile.mutualFriends = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.mutual_friends);
                    if (data.bio != undefined)
                        profile.facebook.profile.bio = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["y" /* url_to_link */](data.bio);
                    if (data.website != undefined)
                        profile.facebook.profile.websiteUrl = data.website;
                    if (data.profile != null)
                        profile.facebook.profile.publicProfile = data.profile;
                }
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getLinkedInProfile = function () {
        var _this = this;
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.action = 'getLNUserProfile';
        if (this.feedItem.data.fromId != undefined)
            params.userId = this.feedItem.data.fromId;
        else if (this.feedItem.data.updateContent != undefined && this.feedItem.data.updateContent.person != undefined) {
            var personId = this.feedItem.data.updateContent.person.id;
            if (typeof personId === 'string' && personId.indexOf('urn:li:person') === -1) {
                delete params.userId;
                params.cmp_id = personId.replace('urn:li:organization:', '');
            }
            else
                params.userId = personId.replace('urn:li:person:', '');
        }
        else {
            params.userId = this.feedItem.data.id;
            if (params.userId == null && this.feedItem.profile)
                params.userId = this.feedItem.profile.profile_id;
        }
        if (this.feedItem.feed.stream.streamId == "ln_companies") {
            delete params.userId;
            params.cmp_id = this.feedItem.data.profile_id;
        }
        if (this.feedItem.feed.stream.streamId === 'lnc_homeWall') {
            delete params.userId;
            params.cmp_id = this.feedItem.profile.original_config.profile_Id;
        }
        var profile = {};
        profile.linkedin = {};
        console.log('params', params);
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                console.log('this.feedItem', _this.feedItem);
                var fullName, picUrl;
                if (['home', 'ln_companies' /*,'cinbox'*/].indexOf(_this.feedItem.feed.stream.streamId) !== -1) {
                    if (_this.feedItem.data.smallLogoUrl)
                        picUrl = _this.feedItem.data.smallLogoUrl;
                    // else picUrl = this.feedItem.profile.picture;
                    // picUrl = this.feedItem.data.smallLogoUrl;
                    fullName = _this.feedItem.data.name;
                    if (_this.feedItem.data.updateContent != undefined && _this.feedItem.data.updateContent.currentUpdate != undefined && _this.feedItem.data.updateContent.currentUpdate.content != undefined && _this.feedItem.data.updateContent.currentUpdate.content.title != undefined) {
                        _this.feedItem.data.headline = _this.feedItem.data.updateContent.currentUpdate.content.title;
                    }
                    _this.feedItem.data.location = '';
                    _this.feedItem.data.numConnections = '';
                    _this.feedItem.data.industry = '';
                    if (_this.feedItem.data.updateContent != undefined && _this.feedItem.data.updateContent.currentUpdate != undefined && _this.feedItem.data.updateContent.currentUpdate.content != undefined && _this.feedItem.data.updateContent.currentUpdate.content.description != undefined) {
                        _this.feedItem.data.summary = _this.feedItem.data.updateContent.currentUpdate.content.description;
                    }
                    _this.feedItem.data.url = 'https://www.linkedin.com/company/' + _this.feedItem.profile.profile_id;
                }
                else if (_this.feedItem.feed.stream.streamId == "lnc_homeWall") {
                    if (data.smallLogoUrl)
                        picUrl = data.smallLogoUrl;
                    else if (_this.feedItem.data.smallLogoUrl)
                        picUrl = _this.feedItem.data.smallLogoUrl;
                    // else picUrl = this.feedItem.profile.picture;
                    fullName = data.name;
                }
                else if (_this.feedItem.feed.stream.streamId == "cinbox") {
                    picUrl = data.pictureUrl || data.smallLogoUrl || _this.feedItem.data.updateContent.person.pictureUrl || _this.feedItem.feed.defaultProfileImage;
                    fullName = data.name || data.firstName + ' ' + data.lastName;
                }
                else if (_this.feedItem.feed.stream.streamId == "groups") {
                    fullName = _this.feedItem.data.name;
                    picUrl = _this.feedItem.data.smallLogoUrl;
                }
                else if (_this.feedItem.feed.stream.streamId == "contacts") {
                    fullName = "<a href='" + _this.feedItem.data.siteStandardProfileRequest + "' target='_blank'>" + _this.feedItem.data.firstName + " " + _this.feedItem.data.lastName + "</a>";
                    picUrl = _this.feedItem.data.pictureUrl;
                }
                else if (_this.feedItem.feed.stream.streamId === 'ln_posted') {
                    fullName = data.firstName + ' ' + data.lastName;
                    picUrl = data.pictureUrl || _this.feedItem.feed.defaultProfileImage;
                }
                else {
                    fullName = _this.feedItem.data.updateContent.person.firstName + ' ' + _this.feedItem.data.updateContent.person.lastName;
                    picUrl = _this.feedItem.data.updateContent.person.pictureUrl;
                }
                if (data.pictureUrl != undefined)
                    profile.profilePic = data.pictureUrl;
                else if (picUrl)
                    profile.profilePic = picUrl;
                // LN company page feed
                if ((_this.feedItem.data.smallLogoUrl && _this.feedItem.feed.stream.streamId !== 'cinbox') || _this.feedItem.feed.stream.streamId === 'lnc_homeWall') {
                    profile.name = fullName;
                    profile.linkedin.isCompany = true;
                    profile.profilePic = _this.feedItem.feed.defaultProfileImage;
                    if (data.location != undefined)
                        profile.linkedin.location = data.location.name;
                    if (data.description != undefined)
                        profile.linkedin.summary = data.description;
                    if (data.numFollowers != undefined)
                        profile.linkedin.followers = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.numFollowers);
                    if (data.websiteUrl)
                        profile.linkedin.websiteUrl = data.websiteUrl;
                    if (data.url)
                        profile.linkedin.publicProfile = data.url;
                }
                else {
                    profile.name = fullName;
                    profile.linkedin.isCompany = false;
                    if (data.location != undefined)
                        profile.linkedin.location = data.location.name;
                    if (data.numConnections != undefined)
                        profile.linkedin.connectionCount = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.numConnections);
                    if (data.numFollowers != undefined)
                        profile.linkedin.followersCount = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.numFollowers);
                    if (data.headline != undefined)
                        profile.linkedin.headline = data.headline;
                    if (data.industry != undefined)
                        profile.linkedin.industry = data.industry;
                    if (data.summary != undefined)
                        profile.linkedin.summary = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["y" /* url_to_link */](data.summary);
                    if (data.description != undefined)
                        profile.linkedin.description = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["y" /* url_to_link */](data.description);
                    if (data.url != undefined)
                        profile.linkedin.publicProfile = data.url;
                    if (data.websiteUrl != undefined)
                        profile.linkedin.websiteUrl = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["y" /* url_to_link */](data.websiteUrl);
                }
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getGPUserProfile = function () {
        var _this = this;
        var profile = {};
        profile.googlePlus = {};
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.userId = this.feedItem.data.fromId;
        params.action = 'gp_user_info';
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                profile.profilePic = data.data[0].profile_pic || _this.feedItem.feed.defaultProfileImage;
                profile.name = data.data[0].displayName;
                profile.googlePlus.publicProfile = data.data[0].profile_url;
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getBloggerProfile = function () {
        var _this = this;
        var profile = {};
        profile.blogger = {};
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.userId = this.feedItem.data.fromId;
        params.action = 'bl_user_info';
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                if (data.data[0].self == 'true') {
                    profile.profilePic = _this.feedItem.data.profilePic || _this.feedItem.feed.defaultProfileImage;
                    profile.name = data.data[0].displayName;
                    if (data.data[0].aboutMe != undefined)
                        profile.blogger.description = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["y" /* url_to_link */](data.data[0].aboutMe);
                    profile.blogger.publicProfile = data.data[0].profile_url;
                }
                else {
                    profile.profilePic = _this.feedItem.data.profilePic;
                    profile.name = _this.feedItem.data.fromName;
                    profile.blogger.publicProfile = _this.feedItem.data.profileLink;
                }
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getGMBUserProfile = function () {
        var _this = this;
        var profile = {};
        profile.googleMyBusiiness = {};
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.stream = 'gmbLocation';
        params.action = 'getGoogleMyBusinessFeed';
        params.next = this.feedItem.data.fromId;
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                profile.profilePic = _this.feedItem.data.profilePic || _this.feedItem.feed.defaultProfileImage;
                profile.name = data.data[0].name;
                profile.googleMyBusiiness.websiteUrl = data.data[0].websiteUrl;
                resolve(profile);
            });
        });
    };
    ViewProfileProvider.prototype.getTwitterUserProfile = function () {
        var _this = this;
        var profile = {};
        profile.twitter = {};
        var params = {};
        params.accountID = this.feedItem.profile.account_id;
        params.profileID = this.feedItem.profile.profile_id;
        params.action = 'getTWUserProfile';
        var id_str = '';
        if (this.feedItem.data[0]) {
            id_str = (this.feedItem.data[0].user) ? this.feedItem.data[0].user.id_str : this.feedItem.data[0].postID;
        }
        else {
            id_str = (this.feedItem.data.user) ? this.feedItem.data.user.id_str : this.feedItem.data.postID;
        }
        params.userId = id_str;
        console.log('this.feedItem', this.feedItem);
        return new Promise(function (resolve, reject) {
            _this._userSettingsProvider.getUserProfile(params).subscribe(function (data) {
                var tw_user_id = data.id;
                var tw_screen_name = data.screen_name;
                var image = _this.feedItem.data.profilePic;
                if (_this.feedItem.data.user && _this.feedItem.data.user.id_str) {
                    console.log('HERE');
                    if (typeof _this.feedItem.data.profilePic == undefined)
                        image = data.profile_image_url_https;
                    profile.profilePic = image.replace('_normal', '');
                    profile.name = data.name;
                }
                else if (_this.feedItem.data[0] && _this.feedItem.data[0].user) {
                    console.log('HERE2');
                    profile.profilePic = _this.feedItem.data[0].profilePic.replace('_normal', '');
                    profile.name = _this.feedItem.data[0].user.name;
                }
                else if (_this.feedItem.data[0]) {
                    console.log('HERE3');
                    profile.profilePic = _this.feedItem.data[0].sender.profile_image_url.replace('_normal', '');
                    profile.name = _this.feedItem.data[0].sender.name;
                }
                else if (_this.feedItem.data.profilePic) {
                    console.log('HERE4');
                    profile.profilePic = _this.feedItem.data.profilePic.replace('_mini', '').replace('_normal', '');
                    profile.name = (data.name || data.firstName + ' ' + data.lastName);
                }
                else {
                    console.log('HERE5');
                    profile.profilePic = _this.feedItem.data.smallLogoUrl.replace('_normal', '');
                    profile.name = (data.name || data.firstName + ' ' + data.lastName);
                }
                profile.twitter.profile = {};
                profile.twitter.profile.verified = false;
                if (data.verified === 'true') {
                    profile.twitter.profile.verified = true;
                }
                if (data.followers_count && _this.feedItem.profile.data.power_users.state === 'on') {
                    var followers_count = Number(data.followers_count);
                    if (followers_count <= Number(_this.feedItem.profile.data.power_users.mediumHigh)
                        && followers_count >= Number(_this.feedItem.profile.data.power_users.mediumLow)) {
                        profile.twitter.profile.powerUser = 'medium';
                    }
                    else if (followers_count > Number(_this.feedItem.profile.data.power_users.mediumHigh)) {
                        profile.twitter.profile.powerUser = 'high';
                    }
                }
                profile.twitter.profile.twitterHandle = '@' + data.screen_name;
                console.log('type', typeof data.entities);
                if (data.entities && typeof data.entities.url != undefined && typeof data.entities.url.urls != undefined) {
                    var urls = data.entities.url.urls, site_url;
                    if (Array.isArray(urls))
                        site_url = urls[0];
                    else
                        site_url = urls;
                    if (!__WEBPACK_IMPORTED_MODULE_2_jquery__["isEmptyObject"](site_url.expanded_url) && !__WEBPACK_IMPORTED_MODULE_2_jquery__["isEmptyObject"](site_url.display_url))
                        profile.twitter.profile.websiteUrl = site_url.expanded_url;
                    profile.twitter.profile.webDisplayUrl = site_url.display_url;
                }
                if (data.location)
                    profile.twitter.profile.location = data.location;
                if (data.friends_count)
                    profile.twitter.profile.following = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.friends_count);
                if (data.followers_count)
                    profile.twitter.profile.followers = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.followers_count);
                if (data.statuses_count)
                    profile.twitter.profile.tweets = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.statuses_count);
                if (data.favourites_count != null)
                    profile.twitter.profile.favorites = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.favourites_count);
                if (data.listed_count != null)
                    profile.twitter.profile.listed = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["d" /* commas */](data.listed_count);
                if (data.description) {
                    var regex = /(^|[^@\w])@(\w{1,15})\b/g, message_htm = __WEBPACK_IMPORTED_MODULE_4__feed_helper__["y" /* url_to_link */](data.description), replace = '$1<a class="tw-user" href="https://twitter.com/$2" target="_blank" data-user="@$2">@$2</a>';
                    message_htm = message_htm.replace(regex, replace);
                    profile.twitter.profile.bio = message_htm;
                }
                console.log('profile', profile);
                profile.twitter.profile.publicProfile = 'http://twitter.com/' + data.screen_name;
                resolve(profile);
            });
        });
    };
    ViewProfileProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_3__providers_user_settings_user_settings__["a" /* UserSettingsProvider */]])
    ], ViewProfileProvider);
    return ViewProfileProvider;
}());

//# sourceMappingURL=view-profile-service.js.map

/***/ }),

/***/ 418:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__ = __webpack_require__(419);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__app_module__ = __webpack_require__(437);


Object(__WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__["a" /* platformBrowserDynamic */])().bootstrapModule(__WEBPACK_IMPORTED_MODULE_1__app_module__["a" /* AppModule */]);
//# sourceMappingURL=main.js.map

/***/ }),

/***/ 437:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AppModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser__ = __webpack_require__(47);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_splash_screen__ = __webpack_require__(392);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ionic_native_status_bar__ = __webpack_require__(393);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_device__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_native_app_version__ = __webpack_require__(394);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ionic_native_network__ = __webpack_require__(148);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ionic_native_in_app_browser__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__ionic_native_facebook__ = __webpack_require__(337);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_google_plus__ = __webpack_require__(336);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ionic_native_instagram__ = __webpack_require__(349);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__ionic_native_fcm__ = __webpack_require__(395);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__ionic_native_file_transfer__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__ionic_native_file__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__ionic_native_file_chooser__ = __webpack_require__(405);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__ionic_native_android_permissions__ = __webpack_require__(350);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__ionic_native_clipboard__ = __webpack_require__(147);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__ionic_native_camera__ = __webpack_require__(403);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__ionic_native_media_capture__ = __webpack_require__(404);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__ionic_native_web_intent__ = __webpack_require__(150);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__ionic_native_autostart__ = __webpack_require__(396);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__ionic_native_in_app_purchase_2__ = __webpack_require__(351);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__ionic_native_date_picker__ = __webpack_require__(411);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__ionic_native_screen_orientation__ = __webpack_require__(397);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__ionic_native_keyboard__ = __webpack_require__(407);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__pipes_pipes_module__ = __webpack_require__(399);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__app_component__ = __webpack_require__(509);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__providers_http_interceptor_http_interceptor__ = __webpack_require__(510);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__providers_app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__providers_auth_auth__ = __webpack_require__(80);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__providers_facebook_facebook__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__providers_user_data_user_data__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__providers_badge_count_badge_count__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__providers_te_text_editor_service_te_text_editor_service__ = __webpack_require__(352);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__providers_te_image_list_service_te_image_list_service__ = __webpack_require__(415);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__providers_te_saved_replies_service_te_saved_replies_service__ = __webpack_require__(416);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__providers_event_mapping_helper_event_mapping_helper__ = __webpack_require__(514);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__providers_event_view_comments_service_event_view_comments_service__ = __webpack_require__(515);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__providers_event_view_conversations_service_event_view_conversations_service__ = __webpack_require__(408);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__providers_event_reply_retweet_dm_service_event_reply_retweet_dm_service__ = __webpack_require__(516);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_44__providers_event_action_buttons_event_action_buttons__ = __webpack_require__(413);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_45__providers_accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_46__providers_accounts_service_accounts_map_account__ = __webpack_require__(333);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_47__providers_accounts_service_accounts_map_profile__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_48__providers_accounts_brands_service_accounts_brands_service__ = __webpack_require__(141);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_49__providers_accounts_add_accounts_add__ = __webpack_require__(409);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_50__providers_publishing_service_publishing_service__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_51__providers_publishing_service_publishing_map_post__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_52__providers_publishing_service_publishing_validator__ = __webpack_require__(146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_53__providers_publishing_service_scrapping_service__ = __webpack_require__(406);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_54__providers_publishing_service_post_preview__ = __webpack_require__(414);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_55__providers_publishing_service_mention__ = __webpack_require__(401);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_56__providers_feeds_feeds_service__ = __webpack_require__(138);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_57__providers_feeds_feed_comments_service__ = __webpack_require__(412);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_58__providers_feeds_feed_notes_service__ = __webpack_require__(149);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_59__providers_feeds_inbox_filter__ = __webpack_require__(139);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_60__providers_feeds_action_button__ = __webpack_require__(400);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_61__providers_feeds_view_profile_service__ = __webpack_require__(417);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_62__providers_fcm_fcm__ = __webpack_require__(142);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_63__providers_window_service_window_service__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_64__providers_ec_uploader_ec_uploader__ = __webpack_require__(402);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_65__providers_in_app_in_app__ = __webpack_require__(145);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_66__providers_crisp_chat_crisp_chat__ = __webpack_require__(398);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_67__ionic_native_file_path__ = __webpack_require__(348);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_68__providers_reputations_reputations__ = __webpack_require__(140);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_69__ionic_native_browser_tab__ = __webpack_require__(410);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
//IONIC-ANGULAR







//IONIC-NATIVE























// PIPES

//APP

//-------------- PROVIDERS ----------------------------


//USER




//GENERAL

//TEXT_EDITOR



// EVENT





// ACCOUNTS





// INBOX
// import { InboxServiceProvider } from '../providers/feeds/inbox-service';
// import {InboxMappingProvider} from '../providers/feeds/inbox-mapping';
// PUBLISHING






// Feeds














var AppModule = /** @class */ (function () {
    function AppModule() {
    }
    AppModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["L" /* NgModule */])({
            declarations: [__WEBPACK_IMPORTED_MODULE_29__app_component__["a" /* MyApp */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["i" /* IonicModule */].forRoot(__WEBPACK_IMPORTED_MODULE_29__app_component__["a" /* MyApp */], {
                    backButtonText: '',
                    backButtonIcon: 'ios-arrow-back'
                }, {
                    links: [
                        { loadChildren: '../pages/accounts-brands-manage/accounts-brands-manage.module#AccountsBrandsManagePageModule', name: 'AccountsBrandsManagePage', segment: 'accounts-brands-manage', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/accounts-manage/accounts-manage.module#AccountsManagePageModule', name: 'AccountsManagePage', segment: 'accounts-manage', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/accounts-social-profiles/accounts-social-profiles.module#AccountsSocialProfilesPageModule', name: 'AccountsSocialProfilesPage', segment: 'accounts-social-profiles', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/add-gmb-event/add-gmb-event.module#AddGmbEventPageModule', name: 'AddGmbEventPage', segment: 'add-gmb-event', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/add-location/add-location.module#AddLocationPageModule', name: 'AddLocationPage', segment: 'add-location', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/add-tiktok-account/add-tiktok-account.module#AddTiktokAccountPageModule', name: 'AddTiktokAccountPage', segment: 'add-tiktok-account', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/add-zendesk-account/add-zendesk-account.module#AddZendeskAccountPageModule', name: 'AddZendeskAccountPage', segment: 'add-zendesk-account', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/approval-assign/approval-assign.module#ApprovalAssignPageModule', name: 'ApprovalAssignPage', segment: 'approval-assign', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/approval-comment/approval-comment.module#ApprovalCommentPageModule', name: 'ApprovalCommentPage', segment: 'approval-comment', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/approval-list/approval-list.module#ApprovalListPageModule', name: 'ApprovalListPage', segment: 'approval-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/approval-post-detail/approval-post-detail.module#ApprovalPostDetailPageModule', name: 'ApprovalPostDetailPage', segment: 'approval-post-detail', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/auth-forgot-password/auth-forgot-password.module#AuthForgotPasswordPageModule', name: 'AuthForgotPasswordPage', segment: 'auth-forgot-password', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/auth-login/auth-login.module#AuthLoginPageModule', name: 'AuthLoginPage', segment: 'auth-login', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/auth-signup/auth-signup.module#AuthSignupPageModule', name: 'AuthSignupPage', segment: 'auth-signup', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/auth-pricing/auth-pricing.module#AuthPricingPageModule', name: 'AuthPricingPage', segment: 'auth-pricing', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/boards/boards.module#BoardsPageModule', name: 'BoardsPage', segment: 'boards', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/change-password/change-password.module#ChangePasswordPageModule', name: 'ChangePasswordPage', segment: 'change-password', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/comments-list/comments-list.module#CommentsListPageModule', name: 'CommentsListPage', segment: 'comments-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/event-reply-retweet-dm/event-reply-retweet-dm.module#EventReplyRetweetDMPageModule', name: 'EventReplyRetweetDMPage', segment: 'event-reply-retweet-dm', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/event-view-comments/event-view-comments.module#EventViewCommentsPageModule', name: 'EventViewCommentsPage', segment: 'event-view-comments', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/event-view-conversation/event-view-conversation.module#EventViewConversationPagePageModule', name: 'EventViewConversationPage', segment: 'event-view-conversation', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/fcm-testing/fcm-testing.module#FcmTestingPageModule', name: 'FcmTestingPage', segment: 'fcm-testing', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/feed-groups/feed-groups.module#FeedGroupsPageModule', name: 'FeedGroupsPage', segment: 'feed-groups', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/feed-popover/feed-popover.module#FeedPopoverPageModule', name: 'FeedPopoverPage', segment: 'feed-popover', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/feed-settings/feed-settings.module#FeedSettingsPageModule', name: 'FeedSettingsPage', segment: 'feed-settings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/feed-streams/feed-streams.module#FeedStreamsPageModule', name: 'FeedStreamsPage', segment: 'feed-streams', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/feeds/feeds.module#FeedsPageModule', name: 'FeedsPage', segment: 'feeds', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/inbox-filters/inbox-filters.module#InboxFiltersPageModule', name: 'InboxFiltersPage', segment: 'inbox-filters', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/inbox-notes/inbox-notes.module#InboxNotesPageModule', name: 'InboxNotesPage', segment: 'inbox-notes', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/inbox-roles/inbox-roles.module#InboxRolesPageModule', name: 'InboxRolesPage', segment: 'inbox-roles', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/inbox-settings-individual-profiles/inbox-settings-individual-profiles.module#InboxSettingsIndividualProfilesPageModule', name: 'InboxSettingsIndividualProfilesPage', segment: 'inbox-settings-individual-profiles', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/inbox-settings/inbox-settings.module#InboxSettingsPageModule', name: 'InboxSettingsPage', segment: 'inbox-settings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/inbox-tags/inbox-tags.module#InboxTagsPageModule', name: 'InboxTagsPage', segment: 'inbox-tags', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/inbox/inbox.module#InboxPageModule', name: 'InboxPage', segment: 'inbox', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/instagram-notifications/instagram-notifications.module#InstagramNotificationsPageModule', name: 'InstagramNotificationsPage', segment: 'instagram-notifications', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/instagram-profiles-list/instagram-profiles-list.module#InstagramProfilesListPageModule', name: 'InstagramProfilesListPage', segment: 'instagram-profiles-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/keywords/keywords.module#KeywordsPageModule', name: 'KeywordsPage', segment: 'keywords', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/main-tabs/main-tabs.module#MainTabsPageModule', name: 'MainTabsPage', segment: 'main-tabs', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/mentions-list/mentions-list.module#MentionsListPageModule', name: 'MentionsListPage', segment: 'mentions-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/pages-new-rre/pages-new-rre.module#PagesNewRrePageModule', name: 'PagesNewRrePage', segment: 'pages-new-rre', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/post-filter/post-filter.module#PostFilterPageModule', name: 'PostFilterPage', segment: 'post-filter', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/post-settings/post-settings.module#PostSettingsPageModule', name: 'PostSettingsPage', segment: 'post-settings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/profiles/profiles.module#ProfilesPageModule', name: 'ProfilesPage', segment: 'profiles', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/publishin-actions-popup/publishin-actions-popup.module#PublishinActionsPopupPageModule', name: 'PublishinActionsPopupPage', segment: 'publishin-actions-popup', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/publishing-post-preview/publishing-post-preview.module#PublishingPostPreviewPageModule', name: 'PublishingPostPreviewPage', segment: 'publishing-post-preview', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/publishing-schedule/publishing-schedule.module#PublishingSchedulePageModule', name: 'PublishingSchedulePage', segment: 'publishing-schedule', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/publishing-select-profiles/publishing-select-profiles.module#PublishingSelectProfilesPageModule', name: 'PublishingSelectProfilesPage', segment: 'publishing-select-profiles', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/publishing/publishing.module#PublishingPageModule', name: 'PublishingPage', segment: 'publishing', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/rep-filters/rep-filters.module#RepFiltersPageModule', name: 'RepFiltersPage', segment: 'rep-filters', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/rep-popover/rep-popover.module#RepPopoverPageModule', name: 'RepPopoverPage', segment: 'rep-popover', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/rep-roles/rep-roles.module#RepRolesPageModule', name: 'RepRolesPage', segment: 'rep-roles', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/rep-tags/rep-tags.module#RepTagsPageModule', name: 'RepTagsPage', segment: 'rep-tags', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/reputations/reputations.module#ReputationsPageModule', name: 'ReputationsPage', segment: 'reputations', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/retweet-list/retweet-list.module#RetweetListPageModule', name: 'RetweetListPage', segment: 'retweet-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/settings/settings.module#SettingsPageModule', name: 'SettingsPage', segment: 'settings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/subscription/subscription.module#SubscriptionPageModule', name: 'SubscriptionPage', segment: 'subscription', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/suggested-hashtags/suggested-hashtags.module#SuggestedHashtagsPageModule', name: 'SuggestedHashtagsPage', segment: 'suggested-hashtags', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/te-image-list/te-image-list.module#TEImageListPageModule', name: 'TEImageListPage', segment: 'te-image-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/te-saved-replies/te-saved-replies.module#TESavedRepliesPageModule', name: 'TESavedRepliesPage', segment: 'te-saved-replies', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/te-thumbnail-modal/te-thumbnail-modal.module#TEThumbnailModalPageModule', name: 'TEThumbnailModalPage', segment: 'te-thumbnail-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/tiktok-notifications/tiktok-notifications.module#TiktokNotificationsPageModule', name: 'TiktokNotificationsPage', segment: 'tiktok-notifications', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/tiktok-profile-list/tiktok-profile-list.module#TiktokProfileListPageModule', name: 'TiktokProfileListPage', segment: 'tiktok-profile-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/video-properties/video-properties.module#VideoPropertiesPageModule', name: 'VideoPropertiesPage', segment: 'video-properties', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/video-thumnails/video-thumnails.module#VideoThumnailsPageModule', name: 'VideoThumnailsPage', segment: 'video-thumnails', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/view-profile/view-profile.module#ViewProfilePageModule', name: 'ViewProfilePage', segment: 'view-profile', priority: 'low', defaultHistory: [] }
                    ]
                }),
                __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser__["a" /* BrowserModule */],
                __WEBPACK_IMPORTED_MODULE_4__angular_common_http__["c" /* HttpClientModule */],
                __WEBPACK_IMPORTED_MODULE_28__pipes_pipes_module__["a" /* PipesModule */],
                __WEBPACK_IMPORTED_MODULE_3__ionic_storage__["a" /* IonicStorageModule */].forRoot()
            ],
            bootstrap: [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["g" /* IonicApp */]],
            entryComponents: [__WEBPACK_IMPORTED_MODULE_29__app_component__["a" /* MyApp */]],
            providers: [
                {
                    provide: __WEBPACK_IMPORTED_MODULE_1__angular_core__["v" /* ErrorHandler */],
                    useClass: __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["h" /* IonicErrorHandler */]
                },
                __WEBPACK_IMPORTED_MODULE_6__ionic_native_status_bar__["a" /* StatusBar */],
                __WEBPACK_IMPORTED_MODULE_5__ionic_native_splash_screen__["a" /* SplashScreen */],
                __WEBPACK_IMPORTED_MODULE_7__ionic_native_device__["a" /* Device */],
                __WEBPACK_IMPORTED_MODULE_8__ionic_native_app_version__["a" /* AppVersion */],
                __WEBPACK_IMPORTED_MODULE_9__ionic_native_network__["a" /* Network */],
                __WEBPACK_IMPORTED_MODULE_10__ionic_native_in_app_browser__["a" /* InAppBrowser */],
                __WEBPACK_IMPORTED_MODULE_69__ionic_native_browser_tab__["a" /* BrowserTab */],
                __WEBPACK_IMPORTED_MODULE_11__ionic_native_facebook__["a" /* Facebook */],
                __WEBPACK_IMPORTED_MODULE_12__ionic_native_google_plus__["a" /* GooglePlus */],
                __WEBPACK_IMPORTED_MODULE_13__ionic_native_instagram__["a" /* Instagram */],
                __WEBPACK_IMPORTED_MODULE_14__ionic_native_fcm__["a" /* FCM */],
                __WEBPACK_IMPORTED_MODULE_17__ionic_native_file_chooser__["a" /* FileChooser */],
                __WEBPACK_IMPORTED_MODULE_67__ionic_native_file_path__["a" /* FilePath */],
                __WEBPACK_IMPORTED_MODULE_15__ionic_native_file_transfer__["a" /* FileTransfer */],
                __WEBPACK_IMPORTED_MODULE_16__ionic_native_file__["a" /* File */],
                __WEBPACK_IMPORTED_MODULE_18__ionic_native_android_permissions__["a" /* AndroidPermissions */],
                __WEBPACK_IMPORTED_MODULE_19__ionic_native_clipboard__["a" /* Clipboard */],
                __WEBPACK_IMPORTED_MODULE_20__ionic_native_camera__["a" /* Camera */],
                __WEBPACK_IMPORTED_MODULE_21__ionic_native_media_capture__["a" /* MediaCapture */],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["a" /* ActionSheetController */],
                __WEBPACK_IMPORTED_MODULE_22__ionic_native_web_intent__["a" /* WebIntent */],
                __WEBPACK_IMPORTED_MODULE_23__ionic_native_autostart__["a" /* Autostart */],
                __WEBPACK_IMPORTED_MODULE_24__ionic_native_in_app_purchase_2__["a" /* InAppPurchase2 */],
                __WEBPACK_IMPORTED_MODULE_25__ionic_native_date_picker__["a" /* DatePicker */],
                __WEBPACK_IMPORTED_MODULE_27__ionic_native_keyboard__["a" /* Keyboard */],
                __WEBPACK_IMPORTED_MODULE_26__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
                {
                    provide: __WEBPACK_IMPORTED_MODULE_4__angular_common_http__["a" /* HTTP_INTERCEPTORS */],
                    useClass: __WEBPACK_IMPORTED_MODULE_30__providers_http_interceptor_http_interceptor__["a" /* HttpInterceptorProvider */],
                    multi: true
                },
                //GENERAL
                __WEBPACK_IMPORTED_MODULE_31__providers_app_settings_app_settings__["a" /* AppSettingsProvider */],
                __WEBPACK_IMPORTED_MODULE_32__providers_auth_auth__["a" /* AuthProvider */],
                __WEBPACK_IMPORTED_MODULE_33__providers_facebook_facebook__["a" /* FacebookProvider */],
                __WEBPACK_IMPORTED_MODULE_35__providers_user_data_user_data__["a" /* UserDataProvider */],
                __WEBPACK_IMPORTED_MODULE_34__providers_user_settings_user_settings__["a" /* UserSettingsProvider */],
                __WEBPACK_IMPORTED_MODULE_36__providers_badge_count_badge_count__["a" /* BadgeCountProvider */],
                // TEXT_EDITOR
                __WEBPACK_IMPORTED_MODULE_37__providers_te_text_editor_service_te_text_editor_service__["a" /* TETextEditorServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_38__providers_te_image_list_service_te_image_list_service__["a" /* TEImageListServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_39__providers_te_saved_replies_service_te_saved_replies_service__["a" /* TESavedRepliesServiceProvider */],
                //Events
                __WEBPACK_IMPORTED_MODULE_41__providers_event_view_comments_service_event_view_comments_service__["a" /* EventViewCommentsServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_42__providers_event_view_conversations_service_event_view_conversations_service__["a" /* EventViewConversationsServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_43__providers_event_reply_retweet_dm_service_event_reply_retweet_dm_service__["a" /* EventReplyRetweetDmServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_40__providers_event_mapping_helper_event_mapping_helper__["a" /* EventMappingHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_44__providers_event_action_buttons_event_action_buttons__["a" /* EventActionButtonsProvider */],
                //Inbox and Feeds
                // InboxMappingProvider,
                //ACCOUNTS
                __WEBPACK_IMPORTED_MODULE_45__providers_accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_46__providers_accounts_service_accounts_map_account__["a" /* AccountsMapAccountProvider */],
                __WEBPACK_IMPORTED_MODULE_47__providers_accounts_service_accounts_map_profile__["a" /* AccountsMapProfileProvider */],
                __WEBPACK_IMPORTED_MODULE_48__providers_accounts_brands_service_accounts_brands_service__["a" /* AccountsBrandsServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_49__providers_accounts_add_accounts_add__["a" /* AccountsAddProvider */],
                //INBOX
                // InboxServiceProvider,
                //PUBLISHING
                __WEBPACK_IMPORTED_MODULE_50__providers_publishing_service_publishing_service__["a" /* PublishingProvider */],
                __WEBPACK_IMPORTED_MODULE_53__providers_publishing_service_scrapping_service__["a" /* ScrappingProvider */],
                __WEBPACK_IMPORTED_MODULE_51__providers_publishing_service_publishing_map_post__["a" /* PublishingMapPostProvider */],
                __WEBPACK_IMPORTED_MODULE_52__providers_publishing_service_publishing_validator__["a" /* PublishingValidatorProvider */],
                __WEBPACK_IMPORTED_MODULE_54__providers_publishing_service_post_preview__["a" /* PostPreviewProvider */],
                __WEBPACK_IMPORTED_MODULE_55__providers_publishing_service_mention__["a" /* MentionsProvider */],
                //FEEDS
                __WEBPACK_IMPORTED_MODULE_56__providers_feeds_feeds_service__["a" /* FeedsServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_57__providers_feeds_feed_comments_service__["a" /* FeedCommentsProvider */],
                __WEBPACK_IMPORTED_MODULE_58__providers_feeds_feed_notes_service__["a" /* FeedNotesProvider */],
                __WEBPACK_IMPORTED_MODULE_59__providers_feeds_inbox_filter__["a" /* InboxFilterProvider */],
                __WEBPACK_IMPORTED_MODULE_60__providers_feeds_action_button__["a" /* ActionButtonsProvider */],
                __WEBPACK_IMPORTED_MODULE_61__providers_feeds_view_profile_service__["a" /* ViewProfileProvider */],
                __WEBPACK_IMPORTED_MODULE_62__providers_fcm_fcm__["a" /* FcmProvider */],
                __WEBPACK_IMPORTED_MODULE_63__providers_window_service_window_service__["a" /* WindowServiceProvider */],
                __WEBPACK_IMPORTED_MODULE_64__providers_ec_uploader_ec_uploader__["a" /* EcUploaderProvider */],
                __WEBPACK_IMPORTED_MODULE_65__providers_in_app_in_app__["a" /* InAppProvider */],
                __WEBPACK_IMPORTED_MODULE_66__providers_crisp_chat_crisp_chat__["a" /* CrispChatProvider */],
                __WEBPACK_IMPORTED_MODULE_68__providers_reputations_reputations__["a" /* ReputationsProvider */],
            ]
        })
    ], AppModule);
    return AppModule;
}());

;
//# sourceMappingURL=app.module.js.map

/***/ }),

/***/ 475:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./af": 206,
	"./af.js": 206,
	"./ar": 207,
	"./ar-dz": 208,
	"./ar-dz.js": 208,
	"./ar-kw": 209,
	"./ar-kw.js": 209,
	"./ar-ly": 210,
	"./ar-ly.js": 210,
	"./ar-ma": 211,
	"./ar-ma.js": 211,
	"./ar-sa": 212,
	"./ar-sa.js": 212,
	"./ar-tn": 213,
	"./ar-tn.js": 213,
	"./ar.js": 207,
	"./az": 214,
	"./az.js": 214,
	"./be": 215,
	"./be.js": 215,
	"./bg": 216,
	"./bg.js": 216,
	"./bm": 217,
	"./bm.js": 217,
	"./bn": 218,
	"./bn.js": 218,
	"./bo": 219,
	"./bo.js": 219,
	"./br": 220,
	"./br.js": 220,
	"./bs": 221,
	"./bs.js": 221,
	"./ca": 222,
	"./ca.js": 222,
	"./cs": 223,
	"./cs.js": 223,
	"./cv": 224,
	"./cv.js": 224,
	"./cy": 225,
	"./cy.js": 225,
	"./da": 226,
	"./da.js": 226,
	"./de": 227,
	"./de-at": 228,
	"./de-at.js": 228,
	"./de-ch": 229,
	"./de-ch.js": 229,
	"./de.js": 227,
	"./dv": 230,
	"./dv.js": 230,
	"./el": 231,
	"./el.js": 231,
	"./en-SG": 232,
	"./en-SG.js": 232,
	"./en-au": 233,
	"./en-au.js": 233,
	"./en-ca": 234,
	"./en-ca.js": 234,
	"./en-gb": 235,
	"./en-gb.js": 235,
	"./en-ie": 236,
	"./en-ie.js": 236,
	"./en-il": 237,
	"./en-il.js": 237,
	"./en-nz": 238,
	"./en-nz.js": 238,
	"./eo": 239,
	"./eo.js": 239,
	"./es": 240,
	"./es-do": 241,
	"./es-do.js": 241,
	"./es-us": 242,
	"./es-us.js": 242,
	"./es.js": 240,
	"./et": 243,
	"./et.js": 243,
	"./eu": 244,
	"./eu.js": 244,
	"./fa": 245,
	"./fa.js": 245,
	"./fi": 246,
	"./fi.js": 246,
	"./fo": 247,
	"./fo.js": 247,
	"./fr": 248,
	"./fr-ca": 249,
	"./fr-ca.js": 249,
	"./fr-ch": 250,
	"./fr-ch.js": 250,
	"./fr.js": 248,
	"./fy": 251,
	"./fy.js": 251,
	"./ga": 252,
	"./ga.js": 252,
	"./gd": 253,
	"./gd.js": 253,
	"./gl": 254,
	"./gl.js": 254,
	"./gom-latn": 255,
	"./gom-latn.js": 255,
	"./gu": 256,
	"./gu.js": 256,
	"./he": 257,
	"./he.js": 257,
	"./hi": 258,
	"./hi.js": 258,
	"./hr": 259,
	"./hr.js": 259,
	"./hu": 260,
	"./hu.js": 260,
	"./hy-am": 261,
	"./hy-am.js": 261,
	"./id": 262,
	"./id.js": 262,
	"./is": 263,
	"./is.js": 263,
	"./it": 264,
	"./it-ch": 265,
	"./it-ch.js": 265,
	"./it.js": 264,
	"./ja": 266,
	"./ja.js": 266,
	"./jv": 267,
	"./jv.js": 267,
	"./ka": 268,
	"./ka.js": 268,
	"./kk": 269,
	"./kk.js": 269,
	"./km": 270,
	"./km.js": 270,
	"./kn": 271,
	"./kn.js": 271,
	"./ko": 272,
	"./ko.js": 272,
	"./ku": 273,
	"./ku.js": 273,
	"./ky": 274,
	"./ky.js": 274,
	"./lb": 275,
	"./lb.js": 275,
	"./lo": 276,
	"./lo.js": 276,
	"./lt": 277,
	"./lt.js": 277,
	"./lv": 278,
	"./lv.js": 278,
	"./me": 279,
	"./me.js": 279,
	"./mi": 280,
	"./mi.js": 280,
	"./mk": 281,
	"./mk.js": 281,
	"./ml": 282,
	"./ml.js": 282,
	"./mn": 283,
	"./mn.js": 283,
	"./mr": 284,
	"./mr.js": 284,
	"./ms": 285,
	"./ms-my": 286,
	"./ms-my.js": 286,
	"./ms.js": 285,
	"./mt": 287,
	"./mt.js": 287,
	"./my": 288,
	"./my.js": 288,
	"./nb": 289,
	"./nb.js": 289,
	"./ne": 290,
	"./ne.js": 290,
	"./nl": 291,
	"./nl-be": 292,
	"./nl-be.js": 292,
	"./nl.js": 291,
	"./nn": 293,
	"./nn.js": 293,
	"./pa-in": 294,
	"./pa-in.js": 294,
	"./pl": 295,
	"./pl.js": 295,
	"./pt": 296,
	"./pt-br": 297,
	"./pt-br.js": 297,
	"./pt.js": 296,
	"./ro": 298,
	"./ro.js": 298,
	"./ru": 299,
	"./ru.js": 299,
	"./sd": 300,
	"./sd.js": 300,
	"./se": 301,
	"./se.js": 301,
	"./si": 302,
	"./si.js": 302,
	"./sk": 303,
	"./sk.js": 303,
	"./sl": 304,
	"./sl.js": 304,
	"./sq": 305,
	"./sq.js": 305,
	"./sr": 306,
	"./sr-cyrl": 307,
	"./sr-cyrl.js": 307,
	"./sr.js": 306,
	"./ss": 308,
	"./ss.js": 308,
	"./sv": 309,
	"./sv.js": 309,
	"./sw": 310,
	"./sw.js": 310,
	"./ta": 311,
	"./ta.js": 311,
	"./te": 312,
	"./te.js": 312,
	"./tet": 313,
	"./tet.js": 313,
	"./tg": 314,
	"./tg.js": 314,
	"./th": 315,
	"./th.js": 315,
	"./tl-ph": 316,
	"./tl-ph.js": 316,
	"./tlh": 317,
	"./tlh.js": 317,
	"./tr": 318,
	"./tr.js": 318,
	"./tzl": 319,
	"./tzl.js": 319,
	"./tzm": 320,
	"./tzm-latn": 321,
	"./tzm-latn.js": 321,
	"./tzm.js": 320,
	"./ug-cn": 322,
	"./ug-cn.js": 322,
	"./uk": 323,
	"./uk.js": 323,
	"./ur": 324,
	"./ur.js": 324,
	"./uz": 325,
	"./uz-latn": 326,
	"./uz-latn.js": 326,
	"./uz.js": 325,
	"./vi": 327,
	"./vi.js": 327,
	"./x-pseudo": 328,
	"./x-pseudo.js": 328,
	"./yo": 329,
	"./yo.js": 329,
	"./zh-cn": 330,
	"./zh-cn.js": 330,
	"./zh-hk": 331,
	"./zh-hk.js": 331,
	"./zh-tw": 332,
	"./zh-tw.js": 332
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 475;

/***/ }),

/***/ 481:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Post; });
var Post = /** @class */ (function () {
    function Post(postData) {
        this.id = null;
        this.pending = false;
        this.accounts = [];
        this.content = '';
        this.attachments = [];
        this.scheduledTimes = [];
        this.isInstagramSharing = false;
        this.data = postData;
        this.id = postData.id || '';
        if (typeof this.data !== 'undefined' && this.data.pending === true)
            this.pending = true;
        this.content = postData.content;
        this.prepareScheduledTimes();
        this.prepareAttachments();
        this.prepareAccounts();
    }
    Post.prototype.prepareScheduledTimes = function () {
        if (typeof this.data == 'undefined')
            return;
        if (typeof this.data.postTime == 'undefined')
            return;
        if (!Array.isArray(this.data.postTime)) {
            this.data.postTime = [this.data.postTime];
        }
        for (var _i = 0, _a = this.data.postTime; _i < _a.length; _i++) {
            var postTime = _a[_i];
            if (typeof postTime == 'object') {
                this.scheduledTimes.push(postTime.time);
            }
            else {
                this.scheduledTimes.push(postTime.replace(/[^0-9]+/g, '').slice(0, 10));
            }
        }
    };
    Post.prototype.prepareAccounts = function () {
        if (typeof this.data == 'undefined')
            return;
        if (typeof this.data.accounts == 'undefined')
            return;
        if (typeof this.data.accounts.account == 'undefined')
            return;
        if (typeof this.data.allAccounts == 'undefined')
            return;
        if (!Array.isArray(this.data.accounts.account)) {
            this.data.accounts.account = [this.data.accounts.account];
        }
        for (var i in this.data.accounts.account) {
            var currentAccount = this.data.accounts.account[i];
            var selectedProfile = { selected: true };
            selectedProfile.profile = this.getProfileByID(currentAccount.config.sampleId);
            this.accounts.push(selectedProfile);
        }
    };
    Post.prototype.getProfileByID = function (profileID) {
        var account;
        var profile;
        for (var index in this.data.allAccounts) {
            account = this.data.allAccounts[index];
            if (!account.profiles)
                continue;
            for (var i in account.profiles) {
                if (account.profiles[i].profile_id == profileID) {
                    profile = account.profiles[i];
                    break;
                }
            }
        }
        return profile;
    };
    Post.prototype.prepareAttachments = function () {
        if (typeof this.data == 'undefined')
            return;
        if (typeof this.data.postAttachment == 'undefined')
            return;
        if (!Array.isArray(this.data.postAttachment)) {
            this.data.postAttachment = [this.data.postAttachment];
        }
        for (var i in this.data.postAttachment) {
            var currentAttachment = this.data.postAttachment[i];
            //Ignore if specificAccounts contains Twitter or Pinterest
            if (currentAttachment.specificAccounts) {
                if (currentAttachment.specificAccounts === 'string'
                    && currentAttachment.specificAccounts.indexOf('Twitter') === -1
                    && currentAttachment.specificAccounts.indexOf('Pinterest') === -1) {
                    continue;
                }
            }
            //VideoMetadata
            if (currentAttachment.videoData != undefined && currentAttachment.videoData.videoMetaData != undefined) {
                currentAttachment.videoData.videoMetaData = JSON.parse(currentAttachment.videoData.videoMetaData);
            }
            //dimension parse
            if (currentAttachment.name != undefined) {
                var dimension = currentAttachment.name.match(/ecsize\_(.*)/g);
                if (dimension && dimension[0] != undefined) {
                    currentAttachment.dimension = {};
                    dimension = dimension[0].replace('ecsize_', '').split('_');
                    if (dimension[0] != undefined) {
                        currentAttachment.dimension.width = (!isNaN(parseInt(dimension[0]))) ? parseInt(dimension[0]) : "";
                    }
                    if (dimension[1] != undefined) {
                        currentAttachment.dimension.height = (!isNaN(parseInt(dimension[1]))) ? parseInt(dimension[1]) : "";
                    }
                    if (dimension[2] != undefined) {
                        currentAttachment.dimension.size = (!isNaN(parseInt(dimension[2]))) ? parseInt(dimension[2]) : "";
                    }
                }
            }
            var attachment = {
                originalData: currentAttachment,
                url: {
                    full: 'https://s3.amazonaws.com/dev-eclincher/' + currentAttachment.location,
                    thumbnail: 'https://s3.amazonaws.com/' + currentAttachment.imageThumbnail
                }
            };
            this.attachments.push(attachment);
        }
    };
    return Post;
}());

//# sourceMappingURL=post.js.map

/***/ }),

/***/ 484:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EcDatePipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_moment_timezone__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_moment_timezone__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


var EcDatePipe = /** @class */ (function () {
    function EcDatePipe() {
    }
    /**
     * Takes a value and makes it datestrng based on passing time-zone.
     */
    EcDatePipe.prototype.transform = function (value) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var format = Array.isArray(args) && args.length ? args[0] : 'h:mm a';
        var timezone = Array.isArray(args) && args.length ? args[1] : __WEBPACK_IMPORTED_MODULE_1_moment_timezone___default.a.tz.guess();
        if (isNaN(parseInt(value))) {
            value = __WEBPACK_IMPORTED_MODULE_1_moment_timezone___default.a.tz().valueOf();
        }
        return __WEBPACK_IMPORTED_MODULE_1_moment_timezone___default.a.tz(parseInt(value), timezone).format(format);
    };
    EcDatePipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["W" /* Pipe */])({
            name: 'ecDate',
        })
    ], EcDatePipe);
    return EcDatePipe;
}());

//# sourceMappingURL=ec-date.js.map

/***/ }),

/***/ 485:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TruncatePipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

var TruncatePipe = /** @class */ (function () {
    function TruncatePipe() {
    }
    TruncatePipe.prototype.transform = function (value, limit) {
        return value.length > limit ? value.substring(0, limit) + '...' : value;
    };
    TruncatePipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["W" /* Pipe */])({
            name: 'truncate',
        })
    ], TruncatePipe);
    return TruncatePipe;
}());

//# sourceMappingURL=truncate.js.map

/***/ }),

/***/ 487:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PinterestFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var PinterestFeed = /** @class */ (function (_super) {
    __extends(PinterestFeed, _super);
    function PinterestFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    PinterestFeed.prototype.getGroups = function () {
        var _this = this;
        if (this.id == 'pi_board') {
            return this.accountsServiceProvider.getAccountByID(this.profile.account_id).map(function (mappedAccount) {
                mappedAccount.profiles.forEach(function (profile) {
                    if (!profile.data.objectType || profile.data.objectType !== 'user') {
                        _this.groups.push({
                            id: profile.original_config.userId,
                            name: profile.display.profile_name + '(' + profile.display.profile_type + ')'
                        });
                    }
                });
                //set defaultGroupID
                _this.defaultGroupID = _this.profile.original_config.defaultGroupId;
                return _this.groups;
            });
        }
    };
    /**
     * It returns feed data
     */
    PinterestFeed.prototype.getData = function () {
        // let httpHeaders = { 'Content-Type': 'application/json' };
        // httpHeaders['skipLoader'] = 'true';
        var _this = this;
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["d" /* HttpHeaders */]().set('Content-Type', 'application/json')
        };
        //set apiPath
        var apiPath = "/feed/pinterest";
        var parameters = [];
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("action", "getPinterestFeed");
        // parameters.push({
        //     key: 'fields',
        //     value: 'id,link,url,board,created_at,note,counts,media,attribution,image,metadata'     
        // });
        // parameters.push({
        //     key: 'limit',
        //     value: '20'     
        // });
        if (this.isGroupFeed()) {
            parameters.push({
                key: 'object_id',
                value: this.group.id
            });
            httpParams = httpParams.append('stream', 'pi_board_pins');
        }
        else {
            httpParams = httpParams.append('stream', this.id);
        }
        if (this.nextToken !== false) {
            parameters.push({
                key: 'bookmark',
                value: this.nextToken
            });
        }
        for (var i in parameters) {
            httpParams = httpParams.append('parameters[' + i + '][key]', parameters[i].key);
            httpParams = httpParams.append('parameters[' + i + '][value]', parameters[i].value);
        }
        return this
            .http
            .get(apiPath, {
            headers: new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["d" /* HttpHeaders */]().set('Content-Type', 'application/json'),
            params: httpParams
        })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    PinterestFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        console.log('feedResponse', feedResponse);
        if (feedResponse.data
            && feedResponse.data.data
            && Array.isArray(feedResponse.data.data)
            && feedResponse.data.data.length) {
            //prepare feed item
            for (var i in feedResponse.data.data) {
                if (feedResponse.data.data[i].type !== 'story')
                    items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this.formatPinterestItem(feedResponse.data.data[i]), this));
            }
        }
        if (feedResponse.data
            && feedResponse.data.page
            && feedResponse.data.page.cursor) {
            nextToken = feedResponse.data.page.cursor;
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    return PinterestFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=pinterest-feed.js.map

/***/ }),

/***/ 488:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return BloggerFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var BloggerFeed = /** @class */ (function (_super) {
    __extends(BloggerFeed, _super);
    function BloggerFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    BloggerFeed.prototype.getGroups = function () {
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of({});
    };
    /**
     * It returns feed data
     */
    BloggerFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/blogger";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", this.profile.account_id)
            .set("profileID", this.profile.profile_id)
            .set("action", "getBloggerPosts");
        if (this.nextToken !== false) {
            httpParams = httpParams.set('next', this.nextToken);
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    BloggerFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        console.log('feedResponse', feedResponse);
        if (feedResponse.data
            && Array.isArray(feedResponse.data)
            && feedResponse.data.length) {
            //prepare feed item
            for (var i in feedResponse.data) {
                items.push(new __WEBPACK_IMPORTED_MODULE_7__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this.formatBloggerItem(feedResponse.data[i]), this));
            }
        }
        if (feedResponse.next)
            nextToken = feedResponse.next;
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    return BloggerFeed;
}(__WEBPACK_IMPORTED_MODULE_6__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=blogger-feed.js.map

/***/ }),

/***/ 489:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InboxFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_jquery__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_timeline_feed_item__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__classes_feed_items_collapsible_feed_Item__ = __webpack_require__(339);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__classes_feed_items_instagram_feed_item__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__classes_feed_items_linkedin_feed_item__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__classes_feed_items_twitter_collapsible_feed_item__ = __webpack_require__(343);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs






//CLASSES






// import { UserSettingsProvider } from '../../user-settings/user-settings';
var InboxFeed = /** @class */ (function (_super) {
    __extends(InboxFeed, _super);
    function InboxFeed(http, stream, profile, group, options, _ionicStorage) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, http, stream, profile, group, options) || this;
        _this._ionicStorage = _ionicStorage;
        _this.twDMConevrsations = {};
        _this._keyForRolesInStorage = "inbox_roles";
        _this.loadSavedRoles();
        return _this;
    }
    /*
    *   it returns groups or like-pages list
    */
    InboxFeed.prototype.getGroups = function () {
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of(this.groups);
    };
    /**
     * It returns feed data
     */
    InboxFeed.prototype.getData = function () {
        var _this = this;
        var savedFilters = this.options.inboxFilters;
        //set apiPath
        var apiPath = "/feed/userEvents";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("action", "getUserEvents")
            .set("maxEvents", '20')
            .set("startTime", '0')
            .set("endTime", '0')
            .set("request_action", "");
        if (this.nextToken !== false) {
            httpParams = httpParams.set('endTime', this.nextToken);
        }
        if (this.options && this.options.inboxSearch) {
            httpParams = httpParams.set("searchText", this.options.inboxSearch);
        }
        if (savedFilters) {
            // FILTERS set any profile filters that may have been set
            if (savedFilters.profileIds.length > 0) {
                for (var _i = 0, _a = savedFilters.profileIds; _i < _a.length; _i++) {
                    var profileId = _a[_i];
                    httpParams = httpParams.append("profileIds[]", profileId);
                }
            }
            ;
            // set any event type filters that may have been set
            if (savedFilters.types.length > 0) {
                for (var _b = 0, _c = savedFilters.types; _b < _c.length; _b++) {
                    var type = _c[_b];
                    httpParams = httpParams.append("types[]", type);
                }
            }
            ;
            // set any tag filters that may have been set
            if (savedFilters.tags.length > 0) {
                for (var _d = 0, _e = savedFilters.tags; _d < _e.length; _d++) {
                    var tag = _e[_d];
                    httpParams = httpParams.append("tags[]", tag);
                }
            }
            ;
        }
        if ((this.options.roles && (this.options.roles.length > 0))) {
            for (var _f = 0, _g = this.options.roles; _f < _g.length; _f++) {
                var role = _g[_f];
                if (role.userName != 'all_roles' && role.enabled)
                    httpParams = httpParams.append("roles[]", role.userName);
            }
        }
        var userSettings = this.accountsServiceProvider.getUserSettings();
        if (userSettings && userSettings.alwaysHideCompletedEvents && userSettings.alwaysHideCompletedEvents == 'true') {
            httpParams = httpParams.set("only_completed", 'false');
        }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (response) {
            return _this.prepareFeedItems(response);
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    InboxFeed.prototype.prepareFeedItems = function (response) {
        var feedResponse = response;
        var nextToken = false;
        var items = [];
        if (feedResponse.returnCode === 'SUCCESS'
            && feedResponse.data
            && feedResponse.data.events
            && Array.isArray(feedResponse.data.events)
            && feedResponse.data.events.length) {
            nextToken = feedResponse.data.startTime;
            if (this.nextToken == nextToken || feedResponse.data.startTime === '9223372036854776000')
                nextToken = false;
            var data = feedResponse.data.events;
            this.processTWDirectMessage(data);
            for (var i in data) {
                var item = this.processItem(data[i]);
                if (item !== false) {
                    items.push(item);
                }
            }
        }
        this.nextToken = nextToken;
        this.items.push.apply(this.items, items);
        return items;
    };
    /**
     * processItem
     */
    InboxFeed.prototype.processItem = function (item) {
        // return false;
        var new_feed_item;
        var maxEventTime = new Date().getTime();
        var item_profile = this.accountsServiceProvider.getProfileByID(item.sampleId);
        if (item_profile == undefined) {
            return false;
        }
        this.profile = item_profile;
        this.account = this.accountsServiceProvider.getAccountDataByID(this.profile.account_id);
        var streamEntry = item.streamEntry, parent = item;
        //if(['TWReply','TWRetweet','TWRetweetWithComments','FBAdsComments','YTComments'].indexOf(parent.eventType) !== -1 ) continue;
        if (parent.eventType == 'GPComments')
            streamEntry = JSON.parse(item.streamEntry[0]);
        if (parent.eventType === 'YTComments')
            streamEntry = JSON.parse(item.streamEntry);
        if (Number(parent.date) > maxEventTime)
            maxEventTime = Number(parent.date);
        streamEntry.eventNetwork = item_profile.display.network.backend_network_name.toLowerCase();
        streamEntry.eventType = parent.eventType;
        streamEntry.eventTime = parent.date;
        streamEntry.ecCompleted = parent.ecCompleted;
        streamEntry.ecDeleted = parent.ecDeleted;
        streamEntry.ecRead = parent.ecRead;
        streamEntry.ecFollow = parent.ecFollow;
        streamEntry.ecRetweet = parent.ecRetweet;
        streamEntry.ecFavorite = parent.ecFavorite;
        streamEntry.ecDM = parent.ecDM;
        streamEntry.ecReply = parent.ecReply;
        var byTimeProps = ['ecCompleted', 'ecReply', 'ecPrivateReply', 'ecRetweet', 'ecLike', 'ecComment'];
        var roles = JSON.parse(JSON.stringify(this.roles));
        var roles_map = Object.create(null);
        for (var index = 0; index < roles.length; index++) {
            var role = roles[index];
            roles_map[role.userName] = role.displayName;
        }
        byTimeProps.forEach(function (prop) {
            var propBy = prop + 'By', userBy = parent[propBy];
            if (userBy && roles_map[userBy]) {
                var propTime = prop + 'Time';
                streamEntry[propBy] = roles_map[userBy];
                streamEntry[propTime] = parent[propTime];
            }
        });
        streamEntry.ecLike = parent.ecLike;
        streamEntry.ecComment = parent.ecComment;
        if (parent.ecNewCommentsCounter)
            streamEntry.ecNewCommentsCounter = parent.ecNewCommentsCounter;
        if (parent.ecZendeskTicket)
            streamEntry.ecZendeskTicket = parent.ecZendeskTicket;
        if (parent.ecHidden)
            streamEntry.ecHidden = parent.ecHidden;
        if (parent.ecPrivateReply)
            streamEntry.ecPrivateReply = parent.ecPrivateReply;
        streamEntry.eventUserName = parent.userName;
        streamEntry.tags = parent.tags;
        streamEntry.roles = [];
        streamEntry.hasRoles = false;
        if (typeof parent.assignedUsers === 'string') {
            var assignedUsers = JSON.parse(parent.assignedUsers);
            for (var index = 0; index < roles.length; index++) {
                var role = roles[index];
                if (assignedUsers.indexOf(role.userName) !== -1) {
                    role.enabled = true;
                    streamEntry.hasRoles = true;
                }
                streamEntry.roles.push(role);
            }
        }
        var this_datum;
        if (['FBComments', 'FBShares', 'FBOthers', 'FBLikes', 'FBWallPosts', 'FBReviews', 'FBAdsComments', 'FBMentions'].indexOf(parent.eventType) !== -1) {
            if (['FBWallPosts', 'FBMentions'].indexOf(parent.eventType) !== -1) {
                if (parent.ecLike) {
                    streamEntry.user_likes = parent.ecLike;
                }
                else {
                    streamEntry.ecLike = streamEntry.user_likes;
                }
                if (parent.eventType === 'FBWallPosts' && typeof streamEntry.id === 'string' && streamEntry.id.indexOf('notif_') === 0
                    && typeof streamEntry.link === 'string' && streamEntry.link.indexOf('/posts/') !== -1) {
                    var m = /\d*\/posts\/\d*/gm.exec(streamEntry.link);
                    if (m != null)
                        streamEntry.id = m[0].replace('/posts/', '_');
                }
            }
            else if (parent.eventType === 'FBReviews') {
                if (__WEBPACK_IMPORTED_MODULE_6_jquery__["isEmptyObject"](streamEntry.message)) {
                    streamEntry.message = '';
                }
                if (typeof streamEntry.objectId === 'string') {
                    streamEntry.eventTitle = 'Review Comment';
                    streamEntry.updateTime = streamEntry.createdTime;
                    streamEntry.profilePic = streamEntry.fromPicture;
                    if (streamEntry.messageId) {
                        streamEntry.link = 'https://www.facebook.com/' + streamEntry.messageId;
                        streamEntry.permalink = 'https://www.facebook.com/' + streamEntry.messageId;
                    }
                }
                else {
                    streamEntry.eventTitle = 'Review';
                }
            }
            else if (parent.eventType === 'FBAdsComments') {
                streamEntry.updateTime = streamEntry.createdTime;
                streamEntry.profilePic = streamEntry.fromPicture;
                if (streamEntry.messageId)
                    streamEntry.link = 'https://www.facebook.com/' + streamEntry.messageId;
            }
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, streamEntry, this);
        }
        else if (parent.eventType == 'FBDirectMessage' || parent.eventType == 'INMessages') {
            if (streamEntry.participants)
                new_feed_item = new __WEBPACK_IMPORTED_MODULE_9__classes_feed_items_collapsible_feed_Item__["a" /* CollapsibleFeedItem */](this.http, streamEntry, this);
            else
                new_feed_item = false;
        }
        else if (parent.eventType == 'TWMentions') {
            this_datum = this.format_tw_entry(streamEntry);
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_12__classes_feed_items_twitter_collapsible_feed_item__["a" /* TwitterCollapsibleFeedItem */](this.http, [this_datum], this);
        }
        else if (parent.eventType == 'TWDirectMessage') {
            var userSettings = this.accountsServiceProvider.getUserSettings();
            if (userSettings.isManagedUser == 'true' && !this.userSettingsProvider.getManagedUserPrivateView(item_profile))
                return false;
            var user_name = item_profile.display.profile_name.trim(), companion;
            var conversation;
            if (!streamEntry.conversation) {
                if (streamEntry.sender != undefined && streamEntry.recipient != undefined) {
                    if (streamEntry.sender.screen_name.toLowerCase() == user_name)
                        companion = streamEntry.recipient.screen_name.toLowerCase();
                    else
                        companion = streamEntry.sender.screen_name.toLowerCase();
                    var thread = this.twDMConevrsations[user_name][companion];
                    conversation = [streamEntry];
                    thread.forEach(function (item) {
                        var itemTime = new Date(item.created_at).getTime(), entryTime = new Date(streamEntry.created_at).getTime();
                        if (itemTime < entryTime)
                            conversation.push(item);
                    });
                    new_feed_item = new __WEBPACK_IMPORTED_MODULE_12__classes_feed_items_twitter_collapsible_feed_item__["a" /* TwitterCollapsibleFeedItem */](this.http, conversation, this);
                }
            }
            else {
                if (!__WEBPACK_IMPORTED_MODULE_6_jquery__["isEmptyObject"](streamEntry.conversation.streamEntry)) {
                    var first_item = streamEntry.conversation.streamEntry;
                    if (Array.isArray(streamEntry.conversation.streamEntry))
                        first_item = streamEntry.conversation.streamEntry[0];
                    Object.keys(first_item).forEach(function (key) {
                        streamEntry[key] = first_item[key];
                    });
                    conversation = [streamEntry];
                    for (var j = 0, ll = streamEntry.conversation.streamEntry.length; j < ll; j++) {
                        if (streamEntry.conversation.streamEntry[j].id_str !== streamEntry.id_str)
                            conversation.push(streamEntry.conversation.streamEntry[j]);
                    }
                    new_feed_item = new __WEBPACK_IMPORTED_MODULE_12__classes_feed_items_twitter_collapsible_feed_item__["a" /* TwitterCollapsibleFeedItem */](this.http, conversation, this);
                }
            }
        }
        else if (parent.eventType === 'LNLikesComments' || parent.eventType === 'LNCompanyUpdates') {
            if (streamEntry.updateContent && streamEntry.comments && streamEntry.comments.values) {
                if (streamEntry.comments.values.length)
                    last_comment = streamEntry.comments.values[0];
                else
                    last_comment = streamEntry.comments.values;
                streamEntry.updateContent.person = last_comment.creator;
                streamEntry.commentCreationTimestamp = last_comment.creationTimestamp;
                if (last_comment.id)
                    streamEntry.id = last_comment.id;
            }
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_11__classes_feed_items_linkedin_feed_item__["a" /* LinkedinFeedItem */](this.http, streamEntry, this);
        }
        else if (parent.eventType == 'TWFollowers' || parent.eventType === 'TWRetweets' || parent.eventType === 'TWRetweetsWithComments') {
            this_datum = this.format_tw_entry(streamEntry);
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this_datum, this);
        }
        else if (['GMBReviews', 'GMBQuestions'].indexOf(parent.eventType) !== -1) {
            this_datum = this.formatGMBItem(streamEntry);
            if (parent.eventType === 'GMBQuestions') {
                this_datum.eventTitle = 'Q&A';
                if (streamEntry.eventQuestion) {
                    this_datum.eventQuestion = streamEntry.eventQuestion;
                    this_datum.eventQuestion.rootEvent = {
                        ecReply: streamEntry.ecReply,
                        ecReplyBy: streamEntry.ecReplyBy,
                        ecReplyTime: streamEntry.ecReplyTime,
                        eventTime: streamEntry.eventTime,
                        eventUserName: streamEntry.eventUserName
                    };
                    this_datum.message = 'A: ' + this_datum.message;
                }
                else
                    this_datum.message = 'Q: ' + this_datum.message;
                ;
            }
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this_datum, this);
        }
        else if (parent.eventType === 'YelpReviews') {
            if (this.profile && typeof this.profile.original_config.pageCategory === 'string')
                streamEntry.link = this.profile.original_config.pageCategory;
            streamEntry.updateTime = streamEntry.eventTime / 1000;
            streamEntry.profilePic = this.profile.display.profile_picture_url;
            streamEntry.fromName = this.profile.display.profile_name;
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, streamEntry, this);
        }
        else if (parent.eventType == 'GPComments') {
            var orig_date = streamEntry.updateTime;
            this_datum = this.formatGPItem(streamEntry);
            if (this_datum.comments && this_datum.comments.comment) {
                if (!Array.isArray(this_datum.comments.comment))
                    this_datum.comments.comment = [this_datum.comments.comment];
                if (this_datum.comments.comment.length > 0) {
                    var this_comment = this_datum.comments.comment[0];
                    this_datum.fromName = this_comment.fromName;
                    this_datum.fromId = this_comment.fromId;
                    this_datum.updateTime = new Date(this_comment.createdTime).getTime().toString().slice(0, 10);
                    this_datum.profileLink = this_comment.fromProfileLink;
                    this_datum.profilePic = this_comment.fromPicture;
                    this_datum.createdTime = orig_date;
                    // this_datum.message = this_comment.message;
                }
            }
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, this_datum, this);
        }
        else if (parent.eventType === 'INComments') {
            if (streamEntry.comments && streamEntry.comments.comment) {
                if (!Array.isArray(streamEntry.comments.comment))
                    streamEntry.comments.comment = [streamEntry.comments.comment];
                var comments = streamEntry.comments.comment;
                if (comments.length > 0) {
                    var last_comment = comments[comments.length - 1];
                    streamEntry.user = last_comment.from;
                    streamEntry.my_post_time = streamEntry.created_time;
                    if (!streamEntry.caption)
                        streamEntry.caption = { text: '' };
                    streamEntry.my_post_text = streamEntry.caption.text;
                    streamEntry.created_time = last_comment.created_time;
                    streamEntry.caption.text = last_comment.text;
                    streamEntry.caption.id = last_comment.id;
                }
            }
            else // igb
             {
                streamEntry.business = true;
                streamEntry.id = streamEntry.objectFromId;
                streamEntry.user = {
                    id: streamEntry.fromId,
                    username: streamEntry.fromName
                };
                streamEntry.my_post_time = new Date(streamEntry.objectFromName).getTime() / 1000;
                streamEntry.caption = { text: streamEntry.message, id: streamEntry.messageId };
                streamEntry.my_post_text = streamEntry.objectMessage;
                if (typeof streamEntry.objectLink === 'string' && streamEntry.link == null)
                    streamEntry.link = streamEntry.objectLink;
                streamEntry.created_time = new Date(streamEntry.date).getTime() / 1000;
                if (streamEntry.media) {
                    if (streamEntry.media.type)
                        streamEntry.type = streamEntry.media.type.toLowerCase();
                    if (streamEntry.media.src) {
                        streamEntry.images = {
                            standard_resolution: {
                                url: streamEntry.media.src
                            },
                            thumbnail: {
                                url: streamEntry.media.src
                            }
                        };
                        if (streamEntry.type === 'video' && streamEntry.media.video && streamEntry.media.video.display_url) {
                            streamEntry.videos = {
                                standard_resolution: {
                                    url: streamEntry.media.video.display_url
                                },
                                low_resolution: {
                                    url: streamEntry.media.video.display_url
                                }
                            };
                        }
                    }
                }
            }
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_10__classes_feed_items_instagram_feed_item__["a" /* InstagramFeedItem */](this.http, streamEntry, this);
        }
        else if (parent.eventType === 'INMentions') {
            var source = streamEntry.source;
            streamEntry.business = true;
            streamEntry.user = {
                id: streamEntry.fromId,
                username: streamEntry.fromName
            };
            streamEntry.link = streamEntry.permalink;
            if (source === 'mentioned_comment')
                streamEntry.caption = { text: streamEntry.message };
            else
                streamEntry.caption = { text: streamEntry.mediaDescription };
            streamEntry.created_time = new Date(streamEntry.updateTime.replace(/([+\-]\d\d)(\d\d)$/, "$1:$2")).getTime() / 1000;
            if (streamEntry.media) {
                if (streamEntry.media.type)
                    streamEntry.type = streamEntry.media.type.toLowerCase();
                if (streamEntry.media.src) {
                    streamEntry.images = {
                        standard_resolution: { url: streamEntry.media.src },
                        thumbnail: { url: streamEntry.media.src }
                    };
                }
                else {
                    streamEntry.images = {
                        standard_resolution: { url: '' },
                        thumbnail: { url: '' }
                    };
                }
                if (streamEntry.type === 'video' && streamEntry.media.video && streamEntry.media.video.display_url) {
                    streamEntry.videos = {
                        standard_resolution: {
                            url: streamEntry.media.video.display_url
                        },
                        low_resolution: {
                            url: streamEntry.media.video.display_url
                        }
                    };
                }
            }
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_10__classes_feed_items_instagram_feed_item__["a" /* InstagramFeedItem */](this.http, streamEntry, this);
        }
        else if (parent.eventType === 'YTComments') {
            var media = streamEntry.media;
            if (media.type === 'video') {
                media.video = {
                    display_url: 'http://www.youtube.com/embed/' + media.id + '',
                    source_url: 'http://www.youtube.com/embed/' + media.id + ''
                };
            }
            streamEntry.updateTime = new Date(streamEntry.updateTime).getTime().toString().slice(0, 10);
            new_feed_item = new __WEBPACK_IMPORTED_MODULE_8__classes_feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](this.http, streamEntry, this);
        }
        else
            new_feed_item = false;
        //Feed notes
        var feed_notes = (parent.comments) ? JSON.parse(parent.comments) : [];
        if (new_feed_item && new_feed_item.data && feed_notes && feed_notes.length > 0) {
            var notes = {};
            notes = this.feedNotesProvider.formatNotes(feed_notes);
            if (new_feed_item.data[0]) {
                new_feed_item.data[0].notes = {};
                new_feed_item.data[0].notes.rawNotes = feed_notes;
                new_feed_item.data[0].notes.eventNotes = notes.eventNotes;
                new_feed_item.data[0].notes.lastNote = notes.lastNote;
            }
            else {
                new_feed_item.data.notes = {};
                new_feed_item.data.notes.rawNotes = feed_notes;
                new_feed_item.data.notes.eventNotes = notes.eventNotes;
                new_feed_item.data.notes.lastNote = notes.lastNote;
            }
        }
        return new_feed_item;
    };
    InboxFeed.prototype.processTWDirectMessage = function (data) {
        if (data === void 0) { data = []; }
        this.twDMConevrsations = {};
        for (var i = 0, l = data.length; i < l; i++) {
            var parent_1 = data[i], streamEntry = void 0;
            if (parent_1.eventType == 'TWDirectMessage') {
                var item_profile = this.accountsServiceProvider.getProfileByID(parent_1.sampleId);
                if (item_profile == undefined)
                    continue;
                var user_name = item_profile.display.profile_name.trim(), companion = void 0;
                if (this.twDMConevrsations[user_name] == undefined)
                    this.twDMConevrsations[user_name] = {};
                streamEntry = parent_1.streamEntry;
                if (!streamEntry.conversation) {
                    if (streamEntry.sender != undefined && streamEntry.recipient != undefined) {
                        if (streamEntry.sender.screen_name.toLowerCase() == user_name)
                            companion = streamEntry.recipient.screen_name.toLowerCase();
                        else
                            companion = streamEntry.sender.screen_name.toLowerCase();
                        if (this.twDMConevrsations[user_name][companion] == undefined)
                            this.twDMConevrsations[user_name][companion] = [];
                        this.twDMConevrsations[user_name][companion].push(streamEntry);
                    }
                }
            }
        }
    };
    /**
       * get saved roles for inbox feeds
       */
    InboxFeed.prototype.loadSavedRoles = function () {
        var _this = this;
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].fromPromise(this._ionicStorage.get(this._keyForRolesInStorage).then(function (savedRoles) {
            if (savedRoles) {
                savedRoles.shift();
                _this.roles = savedRoles;
            }
            return savedRoles;
        }, function () {
            return null;
        }));
    };
    ;
    return InboxFeed;
}(__WEBPACK_IMPORTED_MODULE_7__classes_feed__["a" /* Feed */]));

//# sourceMappingURL=inbox-feed.js.map

/***/ }),

/***/ 490:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return YelpFeed; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__feed__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__feed_items_timeline_feed_item__ = __webpack_require__(31);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

//rxjs





//CLASSES


var YelpFeed = /** @class */ (function (_super) {
    __extends(YelpFeed, _super);
    function YelpFeed(http, stream, profile, group, options) {
        if (options === void 0) { options = {}; }
        return _super.call(this, http, stream, profile, group, options) || this;
    }
    /*
    *   it returns groups or like-pages list
    */
    YelpFeed.prototype.getGroups = function () {
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].of(this.groups);
    };
    /**
     * It returns feed data
     */
    YelpFeed.prototype.getData = function () {
        var _this = this;
        //set apiPath
        var apiPath = "/feed/yelpReviews/";
        //prepare httpParams
        var httpParams = new __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["e" /* HttpParams */]()
            .set("businessId", this.profile.original_config.userId)
            .set("action", 'getYelpReviews');
        // if( this.nextToken === false ) 
        // {
        //     return Observable.of([]);
        // }
        //return Observable.of(httpParams);
        return this
            .http
            .get(apiPath, { params: httpParams })
            .map(function (feedResponse) {
            var items = [];
            console.log('feedResponse', feedResponse);
            if (feedResponse.returnCode === 'SUCCESS'
                && feedResponse.data
                && feedResponse.data.reviews
                && Array.isArray(feedResponse.data.reviews)) {
                //prepare feed item
                for (var i in feedResponse.data.reviews) {
                    var this_datum = _this.formatItem(feedResponse.data.reviews[i]);
                    items.push(new __WEBPACK_IMPORTED_MODULE_7__feed_items_timeline_feed_item__["a" /* TimelineFeedItem */](_this.http, this_datum, _this));
                }
            }
            _this.nextToken = false;
            return items;
        })
            .catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    YelpFeed.prototype.formatItem = function (data) {
        var this_datum = {
            fromId: null,
            fromName: (data.user && typeof data.user.name === 'string' ? data.user.name : 'unbeknown'),
            profilePic: (data.user && typeof data.user.image_url === 'string' ? data.user.image_url : this.defaultProfileImage),
            profileLink: null,
            updateTime: (new Date(data.time_created).getTime() / 1000),
            message: data.text,
            link: data.url,
            rating: data.rating,
            postID: data.id,
            raw_data: data
        };
        return this_datum;
    };
    return YelpFeed;
}(__WEBPACK_IMPORTED_MODULE_6__feed__["a" /* Feed */]));

//# sourceMappingURL=yelp-feed.js.map

/***/ }),

/***/ 509:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MyApp; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(23);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_status_bar__ = __webpack_require__(393);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_splash_screen__ = __webpack_require__(392);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_device__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ionic_native_app_version__ = __webpack_require__(394);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_network__ = __webpack_require__(148);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_native_fcm__ = __webpack_require__(395);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ionic_native_web_intent__ = __webpack_require__(150);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__ionic_native_autostart__ = __webpack_require__(396);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_in_app_browser__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ionic_native_screen_orientation__ = __webpack_require__(397);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_badge_count_badge_count__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_auth_auth__ = __webpack_require__(80);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_user_data_user_data__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_accounts_brands_service_accounts_brands_service__ = __webpack_require__(141);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__providers_accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__providers_window_service_window_service__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__providers_in_app_in_app__ = __webpack_require__(145);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__providers_fcm_fcm__ = __webpack_require__(142);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__providers_publishing_service_publishing_service__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__providers_feeds_feeds_service__ = __webpack_require__(138);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__providers_crisp_chat_crisp_chat__ = __webpack_require__(398);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__providers_publishing_service_publishing_map_post__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__providers_reputations_reputations__ = __webpack_require__(140);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__providers_facebook_facebook__ = __webpack_require__(112);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};



//IONIC-NATIVE











//PROVIDERS
















var MyApp = /** @class */ (function () {
    function MyApp(
    // public events : Events,
    _menuController, _loadingController, _toastController, _alertController, _formBuilder, _platform, _ionicStorage, _splashScreen, _statusBar, _badgeCountProvider, _appSettingsProvider, _userSettingsProvider, _accountsBrandsServiceProvider, _authProvider, _userDataProvider, _accountsServiceProvider, _device, _appVersion, _fcm, _network, _webIntent, _window, _autostart, _inAppProvider, _fcmProvider, _publishingProvider, _inAppBrowser, _feedsServiceProvider, _screenOrientation, _events, crispChatProvider, publishingMapPostProvider, reputationsService, facebookProvider) {
        var _this = this;
        this._menuController = _menuController;
        this._loadingController = _loadingController;
        this._toastController = _toastController;
        this._alertController = _alertController;
        this._formBuilder = _formBuilder;
        this._platform = _platform;
        this._ionicStorage = _ionicStorage;
        this._splashScreen = _splashScreen;
        this._statusBar = _statusBar;
        this._badgeCountProvider = _badgeCountProvider;
        this._appSettingsProvider = _appSettingsProvider;
        this._userSettingsProvider = _userSettingsProvider;
        this._accountsBrandsServiceProvider = _accountsBrandsServiceProvider;
        this._authProvider = _authProvider;
        this._userDataProvider = _userDataProvider;
        this._accountsServiceProvider = _accountsServiceProvider;
        this._device = _device;
        this._appVersion = _appVersion;
        this._fcm = _fcm;
        this._network = _network;
        this._webIntent = _webIntent;
        this._window = _window;
        this._autostart = _autostart;
        this._inAppProvider = _inAppProvider;
        this._fcmProvider = _fcmProvider;
        this._publishingProvider = _publishingProvider;
        this._inAppBrowser = _inAppBrowser;
        this._feedsServiceProvider = _feedsServiceProvider;
        this._screenOrientation = _screenOrientation;
        this._events = _events;
        this.crispChatProvider = crispChatProvider;
        this.publishingMapPostProvider = publishingMapPostProvider;
        this.reputationsService = reputationsService;
        this.facebookProvider = facebookProvider;
        this._newAgency = false;
        this._isShowEdit = false;
        // Show list of brands as sub Menu
        this.showSubmenu = false;
        this.addBrandName = false;
        this.editBrandName = false;
        this.isShowBrands = false;
        this.brandListWithOutSelectedOne = [];
        this.crispScriptLoaded = false;
        this.hasPermissionToOpenAccountsManagePage = true;
        this.versionClickCount = 0;
        // List of pages that can be navigated to from the left menu the left menu only
        // works after login the login page disables the left menu
        this._mainTabs = [
            {
                title: 'Publishing',
                name: 'MainTabsPage',
                component: "MainTabsPage",
                tabComponent: "PublishingPage",
                index: 0,
                icon: 'ios-create-outline',
            },
            {
                title: 'Inbox',
                name: 'MainTabsPage',
                component: "MainTabsPage",
                tabComponent: "InboxPage",
                index: 1,
                icon: 'ios-filing-outline',
            },
            {
                title: 'Social Profiles Live Feeds',
                name: 'MainTabsPage',
                component: "MainTabsPage",
                tabComponent: "AccountsSocialProfilesPage",
                index: 2,
                icon: 'ios-menu-outline',
            },
            // {
            //   title: 'Reputation Management',
            //   name: 'ReputationsPage',
            //   component: "ReputationsPage",
            //   // tabComponent: "ReputationsPage",
            //   // index: 4,
            //   icon: 'ios-chatbubbles-outline', // 'filing'
            // },
            {
                title: 'Instagram Notifications',
                name: 'MainTabsPage',
                component: "MainTabsPage",
                tabComponent: "InstagramNotificationsPage",
                index: 4,
                icon: 'ios-notifications-outline',
            },
            {
                title: 'TikTok Notifications',
                name: 'MainTabsPage',
                component: "MainTabsPage",
                tabComponent: "TiktokNotificationsPage",
                index: 5,
                icon: 'ios-notifications-outline',
            },
            {
                title: 'Add & Manage Accounts',
                name: 'AccountsManagePage',
                component: "AccountsManagePage",
                icon: 'ios-contacts-outline',
            }
        ];
        //General Menu Pages
        this._loggedInPages = [
            {
                title: 'Chat With Us',
                name: 'intercom',
                component: "intercom",
                icon: 'ios-chatboxes-outline',
            }
        ];
        // Agency Menu Pages
        this._agencyPages = [
            {
                title: 'Brands',
                name: 'DisplayBrand',
                component: "",
                icon: 'ios-albums-outline',
            }
        ];
        this._isAgency = false;
        this._userSettings = { displayName: null };
        this._versionNumber = '';
        this._emailAddressToDisplay = '';
        this.isReputationEnabled = true;
        this.initError = function (err) { console.log('openwith init failed: ', err); };
        this.openwithHandler = function (intent) { return __awaiter(_this, void 0, void 0, function () {
            var item;
            return __generator(this, function (_a) {
                if (intent.items.length > 0) {
                    item = intent.items[0];
                    this._publishingProvider.IosShareSource.next(item);
                    if (this.nav.getActiveChildNavs() && this.nav.getActiveChildNavs()[0]) {
                        this.nav.getActiveChildNavs()[0].select(0);
                    }
                }
                return [2 /*return*/];
            });
        }); };
        this._expandBrands = function (page) {
            if (page.name === 'DisplayBrand') {
                _this.showSubmenu = !_this.showSubmenu;
                _this._updateBrandListWithOutSelectedOne();
            }
        };
        this._updateBrandListWithOutSelectedOne = function () {
            _this.brandListWithOutSelectedOne = [];
            console.log('KKK::_updateBrandListWithOutSelectedOne', _this._userSettings.agencyConfiguration.client, _this._selectedClient);
            _this._userSettings.agencyConfiguration.client.find(function (client) {
                // if (client.clientId != this._selectedClient.clientId) {
                _this.brandListWithOutSelectedOne.push(client);
                // }
            });
        };
        this._selectClient = function (newSelectedclient) {
            /*     let loading = this
                  ._loadingController
                  .create({});
                loading.present();
             */ var selectClientRequestParams = {
                agencyId: _this._userSettings["agencyConfiguration"]["agencyId"],
                clientId: newSelectedclient.clientId
            };
            _this
                ._accountsBrandsServiceProvider
                .selectBrand(selectClientRequestParams)
                .subscribe(function (newSelectedClient) {
                //create user_data header object for getAccounts Request
                _this
                    ._accountsServiceProvider
                    .getAccountsAndSettings(false)
                    .subscribe(function (clientMappedAccounts) {
                    _this._selectedClient = newSelectedclient;
                    _this
                        ._badgeCountProvider.getInboxUncompletedBadgeCount().subscribe(function (badgeCount) {
                        _this._badgeCountProvider.badgeCountSource.next(badgeCount);
                    }, function (userSettingsError) {
                        //Show alert
                    });
                    _this._agencyPages = [
                        {
                            title: "Brands: " + _this._selectedClient.clientName,
                            name: 'DisplayBrand',
                            component: "",
                            icon: 'ios-albums-outline',
                        }
                    ];
                    //New brand - refresh the PublishingPage
                    var params = {
                        tabIndex: 0
                    };
                    _this
                        ._menuController
                        .close().then(function () {
                        _this.nav.setRoot("MainTabsPage", params);
                    });
                    _this._publishingProvider.setCalendarDate(null);
                    _this.AMAPermissionCheck(newSelectedclient);
                    _this._feedsServiceProvider.inboxReloadSource.next({ type: 'clear-filter-and-reload' });
                    _this.reputationsService.repReloadSource.next(true);
                    setTimeout(function () {
                        _this
                            ._ionicStorage
                            .ready()
                            .then(function () {
                            _this._ionicStorage
                                .get('pushDataAgency')
                                .then(function (pushData) {
                                if (pushData) {
                                    _this._ionicStorage.remove('pushDataAgency');
                                    _this._fcmProvider.setFcmDataSource(pushData);
                                }
                            });
                            _this._ionicStorage
                                .get('newInboxMessageAgency')
                                .then(function (inboxData) {
                                if (inboxData) {
                                    _this._ionicStorage.remove('newInboxMessageAgency');
                                    _this._fcmProvider.setInboxDataSource(inboxData);
                                }
                            });
                        });
                    }, 1000);
                    // reset calendar data
                    _this._publishingProvider.resetPostsByDateCache();
                    _this
                        ._toastController
                        .create({ message: "Brand " + _this._selectedClient.clientName + " selected", duration: 2000, position: "top" }).present();
                }, function (getClientAccountsSettingsError) { });
            }, function (selectClientError) { });
        }; //end _selectClient
        this._deleteBrand = function (brandToDelete) {
            if (_this._userSettings["agencyConfiguration"]["client"].length === 1) {
                var lastBrandAlert = _this._alertController.create({ message: "Must have at least 1 brand for Agency", buttons: ["ok"] });
                lastBrandAlert.present();
                return;
            }
            ;
            /*     let loading = this
                  ._loadingController
                  .create();
                loading.present();
             */ var deleteBrandBody = {
                data: {
                    type: 'deleteAgencyClient',
                    agencyConfiguration: {
                        agencyName: _this._userSettings["agencyConfiguration"]["agencyName"],
                        agencyId: _this._userSettings["agencyConfiguration"]["agencyId"],
                        client: {
                            clientName: brandToDelete.clientName,
                            clientId: brandToDelete.clientId
                        }
                    }
                }
            };
            var alertConfirm = _this
                ._alertController
                .create({ title: 'Delete Brand', message: 'Delete brand ' + brandToDelete.clientName + ' and all its related data.' });
            alertConfirm.addButton({
                text: 'Ok',
                handler: function (data) {
                    _this
                        ._accountsBrandsServiceProvider
                        .deleteBrand(deleteBrandBody)
                        .subscribe(function (deleteSuccess) {
                        //update local
                        // this._userSettings.agencyConfiguration = deleteSuccess["agencyConfiguration"];
                        _this._userSettings["agencyConfiguration"] = deleteSuccess;
                        //Check if the deleted brand was selected - set the index 0 as the new selected
                        if (brandToDelete.selected) {
                            var selectBrandRequestParams = {
                                agencyId: _this._userSettings.agencyConfiguration.agencyId,
                                clientId: deleteSuccess["client"][0].clientId
                            };
                            _this._accountsBrandsServiceProvider.selectBrand(selectBrandRequestParams).subscribe(function (newSelectedBrand) {
                                _this._userSettings.agencyConfiguration = newSelectedBrand;
                                _this._userSettings["agencyConfiguration"]["client"].sort(function (a, b) {
                                    var nameA = a.clientName;
                                    var nameB = b.clientName;
                                    if (typeof nameA == "string" && typeof nameB == "string") {
                                        return nameA.toLowerCase() > nameB.toLowerCase();
                                    }
                                    return false;
                                });
                                //update the agency brand count.
                                _this._userSettings["agencyNumberOfActiveClients"] = _this._userSettings["agencyNumberOfActiveClients"] - 1;
                                setTimeout(function () {
                                    _this._updateBrandListWithOutSelectedOne();
                                }, 500);
                                // Update userSettingsSource BS
                                _this._userSettingsProvider.userSettingsSource.next(_this._userSettings);
                                //reset form
                                _this
                                    ._addBrandForm
                                    .reset();
                                //dismiss loading
                                // loading.dismiss()
                                // present toast
                                var toast = _this
                                    ._toastController
                                    .create({
                                    message: "Brand " + brandToDelete.clientName + " Deleted",
                                    duration: 3000,
                                    position: "top"
                                });
                                toast.present();
                            });
                        }
                        else {
                            //update the agency brand count.
                            _this._userSettings["agencyNumberOfActiveClients"] = _this._userSettings["agencyNumberOfActiveClients"] - 1;
                            //Update BehaviorSubject
                            _this
                                ._userSettingsProvider
                                .userSettingsSource
                                .next(_this._userSettings);
                            setTimeout(function () {
                                _this._updateBrandListWithOutSelectedOne();
                            }, 500);
                            // loading.dismiss()
                            var toast = _this
                                ._toastController
                                .create({
                                message: "Brand " + brandToDelete.clientName + " Deleted",
                                duration: 3000,
                                position: "top"
                            });
                            toast.present();
                        }
                    }, function (deleteError) {
                        // loading.dismiss()
                        var alert = _this._alertController.create({
                            message: deleteError,
                            buttons: ["ok"]
                        });
                        alert.present();
                    }); //end subscribe
                }
            });
            alertConfirm.addButton('Cancel');
            alertConfirm.present();
        }; // end deleteBrand
        //addBrandForm
        this._addBrandForm = this
            ._formBuilder
            .group({
            'brandName': [
                null, __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].compose([
                    __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].required, __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].minLength(1),
                    __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].maxLength(32)
                ])
            ]
        });
        //editBrandForm
        this._editBrandForm = this
            ._formBuilder
            .group({
            'editBrandName': [
                null, __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].compose([
                    __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].required, __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].minLength(1),
                    __WEBPACK_IMPORTED_MODULE_1__angular_forms__["g" /* Validators */].maxLength(32)
                ])
            ]
        });
        // if user enters from login/signup/app in background
        this.
            _authProvider.authStatus$
            .subscribe(function (authStatus) {
            //reset accounts BS since we use the timestamp check
            // this._accountsServiceProvider.accountsSource.next(null);
            //Reset variables
            _this._isAgency = false;
            _this._agencyUser = null;
            //Can't reset settings BehaviorSubject here
            //start checking 
            if (true === authStatus) {
                //settings behaviorSubject should be populated
                var userSettings = _this._userSettingsProvider.userSettingsSource.value;
                _this._userSettings = userSettings;
                _this.loadChat();
                if (userSettings.licenseType === 'Agency' || userSettings.licenseType === 'Profiles') {
                    _this._isAgency = true;
                    if (userSettings.isAdminUser == 'true')
                        _this._agencyUser = "agency_admin";
                    if (userSettings.isManagedUser == 'true')
                        _this._agencyUser = "agency_user";
                    _this
                        ._menuController
                        .enable(true);
                    if (!userSettings["agencyConfiguration"] || !userSettings["agencyConfiguration"]["client"]) {
                        //no brand created  - send to create a brand. on Agency signup settings does not contain agencyConfiguration
                        if (!_this._userSettings["agencyConfiguration"]["client"]) {
                            _this._newAgency = true;
                            _this._displayAlerCreateFirstBrand();
                        }
                        for (var i = 0; i < _this._agencyPages.length; i++) {
                            if (_this._agencyPages[i].name === 'DisplayBrand') {
                                // this._agencyPages[i].title = `Brands : ${this._userSettings["agencyConfiguration"]["client"].clientName}`;
                            }
                        }
                        /*               this._agencyPages = [
                                        {//Display only brands names not goto AccountsBrandsManagePage
                                          title: `Brands : ${this._userSettings["agencyConfiguration"]["client"].clientName}`, //sent in constructor
                                          name: 'DisplayBrand', //AccountsBrandsManagePage
                                          component: "", //Display only brands names not goto AccountsBrandsManagePage
                                          icon: 'ios-albums-outline', // 'folder'
                                        }
                                      ] */
                    }
                    else {
                        //Prepare a list for Menu display
                        if (_this._userSettings["agencyConfiguration"]["client"]) {
                            if (!Array.isArray(_this._userSettings["agencyConfiguration"]["client"])) {
                                _this._userSettings["agencyConfiguration"]["client"] = [_this._userSettings["agencyConfiguration"]["client"]];
                            }
                        }
                        if (!Array.isArray(_this._userSettings["agencyConfiguration"]["client"])) {
                            for (var i = 0; i < _this._agencyPages.length; i++) {
                                if (_this._agencyPages[i].name === 'DisplayBrand') {
                                    _this._agencyPages[i].title = "Brands: " + _this._userSettings["agencyConfiguration"]["client"].clientName;
                                }
                            }
                            /*                 this._agencyPages = [
                                              {//Display only brands names not goto AccountsBrandsManagePage
                                                title: `Brands : ${this._userSettings["agencyConfiguration"]["client"].clientName}`, //sent in constructor
                                                name: 'DisplayBrand', //AccountsBrandsManagePage
                                                component: "", //Display only brands names not goto AccountsBrandsManagePage
                                                icon: 'ios-albums-outline', // 'folder'
                                              }
                                            ]; */
                        }
                        else {
                            // this._userSettings["agencyConfiguration"]["client"].sort(function (a, b) {
                            //   let nameA = a.clientName;
                            //   let nameB = b.clientName;
                            //   if (typeof nameA == "string" && typeof nameB == "string") {
                            //     return nameA.toLowerCase() > nameB.toLowerCase();
                            //   }
                            //   return false;
                            // });
                            _this._userSettings["agencyConfiguration"]["client"].find(function (client) {
                                if (client.selected) {
                                    _this._selectedClient = client;
                                    for (var i = 0; i < _this._agencyPages.length; i++) {
                                        if (_this._agencyPages[i].name === 'DisplayBrand') {
                                            _this._agencyPages[i].title = "Brands: " + _this._selectedClient.clientName;
                                        }
                                    }
                                    /*                     this._agencyPages = [
                                                          {//Display only brands names not goto AccountsBrandsManagePage
                                                            title: `Brands : ${this._selectedClient.clientName}`, //sent in constructor
                                                            name: 'DisplayBrand', //AccountsBrandsManagePage
                                                            component: "", //Display only brands names not goto AccountsBrandsManagePage
                                                            icon: 'ios-albums-outline', // 'folder'
                                                          }
                                                        ]; */
                                    _this.AMAPermissionCheck(client);
                                }
                            });
                            // this.nav.setRoot("AccountsManagePage");
                        }
                    }
                    //displaying email address on account
                    if (_this._userSettings['accountCode'] === _this._userSettings["agencyConfiguration"].agencyName) {
                        _this._emailAddressToDisplay = _this._userSettings.email;
                    }
                    else {
                        // this._emailAddressToDisplay = this._userSettings["agencyConfiguration"].agencyName;
                        _this._emailAddressToDisplay = _this._userSettings.email;
                    }
                    _this.nav.setRoot("MainTabsPage");
                }
                else {
                    //Not agency
                    _this._isAgency = false;
                    _this._emailAddressToDisplay = _this._userSettings.email;
                    _this
                        ._menuController
                        .enable(true);
                    _this.nav.setRoot("MainTabsPage");
                    // this.nav.setRoot("AccountsManagePage");
                }
                ;
                _this._handleFCM();
                _this.loadChat(); //load crisp chat
                // //initiate intercom
                // setTimeout(() => {
                //   this._handleIntercom();
                // }, 2000);
                //initialize inAppPurhase
                _this._inAppProvider.registerProducts();
                //check if reputation is enabled for this account
                if (userSettings.paymentStatus &&
                    (userSettings.paymentStatus.toLowerCase() == 'trial' || userSettings.keywordsMonitoringAddon === 'none'
                        || userSettings.keywordsMonitoringAddon === 'custom-keywords-monitoring')) {
                    _this.isReputationEnabled = false;
                }
            }
            else {
            } /* else{
              Can't setRoot to login here - shows login screen on refersh
              has to be called on logout
              this.nav.setRoot("AuthLoginPage");
            } */
        }, function (userDataError) {
            _this.nav.setRoot("AuthLoginPage");
        });
        //if user enters from app in backgroyund and logged in
        this
            ._ionicStorage
            .ready()
            .then(function () {
            _this
                ._authProvider
                .validateUser()
                .then(function (settingsRequest) {
                if (null === settingsRequest) {
                    // no user_data in storage - send to login page
                    _this.nav.setRoot("AuthLoginPage");
                    // this.nav.setRoot("AuthPricingPage");
                    _this._menuController
                        .enable(false);
                }
                else {
                    //if user_data exists in storage, Http Observable returned. We must subscribe in order to trigger the request and get seetings and updated ec_data. on Response, userData BehaviorSubject will get updated with next which will trigger the subscribe above, similarly to login/signup
                    settingsRequest.subscribe(function (response) {
                        if (!response || !response.accountsTypeOrder) {
                            // do logout process
                            _this._publishingProvider.instagramPendingCountSource.next(0);
                            _this._publishingProvider.tikTokPendingCountSource.next(0);
                            _this.nav.setRoot("AuthLoginPage").then(function () {
                                _this._accountsServiceProvider.accountsSource.next(null);
                            });
                        }
                    }); //end subscribe
                } //end else
            }, function (currentUserError) {
                _this.nav.setRoot("AuthLoginPage");
                // subscription.unsubscribe(); Display AlertController and call platform.ready()
            });
        }); //end ionicStorage.ready
        //call platform-ready
        this._platformReady();
        // //Subscribe on pause i.e. background
        // this._platform.pause.subscribe(() => {
        // });
        this._platform.resume.subscribe(function () {
            var userSettings = _this._userSettingsProvider.userSettingsSource.value;
            if (userSettings) {
                // this._publishingProvider.getInstagramPendingNotifications(true).subscribe(instagramPostsByDate => {
                // });
                // this._publishingProvider.getTikTokPendingNotifications(true).subscribe(tikTokPostsByDate => {
                // });
            }
            //Shared Image/Link from Other apps like Gallerry
            if (_this._device.platform.toLowerCase() === 'android') {
                _this._webIntent.getIntent().then(function (data) {
                    if (data.clipItems) {
                        var ek = btoa(JSON.stringify(data));
                        if (_this._publishingProvider.sharedIntentData[ek] === undefined) {
                            _this._publishingProvider.sharedIntentData[ek] = 1;
                            if (userSettings) {
                                if (_this.nav.getActive().id != "MainTabsPage") {
                                }
                                else {
                                    if (_this.nav.getActiveChildNavs().length) {
                                        _this
                                            .nav
                                            .getActiveChildNavs()[0]
                                            .select(0);
                                    }
                                }
                                _this._fcmProvider.setSharedDataSource(JSON.stringify(data));
                            }
                            else {
                                _this._ionicStorage.set(_this._appSettingsProvider.sharedDataKey, JSON.stringify(data));
                            }
                        }
                    }
                });
            }
            _this.versionClickCount = 0;
        });
        this
            ._publishingProvider
            .brandSwitch$
            .subscribe(function (brand) {
            if (brand) {
                _this._selectClient(brand);
            }
        });
        this
            ._publishingProvider
            .tabSwitch$
            .subscribe(function (tabName) {
            if (tabName) {
                _this._openPage(_this._mainTabs[2]);
            }
        });
        this._events.subscribe('app:logout', function () {
            console.log('app:logout');
            _this.logout();
        });
        if (this._userSettings) {
            if (this._userSettings.licenseType != "basic") {
                this._mainTabs.splice(3, 0, {
                    title: 'Approval List',
                    name: 'MainTabsPage',
                    component: "MainTabsPage",
                    tabComponent: "ApprovalListPage",
                    index: 3,
                    icon: 'ios-checkmark-circle-outline',
                });
            }
        }
        //Add manage account comes last of the "Main" list
        // this._mainTabs.push({
        //   title: 'Add & Manage Accounts',
        //   name: 'AccountsManagePage',
        //   component: "AccountsManagePage",
        //   icon: 'ios-albums-outline', // 'albums'
        // })
    }
    ; //end constructor
    MyApp.prototype.registerInAppProduct = function () {
        console.log('registerInAppProduct');
        this._inAppProvider.registerProducts();
    };
    MyApp.prototype.ngOnInit = function () {
        var _this = this;
        this.nav.viewWillEnter.subscribe(function (view) {
            var pageName = (view.instance && view.instance.constructor && view.instance.constructor.name) ? view.instance.constructor.name : '';
            // Subscription Expiry Check
            var result = _this.validateExpiry();
            if (result.isExpired) {
                if (pageName === 'SettingsPage' || pageName === 'AuthLoginPage') {
                }
                else {
                    var alertConfirm = _this._alertController.create({ message: result.message, enableBackdropDismiss: false });
                    alertConfirm.addButton({
                        text: 'Ok',
                        handler: function (data) {
                            _this.pushMainSettingsPage();
                            // this.logout();  
                        }
                    });
                    alertConfirm.present();
                }
            }
            // internal Notification
            _this
                ._userSettingsProvider
                .getInternalNotifications()
                .subscribe(function (notification) {
                if (notification) {
                    switch (parseInt(notification.type)) {
                        case 1:
                            break;
                        case 2:
                            break;
                        case 3:
                            if (_this._versionNumber && _this._versionNumber !== '') {
                                var appVersion = _this._versionNumber.split('.').join(''), latestVersion = notification.version.split('.').join('');
                                if (notification.content != '' && Number(latestVersion) > Number(appVersion)) {
                                    var alertConfirm = _this._alertController.create({ message: notification.content });
                                    alertConfirm.addButton({
                                        text: 'Ok',
                                        handler: function (data) {
                                            _this._inAppBrowser.create(_this._appSettingsProvider.getStoreUrl(), '_system', 'location=yes');
                                        }
                                    });
                                    alertConfirm.present();
                                }
                            }
                            break;
                        default:
                            break;
                    }
                }
            });
        });
        // this
        //   ._userSettingsProvider
        //   .userSettings$
        //   .subscribe((userSettings: any) => {
        //     if (userSettings && userSettings.agencyConfiguration && userSettings.agencyConfiguration.client) {
        //       this._updateBrandListWithOutSelectedOne();
        //     }
        //   });
    };
    MyApp.prototype.AMAPermissionCheck = function (client) {
        if (client.permission === 'edit' || client.permission === 'view') {
            this.hasPermissionToOpenAccountsManagePage = false;
            // for (let i = 0; i < this._mainTabs.length; i++) {
            //   if (this._mainTabs[i].title === 'Add & Manage Accounts') {
            //     this._mainTabs[i].name = this._mainTabs[i].component = '';
            //     this.nav.setRoot("PublishingPage");
            //   }
            // }
        }
        else {
            this.hasPermissionToOpenAccountsManagePage = true;
            for (var i = 0; i < this._mainTabs.length; i++) {
                if (this._mainTabs[i].title === 'Add & Manage Accounts') {
                    this._mainTabs[i].name = this._mainTabs[i].component = 'AccountsManagePage';
                }
            }
        }
    };
    ; //end AMAPermissionCheck
    MyApp.prototype._displayAlerCreateFirstBrand = function () {
        var _this = this;
        var addFirstBrandAlert = this._alertController.create({
            enableBackdropDismiss: false,
            title: "Create your first brand",
            message: "Only letters or numbers, max 32 charachters",
            inputs: [{
                    name: "brandNname",
                    placeholder: "e.g. 'My Client'",
                    type: "text"
                }],
            buttons: [{
                    text: "ADD",
                    handler: function (data) {
                        if (data.brandNname.trim().length > 1 && data.brandNname.trim().length < 33) {
                            _this._addBrand(data.brandNname);
                        }
                        else {
                            _this._displayAlertEmptyBrandName();
                        } //end else
                    }
                }]
        }); //end alert.create
        addFirstBrandAlert.present();
    };
    ; //end _displayAlerCreateFirstBrand
    MyApp.prototype._displayAlertEmptyBrandName = function () {
        var _this = this;
        var missingFirstBrandAlert = this._alertController.create({
            enableBackdropDismiss: false,
            title: "Must enter brand name",
            message: "Brand name cannot be empty, and cannot exceed 32 characters",
            buttons: [{
                    text: "OK",
                    handler: function () {
                        _this._displayAlerCreateFirstBrand();
                    }
                }]
        }); //end missingFirstBrandAlert.create
        missingFirstBrandAlert.present();
    };
    ; // end _displayAlertEmptyBrandName
    MyApp.prototype.refreshPage = function (newSelectedclient) {
        var _this = this;
        var selectClientRequestParams = {
            agencyId: this._userSettings["agencyConfiguration"]["agencyId"],
            clientId: newSelectedclient.clientId
        };
        this
            ._accountsBrandsServiceProvider
            .selectBrand(selectClientRequestParams)
            .subscribe(function (newSelectedClient) {
            _this._selectedClient = newSelectedclient;
            _this._agencyPages = [
                {
                    title: "Brands: " + _this._selectedClient.clientName,
                    name: 'DisplayBrand',
                    component: "",
                    icon: 'ios-albums-outline',
                }
            ];
        });
    };
    MyApp.prototype.refreshUserSettings = function (refresher) {
        this
            ._userSettingsProvider.getSettings().subscribe(function (userSettings) {
            refresher.complete();
        }, function (userSettingsError) {
            refresher.complete();
            //Show alert
        });
    };
    ;
    /* ================== PRIVATE METHODS ==================== */
    MyApp.prototype.validateExpiry = function () {
        var message = '';
        var isExpired = false;
        var userSettings = this._userSettingsProvider.userSettingsSource.value;
        console.log('validateExpiry userSettings', userSettings);
        if (userSettings && userSettings.paymentStatus == 'trial' && parseInt(userSettings.daysLeft) < 1) {
            message = 'Your trial has expired. Please upgrade in the Account Settings.';
            isExpired = true;
        }
        else if (userSettings && userSettings.paymentConfig != undefined
            && typeof userSettings.paymentConfig.paymentState === 'string'
            && userSettings.paymentConfig.paymentState === 'expired') {
            message = 'Your subscription has expired. Please upgrade in the Account Settings.';
            isExpired = true;
        } /* else if(this._inAppProvider.isSubscriptionExpired()) {
          isExpired = true;
          message = 'Your subscription has expired. To update your plan,';
        } */
        // message += ' please login to eClincher.com from a web browser (desktop/laptop). If you have any questions, please contact our support.';
        return { isExpired: isExpired, message: message };
    };
    MyApp.prototype._platformReady = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                // Call any initial plugins when ready
                this
                    ._platform
                    .ready()
                    .then(function () {
                    // Okay, so the _platform is ready and our plugins are available. Here you can
                    // do any higher level native things you might need.
                    _this
                        ._statusBar
                        .overlaysWebView(false);
                    if (_this._platform.is('android')) {
                        _this
                            ._statusBar
                            .styleBlackOpaque();
                    }
                    else {
                        _this
                            ._statusBar
                            .styleDefault();
                    }
                    _this
                        ._splashScreen
                        .hide();
                    //handling FCM
                    _this._handleFCM();
                    if (_this._platform.is('cordova')) {
                        _this._appVersion.getVersionNumber().then(function (versionNumber) {
                            _this._versionNumber = versionNumber;
                        });
                        // watch network for a disconnect
                        var disconnectSubscription = _this._network.onDisconnect().subscribe(function () {
                            var toast = _this
                                ._toastController
                                .create({ message: 'network was disconnected.', duration: 10000, position: 'top' });
                            toast.present();
                        });
                        //Shared Image/Link from Other apps like Gallerry
                        if (_this._device.platform.toLowerCase() === 'android') {
                            console.log("sharedDataKey2", _this._userSettingsProvider.getUserSettings());
                            _this._webIntent.getIntent().then(function (data) {
                                if (data.clipItems) {
                                    var ek = btoa(JSON.stringify(data));
                                    if (_this._publishingProvider.sharedIntentData[ek] === undefined) {
                                        _this._publishingProvider.sharedIntentData[ek] = 1;
                                        _this._ionicStorage.set(_this._appSettingsProvider.sharedDataKey, JSON.stringify(data));
                                    }
                                }
                            });
                        }
                        //Enable auto-start
                        _this._autostart.enable();
                    }
                    if (_this._device.platform
                        && _this._device.platform.toLowerCase() === 'android'
                        && _this._window.window.innerWidth >= 768) {
                        _this._screenOrientation.lock(_this._screenOrientation.ORIENTATIONS.LANDSCAPE);
                    }
                    if (_this._platform.is('ios') && _this._platform.is('cordova')) {
                        cordova.openwith.init(_this.initSuccess(), _this.initError);
                        cordova.openwith.addHandler(_this.openwithHandler);
                        //insta bug
                        cordova.plugins.instabug.activate({
                            ios: "f7be72fda7d2b048462aa50387f688d4"
                        }, "shake", {
                            commentRequired: true,
                            colorTheme: "dark",
                        }, function () {
                            console.log("Instabug initialized.");
                        }, function (error) {
                            console.log("Instabug could not be initialized - " + error);
                        });
                    }
                }); // end then
                return [2 /*return*/];
            });
        });
    }; // end platformReady
    // private iosmocking() {
    //   let item = { "base64": "", "utis": [], "text": "https://eclincher.com/", "type": "", "fileSize": "", "uri": "shareextension://index=0,name=,type=", "name": "" };
    //   let saveItem = JSON.stringify(item);
    //   console.log("openwithHandler 1", saveItem);
    //   this._publishingProvider.IosShareSource.next(item);
    //   // if (this.nav.getActiveChildNavs() && this.nav.getActiveChildNavs()[0]) {
    //   //   this.nav.getActiveChildNavs()[0].select(0);
    //   // }
    // }
    MyApp.prototype.initSuccess = function () { console.log('openwith init success!'); };
    MyApp.prototype._selectedBrand = function (client) {
        this.showSubmenu = !this.showSubmenu;
        //reset edit button
        this._isShowEdit = false;
        this._selectClient(client);
        // this._userSettingsProvider.userSettingsSource.next(this._userSettings);
    };
    MyApp.prototype._openPage = function (page) {
        if (page.component == 'intercom') {
            this._window.window.$crisp.push(["do", "chat:open"]);
            return;
        }
        var params = {};
        // the nav component was found using @ViewChild(Nav) setRoot on the nav to
        // remove previous pages and only have this page we wouldn't want the back
        // button to show in this scenario
        if (page.index > -1) {
            params = {
                tabIndex: page.index
            };
        }
        ;
        console.log("openPage", page);
        params["title"] = page.title;
        // If we are already on tabs just change the selected tab don't setRoot again,
        // this maintains the history stack of the tabs even if changing them from the
        // menu
        if (this.nav.getActiveChildNavs().length && page.index != undefined) {
            this
                .nav
                .getActiveChildNavs()[0]
                .select(page.index, params);
        }
        else if (this.nav.getViews() && this.nav.getViews().length > 0 && page.name === this.nav.getViews()[0].component.name) {
            // Prevent opening page if already in current view
            return;
        }
        else {
            this
                .nav
                .setRoot(page.name, params);
            /* Don't use catch - prevents errors from shiwing on page navigation
            .catch((err: any) => {
            });
            */
        }
    }; //end _openPage
    MyApp.prototype.loadCrispChat = function () {
        this._window.window.$crisp = [];
        this._window.window.CRISP_WEBSITE_ID = "32c44f1e-5ba5-4bed-9afa-b065c5a7a609";
        var d = document;
        var s = d.createElement("script");
        s.src = "https://client.crisp.chat/l.js";
        s.async = 1;
        d.getElementsByTagName("head")[0].appendChild(s);
    };
    MyApp.prototype.loadChat = function () {
        var _this = this;
        console.log('loadChat');
        // let userSettings = this._userSettingsProvider.getUserSettings();
        this.crispChatProvider.getIcHash().subscribe(function (res) {
            if (res && res.hash) {
                if (!_this.crispScriptLoaded) {
                    _this._window.window.CRISP_TOKEN_ID = res.hash;
                    _this.loadCrispChat();
                }
                _this.crispScriptLoaded = true;
                if (_this._userSettings) {
                    var nickname = _this._userSettingsProvider.getUserDisplayName(_this._userSettings);
                    console.log('this._userSettings.userDisplayName', nickname, _this._userSettings, typeof _this._userSettings.phoneNumber);
                    window['$crisp'].push(["set", "user:nickname", nickname]);
                    window['$crisp'].push(["set", "user:email", _this._userSettings.email]);
                    if (typeof _this._userSettings.phoneNumber != "object")
                        window['$crisp'].push(["set", "user:phone", _this._userSettings.phoneNumber]);
                    if (typeof _this._userSettings.company != "object")
                        window['$crisp'].push(["set", "user:company", _this._userSettings.company]);
                    if (typeof _this._userSettings.licenseType != "object")
                        window['$crisp'].push(["set", "session:data", ["plan", _this._userSettings.licenseType]]);
                    if (typeof _this._userSettings.paymentStatus != "object")
                        window['$crisp'].push(["set", "session:data", ["status", _this._userSettings.paymentStatus]]);
                    if (typeof _this._userSettings.userSource != "object")
                        window['$crisp'].push(["set", "session:data", ["source", _this._userSettings.userSource]]);
                    window['$crisp'].push(["set", "session:data", ["name", nickname]]);
                    if (typeof _this._userSettings.signupFirstName != "object")
                        window['$crisp'].push(["set", "session:data", ["first_name", _this._userSettings.signupFirstName]]);
                    if (typeof _this._userSettings.signupLastName != "object")
                        window['$crisp'].push(["set", "session:data", ["last_name", _this._userSettings.signupLastName]]);
                    if (typeof _this._userSettings.creationDate != "object")
                        window['$crisp'].push(["set", "session:data", ["created_at", _this._userSettings.creationDate]]);
                    if (_this._window.window.userCreated) {
                        delete _this._window.window.userCreated;
                        _this._window.window['$crisp'].push(["set", "session:event", [[["signup", {}, "blue"]]]]);
                    }
                    var numberofQueues = _this._userSettings.numberOfQueues;
                    var number_of_queues = "";
                    var plan = (_this._userSettings && _this._userSettings.licenseType) ? _this._userSettings.licenseType.toLowerCase() : '';
                    if (['agency', 'profiles', 'premier'].indexOf(plan) === -1) {
                        if (Array.isArray(numberofQueues)) {
                            number_of_queues = numberofQueues[0];
                        }
                        else {
                            number_of_queues = numberofQueues;
                        }
                    }
                    else {
                        number_of_queues = 'unlimited';
                    }
                    _this._window.window['$crisp'].push(["set", "session:data", ["number_of_queues", number_of_queues]]);
                }
                /*this.intercom.boot({
                    app_id: "i4dj7h7n",
                    email: userSettings.email, // Email address,
                    name: userSettings.userName, // Full name
                    fname: userSettings.signupFirstName, // first name
                    lname: userSettings.signupLastName, // last name
                    company: userSettings.company, // company
                    phone: userSettings.phoneNumber, // phone
                    Plan: userSettings.licenseType, // Custom: Plan type
                    Status: userSettings.paymentStatus,
                    Source: userSettings.userSource,
                    Created_at: userSettings.creationDate,
                    user_hash: res.hash,
                    numberOfQueues: 0,
                    numberOfOnQueues: 1
                });*/
            }
        });
    };
    //Can't use [navPush] in template
    MyApp.prototype.pushMainSettingsPage = function () {
        this
            .nav
            .push("SettingsPage");
    };
    MyApp.prototype.pushPostSettingsPage = function () {
        this
            .nav
            .push("PostSettingsPage");
    };
    MyApp.prototype.logout = function (changeEnv) {
        if (changeEnv === void 0) { changeEnv = false; }
        return __awaiter(this, void 0, void 0, function () {
            var logoutLoading;
            var _this = this;
            return __generator(this, function (_a) {
                logoutLoading = this
                    ._loadingController
                    .create({ content: "Goodbye ..." });
                logoutLoading.present();
                setTimeout(function () { return __awaiter(_this, void 0, void 0, function () {
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this
                                    ._authProvider
                                    .logout()
                                    .then(function () {
                                    _this
                                        ._menuController
                                        .enable(false);
                                    _this._publishingProvider.instagramPendingCountSource.next(0);
                                    _this._publishingProvider.tikTokPendingCountSource.next(0);
                                    _this._userSettingsProvider.userSettingsSource.next(null);
                                    /* this._rootPage = "AuthLoginPage";
                                    Can't use _rootPage and then reset accounts -
                                    causes async issues and breaks app when logging out from social account page
                                    */
                                    _this.nav.setRoot("AuthLoginPage").then(function () {
                                        _this._accountsServiceProvider.accountsSource.next(null);
                                    });
                                    if (changeEnv) {
                                        if (_this._appSettingsProvider.getApiUrl().indexOf('qa.app.eclincher') === -1) {
                                            _this._appSettingsProvider.changeEnvToQA();
                                        }
                                        else {
                                            _this._appSettingsProvider.changeEnvToProd();
                                        }
                                    }
                                })];
                            case 1:
                                _a.sent();
                                logoutLoading.dismiss();
                                return [2 /*return*/];
                        }
                    });
                }); }, 2000);
                return [2 /*return*/];
            });
        });
    };
    ; // end logout
    MyApp.prototype._isActive = function (page) {
        var childNav = this
            .nav
            .getActiveChildNavs()[0];
        // Tabs are a special case because they have their own navigation
        if (childNav) {
            if (childNav.getSelected() && childNav.getSelected().root === page.tabComponent) {
                return 'primary';
            }
            return;
        }
        if (this.nav.getActive() && this.nav.getActive().name === page.name) {
            return 'primary';
        }
        return;
    };
    ; // end _isActive
    MyApp.prototype._handleFCM = function () {
        var _this = this;
        if (!this._platform.is('cordova'))
            return;
        this._appVersion.getVersionNumber().then(function (versionNumber) {
            _this._versionNumber = versionNumber;
        });
        //get FCM Token and store it 
        this._fcm.getToken().then(function (token) {
            _this._fcmProvider.updateFCMToken(token);
        });
        //This will fire only when app reinstallation or upgrade
        this._fcm.onTokenRefresh().subscribe(function (token) {
            _this._fcmProvider.updateFCMToken(token);
        });
        //Recieve FCM Notification
        this._fcm.onNotification().subscribe(function (data) {
            if (data.wasTapped) {
            }
            else {
            }
            ;
            var userSettings = _this._userSettingsProvider.userSettingsSource.value;
            console.log("onNotification", userSettings);
            if (typeof data.type !== 'undefined' && data.type.toLowerCase() == 'newinboxmessage') {
                if (userSettings) {
                    _this._openPage(_this._mainTabs[1]);
                    setTimeout(function () {
                        data.isReload = true;
                        _this._fcmProvider.setInboxDataSource(JSON.stringify(data));
                    }, 1000);
                }
                else {
                    data.isReload = false;
                    _this._ionicStorage.set('newInboxMessage', JSON.stringify(data));
                }
            }
            else {
                //this.nav.setRoot('FcmTestingPage', {fcmData: data});
                if (userSettings) {
                    console.log("onNotification 1", data);
                    // if (this.nav.getViews()[0].component.name === 'MainTabsPage') {
                    //   this._ionicStorage.set('pushData', JSON.stringify(data));
                    //   this.nav.setRoot('MainTabsPage', {tabIndex:0})
                    // } else {
                    //   this._ionicStorage.set('pushData', JSON.stringify(data));
                    //   this.nav.setRoot('MainTabsPage', {tabIndex:0});
                    // }
                    // to open publishing editor page on post notification
                    // this.nav.setRoot('MainTabsPage', { tabIndex: 0 });
                    _this._openPage(_this._mainTabs[0]);
                    setTimeout(function () {
                        // this._ionicStorage.set('pushDataWithSettings', JSON.stringify(data));
                        _this._fcmProvider.setFcmDataSource(JSON.stringify(data));
                    }, 1000);
                    // this._fcmProvider.getPostByID(data.postId, data.postSource).then(postData => {
                    //   postData.isInstagramSharing = true;
                    //   postData.instagramRawData = data;
                    //   postData.scheduledTimes = [];           
                    //   this.nav.push('PublishingPage', { postData: postData });
                    // });
                }
                else {
                    _this._ionicStorage.set('pushData', JSON.stringify(data));
                }
            }
        });
    };
    // private _handleIntercom() {
    //   if (!this._platform.is('cordova')) return;
    //   //getSettings
    //   let userSettings: any = this._userSettingsProvider.userSettingsSource.value;
    //   if (userSettings === null) return;
    //   //register user with intercom
    //   let intercom_settings: any = {};
    //   intercom_settings.email = userSettings.email;
    //   intercom_settings.name = userSettings.email;
    //   //prepare userHash
    //   let hasmac = CryptoJS.HmacSHA256(userSettings.email, this._userDataProvider.intercomSecretKey);
    //   intercom_settings.user_hash = CryptoJS.enc.Hex.stringify(hasmac);
    //   this._intercom.registerIdentifiedUser(intercom_settings).then(result => {
    //   }, error => {
    //   });
    //   //Update user additional info
    //   let custom_attributes: any = {
    //     Status: userSettings.paymentStatus,
    //     Plan: userSettings.licenseType,
    //     Source: userSettings.userSource,//'Mobile'
    //     fname: userSettings.signupFirstName,
    //     lname: userSettings.signupLastName,
    //     company: userSettings.company,
    //     phone: userSettings.phoneNumber,
    //     Created_at: userSettings.creationDate
    //   };
    //   this._intercom.updateUser({ custom_attributes: custom_attributes }).then(result => {
    //   }, error => {
    //   });
    // }
    MyApp.prototype.getToken = function () {
        var _this = this;
        //this._userSettingsProvider.inboxNotificationSource.next(true);
        this._fcmProvider.getPostByID('cf593345-01bc-4c6c-8f2c-52a41d10f720', "scheduled").then(function (postData) {
            postData.isInstagramSharing = true;
            _this.nav.push('PublishingPage', { postData: postData });
        });
        //this._inAppProvider.purchase();
        /* this
          ._ionicStorage
          .get(this._appSettingsProvider.getFCMTokenKey()).then(token => {
          });
          let a: any = CryptoJS.HmacSHA256('larisa.litovchenko@eclincher.com', 'Gz3_ecPlUIY_cmKLmaDEBAizBCC3GjS8RCgKmjAz');
          let b: any = CryptoJS.enc.Hex.stringify(a);
       
          let intercom_settings: any = {};
          intercom_settings.email         = 'larisa.litovchenko@eclincher.com';
          intercom_settings.name         = 'larisa.litovchenko@eclincher.com';
          intercom_settings.user_hash = b;
          this._intercom.registerIdentifiedUser(intercom_settings).then(result => {
          }, error => {
          });
          
          //this.nav.setRoot('FcmTestingPage', {fcmData: null});
          //this._intercom.registerUnidentifiedUser({});
       
          setTimeout(() => {
            this._intercom.displayMessenger().then(success => {
            }, error => {
            });
          }, 20000); */
    };
    MyApp.prototype._showEditIcon = function (event) {
        this._isShowEdit = !this._isShowEdit;
        // this._userSettings["agencyConfiguration"] = this._userSettings["agencyConfiguration"];
    };
    MyApp.prototype._showAddBrand = function () {
        this.addBrandName = !this.addBrandName;
    };
    MyApp.prototype._editBrand = function (brandToEdit) {
        var _this = this;
        // delete attr selectedToEdit for previously selected brand
        for (var _i = 0, _a = this._userSettings.agencyConfiguration.client; _i < _a.length; _i++) {
            var client = _a[_i];
            if (client['selectedToEdit'] !== undefined) {
                this.editBrandName = false;
                delete client['selectedToEdit'];
            }
        }
        for (var _b = 0, _c = this._userSettings.agencyConfiguration.client; _b < _c.length; _b++) {
            var client = _c[_b];
            if (client.clientId === brandToEdit.clientId) {
                client['selectedToEdit'] = true;
                this.editBrandName = true;
                setTimeout(function () {
                    _this.myInput.setFocus();
                }, 150);
            }
        }
        this._userSettings["agencyConfiguration"] = this._userSettings["agencyConfiguration"];
    };
    MyApp.prototype._toggleHidden = function () {
        this.showSubmenu = !this.showSubmenu;
        this._updateBrandListWithOutSelectedOne();
    };
    MyApp.prototype._saveEdittedBrandName = function (brandNameToEdit) {
        var _this = this;
        this._userSettings.agencyConfiguration.client.find(function (client) {
            if (client.clientId === brandNameToEdit.clientId) {
                if (client.selectedToEdit) {
                    // client.clientName = this._editBrandForm.value.editBrandName;
                    var editBrandBody_1 = {
                        name: _this._editBrandForm.value.editBrandName,
                        agencyId: _this._userSettings["agencyConfiguration"]["agencyId"],
                        clientId: client.clientId,
                    };
                    _this
                        ._accountsBrandsServiceProvider
                        .editBrand(editBrandBody_1)
                        .subscribe(function (editBrandSuccess) {
                        // this._userSettings["agencyConfiguration"] = editBrandSuccess;
                        if (editBrandSuccess.returnCode === 'SUCCESS') {
                            if (_this._userSettings["agencyConfiguration"] && _this._userSettings["agencyConfiguration"]['client']) {
                                var client_1 = _this._userSettings["agencyConfiguration"]['client'];
                                for (var c = 0; c < client_1.length; c++) {
                                    if (editBrandSuccess.userName === client_1[c].clientId) {
                                        client_1[c].clientName = editBrandBody_1.name;
                                    }
                                }
                                _this._userSettings["agencyConfiguration"]['client'] = client_1;
                            }
                            if (_this._selectedClient.clientId === client.clientId) {
                                _this._agencyPages[0].title = "Brands:" + editBrandBody_1.name;
                                _this._selectedClient.clientName = editBrandBody_1.name;
                            }
                        }
                        //update BehaviorSubject
                        _this._userSettingsProvider.userSettingsSource.next(_this._userSettings);
                    }, function (editBrandError) {
                        // loading.dismiss()
                        var alert = _this
                            ._alertController
                            .create({ title: "Edit Brand Error", message: editBrandError, buttons: ['OK'] });
                        alert.present();
                    });
                }
            }
        });
        // this._editBrandForm.reset();
        this._cancelEdittedBrandName(brandNameToEdit);
    };
    MyApp.prototype._cancelEdittedBrandName = function (brandNameToUndo) {
        var _this = this;
        this._userSettings.agencyConfiguration.client.find(function (client) {
            if (client.clientId === brandNameToUndo.clientId) {
                if (client.selectedToEdit) {
                    _this._editBrandForm.reset();
                    delete client['selectedToEdit'];
                }
            }
        });
    };
    MyApp.prototype._addBrand = function (brandName) {
        var _this = this;
        /*     let loading = this
              ._loadingController
              .create();
            loading.present();
         */
        this.addBrandName = !this.addBrandName;
        var brandNameForBody;
        if (this._underBrandLimit()) {
            if (brandName) {
                //If brandName is passed from addFirstBrandAlert - first brand created
                brandNameForBody = brandName;
            }
            else {
                //Otherwise get from form
                brandNameForBody = this._addBrandForm.value.brandName;
            }
            var addBrandBody = {
                data: {
                    type: 'addAgencyClient',
                    agencyConfiguration: {
                        agencyName: this._userSettings["agencyConfiguration"]["agencyName"],
                        agencyId: this._userSettings["agencyConfiguration"]["agencyId"],
                        userName: this._userSettings["agencyConfiguration"]["userName"],
                        password: this._userSettings.password,
                        client: {
                            clientName: brandNameForBody
                        }
                    }
                }
            };
            this
                ._accountsBrandsServiceProvider
                .addBrand(addBrandBody)
                .subscribe(function (addBrandSuccess) {
                //If this is NOT the first brand created - don't set it as selected
                // if (addBrandSuccess["agencyConfiguration"]["client"].length !== 1) {
                //for testing - set all selected except if array length is 2
                if (addBrandSuccess["client"].length >= 2) {
                    //update _userSettings Locally
                    _this._userSettings["agencyConfiguration"] = addBrandSuccess;
                    //update the agency brand count.
                    _this._userSettings["agencyNumberOfActiveClients"] = parseInt(_this._userSettings["agencyNumberOfActiveClients"]) + 1;
                    //update BehaviorSubject
                    _this._userSettingsProvider.userSettingsSource.next(_this._userSettings);
                    //dismiss loading
                    // loading.dismiss()
                    // present toast
                    var toast = _this
                        ._toastController
                        .create({
                        message: "Brand " + brandNameForBody + " Added",
                        duration: 3000,
                        position: "top"
                    });
                    toast.present();
                    //reset form
                    _this
                        ._addBrandForm
                        .reset();
                    setTimeout(function () {
                        _this._updateBrandListWithOutSelectedOne();
                    }, 500);
                }
                else {
                    // set first brand created as selected
                    var selectBrandRequestParams_1 = {
                        agencyId: _this._userSettings["agencyConfiguration"]["agencyId"],
                        //for testing - set new client selected
                        clientId: addBrandSuccess["client"][addBrandSuccess["client"].findIndex(function (client) {
                            return client.clientName === brandNameForBody;
                        })]["clientId"]
                        // clientId: addBrandSuccess["client"][0].clientId
                    };
                    _this._accountsBrandsServiceProvider.selectBrand(selectBrandRequestParams_1).subscribe(function (newSelectedBrand) {
                        // this._userSettings.agencyConfiguration = newSelectedBrand["agencyConfiguration"];
                        _this._userSettings["agencyConfiguration"] = newSelectedBrand;
                        _this._userSettings["agencyConfiguration"]["client"].sort(function (a, b) {
                            var nameA = a.clientName;
                            var nameB = b.clientName;
                            if (typeof nameA == "string" && typeof nameB == "string") {
                                return nameA.toLowerCase() > nameB.toLowerCase();
                            }
                            return false;
                        });
                        _this._selectedClient = {
                            clientId: selectBrandRequestParams_1.clientId,
                            clientName: brandNameForBody,
                            selected: '1'
                        };
                        setTimeout(function () {
                            _this._updateBrandListWithOutSelectedOne();
                        }, 500);
                        //update the agency brand count.
                        _this._userSettings["agencyNumberOfActiveClients"] = parseInt(_this._userSettings["agencyNumberOfActiveClients"]) + 1;
                        // Update BS
                        _this._userSettingsProvider.userSettingsSource.next(_this._userSettings);
                        //dismiss loading
                        // loading.dismiss()
                        _this._newAgency = false;
                        // present toast
                        var toast = _this
                            ._toastController
                            .create({
                            message: "Brand " + brandNameForBody + " Added",
                            duration: 3000,
                            position: "top"
                        });
                        toast.present();
                        //reset form
                        _this
                            ._addBrandForm
                            .reset();
                    }, function (newSelectedBrandError) { console.error(newSelectedBrandError); });
                }
                ; //end else
            }, function (addBrandError) {
                // loading.dismiss()
                var alert = _this
                    ._alertController
                    .create({ title: "Add Brand Error", message: addBrandError, buttons: ['OK'] });
                alert.present();
            });
        }
        else {
            //Over brand limit - _underBrandLimit returned false
            var alert_1 = this
                ._alertController
                .create({ title: "Add Brand Error", message: "To add more brands, please log in to your eClincher account via non-mobile devices", buttons: ['OK'] });
            alert_1.present();
        }
        ;
    };
    ; // end addBrandName
    /*------------------ INTERNAL METHODS ----------------*/
    MyApp.prototype._underBrandLimit = function () {
        if (Number(this._userSettings["agencyNumberOfActiveClients"]) < Number(this._userSettings["userDefaultAgencyNumberOfClients"])) {
            return true;
        }
        else {
            return false;
        }
        ;
    };
    ; //end _underBrandLimit
    MyApp.prototype._popUpMessage = function (message) {
        var alert = this._alertController.create({
            title: message,
        });
        alert.addButton({
            text: 'Ok',
            handler: function (data) {
            }
        });
        alert.present();
    };
    ; //end _popUpMessage
    MyApp.prototype.versionClick = function () {
        this.versionClickCount++;
        if (this.versionClickCount === 10) {
            this.versionClickCount = 0;
            this.logout(true);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["_14" /* ViewChild */])(__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["o" /* Nav */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["o" /* Nav */])
    ], MyApp.prototype, "nav", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["_14" /* ViewChild */])("mainTab"),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["v" /* Tabs */]
        //Set focus on an input
        )
    ], MyApp.prototype, "mainTab", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["_14" /* ViewChild */])('input'),
        __metadata("design:type", Object)
    ], MyApp.prototype, "myInput", void 0);
    MyApp = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["n" /* Component */])({template:/*ion-inline-start:"E:\projects\IONIC-eClincher\src\app\app.html"*/'<ion-split-pane>\n\n	<!-- logged in menu -->\n\n	<ion-menu id="loggedInMenu" [content]="content">\n\n\n\n		<ion-header>\n\n			<ion-toolbar>\n\n				<ion-title >{{_emailAddressToDisplay}}</ion-title>\n\n			</ion-toolbar>\n\n		</ion-header>\n\n\n\n		<ion-content>\n\n\n\n			<ion-list *ngIf="_agencyUser === \'agency_admin\' || _agencyUser === \'agency_user\'">\n\n				<ion-list-header>\n\n					Agency Brands\n\n				</ion-list-header>\n\n				<span class="brandButton">\n\n					<button ion-item border-none *ngFor="let p of _agencyPages" (click)="_expandBrands(p)">\n\n						<ion-icon item-start [name]="p.icon"></ion-icon>\n\n						<p ion-text [color]="_isActive(p)">{{p.title}}</p>\n\n					</button>\n\n					<button ion-button icon-right clear (click)="_toggleHidden()">\n\n						<ion-icon [color]="\'red\'" name="arrow-dropdown-circle"></ion-icon>\n\n					</button>\n\n				</span>\n\n				<div id="sidenav" *ngIf="showSubmenu"> \n\n					<ion-list *ngIf="!this._newAgency && _userSettings.agencyConfiguration.client.length > 0">\n\n						<ion-item no-lines *ngFor="let brand of this.brandListWithOutSelectedOne">\n\n							<!-- <button ion-button color="lig ht" submenu-item>{{brand.clientName}}</button> -->\n\n							<ion-label *ngIf="brand.selectedToEdit;else other_content">\n\n								<form [formGroup]="_editBrandForm" (ngSubmit)="_saveEdittedBrandName(brand)">\n\n									<ion-item no-lines>\n\n										<!-- <ion-label color="primary" submenu-label placeholder="brand.clientName"></ion-label> -->\n\n										<ion-input type="text" #input [ngModel]="brand.clientName" formControlName="editBrandName"></ion-input>\n\n										<!-- placeholder={{brand.clientName}} -->\n\n										<button ion-button item-end sub-button type="submit" [disabled]="!_editBrandForm.valid">\n\n											<ion-icon icon-color name="ios-checkmark-outline" tappable></ion-icon>\n\n										</button>\n\n									</ion-item>\n\n								</form>\n\n								<span id="closeIcon">\n\n									<ion-icon icon-color float-right name="ios-close-outline" (click)="_cancelEdittedBrandName(brand)" tappable></ion-icon>\n\n								</span>\n\n							</ion-label>\n\n							<ng-template #other_content>\n\n								<ion-label *ngIf="!brand.selectedToEdit" [ngClass]="{\'selectedBrand\': _selectedClient.clientId === brand.clientId}">\n\n									<p ion-text submenu-item (click)="_selectedBrand(brand)">{{brand.clientName}}</p>\n\n									<span *ngIf="this._isShowEdit">\n\n										<span id="editIcon">\n\n											<ion-icon icon-color name="ios-create-outline" (click)="_editBrand(brand)" tappable></ion-icon>\n\n										</span>\n\n										<ion-icon *ngIf="_selectedClient.clientId != brand.clientId" icon-color float-right name="ios-trash-outline" (click)="_deleteBrand(brand)" tappable></ion-icon>\n\n									</span>\n\n								</ion-label>\n\n							</ng-template>\n\n						</ion-item>\n\n					</ion-list>\n\n					<span id="subMenuButton">\n\n						<button ion-button outline border-none icon-start *ngIf="!this._isShowEdit && (_agencyUser === \'agency_admin\') && _userSettings.agencyConfiguration.client.length > 0" (click)="_showEditIcon($event)">\n\n							<ion-icon name=\'ios-create-outline\'></ion-icon>\n\n							<span class="spanPadding">Edit</span>\n\n						</button>\n\n						<button ion-button border-none icon-start *ngIf="this._isShowEdit && _userSettings.agencyConfiguration.client.length > 0" (click)="_showEditIcon()">\n\n							<ion-icon name=\'ios-create-outline\' editColorWhite></ion-icon>\n\n							<span class="spanPadding">Edit</span>\n\n						</button>\n\n						<button ion-button outline border-none icon-start *ngIf="!this.addBrandName && (_agencyUser === \'agency_admin\')" (click)="_showAddBrand()">\n\n							<ion-icon name=\'ios-add-outline\'></ion-icon>\n\n							<span class="spanPadding">Add</span>\n\n						</button>\n\n						<button ion-button border-none icon-start *ngIf="this.addBrandName" (click)="_showAddBrand()">\n\n							<ion-icon name=\'ios-add-outline\' editColorWhite></ion-icon>\n\n							<span class="spanPadding">Add</span>\n\n						</button>\n\n					</span>\n\n\n\n					<!-- 					<div id="subMenuButton">\n\n						<button ion-button item-end outline>\n\n							<ion-icon item-start name="ios-create"></ion-icon>Edit\n\n						</button>\n\n						<button ion-button item-end outline (click)="_addBrand()">\n\n							<ion-icon item-start name="ios-add-outline"></ion-icon>Add\n\n						</button>\n\n					</div> -->\n\n				</div>\n\n			</ion-list>\n\n			<div *ngIf="addBrandName">\n\n				<form [formGroup]="_addBrandForm" (ngSubmit)="_addBrand()">\n\n					<ion-item id="textmargin">\n\n						<ion-label color="primary" floating>Add Brand</ion-label>\n\n						<ion-input type="text" formControlName="brandName"></ion-input>\n\n						<button ion-button item-end outline border-none type="submit" [disabled]="!_addBrandForm.valid">\n\n							<p ion-text psize>Save</p>\n\n						</button>\n\n					</ion-item>\n\n					<ion-item ion-text color="danger" text-center *ngIf="!_addBrandForm.controls[\'brandName\'].valid && _addBrandForm.controls[\'brandName\'].dirty && _addBrandForm.value[\'brandName\'] !==\'\' ">\n\n\n\n						Brand Name must be less than 32 chars\n\n					</ion-item>\n\n				</form>\n\n			</div>\n\n			<ion-list>\n\n				<ion-list-header>\n\n					Main\n\n				</ion-list-header>\n\n				<button ion-item border-none menuClose *ngFor="let p of _mainTabs" (click)="_openPage(p)">\n\n					<ion-icon item-start [name]="p.icon" [ngClass]="{\'inbox-icon\':p.icon ===\'ios-filing-outline\'}"></ion-icon>\n\n					<p ion-text [color]="_isActive(p)">{{p.title}}</p>\n\n				</button>\n\n			</ion-list>\n\n\n\n			<ion-list>\n\n				<ion-list-header>\n\n					Support\n\n				</ion-list-header>\n\n				<div *ngIf="!_isAgencyManagedUser">\n\n					<button ion-item border-none menuClose *ngFor="let p of _accountPages" (click)="_openPage(p)">\n\n						<ion-icon item-start [name]="p.icon" [color]="_isActive(p)"></ion-icon>\n\n						{{p.title}}\n\n					</button>\n\n					<button ion-item border-none menuClose *ngFor="let p of _loggedInPages" (click)="_openPage(p)">\n\n						<ion-icon item-start [name]="p.icon"></ion-icon>\n\n						<p ion-text [color]="_isActive(p)">{{p.title}}</p>\n\n					</button>\n\n				</div>\n\n\n\n			</ion-list>\n\n\n\n			<ion-list>\n\n				<ion-list-header>\n\n						Main Settings\n\n				</ion-list-header>\n\n				<button ion-item border-none menuClose (click)="pushMainSettingsPage()">\n\n					<ion-icon item-start name="ios-settings-outline"></ion-icon>\n\n					<p ion-text pText>Account Settings</p>\n\n				</button>\n\n				<button ion-item border-none menuClose (click)="pushPostSettingsPage()">\n\n					<ion-icon item-start name="ios-settings-outline"></ion-icon>\n\n					<p ion-text pText>Publishing Settings</p>\n\n				</button>\n\n			</ion-list>\n\n\n\n			<ion-list>\n\n					<!-- <button ion-item border-none menuClose (click)="registerInAppProduct()">\n\n							<ion-icon item-start name="ios-log-out-outline"></ion-icon>\n\n							<p ion-text pText>Register Product</p>					\n\n						</button> -->\n\n				<button ion-item border-none menuClose (click)="logout()">\n\n					<ion-icon item-start name="ios-log-out-outline"></ion-icon>\n\n					<p ion-text pText>Logout</p>					\n\n				</button>\n\n\n\n				<button ion-item border-none (click)="versionClick($event)">\n\n					<ion-icon item-start name="ios-appstore-outline"></ion-icon>\n\n					<p ion-text pText>App Version: {{_versionNumber}}</p>\n\n				</button>\n\n				<!-- 				<button ion-item border-none menuClose (click)="getToken()">\n\n					<ion-icon item-start name="ios-log-out-outline"></ion-icon>\n\n					FCM\n\n				</button> -->\n\n\n\n			</ion-list>\n\n\n\n		</ion-content>\n\n\n\n	</ion-menu>\n\n\n\n	<!-- main navigation -->\n\n	<!-- main attribute is for ion-split-pane -->\n\n	<!-- removed [root]="_rootPage" - using nav.setRoot instead-->\n\n\n\n	<ion-nav #content [root]="_rootPage" swipeBackEnabled="false" main>\n\n	</ion-nav>\n\n\n\n</ion-split-pane>\n\n'/*ion-inline-end:"E:\projects\IONIC-eClincher\src\app\app.html"*/ }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["m" /* MenuController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* LoadingController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["x" /* ToastController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["r" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_9__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_splash_screen__["a" /* SplashScreen */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_status_bar__["a" /* StatusBar */],
            __WEBPACK_IMPORTED_MODULE_15__providers_badge_count_badge_count__["a" /* BadgeCountProvider */],
            __WEBPACK_IMPORTED_MODULE_14__providers_app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_19__providers_user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_18__providers_accounts_brands_service_accounts_brands_service__["a" /* AccountsBrandsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_16__providers_auth_auth__["a" /* AuthProvider */],
            __WEBPACK_IMPORTED_MODULE_17__providers_user_data_user_data__["a" /* UserDataProvider */],
            __WEBPACK_IMPORTED_MODULE_20__providers_accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_5__ionic_native_device__["a" /* Device */],
            __WEBPACK_IMPORTED_MODULE_6__ionic_native_app_version__["a" /* AppVersion */],
            __WEBPACK_IMPORTED_MODULE_8__ionic_native_fcm__["a" /* FCM */],
            __WEBPACK_IMPORTED_MODULE_7__ionic_native_network__["a" /* Network */],
            __WEBPACK_IMPORTED_MODULE_10__ionic_native_web_intent__["a" /* WebIntent */],
            __WEBPACK_IMPORTED_MODULE_21__providers_window_service_window_service__["a" /* WindowServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_11__ionic_native_autostart__["a" /* Autostart */],
            __WEBPACK_IMPORTED_MODULE_22__providers_in_app_in_app__["a" /* InAppProvider */],
            __WEBPACK_IMPORTED_MODULE_23__providers_fcm_fcm__["a" /* FcmProvider */],
            __WEBPACK_IMPORTED_MODULE_24__providers_publishing_service_publishing_service__["a" /* PublishingProvider */],
            __WEBPACK_IMPORTED_MODULE_12__ionic_native_in_app_browser__["a" /* InAppBrowser */],
            __WEBPACK_IMPORTED_MODULE_25__providers_feeds_feeds_service__["a" /* FeedsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_13__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["e" /* Events */],
            __WEBPACK_IMPORTED_MODULE_26__providers_crisp_chat_crisp_chat__["a" /* CrispChatProvider */],
            __WEBPACK_IMPORTED_MODULE_27__providers_publishing_service_publishing_map_post__["a" /* PublishingMapPostProvider */],
            __WEBPACK_IMPORTED_MODULE_28__providers_reputations_reputations__["a" /* ReputationsProvider */],
            __WEBPACK_IMPORTED_MODULE_29__providers_facebook_facebook__["a" /* FacebookProvider */]])
    ], MyApp);
    return MyApp;
}());

; // end class MyApp
//# sourceMappingURL=app.component.js.map

/***/ }),

/***/ 510:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HttpInterceptorProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_do__ = __webpack_require__(511);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_do___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_do__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_throw__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_user_data_user_data__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_storage__ = __webpack_require__(24);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






//Providers



/*
intercepts Response to get ec_data
if ec_data exists - add it to Request headers as user_data
Otherwise get it from currentUser in AuthProvider
 */
var HttpInterceptorProvider = /** @class */ (function () {
    /*
    private _baseURL =     "http://localhost:1337/parse";
    private _baseURL =     "https://qa.app.eclincher.com/service";
     
    private _baseURL = "https://ionicdev.app.eclincher.com";
  
    // private _baseURL = "https://app.eclincher.com/service";
  */
    function HttpInterceptorProvider(_appSettingsProvider, _userDataProvider, _ionicStorgae, _loadingController) {
        var _this = this;
        this._appSettingsProvider = _appSettingsProvider;
        this._userDataProvider = _userDataProvider;
        this._ionicStorgae = _ionicStorgae;
        this._loadingController = _loadingController;
        this._openURLs = ["/user/login", "/user/create", "/user/forgotPassword"];
        this._updateUserDataURLs = ["/user/login", "/user/create", "/user/settings", "/agency/selectClient"];
        //Subscription
        this._appSettingsProvider.appSettings$.subscribe(function (appSettings) {
            _this._baseURL = appSettings.baseUrl;
        });
    }
    ; //end constructor
    HttpInterceptorProvider.prototype.intercept = function (request, next) {
        var _this = this;
        //loading controller
        var loading = this._loadingController.create();
        if ((request.url && (request.url.indexOf('/feed/notifications') !== -1 || request.url.indexOf('/publishing/listMentions') !== -1) || request.url.indexOf('/user/addNotification') !== -1) || request.params.get('disableLoader') === 'true') {
        }
        else {
            loading.present();
        }
        //reset this._userData  for these URLs
        if (this._openURLs.indexOf(request.url) > -1) {
            this._userData = undefined;
            this._ecData = undefined;
        }
        ;
        /*     const authReq = request.clone({
              headers: request.headers.set('Authorization', 'token <your GitHub token>')
            });
            See below for a shorter way of wrtiting the same code - from Angular docs
         */
        request = request.clone({
            setHeaders: { is_mobile_app: "1" },
            url: (request.url.indexOf('http://') === 0 || request.url.indexOf('https://') === 0) ? request.url : this._baseURL + request.url,
        });
        //set userData if it exists && no "user_data" headers were passed
        if (undefined !== this._userData && !request.headers.has(this._userDataProvider.requestHeadersAndStorageKey)) {
            request = request.clone({
                setHeaders: {
                    "user_data": this._userData
                }
            });
        }
        ;
        // if (undefined !== this._ecData && !request.headers.has(this._userDataProvider.responseHeadersKey2)) {
        //   request = request.clone({
        //     setHeaders: {
        //       "en_ecdata": this._ecData
        //     }
        //   })
        // };
        //Make request
        return next.handle(request).map(function (event) {
            if (event instanceof __WEBPACK_IMPORTED_MODULE_2__angular_common_http__["f" /* HttpResponse */]) {
                //temparoy fix for giphy is not returning ec_data in headers 
                //console.log('INTERCEPT:::', this._baseURL, event.url );
                if (event.url.split(_this._baseURL).length > 1 && event.url.split(_this._baseURL)[1].startsWith("/giphy/gf")) {
                    loading.dismiss();
                    return event;
                }
                //update local userData from headers
                var userData = event.headers.get(_this._userDataProvider.responseHeadersKey);
                var userDataObj = JSON.parse(userData);
                _this._ecData = event.headers.get(_this._userDataProvider.responseHeadersKey2);
                if (userData && userDataObj && userDataObj.user_name) {
                    _this._userData = userData;
                    // update BehaviorSubject
                    _this._userDataProvider.userDataSource.next(JSON.parse(_this._userData));
                    //Update storage
                    if (event.url.indexOf('/feed/notifications') === -1) {
                        _this._ionicStorgae.set(_this._userDataProvider.requestHeadersAndStorageKey, _this._userData).then(function (savedUserData) {
                            return event;
                        });
                        _this._ionicStorgae.set(_this._userDataProvider.responseHeadersKey2, _this._ecData).then(function (savedUserData) {
                            return event;
                        });
                    }
                }
                // this._userData = event.headers.get(this._userDataProvider.responseHeadersKey)
                // Update BeahviorSubject and Sortage for certain URLs
                if (userData && userDataObj && userDataObj.user_name && _this._updateUserDataURLs.indexOf(event.url.split(_this._baseURL)[1]) > -1) {
                    // update BehaviorSubject
                    _this._userDataProvider.userDataSource.next(JSON.parse(_this._userData));
                    //Update storage
                    if (event.url.indexOf('/feed/notifications') === -1) {
                        _this._ionicStorgae.set(_this._userDataProvider.requestHeadersAndStorageKey, _this._userData).then(function (savedUserData) {
                            return event;
                        });
                        _this._ionicStorgae.set(_this._userDataProvider.responseHeadersKey2, _this._ecData).then(function (savedUserData) {
                            return event;
                        });
                    }
                }
                loading.dismiss();
                return event;
            }
        }).catch(function (HttpErrorResponse) {
            loading.dismiss();
            return __WEBPACK_IMPORTED_MODULE_3_rxjs_Observable__["Observable"].throw(HttpErrorResponse);
            /*       if (ErrorEvent instanceof HttpErrorResponse) {
                    console.error(eventError);
                  }
             */ 
        });
    };
    ; //end intercept
    HttpInterceptorProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_app_settings_app_settings__["a" /* AppSettingsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_user_data_user_data__["a" /* UserDataProvider */], __WEBPACK_IMPORTED_MODULE_8__ionic_storage__["b" /* Storage */], __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["l" /* LoadingController */]])
    ], HttpInterceptorProvider);
    return HttpInterceptorProvider;
}());

; //end HttpInterceptorProvider
//# sourceMappingURL=http-interceptor.js.map

/***/ }),

/***/ 514:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EventMappingHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


var EventMappingHelperProvider = /** @class */ (function () {
    function EventMappingHelperProvider(http) {
        this.http = http;
    } //end constructor
    //Begin - Utility fcns copied from common.js in the jQuery mobile eClincher app
    EventMappingHelperProvider.prototype.findUrls = function (text) {
        var source = (text || '').toString(), urlArray = [], url, matchArray, regexToken = /(((ftp|https?):\/\/)[\-\w@:%_\+.~#?,&\/\/=]+)|((mailto:)?[_.\w-]+@([\w][\w\-]+\.)+[a-zA-Z]{2,3})/g;
        while ((matchArray = regexToken.exec(source)) !== null) {
            var token = matchArray[0];
            urlArray.push(token);
        }
        return urlArray;
    };
    ; //end findUrls
    EventMappingHelperProvider.prototype.twelve_hours = function (time, delim, period) {
        var split_time = (typeof time == 'undefined' ? '0:0:0' : time.split(delim)), am_pm = ' AM', formatted_time = '';
        // cryptic; rename vars
        if (split_time[0][0] == 0)
            split_time[0] = split_time[0][1];
        if (split_time[0] > 12) {
            split_time[0] -= 12;
            am_pm = ' PM';
        }
        formatted_time = split_time[0] + ':' + split_time[1] + (typeof period == 'undefined' ? '' : am_pm);
        return formatted_time;
    };
    ; //end twelve_hours
    EventMappingHelperProvider.prototype.hashtag_to_link = function (text, network) {
        var exp = /\B#(\w*[a-zA-Z]+\w*)/ig, linked = '';
        var target = "_blank";
        if (this.isArray(text))
            text = text[0];
        if (typeof text != 'undefined') // maybe if text != undefined
            if (network != undefined && network == 'twitter')
                linked = text.replace(exp, "<a target='" + target + "' href='" + ('https://twitter.com/search?q=%23$1') + "'>#$1</a>");
            else if (network === 'facebook')
                linked = text.replace(exp, "<a target='" + target + "' href='" + ('https://www.facebook.com/hashtag/$1') + "'>#$1</a>"); // https://www.facebook.com/hashtag/nba?hc_location=ufi
            else
                linked = text.replace(exp, "<a target='" + target + "' href='" + ('https://twitter.com/search?q=%23$1') + "'>#$1</a>");
        return linked;
    };
    ; //end hashtag_to_link
    EventMappingHelperProvider.prototype.mention_to_link = function (text, network) {
        var exp = /\B@(\w*[a-zA-Z]+\w*)/ig, linked = '';
        if (this.isArray(text))
            text = text[0];
        if (typeof text != 'undefined') // maybe if text != undefined
            if (network != undefined && network == 'twitter')
                linked = text.replace(exp, "<a class='tw-user' href='javascript:;' onClick='EC.UI.IAB(\"https://twitter.com/$1\");' data-user='@$1'>@$1</a>");
            else
                linked = text.replace(exp, "<a href='javascript:;' onClick='EC.UI.IAB(\"https://twitter.com/$1\");'>@$1</a>");
        return linked;
    }; //end mention_to_link
    EventMappingHelperProvider.prototype.url_to_link = function (text) {
        var target = "_blank";
        var exp = /(\b((https?|ftp|file):\/\/|bit.ly\/|goo.gl\/|t.co\/)[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
        function replacer(match) {
            return "<a target='" + target + "' href='" + (match.indexOf('//') == -1 ? '//' + match : match) + "'>" + (match.indexOf('//') == -1 ? '//' + match : match) + "</a>";
        }
        if (typeof text == 'string')
            return text.replace(exp, replacer);
        else
            return '';
    };
    ; //end url_to_link
    EventMappingHelperProvider.prototype.extract_urls = function (text) {
        var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
        if (typeof text == 'string')
            return text.match(exp);
        else
            return '';
    };
    ; //end extract_urls
    EventMappingHelperProvider.prototype.numberWithCommas = function (x) {
        if (x == undefined)
            return '';
        var parts = x.toString().split(".");
        parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        return parts.join(".");
    };
    ; //end numberWithCommas
    EventMappingHelperProvider.prototype.replaceURLWithHTMLLinks = function (text) {
        if (typeof text != "string")
            return;
        var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
        return text.replace(exp, "<a href='$1' target='_blank'>$1</a>");
    };
    ; //end replaceURLWithHTMLLinks
    EventMappingHelperProvider.prototype.is_valid_email = function (email) {
        var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
    };
    ; //end is_valid_email
    EventMappingHelperProvider.prototype.tw_user_mentions_to_links = function (text, raw_data) {
        text = text || '';
        var user_mentions;
        if (raw_data.streamEntry.entities != undefined && raw_data.streamEntry.entities.user_mentions != undefined
            && raw_data.streamEntry.entities.user_mentions.screen_name != undefined) {
            user_mentions = raw_data.streamEntry.entities.user_mentions.screen_name;
            if (!this.isArray(user_mentions))
                user_mentions = [user_mentions];
        }
        user_mentions = user_mentions || [];
        // user_mentions = user_mentions.filter(onlyUniqueVal);
        for (var i = 0, l = user_mentions.length; i < l; i++) {
            var screen_name = user_mentions[i];
            var exp = new RegExp('@' + screen_name, 'ig');
            var target = "_blank";
            text = text.replace(exp, "<a target='" + target + "' href='" + ('https://twitter.com/' + screen_name) + "'>@" + screen_name + "</a>");
            // text = text.replace(exp, '<a (\'https://twitter.com/' + screen_name +
            // 	'\');"  data-user="@' + screen_name + '">@' + screen_name + '</a>');
        }
        return text;
    };
    ;
    // Utility fcns copied from common.js in the jQuery mobile eClincher app
    EventMappingHelperProvider.prototype.onlyUniqueVal = function (value, index, self) {
        // self = this;
        return self.indexOf(value) === index;
    };
    ;
    //end onlyUniqueVal
    EventMappingHelperProvider.prototype.isArray = function (entity) {
        return Object.prototype.toString.call(entity) === "[object Array]";
    };
    ; //end isArray
    EventMappingHelperProvider.prototype.getUrls = function (message, event, profile) {
        if (profile.display.network.backend_network_name == 'Twitter') {
            /* 		if (event.streamEntry.retweeted_status == undefined && event.streamEntry.quoted_tweet != undefined
                  && event.streamEntry.quoted_tweet.streamEntry != undefined) // && !$.isEmptyObject( event.streamEntry.quoted_tweet.streamEntry ) )
                {
                  if (event.streamEntry.entities.urls != undefined) // && !$.isEmptyObject( event.streamEntry.entities.urls ) )
                  {
                    let urls = event.streamEntry.entities.urls;
                    let first_url;
            
                    if (isArray(urls)) first_url = urls[0].url;
                    else first_url = urls.url;
            
                    message = message.replace(first_url, '');
                  }
            
                  message = url_to_link(message);
                }
                else */ if (event.eventType === 'TWDirectMessage') {
                if (this.isArray(event.streamEntry.conversation.streamEntry)) {
                    var urls = event.streamEntry.conversation.streamEntry[0].entities.urls;
                    for (var url in urls) {
                        if (urls.hasOwnProperty(url)) {
                            if (urls.url && urls.expanded_url && urls.display_url) {
                                message = message.replace(urls.url, ''); //'<a target="_blank" href="' + urls.expanded_url + '">' + urls.display_url + '</a>'
                            }
                            // else {
                            // 	console.error("Does not have urls.");
                            // }
                        }
                        else {
                            console.error("Does not have property.");
                        }
                    }
                    ;
                }
                else if (!this.isArray(event.streamEntry.conversation.streamEntry)) {
                    var urls = event.streamEntry.conversation.streamEntry.entities.urls;
                    if (urls != undefined) {
                        for (var i = 0; i <= urls.length - 1; i++) {
                            if (urls[i].url && urls[i].expanded_url && urls[i].display_url) {
                                message = message.replace(urls[i].url, '<a target="_blank" href="' + urls[i].expanded_url + '">' + urls[i].display_url + '</a>');
                            }
                            // else {
                            // 	console.error("Does not have urls.");
                            // }
                        }
                        ;
                    }
                }
                else {
                    message = this.url_to_link(message);
                }
            }
            else { //tw_deep_link_to_html
                //message = url_to_link( message, "_blank" );
                if (event.streamEntry.entities && event.streamEntry.entities.urls != undefined) // && !$.isEmptyObject( event.streamEntry.entities.urls ) )
                 {
                    var urls = event.streamEntry.entities.urls;
                    for (var url in urls) {
                        if (urls.hasOwnProperty(url)) {
                            if (this.isArray(urls)) {
                                var index = parseInt(url);
                                if (urls[index].url && urls[index].expanded_url && urls[index].display_url) {
                                    message = message.replace(urls[index].url, '<a target="_blank" href="' + urls[index].expanded_url + '">' + urls[index].display_url + '</a>');
                                }
                                else {
                                    console.error("Does not have property.");
                                }
                            }
                            else if (urls.url && urls.expanded_url && urls.display_url) {
                                message = message.replace(urls.url, '<a target="_blank" href="' + urls.expanded_url + '">' + urls.display_url + '</a>');
                            }
                            else {
                                console.error("Does not have urls.");
                            }
                            ; //end if (urls.url && urls.expanded_url && urls.display_url) {
                        } //end if (urls.hasOwnProperty(url)) {
                        else {
                            console.error("Does not have property.");
                        }
                    }
                    ;
                }
                else
                    message = this.url_to_link(message);
            }
            // if ( event.streamEntry.description && ( self.feed.id == 'twFriends' || self.feed.id == 'twFollowers' || self.data.eventType == 'TWFollowers'
            // 		|| ( ( self.feed.id == 'search' || self.feed.id == 'outreach' ) 
            // 			&& self.feed.options.parameters.type == 'users' ) ) )
            // {
            // 	//message = event.streamEntry.description;
            // 	message = $('<div>').html( event.streamEntry.description ).text();
            // 	var from_name = $('<div>').html( self.data.fromName ).text();
            // 	if ( self.data.eventType == 'TWFollowers' ) message += ' <span class="view-follower">View ' + from_name + ' profile</span>';  
            // }
            //message = url_to_link( message );
            if (event.streamEntry.entities && event.streamEntry.entities.ext_media && event.streamEntry.entities.ext_media.media && event.streamEntry.entities.ext_media.media[0] != undefined) // && !$.isEmptyObject( event.streamEntry.entities.urls ) )
             {
                var urls = event.streamEntry.entities.ext_media.media[0];
                for (var url in urls) {
                    if (urls.hasOwnProperty(url)) {
                        if (urls.url && urls.expanded_url && urls.display_url) {
                            message = message.replace(urls.url, '<a target="_blank" href="' + urls.expanded_url + '">' + urls.display_url + '</a>');
                        }
                        else {
                            console.error("Does not have urls.");
                        }
                    }
                    else {
                        console.error("Does not have property.");
                    }
                }
                ;
            }
            // console.log('message', message);
        }
        // else {
        // 	message = url_to_link(message, "_blank");
        // }
        message = this.tw_user_mentions_to_links(message, event);
        message = this.hashtag_to_link(message, profile.display.network.backend_network_name);
        return message;
    };
    ; //end getUrls
    EventMappingHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */]])
    ], EventMappingHelperProvider);
    return EventMappingHelperProvider;
}());

; //end EventMappingHelperProvider
//# sourceMappingURL=event-mapping-helper.js.map

/***/ }),

/***/ 515:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EventViewCommentsServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/*
  Generated class for the EventViewCommentsServiceProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var EventViewCommentsServiceProvider = /** @class */ (function () {
    function EventViewCommentsServiceProvider(http) {
        this.http = http;
        console.log('Hello EventViewCommentsServiceProvider Provider');
    }
    EventViewCommentsServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */]])
    ], EventViewCommentsServiceProvider);
    return EventViewCommentsServiceProvider;
}());

//# sourceMappingURL=event-view-comments-service.js.map

/***/ }),

/***/ 516:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EventReplyRetweetDmServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/*
  Generated class for the EventReplyRetweetDmServiceProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var EventReplyRetweetDmServiceProvider = /** @class */ (function () {
    function EventReplyRetweetDmServiceProvider(_http) {
        this._http = _http;
        console.log('Hello EventReplyRetweetDmServiceProvider Provider');
    }
    /******************************************************\
     *                REPLY METHOD
     *
    /******************************************************/
    EventReplyRetweetDmServiceProvider.prototype.saveSendForTwitter = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("id", data.userId)
            .set("status", data.status)
            .set("text", data.text)
            .set("user_id", data.userId);
        //merging 2 objects
        Object.assign(requestBody, this._setAttachments(data));
        console.info("InboxActionButtonProvider::saveLikeForTwitter  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveSendForTwitter
    EventReplyRetweetDmServiceProvider.prototype.saveReplyRetweetForTwitter = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("id", data.id)
            .set("status", data.status);
        //merging 2 objects
        Object.assign(requestBody, this._setAttachments(data));
        console.info("InboxActionButtonProvider::saveLikeForTwitter  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplyRetweetForTwitter
    EventReplyRetweetDmServiceProvider.prototype.saveReplytForFacebook = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.post_id)
            .set("message", data.message);
        console.info("InboxActionButtonProvider::saveLikeForFaceBook  - requestBody - ", requestBody);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplytForFacebook
    EventReplyRetweetDmServiceProvider.prototype.saveDMForFacebook = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("id", data.id)
            .set("user", data.user)
            .set("inbox", data.inbox)
            .set("message", data.message);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplytForFacebook
    EventReplyRetweetDmServiceProvider.prototype.saveReplytForInstaBusiness = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            // .set("reply", data.reply)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.post_id)
            .set("message", data.message);
        if (data.reply) {
            requestBody = requestBody.set('reply', data.reply);
        }
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplytForFacebook
    EventReplyRetweetDmServiceProvider.prototype.saveReplytForYouTube = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("parent_id", data.parent_id)
            .set("comment", data.comment);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplytForYouTube
    EventReplyRetweetDmServiceProvider.prototype.saveCommentForYouTube = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            // .set("reply", data.reply)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.post_id)
            .set("comment", data.message);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplytForFacebook
    EventReplyRetweetDmServiceProvider.prototype.saveReplytForGoogleMyBusiness = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.post_id)
            .set("message", data.message);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplytForYouTube
    EventReplyRetweetDmServiceProvider.prototype.saveCommentForLinkedin = function (data) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", data.action)
            .set("accountID", data.accountId)
            .set("profileID", data.profileId)
            .set("post_id", data.post_id)
            .set("message", data.comment);
        return this
            ._http
            .post("/feed/reply", requestBody);
    };
    ; //end saveReplytForFacebook
    EventReplyRetweetDmServiceProvider.prototype._setAttachments = function (data) {
        var _parameters = {};
        var _loop_1 = function (index) {
            var keyData;
            Object.keys(data.attachments[index].originalData).forEach(function (key) {
                if (key === 'size') {
                    keyData = "attachments[" + index + "][dimension][" + key + "]";
                }
                else {
                    keyData = "attachments[" + index + "][" + key + "]";
                }
                _parameters[keyData] = data.attachments[index].originalData[key];
                console.log(key, data.attachments[index].originalData[key]);
            });
        };
        for (var index = 0; index <= data.attachments.length - 1; index++) {
            _loop_1(index);
        }
        return _parameters;
    };
    /******************************************************\
   *
   * GENERIC METHOD TO SAVE BOOLEAN VALUES FOR ACTION BUTTONS
   *
  /******************************************************/
    EventReplyRetweetDmServiceProvider.prototype.saveButtonValueInUserEvents = function (actionButtonRequest) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]();
        //convert only booleans to string
        for (var key in actionButtonRequest) {
            requestBody = requestBody.append("events[0][" + key + "]", actionButtonRequest[key].toString());
        }
        ; //end for loop
        return this
            ._http
            .post("/user/events", requestBody);
    };
    ; //end saveButtonValueInUserEvents
    EventReplyRetweetDmServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], EventReplyRetweetDmServiceProvider);
    return EventReplyRetweetDmServiceProvider;
}());

; //end export class EventReplyRetweetDmServiceProvider
; //end EventActionButtonsInterface
/*   public saveReplyForFacebook(actionButtonInfo, inboxItem): Observable<any> {
    console.info('Entering InboxActionButtonProvider::saveReplyForFacebook.');
    let _dataInfo: any = {};

      let requestBody = {};
      requestBody["action"] = actionButtonInfo.action;
      requestBody["accountID"] = inboxItem.accountId;
      requestBody["profileID"] = inboxItem.profileId;
      // if( actionButtonInfo.action == 'addFbComment'){
      requestBody[actionButtonInfo.idKey] = actionButtonInfo.idValue;
      // } else {
      //   requestBody[actionButtonInfo.idKey] = inboxItem.userId;
      // }
      requestBody[actionButtonInfo.messageName] = actionButtonInfo.messageValue;

      console.info("InboxActionButtonProvider::saveReplyForFacebook  - requestBody - ", requestBody);

      return this
        ._http
        .post("/feed/reply", requestBody)
        .map(inboxSaveReplyResponse => {
          console.info('InboxActionButtonProvider::saveReplyForFacebook - Successfully saved send reply info.', inboxSaveReplyResponse);

          console.info('Exiting InboxActionButtonProvider::saveReplyForFacebook');
          return inboxSaveReplyResponse.json();
        },
        inboxSaveReplyError => {
          console.error("InboxActionButtonProvider::saveReplyForFacebook - Error saving reply.  Error is : ", inboxSaveReplyError);
          return inboxSaveReplyError;
        });
          } //end saveReplyForFacebook */
/*   public saveSendReplyRetweet(actionButtonInfo, inboxItem, attachmentInfo): Observable<HttpResponse<any>> {
    console.info('Entering InboxActionButtonProvider::_saveReply.');
    let body_json: any = {};

    if (actionButtonInfo.action == 'TWSend') { // for twitter send(DM)
      body_json = {
        action: actionButtonInfo.action,
        accountID: inboxItem.accountId,
        profileID: inboxItem.profileId,
        placeHolder1: actionButtonInfo.messageValue,
        placeHolder2: inboxItem.userId,
        // eventUserName: inboxItem.userName,
        text: actionButtonInfo.messageValue,
        user_id: inboxItem.userIdStr
      }

      let body_str = JSON.stringify(body_json);
      body_str = body_str.replace("placeHolder1", actionButtonInfo.messageName);
      body_str = body_str.replace("placeHolder2", actionButtonInfo.idKey);

      body_json = JSON.parse(body_str);
      console.info("body_json: ", body_json);
    }
    else if (actionButtonInfo.action == 'TWReply' || actionButtonInfo.action == 'TWWallPost') { // for twitter reply and retweet
      body_json = {
        action: actionButtonInfo.action,
        accountID: inboxItem.accountId,
        profileID: inboxItem.profileId,
        placeHolder1: actionButtonInfo.messageValue,
        placeHolder2: inboxItem.userId,
      }

      let body_str = JSON.stringify(body_json);
      body_str = body_str.replace("placeHolder1", actionButtonInfo.messageName);
      body_str = body_str.replace("placeHolder2", actionButtonInfo.idKey);

      let _parameters = "";
      for (let index = 0; index < actionButtonInfo.attachments.length; index++) {
        _parameters += "&attachments[" + index + "][key]=" + actionButtonInfo.attachments[index]["key"];
        _parameters += "&attachments[" + index + "][value]=" + actionButtonInfo.attachments[index]["value"];
      }

      console.log("_parameters : ", _parameters);

      body_json = JSON.parse(body_str);
      console.info("body_json: ", body_json);
    }
    else if (actionButtonInfo.action == 'addFbComment' && inboxItem.eventType === "FBMentions") { // for facebook reply

      body_json = {
        action: actionButtonInfo.action,
        accountID: inboxItem.accountId,
        profileID: inboxItem.profileId,
        placeHolder1: actionButtonInfo.messageValue,
        placeHolder2: inboxItem.objectId,
      }

      let body_str = JSON.stringify(body_json);
      body_str = body_str.replace("placeHolder1", actionButtonInfo.messageName);
      body_str = body_str.replace("placeHolder2", actionButtonInfo.idKey);

      body_json = JSON.parse(body_str);
      console.info("body_json: ", body_json);
    }
    else if (actionButtonInfo.action == 'addFbComment' && inboxItem.eventType != "FBMentions") { // for facebook reply

      body_json = {
        action: actionButtonInfo.action,
        accountID: inboxItem.accountId,
        profileID: inboxItem.profileId,
        placeHolder1: actionButtonInfo.messageValue,
        placeHolder2: inboxItem.idValue,
      }

      let body_str = JSON.stringify(body_json);
      body_str = body_str.replace("placeHolder1", actionButtonInfo.messageName);
      body_str = body_str.replace("placeHolder2", actionButtonInfo.idKey);

      body_json = JSON.parse(body_str);
      console.info("body_json: ", body_json);
    }
    else if (actionButtonInfo.action == 'addYTReply') { // for facebook reply

      body_json = {
        action: actionButtonInfo.action,
        accountID: inboxItem.accountId,
        profileID: inboxItem.profileId,
        placeHolder1: actionButtonInfo.messageValue,
        placeHolder2: inboxItem.parentId,
      }

      let body_str = JSON.stringify(body_json);
      body_str = body_str.replace("placeHolder1", actionButtonInfo.messageName);
      body_str = body_str.replace("placeHolder2", actionButtonInfo.idKey);

      body_json = JSON.parse(body_str);
      console.info("body_json: ", body_json);
    }


    if (attachmentInfo.length > 0) {
      //attachments
      body_json["attachments"] = [];
      let _attachments = [], dimension = {};
      for (let index = 0; index < attachmentInfo.length; index++) {

        let _attachment = {}
        _attachment["name"] = attachmentInfo[index].filename
        _attachment["image"] = attachmentInfo[index].name
        _attachment["type"] = attachmentInfo[index].type
        _attachment["size"] = attachmentInfo[index].size
        _attachment["location"] = attachmentInfo[index].filename
        _attachment["s3_url"] = attachmentInfo[index].s3_url
        _attachment["imageThumbnail"] = attachmentInfo[index].imageThumbnail
        _attachment["dimension"]["size"] = attachmentInfo[index].size
        _attachment["source"] = "upload"
        body_json["attachments"][index] = _attachment
      }
    }

    try {
      let body_str = JSON.stringify(body_json)
      console.log("InboxActionButtonProvider::_saveReply  - requestBody as string - ", body_str)
    }
    catch (e) {

    }

    console.info("InboxActionButtonProvider::_saveReply  - requestBody - ", body_json);

    return this
      ._http
      .post<HttpResponse<any>>("/feed/reply", body_json)
      .catch(inboxSaveReplyError => {
        console.error("InboxActionButtonProvider::_saveReply - Error saving settings.  Error is : ", inboxSaveReplyError);
        return Observable.throw(inboxSaveReplyError);
      });
  }; //end saveSendForReply */
//# sourceMappingURL=event-reply-retweet-dm-service.js.map

/***/ }),

/***/ 52:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserDataProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var UserDataProvider = /** @class */ (function () {
    function UserDataProvider(_ionicStorage) {
        this._ionicStorage = _ionicStorage;
        this.responseHeadersKey = "ec_data";
        this.responseHeadersKey2 = "mob_ec_data"; //for nest api bearer token
        this.requestHeadersAndStorageKey = "user_data";
        this.intercomSecretKey = 'Gz3_ecPlUIY_cmKLmaDEBAizBCC3GjS8RCgKmjAz';
        // source for observable
        this.userDataSource = new __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.userData$ = this
            .userDataSource
            .asObservable();
    }
    ; //end constructor
    UserDataProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_storage__["b" /* Storage */]])
    ], UserDataProvider);
    return UserDataProvider;
}());

; //end UserDataProvider
//# sourceMappingURL=user-data.js.map

/***/ }),

/***/ 61:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FeedItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__ = __webpack_require__(30);
//HELPERS

/*
*   FeedItem is a base class for all feeditems ( TimelineFeedItem, InstagramFeedItem, etc...).
*   it will carry the item's data and its feed info.
*/
var FeedItem = /** @class */ (function () {
    function FeedItem(http, data, feed) {
        this.defaultThumbImage = 'https://app.eclincher.com/img/video_empty_thumb.png';
        this.profile = feed.profile;
        this.feed = feed;
        this.data = data;
        this.isCommentView = false;
        this.network = this.profile.display.network.backend_network_name.toLocaleLowerCase();
    }
    /**
     * prepareTwitterMedia
     */
    FeedItem.prototype.prepareTwitterMedia = function (raw_data, media) {
        if (raw_data && raw_data.entities && raw_data.entities.media) {
            var ext_media_data = raw_data.entities.ext_media;
            var ext_media = void 0;
            var variant = void 0;
            if (ext_media_data && ext_media_data.media) {
                if (Array.isArray(ext_media_data.media))
                    ext_media = ext_media_data.media[0];
                else
                    ext_media = ext_media_data.media;
            }
            if (ext_media
                && (ext_media.type === 'animated_gif' || ext_media.type === 'video')
                && ext_media.video_info
                && ext_media.video_info.variants
                && ext_media.video_info.variants.variant) {
                var variant_data = ext_media.video_info.variants.variant;
                if (Array.isArray(variant_data))
                    variant = variant_data[0];
                else
                    variant = variant_data;
            }
            if (variant) {
                //Media URL
                media.mediaUrl = ext_media.media_url_https;
                if (ext_media.type === 'animated_gif')
                    media.isAnimated = true;
                //Video URL
                media.videoUrl = variant.url;
            }
            else {
                if (typeof raw_data.entities.media.media_url === 'string') {
                    if (raw_data.entities.media.media_url.indexOf('https:') === -1) {
                        if (raw_data.preview_content) {
                            var preview_content = JSON.parse(raw_data.preview_content);
                            if (preview_content.title)
                                media.mediaOriginalPageContent = preview_content.title;
                            if (typeof raw_data.picture_text === 'string')
                                media.mediaOriginalPagePreview = raw_data.picture_text;
                            media.mediaOriginalPageUrl = preview_content.url;
                        }
                    }
                    else {
                        if (raw_data.preview_content) {
                            var preview_content = JSON.parse(raw_data.preview_content);
                            //Media URL
                            media.mediaUrl = raw_data.entities.media.media_url;
                            if (preview_content.title) {
                                media.mediaOriginalPageContent = preview_content.title;
                            }
                            if (typeof raw_data.picture_text === 'string') {
                                media.mediaOriginalPagePreview = raw_data.picture_text;
                            }
                            media.mediaOriginalPageUrl = preview_content.url;
                        }
                        else {
                            //Media URL
                            media.mediaUrl = raw_data.entities.media.media_url;
                        }
                        //Video URL
                        if (raw_data.entities.video_id) {
                            media.videoUrl = 'https://www.youtube.com/embed/' + raw_data.entities.video_id;
                        }
                    }
                }
            }
        }
        if (media.mediaUrl !== '') {
            media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
        }
        return media;
    };
    /**
     * prepareFBMedia
     */
    FeedItem.prototype.prepareFBMedia = function (post_data, media) {
        var preview = '';
        if (Array.isArray(post_data.media)) {
            // ??
        }
        else if (typeof post_data.media === 'object' && post_data.media.type !== 'unavailable') {
            if (!__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](post_data.mediaDescription)) {
                preview = post_data.mediaDescription;
            }
            else if (post_data.caption) {
                preview = post_data.caption;
            }
            else if (post_data.media.alt && post_data.media.alt !== post_data.message) {
                preview = post_data.media.alt;
            }
            media.mediaOriginalPagePreview = __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["t" /* replaceURLWithHTMLLinks */](preview);
            if (post_data.media.type && post_data.media.type.indexOf('video') !== -1) {
                media.isImage = false;
                if (post_data.media.video) {
                    var url_n = post_data.media.src || post_data.media.video.display_url;
                    if (typeof url_n === 'string') {
                        media.mediaUrl = url_n.replace('Fdefault', 'Fhqdefault').replace('/default', '/hqdefault');
                        media.videoUrl = post_data.media.video.source_url.replace('http://', 'https://').replace('&dl=1', '');
                    }
                }
                else if (post_data.media.href) {
                    media.mediaUrl = post_data.media.src;
                    media.videoUrl = post_data.media.href;
                }
            }
            else {
                if (this.feed.id === 'cinbox') {
                    var url_n = post_data.media.src;
                    if (post_data.media.type === 'animated_image_share' && url_n.indexOf('url=http') !== -1) {
                        if (typeof post_data.media.href === 'string' && post_data.media.href.indexOf('u=http') !== -1) {
                            url_n = post_data.media.href;
                            url_n = decodeURIComponent(url_n.slice(url_n.indexOf('u=http') + 2));
                            url_n = url_n.slice(0, url_n.indexOf('&'));
                        }
                        else
                            url_n = decodeURIComponent(url_n.slice(url_n.indexOf('url=http') + 4));
                    }
                    if (typeof url_n === 'string') {
                        media.mediaUrl = url_n;
                    }
                }
                else {
                    if (post_data.media.type === 'photo') {
                        media.mediaUrl = __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["a" /* FB_thumbnail_to_full_size */](post_data.media.src);
                    }
                    else {
                        if (__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](post_data.media.src)) {
                        }
                        else {
                            media.mediaUrl = post_data.media.src;
                        }
                    }
                }
            }
        }
        if (media.mediaUrl !== '') {
            media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
        }
        return media;
    };
    /**
     * prepareGalleyImage
     */
    FeedItem.prototype.prepareGalleyImage = function (imageURL) {
        var gallery_image;
        return gallery_image = {
            originalData: '',
            url: {
                full: imageURL,
                thumbnail: imageURL
            }
        };
    };
    /**
     * convertToHTML
     * It return HTML decoded text
     */
    FeedItem.prototype.convertToHTML = function (str) {
        var div = document.createElement('div');
        div.innerHTML = str;
        return div.innerText;
    };
    /**
     * removeButtons
     */
    FeedItem.prototype.removeButtons = function (buttons) {
        if (buttons === void 0) { buttons = []; }
        var updatedButtons = {};
        if (this.actionButtons) {
            return updatedButtons;
        }
        var keys = Object.keys(this.actionButtons);
        for (var i in keys) {
            if (buttons.length && buttons.indexOf(keys[i]) === -1) {
                updatedButtons[keys[i]] = this.actionButtons[keys[i]];
            }
        }
        return updatedButtons;
    };
    /**
     * removeKeys
     */
    FeedItem.prototype.removeKeys = function (obj, keys) {
        if (keys === void 0) { keys = []; }
        var updatedHeaders = {};
        var headerKeys = Object.keys(obj);
        for (var i in headerKeys) {
            if (keys.length && keys.indexOf(headerKeys[i]) === -1) {
                updatedHeaders[headerKeys[i]] = this.actionButtons[headerKeys[i]];
            }
        }
        return updatedHeaders;
    };
    /**
     * getPostIdAndObjectType
     */
    FeedItem.prototype.getPostIdAndObjectType = function () {
        var display_more = false, post_id, object_type = 'post';
        if (this.data.eventTitle === 'Review Comment' || this.data.feed_id === 'fb_reviews') {
            display_more = true;
            object_type = 'review';
            post_id = this.data.objectId;
            if (this.data.feed_id === 'fb_reviews')
                post_id = this.data.id;
        }
        if (this.data.eventType === 'FBAdsComments') {
            display_more = true;
            post_id = this.data.objectId;
        }
        var link = this.data.link;
        if (this.data.type || this.data.source === 'fbwebhook') {
            if (this.data.type === 'Groups')
                display_more = true;
            else if (this.data.type === 'Gifts')
                display_more = true;
            else if (this.data.type === 'Likes' || this.data.type === 'Feed Comments') {
                display_more = true;
                post_id = this.data.object_id;
                if (this.data.message.indexOf('your photo') !== -1 && typeof post_id === 'string' && post_id.indexOf('_') === -1)
                    object_type = 'photo';
                if (this.data.message.indexOf('your video') !== -1 && typeof post_id === 'string' && post_id.indexOf('_') === -1)
                    object_type = 'video';
            }
            else if (this.data.type === 'Wall' || this.data.type === 'Links') {
                display_more = true;
                post_id = this.data.object_id;
            }
            else if (this.data.type === 'Photos') {
                display_more = true;
                post_id = this.data.object_id;
                object_type = 'photo';
            }
            else if (this.data.source === 'fbwebhook') {
                display_more = true;
                post_id = this.data.id;
                // display_more = true;
                // post_id = this.data.getPostIdAndObjectType;
                // if(this.data.type === 'photo') {
                // 	post_id = this.data.id.substring(this.data.id.indexOf('_') + 1);
                // 	object_type = 'photo';
                // }
                // else if(this.data.type=='video') object_type = 'video';
                // else if(this.data.type === 'link') object_type = 'link';
                // else if(this.data.type === 'status'){
                // 	object_type = 'review';
                // 	console.log('getPostIdAndObjectType',this.data);
                // }
            }
            else if (this.data.type === 'Pages') {
                if (link.indexOf('/posts/') !== -1) {
                    display_more = true;
                    post_id = link.substring(link.indexOf('/posts/'));
                    post_id = post_id.replace('/posts/', '');
                    object_type = 'link';
                }
            }
            else if (this.data.type === 'Video' || this.data.type === 'Videos' || this.data.type === 'Watch') {
                display_more = true;
                post_id = this.data.object_id;
                if (post_id || post_id.indexOf('_') == -1)
                    object_type = 'video';
            }
            if (post_id == null && typeof link === 'string' && link.indexOf('http://www.facebook.com/groups/') !== -1) {
                post_id = link.replace('http://www.facebook.com/groups/', '');
                var exp = /\/\d*\//g;
                var m = exp.exec(post_id);
                if (m != null) {
                    post_id = m[0].replace(/\//g, '');
                    display_more = true;
                }
                else
                    post_id = undefined;
            }
        }
        var result = {
            display_more: display_more,
            post_id: post_id,
            object_type: object_type
        };
        return result;
    };
    /**
     * prepare Post Data
     */
    FeedItem.prototype.preparePostData = function () {
        var postData = {
            content: '',
            images: [],
            links: [],
            postSummary: ''
        };
        switch (this.feed.network) {
            case 'facebook':
            case 'twitter':
            case 'linkedin':
                // Content
                var linkUrl = void 0;
                if (this.data.message) {
                    postData.content = this.data.message;
                }
                else if (this.data.shortDescription) {
                    postData.content = this.data.shortDescription;
                }
                else if (this.data.updateContent
                    && this.data.updateContent.currentUpdate
                    && typeof this.data.updateContent.currentUpdate.comment === 'string') {
                    postData.content = this.data.updateContent.currentUpdate.comment;
                }
                if (this.feed.network === 'twitter') {
                    if (this.data.raw_data && this.data.raw_data.entities && this.data.raw_data.entities.urls) {
                        var urls = this.data.raw_data.entities.urls;
                        if (!Array.isArray(urls)) {
                            urls = [urls];
                        }
                        urls.forEach(function (url) {
                            if (url.expanded_url
                                && postData.content.indexOf(url.url) === -1
                                && postData.content.indexOf(url.expanded_url) === -1) {
                                postData.content += ' ' + url.expanded_url;
                            }
                            else {
                            }
                        });
                    }
                }
                // Links
                if (this.feed.network === 'facebook' && this.data.media && this.data.media.type) {
                    if (['link', 'share', 'video'].indexOf(this.data.media.type) !== -1) {
                        linkUrl = __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["m" /* getUrlParam */]("u", decodeURIComponent(this.data.media.href));
                    }
                    if (this.data.media.type === 'link') {
                        linkUrl = this.data.media.href;
                    }
                    if (linkUrl && linkUrl != '') {
                        postData.links.push(linkUrl);
                    }
                }
                if (this.feed.network !== 'twitter') {
                    var re = /(\b((https?|ftp|file):\/\/|bit.ly\/|goo.gl\/|t.co\/)[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig, m = void 0, url = void 0, $content_links = [];
                    while ((m = re.exec(postData.content)) != null) {
                        if (m.index === re.lastIndex) {
                            re.lastIndex++;
                        }
                        $content_links.push(m[0]);
                    }
                    if ($content_links.length) {
                        postData.links = $content_links;
                    }
                }
                if (this.feed.network === 'linkedin') {
                    if (this.data.updateContent
                        && this.data.updateContent.currentUpdate
                        && this.data.updateContent.currentUpdate.content) {
                        var li_content = this.data.updateContent.currentUpdate.content;
                        if (postData.content.length === 0) {
                            if (li_content.title === 'string')
                                postData.content += li_content.title;
                            if (li_content.description === 'string')
                                postData.content = postData.content + ' ' + li_content.description;
                        }
                        var ph_link = '';
                        if (!(/\.(jpg|jpeg|png|bmp|tiff|avi|mpeg|mkv|ogg|mov|mpeg|mpg|mpe|flv|3gp|gif)$/i).test(li_content.title)
                            && li_content.title !== 'View Image'
                            && li_content.title !== 'Click Here to View Image'
                            && li_content.title !== 'Content title'
                            && li_content.title.indexOf('_ecsize_') === -1
                            && typeof li_content.submittedUrl === 'string') {
                            postData.links.push(decodeURIComponent(li_content.submittedUrl));
                        }
                    }
                }
                if (linkUrl) {
                    if (this.feed.network === 'facebook') {
                        postData.shared_url = linkUrl;
                    }
                    else if (postData.content.indexOf(linkUrl) === -1) {
                        postData.content += ' ' + linkUrl;
                    }
                }
                if (this.data.title) {
                    postData.content = this.data.title + ' ' + postData.content;
                }
                // Media 
                if (this.data.media) {
                    var media = [];
                    if (Array.isArray(this.data.media)) {
                        media = this.data.media;
                    }
                    else {
                        media = [this.data.media];
                    }
                    for (var i = 0; i < media.length; i++) {
                        var currentMedia = media[i];
                        if (__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](currentMedia)) {
                            continue;
                        }
                        var url_n_1 = '', image_data_1 = {}, stuff = '';
                        if (this.data.mediaDescription && !__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](this.data.mediaDescription)) {
                            stuff = this.data.mediaDescription;
                        }
                        else if (this.data.caption) {
                            stuff = this.data.caption;
                            image_data_1.title = this.data.caption;
                        }
                        else if (currentMedia.alt && currentMedia.alt !== this.data.message) {
                            stuff = currentMedia.alt;
                            image_data_1.title = currentMedia.alt;
                        }
                        if (currentMedia.type === 'photo') {
                            url_n_1 = __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["a" /* FB_thumbnail_to_full_size */](currentMedia.src);
                        }
                        else if (currentMedia.type === 'video' && currentMedia.video) {
                            url_n_1 = currentMedia.src.replace('Fdefault', 'Fhqdefault').replace('/default', '/hqdefault');
                        }
                        else {
                            if (!__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](currentMedia.src)) {
                                url_n_1 = currentMedia.src;
                            }
                        }
                        postData.postSummary = stuff;
                        if (url_n_1 && url_n_1 != '') {
                            image_data_1.src = url_n_1;
                            if (image_data_1.title == undefined) {
                                image_data_1.title = image_data_1.src;
                            }
                            image_data_1.filename = url_n_1.substring(url_n_1.lastIndexOf("/") + 1, url_n_1.lastIndexOf(".")) + '.jpg';
                            postData.images.push(image_data_1);
                        }
                    }
                }
                // Video Url
                if (this.feed.network === 'facebook') {
                    if (this.data.media
                        && this.data.media.type
                        && this.data.media.type === 'video'
                        && this.data.media.video
                        && this.data.media.video.source_url) {
                        postData.images = [];
                        postData.videoUrl = this.data.media.video.source_url;
                        if (postData.content.indexOf(postData.videoUrl) === -1) {
                            postData.content += ' ' + postData.videoUrl;
                        }
                    }
                }
                if (this.feed.network === 'twitter') {
                    if (this.data.raw_data
                        && this.data.raw_data.entities
                        && this.data.raw_data.entities.ext_media
                        && this.data.raw_data.entities.ext_media.media) {
                        var extMedia = this.data.raw_data.entities.ext_media.media;
                        if (Array.isArray(extMedia)) {
                            extMedia = extMedia[0];
                        }
                        if (extMedia
                            && extMedia.type === 'video'
                            && extMedia.video_info
                            && extMedia.video_info.variants
                            && extMedia.video_info.variants.variant) {
                            var variant = extMedia.video_info.variants.variant;
                            if (Array.isArray(extMedia.video_info.variants.variant)) {
                                variant = extMedia.video_info.variants.variant[0];
                            }
                            if (variant.length) {
                                postData.images = [];
                                postData.videoUrl = variant.url;
                                if (postData.content.indexOf(postData.videoUrl) === -1) {
                                    postData.content += ' ' + postData.videoUrl;
                                }
                            }
                        }
                    }
                }
                break;
            case 'instagram':
            case 'instabusiness':
                var url_n = '', image_data = {};
                if (this.data.caption && typeof this.data.caption.text === 'string') {
                    postData.content = this.data.caption.text;
                }
                if (this.data.type == "image") {
                    url_n = this.data.images.standard_resolution.url;
                }
                else if (this.data.type == "video") {
                    postData.images = [];
                    postData.videoUrl = this.data.videos.standard_resolution.url;
                    if (postData.content.indexOf(postData.videoUrl) == -1) {
                        postData.content += ' ' + postData.videoUrl;
                    }
                }
                else if (this.data.type === 'carousel') {
                    var carousel_media = this.data.carousel_media.media;
                    if (!Array.isArray(carousel_media))
                        carousel_media = [carousel_media];
                    for (var i = 0, l = carousel_media.length; i < l; i++) {
                        var imageEl = carousel_media[i];
                        if (imageEl.standard_resolution == null || typeof imageEl.standard_resolution.url !== 'string') {
                            continue;
                        }
                        var url_n_2 = imageEl.standard_resolution.url;
                        postData.images.push({
                            src: url_n_2,
                            title: url_n_2,
                            filename: url_n_2.substring(url_n_2.lastIndexOf('/') + 1, url_n_2.lastIndexOf('.')) + '.jpg'
                        });
                    }
                }
                else {
                    if (!__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](this.data.images.standard_resolution.url)) {
                        url_n = this.data.media.src;
                    }
                }
                if (url_n != "" && postData.images.length === 0) {
                    image_data.src = url_n;
                    if (image_data.title == undefined) {
                        image_data.title = image_data.src;
                    }
                    image_data.filename = url_n.substring(url_n.lastIndexOf("/") + 1, url_n.lastIndexOf(".")) + '.jpg';
                    postData.images.push(image_data);
                }
                break;
            case 'youtube':
                postData.content = this.data.message;
                if (this.data.media
                    && this.data.media.video
                    && this.data.media.video.source_url) {
                    if (this.data.media.video.source_url.indexOf('embed') > 0) {
                        var new_self_data_media_video_url = this.data.media.video.source_url.split('?');
                        new_self_data_media_video_url = (new_self_data_media_video_url[0] != undefined) ? new_self_data_media_video_url[0].replace('embed/', 'watch?v=') : '';
                        postData.content = new_self_data_media_video_url;
                        postData.shared_url = new_self_data_media_video_url;
                    }
                    else {
                        postData.content += ' ' + this.data.media.video.source_url;
                        postData.shared_url = this.data.media.video.source_url;
                    }
                }
                break;
            case 'pinterest':
                postData.content = this.data.message.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
                postData.images.push({
                    src: this.data.media.src,
                    title: "",
                    filename: this.data.media.src
                });
                break;
            case 'googleplus':
                postData.content = (typeof this.data.message === 'object' ? '' : this.data.message);
                var testUrl = postData.content.match(/((?:(http|https|Http|Https|rtsp|Rtsp):\/\/(?:(?:[a-zA-Z0-9\$\-\_\.\+\!\*\'\(\)\,\;\?\&\=]|(?:\%[a-fA-F0-9]{2})){1,64}(?:\:(?:[a-zA-Z0-9\$\-\_\.\+\!\*\'\(\)\,\;\?\&\=]|(?:\%[a-fA-F0-9]{2})){1,25})?\@)?)?((?:(?:[a-zA-Z0-9][a-zA-Z0-9\-]{0,64}\.)+(?:(?:aero|arpa|asia|a[cdefgilmnoqrstuwxz])|(?:biz|b[abdefghijmnorstvwyz])|(?:cat|com|coop|c[acdfghiklmnoruvxyz])|d[ejkmoz]|(?:edu|e[cegrstu])|f[ijkmor]|(?:gov|g[abdefghilmnpqrstuwy])|h[kmnrtu]|(?:info|int|i[delmnoqrst])|(?:jobs|j[emop])|k[eghimnrwyz]|l[abcikrstuvy]|(?:mil|mobi|museum|m[acdghklmnopqrstuvwxyz])|(?:name|net|n[acefgilopruz])|(?:org|om)|(?:pro|p[aefghklmnrstwy])|qa|r[eouw]|s[abcdeghijklmnortuvyz]|(?:tel|travel|t[cdfghjklmnoprtvwz])|u[agkmsyz]|v[aceginu]|w[fs]|y[etu]|z[amw]))|(?:(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[1-9])\.(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[1-9]|0)\.(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[1-9]|0)\.(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[0-9])))(?:\:\d{1,5})?)(\/(?:(?:[a-zA-Z0-9\;\/\?\:\@\&\=\#\~\-\.\+\!\*\'\(\)\,\_])|(?:\%[a-fA-F0-9]{2}))*)?(?:\b|$)/ig);
                if (testUrl && testUrl.length) {
                    postData.links.push(decodeURIComponent(testUrl[0].trim()));
                }
                if (this.data.media && this.data.media.type) {
                    if (this.data.media.type == 'article' || this.data.media.type == 'video') {
                        postData.links.push(decodeURIComponent(this.data.media.url));
                        postData.content = postData.content + ' ' + decodeURIComponent(this.data.media.url);
                    }
                }
                if (postData.links && !postData.links.length) {
                    if (this.data.media && (this.data.media.image || this.data.media.fullImage)) {
                        postData.images.push({
                            src: (this.data.media.fullImage ? this.data.media.fullImage.url : this.data.media.image.url),
                            title: (this.data.media.content && !__WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["o" /* isEmptyObject */](this.data.media.content)),
                            filename: ''
                        });
                    }
                }
                break;
        }
        return postData;
    };
    FeedItem.prototype.getAssignedRoles = function () {
        var roles = [];
        var self_data = this.data[0] ? this.data[0] : this.data;
        if (Array.isArray(self_data.roles) && self_data.roles.length > 0) {
            roles = self_data.roles;
        }
        return roles;
    };
    /**
     * getAssignedTagsAndRoles
     */
    FeedItem.prototype.getAssignedTagsAndRoles = function () {
        var temMembers = '';
        if (this.header.assignedRoles) {
            if (Array.isArray(this.header.assignedRoles.selectedRoles) && this.header.assignedRoles.selectedRoles.length > 0) {
                for (var _i = 0, _a = this.header.assignedRoles.selectedRoles; _i < _a.length; _i++) {
                    var role = _a[_i];
                    if (role.enabled) {
                        temMembers += '<span class="badge badge-ios">' + role.displayName + '</span>';
                    }
                }
            }
        }
        var tags = '';
        if (this.header.eventTags) {
            if (Array.isArray(this.header.eventTags.selectedTagsArray) && this.header.eventTags.selectedTagsArray.length > 0) {
                for (var _b = 0, _c = this.header.eventTags.selectedTagsArray; _b < _c.length; _b++) {
                    var tag = _c[_b];
                    tags += '<span class="badge badge-ios">' + tag + '</span>';
                }
            }
        }
        return temMembers + tags;
    };
    /**
     * getUpdatedMessageText
     */
    FeedItem.prototype.removeRolesAndTagsFromMessageText = function () {
        var messageText = '';
        if (this.summary && this.summary.messageView && this.summary.messageView.messageText) {
            messageText = __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["s" /* removeRolesAndTagsFromHtml */](this.summary.messageView.messageText);
            console.log('33333::000', messageText);
        }
        return messageText;
    };
    FeedItem.prototype.getReviewReply = function () {
        var reviewReply = null;
        if (this.feed.id === 'gmbReviews' || this.data.eventType === 'GMBReviews') {
            if (this.data.reviewReply) {
                reviewReply = {
                    content: __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["r" /* new_url_to_link */](this.data.reviewReply.comment),
                    date: new Date(this.data.reviewReply.updateTime).getTime(),
                    profileName: '(owner)',
                    profileImage: this.feed.defaultProfileImage
                };
            }
        }
        if (this.feed.id === 'gmbQuestions' || this.data.eventType === 'GMBQuestions') {
            if (this.data.ownerAnswer) {
                var proPic = (this.data.ownerAnswer.author.profilePic) ? this.data.ownerAnswer.author.profilePic : this.feed.defaultProfileImage;
                reviewReply = {
                    content: __WEBPACK_IMPORTED_MODULE_0__feeds_feed_helper__["r" /* new_url_to_link */](this.data.ownerAnswer.summary),
                    date: new Date(this.data.ownerAnswer.updateTime).getTime(),
                    profileName: this.data.ownerAnswer.author.fromName,
                    profileImage: proPic
                };
            }
        }
        return reviewReply;
    };
    return FeedItem;
}());

//# sourceMappingURL=feed-item.js.map

/***/ }),

/***/ 62:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PublishingProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_publishing_service_publishing_map_post__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__publishing_service_publishing_validator__ = __webpack_require__(146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__publishing_service_post__ = __webpack_require__(481);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_moment__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_10_moment__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_moment_timezone__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_11_moment_timezone__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_12_jquery__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_uuid_v1__ = __webpack_require__(335);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_uuid_v1___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_13_uuid_v1__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__publishing_helper__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__ionic_storage__ = __webpack_require__(24);
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




//PROVIDERS












var PublishingProvider = /** @class */ (function () {
    function PublishingProvider(_http, _accountsServiceProvider, _publishingMapPostProvider, _appSettingsProvider, _publishingValidatorProvider, userSettingsProvider, ionicStorage) {
        var _this = this;
        this._http = _http;
        this._accountsServiceProvider = _accountsServiceProvider;
        this._publishingMapPostProvider = _publishingMapPostProvider;
        this._appSettingsProvider = _appSettingsProvider;
        this._publishingValidatorProvider = _publishingValidatorProvider;
        this.userSettingsProvider = userSettingsProvider;
        this.ionicStorage = ionicStorage;
        this._pastDays = 30;
        this.instagramPendingCountSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](0);
        this.instagramPendingCount$ = this
            .instagramPendingCountSource
            .asObservable();
        this.tikTokPendingCountSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](0);
        this.tikTokPendingCount$ = this
            .tikTokPendingCountSource
            .asObservable();
        this.brandSwitchSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        this.brandSwitch$ = this.brandSwitchSource.asObservable();
        this.tabSwitchSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        this.tabSwitch$ = this.tabSwitchSource.asObservable();
        this.contentUpdateSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        this.contentUpdate$ = this.contentUpdateSource.asObservable();
        this.IosShareSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        this.IosShare$ = this.IosShareSource.asObservable();
        this.isEditSource = new __WEBPACK_IMPORTED_MODULE_3_rxjs_BehaviorSubject__["BehaviorSubject"](false);
        this.isEdit$ = this.isEditSource.asObservable();
        this.postsByDate = {};
        this.postsByMonth = {};
        this.draftPostsByDate = {};
        this.postsByDateCache = {};
        this.calLastSelectedDate = null;
        this.sharedIntentData = {};
        //public instagramPostsByDate: {[key: number]: {[key: string]: Array<MappedPostInterface>}} = {};
        this.instagramPostsByDate = {};
        this.tikTokPostsByDate = {};
        this.checkEmptyAccounts = true;
        this.deletedIGPosts = [];
        this.deletedTikTokPosts = [];
        this.postsById = {};
        this.postDailyCounts = {};
        this.queuesContainer = {};
        this.queues = [];
        this.keyForPostFilterInStorage = 'post_filters';
        this.postTypeFilters = ["scheduled", "approved", "none", "autopost", "draft", "rejected"];
        this.roles = [];
        this.rolesByUsername = {};
        this.approverData = {
            approverLogo: 'assets/images/logo-text-lite.png',
            brandNameColor: "FFFFFF",
            headerBackgroundColor: '4d7cfe',
            approverDisplayName: 'eClincher',
            displayName: ""
        };
        this.post = new __WEBPACK_IMPORTED_MODULE_9__publishing_service_post__["a" /* Post */]({});
        this.userTimeZone = this.userSettingsProvider.getUserTimeZone();
        this.userSettingsProvider
            .userSettings$
            .subscribe(function (userSettings) {
            _this.userTimeZone = _this.userSettingsProvider.getUserTimeZone();
        });
    }
    ;
    PublishingProvider.prototype.createPost = function (postData) {
        if (postData === void 0) { postData = {}; }
        var post = new __WEBPACK_IMPORTED_MODULE_9__publishing_service_post__["a" /* Post */](postData);
        return post;
    };
    PublishingProvider.prototype.getErrorMessage = function (text) {
        return { status: false, message: text };
    };
    ;
    PublishingProvider.prototype.savePublishingPostAndSchedule = function (postData) {
        //if(1==1) return;
        postData.updateProfilesFlag();
        postData.updateAttachmentsFlag();
        var validationResult = null;
        if (!postData.accounts.length && !postData.addToApproval) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage('Please select at least one profile to post.'));
        }
        if (postData.has_instagram_profile || postData.has_blogger_profile || postData.has_twitter_profile || postData.has_linkedin_profile || postData.has_pinterest_profile
            || postData.has_fb_profile || postData.has_googleplus_profile || postData.has_googlemybusiness_profile || postData.has_youtube_profile || postData.has_tiktok_profile) {
            //Validate Character Limit
            validationResult = this._publishingValidatorProvider.validateTextLimit(postData);
            if (!validationResult.status) {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage(validationResult.text));
            }
            //Validate Attachments
            validationResult = this._publishingValidatorProvider.validateAttachments(postData, true);
            if (!validationResult.status) {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage(validationResult.text));
            }
            if (postData.has_video && (postData.has_blogger_profile
                // || postData.has_linkedin_profile
                || postData.has_googleplus_profile
                || postData.has_pinterest_profile
                || postData.has_googlemybusiness_profile)) {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage('Video attachment is only supported by Facebook, Twitter, LinkedIn and Instagram. Please edit your post.'));
            }
            if (postData.has_video && postData.has_image && !(postData.accounts.length === 1 && (postData.has_instagram_profile || postData.has_instagram_business_profile))) {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage('Video and Image cannot be Posted. Please Remove Image or Video.'));
            }
            if (postData.has_googlemybusiness_profile) {
                if (postData.content == null || postData.content.length === 0) {
                    return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage('Please write a message.'));
                }
            }
        }
        var content = postData.content.trim(); //for blocking messages with only spaces
        if (postData.attachments.length < 1 && content.length < 1) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage('Please write a message or add attachments to post.'));
        }
        console.info('savePublishingPostAndSchedule', postData);
        // Prepare Data
        var data = {
            accounts: [],
            groups: [],
            message: "",
            attachment: [],
            post_time: [],
            post_now: 'false',
            email_me: 'false',
            postId: postData.id,
            save: postData.id ? 'true' : 'false',
            link: "",
            links: [],
            group_subject: "",
            contentTitle: "",
            contentDescription: "",
            preview_content: "{}",
            pendingStatus: "",
            callsToAction: "",
            add_to_approval: (postData.addToApproval) ? 'true' : 'false',
            fb_boost_data: "[]",
            isIGStory: (postData.isIGStory) ? 'true' : 'false',
            pinterestLink: (postData.pinterestLink) ? postData.pinterestLink : ""
        };
        if (postData.pendingComment) {
            data.pendingComment = postData.pendingComment;
        }
        else if (data.add_to_approval && !postData.pendingComment) {
            data.pendingComment = this.preparePendingComments(postData, 'approval');
        }
        if (postData.fbContentReplacement) {
            data.fbContentReplacement = postData.fbContentReplacement;
        }
        if (postData.source === 'draft') {
            data.postId = null;
            data.save = 'false';
        }
        // callsToAction
        if (postData.callsToAction) {
            data.callsToAction = postData.callsToAction;
        }
        var callsToAction = __assign({}, postData.callsToAction);
        if (callsToAction
            && callsToAction.liAnnotations
            && callsToAction.liAnnotations.annotations.length) {
            data.callsToAction.liAnnotations = {};
            data.callsToAction.liAnnotations.annotations = JSON.stringify(callsToAction.liAnnotations.annotations);
        }
        console.log("fbContentReplacement", data);
        // Accounts
        for (var _i = 0, _a = postData.accounts; _i < _a.length; _i++) {
            var account = _a[_i];
            var temp = void 0;
            if (typeof account.isGroup === 'boolean' && account.isGroup && !__WEBPACK_IMPORTED_MODULE_12_jquery__["isEmptyObject"](account.group)) {
                if (!this.isProfileExists(data.accounts, account.group.profileId)) {
                    temp = {
                        accountID: account.profile.account_id,
                        profileID: account.profile.profile_id,
                        type: account.profile.display.network.backend_network_name.toLowerCase()
                    };
                }
            }
            else {
                temp = {
                    accountID: account.profile.account_id,
                    profileID: account.profile.profile_id,
                    type: account.profile.display.network.backend_network_name.toLowerCase()
                };
                if (account.profile.display.network.backend_network_name === 'Facebook'
                    && account.profile.data.groups && account.profile.data.groups.length) {
                    var group = {
                        profileID: account.profile.profile_id,
                        groupID: '_self_'
                    };
                    data.groups.push(group);
                }
            }
            if (temp) {
                data.accounts.push(temp);
            }
        }
        // Groups
        for (var _b = 0, _c = postData.accounts; _b < _c.length; _b++) {
            var account = _c[_b];
            if (typeof account.isGroup !== 'boolean' || !account.isGroup) {
                continue;
            }
            if (__WEBPACK_IMPORTED_MODULE_12_jquery__["isEmptyObject"](account.group)) {
                continue;
            }
            var group = {
                profileID: account.group.profileId,
                groupID: account.group.id
            };
            data.groups.push(group);
        }
        data.message = postData.content;
        console.log('updateContent', postData);
        // Attachments
        for (var _d = 0, _e = postData.attachments; _d < _e.length; _d++) {
            var att = _e[_d];
            var attachment = void 0;
            if (typeof att.url.isScrapped === 'boolean' && att.url.isScrapped) {
                attachment = {
                    name: att.originalData.name,
                    image: "",
                    type: 'file',
                    size: '0',
                    location: att.url.full,
                    s3_url: '',
                    imageThumbnail: '',
                    source: 'scrape',
                    imageUrlSource: att.url.full,
                    title: ''
                };
            }
            else if (att.originalData && att.originalData.id) {
                attachment = att.originalData;
            }
            else {
                attachment = {
                    name: att.originalData.name,
                    image: "",
                    type: (att.originalData.type == 'picture' || att.originalData.type.match(/image.*/)) ? "picture" : "video",
                    size: att.originalData.size,
                    location: att.originalData.location,
                    s3_url: att.originalData.s3_url,
                    imageThumbnail: att.originalData.imageThumbnail,
                    source: "upload"
                };
                if (attachment.type === 'picture') {
                    attachment.imageUrlSource = att.url.full;
                }
                if (attachment.type == 'video') {
                    attachment.s3_url = this._appSettingsProvider.getS3Url() + '/dev-eclincher/' + attachment.location;
                    attachment.imageThumbnail = att.url.thumbnail.replace(this._appSettingsProvider.getS3Url(), '');
                    attachment.imageThumbnail = attachment.imageThumbnail.substr(1);
                    if (att.originalData.videoData) {
                        attachment.videoData = att.originalData.videoData;
                    }
                }
                att.originalData.imageThumbnail;
                if (att.originalData.dimension) {
                    attachment.dimension = att.originalData.dimension;
                }
                if (att.originalData.imageUrlSource) {
                    attachment.imageUrlSource = att.originalData.imageUrlSource;
                }
            }
            data.attachment.push(attachment);
        }
        console.log('data.attachment', data.attachment);
        // ScheduleTimes
        for (var _f = 0, _g = postData.scheduledTimes; _f < _g.length; _f++) {
            var this_time = _g[_f];
            var t_str = '' + (this_time * 1000);
            if (t_str.length > 13)
                data.post_time.push(Number(t_str.slice(0, 10)));
            else
                data.post_time.push(this_time);
        }
        // Preview Content
        if (typeof postData.previewContent !== 'undefined' && !__WEBPACK_IMPORTED_MODULE_12_jquery__["isEmptyObject"](postData.previewContent)) {
            var preview_content = {
                title: postData.previewContent.title,
                description: postData.previewContent.description,
                url: postData.previewContent.url,
                image: {},
                twitter_tag: postData.previewContent.twitterTag,
                twitter_data: postData.previewContent.twitterData
            };
            for (var _h = 0, _j = postData.previewContent.image; _h < _j.length; _h++) {
                var img = _j[_h];
                var keys = Object.keys(img), temp = {};
                for (var _k = 0, keys_1 = keys; _k < keys_1.length; _k++) {
                    var k = keys_1[_k];
                    if (k !== 'previewContent') {
                        temp[k] = img[k];
                    }
                }
                preview_content.image = temp;
            }
            data.preview_content = JSON.stringify(preview_content);
            data.contentTitle = postData.previewContent.title;
            data.contentDescription = postData.previewContent.description;
            data.link = postData.link;
            data.links = postData.links;
        }
        if (postData.isPostNow == true) {
            var date = new Date(), new_time = (date.getTime() / 1000).toFixed(); // why must we divide by 1000?
            data.post_time.push(new_time);
            data.post_now = 'true';
            postData.postTime = new_time;
            data.isIGStory = 'false';
        }
        console.info('Before sending to server:::', data);
        // Validate GMB Event
        if (postData.has_googlemybusiness_profile && postData.callsToAction && postData.callsToAction.gmbEvent) {
            var gmbEventTime = this.getGmbEventTime(postData);
            var maxScheduledTime = Math.max.apply(null, data.post_time);
            if (maxScheduledTime >= gmbEventTime / 1000) {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of(this.getErrorMessage('Please schedule GMB event to a future date & time.'));
            }
        }
        // post approval
        if (postData.source && ['postapproval', 'draft'].indexOf(postData.source) === -1 && postData.addToApproval) {
            data.added_from_scheduled = true;
        }
        if (data.post_time.length == 0 && postData.addToApproval) {
            data.deleteAllTimes = 'true';
        }
        // if (1 === 1) {
        //   console.log('savePublishingPostAndSchedule', data);
        //   let error: any = {status: false, message: 'YYYYYYYYYY'};
        //   return Observable.of(error);
        // }
        console.log('savePostData', data);
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/publishing/store", data, httpOptions);
    };
    ; //end savePublishingPostAndSchedule
    PublishingProvider.prototype.preparePendingComments = function (postData, type) {
        var comments = __WEBPACK_IMPORTED_MODULE_12_jquery__["extend"]([], true, postData.pendingComment);
        if (type == "approval" || (postData.source && postData.source == 'approval')) {
            if (postData.id) {
                comments.push(__WEBPACK_IMPORTED_MODULE_10_moment__().format("MMM D, YYYY hh:mm a") + ", " + this.userSettingsProvider.getDisplayName() + ": Post updated.");
            }
            else {
                comments.push(__WEBPACK_IMPORTED_MODULE_10_moment__().format("MMM D, YYYY hh:mm a") + ", " + this.userSettingsProvider.getDisplayName() + ": Post created.");
            }
        }
        return comments;
    };
    PublishingProvider.prototype.sendPostsForApproval = function (data) {
        var params = {
            data: data,
            action: 'sendPostsForApproval'
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/sendPostsForApproval', params, httpOptions)
            .map(function (httpResponse) {
            console.log('httpResponse', httpResponse);
            return httpResponse;
        });
    };
    PublishingProvider.prototype.isProfileExists = function (accounts, profileId) {
        for (var i = 0; i < accounts.length; i++) {
            if (accounts[i].profileID === profileId)
                return true;
        }
        return false;
    };
    PublishingProvider.prototype.getCalendarList = function (data) {
        var _this = this;
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("start_date", data.startDate)
            .set("end_date", data.endDate)
            .set("includeFutureQueues", 'true')
            .set("postForDay", data.postForDay ? data.postForDay : "")
            .set("postType", data.postType ? JSON.stringify(data.postType) : "{}")
            .set("sampleId", data.sampleId ? JSON.stringify(data.sampleId) : "{}")
            .set("appVersion", '1.2.5');
        this.postsById = {};
        this.postsByDate = {};
        this.postsByMonth = {};
        return this
            ._http
            .get("/publishing/posts", { params: requestBody })
            .flatMap(function (result) {
            if (result['posts'] !== undefined) {
                if (result['posts']['post'] !== undefined)
                    result['posts']['post'] = Array.isArray(result['posts']['post']) ? result['posts']['post'] : [result['posts']['post']];
                if (result['posts']['daily'] !== undefined && result['posts']['daily']['day'] !== undefined)
                    result['posts']['daily']['day'] = Array.isArray(result['posts']['daily']['day']) ? result['posts']['daily']['day'] : [result['posts']['daily']['day']];
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(_this._prepareCalendarPostsList(result['posts'], data).then(function (mappedPostsByDate) {
                    var dateKeys = Object.keys(mappedPostsByDate);
                    for (var _i = 0, dateKeys_1 = dateKeys; _i < dateKeys_1.length; _i++) {
                        var dateKey = dateKeys_1[_i];
                        mappedPostsByDate[dateKey].sort(function (a, b) {
                            if (a.scheduledTime > b.scheduledTime) {
                                return 1;
                            }
                            else if (a.scheduledTime == b.scheduledTime) {
                                return 0;
                            }
                            else {
                                return -1;
                            }
                        });
                    }
                    //next to publish set
                    if (data.postForDay) {
                        if (mappedPostsByDate[data.postForDay] && data.postForDay == __WEBPACK_IMPORTED_MODULE_10_moment__().format('YYYY-MM-DD')) {
                            mappedPostsByDate[data.postForDay].find(function (x) {
                                if (x.source != 'approval' && x.source !== 'draft'
                                    && (parseInt(x.scheduledTime) / 1000) > __WEBPACK_IMPORTED_MODULE_10_moment__().unix()) {
                                    x.nextToPublish = true;
                                    return true;
                                }
                            });
                        }
                    }
                    // console.log('getCalendarList this.postsById',this.postsById);
                    //   console.log('getCalendarList this.postsByDate',this.postsByDate) ;
                    //     console.log('getCalendarList this.postsByDate',this.postsByMonth);
                    //     console.log('getCalendarList result',mappedPostsByDate);
                    return mappedPostsByDate;
                }));
            }
            else {
                _this.postsByDate = {};
                _this.postsByMonth = {};
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of({});
            }
        });
    };
    PublishingProvider.prototype._prepareCalendarPostsList = function (posts, data) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var promisableMappedPosts = [];
            var items = (posts.post) ? posts.post : [];
            var dailyCounts = (posts.daily && posts.daily.day) ? posts.daily.day : [];
            _this.postDailyCounts = {};
            for (var i = 0, p = items.length; i < p; i++) {
                if (items[i].originalPostId)
                    items[i].autoPostOriginalId = items[i].originalPostId; //autopost id
                if (items[i].sourceType && items[i].sourceType == "postApproval") {
                    items[i].source = 'approval';
                }
                else if (items[i].audit && items[i].audit == "postApproval") {
                    items[i].source = 'scheduledapproval';
                }
                else if (items[i].queueIdSource) {
                    items[i].source = 'autopost';
                }
                else if (items[i].source !== 'draft') {
                    items[i].source = 'scheduled';
                }
                var post = _this._publishingMapPostProvider.mapPost(items[i]);
                promisableMappedPosts.push(post);
            }
            _this.postsByDate = {};
            _this.postsByMonth = {};
            // let currentTime: number = moment().valueOf();
            var currentTime = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](_this.userTimeZone).valueOf() / 1000;
            //postDailyCounts
            for (var k = 0; k < dailyCounts.length; k++) {
                _this.postDailyCounts[dailyCounts[k].date] = dailyCounts[k].total;
            }
            if (items.length == 0) {
                resolve(_this.postsByDate);
                return;
            }
            Promise.all(promisableMappedPosts).then(function (mappedPosts) {
                for (var _i = 0, mappedPosts_1 = mappedPosts; _i < mappedPosts_1.length; _i++) {
                    var post = mappedPosts_1[_i];
                    if (post.source == 'autopost' && post.queueIdSource && post.queueTypeSource) {
                        post.editorType = 'autoPostEditor';
                        post.queues = [{ queueId: post.queueIdSource, type: post.queueTypeSource }];
                    }
                    if (post.source == 'approval' && !_this.userSettingsProvider.isAdmin()) {
                        if (!_this.checkPostPermission(post))
                            continue;
                    }
                    for (var i_1 = 0; i_1 < post.scheduledTimes.length; i_1++) {
                        var date = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](new Date(parseInt(post.scheduledTimes[i_1]) * 1000), _this.userTimeZone);
                        var dateKey = date.format('YYYY-MM-DD');
                        var monthKey = date.format('YYYY-MM');
                        var scheduledTime = parseInt(post.scheduledTimes[i_1]) * 1000;
                        console.log('_prepareCalendarPostsList this.postsByDate', parseInt(post.scheduledTimes[i_1]) * 1000);
                        var calendarData = {
                            scheduledTime: scheduledTime,
                            id: post.id,
                            uniqId: __WEBPACK_IMPORTED_MODULE_14__publishing_helper__["p" /* unique_name_with_uuid */](),
                            source: post.source,
                            isDraftPost: false,
                            buttons: {
                                duplicatePost: true,
                                edit: true,
                                delete: date.valueOf() > currentTime
                            }
                        };
                        if (post.queueTypeSource && post.queueTypeSource != '') {
                            calendarData.buttons.edit = false;
                            calendarData.buttons.delete = false;
                        }
                        var clonedPost = __WEBPACK_IMPORTED_MODULE_12_jquery__["extend"](true, {}, post); //JSON.parse(JSON.stringify(post));
                        clonedPost.calendarData = {
                            scheduledTime: scheduledTime.toString(),
                            isDraftPost: false,
                            buttons: {
                                duplicatePost: true,
                                edit: true,
                                delete: parseInt(post.scheduledTimes[i_1]) > currentTime
                            }
                        };
                        if (parseInt(post.scheduledTimes[i_1]) > currentTime) {
                            clonedPost.calendarData.buttons.delete = true;
                        }
                        if (post.queueTypeSource && post.queueTypeSource != '') {
                            clonedPost.calendarData.buttons.edit = false;
                            clonedPost.calendarData.buttons.delete = false;
                        }
                        _this.postsById[post.id] = clonedPost;
                        if (typeof _this.postsByDate[dateKey] == 'undefined')
                            _this.postsByDate[dateKey] = [];
                        if (typeof _this.postsByMonth[monthKey] == 'undefined')
                            _this.postsByMonth[monthKey] = [];
                        if (!data.postForDay || data.postForDay == dateKey) {
                            _this.postsByDate[dateKey].push(calendarData);
                            _this.postsByMonth[monthKey].push(calendarData);
                        }
                    }
                }
                // sort postsByMonth
                var dateKeys = Object.keys(_this.postsByMonth);
                for (var _a = 0, dateKeys_2 = dateKeys; _a < dateKeys_2.length; _a++) {
                    var dateKey = dateKeys_2[_a];
                    _this.postsByMonth[dateKey].sort(function (a, b) {
                        if (a.scheduledTime > b.scheduledTime)
                            return 1;
                        else if (a.scheduledTime == b.scheduledTime)
                            return 0;
                        else
                            return -1;
                    });
                }
                console.log('_prepareCalendarPostsList this.postsByDate', _this.postsByDate);
                console.log('_prepareCalendarPostsList this.postsByMonth', _this.postsByMonth);
                console.log("dailyCounts", _this.postDailyCounts);
                resolve(_this.postsByDate);
            });
        });
    };
    PublishingProvider.prototype.checkPostPermission = function (post) {
        var check_Ids = [];
        if (['agency', 'profiles'].indexOf(this.userSettingsProvider.getLicenseType().toLowerCase()) !== -1) {
            var selectedBrand = this.userSettingsProvider.getSelectedClient();
            if (selectedBrand)
                check_Ids[selectedBrand.id] = selectedBrand.id;
        }
        else {
            for (var _i = 0, _a = post.accounts; _i < _a.length; _i++) {
                var acc = _a[_i];
                check_Ids[acc.profile.profile_id] = acc.profile.profile_id;
            }
        }
        // console.log('$filterd_roles',$filterd_roles);                   
        var hasPermission = false;
        // let filteredUsers = this.FilterTeamMembersByPermission(this.roles, check_Ids, ['admin', 'edit', 'view']);
        // for (let fRole of filteredUsers) {
        //   if (fRole['userName'].toLowerCase() === this.userSettingsProvider.getUserName().toLowerCase()) hasPermission = true;
        // }
        // if (!hasPermission) {
        //   return false;
        // }
        return true;
    };
    PublishingProvider.prototype.FilterTeamMembersByPermission = function (teamMembers, checkIds, permissions) {
        if (teamMembers === void 0) { teamMembers = {}; }
        if (checkIds === void 0) { checkIds = {}; }
        if (permissions === void 0) { permissions = ""; }
        var filtedUsers = [];
        permissions = (permissions) ? permissions : ['admin', 'edit'];
        for (var memberId in teamMembers) {
            if (!Object.keys(checkIds).length
                || (teamMembers[memberId]['role'] == 'postApprovalUser' && !this.userSettingsProvider.isAgency())
                || teamMembers[memberId]['masterAccountsPermission'] == 'true') {
                filtedUsers.push(teamMembers[memberId]);
            }
            else /*if (teamMembers[memberId]['role'] == 'eClincherUser')*/ {
                try {
                    var addRole = false;
                    for (var id in checkIds) {
                        var hasAccPermission = false;
                        if (teamMembers[memberId]['accountPermissions'] && teamMembers[memberId]['accountPermissions']['account']) {
                            var accounts = (teamMembers[memberId]['accountPermissions']['account'][0] != undefined) ? teamMembers[memberId]['accountPermissions']['account'] : [teamMembers[memberId]['accountPermissions']['account']];
                            for (var _i = 0, accounts_1 = accounts; _i < accounts_1.length; _i++) {
                                var account = accounts_1[_i];
                                var sampleId = "", permission = "";
                                if (account['config'] && account['config']['sampleId']) {
                                    sampleId = account['config']['sampleId'];
                                }
                                if (account['config'] && account['config']['permission']) {
                                    permission = account['config']['permission'];
                                }
                                if (permissions.indexOf(permission) != -1 && sampleId && id == sampleId) {
                                    hasAccPermission = true;
                                    break;
                                }
                            }
                        }
                        else if (teamMembers[memberId]['accountPermissions']
                            && teamMembers[memberId]['accountPermissions']['client']) {
                            var clients = (teamMembers[memberId]['accountPermissions']['client'][0] != undefined) ?
                                teamMembers[memberId]['accountPermissions']['client'] :
                                [teamMembers[memberId]['accountPermissions']['client']];
                            for (var _a = 0, clients_1 = clients; _a < clients_1.length; _a++) {
                                var client = clients_1[_a];
                                var clientId = "", permission = "";
                                if (client['clientId']) {
                                    clientId = client['clientId'];
                                }
                                if (client['permission']) {
                                    permission = client['permission'];
                                }
                                if ((permissions.indexOf(permission) != -1) && clientId && id == clientId) {
                                    hasAccPermission = true;
                                    break;
                                }
                            }
                        }
                        if (hasAccPermission) {
                            addRole = true;
                        }
                        else {
                            addRole = false;
                            break;
                        }
                    }
                    if (addRole) {
                        filtedUsers.push(teamMembers[memberId]);
                    }
                }
                catch (e) {
                    console.log('filter roles error' + e);
                }
            }
        }
        return filtedUsers;
    };
    // public getCalendarList(data: CalendarListInterface): Observable<{ [key: number]: Array<MappedPostInterface> }> {
    //   let requestBody = new HttpParams()
    //     .set("start_date", data.startDate)
    //     .set("end_date", data.endDate)
    //     .set("includeFutureQueues", 'true')
    //   return this
    //     ._http
    //     .get<HttpResponse<any>>("/publishing/posts", { params: requestBody })
    //     .flatMap(result => {
    //       if (result['post'] !== undefined) {
    //         result['post'] = Array.isArray(result['post']) ? result['post'] : [result['post']];
    //         return Observable.fromPromise(this._preparePosts(result['post']).then(mappedPostsByDate => {
    //           //sorting
    //           let dateKeys: Array<string> = Object.keys(mappedPostsByDate);
    //           for (let dateKey of dateKeys) {
    //             mappedPostsByDate[dateKey].sort(function (a, b) {
    //               let time_a: number = parseInt(a.calendarData.scheduledTime);
    //               let time_b: number = parseInt(b.calendarData.scheduledTime);
    //               if (time_a > time_b) {
    //                 return 1;
    //               } else if (time_a == time_b) {
    //                 return 0;
    //               }
    //               else {
    //                 return -1;
    //               }
    //             })
    //           }
    //           return mappedPostsByDate;
    //         }));
    //       }
    //       else {
    //         return Observable.of({});
    //       }
    //     });
    // }; //end getCalendarList
    PublishingProvider.prototype._preparePosts = function (items) {
        var _this = this;
        console.log('promisableMappedPosts', items);
        return new Promise(function (resolve, reject) {
            var promisableMappedPosts = [];
            for (var i = 0, p = items.length; i < p; i++) {
                // items[i].source = 'scheduled';
                // items[i].source = 'scheduled';
                promisableMappedPosts.push(_this._publishingMapPostProvider.mapPost(items[i]));
            }
            _this.postsByDate = {};
            _this.postsByMonth = {};
            var currentTime = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](_this.userTimeZone).valueOf() / 1000;
            Promise.all(promisableMappedPosts).then(function (mappedPosts) {
                for (var _i = 0, mappedPosts_2 = mappedPosts; _i < mappedPosts_2.length; _i++) {
                    var post = mappedPosts_2[_i];
                    var _loop_1 = function (i_2) {
                        var date = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](parseInt(post.scheduledTimes[i_2]) * 1000, _this.userTimeZone), dateKey = date.format('YYYY-MM-DD'), monthKey = date.format('YYYY-MM');
                        //post.calendarScheduledTime = ''+parseInt(scheduledTime)*1000;
                        var clonedPost = __WEBPACK_IMPORTED_MODULE_12_jquery__["extend"](true, {}, post);
                        ; //JSON.parse(JSON.stringify(post));
                        clonedPost.calendarData = {
                            scheduledTime: '' + parseInt(post.scheduledTimes[i_2]) * 1000,
                            isDraftPost: false,
                            buttons: {
                                duplicatePost: true,
                                edit: true
                            }
                        };
                        if (parseInt(post.scheduledTimes[i_2]) > currentTime) {
                            clonedPost.calendarData.buttons.delete = true;
                        }
                        var instagramCodes = _this._getInstagramCodes(clonedPost);
                        var hiddenProfiles = [];
                        Object.keys(instagramCodes).forEach(function (key) {
                            if (instagramCodes[key].length && instagramCodes[key] === 'PENDING')
                                hiddenProfiles.push(key);
                        });
                        var flag = false;
                        for (var _i = 0, _a = clonedPost.accounts; _i < _a.length; _i++) {
                            var mappedInput = _a[_i];
                            if (mappedInput.profile && hiddenProfiles.indexOf(mappedInput.profile.profile_id) === -1) {
                                flag = true;
                            }
                            else {
                                mappedInput.selected = false;
                            }
                        }
                        if (!flag)
                            return "continue";
                        if (typeof _this.postsByDate[dateKey] == 'undefined')
                            _this.postsByDate[dateKey] = [];
                        if (typeof _this.postsByMonth[monthKey] == 'undefined')
                            _this.postsByMonth[monthKey] = [];
                        // this.postsByDate[dateKey].push(clonedPost);
                        // this.postsByMonth[monthKey].push(clonedPost);
                    };
                    for (var i_2 = 0; i_2 < post.scheduledTimes.length; i_2++) {
                        _loop_1(i_2);
                    }
                }
                console.log('this.postsByDate', _this.postsByDate);
                resolve(_this.postsByDate);
            });
        });
    };
    PublishingProvider.prototype.getDraftPost = function (data) {
        var _this = this;
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("filter", data.filter)
            .set("start_date", data.startDate)
            .set("end_date", data.endDate)
            .set("appVersion", '1.2.5');
        return this
            ._http
            .get("/publishing/posts", { params: requestBody })
            .flatMap(function (resp) {
            var httpResponse = resp;
            if (httpResponse.savedUrls == undefined || httpResponse.savedUrls.savedUrl == undefined) {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of([]);
            }
            var items = httpResponse.savedUrls.savedUrl;
            if (!Array.isArray(items)) {
                items = [items];
            }
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(_this._prepareDraftPosts(items).then(function (mappedDraftPosts) {
                return mappedDraftPosts;
            }));
        });
    };
    ; //end getDraftPost
    PublishingProvider.prototype._prepareDraftPosts = function (items) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var promisableMappedPosts = [];
            for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                var item = items_1[_i];
                var title = _this.isEmptyObject(item.text) ? '' : item.text;
                // isIGStory: (postData.isIGStory)?'true':'false',
                // callsToAction:(postData.callsToAction)?postData.callsToAction:{}
                var post = {
                    id: item.id,
                    accounts: {},
                    postTime: item.postTime,
                    draftTime: item.date.slice(0, 10),
                    content: _this.isEmptyObject(item.description) ? title : item.description,
                    postTitle: title,
                    link: _this.isEmptyObject(item.url) ? '' : item.url,
                    links: item.links,
                    fbContentReplacement: item.fbContentReplacement,
                    twTweetSampleId: item.twTweetSampleId,
                    preview_content: (item.preview_content != undefined) ? item.preview_content : "",
                    source: 'draft',
                    isIGStory: (item.isIGStory == "true") ? true : false,
                    callsToAction: (item.callsToAction) ? item.callsToAction : {}
                };
                // console.log(post.content, item);
                if (item.accounts && !_this.isEmptyObject(item.accounts)) {
                    post.accounts = { account: [] };
                    if (!Array.isArray(item.accounts.account))
                        post.accounts.account = [item.accounts.account];
                    else
                        post.accounts.account = item.accounts.account;
                    var flag = true;
                    if (_this.userSettingsProvider.getLicenseType() === 'premier' && !_this.userSettingsProvider.isAdmin()) {
                        for (var i = 0; i < post.accounts.account.length; i++) {
                            var account = post.accounts.account[i];
                            if (account && account.config && account.config.sampleId) {
                                var profile = _this._accountsServiceProvider.getProfileByID(account.config.sampleId);
                                // console.log(post.content, profile);
                                if (!profile) {
                                    flag = false;
                                    break;
                                }
                            }
                        }
                    }
                    if (!flag) {
                        continue;
                    }
                }
                if (item.attachments != undefined && !_this.isEmptyObject(item.attachments)) {
                    post.postAttachment = item.attachments.postAttachment;
                }
                promisableMappedPosts.push(_this._publishingMapPostProvider.mapPost(post));
            }
            _this.draftPostsByDate = {};
            var currentTime = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](_this.userTimeZone).valueOf() / 1000;
            Promise.all(promisableMappedPosts).then(function (mappedPosts) {
                for (var _i = 0, mappedPosts_3 = mappedPosts; _i < mappedPosts_3.length; _i++) {
                    var post = mappedPosts_3[_i];
                    post.calendarData = {
                        scheduledTime: '' + parseInt(post.draftTime) * 1000,
                        isDraftPost: true,
                        buttons: {
                            duplicatePost: true,
                            edit: true,
                            delete: true
                        }
                    };
                    // remove all schedules
                    // post.scheduledTimes = [];
                }
                resolve(mappedPosts);
            });
        });
    };
    PublishingProvider.prototype.saveToDraftPost = function (postData) {
        console.info('PublishingProvider - savePublishingPostNow.', postData);
        var linksList = [];
        if (postData.links && postData.links.length > 0) {
            for (var _i = 0, _a = postData.links; _i < _a.length; _i++) {
                var link = _a[_i];
                linksList.push({ link: link });
            }
        }
        var saved_post = {
            savedUrls: {
                savedUrl: {
                    description: postData.content,
                    text: postData.subject,
                    post_time: [],
                    date: new Date().getTime(),
                    url: postData.link,
                    links: linksList,
                    id: postData.id,
                    accounts: [],
                    attachments: [],
                    preview_content: null,
                    isIGStory: (postData.isIGStory) ? 'true' : 'false'
                }
            }
        };
        if (postData.callsToAction) {
            saved_post.savedUrls.savedUrl.callsToAction = postData.callsToAction;
        }
        if (postData.fbContentReplacement) {
            saved_post.savedUrls.savedUrl.fbContentReplacement = postData.fbContentReplacement;
        }
        // ScheduleTimes
        for (var _b = 0, _c = postData.scheduledTimes; _b < _c.length; _b++) {
            var this_time = _c[_b];
            var t_str = '' + (this_time * 1000);
            if (t_str.length > 13)
                saved_post.savedUrls.savedUrl.post_time.push(Number(t_str.slice(0, 10)));
            else
                saved_post.savedUrls.savedUrl.post_time.push(this_time);
        }
        // Attachments
        for (var _d = 0, _e = postData.attachments; _d < _e.length; _d++) {
            var att = _e[_d];
            var attachment = void 0;
            if (typeof att.url.isScrapped === 'boolean' && att.url.isScrapped) {
                attachment = {
                    postAttachment: {
                        name: att.originalData.name,
                        image: "",
                        type: 'file',
                        size: '0',
                        location: att.url.full,
                        s3_url: '',
                        imageThumbnail: '',
                        source: 'scrape',
                        imageUrlSource: att.url.full,
                        title: ''
                    }
                };
            }
            else {
                attachment = {
                    postAttachment: {
                        type: (att.originalData.type == 'picture' || att.originalData.type.match(/image.*/)) ? "picture" : "video",
                        name: att.originalData.filename || att.originalData.name,
                        source: "upload"
                    }
                };
                if (att.originalData.location) {
                    attachment.postAttachment.location = att.originalData.location;
                }
                if (att.originalData.videoData) {
                    attachment.postAttachment.videoData = att.originalData.videoData;
                }
                if (att.originalData.imageUrlSource) {
                    attachment.postAttachment.imageUrlSource = att.originalData.imageUrlSource;
                }
                if (att.originalData.imageThumbnail) {
                    attachment.postAttachment.imageThumbnail = att.originalData.imageThumbnail;
                }
            }
            saved_post.savedUrls.savedUrl.attachments.push(attachment);
        }
        var accounts = {};
        // Accounts
        for (var _f = 0, _g = postData.accounts; _f < _g.length; _f++) {
            var currentAccount = _g[_f];
            var account = {
                account: {
                    accountId: currentAccount.profile.account_id,
                    type: currentAccount.profile.display.network.backend_network_name.toLowerCase(),
                    config: {
                        profileId: currentAccount.profile.profile_id
                    }
                }
            };
            //include group
            if (currentAccount.profile.display.network.backend_network_name === 'Facebook') {
                if (typeof currentAccount.isGroup === 'boolean' && currentAccount.isGroup && currentAccount.group) {
                    account.account.config.facebookGroupsList = currentAccount.group.id;
                }
                else if (currentAccount.profile.data.groups && currentAccount.profile.data.groups.length) {
                    account.account.config.facebookGroupsList = '_self_';
                }
            }
            if (typeof accounts[currentAccount.profile.profile_id] === 'undefined') {
                accounts[currentAccount.profile.profile_id] = [];
            }
            accounts[currentAccount.profile.profile_id].push(account);
            //saved_post.savedUrls.savedUrl.accounts.push( account );
        }
        console.log('accounts', accounts);
        var profileIds = Object.keys(accounts);
        for (var _h = 0, profileIds_1 = profileIds; _h < profileIds_1.length; _h++) {
            var profileId = profileIds_1[_h];
            var account = void 0;
            for (var i in accounts[profileId]) {
                if (parseInt(i) === 0) {
                    account = accounts[profileId][i];
                    continue;
                }
                if (account.account.config.facebookGroupsList) {
                    account.account.config.facebookGroupsList += ',' + accounts[profileId][i].account.config.facebookGroupsList;
                }
            }
            if (account) {
                saved_post.savedUrls.savedUrl.accounts.push(account);
            }
        }
        // Preview Content
        if (typeof postData.previewContent !== 'undefined' && !__WEBPACK_IMPORTED_MODULE_12_jquery__["isEmptyObject"](postData.previewContent)) {
            var preview_content = {
                title: postData.previewContent.title,
                description: postData.previewContent.description,
                url: postData.previewContent.url,
                image: [],
                twitter_tag: postData.previewContent.twitterTag,
                twitter_data: postData.previewContent.twitterData
            };
            for (var _j = 0, _k = postData.previewContent.image; _j < _k.length; _j++) {
                var img = _k[_j];
                var keys = Object.keys(img), temp = {};
                for (var _l = 0, keys_2 = keys; _l < keys_2.length; _l++) {
                    var k = keys_2[_l];
                    if (k !== 'previewContent') {
                        temp[k] = img[k];
                    }
                }
                preview_content.image.push(temp);
            }
            saved_post.savedUrls.savedUrl.preview_content = JSON.stringify(preview_content);
        }
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        var data = {
            action: 'savedUrls',
            data: saved_post
        };
        console.log('data before sending to server::', data);
        return this
            ._http
            .post("/publishing/schedulePost", data, httpOptions);
    };
    ; //end saveToDraftPost
    PublishingProvider.prototype.getInstagramPendingNotifications = function (disableLoader) {
        var _this = this;
        if (disableLoader === void 0) { disableLoader = false; }
        var instagramProfiles = this._accountsServiceProvider.getMontitoredProfilesByType(['Instagram', 'InstaBusiness']);
        if (!instagramProfiles.length) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of({});
        }
        var toDate = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"]().valueOf(), fromDate = toDate - (this._pastDays * 60 * 24 * 60 * 1000) + '';
        var x = __WEBPACK_IMPORTED_MODULE_10_moment__(toDate).subtract(this._pastDays, 'days').valueOf();
        console.log("getInstagramPendingNotifications", x);
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("start_date", fromDate)
            .set("end_date", toDate);
        if (disableLoader) {
            requestBody = requestBody.set('disableLoader', 'true');
        }
        for (var _i = 0, instagramProfiles_1 = instagramProfiles; _i < instagramProfiles_1.length; _i++) {
            var instagramProfile = instagramProfiles_1[_i];
            requestBody = requestBody.append("sampleIDs[]", instagramProfile.profile_id);
        }
        return this
            ._http
            .get("/publishing/posts", { params: requestBody })
            .flatMap(function (data) {
            var items = [];
            if (Array.isArray(data.post))
                items = data.post;
            else if (typeof data.post == 'object' && !Array.isArray(data.post))
                items.push(data.post);
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(_this._prepareIGPendingPosts(items, fromDate, toDate).then(function (mappedPostsByDate) {
                return mappedPostsByDate;
            }));
        });
    };
    ; //end getDraftPost
    PublishingProvider.prototype._prepareIGPendingPosts = function (items, fromDate, toDate) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            console.log("_prepareIGPendingPosts", items);
            var mappedAccounts = _this._accountsServiceProvider.accountsSource.value;
            if (!mappedAccounts) {
                _this.instagramPendingCountSource.next(0);
                resolve({});
            }
            var promisableMappedPosts = [];
            for (var i = 0, p = items.length; i < p; i++) {
                if (items[i].source != 'draft') {
                    items[i].source = 'scheduled';
                    promisableMappedPosts.push(_this._publishingMapPostProvider.mapPost(items[i]));
                }
            }
            _this.instagramPostsByDate = {};
            var currentTime = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](_this.userTimeZone).valueOf() / 1000;
            var count = 0;
            Promise.all(promisableMappedPosts).then(function (mappedPosts) {
                // console.log('mappedPosts', mappedPosts);
                // console.log('fromDate', fromDate);
                // console.log('toDate', toDate);
                for (var _i = 0, mappedPosts_4 = mappedPosts; _i < mappedPosts_4.length; _i++) {
                    var post = mappedPosts_4[_i];
                    for (var i_3 = 0; i_3 < post.scheduledTimes.length; i_3++) {
                        var date = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](parseInt(post.scheduledTimes[i_3]) * 1000, _this.userTimeZone);
                        var key = (date.unix() * 1000);
                        var clonedPost = __WEBPACK_IMPORTED_MODULE_12_jquery__["extend"](true, {}, post);
                        ; //JSON.parse(JSON.stringify(post));
                        clonedPost.calendarData = {
                            scheduledTime: '' + parseInt(post.scheduledTimes[i_3]) * 1000,
                            isDraftPost: false,
                            buttons: {
                                duplicatePost: true,
                                edit: true
                            }
                        };
                        // let instagramCodes = this._getInstagramCodes(clonedPost);
                        //       console.log('222AA',clonedPost.content, instagramCodes, clonedPost);
                        // console.log('toDate', toDate, post.accounts.length,key, date.valueOf(), momentTimezone.tz().valueOf());
                        if (key >= parseInt(fromDate) && key <= (parseInt(toDate) - 1000) && clonedPost.accounts.length) {
                            if (date.valueOf() > __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"]().valueOf()) {
                                console.log('111', date.valueOf(), __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"]().valueOf());
                            }
                            else {
                                for (var _a = 0, _b = clonedPost.accounts; _a < _b.length; _a++) {
                                    var account = _b[_a];
                                    if (account.profile !== undefined && account.profile) {
                                        if (['Instagram', 'InstaBusiness'].indexOf(account.profile.display.network.backend_network_name) === -1) {
                                            continue;
                                        }
                                        var SID = account.profile.profile_id;
                                        var instagramCodes = _this._getInstagramCodes(clonedPost);
                                        if (typeof instagramCodes[SID] === 'undefined' || (typeof instagramCodes[SID] === 'string' && (instagramCodes[SID] === 'PENDING' /*|| instagramCodes[SID].indexOf("PENDING") != -1*/)) || _this.isEmptyObject(instagramCodes)) {
                                            if (_this.deletedIGPosts.indexOf(clonedPost.id + ':' + SID) === -1) {
                                                if (_this.instagramPostsByDate[key] == undefined) {
                                                    _this.instagramPostsByDate[key] = {};
                                                }
                                                if (!_this.instagramPostsByDate[key][SID])
                                                    _this.instagramPostsByDate[key][SID] = [];
                                                _this.instagramPostsByDate[key][SID].push(clonedPost);
                                                count++;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                //trigger instagrm-count
                _this.instagramPendingCountSource.next(count);
                resolve(_this.instagramPostsByDate);
            });
        });
    };
    PublishingProvider.prototype.getTikTokPendingNotifications = function (disableLoader) {
        var _this = this;
        if (disableLoader === void 0) { disableLoader = false; }
        var tikTokProfiles = this._accountsServiceProvider.getMontitoredProfilesByType(['TikTok']);
        if (!tikTokProfiles.length) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of({});
        }
        var toDate = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"]().valueOf(), fromDate = toDate - (this._pastDays * 60 * 24 * 60 * 1000) + '';
        var x = __WEBPACK_IMPORTED_MODULE_10_moment__(toDate).subtract(this._pastDays, 'days').valueOf();
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("start_date", fromDate)
            .set("end_date", toDate);
        if (disableLoader) {
            requestBody = requestBody.set('disableLoader', 'true');
        }
        for (var _i = 0, tikTokProfiles_1 = tikTokProfiles; _i < tikTokProfiles_1.length; _i++) {
            var tikTokProfile = tikTokProfiles_1[_i];
            requestBody = requestBody.append("sampleIDs[]", tikTokProfile.profile_id);
        }
        return this
            ._http
            .get("/publishing/posts", { params: requestBody })
            .flatMap(function (data) {
            var items = [];
            if (Array.isArray(data.post))
                items = data.post;
            else if (typeof data.post == 'object' && !Array.isArray(data.post))
                items.push(data.post);
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(_this._prepareTikTokPendingPosts(items, fromDate, toDate).then(function (mappedPostsByDate) {
                return mappedPostsByDate;
            }));
        });
    };
    ; //end getDraftPost
    PublishingProvider.prototype._prepareTikTokPendingPosts = function (items, fromDate, toDate) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var mappedAccounts = _this._accountsServiceProvider.accountsSource.value;
            if (!mappedAccounts) {
                _this.tikTokPendingCountSource.next(0);
                resolve({});
            }
            var promisableMappedPosts = [];
            for (var i = 0, p = items.length; i < p; i++) {
                if (items[i].source != 'draft') {
                    items[i].source = 'scheduled';
                    promisableMappedPosts.push(_this._publishingMapPostProvider.mapPost(items[i]));
                }
            }
            _this.tikTokPostsByDate = {};
            var currentTime = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](_this.userTimeZone).valueOf() / 1000;
            var count = 0;
            Promise.all(promisableMappedPosts).then(function (mappedPosts) {
                // console.log('mappedPosts', mappedPosts);
                // console.log('fromDate', fromDate);
                // console.log('toDate', toDate);
                for (var _i = 0, mappedPosts_5 = mappedPosts; _i < mappedPosts_5.length; _i++) {
                    var post = mappedPosts_5[_i];
                    for (var i_4 = 0; i_4 < post.scheduledTimes.length; i_4++) {
                        var date = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](parseInt(post.scheduledTimes[i_4]) * 1000, _this.userTimeZone);
                        var key = (date.unix() * 1000);
                        var clonedPost = __WEBPACK_IMPORTED_MODULE_12_jquery__["extend"](true, {}, post);
                        ; //JSON.parse(JSON.stringify(post));
                        clonedPost.calendarData = {
                            scheduledTime: '' + parseInt(post.scheduledTimes[i_4]) * 1000,
                            isDraftPost: false,
                            buttons: {
                                duplicatePost: true,
                                edit: true
                            }
                        };
                        // let instagramCodes = this._getInstagramCodes(clonedPost);
                        //       console.log('222AA',clonedPost.content, instagramCodes, clonedPost);
                        // console.log('toDate', toDate, post.accounts.length,key, date.valueOf(), momentTimezone.tz().valueOf());
                        if (key >= parseInt(fromDate) && key <= (parseInt(toDate) - 1000) && clonedPost.accounts.length) {
                            if (date.valueOf() > __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"]().valueOf()) {
                                console.log('111', date.valueOf(), __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"]().valueOf());
                            }
                            else {
                                for (var _a = 0, _b = clonedPost.accounts; _a < _b.length; _a++) {
                                    var account = _b[_a];
                                    if (account.profile !== undefined && account.profile) {
                                        if (['TikTok'].indexOf(account.profile.display.network.backend_network_name) === -1) {
                                            continue;
                                        }
                                        var SID = account.profile.profile_id;
                                        var tikTokCodes = _this._getTikTokCodes(clonedPost);
                                        if (typeof tikTokCodes[SID] === 'undefined' || (typeof tikTokCodes[SID] === 'string' && tikTokCodes[SID] === 'PENDING') || _this.isEmptyObject(tikTokCodes)) {
                                            if (_this.deletedTikTokPosts.indexOf(clonedPost.id + ':' + SID) === -1) {
                                                if (_this.tikTokPostsByDate[key] == undefined) {
                                                    _this.tikTokPostsByDate[key] = {};
                                                }
                                                if (!_this.tikTokPostsByDate[key][SID])
                                                    _this.tikTokPostsByDate[key][SID] = [];
                                                _this.tikTokPostsByDate[key][SID].push(clonedPost);
                                                count++;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                //trigger instagrm-count
                _this.tikTokPendingCountSource.next(count);
                resolve(_this.tikTokPostsByDate);
            });
        });
    };
    PublishingProvider.prototype.deletePost = function (id) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("id", id);
        return this
            ._http
            .post("/publishing/deleteScheduledPost", requestBody);
    };
    PublishingProvider.prototype.deleteDraftPost = function (id) {
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("id", id)
            .set('action', 'deleteUnscheduledPosts');
        return this
            ._http
            .post("/publishing/deleteUnscheduledPosts", requestBody);
    };
    PublishingProvider.prototype._getInstagramCodes = function (post) {
        var instagramCodes = {};
        for (var _i = 0, _a = post.postTime; _i < _a.length; _i++) {
            var postTime = _a[_i];
            var executions = postTime.executions, resultData = (!this.isEmptyObject(executions) ? executions.resultData : {});
            if (!this.isEmptyObject(resultData)) {
                if (!Array.isArray(resultData))
                    resultData = [resultData];
                for (var _b = 0, resultData_1 = resultData; _b < resultData_1.length; _b++) {
                    var result = resultData_1[_b];
                    if (result.sampleId) {
                        var profile = this._accountsServiceProvider.getProfileByID(result.sampleId);
                        if (profile && ['instagram', 'instabusiness'].indexOf(profile.display.network.backend_network_name.toLowerCase()) !== -1) {
                            if (typeof instagramCodes[profile.profile_id] !== 'string')
                                instagramCodes[profile.profile_id] = '';
                            if (typeof result.result === 'string' && instagramCodes[profile.profile_id].indexOf(result.result) === -1)
                                instagramCodes[profile.profile_id] += result.result;
                        }
                    }
                }
            }
        }
        return instagramCodes;
    };
    PublishingProvider.prototype._getTikTokCodes = function (post) {
        var tikTokCodes = {};
        for (var _i = 0, _a = post.postTime; _i < _a.length; _i++) {
            var postTime = _a[_i];
            var executions = postTime.executions, resultData = (!this.isEmptyObject(executions) ? executions.resultData : {});
            if (!this.isEmptyObject(resultData)) {
                if (!Array.isArray(resultData))
                    resultData = [resultData];
                for (var _b = 0, resultData_2 = resultData; _b < resultData_2.length; _b++) {
                    var result = resultData_2[_b];
                    if (result.sampleId) {
                        var profile = this._accountsServiceProvider.getProfileByID(result.sampleId);
                        if (profile && ['tiktok'].indexOf(profile.display.network.backend_network_name.toLowerCase()) !== -1) {
                            if (typeof tikTokCodes[profile.profile_id] !== 'string')
                                tikTokCodes[profile.profile_id] = '';
                            if (typeof result.result === 'string' && tikTokCodes[profile.profile_id].indexOf(result.result) === -1)
                                tikTokCodes[profile.profile_id] += result.result;
                        }
                    }
                }
            }
        }
        return tikTokCodes;
    };
    /**
     * getPostByID
     */
    PublishingProvider.prototype.getPostByID = function (id, source) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            //prepare apiPath and httpParams
            var apiPath = "/publishing/postByID";
            var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
                .set("postID", id)
                .set("postSource", source);
            _this
                ._http
                .get(apiPath, { params: httpParams }).subscribe(function (resp) {
                var data = resp['post'];
                resolve(_this._publishingMapPostProvider.mapPost(data));
                // this._accountsServiceProvider.accounts$.subscribe(updatedMappedAccounts => {
                //   data.allAccounts = updatedMappedAccounts.accounts;
                //   resolve(new Post(data));
                // });
            });
        });
    };
    //HELPERS
    PublishingProvider.prototype.isEmptyObject = function (obj) {
        for (var name in obj) {
            return false;
        }
        return true;
    };
    /**
     * convertExternalUrlToS3
     */
    PublishingProvider.prototype.convertExternalUrlToS3 = function (imageInfo) {
        var ext = imageInfo.src.split('.');
        ext = ext[ext.length - 1];
        ext = ext.split('?');
        var data = {
            action: "s3_upload",
            images: {
                src: imageInfo.src,
                title: '',
                filename: __WEBPACK_IMPORTED_MODULE_13_uuid_v1___default()()
            }
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post("/upload/s3", data, httpOptions);
    };
    /**
     * setpostsByDateCache
     */
    PublishingProvider.prototype.setPostsByDateCache = function (cacheKey, posts) {
        if (posts === void 0) { posts = {}; }
        console.log('setPostsByDateCache', cacheKey, this.postsByDateCache);
        if (cacheKey) {
            this.postsByDateCache[cacheKey] = posts;
        }
    };
    /**
     * setPostsByDateCache
     */
    PublishingProvider.prototype.getPostsByDateCache = function (cacheKey) {
        if (cacheKey === void 0) { cacheKey = ''; }
        var posts = null;
        if (this.postsByDateCache[cacheKey]) {
            posts = this.postsByDateCache[cacheKey];
        }
        console.log('setPostsByDateCache', cacheKey, this.postsByDateCache);
        return posts;
    };
    /**
     * resetPostsByDateCache
     */
    PublishingProvider.prototype.resetPostsByDateCache = function () {
        this.postsByDateCache = {};
        this.draftPostsByDate = {};
    };
    /**
     * getgmbEventTime
     */
    PublishingProvider.prototype.getGmbEventTime = function (postData) {
        var gmbEventTime = Number.MAX_VALUE;
        if (postData && postData.callsToAction && postData.callsToAction.gmbEvent) {
            var gmbEvent = postData.callsToAction.gmbEvent;
            var dateStr = gmbEvent.endMonth + '-' + gmbEvent.endDay + '-' + gmbEvent.endYear;
            dateStr += ' ' + gmbEvent.endHours + ':' + gmbEvent.endMinutes;
            gmbEventTime = __WEBPACK_IMPORTED_MODULE_11_moment_timezone__["tz"](dateStr, 'MM-DD-YYYY h:mm', this.userTimeZone).valueOf();
        }
        return gmbEventTime;
    };
    /**
     * get instgram hashtags
     * @param accountProfile
     * @param postId
     * @param stream
     * @param searchValue
     * @param searchType
     */
    PublishingProvider.prototype.instagramBusinessFeed = function (profile, postId, stream, searchValue, searchType) {
        if (postId === void 0) { postId = ""; }
        if (searchValue === void 0) { searchValue = ""; }
        if (searchType === void 0) { searchType = "top"; }
        console.log('instagramBusinessFeed profile', profile, profile.account_id);
        if (!profile)
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of([]);
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", profile.account_id)
            .set("profileID", profile.profile_id)
            .set("parameters", JSON.stringify([{ key: 'q', value: encodeURI(searchValue) }, { key: 'type', value: searchType }]))
            .set("stream", stream)
            .set("action", 'instagramBusiness')
            .set('post_id', postId);
        return this
            ._http
            .get("/feed/instagramBusiness", { params: httpParams })
            .map(function (response) {
            console.log(response);
            var output = [];
            if (response.data) {
                if (!Array.isArray(response.data))
                    response.data = [response.data];
                output = response.data;
            }
            return output;
        }).catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    /**
     * gettwitter hashtags
     */
    PublishingProvider.prototype.getTWHashTags = function (q, profile) {
        if (q === void 0) { q = ''; }
        if (q == "" || !profile)
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of([]);
        var params = {
            action: 'getTWSearch',
            parameters: [{ key: 'q', value: q }, { key: 'result_type', value: "popular" }],
            type: 'tweets',
            accountID: profile.account_id,
            profileID: profile.profile_id
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json', 'skipLoader': 'true' }),
        };
        return this
            ._http
            .post('/publishing/listMentions', params, httpOptions)
            .map(function (httpResponse) {
            console.log(httpResponse);
            var output = [];
            if (httpResponse.returnCode && httpResponse.returnCode === 'SUCCESS' && httpResponse.data) {
                output = Array.isArray(httpResponse.data) ? httpResponse.data : [httpResponse.data];
            }
            console.log('output', output);
            return output;
        });
    };
    PublishingProvider.prototype.addSavedReply = function (reqData, skipLoader) {
        if (skipLoader === void 0) { skipLoader = false; }
        var params = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]().set("action", "addSavedReply")
            .set("data[savedReply][id]", reqData.id)
            .set("data[savedReply][type]", reqData.type)
            .set("data[savedReply][label]", reqData.label)
            .set("data[savedReply][content]", reqData.content);
        var attachment = reqData.attachments;
        var httpOptions = {};
        if (skipLoader) {
            httpOptions.headers = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'skipLoader': 'true' });
        }
        for (var index = 0; index < attachment.length; index++) {
            params = params.set("data[savedReply][attachments][" + index + "][postAttachment][type]", attachment[index].type)
                .set("data[savedReply][attachments][" + index + "][postAttachment][name]", attachment[index].name)
                .set("data[savedReply][attachments][" + index + "][postAttachment][source]", attachment[index].source)
                .set("data[savedReply][attachments][" + index + "][postAttachment][location]", attachment[index].location)
                .set("data[savedReply][attachments][" + index + "][postAttachment][imageThumbnail]", attachment[index].imageThumbnail);
        }
        console.log(params);
        return this._http
            .post('/publishing/addSavedReply', params, httpOptions)
            .map(function (response) {
            return response;
        });
    };
    PublishingProvider.prototype.youtubeFeed = function (accountProfile, stream) {
        if (!accountProfile || !accountProfile.profile)
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of([]);
        var httpParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("accountID", accountProfile.profile.account_id)
            .set("profileID", accountProfile.profile.profile_id)
            .set("stream", stream)
            .set("action", 'getYouTubeFeed');
        return this
            ._http
            .get("/feed/youTube", { params: httpParams })
            .map(function (response) {
            var output = [];
            if (response.data && response.data.items) {
                if (!Array.isArray(response.data.items))
                    response.data.items = [response.data.items];
                output = response.data.items;
            }
            return output;
        }).catch(function (Error) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].throw(Error);
        });
    };
    PublishingProvider.prototype.getQueues = function (skipLoader) {
        var _this = this;
        if (skipLoader === void 0) { skipLoader = false; }
        var httpHeaders = { 'Content-Type': 'application/json' };
        if (skipLoader)
            httpHeaders['skipLoader'] = 'true';
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */](httpHeaders);
        return this
            ._http.get("/publishing/getQueueList", { headers: headers })
            .flatMap(function (response) {
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(_this._prepareQueues(response).then(function (mappedDraftPosts) {
                return mappedDraftPosts;
            }));
        });
    };
    PublishingProvider.prototype._prepareQueues = function (response) {
        var _this = this;
        return new Promise(function (resolve) {
            var respQueue = (response.queues && response.queues.queue) ? response.queues.queue : [];
            respQueue = Array.isArray(respQueue) ? respQueue : [respQueue];
            _this.queuesContainer = {};
            for (var i in respQueue) {
                var queue = _this.getMappedQueue(respQueue[i]);
                _this.queuesContainer[queue.queueId] = queue;
            }
            resolve(response);
        });
    };
    PublishingProvider.prototype.getMappedQueue = function (raw_queue) {
        var queue = {
            colorCode: raw_queue.colorCode,
            endTime: raw_queue.endTime,
            functionality: raw_queue.functionality,
            queueId: raw_queue.queueId,
            queueName: raw_queue.queueName,
            sendEmptyQueueEmail: (raw_queue.sendEmptyQueueEmail === 'true') ? true : false,
            startTime: raw_queue.startTime,
            status: raw_queue.status,
            turnOffOnEmpty: (raw_queue.turnOffOnEmpty === 'true') ? true : false,
            type: raw_queue.type,
            queueTypeText: '' //this.getQueueType(raw_queue),
        };
        return queue;
    };
    /**
     * getQueueNameByID
     */
    PublishingProvider.prototype.getQueueNameByID = function (id) {
        var queue = this.getQueuesById(id);
        var name = "";
        if (queue && queue.queueName)
            name = queue.queueName;
        return name;
    };
    /**
     * getQueuesById
     */
    PublishingProvider.prototype.getQueuesById = function (id) {
        return (id && this.queuesContainer) ? this.queuesContainer[id] || null : null;
    };
    PublishingProvider.prototype.getApprovalRoles = function (skipLoader) {
        var _this = this;
        if (skipLoader === void 0) { skipLoader = false; }
        var params = {
            action: 'getApprovalRoles'
        };
        var httpHeaders = { 'Content-Type': 'application/json' };
        if (skipLoader)
            httpHeaders['skipLoader'] = 'true';
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */](httpHeaders)
        };
        return this
            ._http
            .post('/publishing/ApprovalRoles', params, httpOptions)
            .map(function (httpResponse) {
            //roles get
            _this._prepareRoles(httpResponse);
            return httpResponse;
        });
    };
    PublishingProvider.prototype._prepareRoles = function (httpResponse) {
        console.log('httpResponse', httpResponse);
        if (httpResponse.roles && httpResponse.roles.users) {
            this.rolesByUsername = {};
            httpResponse.roles.users = (Array.isArray(httpResponse.roles.users)) ? httpResponse.roles.users : [httpResponse.roles.users];
            this.roles = httpResponse.roles.users;
            for (var _i = 0, _a = httpResponse.roles.users; _i < _a.length; _i++) {
                var user = _a[_i];
                this.rolesByUsername[user.userName] = user;
            }
        }
        console.log("_prepareRoles", this.rolesByUsername);
    };
    PublishingProvider.prototype.savePostFilters = function (filters) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.ionicStorage.set(_this.keyForPostFilterInStorage, filters)
                .then(function (result) {
                resolve();
            }, function (error) {
                reject(error);
            });
        });
    };
    PublishingProvider.prototype.mapProfilesForPostFilter = function (savedFilters) {
        var mappedProfiles = [];
        var accounts = this._accountsServiceProvider.getAccounts();
        return new Promise(function (resolve, reject) {
            try {
                for (var _i = 0, _a = accounts.accounts; _i < _a.length; _i++) {
                    var account = _a[_i];
                    if (undefined != account.profiles && account.profiles.length > 0 && (account.settings && !account.settings.expired)) {
                        for (var _b = 0, _c = account.profiles; _b < _c.length; _b++) {
                            var profile = _c[_b];
                            if (profile.original_config.monitored === 'on' || profile.original_config.socialMonitored == 'on') {
                                if (account.display.network.backend_network_name === 'GooglePlus' && profile.original_config.objectType === 'person') {
                                    continue;
                                }
                            }
                            if ((profile.original_config.monitored === 'on' || (['GooglePlus', 'Yelp'].indexOf(account.display.network.backend_network_name) == -1 && profile.original_config.socialMonitored === 'on')) && profile.original_config.eventsMonitored === 'on') { //  
                                var selected = (savedFilters && savedFilters.indexOf(profile.profile_id) != -1);
                                mappedProfiles.push({
                                    selected: selected,
                                    profile: profile,
                                });
                            }
                            if (profile.display.network.backend_network_name.toLowerCase() === "pinterest") {
                                var selected = (savedFilters && savedFilters.indexOf(profile.profile_id) != -1);
                                mappedProfiles.push({
                                    selected: selected,
                                    profile: profile,
                                });
                            }
                        }
                    }
                } //end for
                if (mappedProfiles && mappedProfiles.length) {
                    mappedProfiles.sort(function (a, b) {
                        var aName = a.profile.display.network.backend_network_name.toLowerCase();
                        var bName = b.profile.display.network.backend_network_name.toLowerCase();
                        if (aName > bName) {
                            return 1;
                        }
                        else if (aName < bName) {
                            return -1;
                        }
                        else
                            return 0;
                    });
                }
                resolve(mappedProfiles);
            }
            catch (err) {
                reject(err);
            }
        }); //end promise
    };
    PublishingProvider.prototype.getApprovalPost = function (data) {
        var _this = this;
        var requestBody = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("filter", data.filter)
            .set("start_date", data.startDate)
            .set("end_date", data.endDate)
            .set("appVersion", '1.2.5');
        return this
            ._http
            .get("/publishing/posts", { params: requestBody })
            .flatMap(function (resp) {
            var httpResponse = resp;
            _this.setApproverData(httpResponse);
            if (!httpResponse.pending_post ||
                httpResponse.pending_post.posts == undefined ||
                httpResponse.pending_post.posts.post == undefined) {
                return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].of([]);
            }
            var items = httpResponse.pending_post.posts.post;
            if (!Array.isArray(items)) {
                items = [items];
            }
            //roles get
            _this._prepareRoles(httpResponse);
            return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(_this.prepareAprovalPosts(items).then(function (mappedApprovalPosts) {
                console.log('mappedApprovalPosts', mappedApprovalPosts);
                //sort by created time
                mappedApprovalPosts.sort(function (a, b) {
                    if (a.calendarData.scheduledTime > b.calendarData.scheduledTime) {
                        return -1;
                    }
                    else if (a.calendarData.scheduledTime == b.calendarData.scheduledTime) {
                        return 0;
                    }
                    else {
                        return 1;
                    }
                });
                return mappedApprovalPosts;
            }));
        });
    };
    ; //end getDraftPost
    PublishingProvider.prototype.setApproverData = function (data) {
        if (data.pending_post == undefined)
            return;
        if (data.pending_post.approverDisplayName != undefined) {
            this.approverData.approverDisplayName = data.pending_post.approverDisplayName;
        }
        if (data.pending_post.displayName != undefined) {
            this.approverData.displayName = data.pending_post.displayName;
        }
        if (data.pending_post.approverLogo != undefined) {
            this.approverData.approverLogo = data.pending_post.approverLogo;
        }
        if (data.pending_post.approverData != undefined) {
            if (data.pending_post.approverData.brandNameColor)
                this.approverData.brandNameColor = data.pending_post.approverData.brandNameColor;
            if (data.pending_post.approverData.headerBackgroundColor)
                this.approverData.headerBackgroundColor = data.pending_post.approverData.headerBackgroundColor;
        }
    };
    PublishingProvider.prototype.prepareAprovalPosts = function (items) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var promisableMappedPosts = [];
            for (var _i = 0, items_2 = items; _i < items_2.length; _i++) {
                var item = items_2[_i];
                item.source = 'postapproval';
                item.addToApproval = true;
                if ((item.pendingType && (item.pendingType == 'queue')))
                    item.source = 'queueapproval';
                var title = _this.isEmptyObject(item.text) ? '' : item.text;
                item.created = item.createTime.slice(0, 10);
                promisableMappedPosts.push(_this._publishingMapPostProvider.mapPost(item));
            }
            Promise.all(promisableMappedPosts).then(function (mappedPosts) {
                for (var _i = 0, mappedPosts_6 = mappedPosts; _i < mappedPosts_6.length; _i++) {
                    var post = mappedPosts_6[_i];
                    //scheduletime
                    // let defaultCreationtime = 1451649600000 * 10000; // Jan 1, 2016 12:00
                    // let postTime = defaultCreationtime + 1000000000000;
                    // if (post.scheduledTimes.length) {
                    //   let stCopy = post.scheduledTimes.slice(0);
                    //   stCopy.sort();
                    //   postTime = stCopy[0] * 1000;
                    // }
                    // if (post.pendingQueues.length) {
                    //   post.editorType = 'autoPostEditor';
                    // }
                    post.calendarData = {
                        scheduledTime: '' + parseInt(post.created),
                        isDraftPost: true,
                        buttons: {
                            duplicatePost: true,
                            edit: true,
                            delete: true
                        }
                    };
                    // remove all schedules
                    // post.scheduledTimes = [];
                }
                resolve(mappedPosts);
            });
        });
    };
    PublishingProvider.prototype.getSelectedProfileIds = function (postData) {
        var selectedProfiles = [];
        var groupsByProfileId = {};
        var removedProfiles = [];
        for (var _i = 0, _a = postData.groups; _i < _a.length; _i++) {
            var group = _a[_i];
            if (groupsByProfileId[group.profileID] == undefined)
                groupsByProfileId[group.profileID] = [];
            groupsByProfileId[group.profileID].push(group.groupID);
        }
        for (var _b = 0, _c = postData.accounts; _b < _c.length; _b++) {
            var account = _c[_b];
            if (account.profile.display.network.backend_network_name && (!groupsByProfileId[account.profile.profile_id] || groupsByProfileId[account.profile.profile_id].indexOf("_self_") !== -1))
                selectedProfiles.push(account.profile.profile_id);
            if (!account.profile.display.network.backend_network_name)
                removedProfiles.push(account.profile.profile_id);
        }
        for (var _d = 0, _e = postData.groups; _d < _e.length; _d++) {
            var group = _e[_d];
            if (group.groupID.indexOf('_self_') === -1 && removedProfiles.indexOf(group.profileID) == -1)
                selectedProfiles.push(group.groupID + "_" + group.profileID);
        }
        return selectedProfiles;
    };
    PublishingProvider.prototype.setApprovalPost = function (data) {
        var params = {
            data: data,
            action: 'setApprovalPost'
        };
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/setApprovalPost', params, httpOptions)
            .map(function (httpResponse) {
            console.log('httpResponse', httpResponse);
            return httpResponse;
        });
    };
    PublishingProvider.prototype.parsePostAssignedUsers = function (postData) {
        var assignedUsers = "";
        var userSettings = this.userSettingsProvider.getUserSettings();
        if (userSettings) {
            for (var _i = 0, _a = postData.assignedUsers; _i < _a.length; _i++) {
                var user = _a[_i];
                var name_1 = (this.rolesByUsername[user]) ? this.rolesByUsername[user]['displayName'] : null; // : user;
                if (name_1 == null && (user == this.userSettingsProvider.getAdminUsername() || user == userSettings.email))
                    name_1 = "Main Admin";
                // display only existing users
                if (name_1 != null)
                    assignedUsers += (assignedUsers) ? ", " + name_1 : name_1;
            }
        }
        return assignedUsers;
    };
    PublishingProvider.prototype.parsePostAssignedUser = function (user) {
        var assignedUser = "";
        var userSettings = this.userSettingsProvider.getUserSettings();
        if (userSettings) {
            var name_2 = (this.rolesByUsername[user]) ? this.rolesByUsername[user]['displayName'] : null; // : user;
            if (name_2 == null && (user == this.userSettingsProvider.getAdminUsername() || user == userSettings.email))
                name_2 = "Main Admin";
            // display only existing users
            if (name_2 != null)
                assignedUser = name_2;
            //}
        }
        return assignedUser;
    };
    PublishingProvider.prototype.notifyPostApproval = function (data, sendRequest) {
        if (sendRequest === void 0) { sendRequest = false; }
        var params = {};
        if (!sendRequest) {
            params = {
                postIds: data.postIds,
                action: 'notifyPostApproval',
                comments: data.comments
            };
        }
        else {
            params = {
                action: 'notifyPostApproval',
                data: data,
                new: 'true'
            };
        }
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/notifyPostApproval', params, httpOptions)
            .map(function (httpResponse) {
            return httpResponse;
        });
    };
    PublishingProvider.prototype.parsePostLastComment = function (postData) {
        var output = {
            commentName: "",
            commentDate: "",
            commentContent: ""
        };
        if (postData.pendingComment && postData.pendingComment.length) {
            var last = postData.pendingComment[postData.pendingComment.length - 1];
            if (typeof last !== 'string') {
                if (postData.pendingComment.length > 1) {
                    last = postData.pendingComment[postData.pendingComment.length - 2];
                    if (typeof last !== 'string')
                        last = ',,';
                }
                else
                    last = ',,';
            }
            var commentSeg = last.split(',');
            var commentName = __WEBPACK_IMPORTED_MODULE_12_jquery__["trim"](commentSeg[2].substr(0, commentSeg[2].indexOf(':')));
            var commentDate = __WEBPACK_IMPORTED_MODULE_12_jquery__["trim"](commentSeg[0] + ',' + commentSeg[1]);
            var commentContent = last.split(':');
            commentContent.shift();
            commentContent.shift();
            commentContent = __WEBPACK_IMPORTED_MODULE_12_jquery__["trim"](commentContent.join(':'));
            if (commentName === 'Admin')
                commentName = 'Main Admin';
            output.commentName = commentName;
            output.commentDate = commentDate;
            output.commentContent = commentContent;
        }
        return output;
    };
    PublishingProvider.prototype.deletePendingPosts = function (source, deleteIds, queueId) {
        if (queueId === void 0) { queueId = ""; }
        var actionType = "";
        // switch (source) {
        //   case 'scheduled':
        //   case 'scheduledapproval':
        //     actionType = "deleteScheduledPost";
        //     break;
        //   case 'draft':
        //     actionType = "deleteSavedUrls";
        //     break;
        //   case 'approval':
        //   case 'queueapproval':
        actionType = "deletePendingPosts";
        //     break;
        //   case 'autopost':
        //     actionType = "deleteUserQueuePosts";
        //     break;
        // }
        var params = {
            type: actionType,
            delete_ids: deleteIds,
            action: 'deletePosts'
        };
        if (queueId)
            params.queueId = queueId;
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/deletePosts', params, httpOptions)
            .map(function (httpResponse) {
            console.log('httpResponse', httpResponse);
            return httpResponse;
        });
    };
    PublishingProvider.prototype.loadSavedPostFilters = function () {
        return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].fromPromise(this.ionicStorage.get(this.keyForPostFilterInStorage).then(function (savedFilters) {
            console.log('loadSavedPostFilters', savedFilters);
            return savedFilters;
        }, function () {
            return null;
        }));
    };
    ;
    PublishingProvider.prototype.setCalendarDate = function (date) {
        this.calLastSelectedDate = date;
    };
    PublishingProvider.prototype.getlastSelectedDate = function () {
        return this.calLastSelectedDate;
    };
    PublishingProvider.prototype.userIsAbleToApprove = function (postData) {
        var result = true;
        var userSettings = this.userSettingsProvider.getUserSettings();
        if (userSettings) {
            var userInAssignedUsers = postData.assignedUsers.indexOf(userSettings.paymentId) !== -1;
            if (userSettings.licenseType === 'Premier') {
                if (userSettings.isManagedUser && userSettings.masterAccountsPermission === false)
                    result = userInAssignedUsers;
            }
            else {
                var client = this.userSettingsProvider.getSelectedBrand();
                if (client && client.permission) {
                    if (['admin', 'edit'].indexOf(client.permission) === -1)
                        result = userInAssignedUsers;
                }
            }
        }
        else
            result = false;
        return result;
    };
    /**
   * set sharedDataSource
   */
    PublishingProvider.prototype.setIOSSharedDataSource = function (data) {
        if (data === void 0) { data = null; }
        this.IosShareSource.next(data);
    };
    PublishingProvider.prototype.isUserAllowedSendExternalUserEmails = function (user) {
        var has = true;
        if (this.rolesByUsername[user]
            && this.rolesByUsername[user]['role'] == 'postApprovalUser'
            && this.rolesByUsername[user]['sendExternalUserEmails'] === 'false')
            has = false;
        return has;
    };
    PublishingProvider.prototype.sendApprovalEmail = function (inputData, showConfirm) {
        var _this = this;
        if (showConfirm === void 0) { showConfirm = false; }
        console.log("inputData", inputData);
        return new Promise(function (resolve) {
            var sendData = [];
            for (var clientId in inputData) {
                var post_ids = inputData[clientId].post_ids;
                var postIds = [];
                var comments = [];
                var newPost = inputData[clientId].newPost;
                var assignedUsersList = inputData[clientId].assignedUsersList;
                if (newPost) {
                    newPost = (Array.isArray(newPost)) ? newPost : [newPost];
                    for (var _i = 0, newPost_1 = newPost; _i < newPost_1.length; _i++) {
                        var pd = newPost_1[_i];
                        var hasFutureTime = false;
                        for (var _a = 0, _b = pd.scheduledTimes; _a < _b.length; _a++) {
                            var time = _b[_a];
                            var checkTime = __WEBPACK_IMPORTED_MODULE_10_moment__(time * 1000).unix();
                            var currentTime = __WEBPACK_IMPORTED_MODULE_10_moment__().add('minutes', 5).unix();
                            if (checkTime > currentTime)
                                hasFutureTime = true;
                        }
                        console.log("sendData", hasFutureTime, assignedUsersList);
                        if (pd.accounts.length && hasFutureTime && assignedUsersList) {
                            postIds.push(pd.id);
                            var assignedUsers = assignedUsersList;
                            var comment = __WEBPACK_IMPORTED_MODULE_10_moment__().format("MMM D,YYYY hh:mma") + ", " + _this.userSettingsProvider.getDisplayName() + ": Sent email to " + assignedUsers + " for request approval.";
                            comments.push({ comment: comment, postId: pd.id });
                        }
                    }
                }
                else {
                    // for (let id of post_ids) {
                    //   let post = this.getPostsById(id);
                    //   let hasFutureTime = false;
                    //   for (let time of post.scheduledTimes) {
                    //     let checkTime = moment(time * 1000).unix();
                    //     let currentTime = moment().add('minutes', 5).unix();
                    //     if (checkTime > currentTime)
                    //       hasFutureTime = true;
                    //   }
                    //   if ((post.assignedUsers.length || assignedUsersList) && ((post.accounts.length && hasFutureTime) || (post.source == 'queueapproval' && post.pendingQueues.length))) {
                    //     postIds.push(id);
                    //     let assignedUsers = (assignedUsersList) ? assignedUsersList : this.parsePostAssignedUsers(this.getPostsById(id), true);
                    //     if (assignedUsers) {
                    //       let comment =moment().format("MMM D,YYYY hh:mma") + ", " + this.userSettingsProvider.getDisplayName() + ": Sent email to " + assignedUsers + " for request approval.";
                    //       comments.push({ comment: comment, postId: id });
                    //     }
                    //   }
                    // }
                }
                //  if (postIds.length == 0 || comments.length == 0) {
                //   return resolve(false);
                //  }
                if (postIds.length && comments.length) {
                    var clientData = [];
                    for (var _c = 0, postIds_1 = postIds; _c < postIds_1.length; _c++) {
                        var pid = postIds_1[_c];
                        clientData.push({ 'postId': pid });
                    }
                    var addComments = [];
                    for (var _d = 0, comments_1 = comments; _d < comments_1.length; _d++) {
                        var cm = comments_1[_d];
                        addComments.push({ addComment: { comment: cm.comment, postId: cm.postId } });
                    }
                    clientData.push({ addComments: addComments });
                    clientData.push({ 'clientId': clientId });
                    sendData.push({
                        client: clientData
                    });
                }
            }
            if (sendData.length == 0) {
                return resolve(false);
            }
            if (showConfirm) {
                // let wmesg = 'An automated email will be sent to assigned approvers, including all external users that were set to <br>"enable request approval email" (can be set in the external user settings). By default, external users will not be enabled to receive an automated request approval email. Please note, the email will be sent from the <br>eclincher domain.';
                // //wmesg += ' Please note, the email will be sent from the eclincher domain.<br><br>If you assigned an external user, such as a customer, you may want to send the approval request email from your own domain or email provider (simply copy the external user dedicated link and email it). ';
                // this.ecPopupService.confirm('Request approval', wmesg, '', '', 'lg', true)
                //   .then((confirmed) => {
                //     if (confirmed) {
                //       this.notifyPostApproval(sendData).subscribe((res: any) => {
                //         resolve(true);
                //       });
                //     }
                //   })
                //   .catch(() => console.log('User dismissed the dialog (e.g., by using ESC, clicking the cross icon, or clicking outside the dialog)'));
            }
            else {
                console.log("sendApprovalEmail", sendData);
                _this.notifyPostApproval(sendData, true).subscribe(function (res) {
                    resolve(true);
                });
            }
        });
    };
    PublishingProvider.prototype.deletePosts = function (source, deleteIds, queueId) {
        if (queueId === void 0) { queueId = ""; }
        var actionType = "";
        switch (source) {
            case 'scheduled':
            case 'scheduledapproval':
                actionType = "deleteScheduledPost";
                break;
            case 'draft':
                actionType = "deleteSavedUrls";
                break;
            case 'approval':
            case 'queueapproval':
                actionType = "deletePendingPosts";
                break;
            case 'autopost':
                actionType = "deleteUserQueuePosts";
                break;
        }
        var params = {
            type: actionType,
            delete_ids: deleteIds,
            action: 'deletePosts'
        };
        if (queueId)
            params.queueId = queueId;
        var httpOptions = {
            headers: new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpHeaders */]({ 'Content-Type': 'application/json' })
        };
        return this
            ._http
            .post('/publishing/deletePosts', params, httpOptions)
            .map(function (httpResponse) {
            console.log('httpResponse', httpResponse);
            return httpResponse;
        });
    };
    PublishingProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_4__accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_publishing_service_publishing_map_post__["a" /* PublishingMapPostProvider */],
            __WEBPACK_IMPORTED_MODULE_6__app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__publishing_service_publishing_validator__["a" /* PublishingValidatorProvider */],
            __WEBPACK_IMPORTED_MODULE_8__user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_15__ionic_storage__["b" /* Storage */]])
    ], PublishingProvider);
    return PublishingProvider;
}());

; //end PublishingProvider
;
;
;
;
;
;
;
//# sourceMappingURL=publishing-service.js.map

/***/ }),

/***/ 63:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PublishingMapPostProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__accounts_service_accounts_service__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__app_settings_app_settings__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__publishing_helper__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_jquery__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__user_settings_user_settings__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

//PROVIDERS





var PublishingMapPostProvider = /** @class */ (function () {
    function PublishingMapPostProvider(_accountsServiceProvider, _appSettingsProvider, userSettingsProvider) {
        this._accountsServiceProvider = _accountsServiceProvider;
        this._appSettingsProvider = _appSettingsProvider;
        this.userSettingsProvider = userSettingsProvider;
        this.resetAccounts = function () {
            this.accounts = [];
            this.lastSelectedAccountByType = {};
            this.updateAttachmentsFlag();
            this.updateProfilesFlag();
        };
        /* MAPPER FUNTIONS */
        this.hasGiphy = function (obj) {
            var flag = false;
            for (var _i = 0, _a = this['attachments']; _i < _a.length; _i++) {
                var attachment = _a[_i];
                if (attachment.originalData && attachment.originalData.type == 'image/gif') {
                    flag = true;
                    break;
                }
            }
            return flag;
        };
        this.updateProfilesFlag = function () {
            this.lastSelectedAccountByType = {};
            this.has_fb_profile = false;
            this.has_twitter_profile = false;
            this.has_linkedin_profile = false;
            this.has_googleplus_profile = false;
            this.has_pinterest_profile = false;
            this.has_instagram_profile = false;
            this.has_instagram_business_profile = false;
            this.has_tiktok_profile = false;
            this.has_blogger_profile = false;
            this.has_googlemybusiness_profile = false;
            this.has_linkedin_user = false;
            this.has_youtube_profile = false;
            this.has_only_instagram_business_profile = false;
            var has_instagram = false;
            for (var _i = 0, _a = this.accounts; _i < _a.length; _i++) {
                var account = _a[_i];
                var accType = account.profile.display.network.backend_network_name.toLowerCase();
                if (accType == 'linkedin' && account.profile
                    && account.profile.original_config
                    && account.profile.original_config.profileName.indexOf('(Company Page)') !== -1)
                    accType = "linkedinpage";
                this.lastSelectedAccountByType[accType] = account;
                switch (accType) {
                    case 'facebook':
                        this.has_fb_profile = true;
                        break;
                    case 'twitter':
                        this.has_twitter_profile = true;
                        break;
                    case 'linkedin':
                        this.has_linkedin_profile = true;
                        if (account.profile
                            && account.profile.original_config
                            && account.profile.original_config.profileName.indexOf('(Company Page)') === -1) {
                            this.has_linkedin_user = true;
                        }
                        break;
                    case 'linkedinpage':
                        this.has_linkedin_profile = true;
                        break;
                    case 'googleplus':
                        this.has_googleplus_profile = true;
                        break;
                    case 'googlemybusiness':
                        this.has_googlemybusiness_profile = true;
                        break;
                    case 'pinterest':
                        this.has_pinterest_profile = true;
                        break;
                    case 'instagram':
                        has_instagram = true;
                        this.has_instagram_profile = true;
                        break;
                    case 'instabusiness':
                        this.has_instagram_profile = true;
                        this.has_instagram_business_profile = true;
                        break;
                    case 'blogger':
                        this.has_blogger_profile = true;
                        break;
                    case 'youtube':
                        this.has_youtube_profile = true;
                        break;
                    case 'tiktok':
                        this.has_tiktok_profile = true;
                        break;
                }
            }
            if (!has_instagram && this.has_instagram_business_profile)
                this.has_only_instagram_business_profile = true;
        };
        this.updateAttachmentsFlag = function () {
            this.has_image = false;
            this.has_video = false;
            this.has_bmp = false;
            this.has_gif = false;
            this.has_3mb_image = false;
            this.has_10mb_image = false;
            for (var _i = 0, _a = this.attachments; _i < _a.length; _i++) {
                var att = _a[_i];
                if (att.originalData.type == 'picture' || att.originalData.type.match(/image.*/))
                    this.has_image = true;
                if (att.originalData.type == 'video' || att.originalData.type.match(/video.*/))
                    this.has_video = true;
                if (att.url.full.indexOf('.bmp') != -1)
                    this.has_image = true;
                if (att.url.full.indexOf('.gif') != -1)
                    this.has_gif = true;
                if (!this.has_video) {
                    if (att.originalData.size > 3072 * 1000)
                        this.has_3mb_image = true;
                    if (att.originalData.size > 10240 * 1000)
                        this.has_10mb_image = true;
                }
            }
        };
        this.limitCharacters = function (text) {
            var ret = {}, max = false;
            // if ( this.has_linkedin_profile && !this.has_twitter_profile /* && $('.selected-items .badge.linkedin.group').length */ ) max = 250;
            if (this.has_linkedin_profile && !this.has_twitter_profile && !this.has_pinterest_profile) {
                max = 1300; // 600;
                // if (this.has_linkedin_user) {
                //     max = 600;
                // }
            }
            else if (this.has_pinterest_profile && !this.has_twitter_profile)
                max = 500;
            else if (this.has_twitter_profile)
                max = 280 - (__WEBPACK_IMPORTED_MODULE_3__publishing_helper__["h" /* getWeightedLength */](text) - text.length);
            else if (this.has_instagram_profile) {
                if (this.has_instagram_business_profile) {
                    max = 2200;
                }
                else {
                    max = 1400;
                }
            }
            else if (this.has_googlemybusiness_profile)
                max = 1500;
            else if (this.has_fb_profile || this.has_googleplus_profile || this.has_youtube_profile)
                max = 5000;
            else if (this.has_tiktok_profile)
                max = 1400;
            ret.text = text;
            ret.max = (this.has_twitter_profile ? 280 : max);
            ret.remaining = max - ret.text.length;
            for (var key in this.NetworkCharacterLimit) {
                this.NetworkCharacterLimit[key].remaining = this.NetworkCharacterLimit[key].max - text.length;
                if (key === 'twitter') {
                    var nmax = 280 - (__WEBPACK_IMPORTED_MODULE_3__publishing_helper__["h" /* getWeightedLength */](text) - text.length);
                    this.NetworkCharacterLimit[key].nmax = nmax;
                    this.NetworkCharacterLimit[key].remaining = nmax - text.length;
                }
            }
            // console.log('ret', ret);
            return ret;
        };
        this.getLastSelectedAccountByType = function (type) {
            if (this.lastSelectedAccountByType[type]) {
                return this.lastSelectedAccountByType[type];
            }
            return false;
        };
        this.wrapFBMentions = function (content) {
            console.log('this.fbContentReplacement.length', this.fbContentReplacement.length);
            if (this.fbContentReplacement && this.fbContentReplacement.length <= 0) {
                return content;
            }
            var mentions = this.fbContentReplacement;
            // self.mentionsbyid = [];
            mentions.sort(function (a, b) {
                return b.key.length - a.key.length;
            });
            if (mentions.length) {
                for (var i = 0; i < mentions.length; i++) {
                    if (typeof mentions[i].key != 'string' && typeof mentions[i].value != 'string') {
                        continue;
                    }
                    var mention_key = mentions[i].key;
                    var reg_pattern_str = mention_key.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
                    var reg_pattern = new RegExp(reg_pattern_str, 'g');
                    var reg_pattern_enc = new RegExp(__WEBPACK_IMPORTED_MODULE_3__publishing_helper__["i" /* htmlFromText */](reg_pattern_str), 'g');
                    // mention_key = mention_key.replace(/ /g,'__-_-__'); //to hanlde the name which has space
                    // self.mentionsbyid[$mentions[i].value] = $mentions[i].key;
                    if (!reg_pattern.test(content))
                        reg_pattern = reg_pattern_enc;
                    var mk = mention_key.replace('@', '');
                    content = content.replace(reg_pattern, '<span data-id="' + mentions[i].value + '" class="mentions-key hide">@</span><span data-id="' + mentions[i].value + '" data-screen-name ="' + mk + '" class="mentions-value">' + mk + '</span>&nbsp;');
                }
            }
            return content;
        };
        this.wrapTWMentions = function (content) {
            var mentions = __WEBPACK_IMPORTED_MODULE_3__publishing_helper__["b" /* extractMentions */](content);
            if (!Array.isArray(mentions)) {
                return content;
            }
            console.log('mentions', mentions);
            mentions.sort(function (a, b) {
                return b.length - a.length;
            });
            if (mentions.length) {
                for (var i = 0; i < mentions.length; i++) {
                    var mention = '@' + mentions[i];
                    var regPattern = new RegExp('\\' + mention + '\\b');
                    var prevTextLength = content.length;
                    var replaceText = '<span data-id="' + mentions[i] + '" data-screen-name ="' + mentions[i] + '" class="twitter mentions-value">' + mention + '</span>&nbsp;';
                    content = content.replace(regPattern, replaceText);
                    if (prevTextLength === content.length) {
                        regPattern = new RegExp(mention.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&"), 'g');
                        this.postData.htmlContent = content.replace(regPattern, replaceText);
                    }
                }
            }
            return content;
        };
        this.getAttachmentCount = function (include_scraped_image) {
            if (include_scraped_image === void 0) { include_scraped_image = false; }
            include_scraped_image = (!include_scraped_image) ? false : true;
            var $count = 0, $scrape_image_count = 0;
            if (this.attachments != undefined) {
                if (this.attachments.length >= 0) {
                    for (var i = 0; i < this.attachments.length; i++) {
                        if (this.attachments[i].source == 'scrape') {
                            if (include_scraped_image == true)
                                $scrape_image_count = 1;
                        }
                        else {
                            $count++;
                        }
                    }
                }
            }
            $count = $count + $scrape_image_count;
            return $count;
        };
        this.has_only_one_image = function () {
            if (this.attachments.length === 1) {
                var att = this.attachments[0], loc = (typeof att.location === 'string' ? att.location : '');
                if (att.type === 'picture' && loc.indexOf('.gif') === -1 /* && att.source === 'upload' */)
                    return true;
            }
            else if (this.attachments.length > 1 && this.has_only_scrapped_attachments())
                return true;
            return false;
        };
        this.has_only_scrapped_attachments = function () {
            var result = true;
            if (this.attachments)
                this.attachments.forEach(function (att) { if (att.source !== 'scrape')
                    result = false; });
            return result;
        };
        this.updateCharactersLimit = function () {
            if (!this.accounts || !this.accounts.length)
                return;
            var resArr = [];
            this.accounts.filter(function (item) {
                var i = resArr.findIndex(function (x) { return x.profile.display.network.backend_network_name == item.profile.display.network.backend_network_name; });
                if (i <= -1) {
                    resArr.push(item);
                }
                return null;
            });
            this.NetworkCharacterLimit = {};
            for (var _i = 0, resArr_1 = resArr; _i < resArr_1.length; _i++) {
                var item = resArr_1[_i];
                var networkName = item.profile.display.network.backend_network_name.toLowerCase();
                if (networkName === 'linkedin') {
                    item.profile.display.network.character_limit = 1300;
                    // if (this.has_linkedin_user) {
                    //     item.profile.display.network.character_limit = 600;
                    // }            
                }
                this.NetworkCharacterLimit[networkName] = {
                    logo: item.profile.display.network.circle_logo,
                    max: item.profile.display.network.character_limit,
                    remaining: item.profile.display.network.character_limit - this.content.length
                };
                if (networkName === 'twitter') {
                    var nmax = 280 - (__WEBPACK_IMPORTED_MODULE_3__publishing_helper__["h" /* getWeightedLength */](this.content) - this.content.length);
                    this.NetworkCharacterLimit[networkName].nmax = nmax;
                    this.NetworkCharacterLimit[networkName].remaining = nmax - this.content.length;
                }
            }
        };
        //this.hasGiphy = obj => this.hasGiphy(obj);
    }
    PublishingMapPostProvider.prototype.mapPost = function (data) {
        var _this = this;
        if (data === void 0) { data = {}; }
        return new Promise(function (resolve, reject) {
            var post = {
                id: null,
                accounts: [],
                groups: [],
                attachments: [],
                scrappedAttachments: [],
                content: '',
                link: '',
                links: [],
                scheduledTimes: [],
                postTime: [],
                assignedUsers: [],
                isPostNow: false,
                pending: false,
                callsToAction: null,
                lastSelectedAccountByType: {},
                isScheduled: false,
                isIGStory: true,
                has_fb_profile: false,
                has_twitter_profile: false,
                has_linkedin_profile: false,
                has_googleplus_profile: false,
                has_pinterest_profile: false,
                has_instagram_profile: false,
                has_blogger_profile: false,
                has_googlemybusiness_profile: false,
                has_youtube_profile: false,
                has_only_instagram_business_profile: false,
                has_tiktok_profile: false,
                has_image: false,
                has_video: false,
                has_bmp: false,
                has_gif: false,
                has_3mb_image: false,
                has_10mb_image: false,
                displayOptions: {
                    characterLimit: 5000,
                    placeholder: 'Create your post...',
                    giphy: true,
                    pixabay: true,
                    camera: true,
                    gallery: true,
                    savedPost: true,
                    postApproval: false
                },
                hasGiphy: _this.hasGiphy,
                updateProfilesFlag: _this.updateProfilesFlag,
                updateAttachmentsFlag: _this.updateAttachmentsFlag,
                limitCharacters: _this.limitCharacters,
                updateCharactersLimit: _this.updateCharactersLimit,
                wrapFBMentions: _this.wrapFBMentions,
                wrapTWMentions: _this.wrapTWMentions,
                getAttachmentCount: _this.getAttachmentCount,
                showGMBEventButton: false,
                NetworkCharacterLimit: {},
                fbContentReplacement: [],
                mentionsListPosition: 0,
                addToApproval: (data.addToApproval) ? data.addToApproval : false,
                needsApprovedBy: 'one',
                source: data.id ? 'scheduled' : null,
                resetAccounts: _this.resetAccounts,
                getLastSelectedAccountByType: _this.getLastSelectedAccountByType,
                has_only_one_image: _this.has_only_one_image,
                pinterestLink: (data.pinterestLink) ? data.pinterestLink : '',
            };
            post.displayOptions.postApproval = (['free', 'individual', 'basic'].indexOf(_this.userSettingsProvider.getLicenseType()) === -1);
            if (data.source && ['scheduled', 'draft', 'postapproval'].indexOf(data.source) !== -1) {
                post.source = data.source;
            }
            if (typeof data == 'undefined' || data.pending === true)
                data.pending = true;
            if (data && typeof data.callsToAction === 'object') {
                post.callsToAction = data.callsToAction;
            }
            //prepare attachments
            post.attachments = _this.prepareAttachments(data, post);
            post.scheduledTimes = _this.prepareScheduledTimes(data);
            post.accounts = _this.prepareAccounts(data);
            if (data.content && typeof data.content != 'object')
                post.content = data.content;
            post.content = __WEBPACK_IMPORTED_MODULE_3__publishing_helper__["e" /* getDecodedHtmlContent */](post.content);
            post.subject = data.postTitle || '';
            post.id = data.id || null;
            post.emailNotification = data.emailNotification || false;
            post.isScheduled = data.isScheduled || false;
            post.draftTime = data.draftTime || '';
            post.postTime = data.postTime || [];
            post.created = data.createTime || '';
            post.queueIdSource = data.queueIdSource || "";
            post.queueTypeSource = data.queueTypeSource || "";
            post.pendingStatus = data.pendingStatus || "";
            if (data.needsApprovedBy && typeof data.needsApprovedBy == "string")
                post.needsApprovedBy = data.needsApprovedBy;
            //assigned users
            if (data.assignedUsers && data.assignedUsers.user) {
                data.assignedUsers.user = (Array.isArray(data.assignedUsers.user)) ? data.assignedUsers.user : [data.assignedUsers.user];
                post.assignedUsers = data.assignedUsers.user;
            }
            if (data.assignedUsersList && data.assignedUsersList.user) {
                data.assignedUsersList.user = (Array.isArray(data.assignedUsersList.user)) ? data.assignedUsersList.user : [data.assignedUsersList.user];
                post.assignedUsersDetails = data.assignedUsersList.user;
            }
            //pendingQueues
            if (data.pendingQueues) {
                if (data.pendingQueues.queueId)
                    data.pendingQueues = [data.pendingQueues];
                else if (Array.isArray(data.pendingQueues))
                    data.pendingQueues = data.pendingQueues;
                else
                    data.pendingQueues = [];
                post.pendingQueues = data.pendingQueues;
            }
            //pendingComments
            if (data.pendingComment && data.pendingComment.comment) {
                data.pendingComment.comment = (Array.isArray(data.pendingComment.comment)) ? data.pendingComment.comment : [data.pendingComment.comment];
                post.pendingComment = data.pendingComment.comment;
            }
            if (data.getIsIGStory && typeof data.getIsIGStory == "string") {
                if (data.getIsIGStory == 'true')
                    post.isIGStory = true;
                else if (data.getIsIGStory == 'false')
                    post.isIGStory = false;
            }
            else if (data.isIGStory && typeof data.isIGStory == "string") {
                if (data.isIGStory == 'true')
                    post.isIGStory = true;
                else if (data.isIGStory == 'false')
                    post.isIGStory = false;
            }
            if (data.links != undefined && data.links.link != undefined) {
                post.links = data.links.link;
                if (!Array.isArray(post.links))
                    post.links = [post.links];
                post.link = (post.link == "" && post.links[0] != undefined && post.links[0].long != undefined) ? post.links[0].long : post.link;
            }
            else
                post.links = [];
            if (data.preview_content && typeof data.preview_content === 'string') {
                var preview_content = JSON.parse(data.preview_content);
                if (!__WEBPACK_IMPORTED_MODULE_4_jquery__["isEmptyObject"](preview_content)) {
                    post.previewContent = {
                        title: preview_content.title ? preview_content.title : '',
                        description: preview_content.description ? preview_content.description : '',
                        image: preview_content.image ? preview_content.image : [],
                        twitterData: preview_content.twitter_data ? preview_content.twitter_data : {},
                        twitterTag: preview_content.twitter_tag ? preview_content.twitter_tag : false,
                        scrappedUrl: ''
                    };
                    if (preview_content.url) {
                        post.previewContent.url = preview_content.url;
                    }
                    if (post.previewContent.image) {
                        var images = [];
                        if (Array.isArray(post.previewContent.image)) {
                            images = post.previewContent.image;
                        }
                        else {
                            images = [post.previewContent.image];
                        }
                        if (images.length) {
                            var originalData = images[0];
                            originalData.previewContent = __WEBPACK_IMPORTED_MODULE_4_jquery__["extend"](true, {}, post.previewContent);
                            var attachment = {
                                originalData: originalData,
                                url: {
                                    full: originalData.src,
                                    thumbnail: originalData.src,
                                    isVideo: false,
                                    isScrapped: true
                                }
                            };
                            post.scrappedAttachments = [attachment];
                        }
                    }
                }
            }
            // set hashtags count
            var hashTags = __WEBPACK_IMPORTED_MODULE_3__publishing_helper__["a" /* extractHashtags */](post.content);
            post.hashTagsCount = hashTags.length;
            // FB Content Replacement
            if (data.fbContentReplacement) {
                if (!Array.isArray(data.fbContentReplacement)) {
                    data.fbContentReplacement = [data.fbContentReplacement];
                }
                post.fbContentReplacement = data.fbContentReplacement;
            }
            // post.htmlContent = post.wrapFBMentions(post.content);
            // post.htmlContent = post.wrapTWMentions(post.content);
            post.htmlContent = post.content;
            // update CharactersLimit
            _this.updateCharactersLimit();
            resolve(post);
        });
    };
    PublishingMapPostProvider.prototype.prepareAccounts = function (data) {
        if (data === void 0) { data = {}; }
        var accounts = [];
        if (typeof data == 'undefined')
            return accounts;
        if (typeof data.accounts == 'undefined')
            return accounts;
        if (typeof data.accounts.account == 'undefined')
            return accounts;
        if (!Array.isArray(data.accounts.account)) {
            data.accounts.account = [data.accounts.account];
        }
        for (var i in data.accounts.account) {
            var currentAccount = data.accounts.account[i];
            var selectedProfile = { selected: true };
            var selectedGroups = [];
            if (currentAccount.config.groupIds && currentAccount.config.groupIds.groupId) {
                if (Array.isArray(currentAccount.config.groupIds.groupId)) {
                    selectedGroups = currentAccount.config.groupIds.groupId;
                }
                else {
                    selectedGroups.push(currentAccount.config.groupIds.groupId);
                }
            }
            var profile = this._accountsServiceProvider.getProfileByID(currentAccount.config.sampleId);
            if (!profile) {
                continue;
            }
            if (selectedGroups.length && profile && profile.data.groups
                && Array.isArray(profile.data.groups) && profile.data.groups.length) {
                if (selectedGroups.indexOf('_self_') !== -1) {
                    selectedProfile.profile = profile;
                    accounts.push(selectedProfile);
                    selectedGroups.splice(selectedGroups.indexOf('_self_'), 1);
                }
                var _loop_1 = function (selectedGroup) {
                    var currentGroupData = profile.data.groups.filter(function (group) { return group.id === selectedGroup; });
                    if (Array.isArray(currentGroupData) && currentGroupData.length && currentGroupData[0].id) {
                        console.log('ASDASD', profile, selectedGroup, currentGroupData);
                        var selectedGroupProfile = {
                            selected: true,
                            profile: profile,
                            isGroup: true,
                            group: {
                                id: currentGroupData[0].id,
                                name: currentGroupData[0].name,
                                profileId: profile.profile_id
                            }
                        };
                        accounts.push(selectedGroupProfile);
                    }
                };
                for (var _i = 0, selectedGroups_1 = selectedGroups; _i < selectedGroups_1.length; _i++) {
                    var selectedGroup = selectedGroups_1[_i];
                    _loop_1(selectedGroup);
                }
            }
            else {
                selectedProfile.profile = profile;
                accounts.push(selectedProfile);
            }
        }
        return accounts;
    };
    PublishingMapPostProvider.prototype.prepareAttachments = function (data, postData) {
        if (postData === void 0) { postData = null; }
        var attachments = [];
        if (typeof data.postAttachment == 'undefined')
            return attachments;
        if (!Array.isArray(data.postAttachment)) {
            data.postAttachment = [data.postAttachment];
        }
        for (var i in data.postAttachment) {
            var currentAttachment = data.postAttachment[i];
            if (postData && currentAttachment.pinterestLink && typeof currentAttachment.pinterestLink == 'string') {
                postData.pinterestLink = currentAttachment.pinterestLink;
                console.log('prepareAttachments', currentAttachment.pinterestLink);
            }
            //Ignore if specificAccounts contains Twitter or Pinterest
            if (currentAttachment.specificAccounts) {
                if (currentAttachment.specificAccounts === 'string'
                    && currentAttachment.specificAccounts.indexOf('Twitter') === -1
                    && currentAttachment.specificAccounts.indexOf('Pinterest') === -1) {
                    continue;
                }
            }
            //VideoMetadata
            if (currentAttachment.videoData != undefined && currentAttachment.videoData.videoMetaData != undefined) {
                currentAttachment.videoData.videoMetaData = JSON.parse(currentAttachment.videoData.videoMetaData);
            }
            //dimension parse
            if (typeof currentAttachment.name === 'string') {
                var dimension = currentAttachment.name.match(/ecsize\_(.*)/g);
                if (dimension && dimension[0] != undefined) {
                    currentAttachment.dimension = {};
                    dimension = dimension[0].replace('ecsize_', '').split('_');
                    if (dimension[0] != undefined) {
                        currentAttachment.dimension.width = (!isNaN(parseInt(dimension[0]))) ? parseInt(dimension[0]) : "";
                    }
                    if (dimension[1] != undefined) {
                        currentAttachment.dimension.height = (!isNaN(parseInt(dimension[1]))) ? parseInt(dimension[1]) : "";
                    }
                    if (dimension[2] != undefined) {
                        currentAttachment.dimension.size = (!isNaN(parseInt(dimension[2]))) ? parseInt(dimension[2]) : "";
                    }
                }
            }
            var attachment = {
                originalData: currentAttachment,
                url: {
                    full: this._appSettingsProvider.getS3Url() + '/dev-eclincher/' + currentAttachment.location,
                    thumbnail: this._appSettingsProvider.getS3Url() + '/' + currentAttachment.imageThumbnail
                }
            };
            if (currentAttachment.externalLocation && currentAttachment.externalLocation.indexOf('://') === -1) {
                attachment.url.full = this._appSettingsProvider.getS3Url() + '/' + currentAttachment.externalLocation;
            }
            if (!currentAttachment.imageThumbnail) {
                attachment.url.thumbnail = attachment.url.full;
            }
            if (currentAttachment.type) {
                if (currentAttachment.type === 'video') {
                    attachment.url.isVideo = true;
                    if (!attachment.originalData.s3_url) {
                        attachment.originalData.s3_url = attachment.originalData.location;
                    }
                }
                else {
                    attachment.url.isVideo = false;
                }
            }
            attachments.push(attachment);
        }
        return attachments;
    };
    PublishingMapPostProvider.prototype.prepareScheduledTimes = function (data) {
        if (data === void 0) { data = {}; }
        var scheduledTimes = [];
        if (typeof data == 'undefined')
            return scheduledTimes;
        if (typeof data.postTime == 'undefined')
            return scheduledTimes;
        if (!Array.isArray(data.postTime)) {
            data.postTime = [data.postTime];
        }
        for (var _i = 0, _a = data.postTime; _i < _a.length; _i++) {
            var postTime = _a[_i];
            if (typeof postTime == 'object') {
                scheduledTimes.push(postTime.time);
            }
            else {
                scheduledTimes.push(postTime.replace(/[^0-9]+/g, '').slice(0, 10));
            }
        }
        return scheduledTimes;
    };
    PublishingMapPostProvider.prototype.checkPostDataIgstroy = function (postData) {
        if (postData.has_only_instagram_business_profile && postData.getAttachmentCount(true) == 1) {
            postData.isIGStory = false;
        }
        else {
            postData.isIGStory = true;
        }
    };
    PublishingMapPostProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__accounts_service_accounts_service__["a" /* AccountsServiceProvider */],
            __WEBPACK_IMPORTED_MODULE_2__app_settings_app_settings__["a" /* AppSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__user_settings_user_settings__["a" /* UserSettingsProvider */]])
    ], PublishingMapPostProvider);
    return PublishingMapPostProvider;
}());

;
//# sourceMappingURL=publishing-map-post.js.map

/***/ }),

/***/ 64:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["c"] = extractUrls;
/* harmony export (immutable) */ __webpack_exports__["a"] = extractHashtags;
/* harmony export (immutable) */ __webpack_exports__["b"] = extractMentions;
/* unused harmony export getInstagramHashTags */
/* harmony export (immutable) */ __webpack_exports__["h"] = getWeightedLength;
/* harmony export (immutable) */ __webpack_exports__["e"] = getDecodedHtmlContent;
/* harmony export (immutable) */ __webpack_exports__["g"] = getUUID;
/* unused harmony export addGoogleUtmParams */
/* harmony export (immutable) */ __webpack_exports__["q"] = validateShortLinkDomains;
/* harmony export (immutable) */ __webpack_exports__["d"] = getDayNumberOfWeek;
/* harmony export (immutable) */ __webpack_exports__["i"] = htmlFromText;
/* unused harmony export for_each */
/* harmony export (immutable) */ __webpack_exports__["l"] = parseHashTagsFromFeed;
/* unused harmony export decodeHTMLEntities */
/* harmony export (immutable) */ __webpack_exports__["f"] = getFbActionTypes;
/* harmony export (immutable) */ __webpack_exports__["p"] = unique_name_with_uuid;
/* harmony export (immutable) */ __webpack_exports__["m"] = s3Url;
/* harmony export (immutable) */ __webpack_exports__["o"] = textCopyToClipboard;
/* harmony export (immutable) */ __webpack_exports__["k"] = ordinalSuffixOf;
/* harmony export (immutable) */ __webpack_exports__["n"] = sanitizeString;
/* unused harmony export convertGmbEventToTimestamps */
/* harmony export (immutable) */ __webpack_exports__["j"] = isvalidUrl;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_twitter_text__ = __webpack_require__(334);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_twitter_text___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_twitter_text__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_jquery__);


function extractUrls(content) {
    var urls = __WEBPACK_IMPORTED_MODULE_0_twitter_text__["extractUrlsWithIndices"](content);
    return urls;
}
function extractHashtags(content) {
    // let tags = twttrTxt.extractHashtags(content);
    var tags = getInstagramHashTags(content);
    return tags;
}
function extractMentions(content) {
    var mentions = __WEBPACK_IMPORTED_MODULE_0_twitter_text__["extractMentions"](content);
    return mentions;
}
function getInstagramHashTags(inputText) {
    var alphaCharsStr = 'A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1'
        + '\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF'
        + '\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985'
        + '-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35'
        + '\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10'
        + '\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8'
        + '-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE'
        + '\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32'
        + '\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF'
        + '\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC'
        + '-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A'
        + '\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16F1-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780'
        + '-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B'
        + '\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50'
        + '-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C'
        + '\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2'
        + '\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031'
        + '-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C'
        + '\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882'
        + '-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A'
        + '\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65'
        + '\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-'
        + '\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC';
    // regex = /(?:#)([A-Za-z0-9_](?:(?:[A-Za-z0-9_]|(?:\.(?!\.))){0,28}(?:[A-Za-z0-9_]))?)/gm;
    var match, matches = [], regex = new RegExp('(?:#)([' + alphaCharsStr + '0-9_](?:(?:[' + alphaCharsStr + '0-9_]|(?:\.(?!\.))){0,28}(?:[' + alphaCharsStr + '0-9_]))?)', 'gm');
    while ((match = regex.exec(inputText))) {
        matches.push(match[1]);
    }
    return matches;
}
;
function getWeightedLength(text) {
    return __WEBPACK_IMPORTED_MODULE_0_twitter_text__["parseTweet"](text).weightedLength;
}
;
function getDecodedHtmlContent(string) {
    if (typeof string !== 'string')
        return string;
    var decodeElem = document.createElement('textarea');
    decodeElem.innerHTML = string;
    string = decodeElem.value;
    return string;
}
function getUUID() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0, v = c === 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
}
function addGoogleUtmParams(url, utmParams) {
    if (typeof url !== 'string')
        url = '';
    if (url.indexOf('snip.ly') == -1 && utmParams && url.indexOf('utm_source') == -1 && url.indexOf('utm_medium') == -1 && url.indexOf('utm_content') == -1 && url.indexOf('utm_campaign') == -1) {
        ['utmSource', 'utmMedium', 'utmContent', 'utmCampaign'].forEach(function (name) {
            if (utmParams[name] && utmParams[name] != '') {
                url += (url.indexOf('?') === -1 ? '?' : '&') + 'utm_' + name.split('utm')[1].toLowerCase() + '=' + encodeURIComponent(utmParams[name]);
            }
        });
    }
    return url;
}
function validateShortLinkDomains($str) {
    var shortLinkDomains = ['bit.do',
        't.co',
        'lnkd.in',
        'db.tt',
        'qr.ae',
        'adf.ly',
        'goo.gl',
        'bitly.com',
        'cur.lv',
        'tinyurl.com',
        'ow.ly',
        'bit.ly',
        'ity.im',
        'q.gs',
        'is.gd',
        'po.st',
        'bc.vc',
        'twitthis.com',
        'u.to',
        'j.mp',
        'buzurl.com',
        'cutt.us',
        'u.bb',
        'yourls.org',
        'x.co',
        'prettylinkpro.com',
        'scrnch.me',
        'filoops.info',
        'vzturl.com',
        'qr.net',
        '1url.com',
        'tweez.me',
        'v.gd',
        'tr.im',
        'link.zip.net',
        'adcraft.co',
        'adcrun.ch',
        'adflav.com',
        'aka.gr',
        'bee4.biz',
        'cektkp.com',
        'dft.ba',
        'fun.ly',
        'fzy.co',
        'gog.li',
        'golinks.co',
        'hit.my',
        'id.tl',
        'linkto.im',
        'lnk.co',
        'nov.io',
        'p6l.org',
        'picz.us',
        'shortquik.com',
        'su.pr',
        'sk.gy',
        'tota2.com',
        'xlinkz.info',
        'xtu.me',
        'yu2.it',
        'zpag.es', 'tcrn.ch'];
    $str = $str.replace('http://', '');
    $str = $str.replace('https://', '');
    $str = $str.replace('://', '');
    $str = $str.split('?')[0];
    $str = $str.split('/')[0];
    if ($str.indexOf('.goo.gl') != -1) {
        return true;
    }
    for (var $i = 0; $i < shortLinkDomains.length; $i++) {
        if ($str == shortLinkDomains[$i]) {
            return true;
        }
    }
    return false;
}
function getDayNumberOfWeek(dayName) {
    if (dayName === void 0) { dayName = 'monday'; }
    var days = ['sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday'];
    return (days.indexOf(dayName) !== -1) ? days.indexOf(dayName) : 0;
}
function htmlFromText(str) {
    str = str.toString();
    return str
        .replace(/&/g, '&amp;')
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;')
        .replace(/"/g, '&quot;')
        .replace(/'/g, '&#x27;')
        .replace(/`/g, '&#x60;')
        .replace(/(?:\r\n|\r|\n)/g, '\n')
        .replace(/(\n+)/g, '<div>$1</div>')
        .replace(/\n/g, '<br/>')
        .replace(/<br\/><\/div>/g, '</div>');
}
function for_each(array, fn) {
    array = Array.isArray(array) ? array : [array];
    for (var index = 0, length_1 = array.length; index < length_1; ++index)
        fn(array[index], index, length_1);
}
;
function parseHashTagsFromFeed(data, type) {
    var htMap = Object.create(null), htArray = [];
    var l = data.length;
    if (type == 'instabusiness') {
        for (var i = 0; i < l; i++) {
            var mediaDescription = decodeHTMLEntities(data[i].mediaDescription);
            if (typeof mediaDescription === 'string') {
                var mediaHt = getInstagramHashTags(mediaDescription);
                mediaHt.forEach(function (ht) {
                    if (ht in htMap)
                        htMap[ht] += 1;
                    else
                        htMap[ht] = 1;
                });
            }
        }
    }
    else if (type == 'twitter') {
        for (var i = 0; i < l; i++) {
            var entities = data[i].entities;
            if (entities.hashtags && entities.hashtags.text) {
                for_each(entities.hashtags.text, function (ht) {
                    if (ht in htMap)
                        htMap[ht] += 1;
                    else
                        htMap[ht] = 1;
                });
            }
        }
    }
    Object.keys(htMap).forEach(function (key) {
        var freq = htMap[key];
        htArray.push({ name: key, freq: freq, rel: Math.round(100 * freq / l) });
    });
    htArray.sort(function (a, b) {
        if (b.freq > a.freq)
            return 1;
        else if (b.freq < a.freq)
            return -1;
        else {
            var nameA = (typeof a.name === 'string' ? a.name.toLowerCase() : '');
            var nameB = (typeof b.name === 'string' ? b.name.toLowerCase() : '');
            if (nameA > nameB)
                return 1;
            else if (nameA < nameB)
                return -1;
            else
                return 0;
        }
    });
    htArray = htArray.slice(0, 30);
    return htArray;
}
function decodeHTMLEntities(encodedString) {
    if (typeof encodedString !== 'string')
        return encodedString;
    var textArea = document.createElement('textarea');
    textArea.innerHTML = encodedString;
    return textArea.value;
}
;
function getFbActionTypes() {
    return [
        { label: 'No button', action: 'EMPTY' },
        { label: 'Contact us', action: 'CONTACT_US' },
        { label: 'Donate', action: 'DONATE' },
        { label: 'Download', action: 'DOWNLOAD' },
        { label: 'Get directions', action: 'GET_DIRECTIONS' },
        { label: 'Learn more', action: 'LEARN_MORE' },
        { label: 'Shop now', action: 'SHOP_NOW' },
        { label: 'Sign up', action: 'SIGN_UP' },
        { label: 'Watch video', action: 'WATCH_VIDEO' },
        { label: 'Watch more', action: 'WATCH_MORE' },
        { label: 'Get offer', action: 'GET_OFFER' },
        { label: 'Buy now', action: 'BUY_NOW' },
        { label: 'Buy tickets', action: 'BUY_TICKETS' },
        { label: 'Order now', action: 'ORDER_NOW' },
        { label: 'Sell now', action: 'SELL_NOW' },
        { label: 'Call', action: 'CALL' },
        { label: 'Apply now', action: 'APPLY_NOW' },
        { label: 'Get quote', action: 'GET_QUOTE' },
        { label: 'Subscribe', action: 'SUBSCRIBE' },
        { label: 'Vote now', action: 'VOTE_NOW' },
        { label: 'See menu', action: 'SEE_MENU' }
    ];
}
;
function unique_name_with_uuid(suffix, prefix) {
    if (suffix === void 0) { suffix = ""; }
    if (prefix === void 0) { prefix = ""; }
    var name = '';
    suffix = (!suffix) ? "" : suffix;
    prefix = (!prefix) ? "" : suffix;
    var d = new Date();
    var n = d.getTime();
    name = prefix + getUUID() + '_' + n + suffix;
    return name;
}
function s3Url(link) {
    return (link.indexOf("://") == -1) ? "https://s3.amazonaws.com/" + link : link;
}
;
function textCopyToClipboard(text) {
    // Create a new textarea element and give it id='t'
    var textarea = document.createElement('textarea');
    textarea.id = 't';
    // Optional step to make less noise on the page, if any!
    textarea.style.height = 0;
    // Now append it to your page somewhere, I chose <body>
    document.body.appendChild(textarea);
    // Give our textarea a value of whatever inside the div of id='to-copy'
    textarea.value = text;
    // Now copy whatever inside the textarea to clipboard
    var selector = document.querySelector('#t');
    selector.select();
    document.execCommand('copy');
    // Remove the textarea
    document.body.removeChild(textarea);
}
function ordinalSuffixOf(i) {
    var j = i % 10, k = i % 100;
    if (j == 1 && k != 11) {
        return "st";
    }
    if (j == 2 && k != 12) {
        return "nd";
    }
    if (j == 3 && k != 13) {
        return "rd";
    }
    return "th";
}
function sanitizeString(str) {
    return __WEBPACK_IMPORTED_MODULE_1_jquery__('<div/>').html(str).text();
}
function convertGmbEventToTimestamps(gmbEventData, momentObj) {
    var timeStamps = {
        eventStart: 0,
        eventEnd: 0
    };
    var startDtaeStr, endDtaeStr = "";
    startDtaeStr = gmbEventData.startYear + '-' + gmbEventData.startMonth + '-' + gmbEventData.startDay;
    startDtaeStr += ' ' + gmbEventData.startHours + ':' + gmbEventData.startMinutes;
    endDtaeStr = gmbEventData.endYear + '-' + gmbEventData.endMonth + '-' + gmbEventData.endDay;
    endDtaeStr += ' ' + gmbEventData.endHours + ':' + gmbEventData.endMinutes;
    //console.log('startDate', startDtaeStr);
    // console.log('end date', endDtaeStr);
    timeStamps.eventStart = momentObj(startDtaeStr, "YYYY-MM-DD HH:mm").unix();
    timeStamps.eventEnd = momentObj(endDtaeStr, "YYYY-MM-DD HH:mm").unix();
    return timeStamps;
}
;
function isvalidUrl(url) {
    return __WEBPACK_IMPORTED_MODULE_0_twitter_text__["isValidUrl"](url);
}
;
//# sourceMappingURL=publishing-helper.js.map

/***/ }),

/***/ 73:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InstagramFeedItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__ = __webpack_require__(61);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__ = __webpack_require__(30);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
//CLASSES


var InstagramFeedItem = /** @class */ (function (_super) {
    __extends(InstagramFeedItem, _super);
    function InstagramFeedItem(http, data, feed) {
        var _this = _super.call(this, http, data, feed) || this;
        _this.header = null;
        _this.summary = {};
        _this.actionButtons = {};
        //prepare data
        _this.prepareData();
        return _this;
    }
    /**
    * prepareData
    */
    InstagramFeedItem.prototype.prepareData = function () {
        this.header = {
            profile: this.profile,
            eventType: this.feed.stream.name,
            eventDate: this.data.eventTime
        };
        if (this.feed.id === 'igbInbox' && this.data.user)
            this.data.user.username = this.data.user.full_name;
        if (typeof this.data.type === 'string')
            this.data.type = this.data.type.toLowerCase();
        //tags for inbox
        if (this.feed.id === 'cinbox' || this.feed.id === 'inBox') {
            this.header.eventType = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["j" /* formatEventType */](this.data.eventType, this.data);
            this.header.eventTags = {
                selectedTagsArray: this.data.tags,
                hasTags: Boolean(this.data.tags.length)
            };
            if (Array.isArray(this.data.roles) && this.data.roles.length > 0) {
                this.header.assignedRoles = {
                    selectedRoles: this.getAssignedRoles(),
                    hasRoles: false
                };
            }
        }
        this.summary.messageView = {
            sender: {
                senderName: this.getSenderName(),
                createdDate: this.getCreatedDate(),
                twittterHandle: this.getScreenName(),
                senderProfileImage: this.getProfilePic(),
                senderProfileURL: ''
            },
            messageText: this.getMessageText(),
            tags: this.getAssignedTagsAndRoles(),
        };
        //SCREEN NAME
        if (this.getScreenName() !== '') {
            this.summary.messageView.sender.twittterHandle = this.getScreenName();
        }
        //PREPARE MEDIA
        var media = this.getMedia();
        if (media.mediaUrl != '') {
            this.summary.messageView.media = media;
        }
        //Prepare actionHeaders
        this.actionHeader = {};
        this.getActionHeaders();
        //ACTION BUTTONS
        this.getActionButtons();
        // update action buttons
        if (this.feed.network === 'cinbox') {
            this.actionButtons.completeItem = { highlighted: false };
            if (this.data.ecCompleted === 'true') {
                this.actionButtons.completeItem.highlighted = true;
            }
        }
    };
    InstagramFeedItem.prototype.getSenderName = function () {
        var senderName = '';
        console.log("getSenderName", this.data);
        if (typeof this.data.user.full_name == 'string') {
            senderName = this.data.user.username + ' (' + this.data.user.full_name + ')';
        }
        else {
            senderName = this.data.user.username;
        }
        if (this.feed.id === 'ig_relationships' || this.feed.id === 'igbInbox'
            || (this.feed.options.search && this.feed.options.parameters.type === 'users')) {
            senderName = this.data.user.username;
        }
        else if (this.feed.id === 'igbTags')
            senderName = this.data.user.full_name;
        return senderName;
    };
    InstagramFeedItem.prototype.getCreatedDate = function () {
        if (this.feed.id !== 'ig_relationships') {
            if (this.network === 'instabusiness')
                return parseInt(this.data.created_time) * 1000;
            else
                return (new Date(this.data.created_time)).getTime();
        }
        return 0;
    };
    InstagramFeedItem.prototype.getScreenName = function () {
        var screenName = '';
        if (this.feed.id === 'ig_relationships' && typeof this.data.user.full_name === 'string') {
            screenName = this.data.user.full_name;
        }
        return screenName;
    };
    InstagramFeedItem.prototype.getProfilePic = function () {
        var profilePicture = 'https://app.eclincher.com/img/no_user_image.jpg';
        if (typeof this.data.user.profile_picture === 'string' && this.data.user.profile_picture.indexOf('https:') !== -1) {
            profilePicture = this.data.user.profile_picture;
        }
        return profilePicture;
    };
    InstagramFeedItem.prototype.getMessageText = function () {
        var messageText = '';
        if (this.data.caption != undefined) {
            if (this.data.eventType) {
                this.data.caption.text = this.convertToHTML(this.data.caption.text);
                var text = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](this.data.caption.text);
                // if (this.data.eventType === 'INComments') {
                //     messageText = '<span class="comment-subtitle">' + FeedHelper.replace_type_in_username(this.profile.display.profile_name) + '\'s Post:</span> ';
                //     messageText += this.data.my_post_text + '<br><br><span class="comment-subtitle">' + this.getSenderName() + '\'s Comment:</span> ' + text;
                //     this.isCommentView = true;
                // } else {
                //     messageText = '<span class="comment-subtitle">' + this.getSenderName() + '\'s Mention:</span> ' + text;
                //     this.isCommentView = true;
                // }
                messageText = text;
            }
        }
        if (this.feed.id === 'igbInbox' && this.data.comments && this.data.comments.comment && this.data.comments.comment.length) {
            var comment = this.data.comments.comment[0];
            if (typeof comment.message === 'string')
                messageText = comment.message;
            if (this.data.caption)
                this.data.caption.id = comment.messageId;
            if (comment.fromId === this.profile.original_config.page_id)
                messageText = 'You: ' + messageText;
        }
        return messageText;
    };
    InstagramFeedItem.prototype.getMedia = function () {
        var media = {
            isImage: true,
            alt: '',
            mediaUrl: '',
            gallery: []
        };
        if (this.data.caption != undefined) {
            media.mediaOriginalPagePreview = __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["y" /* url_to_link */](this.data.caption.text);
        }
        if (this.feed.id !== 'ig_relationships') {
            if ((this.data.type === 'carousel' && (this.data.carousel_media == null || this.data.carousel_media.media == null))
                || this.data.type === 'carousel_album') {
                if (this.data.videos)
                    this.data.type = 'video';
                else
                    this.data.type = 'image';
            }
            if (this.feed.network === 'instagram' && this.data.type === 'carousel' && this.data.carousel_media
                && this.data.videos && this.data.videos.standard_resolution && this.data.videos.low_resolution
                && this.data.images && this.data.images.standard_resolution && this.data.images.thumbnail) {
                if (!Array.isArray(this.data.carousel_media.media))
                    this.data.carousel_media.media = [this.data.carousel_media.media];
                this.data.carousel_media.media.forEach(function (media) {
                    if (media.type !== 'video')
                        media.type = 'image';
                });
                this.data.carousel_media.media.push({
                    standard_resolution: this.data.images.standard_resolution,
                    thumbnail: this.data.images.thumbnail.url,
                    type: 'video',
                    videos: {
                        standard_resolution: this.data.videos.standard_resolution,
                        low_resolution: this.data.videos.low_resolution
                    }
                });
            }
            if (this.data.type == "image") {
                //Media URL
                media.mediaUrl = this.data.images.standard_resolution.url;
                media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
            }
            else if (this.data.type == "video") {
                //Media URL
                media.mediaUrl = this.data.images.standard_resolution.url;
                if (this.data.eventType === 'INMentions' && !this.data.images.standard_resolution.url) {
                    media.mediaUrl = this.defaultThumbImage;
                }
                media.isImage = false;
                if (this.data.videos && this.data.videos.standard_resolution && this.data.videos.standard_resolution.url && typeof this.data.videos.standard_resolution.url == 'string') {
                    // media.videoUrl = encodeURI(this.data.videos.standard_resolution.url.replace('http://', 'https://'))
                    media.videoUrl = this.data.videos.standard_resolution.url.replace('http://', 'https://');
                }
                else {
                    // media.videoUrl = encodeURI(media.mediaUrl);
                    media.videoUrl = media.mediaUrl;
                }
            }
            else if (this.data.type === 'carousel') {
                var carousel_media = this.data.carousel_media.media;
                if (!Array.isArray(carousel_media))
                    carousel_media = [carousel_media];
                //Media URL
                for (var i in carousel_media) {
                    media.gallery.push(this.prepareGalleyImage(carousel_media[i].standard_resolution.url));
                    if (media.gallery.length === 1) {
                        media.mediaUrl = carousel_media[i].standard_resolution.url;
                    }
                }
            }
            else {
                if (typeof this.data.images !== 'undefined' && __WEBPACK_IMPORTED_MODULE_1__feeds_feed_helper__["o" /* isEmptyObject */](this.data.images.standard_resolution.url)) {
                }
                else if (typeof this.data.media !== 'undefined') {
                    //Media URL
                    media.mediaUrl = this.data.media.src;
                    //Media Link
                    media.mediaOriginalPageContent = this.data.name || '';
                    media.mediaOriginalPageUrl = this.data.media.href;
                    media.gallery.push(this.prepareGalleyImage(media.mediaUrl));
                }
                if (this.feed.id === 'igbInbox' && this.data.comments && this.data.comments.comment && this.data.comments.comment.length) {
                    var comment = this.data.comments.comment[0];
                    if (comment.media) {
                        media.mediaUrl = comment.media.src;
                        media.gallery = [{
                                originalData: '',
                                url: {
                                    full: comment.media.src,
                                    thumbnail: comment.media.src
                                }
                            }];
                    }
                }
            }
        }
        else {
        }
        return media;
    };
    InstagramFeedItem.prototype.getActionHeaders = function () {
        if (this.feed.id !== 'ig_relationships' && this.feed.id !== 'igbInbox' /* && ( !this.feed.options.search || this.feed.options.parameters.type !== 'users' ) */) {
            if (!this.data.eventType) {
                //Likes
                if (this.data.likes == undefined)
                    this.actionHeader.likes = { count: 0 };
                else {
                    if (parseInt(this.data.likes.count) == 1)
                        this.data.likes.like = [this.data.likes.like];
                    this.actionHeader.likes = { count: this.data.likes.count };
                    if (parseInt(this.data.likes.count) > 0)
                        this.actionHeader.likes.highlighted = true;
                }
                //Comments
                if (this.data.comments == undefined) {
                    this.actionHeader.comments = { count: 0 };
                }
                else {
                    if (parseInt(this.data.comments.count) == 1) {
                        this.data.comments.comment = [this.data.comments.comment];
                    }
                    this.actionHeader.comments = { count: this.data.comments.count };
                    if (this.actionHeader.comments.count > 0)
                        this.actionHeader.comments.highlighted = true;
                }
            }
        }
        if (this.feed.id === 'igbStories' || this.feed.id === 'igbInbox') {
            this.actionHeader = {};
        }
    };
    InstagramFeedItem.prototype.getActionButtons = function () {
        if (this.feed.id !== 'ig_relationships' /* && ( !this.feed.options.search || this.feed.options.parameters.type !== 'users' ) */) {
            if (!this.data.eventType) {
                if (this.network === 'instabusiness') {
                    if (this.feed.id != "search" && this.feed.id != "igbTags" && this.feed.id != "igbInbox") {
                        this.actionButtons.comment = {
                            highlighted: false,
                            id: this.data.id,
                            text: ''
                        };
                    }
                    // this.actionButtons.comment = {
                    //     highlighted: false,
                    //     id: this.data.id,
                    //     text: ''
                    // };
                }
                else {
                    if (typeof this.data.link === 'string') {
                        this.actionButtons.showInInstagram = true;
                    }
                }
            }
            else {
                //Inbox
                if (this.data.eventType === 'INComments') {
                    if (this.network === 'instabusiness') {
                        this.actionButtons.reply = {
                            highlighted: (this.data.ecReply == 'true'),
                            id: this.data.id,
                            text: '@' + this.data.user.username + ' '
                        };
                        if (this.data.business) {
                            this.actionButtons.reply.id = this.data.messageId;
                        }
                        if (typeof this.data.link === 'string') {
                            this.actionButtons.showInInstagram = true;
                        }
                    }
                    else {
                        if (typeof this.data.link === 'string') {
                            this.actionButtons.showInInstagram = true;
                        }
                    }
                    this.actionButtons.showViewLatest = { label: 'View Post & Comments', pageTitle: 'Comments' };
                }
                else if (this.data.eventType === 'INMentions') {
                    if (typeof this.data.link === 'string') {
                        this.actionButtons.showInInstagram = true;
                    }
                }
            }
            if (this.feed.id === 'igbStories') {
                this.actionButtons = {};
            }
            else if (this.feed.id === 'igbInbox') {
                this.actionButtons.reply = {
                    highlighted: false,
                    id: this.data.recipient_id,
                    // text: '@' + this.data.user.username + ' '
                    text: ""
                };
                this.actionButtons.showViewLatest = { label: 'Conversation', pageTitle: 'Conversation' };
            }
        }
        else {
            // ig_relationships
            if (this.feed.group.id == 'follows') {
                this.actionButtons.igFollow = { highlighted: false };
                this.data.outgoing_status = 'follows';
                if (this.data.outgoing_status === 'follows') {
                    this.actionButtons.igFollow.highlighted = true;
                }
            }
        }
    };
    return InstagramFeedItem;
}(__WEBPACK_IMPORTED_MODULE_0__feed_items_feed_item__["a" /* FeedItem */]));

//# sourceMappingURL=instagram-feed-item.js.map

/***/ }),

/***/ 79:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WindowServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/*
  Generated class for the WindowServiceProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var WindowServiceProvider = /** @class */ (function () {
    function WindowServiceProvider(http) {
        this.http = http;
        this.window = window;
    }
    WindowServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */]])
    ], WindowServiceProvider);
    return WindowServiceProvider;
}());

//# sourceMappingURL=window-service.js.map

/***/ }),

/***/ 80:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AuthProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_storage__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment_timezone__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_moment_timezone__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_mergeMap__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_mergeMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_mergeMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs_add_observable_fromPromise__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs_add_observable_fromPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_rxjs_add_observable_fromPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_user_settings_user_settings__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_user_data_user_data__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__facebook_facebook__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_jquery__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_12_jquery__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_rxjs_observable_of__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_rxjs_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_13_rxjs_observable_of__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__publishing_service_publishing_service__ = __webpack_require__(62);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





//rxjs




// import "rxjs/add/observable/throw";
// PROVIDERS






/* Storage is imported in app.module - no need to import here
Meanwhile using IonicStorage. might want to swicth to NativeStorage
import {NativeStorage} from "@ionic-native/native-storage";
 */
var AuthProvider = /** @class */ (function () {
    function AuthProvider(_http, _ionicStorage, _alertController, _facebookProvider, _userSettingsProvider, _userDataProvider, publishingProvider) {
        this._http = _http;
        this._ionicStorage = _ionicStorage;
        this._alertController = _alertController;
        this._facebookProvider = _facebookProvider;
        this._userSettingsProvider = _userSettingsProvider;
        this._userDataProvider = _userDataProvider;
        this.publishingProvider = publishingProvider;
        // source for observable
        this._authStatusSource = new __WEBPACK_IMPORTED_MODULE_6_rxjs_BehaviorSubject__["BehaviorSubject"](false);
        // observable stream
        this.authStatus$ = this
            ._authStatusSource
            .asObservable();
        this.googleTwoStepHashkey = null;
    }
    ;
    /** ------------------ signup ----------------------
   *
   * @param email
   * @param password
   */
    AuthProvider.prototype.signup = function (signupRequestBody) {
        var _this = this;
        console.log("AuthProvider - signup");
        return this
            ._http
            .put("/user/create", signupRequestBody).map(function (signupResponse) {
            if (signupRequestBody.payment === 'agency') {
                return _this._userSettingsProvider.getSettings().subscribe(function (settingsResponse) {
                    signupResponse.all_settings.settings = settingsResponse;
                    return (_this._updateAuthStatusAndUserSettings(signupResponse));
                });
            }
            else {
                return (_this._updateAuthStatusAndUserSettings(signupResponse));
            }
        })
            /*       .flatMap(signupResponse => {
                    return Observable.fromPromise(this._saveUserDataFromHeaders(signupResponse))
                  })
             */ .catch(function (signupError) {
            return __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"].throw(signupError);
        });
    };
    ; // end signup
    /** ------------------ login ----------------------
    *
    * @param  {string} email
    * @param  {string} password
    */
    AuthProvider.prototype.login = function (loginRequestBody) {
        var _this = this;
        return this
            ._http
            .post('/user/login', loginRequestBody).map(function (loginResponse) {
            if (loginResponse.authorizeId) {
                _this.googleTwoStepHashkey = loginResponse.authorizeId;
                return loginResponse;
            }
            else {
                return _this._updateAuthStatusAndUserSettings(loginResponse);
            }
        })
            .catch(function (loginError) {
            return __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"].throw(loginError);
        });
    };
    ; // end login
    /**
    * verifyGoogleTwoStepCode
    */
    AuthProvider.prototype.verifyGoogleTwoStepCode = function (params) {
        var _this = this;
        var data = {};
        data["googleTwoStepCode"] = params.googleTwoStepCode;
        if (params.googleTwoStepKey) {
            data["googleTwoStepKey"] = params.googleTwoStepKey;
        }
        else {
            data["googleTwoStepHashkey"] = this.googleTwoStepHashkey;
        }
        var test = new __WEBPACK_IMPORTED_MODULE_2__angular_common_http__["e" /* HttpParams */]()
            .set("googleTwoStepCode", params.googleTwoStepCode)
            .set("googleTwoStepHashkey", this.googleTwoStepHashkey);
        return this
            ._http
            .get('/user/verifyGoogleTwoStepCode', { params: test })
            .flatMap(function (response) {
            if (response.status) {
                return Object(__WEBPACK_IMPORTED_MODULE_13_rxjs_observable_of__["of"])(_this._updateAuthStatusAndUserSettings(response));
            }
            else {
                return Object(__WEBPACK_IMPORTED_MODULE_13_rxjs_observable_of__["of"])(response);
            }
        });
    };
    /** ------------------ facebook login ----------------------
    */
    AuthProvider.prototype.facebookLogin = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this
                ._facebookProvider
                .login()
                .then(function (facebookResponse) {
                console.log('Hello FacebookProvider Provider', facebookResponse);
                if (facebookResponse && facebookResponse.status && facebookResponse.status === 'connected') {
                    if (facebookResponse.authResponse && facebookResponse.authResponse.userID) {
                        var fbDetails = {
                            authToken: facebookResponse.authResponse.accessToken,
                            expiresIn: facebookResponse.authResponse.expiresIn,
                            session_key: facebookResponse.authResponse.session_key,
                            sig: facebookResponse.authResponse.sig,
                            userID: facebookResponse.authResponse.userID
                        };
                        var userID = facebookResponse.authResponse.userID;
                        var loginRequestBody = {
                            email: 'fb_' + userID,
                            password: 'fb_' + parseInt(userID) * 12,
                            loginType: 'facebookLogin',
                            ajax: true,
                            fbDetails: fbDetails,
                            appVersion: "1.2.5"
                        };
                        _this
                            ._http
                            .post('/user/login', loginRequestBody).subscribe(function (loginResponse) {
                            if (loginResponse.authorizeId) {
                                _this.verifyGoogleTwoStepCode = loginResponse.authorizeId;
                                resolve(loginResponse);
                            }
                            else {
                                resolve(_this._updateAuthStatusAndUserSettings(loginResponse));
                            }
                        });
                    }
                    else {
                        reject('something went wrong!.');
                    }
                }
                else {
                    reject('something went wrong!.');
                }
            }, function (error) {
                if (__WEBPACK_IMPORTED_MODULE_12_jquery__["isEmptyObject"](error)) {
                    reject(error);
                }
                else {
                    var errorMessage = error.errorMessage || '';
                    if (error.errorCode && error.errorCode == '4201') {
                        errorMessage = ''; //User cancelled dialog.
                    }
                    reject(errorMessage);
                }
            });
        });
    };
    ; // end facebook login
    /** ------------------ facebook signup ----------------------
    */
    AuthProvider.prototype.facebookSignup = function (planName) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this
                ._facebookProvider
                .login()
                .then(function (facebookResponse) {
                console.log('Hello FacebookProvider Provider', facebookResponse);
                if (facebookResponse && facebookResponse.status && facebookResponse.status === 'connected') {
                    if (facebookResponse.authResponse && facebookResponse.authResponse.userID) {
                        var authResponse = facebookResponse.authResponse || {};
                        var fbDetails = {
                            authToken: facebookResponse.authResponse.accessToken,
                            expiresIn: facebookResponse.authResponse.expiresIn,
                            session_key: facebookResponse.authResponse.session_key,
                            sig: facebookResponse.authResponse.sig,
                            userID: facebookResponse.authResponse.userID
                        };
                        var userID = facebookResponse.authResponse.userID;
                        var signupRequest = {
                            payment: planName,
                            fname: (authResponse.firstName != undefined) ? authResponse.firstName : "",
                            lname: (authResponse.lastName != undefined) ? authResponse.lastName : "",
                            company: '',
                            phone_no: '',
                            email: 'fb_' + userID,
                            password: 'fb_' + parseInt(userID) * 12,
                            confirmpass: 'fb_' + parseInt(userID) * 12,
                            loginType: 'facebookLogin',
                            terms_agree: 'true',
                            is_mobile_app: 1,
                            timezone: __WEBPACK_IMPORTED_MODULE_4_moment_timezone__["tz"].guess(),
                            utm_source: '',
                            gID: '',
                            fbDetails: fbDetails
                        };
                        signupRequest.email = signupRequest.email.toLowerCase();
                        var loginRequestBody = {
                            email: 'fb_' + userID,
                            password: 'fb_' + parseInt(userID) * 12,
                            loginType: 'facebookLogin',
                            ajax: true,
                            fbDetails: fbDetails,
                            appVersion: "1.2.5"
                        };
                        resolve({ signupRequestBody: signupRequest, loginRequestBody: loginRequestBody });
                    }
                    else {
                        reject('something went wrong!.');
                    }
                }
                else {
                    reject('something went wrong!.');
                }
            }, function (error) {
                if (__WEBPACK_IMPORTED_MODULE_12_jquery__["isEmptyObject"](error)) {
                    reject(error);
                }
                else {
                    var errorMessage = error.errorMessage || '';
                    if (error.errorCode && error.errorCode == '4201') {
                        errorMessage = ''; //User cancelled dialog.
                    }
                    reject(errorMessage);
                }
            });
        });
    };
    ; // end facebook login
    /** ------------------ logout ----------------------
    */
    AuthProvider.prototype.logout = function () {
        var _this = this;
        return this
            ._ionicStorage
            .clear()
            .then(function () {
            _this
                ._userDataProvider.userDataSource
                .next(null);
            //Trigger app.comonent subscription
            _this._authStatusSource.next(false);
            return;
        });
    };
    ; // end logout
    /** -------------------- validateUser -------------------
     */
    AuthProvider.prototype.validateUser = function () {
        var _this = this;
        // Get user_data from Storage        
        return this
            ._ionicStorage
            .get(this._userDataProvider.requestHeadersAndStorageKey)
            .then(function (savedUserDataFromStorage) {
            if (null === savedUserDataFromStorage) {
                return null;
            }
            else {
                // Make a request to get user/settings with user_data in headers
                return _this._http.get("/user/settings", { headers: new __WEBPACK_IMPORTED_MODULE_2__angular_common_http__["d" /* HttpHeaders */]().set("user_data", savedUserDataFromStorage) }).map(function (settingsResponse) {
                    return (_this._updateAuthStatusAndUserSettings(settingsResponse));
                }).catch(function (settingsError) {
                    return settingsError;
                }); //end get /user/settings
            } //end else
        }); //end then
    };
    ; //end validateUser
    /** ------------------ resetPassword ----------------------
     *
     * @param email
     */
    AuthProvider.prototype.forgotPassword = function (email) {
        console.log("AuthProvider - forgotPassword - email - ", email);
        var httpParams = new __WEBPACK_IMPORTED_MODULE_2__angular_common_http__["e" /* HttpParams */]();
        httpParams.set("email", email);
        return this
            ._http
            .get(encodeURI("/user/forgotPassword?email=" + email), { params: httpParams });
    };
    ; //end forgotPassword
    /** ------------------ changePassword ----------------------
     *
     * @param changeBody
     */
    AuthProvider.prototype.changePassword = function (changeBody) {
        var _this = this;
        return this
            ._http
            .post("/user/settings", changeBody).map(function (changePasswordResponse) {
            if (changePasswordResponse && typeof changePasswordResponse.status === 'boolean' && !changePasswordResponse.status) {
                return changePasswordResponse;
            }
            else {
                return (_this._updateAuthStatusAndUserSettings(changePasswordResponse, false));
            }
        }).catch(function (changePasswordResponseError) {
            return changePasswordResponseError;
        }); //end get /user/settings
    };
    ; // end changePassword
    /** ------------------ INTERNAL METHOD ----------------------*/
    AuthProvider.prototype._updateAuthStatusAndUserSettings = function (response, triggerAuthStatus) {
        if (triggerAuthStatus === void 0) { triggerAuthStatus = true; }
        this._userSettingsProvider.getUserRoles().subscribe(function (resp) {
        });
        this.publishingProvider.getApprovalRoles().subscribe();
        var settings;
        if (response["all_settings"]) {
            if (response["all_settings"]["settings"]) {
                //response is from signup
                settings = response["all_settings"]["settings"];
            }
            else {
                //response is from login
                settings = response["all_settings"];
            }
        }
        else if (response["settings"]) {
            // response is from changePassword
            settings = response["settings"];
        }
        else {
            // response is from validateUser - get "/user/settings"
            settings = response;
        }
        ;
        if (settings && settings.accountCode && !settings.accountsTypeOrder) {
            settings = null;
        }
        /*     const responseKeys = response.body.keys();
            for (let key in responseKeys) {
              switch (key) {
                case ("all_settings"):
                  //response is from login/signup
                  settings = response["all_settings"];
                  break;
                case ("settings"):
                  // response is from changePassword
                  settings = response["settings"];
                  break;
                default:
                  // response is from validateUser - get "/user/settings"
                  settings = response;
              };
            };
         */
        // Update userSettings BehaviorSubject for app.component
        this._userSettingsProvider.userSettingsSource.next(settings);
        //Trigger subscription in app.component except for changePassword method
        if (!settings || settings['status'] === false) {
            this._authStatusSource.next(false);
        }
        else {
            if (triggerAuthStatus) {
                this._authStatusSource.next(true);
            }
            ;
        }
        //return settings for vaidateUer
        return settings;
    };
    ; //end _updateSettings
    AuthProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__angular_common_http__["b" /* HttpClient */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_storage__["b" /* Storage */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_11__facebook_facebook__["a" /* FacebookProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_user_settings_user_settings__["a" /* UserSettingsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_user_data_user_data__["a" /* UserDataProvider */],
            __WEBPACK_IMPORTED_MODULE_14__publishing_service_publishing_service__["a" /* PublishingProvider */]])
    ], AuthProvider);
    return AuthProvider;
}());

; // end export class AuthProvider
//# sourceMappingURL=auth.js.map

/***/ }),

/***/ 82:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return BadgeCountProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment_timezone__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_moment_timezone__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_observable_of__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_observable_of___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_observable_of__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/*
  Generated class for the BadgeCounterProvider provider.

  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
  for more info on providers and Angular DI.
*/
var BadgeCountProvider = /** @class */ (function () {
    function BadgeCountProvider(_http) {
        this._http = _http;
        // source for observable
        this.badgeCountSource = new __WEBPACK_IMPORTED_MODULE_2_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        // observable stream
        this.badgeCount$ = this
            .badgeCountSource
            .asObservable();
        this.lastCalledTime = null;
    }
    BadgeCountProvider.prototype.getInboxUncompletedBadgeCount = function () {
        var _this = this;
        var getInboxUncompletedBadgeCountParams = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpParams */]()
            .set("action", "getUncompletedEventsNumber")
            .set("maxNumber", "99")
            .set("disableLoader", "true");
        /*         return this
                    ._http
                    .get<HttpResponse<any>>('/feed/uncompletedEventsNumber', { params: getInboxUncompletedBadgeCountParams }); */
        // if (this.lastCalledTime) {
        //     return of();
        // }
        console.log('lastCalledTime', this.lastCalledTime);
        if (this.lastCalledTime) {
            var duration = __WEBPACK_IMPORTED_MODULE_3_moment_timezone__["duration"](__WEBPACK_IMPORTED_MODULE_3_moment_timezone__().diff(__WEBPACK_IMPORTED_MODULE_3_moment_timezone__(this.lastCalledTime)));
            console.log('lastCalledTime::in mins', duration.asMinutes());
            if (duration.asMinutes() < 1) {
                return Object(__WEBPACK_IMPORTED_MODULE_4_rxjs_observable_of__["of"])(this.badgeCountSource.value);
            }
        }
        return this
            ._http
            .get('/feed/uncompletedEventsNumber', { params: getInboxUncompletedBadgeCountParams }).map(function (badgeCount) {
            _this.badgeCountSource.next(badgeCount);
            _this.lastCalledTime = __WEBPACK_IMPORTED_MODULE_3_moment_timezone__().valueOf();
            return badgeCount;
        });
    };
    ; //end getInboxUncompletedBadgeCount
    BadgeCountProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["B" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
    ], BadgeCountProvider);
    return BadgeCountProvider;
}());

; // end BadgeCounterProvider
//# sourceMappingURL=badge-count.js.map

/***/ })

},[418]);
//# sourceMappingURL=main.js.map